
#ifndef __HSCAL_BLACS_BI_BLACSERR_MACRO_HH
#define __HSCAL_BLACS_BI_BLACSERR_MACRO_HH

#include "../../../../include/scalapack.h"

#include <stdio.h>
#include <stdarg.h>

void BI_BlacsErr_nocomm(
     HSCALBLACSCONTEXT *ctxt, 
     int line, char *file, char *form, ...)
{
   int myrow, mycol, Iam;
   va_list argptr;
   char cline[100];

   va_start(argptr, form);
   vsprintf(cline, form, argptr);
   va_end(argptr);

   if (ctxt != NULL)
   {
      myrow = ctxt->cscp.Iam;
      mycol = ctxt->rscp.Iam;
      Iam  = ctxt->ascp.Iam;
   }
   else myrow = mycol = Iam = -1;

   fprintf(stderr,
"BLACS ERROR '%s'\nfrom {%d,%d}, pnum=%d, on line %d of file '%s'.\n\n",
           cline, myrow, mycol, Iam, line, file);

   return;
}

#endif

