
#ifndef __HSCAL_BLACS_BIBLACSWARN_HH
#define __HSCAL_BLACS_BIBLACSWARN_HH

#include "../../../../include/scalapack.h"

#include <stdio.h>
#include <stdarg.h>

void BI_BlacsWarn_nocomm(
       HSCALBLACSCONTEXT *ctxt, 
       int line, char *file, char *form, ...)
{
   int myrow, mycol;
   va_list argptr;
   char cline[100];

   va_start(argptr, form);
   vsprintf(cline, form, argptr);
   va_end(argptr);

   if (ctxt != NULL)
   {
      myrow = ctxt->cscp.Iam;
      mycol = ctxt->rscp.Iam;
   }
   else myrow = mycol = -1;

   fprintf(stderr,
"BLACS WARNING '%s'\nfrom {%d,%d} on line %d of file '%s'.\n\n",
           cline, myrow, mycol, line, file);

   return;
}

#endif

