
#ifndef __HSCAL_BLACS_BIMPIALLREDUCE_HSCALFUNC_HH
#define __HSCAL_BLACS_BIMPIALLREDUCE_HSCALFUNC_HH

/*
*  The implementation here depends on the MPI package
*  Currently using only the simple method
*/

#include "../../../../include/scalapack.h"

void hscal_BI_MPI_Allreduce_nocomm(
     HSCALBLACSCONTEXT *ctxt, int NC, int N, HSCALVVFUNPTR Xvvop,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
)
{
   if (N == 0)
   {
      return;
   }

   HSCAL_DEBUG(__FILE__, __FUNCTION__,__LINE__, "ALLREDUCE N %d", N);

   /* Reduce to 0, then bcast */
   hscal_BI_MPI_Reduce_nocomm(
        ctxt,
        NC,
        N,
        Xvvop,
        0,
        nprow,
        npcol,
        myrow,
        mycol,
        tcomp,
        tcomm
   );

   hscal_BI_MPI_Bcast_nocomm(
        ctxt,
        NC,
        N,
        0,
        nprow,
        npcol,
        myrow,
        mycol,
        tcomp,
        tcomm
   );

   return;
} 

#endif

