
#ifndef __HSCAL_BLACS_BIGETMPITRTYPE_HH
#define __HSCAL_BLACS_BIGETMPITRTYPE_HH

#include "../../../../include/scalapack.h"

void hscal_BI_GetMpiTrType(char uplo, char diag,
                           int m, int n, int lda, int *N)
{
   int info, start, i, k;
   int *len, *disp;

   if (diag == 'u') start = 1;
   else start = 0;

   *N = 0;

/*
 * Get space to hold the length and displacement values
 */
   if (m > n)
   {
      if (uplo == 'u')
      {
         k = m - n + 1 - start;
         for (i=0; i < n; i++)
         {
            *N += k + i;
         }
      }
      else  /* uplo = 'l' and m > n */
      {
         k = m - start;
         lda++;
         *N = k;
         for (i=1; i < n; i++)
         {
            *N += k - i;
         }
      }
   }
   else /* m <= n */
   {
      if (uplo == 'u')
      {
         k = 1 - start;
         for (i=0; i < m; i++)
         {
            *N += i + k;
         }
         for (; i < n; i++)
         {
            *N += m;
         }
      }
      else  /* uplo = 'l' and m <= n */
      {
         k = n - m;
         for (i=0; i < k; i++)
         {
            *N += m;
         }
         if (i < n)
         {
            k = n - start;
            *N += k - i;
            lda++;
            for (i++; i < n; i++)
            {
               *N += k - i;
            }
         }
      }
   }

   return;
}

#endif
