
#ifndef __HSCAL_BLACS_BIHYPBR_HSCALFUNC_HH
#define __HSCAL_BLACS_BIHYPBR_HSCALFUNC_HH

#include "../../../../include/scalapack.h"

void hscal_BI_HypBR_nocomm(
     HSCALBLACSCONTEXT *ctxt, int NC, int N, HSCALSDPTR send, int src, int * error,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
)
{
   int relnode, bit, Np, Iam;
   char scope = ctxt->scp->scope;

   if (N == 0)
   {
      return;
   }

   HSCAL_DEBUG(__FILE__, __FUNCTION__,__LINE__, "N %d", N);

   Np = ctxt->scp->Np;
   Iam = ctxt->scp->Iam;

   for (bit=2; bit < Np; bit <<= 1);
   if (bit^Np) 
   {
      *error = NPOW2;  /* not a power of 2 */
      return;
   }

   relnode = Iam ^ src;

   for(bit=1; (bit^Np); bit <<= 1)
   {
      if (bit > relnode)
      {
         int dest = (Iam^bit);

         if (tcomm != NULL)
         {
            int idest, jdest;
            switch (scope)
            {
            case 'c':
            {      
                send(
                   N, dest, mycol,
                   nprow, npcol, myrow, mycol, tcomp, tcomm
                );
                break;
            }
            case 'r':
            {
                send(
                   N, myrow, dest,
                   nprow, npcol, myrow, mycol, tcomp, tcomm
                );
                break;
            }
            case 'a':
            {
                idest = dest/npcol;
                jdest = dest%npcol;
                send(
                   N, idest, jdest,
                   nprow, npcol, myrow, mycol, tcomp, tcomm
                );
                break;
            }
            default:
                break;
            }
         }
      }
   }

   *error = 0;  /* error-free return */
}

#endif
