
#ifndef __HSCAL_BLACS_BIIDRINGBR_HSCALFUNC_HH
#define __HSCAL_BLACS_BIIDRINGBR_HSCALFUNC_HH

#include "../../../../include/scalapack.h"

void hscal_BI_IdringBR_nocomm(
     HSCALBLACSCONTEXT *ctxt, int NC, int N, HSCALSDPTR send, int src, int step,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
)
{
   int Np, Iam, dest;
   char scope = ctxt->scp->scope;

   if (N == 0)
   {
      return;
   }

   HSCAL_DEBUG(__FILE__, __FUNCTION__,__LINE__, "N %d src %d step %d", N, src, step);

   Np = ctxt->scp->Np;
   Iam = ctxt->scp->Iam;
   dest = (Np + Iam + step) % Np;
   if (dest != src) 
   {
      if (tcomm != NULL)
      {
         int idest, jdest;
         switch (scope)
         {
         case 'c':
         {      
             send(
               N, dest, mycol,
               nprow, npcol, myrow, mycol, tcomp, tcomm
             );
             break;
         }
         case 'r':
         {
             send(
               N, myrow, dest,
               nprow, npcol, myrow, mycol, tcomp, tcomm
             );
             break;
         }
         case 'a':
         {
             idest = dest/npcol;
             jdest = dest%npcol;
             send(
               N, idest, jdest,
               nprow, npcol, myrow, mycol, tcomp, tcomm
             );
             break;
         }
         default:
             break;
         }
      }
   }
}

#endif
