
#ifndef __HSCAL_BLACS_BITRANSDIST_HSCALFUNC_HH
#define __HSCAL_BLACS_BITRANSDIST_HSCALFUNC_HH

#include "../../../../include/scalapack.h"

void hscal_BI_TransDist_nocomm(
     HSCALBLACSCONTEXT *ctxt, 
     char scope, int m, int n, int *rA,
     int *cA, int ldrc, BI_DistType *dist, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
)
{
   int i, j, k, dest;
   int Ng = (ctxt)->ascp.Np;

   if (rdest == -1) rdest = cdest = 0;

   switch (scope)
   {
   case 'r':
      {
      if (tcomp != NULL)
      {
         TCOMP(myrow, mycol, nprow, npcol) += (n*m);
      }
      for (j=0; j < n; j++)
      {
         for (i=0; i < m; i++)
         {
            rA[i] = myrow;
            cA[i] = (int) (cdest + dist[i]) % npcol;
         }
         rA += ldrc;
         cA += ldrc;
         dist += m;
       }
       break;
      }
   case 'c':
      {
      if (tcomp != NULL)
      {
         TCOMP(myrow, mycol, nprow, npcol) += (n*m);
      }
      for (j=0; j < n; j++)
      {
         for (i=0; i < m; i++)
         {
            rA[i] = (int) (rdest + dist[i]) % nprow;
            cA[i] = mycol;
         }
         rA += ldrc;
         cA += ldrc;
         dist += m;
      }
      break;
      }
   case 'a':
      {
      if (tcomp != NULL)
      {
         TCOMP(myrow, mycol, nprow, npcol) += (n*m);
      }
      dest = Mvkpnum(ctxt, rdest, cdest);
      for (j=0; j < n; j++)
      {
         for (i=0; i < m; i++)
         {
            k = (int) (dest + dist[i]) % Ng;   /* figure node number */
            Mvpcoord(ctxt, k, rA[i], cA[i]);   /* figure node coordinates */
         }
         rA += ldrc;
         cA += ldrc;
         dist += m;
      }
      }
      break;
   default:
      break;
   }
}

#endif
