
#ifndef __HSCAL_BLACS_CBLACSGET_HH
#define __HSCAL_BLACS_CBLACSGET_HH

#include "../../../include/scalapack.h"

void Cblacs_get_nocomm(HSCALBLACSCONTEXT *ctxt, int what, int *val)
{
   switch( Mpval(what) )
   {
   case SGET_SYSCONTXT:
      *val = -1;
      break;
   case SGET_MSGIDS:
      val[0] = -1;
      val[1] = -1;
      break;
   case SGET_DEBUGLVL:
      *val = 0;
      break;
   case SGET_BLACSCONTXT:
      *val = -1;
      break;
   case SGET_NR_BS:
      *val = ctxt->Nr_bs;
      break;
   case SGET_NB_BS:
      *val = ctxt->Nb_bs - 1;
      break;
   case SGET_NR_CO:
      *val = ctxt->Nr_co;
      break;
   case SGET_NB_CO:
      *val = ctxt->Nb_co - 1;
      break;
   case SGET_TOPSREPEAT:
      *val = ctxt->TopsRepeat;
      break;
   case SGET_TOPSCOHRNT:
      *val = ctxt->TopsCohrnt;
      break;
   default:
      BI_BlacsWarn_nocomm(
        ctxt, __LINE__, __FILE__, "Unknown WHAT (%d)",
        Mpval(what)
      );
      break;
   }
}

#endif
