
#ifndef __HSCAL_BLACS_CBLACSGRIDMAP_HH
#define __HSCAL_BLACS_CBLACSGRIDMAP_HH

#include <stdio.h>

#include <stdlib.h>

#include "../../../include/scalapack.h"

HSCALBLACSCONTEXT _hscal_blacs_buffer_;

void Cblacs_gridmap_nocomm(
           HSCALBLACSCONTEXT **ConTxt, int *usermap, 
           int ldup, int nprow0, int npcol0
)
{
   int i, j, *iptr;
   int nprow, npcol, Ng;
   HSCALBLACSCONTEXT *ctxt = &_hscal_blacs_buffer_;

   nprow = Mpval(nprow0);
   npcol = Mpval(npcol0);
   Ng = nprow * npcol;
   if ( (nprow < 1) || (npcol < 1) )
   {
      BI_BlacsErr_nocomm(
        NULL, -1, "BLACS_GRIDINIT/BLACS_GRIDMAP",
        "Illegal grid (%d x %d), #procs=%d", nprow, npcol, Ng);
   }

   *ConTxt = ctxt;

   ctxt->rscp.Np = npcol;
   ctxt->rscp.Iam = -1;
   ctxt->rscp.scope = 'r';
   ctxt->cscp.Np = nprow;
   ctxt->cscp.Iam = -1;
   ctxt->cscp.scope = 'c';
   ctxt->pscp.Np = ctxt->ascp.Np = Ng;
   ctxt->pscp.Iam = ctxt->ascp.Iam = -1;
   ctxt->ascp.scope = 'a';
   ctxt->rscp.scope = 'r';
   ctxt->Nr_bs = ctxt->Nr_co = 1;
   ctxt->Nb_bs = ctxt->Nb_co = 2;
   ctxt->TopsRepeat = ctxt->TopsCohrnt = 0;

   return;
}

#endif

