
/*************************************************************************
*                                                                       *
*                 Heterogeneous Data Partitioning Interface             *
*                 =========================================             *
*                                                                       *
*  Copyright (c) 2002          Department of Computer Science,          *
*                              University College Dublin.               *
*                                                                       *
*  All rights reserved. We assume no responsibility for the use         *
*  or reliability of our software.                                      *
*                                                                       *
*************************************************************************/

   /************************************************/
   /* Partitioning interfaces for trees            */
   /*                                              */
   /* Revision history                             */
   /* 19-05-2003  --      Initial version          */
   /************************************************/

   #ifndef __HMPI_PARTITIONING_TREES_HH
   #define __HMPI_PARTITIONING_TREES_HH

   int HMPI_Partition_tree(
           int p,
           int pn,
	   const double *speeds,
	   const int *psizes,
	   const int *mlimits,
	   int n,
	   int nedges,
	   const int *nwgt,
	   const int *xadj,
	   const int *adjacency,
	   const int *adjwgt,
	   int *vp,
	   int *edgecut
   );

   #endif  /* __HMPI_PARTITIONING_TREES_HH */

