/* code generation for Assignment */
/* Coded by A.Kalinov 11.95 -12.95 */

#include "be_print.h"

/*int is_assign_array_to_pointer(tTree , tTree );
int is_assign_pointer_to_pointer(tTree , tTree );*/


void print_OneToOne(tTree);
void print_OneToMany(tTree);
void print_ManyToOne(tTree);
int print_ManyToMany(tTree);
static int specIndexLevel(tTree);

static int startWithVector;


#define ON_ON  ret=ONE_ONE;

#define ON_ON_GA  ret=ONE_ONE; one_to_one_kind=GATHER;

#define ON_ON_BR  ret=ONE_ONE; one_to_one_kind=BCAST;

#define ON_ON_SC  ret=ONE_ONE; one_to_one_kind=SCATTER;

#define ON_MAN  ret=ONE_MANY;

#define MAN_ON  ret=MANY_ONE;

#define MAN_MAN  ret=MANY_MANY;


int PredAssign_kind(tTree pExpr, tTree * ppLType, tTree * ppRType)
{
    int ret = WRONG;
    tTree pLop, pRop;
    tTree pLopStore, pRopStore;
    tTree pLType, pRType;
    tExprFlags flag;
    one_to_one_kind = 0;
    PointerControl(pExpr);
    pLop = pExpr->MPC_BinaryExpr.Loperand;
    PointerControl(pLop);
    pRop = pExpr->MPC_BinaryExpr.Roperand;
    PointerControl(pRop);
    pLopStore = pLop->MPC_Expr.StoreNet;
    PointerControl(pLopStore);
    pRopStore = pRop->MPC_Expr.StoreNet;
    PointerControl(pRopStore);
    pRType = pRop->MPC_Expr.Type;
    PointerControl(pRType);
    pLType = pLop->MPC_Expr.Type;
    PointerControl(pLType);
    *ppLType = pLType;
    *ppRType = pRType;
    flag = pExpr->MPC_BinaryExpr.Flag;
    if (prt)
        printf("PredAssign_kind Asynchr=%d Generated=%d ",
               flag.Asynchr, flag.Generated);
    {
        tExprFlags l_flag = pLop->MPC_BinaryExpr.Flag;
        tExprFlags r_flag = pRop->MPC_BinaryExpr.Flag;
        int l_distr = l_flag.Distributed;
        int r_distr = r_flag.Distributed;
        if (prt)
            printf("l_Dist=%d r_Dist=%d\n", l_distr, r_distr);
        if (pExpr->MPC_Expr.Flag.Asynchr) {
            ret = ASYNCH;
      /**ppLType=pExpr->MPC_Expr.Type;*/
        } else {
            if (l_distr == 0 && r_distr == 0) {
                ON_ON;
            } else if ((l_distr == 0 ||
                        (l_distr == 1 &&
                         is_first_parent_of_second(pLopStore, pRopStore)))
                       && r_distr == 1) {
                if (pRopStore->Kind == kMPC_Net
                    || (!pRopStore->MPC_Subnet.Flexible
                        && is_subnet(pLopStore, pRopStore))) {
                    MAN_ON;
                } else {
                    ON_ON_GA;
                }
            } else if (l_distr == 1 && (r_distr == 0 ||
                                        (r_distr == 1 &&
                                         is_first_parent_of_second
                                         (pRopStore, pLopStore)))) {
                if (pLopStore->Kind == kMPC_Net
                    || (!pLopStore->MPC_Subnet.Flexible
                        && is_subnet(pRopStore, pLopStore))) {
                    ON_MAN;
                } else {
                    if (equal_type(pLType, pRType)) {
                        ON_ON_BR;
                    } else {
                        ON_ON_SC;
                    }
                }
            } else if (l_distr == 1 && r_distr == 1) {
                MAN_MAN;
            }
        }
    }
    if (prt)
        printf("                ret=%d one_to_one_kind=%d\n",
               ret, one_to_one_kind);
    return ret;
}

void print_PredAssign(tTree pExpr)
{
    tTree pLType, pRType;
    int kind;
    int was_generated = 1;
    int old_not_check = not_check;
    tTree pLop, pRop;
    tPosition real_pos;
    PointerControl(pExpr);
    pLop = pExpr->MPC_BinaryExpr.Loperand;
    PointerControl(pLop);
    pRop = pExpr->MPC_BinaryExpr.Roperand;
    PointerControl(pRop);
    kind = PredAssign_kind(pExpr, &pLType, &pRType);
    if (kind == WRONG || pLType == NoTree || pRType == NoTree) {
        fprintf(stderr, "wrong kind of the assignment\n");
        internal_error();
    }
    real_pos = RealPosition(Position);
    c_blank;
    print2file("", "MPC_Source_position_set(%d,%d);\n",
               real_pos.Column, real_pos.Line);
    /*not_check=1; */
    in_assign = 1;
    switch (kind) {
    case ASYNCH:
        print_Assign_OneToOne(pExpr);
        break;
    case ONE_ONE:
        print_OneToOne(pExpr);
        break;
    case ONE_MANY:
        print_OneToMany(pExpr);
        break;
    case MANY_ONE:
        print_ManyToOne(pExpr);
        break;
    case MANY_MANY:
        was_generated = print_ManyToMany(pExpr);
        break;
    }
    in_assign = 0;
    /*  tTree pLop,pRop;
       tTree pLopStore,pRopStore;
       tExprFlags flag;
       int was_generated=1;
       PointerControl(pExpr);
       pLop=pExpr->MPC_BinaryExpr.Loperand;
       PointerControl(pLop);
       pRop=pExpr->MPC_BinaryExpr.Roperand;
       PointerControl(pRop);
       pLopStore=pLop->MPC_Expr.StoreNet;
       PointerControl(pLopStore);
       pRopStore=pRop->MPC_Expr.StoreNet;
       PointerControl(pRopStore);
       flag=pExpr->MPC_BinaryExpr.Flag;
       if(prt) printf("print_PredAssign Asynchr=%d Generated=%d\n",
       flag.Asynchr,flag.Generated);
       {
       tExprFlags l_flag=pLop->MPC_BinaryExpr.Flag;
       tExprFlags r_flag=pRop->MPC_BinaryExpr.Flag;
       int l_distr=l_flag.Distributed;
       int r_distr=r_flag.Distributed;
       if(prt) printf("l_flag.Distributed=%d r_flag.Distributed=%d\n",
       l_distr,r_distr);
       if(l_distr == 0 && r_distr == 0) {
       if(pExpr->MPC_Expr.Flag.Asynchr) {
       print_Assign_OneToOne(pExpr);
       }
       else {
       print_OneToOne(pExpr,pRop);
       }
       }
       else if(l_distr == 0 && r_distr == 1) {
       if(pRopStore->MPC_NetOrSubnet.SingleNode) {
       print_OneToOne(pExpr,pRop);
       }
       else {
       print_ManyToOne(pExpr,pLop);
       }
       }
       else if(l_distr == 1 && r_distr == 0) {
       if(pLopStore->MPC_NetOrSubnet.SingleNode) {
       print_OneToOne(pExpr,pRop);
       }
       else {
       print_OneToMany(pExpr,pRop);
       }
       }
       else if(l_distr == 1 && r_distr == 1) {
       if(pRopStore->MPC_NetOrSubnet.SingleNode &&
       pLopStore->MPC_NetOrSubnet.SingleNode) {
       print_OneToOne(pExpr,pRop);
       }
       else if((pRopStore->MPC_NetOrSubnet.SingleNode &&
       !pLopStore->MPC_NetOrSubnet.SingleNode) ||
       is_parent(pRopStore,pLopStore)) {  
       print_OneToMany(pExpr,pRop);
       }
       else if((!pRopStore->MPC_NetOrSubnet.SingleNode &&
       pLopStore->MPC_NetOrSubnet.SingleNode) ||
       is_parent(pLopStore,pRopStore)) {  
       print_ManyToOne(pExpr,pLop);
       }
       else {
       was_generated=print_ManyToMany(pExpr,pRop);
       }
       } */
    end_statement_is_needed = 0;
    if (was_generated)
        pExpr->MPC_Expr.Flag.Generated = 1;
    not_check = old_not_check;
    if (prt)
        printf("print_PredAssign end was_generated=%d\n", was_generated);
    return;
}

void print_Expr_without_net_check(tTree pExpr)
{
    int old_not_check = not_check;
    not_check = 1;
    PointerControl(pExpr);
    print_Expr(pExpr);
    not_check = old_not_check;
}

void print_Assign(tTree pExpr)
{
    tTree pLop;
    tTree pRop;
    tTree pType;
    tExprFlags flag;
    int l_index;
    int r_index;
    int e_index;
    int old_in_sideeff;

    old_in_sideeff = in_sideeff;
    in_sideeff = 1;
    PointerControl(pExpr);
    pLop = pExpr->MPC_BinaryExpr.Loperand;
    PointerControl(pLop);
    pRop = pExpr->MPC_BinaryExpr.Roperand;
    PointerControl(pRop);
    pType = pExpr->MPC_Expr.Type;
    PointerControl(pType);
    flag = pExpr->MPC_BinaryExpr.Flag;
    if (prt)
        printf("print_Assign flag.Asynchr=%d\n", flag.Asynchr);
    if (!IsSingleRegion(cur_act_net)) {
        fprintf(stderr,
                "final assign ExecNetList contains more than one network\n");
        internal_error();
    }
    if (pLop->Kind == kMPC_NetCastExpr) {
        if (!is_NetCast_asynch(pLop)) {
            fprintf(stderr,
                    "Sorry, not bounded NetCast isn't supported\n");
            internal_error();
        }
        pLop = pLop->MPC_NetCastExpr.Operand;
        PointerControl(pLop);
    }
    e_index = index_level(pType);
    l_index = index_level(pLop->MPC_Expr.Type);
    r_index = index_level(pRop->MPC_Expr.Type);
    if (prt)
        printf("e_index=%d l_index=%d r_index=%d\n", e_index, l_index,
               r_index);
    root_index = l_index;
    expr_index = 0;
    if (l_index == 0) {
        tTree pLType = pLop->MPC_Expr.Type;
        int OpCode = pExpr->MPC_BinaryExpr.OpCode;
        PointerControl(pLType);
        print_Expr_without_net_check(pLop);
        print2file("", "%s", op_represent[OpCode]);
        if ((OpCode == PLUS_ASSIGN || OpCode == MINUS_ASSIGN) &&
            is_not_c_pointer(pLType)) {
            print2file("", "(");
            print_Expr_without_net_check(pRop);
            print2file("", ")*%s", step_macro(pLType));
        } else {
            print_Expr_without_net_check(pRop);
        }
        end_statement_is_needed = 1;
    } else {
        int i_index;
        if (l_index < r_index) {
            fprintf(stderr,
                    "invalid l_index=%d < r_index=%d of the asynchr assignment\n",
                    l_index, r_index);
            internal_error();
        }
        ExprPiece_traverse(NoTree, pExpr, set_tmp_slots);


        index_boundary = malloc(sizeof(struct INDEX_BOUNDARY) * l_index);
        set_index_boundary(pLop->MPC_Expr.Type);
        print2file("", "{\n");
        cur_blank += SKIP;
        defineNewVectorTypes(pLop);
        for (i_index = 0; i_index < l_index; i_index++) {

            global_index_level = i_index;
            use_slots = 1;
            ExprPiece_traverse(NoTree, pExpr, declare_tmp_slots);
            use_slots = 0;

            c_blank;
            print2file("", "int %s=0;\n", index_name(i_index));
            if (i_index == 0) { /*Expr_traverse(pExpr,initNewVectorTypes) */
                initNewVectorTypes(pLop);
            }
            use_slots = 1;
            ExprPiece_traverse(NoTree, pExpr, calc_tmp_slots);
            use_slots = 0;
            c_blank;
            if (index_boundary[i_index].NumberOfComponents)
                print2file("", "for(;%s<%d;%s++) {\n",
                           index_name(i_index),
                           index_boundary[i_index].NumberOfComponents,
                           index_name(i_index));
            else {
                print2file("", "for(;%s<", index_name(i_index));
                print2file("", "%s.Number;",
                           DataVarName(index_boundary[i_index].Type));
                print2file("", "%s++) {\n", index_name(i_index));
            }
            cur_blank += SKIP;
        }

        global_index_level++;
        use_slots = 1;

        free(index_boundary);
        c_blank;
        print_Expr_without_net_check(pLop);
        print2file("", "%s", op_represent[pExpr->MPC_BinaryExpr.OpCode]);
        expr_index = 0;
        print_Expr_without_net_check(pRop);
        print2file("", ";\n");
        end_statement_is_needed = 0;
        use_slots = 0;

        for (i_index = 0; i_index < l_index; i_index++) {
            b_end;
        }
        b_end;
    }
    if (prt)
        printf("print_Assign end\n");
    in_sideeff = old_in_sideeff;
}

int is_Assign_asynch(tTree pExpr)
{
    tTree pLeft;
    tTree pRight;
    int may_be;
    tTree pLeftType, pRightType;
    PointerControl(pExpr);
    if (pExpr->MPC_Expr.Flag.Asynchr || asynchr_mode) {
        may_be = 1;
    } else {
        pLeft = pExpr->MPC_BinaryExpr.Loperand;
        PointerControl(pLeft);
        pRight = pExpr->MPC_BinaryExpr.Roperand;
        PointerControl(pRight);
        pLeftType = pLeft->MPC_Expr.Type;
        pRightType = pRight->MPC_Expr.Type;
        PointerControl(pLeftType);
        PointerControl(pRightType);
        if (index_level(pLeftType) != index_level(pRightType)) {
            may_be = 0;
        } else {
            tTree pLeftNet = pLeft->MPC_Expr.StoreNet;
            tTree pRightNet = pRight->MPC_Expr.StoreNet;
            PointerControl(pLeftNet);
            PointerControl(pRightNet);
            if (pLeftNet == pRightNet || pRight == COMPUTING_SPACE) {
                may_be = 1;
            } else {
                may_be = (is_parent(pLeftNet, pRightNet) ||
                          is_subnet(pLeftNet, pRightNet));
            }
        }
    }
    if (prt)
        printf("is_Assign_asynch pExpr=%p may_be=%d asynchr_mode=%d\n",
               pExpr, may_be, asynchr_mode);
    return may_be;
}

/*int is_assign_array_to_pointer(tTree pLop, tTree pRop) {
  tTree pLType,pRType,plType,prType;
  int ret=0;
  PointerControl(pLop);
  PointerControl(pRop);
  pLType=pLop->MPC_Expr.Type;
  PointerControl(pLType);
  pRType=pRop->MPC_Expr.Type;
  PointerControl(pRType);
  if(prt) printf("is_assign_array_to_pointer Lkind=%d Rkind=%d ",
         pLType->Kind,pRType->Kind);
  if(pLType->Kind == kMPC_PointerType) {
    plType=pLType->MPC_PointerType.ElementType;
    PointerControl(plType);
    if(pRType->Kind == kMPC_ArrayType) {
      prType=pRType->MPC_ArrayType.ElementType;
      PointerControl(plType);
      if(plType->MPC_Type.pType == prType->MPC_Type.pType) {
        ret=1;
      }
    }
  }
  if(prt) printf(" ret=%d\n",ret);
  return ret;
}

int is_assign_pointer_to_pointer(tTree pLop, tTree pRop) {
  tTree pLType,pRType;
  int ret=0;
  PointerControl(pLop);
  PointerControl(pRop);
  pLType=pLop->MPC_Expr.Type;
  PointerControl(pLType);
  pRType=pRop->MPC_Expr.Type;
  PointerControl(pRType);
  if(prt) printf("is_assign_pointer_to_pointer Lkind=%d Rkind=%d ",
         pLType->Kind,pRType->Kind);
  if(pLType->Kind == kMPC_PointerType) {
    ret=1;
  }
  if(prt) printf(" ret=%d\n",ret);
  return ret;
}*/

void print_OneToMany(tTree pExpr)
{
    tTree pLType, pRType;
    PointerControl(pExpr);
    if (prt)
        printf("print_OneToMany pExpr=%p\n", pExpr);
    if (PredAssign_kind(pExpr, &pLType, &pRType) != ONE_MANY) {
        fprintf(stderr, "error in the OneToMany call\n");
        internal_error();
    }
    c_blank;
    print2file("", "{\n");
    cur_blank += SKIP;
    ExprTab = InitTab;
    MakeArray(&ExprTab.Tab, &ExprTab.ActualSize, sizeof(tTree));
    in_expr = 1;
    print_rts_type(pLType);
    print_rts_type(pRType);
    print_Assign_OneToMany(pExpr);
    in_expr = 0;
    FreeTypeTab(ExprTab);
    ReleaseArray(&ExprTab.Tab, &ExprTab.ActualSize, sizeof(tTree));
    b_end;
}

void print_ManyToOne(tTree pExpr)
{
    tTree pLType, pRType;
    PointerControl(pExpr);
    if (prt)
        printf("print_ManyToOne pExpr=%p \n", pExpr);
    if (PredAssign_kind(pExpr, &pLType, &pRType) != MANY_ONE) {
        fprintf(stderr, "error in the ManyToOne call\n");
        internal_error();
    }
    c_blank;
    print2file("", "{\n");
    cur_blank += SKIP;
    ExprTab = InitTab;
    MakeArray(&ExprTab.Tab, &ExprTab.ActualSize, sizeof(tTree));
    in_expr = 1;
    print_rts_type(pLType);
    print_rts_type(pRType);
    print_Assign_ManyToOne(pExpr);
    in_expr = 0;
    FreeTypeTab(ExprTab);
    ReleaseArray(&ExprTab.Tab, &ExprTab.ActualSize, sizeof(tTree));
    b_end;
}

int print_ManyToMany(tTree pExpr)
{
    tTree pLType, pRType;
    int was_generated;
    PointerControl(pExpr);
    if (prt)
        printf("print_ManyToMany pExpr=%p\n", pExpr);
    if (PredAssign_kind(pExpr, &pLType, &pRType) != MANY_MANY) {
        fprintf(stderr, "error in the ManyToMany call\n");
        internal_error();
    }
    c_blank;
    print2file("", "{\n");
    cur_blank += SKIP;
    ExprTab = InitTab;
    MakeArray(&ExprTab.Tab, &ExprTab.ActualSize, sizeof(tTree));
    in_expr = 1;
    print_rts_type(pLType);
    print_rts_type(pRType);
    was_generated = print_Assign_ManyToMany(pExpr);
    in_expr = 0;
    FreeTypeTab(ExprTab);
    ReleaseArray(&ExprTab.Tab, &ExprTab.ActualSize, sizeof(tTree));
    b_end;
    return was_generated;
}

void print_OneToOne(tTree pExpr)
{
    tTree pLType, pRType;
    PointerControl(pExpr);
    if (prt)
        printf("print_OneToOne pExpr=%p\n", pExpr);
    if (PredAssign_kind(pExpr, &pLType, &pRType) != ONE_ONE) {
        fprintf(stderr, "error in the OneToOne call\n");
        internal_error();
    }
    c_blank;
    print2file("", "{\n");
    cur_blank += SKIP;
    ExprTab = InitTab;
    MakeArray(&ExprTab.Tab, &ExprTab.ActualSize, sizeof(tTree));
    in_expr = 1;
    print_rts_type(pLType);
    print_rts_type(pRType);
    print_Assign_OneToOne(pExpr);
    in_expr = 0;
    FreeTypeTab(ExprTab);
    ReleaseArray(&ExprTab.Tab, &ExprTab.ActualSize, sizeof(tTree));
    b_end;
}

void set_tmp_slots(tTree pParentExpr, tTree pExpr)
{
    int number_of_slots = 0;
    int slot = 0;

    PointerControl(pExpr);

    if (!is_trivial_expr(pExpr)) {
        if ((pParentExpr != NoTree)
            && (expr_depth(pParentExpr) > expr_depth(pExpr)))
            slot = 1;

        if ((pExpr->Kind == kMPC_UnaryExpr)
            && (pExpr->MPC_UnaryExpr.OpCode == BRACKETS))
            number_of_slots = expr_depth(pExpr) - 1;
    }

    if (number_of_slots <= 0) {
        pExpr->MPC_Expr.Optm_Attribute.first_slot = 0;
        pExpr->MPC_Expr.Optm_Attribute.last_slot = 0;
    } else {
        pExpr->MPC_Expr.Optm_Attribute.first_slot = current_slot_number;
        pExpr->MPC_Expr.Optm_Attribute.last_slot =
            current_slot_number + number_of_slots - 1;
        current_slot_number += number_of_slots;
    }

    if (slot == 0) {
        pExpr->MPC_Expr.Optm_Attribute.slot = 0;
    } else {
        pExpr->MPC_Expr.Optm_Attribute.slot = current_slot_number;
        current_slot_number += 1;
    }

    pExpr->MPC_Expr.Optm_Attribute.generated = 0;

}


int is_trivial_expr(tTree pExpr)
{
    PointerControl(pExpr);
    if ((pExpr->Kind == kMPC_Ident) || (pExpr->Kind == kMPC_IntConst)
        || (pExpr->Kind == kMPC_UIntConst)
        || (pExpr->Kind == kMPC_FloatConst))
        return 1;
    else
        return 0;
}

static int specIndexLevel(tTree pType)
{
    int level = 0;
    int go;

    if (prt)
        printf("specIndexLevel pType=%p\n", pType);
    while (pType != NoTree) {
        if (prt)
            printf("specIndexLevel pType=%p pType->Kind=%d\n",
                   pType, pType->Kind);
        go = pType->Kind == kMPC_VectorType ||
            ((pType->Kind == kMPC_ArrayType) && (!startWithVector));
        if (go) {
            level++;
            pType = element_type(pType);
        } else
            break;
    }
    if (prt)
        printf("specIndexLevel level=%d\n", level);
    return level;
}

int expr_depth(tTree pExpr)
{
    int depth = 0;
    PointerControl(pExpr);
    startWithVector = 0;
    if ((pExpr->MPC_Expr.Flag.Lvalue == 0)
        && (pExpr->MPC_Expr.Type->Kind == kMPC_ArrayType))
        depth = 0;
    else {
        startWithVector = (pExpr->MPC_Expr.Type->Kind == kMPC_VectorType);
        depth = specIndexLevel(pExpr->MPC_Expr.Type);
    }
    return depth;

}

void declare_tmp_slots(tTree pParentExpr, tTree pExpr)
{
    tTree pType;
    int local_index_level = global_index_level - global_shift;

    PointerControl(pExpr);

    if (pExpr->MPC_Expr.Optm_Attribute.first_slot != 0) {
        int number_of_slots =
            pExpr->MPC_Expr.Optm_Attribute.last_slot -
            pExpr->MPC_Expr.Optm_Attribute.first_slot + 1;

        if ((local_index_level <= number_of_slots)
            && (local_index_level > 0)) {
            pType =
                get_type_pattern(pExpr->MPC_Expr.Type, local_index_level);
            declare_slot(pType,
                         pExpr->MPC_Expr.Optm_Attribute.first_slot +
                         local_index_level - 1);
        }
    }

    if ((pExpr->MPC_Expr.Optm_Attribute.slot != 0)
        && (expr_depth(pExpr) == global_index_level)) {
        pType = get_type_pattern(pExpr->MPC_Expr.Type, global_index_level);
        declare_slot(pType, pExpr->MPC_Expr.Optm_Attribute.slot);
    }

}

void declare_slot(tTree pType, int slot)
{
    tTree eType;
    int old_print_base_type;
    int old_in_var_decl;

    old_print_base_type = print_base_type;
    print_base_type = 1;
    old_in_var_decl = in_var_decl;
    in_var_decl = 1;
    in_declare_slot = 1;

    if ((pType->Kind == kMPC_ArrayType)
        || (pType->Kind == kMPC_VectorType)) {
        if (is_dynamic_type(pType)) {
            c_blank;
            print_LeftType(pType, NoTree);
            print2file("", "%s%d", TMP_SLOT_PREFIX, slot);
            print_RightType(pType, NoTree);
            print2file("", ";\n");
        } else {
            eType = element_type(pType);
            c_blank;
            print_LeftType(eType, NoTree);
            print2file("", " (*%s%d)", TMP_SLOT_PREFIX, slot);
            print_RightType(eType, NoTree);
            print2file("", ";\n");
        }
    } else {
        c_blank;
        print_LeftType(pType, NoTree);
        print2file("", " %s%d ", TMP_SLOT_PREFIX, slot);
        print_RightType(pType, NoTree);
        print2file("", ";\n");
    }
    in_declare_slot = 0;
    print_base_type = old_print_base_type;
    in_var_decl = old_in_var_decl;

}


void calc_tmp_slots(tTree pParentExpr, tTree pExpr)
{
    tTree pType;
    int old_print_base_type;
    int local_index_level = global_index_level - global_shift;

    PointerControl(pExpr);
    old_print_base_type = print_base_type;
    print_base_type = 1;

    if (pExpr->MPC_Expr.Optm_Attribute.first_slot != 0) {
        int number_of_slots =
            pExpr->MPC_Expr.Optm_Attribute.last_slot -
            pExpr->MPC_Expr.Optm_Attribute.first_slot + 1;

        if ((local_index_level <= number_of_slots)
            && (local_index_level > 0)) {
            pType =
                get_type_pattern(pExpr->MPC_Expr.Type, local_index_level);
            if ((pType->Kind == kMPC_ArrayType)
                || (pType->Kind == kMPC_VectorType)) {
                c_blank;
                print2file("", "%s%d=", TMP_SLOT_PREFIX,
                           pExpr->MPC_Expr.Optm_Attribute.first_slot +
                           local_index_level - 1);
                print_sexpr(pExpr);
                print2file("", ";\n");
            } else {
                internal_error();
            }
        }
    }

    if ((pExpr->MPC_Expr.Optm_Attribute.slot != 0)
        && (expr_depth(pExpr) == global_index_level)) {
        c_blank;
        print2file("", "%s%d=", TMP_SLOT_PREFIX,
                   pExpr->MPC_Expr.Optm_Attribute.slot);
        print_sexpr(pExpr);
        print2file("", ";\n");
        pExpr->MPC_Expr.Optm_Attribute.generated = 1;
    }

    print_base_type = old_print_base_type;
}


void clear_generated(tTree pParentExpr, tTree pExpr)
{
    PointerControl(pExpr);
    if (expr_depth(pExpr) > clear_level)
        pExpr->MPC_Expr.Optm_Attribute.generated = 0;
}

/**
 * Retrievs first non array/vector type
 *
 * @param pType processing type
 */
tTree get_TerminalAVType(tTree pType)
{
    tTree rType = pType;
    int go;

    while (rType != NoTree) {

        go = rType->Kind == kMPC_VectorType ||
            rType->Kind == kMPC_ArrayType;
        if (go)
            rType = element_type(rType);
        else
            break;
    }
    return rType;
}

tTree get_type_pattern(tTree pType, int depth)
{
    tTree rType = pType;
    int go;

    while ((rType != NoTree) && (depth != 0)) {
        depth--;
        go = rType->Kind == kMPC_VectorType ||
            rType->Kind == kMPC_ArrayType;
        if (go)
            rType = element_type(rType);
        else
            break;
    }
    return rType;
}

void defineNewVectorTypes(tTree pExpr)
{
    tTree pType;
    tType pRtsType;

    PointerControl(pExpr);
    pType = pExpr->MPC_Expr.Type;
    PointerControl(pType);
    pRtsType = pType->MPC_Type.pType;
    if (pRtsType != NoType)
        print_rts_type_tree(pRtsType);
}

void undefineNewVectorTypes(tTree pExpr)
{
    tTree pType;
    tType pRtsType;

    PointerControl(pExpr);
    pType = pExpr->MPC_Expr.Type;
    PointerControl(pType);
    pRtsType = pType->MPC_Type.pType;
    if (pRtsType != NoType)
        unprint_rts_type_tree(pRtsType);
        
}


void initNewVectorTypes(tTree pExpr)
{
    tTree pType;
    tType pRtsType;

    PointerControl(pExpr);
    pType = pExpr->MPC_Expr.Type;
    PointerControl(pType);
    pRtsType = pType->MPC_Type.pType;
    if (pRtsType != NoType)
        print_rts_type_tree_2(pRtsType);
}
