/*
<<<<<<< ConvertType.c
 * $Id: ConvertType.c,v 1.48 2006/01/11 15:49:43 zahar Exp $
=======
 * $Id: ConvertType.c,v 1.48 2006/01/11 15:49:43 zahar Exp $
>>>>>>> 1.11
 */



/* converts Tree types to rts ones */
/* Coded by A.Kalinov 2.96 ... */

#include "be_print.h"

static void declare_SU_members_types(tTree yyt);
static void define_SU_members_types(tTree yyt);
static void assign_SU_members_offsets(tTree yyt);
static void print_Type_in_rts(tTree yyt);
static void print_Type_in_rts(tTree yyt);
static tTree Not_Array_Type(tTree);
static tTree First_Static_Type(tTree);
static void AddToTypeTab(tTree yyt);
static tTree get_complete_su_type(tTree yyt);
static int type_num = 0;




/**
* Compares two AST types in order to determine equivalence.
*
* @param pOrigin first type
* @param yyt second type
*/
int same_type(tTree pOrigin, tTree yyt)
{
    int ret = 0;
    tTree pEquivType;

    PointerControl(pOrigin);
    PointerControl(yyt);
    pEquivType = pOrigin->MPC_Type.EquivType;

    /*
       while(pEquivType != pOrigin ) {
       if(pEquivType == yyt) {
       ret=1;
       break;
       }
       if(pEquivType == NoTree) {
       ret=0;
       break;
       }
       pEquivType=pEquivType->MPC_Type.EquivType;
       }
     */

    if (ret != 1) {
        switch (pOrigin->Kind) {
        case kMPC_BasicType:
            ret = ((yyt->Kind == kMPC_BasicType &&
                    yyt->MPC_BasicType.TypeConstructor ==
                    pOrigin->MPC_BasicType.TypeConstructor)
#ifdef MPC_DEBUGGER
/* ka 04.01.2001 begin */
/*
                   ||
                   (yyt->Kind == kMPC_EnumType &&
                    pOrigin->MPC_BasicType.TypeConstructor == INT)
                    */
/* ka 04.01.2001 end */
#endif                          /*MPC_DEBUGGER */
                );
            break;
/*
        case kMPC_EnumType:
            ret = (yyt->Kind == kMPC_EnumType);
            break;
*/            
        case kMPC_Typedef:
            {
                tTree pParent = pOrigin->MPC_Typedef.Type;

                PointerControl(pParent);
                /*
                   while(pParent->Kind == kMPC_Typedef) { 
                   pParent=pParent->MPC_Typedef.Type;
                   PointerControl(pParent);
                   }
                 */
                pParent = Strip_Typedef(pParent);
                ret = same_type(pParent, yyt);
            }
            break;
        case kMPC_ArrayType:
            if (is_dynamic_type(yyt) && carefull_compare)
                ret = (yyt == pOrigin);
            else
                ret = (yyt->Kind == kMPC_ArrayType &&
                       same_type(yyt->MPC_ArrayType.ElementType,
                                 pOrigin->MPC_ArrayType.ElementType) &&
                       yyt->MPC_ArrayType.Step ==
                       pOrigin->MPC_ArrayType.Step &&
                       yyt->MPC_ArrayType.NumberOfComponents ==
                       pOrigin->MPC_ArrayType.NumberOfComponents);
            break;

        case kMPC_VectorType:
            if (is_dynamic_type(yyt) && carefull_compare)
                ret = (pOrigin == yyt);
            else
                ret = (yyt->Kind == kMPC_VectorType &&
                       same_type(yyt->MPC_VectorType.ElementType,
                                 pOrigin->MPC_VectorType.ElementType) &&
                       yyt->MPC_VectorType.Step ==
                       pOrigin->MPC_VectorType.Step &&
                       yyt->MPC_VectorType.NumberOfComponents ==
                       pOrigin->MPC_VectorType.NumberOfComponents);
            break;
        case kMPC_PointerType:
            if (yyt->Kind == kMPC_PointerType) {
                if (same_type(element_type(pOrigin), element_type(yyt))) {
                    ret = 1;
                }
            } else
                ret = 0;
            break;
        case kMPC_StructType:
        case kMPC_UnionType:
        case kMPC_EnumType:

            if (pOrigin->Kind == yyt->Kind) {
                tTree pEquivType;
                if (pOrigin == yyt) {
                    ret = 1;
                    break;
                }
                pEquivType = yyt->MPC_Type.EquivType;
                if (pEquivType != NoTree) {
                    while (yyt != pEquivType) {
                        if (pOrigin == pEquivType) {
                            ret = 1;
                            break;
                        }
                        pEquivType = pEquivType->MPC_Type.EquivType;
                    }
                }
            }

            break;              /* ka 21.02.2002 */
        case kMPC_FunctionType:
            ret = yyt->Kind == kMPC_FunctionType;
            break;
        default:
            fprintf(stderr, "Wrong Kind of the internal tree node\n");
            internal_error();
            break;
        }
    }
    if (prt)
        printf(" ret=%d\n", ret);
    return ret;
}




/**
 * Constructs new tType from yyt and parent inParentType.
 *
 * It first looks for same types in children of parent
 * type. If nothing is found it constructs new type.
 *
 * @param inParentType parent type
 * @param inTree AST-type tree node
 */
static tType new_type(tType inParentType, tTree inTree)
{
    tType pNewType, pTypes;

    PointerControl(inTree);
    TypeControl(inParentType);

    pTypes = inParentType->Type.Children;

    while (pTypes != NoType) {
        tTree pOrigin;

        pNewType = pTypes->Types.Type;
        TypeControl(pNewType);
        pOrigin = pNewType->Type.Origin;
        PointerControl(pOrigin);
        if (same_type(pOrigin, inTree))
            return pNewType;
        pTypes = pTypes->Types.Next;
    }

    pNewType = mType(inTree, inParentType, ++type_num, NoType, 0, 0, 0);
    pTypes = mTypes(pNewType, inParentType->Type.Children);
    inParentType->Type.Children = pTypes;


    return pNewType;
}




/**
 * Traverses struct or union members with fill_be_type_tree.
 *
 * @param yyt processing node
 */
static void traverse_su_members(tTree yyt)
{
    tTree pMemberList;

    pMemberList = yyt->MPC_SU_Type.MemberDecls;

    if (pMemberList != NoTree) {
        while (pMemberList->Kind != kMPC_FreeNode) {
            tTree pMember = pMemberList->MPC_SU_MemberDecl.Member;

            PointerControl(pMember);
            while (pMember->Kind != kMPC_FreeNode) {
                tTree pMemberType = pMember->MPC_SU_Member.Type;

                PointerControl(pMemberType);
                fill_be_type_tree(pMemberType);
                pMember = pMember->MPC_SU_Member.Next;
                PointerControl(pMember);
            }
            pMemberList = pMemberList->MPC_SU_MemberDecl.Next;
            PointerControl(pMemberList);
        }
    }
}


/**
 * Assignes Struct/Union tags for nonamed structs.
 *
 * @param yyt processing type
 */

void assign_SU_tag(tTree yyt)
{
    PointerControl(yyt);

    if (yyt->MPC_SU_Type.SU_Tag == NoIdent) {
        static mpc_su_tag_num = 0;
        char *nam;
        nam = (char *) malloc(MAX_IDENT_LEN);
        sprintf(nam, "%s%d", MPC_SU_TAG, mpc_su_tag_num++);
        yyt->MPC_SU_Type.SU_Tag = MakeIdent(nam, strlen(nam));
    }
}


/**
 * Function contructs the back-end type tree
 *
 * @param yyt the processing node
 */
void fill_be_type_tree(tTree yyt)
{
    tTree pParentType = NoTree;

    tType pParent = NoType;


    if (prt)
        printf("fill_be_type_tree yyt=%p Kind=%d \n",
               yyt, yyt != NoTree ? yyt->Kind : 0);

    if (yyt != NoTree) {
        tTree aux = NoTree;

        if (Tree_IsType(yyt, kMPC_Type) && yyt->MPC_Type.pType == NoType) {
            switch (yyt->Kind) {
            case kMPC_Typedef:
                pParentType = Strip_Typedef(yyt);       /* ka 18.02.2002 */
                break;
            case kMPC_ArrayType:
                pParentType = yyt->MPC_ArrayType.ElementType;
                break;
            case kMPC_VectorType:
                pParentType = yyt->MPC_VectorType.ElementType;
                break;
            case kMPC_PointerType:
                pParentType = yyt->MPC_PointerType.ElementType;
                break;
            case kMPC_StructType:
            case kMPC_UnionType:
                traverse_su_members(yyt);
                aux = get_complete_su_type(yyt);
                assign_SU_tag(aux);
                pParent = TypeRoot;
                break;
            default:
                pParent = TypeRoot;
                break;
            }

            if (pParent == NoType) {
                PointerControl(pParentType);
                fill_be_type_tree(pParentType);
                TypeControl(pParentType->MPC_Type.pType);
                pParent = pParentType->MPC_Type.pType;
            }

            if (yyt->Kind == kMPC_Typedef)
                yyt->MPC_Type.pType = pParentType->MPC_Type.pType;
            else if (yyt->MPC_Type.pType == NoType)
                yyt->MPC_Type.pType =
                    new_type(pParent, (aux != NoTree) ? aux : yyt);


            if (yyt->MPC_Type.pType == NoType) {
                fprintf(stderr,
                        "wrong result of the be type tree generation yyt=%p\n",
                        yyt);
                internal_error();
            }
        } else {
            if (prt)
                printf("\n");
        }
    }
}


#define RTS_TYPE_BASIC      "MPC_Basic"
#define RTS_TYPE_ENUM       "MPC_Enum"
#define RTS_TYPE_TYPEDEF    "MPC_Typedef"
#define RTS_TYPE_BITFIELD   "MPC_BitField"
#define RTS_TYPE_ARRAY      "MPC_Array"
#define RTS_TYPE_POINTER    "MPC_Pointer"
#define RTS_TYPE_STRUCT     "MPC_Struct"
#define RTS_TYPE_UNION      "MPC_Union"
#define RTS_TYPE_FUNCTION   "MPC_Function"
#define RTS_TYPE_LIST       "MPC_List"

static char *EmptyString = "";




/**
 * Function returns the name of auxilary initializer variable
 * for filling dynamic fields.
 */
static char *GetMpcAuxInitName()
{
    static int AuxInitNameNum = 0;
    static char AuxInitNameBuf[128];

    sprintf(AuxInitNameBuf, "%s_%d", MPC_AUX_INIT_NAME_PREFIX,
            AuxInitNameNum++);
    return AuxInitNameBuf;
}


/**
 * Traverses EquivType ring list and returns the complete
 * definition (if any) or parameter tree (yyt) otherwise.
 *
 * @param yyt struct/union type
 */
static tTree get_complete_su_type(tTree yyt)
{
    tTree p;

    yyt = Strip_Typedef(yyt);
    for (p = yyt->MPC_SU_Type.EquivType;; p = p->MPC_SU_Type.EquivType)
        if (p == NoTree)
            return yyt;
        else if (p->MPC_SU_Type.MemberDecls)
            return p;
        else if (p == yyt)
            return yyt;
}

/**
 * Traverses EquivType ring list and returns 1 if the rts type is
 * already generated for ring list and 0 otherwise.
 *
 * @param yyt struct/union type
 */
static int su_type_already_generated(tTree yyt)
{
    tTree p;
    int ret = 0;

    yyt = Strip_Typedef(yyt);

    for (p = yyt->MPC_SU_Type.EquivType; (p != NoTree) && (p != yyt);
         p = p->MPC_SU_Type.EquivType)
        if ((p->MPC_Type.pType)
            && (((tType) (p->MPC_Type.pType))->Type.Gen)) {
            ret = 1;
            break;
        }

    return ret;
}



static void declare_MemberList(tTree pMemberList, tTree yyt)
{

}

/**
 * Checks whether RTS tree for type cannot be completely 
 * generated on file scope level and should be initialized
 * at the place where type is appeared in the program code.
 *
 * @param inType processing type
 */
static int is_type_to_fill_later(tTree inType)
{
    tTree tt;
    int rc = 0;

    if (is_dynamic_type(inType))
        rc = 1;
    else {
        tt = get_TerminalAVType(inType);
        PointerControl(tt);
        if (((Tree_IsType(tt, kMPC_SU_Type) ||
              Tree_IsType(tt, kMPC_EnumType)) &&
             tt->MPC_Type.Flag.Local) ||
            (Tree_IsType(tt, kMPC_Typedef) && tt->MPC_Type.Flag.Local))
            rc = 1;
    }
    return rc;
}

/**
 * Generates declarations for ALL rts type tree nodes
 * at the file-scope level to be initialized later.
 *
 * @param yy back-end type tree node 
 */
void declare_rts_type_tree(tType yy)
{
    TypeControl(yy);

    if (yy->Kind == kType && yy->Type.Used == 1) {
        tTree yyt = yy->Type.Origin;
        tIdent Ident;
        tTree pElement;
        PointerControl(yyt);

        switch (yyt->Kind) {
        case kMPC_BasicType:
            print2file("", "static %s %s;\n",
                       RTS_TYPE_BASIC, DataVarName(yyt));
            break;
        case kMPC_EnumType:
            print2file("", "static %s %s;\n",
                       RTS_TYPE_ENUM, DataVarName(yyt));
            break;
        case kMPC_Typedef:
            fprintf(stderr, "typedef can not be in be_type_tree\n");
            internal_error();
            break;
        case kMPC_ArrayType:
            c_blank;
            print2file("", "static %s %s;\n",
                       RTS_TYPE_ARRAY, DataVarName(yyt));
            break;
        case kMPC_VectorType:
            c_blank;
            print2file("", "static %s %s;\n",
                       RTS_TYPE_ARRAY, DataVarName(yyt));

            break;
        case kMPC_PointerType:
            print2file("", "static %s %s;\n", RTS_TYPE_POINTER,
                       DataVarName(yyt));
            break;
        case kMPC_StructType:
        case kMPC_UnionType:
            {
                char *type_name = (yyt->Kind == kMPC_StructType) ?
                    RTS_TYPE_STRUCT : RTS_TYPE_UNION;

                declare_SU_members_types(yyt);

                Ident = yyt->MPC_SU_Type.SU_Tag;
                print2file("", "static %s %s;\n",
                           type_name, DataVarName(yyt));
            }
            break;
        case kMPC_FunctionType:
            print2file("", "static %s %s;\n",
                       RTS_TYPE_FUNCTION, DataVarName(yyt));

            break;
        default:
            break;
        }
        yy->Type.Gen = GEN_DECLARED;
    }

}

/** 
 * Prints Const, Volatile and Repl type qualifiers 
 * in RTS type tree
 *
 * inTree processing type
 */
static void print_rts_type_qualifiers(tTree inTree)
{
/*
    PointerControl(inTree);
    print2file("", "%d, %d, %d,", 
        inTree->MPC_Type.Flag.Const,
        inTree->MPC_Type.Flag.Volatile,
        inTree->MPC_Type.Flag.Repl);
*/
}

/**
 * Generates structures of rts tree at the file scope level
 * and initializes some fields. If the type is derived from struct
 * or union with local scope then "Size" field is initialized with 0 -
 * to be assigned with expressions generated by print_rts_type_tree at 
 * the place where type is needed (var declarations or vector expression).
 *
 * @param yy back-end type tree node
 */
void define_rts_type_tree(tType yy)
{
    int old_in_type = in_type;
    tType pAux;
    int old_not_check = not_check;
    int SU_printed = 1;
    char *mem_class = in_function ? "" : "static ";

    not_check = 1;

    in_type = 1;
    TypeControl(yy);
    if (yy != NoType) {
        if (prt)
            printf
                ("print_rts_type_tree yy=%p Gen=%d Used=%d Number=%d\n",
                 yy, yy->Type.Gen, yy->Type.Used, yy->Type.Number);
    }


    if (yy->Kind == kType && (yy->Type.Gen & GEN_DECLARED)) {
        tTree yyt = yy->Type.Origin;
        tIdent Ident;
        tTree pElement;

        PointerControl(yyt);

        switch (yyt->Kind) {
        case kMPC_BasicType:
            yyt->MPC_BasicType.UniqueNumber = ++type_num;
            print2file("", "%s %s %s={{k%s,\"",
                       mem_class,
                       RTS_TYPE_BASIC, DataVarName(yyt), RTS_TYPE_BASIC);
            print2file("", "\",%d,", yy->Type.Number);
            if (yyt->MPC_BasicType.TypeConstructor != VOID) {
                print2file("", "sizeof(");
                print_Type_in_rts(yyt);
                print2file("", "),");
            } else {
                print2file("", "0,");
            }
            print2file("", "1,");
            print_rts_type_qualifiers(yyt);
            print2file("", "%s},%d};\n",
                       NULL_DATATYPE, -yyt->MPC_BasicType.TypeConstructor);
            break;
        case kMPC_EnumType:
            {
                yyt->MPC_BasicType.UniqueNumber = ++type_num;
                print2file("", "%s %s %s={k%s,",
                           mem_class,
                           RTS_TYPE_ENUM, DataVarName(yyt), RTS_TYPE_ENUM);
                Ident = yyt->MPC_EnumType.EnumTag;
                if (Ident != NoIdent) {
                    GetString(Ident, NameBuf);
                } else {
                    strcpy(NameBuf, "NoName");
                }
                print2file("", "\"%s\",%d,sizeof(",
                           NameBuf, yy->Type.Number);
                if (Ident != NoIdent) {
                    not_members = 1;
                    in_type = 0;
                }
                print_Type_in_rts(yyt);
                not_members = 0;
                print2file("", "),1,");
                print_rts_type_qualifiers(yyt);
                print2file("", "%s};\n", NULL_DATATYPE);
            }
            AddToTypeTab(yyt);
            break;
        case kMPC_Typedef:
            fprintf(stderr, "typedef can not be in be_type_tree\n");
            internal_error();
            break;
        case kMPC_ArrayType:
            pElement = yyt->MPC_ArrayType.ElementType;
            PointerControl(pElement);



            c_blank;
            print2file("", "%s%s %s={{k%s,",
                       mem_class,
                       RTS_TYPE_ARRAY, DataVarName(yyt), RTS_TYPE_ARRAY);
            print2file("", "\"");
            print2file("", "\",%d,", yy->Type.Number);
            if (is_type_to_fill_later(yyt) ||
                (yyt->MPC_ArrayType.NumberOfComponents == UNDEFINED))
                print2file("", "0");
            else {
                print2file("", "%d * sizeof(",
                           yyt->MPC_ArrayType.NumberOfComponents);
                print_Type_in_rts(yyt->MPC_ArrayType.ElementType);
                print2file("", ")");
            }
            print2file("", ",%d,", yyt->MPC_ArrayType.Flag.MemCopy);

            print_rts_type_qualifiers(yyt);

            print2file("", "%s},", NULL_DATATYPE);

            if (is_dynamic_step(yyt) && (yyt->MPC_ArrayType.Step == 0)) {
                print2file("", "0,");
            } else
                print2file("", "%d,", yyt->MPC_ArrayType.Step);

            if (yyt->MPC_ArrayType.NumberOfComponents == UNDEFINED) {
                print2file("", "MPC_UNDEFINED_COUNT");
            } else if (is_dynamic_size(yyt)
                       && (yyt->MPC_ArrayType.NumberOfComponents == 0)) {
                print2file("", "0");
            } else {
                print2file("", "%d",
                           yyt->MPC_ArrayType.NumberOfComponents);
            }
            print2file("", ",");
            print2file("", "(%s)&%s", DATATYPE, DataVarName(pElement));
            print2file("", ",%d", yyt->MPC_ArrayType.Flag.BitArray);
            if(MPF_SRC)print2file("", ",%d", yyt->MPC_ArrayType.IsString);
            if(MPF_SRC)print2file("", ",%d", yyt->MPC_ArrayType.Lbound);
            print2file("", "};\n");
            AddToTypeTab(yyt);
            break;
        case kMPC_VectorType:


            c_blank;
            print2file("", "%s%s %s={{k%s,",
                       mem_class,
                       RTS_TYPE_ARRAY, DataVarName(yyt), RTS_TYPE_ARRAY);
            print2file("", "\"");
            print2file("", "\",%d,", yy->Type.Number);
            if (is_type_to_fill_later(yyt) ||
                (yyt->MPC_VectorType.NumberOfComponents == UNDEFINED))
                print2file("", "0,");
            else {
                print2file("", "%d * sizeof(",
                           yyt->MPC_VectorType.NumberOfComponents);
                print_Type_in_rts(yyt->MPC_VectorType.ElementType);
                print2file("", "),");
            }
            //print2file("", "1,");
            print2file("", "%d,", yyt->MPC_VectorType.Flag.MemCopy);

            print_rts_type_qualifiers(yyt);

            print2file("", "%s},", NULL_DATATYPE);
            PointerControl(yyt->MPC_VectorType.ElementType);
            if (is_dynamic_step(yyt)) {
                print2file("", "0,");
            } else
                print2file("", "%d,", yyt->MPC_VectorType.Step);
                
            if (yyt->MPC_VectorType.NumberOfComponents == UNDEFINED) {
                print2file("", "MPC_UNDEFINED_COUNT");
            } else if (is_dynamic_size(yyt)
                       && (yyt->MPC_VectorType.NumberOfComponents == 0)) {
                print2file("", "0");
            } else {
                print2file("", "%d",
                           yyt->MPC_VectorType.NumberOfComponents);
            }
            print2file("", ",(%s)&%s,0};\n",
                       DATATYPE,
                       DataVarName(yyt->MPC_VectorType.ElementType));

            AddToTypeTab(yyt);
            break;
        case kMPC_PointerType:
            pElement = yyt->MPC_PointerType.ElementType;
            {
                tTree pMemberList;
                tType pElem = pElement->MPC_Type.pType;

                if (pElement->Kind == kMPC_StructType ||
                    pElement->Kind == kMPC_UnionType)
                    pMemberList = pElement->MPC_SU_Type.MemberDecls;

                c_blank;

                print2file("", "%s%s %s={{k%s,",
                           mem_class,
                           RTS_TYPE_POINTER,
                           DataVarName(yyt), RTS_TYPE_POINTER);
                print2file("", "\"");
                print2file("", "\",%d,", yy->Type.Number);
                print2file("", "sizeof(void* )");
                print2file("", ",1,");
                print_rts_type_qualifiers(yyt);
                print2file("", "%s},1,", NULL_DATATYPE);
                print2file("", "(%s)&%s};\n", DATATYPE,
                           DataVarName(pElement));

                AddToTypeTab(yyt);
            }
            break;
        case kMPC_StructType:
        case kMPC_UnionType:
            {
                tTree pMemberList;
                char *type_name = (yyt->Kind == kMPC_StructType) ?
                    RTS_TYPE_STRUCT : RTS_TYPE_UNION;

                pMemberList = yyt->MPC_SU_Type.MemberDecls;
                Ident = yyt->MPC_SU_Type.SU_Tag;

                define_SU_members_types(yyt);

                print2file("", "static %s %s={{k%s,",
                           type_name, DataVarName(yyt), type_name);
                GetString(Ident, NameBuf);
                print2file("", "\"%s\",%d,", NameBuf, yy->Type.Number);
                if (is_type_to_fill_later(yyt) || (pMemberList == NoTree)) {
                    print2file("", "0");
                } else {
                    print2file("", "sizeof(");
                    print_Type_in_rts(yyt);
                    print2file("", ")");
                }

                print2file("", ",1,");
                print_rts_type_qualifiers(yyt);
                print2file("", "%s },", NULL_DATATYPE);

                if (pMemberList != NoTree)
                    print2file("", "(%s)&%s};\n",
                               DATATYPE,
                               DataVarName(pMemberList->MPC_SU_MemberDecl.
                                           Member));
                else
                    print2file("", "%s};\n", NO_MPC_TYPE_DATATYPE);

                AddToTypeTab(get_complete_su_type(yyt));
            }
            break;
        case kMPC_FunctionType:
            print2file("", "static %s %s={k%s,",
                       RTS_TYPE_FUNCTION, DataVarName(yyt),
                       RTS_TYPE_FUNCTION);
            print2file("", "\"%s\",%d,0,1,",
                       EmptyString, yyt->MPC_FunctionType.UniqueNumber);
            print_rts_type_qualifiers(yyt);
            print2file("", "%s};\n", NULL_DATATYPE);
            break;
        default:
            break;
        }
    }

    not_check = old_not_check;
    in_type = old_in_type;
}

/**
 * Clears flags indicating that local Type info has been
 * produced.
 * 
 * @param yy processing type
 */
void unprint_rts_type_tree(tType yy)
{
        
    if (yy->Kind == kType) {
        tTree yyt = yy->Type.Origin;
        PointerControl(yyt);
        if(yyt->Kind == kMPC_VectorType) {
            tType pyy;
            
            yy->Type.Gen &= (~GEN_INITIALIZED);
            pyy = yyt->MPC_VectorType.ElementType->MPC_Type.pType;
            if(pyy != NoType)
                unprint_rts_type_tree(pyy);
        }
     }

}

/**
 * Fills in size and step fields for types which are
 * not initialized at the file-scope level
 *
 * @param yy back-end type tree node
 */
void print_rts_type_tree(tType yy)
{
    int old_in_type = in_type;
    tType pAux;
    int old_not_check = not_check;

    not_check = 1;
    in_type = 1;

    TypeControl(yy);

    if (yy->Kind == kType && (yy->Type.Gen & GEN_DECLARED) &&
        (!(yy->Type.Gen & GEN_INITIALIZED))) {
        tTree yyt = yy->Type.Origin;
        tIdent Ident;
        tTree pElement;

        PointerControl(yyt);
        if (is_type_to_fill_later(yyt)) {
            switch (yyt->Kind) {
            case kMPC_EnumType:
                print2file("", "%s.Base.Size = sizeof(", DataVarName(yyt));
                print_Type_in_rts(yyt);
                print2file("", ");\n");
                AddToTypeTab(yyt);
                break;
            case kMPC_Typedef:
                fprintf(stderr, "typedef can not be in be_type_tree\n");
                internal_error();
                break;
            case kMPC_ArrayType:
                print_rts_type_tree(yyt->MPC_ArrayType.ElementType->
                                    MPC_Type.pType);
                c_blank;
                print2file("", "int %s = (", GetMpcAuxInitName());

                print2file("", "%s.Base.Size = ", DataVarName(yyt));

                print2file("", "%s.Base.Size*(",
                           DataVarName(yyt->MPC_ArrayType.ElementType));
                print2file("", "((");
                if (is_dynamic_size(yyt)
                    && (yyt->MPC_ArrayType.NumberOfComponents == 0))
                    print_Expr(yyt->MPC_ArrayType.ArraySize);
                else
                    print2file("", " %d ",
                               yyt->MPC_ArrayType.NumberOfComponents);
                print2file("", ")-1)");
                if (is_dynamic_step(yyt) && (yyt->MPC_ArrayType.Step == 0)) {
                    print2file("", "*(");
                    print_Expr(yyt->MPC_ArrayType.DynStep);
                    print2file("", ")");
                } else if (yyt->MPC_ArrayType.Step != 1) {
                    print2file("", "*(");
                    print2file("", "%d", yyt->MPC_ArrayType.Step);
                    print2file("", ")");
                }

                print2file("", "+1),");

                if (is_dynamic_size(yyt)
                    && (yyt->MPC_ArrayType.NumberOfComponents == 0)) {
                    print2file("", "%s.Number=", DataVarName(yyt));
                    print_Expr(yyt->MPC_ArrayType.ArraySize);
                    print2file("", ",");
                }

                if (is_dynamic_step(yyt) && (yyt->MPC_ArrayType.Step == 0)) {
                    print2file("", "%s.Step=", DataVarName(yyt));
                    print_Expr(yyt->MPC_ArrayType.DynStep);
                    print2file("", ",");
                }
                print2file("", "MPC_Type_free(&(%s.Base.Datatype)),",
                           DataVarName(yyt));
                print2file("", "0);\n");

                c_blank;
                print2file("", "int %s%s=", DataVarName(yyt),
                           SHIFT_SIZE_POSTFIX);

                if ((yyt->MPC_ArrayType.ElementType->Kind ==
                     kMPC_ArrayType)
                    || (yyt->MPC_ArrayType.ElementType->Kind ==
                        kMPC_VectorType)) {
                    print2file("", "(%s.Base.Size",
                               DataVarName(yyt->MPC_ArrayType.
                                           ElementType));
                    print2file("", "/");
                    print2file("", "sizeof(");
                    print_Type_in_rts(First_Static_Type(yyt));
                    print2file("", "))");

                    if (is_dynamic_step(yyt)
                        && (yyt->MPC_ArrayType.Step == 0)) {
                        print2file("", "*%s.Step", DataVarName(yyt));
                    } else if (yyt->MPC_ArrayType.Step != 1) {
                        print2file("", "*%d", yyt->MPC_ArrayType.Step);
                    }
                } else {
                    if (is_dynamic_step(yyt)
                        && (yyt->MPC_ArrayType.Step == 0)) {
                        print2file("", "%s.Step", DataVarName(yyt));
                    } else {
                        print2file("", "%d", yyt->MPC_ArrayType.Step);
                    }
                }

                print2file("", ";\n");

                c_blank;

                print2file("", "int %s%s=", DataVarName(yyt),
                           REDUCED_SIZE_POSTFIX);

                print2file("", "%s.Base.Size/", DataVarName(yyt));

                print2file("", "sizeof(");
                print_Type_in_rts(First_Static_Type(yyt));
                print2file("", ");\n");

                /*AddToTypeTab(yyt); */
                break;
            case kMPC_VectorType:
                print_rts_type_tree(yyt->MPC_VectorType.ElementType->
                                    MPC_Type.pType);
                c_blank;
                print2file("", "int %s = (", GetMpcAuxInitName());

                print2file("", "%s.Base.Size = ", DataVarName(yyt));


                print2file("", "%s.Base.Size*(",
                           DataVarName(yyt->MPC_VectorType.ElementType));

                if (yyt->MPC_VectorType.NumberOfComponents == 0) {
                    print_Expr(yyt->MPC_VectorType.VectorSize);
                } else
                    print2file("", "%d",
                               yyt->MPC_VectorType.NumberOfComponents);

                print2file("", "),");

                if (is_dynamic_size(yyt)
                    && (yyt->MPC_VectorType.NumberOfComponents == 0)) {
                    print2file("", "%s.Number=", DataVarName(yyt));
                    print_Expr(yyt->MPC_VectorType.VectorSize);
                    print2file("", ",");
                }
                if (is_dynamic_step(yyt) /*&& (yyt->MPC_VectorType.Step == 0)*/) {
                    print2file("", "%s.Step=", DataVarName(yyt));
                    print_Expr(yyt->MPC_VectorType.DynStep);
                    print2file("", ",");
                }
                print2file("", "MPC_Type_free(&(%s.Base.Datatype)),",
                           DataVarName(yyt));
                print2file("", "0);\n");

                c_blank;
                print2file("", "int %s%s=", DataVarName(yyt),
                           SHIFT_SIZE_POSTFIX);

                if ((yyt->MPC_VectorType.ElementType->Kind ==
                     kMPC_VectorType)
                    || (yyt->MPC_VectorType.ElementType->Kind ==
                        kMPC_VectorType)) {
                    print2file("", "(%s.Base.Size",
                               DataVarName(yyt->MPC_VectorType.
                                           ElementType));
                    print2file("", "/");
                    print2file("", "sizeof(");
                    print_Type_in_rts(First_Static_Type(yyt));
                    print2file("", "))");
                } else {
                    print2file("", "1");
                }

                print2file("", ";\n");
                AddToTypeTab(yyt);
                break;
            case kMPC_PointerType:
                print_rts_type_tree(yyt->MPC_PointerType.ElementType->
                                    MPC_Type.pType);
                c_blank;
                print2file("", "int %s%s=(", DataVarName(yyt),
                           SHIFT_SIZE_POSTFIX);
                if (is_dynamic_pointer(yyt)) {
                    tTree pStep = yyt->MPC_PointerType.DynStep;

                    PointerControl(pStep);
                    print_Expr(pStep);
                } else {
                    print2file("", "%d", yyt->MPC_PointerType.Step);
                }
                print2file("", ")");
                if (is_pointer_on_dynamic(yyt)) {
                    print2file("", "*%s%s",
                               DataVarName(yyt->MPC_PointerType.
                                           ElementType),
                               REDUCED_SIZE_POSTFIX);
                }
                print2file("", ";\n");
                AddToTypeTab(yyt);
                break;
            case kMPC_StructType:
            case kMPC_UnionType:
                assign_SU_members_offsets(yyt);
                c_blank;
                print2file("", "int %s = (", GetMpcAuxInitName());
                print2file("", "%s.Base.Size = sizeof(", DataVarName(yyt));
                print_Type_in_rts(yyt);
                print2file("", "),0);\n");
                break;
            default:
                break;
            }
            yy->Type.Gen = yy->Type.Gen | GEN_INITIALIZED;
        }

    }
    not_check = old_not_check;
    in_type = old_in_type;
}


/**
 * Function print_rts_type prints RTS type structures  for a given 
 * tree type. It is used in data-exchange assignements.
 *
 * @param pType processing type node
 *
 */
void print_rts_type(tTree pType)
{
    int old_print_base_type = print_base_type;
    tType p_type;
    PointerControl(pType);
    p_type = pType->MPC_Type.pType;
    if (p_type != NoType) {
        if (prt)
            printf("print_rts_type\n");
        print_base_type = 1;
        print_rts_type_tree(p_type);
        print_base_type = old_print_base_type;
    } else {
        fprintf(stderr, "not filled back_end type tree for type %s\n",
                TypeName(pType));
        internal_error();
    }
}


/**
 * Function generates structures of rts tree
 * intializes fields which are not statically initialized in 
 * print_rts_type_tree.
 *
 * @param yy processing back-end type tree node
 */
void print_rts_type_tree_2(tType yy)
{
/*
    tTree yyt;
    tTree pSize;
    tType pAux;
    int old_not_check = not_check;


    TypeControl(yy);
    not_check = 1;
    if (yy != NoType) {
        if (prt)
            printf("print_rts_type_tree2 yy=%p Gen=%d\n", yy,
                   yy->Type.Gen);
    }

    if ((yy->Kind == kType) &&
        (yy->Type.Gen != PRTT_2PASS) && (yy->Type.Used == 0)) {
        tTree yyt = yy->Type.Origin;

        PointerControl(yyt);
        switch (yyt->Kind) {
        case kMPC_PointerType:
            if (yyt->MPC_PointerType.ElementType->MPC_Type.pType !=
                parent_type) {
                parent_type = yy;
                print_rts_type_tree_2(yyt->MPC_PointerType.ElementType->
                                      MPC_Type.pType);
            }
            break;
        }
        if (set_gen_2)
            yy->Type.Gen = PRTT_2PASS;
    }

    if ((yy->Kind == kType) &&
        (yy->Type.Gen != PRTT_2PASS) && (yy->Type.Used == 1)) {
        yyt = yy->Type.Origin;
        PointerControl(yyt);
        if (is_dynamic_type(yyt))
            switch (yyt->Kind) {
            case kMPC_ArrayType:
                if (set_gen_2)
                    yy->Type.Gen = PRTT_2PASS;
                print_rts_type_tree_2(yyt->MPC_ArrayType.ElementType->
                                      MPC_Type.pType);
                pSize = yyt->MPC_ArrayType.ArraySize;
                PointerControl(pSize);

                c_blank;
                print2file("", "%s.Base.Size=", DataVarName(yyt));
                print2file("", "%s.Base.Size*(",
                           DataVarName(yyt->MPC_ArrayType.ElementType));
                print2file("", "((");
                if (is_dynamic_size(yyt)
                    && (yyt->MPC_ArrayType.NumberOfComponents == 0))
                    print_Expr(pSize);
                else
                    print2file("", " %d ",
                               yyt->MPC_ArrayType.NumberOfComponents);
                print2file("", ")-1)");


                if (is_dynamic_step(yyt) && (yyt->MPC_ArrayType.Step == 0)) {
                    tTree pStep = yyt->MPC_ArrayType.DynStep;

                    PointerControl(pStep);
                    print2file("", "*(");
                    print_Expr(pStep);
                    print2file("", ")");
                } else if (yyt->MPC_ArrayType.Step != 1) {
                    print2file("", "*(");
                    print2file("", "%d", yyt->MPC_ArrayType.Step);
                    print2file("", ")");
                }

                print2file("", "+1);\n");
                if (is_dynamic_size(yyt)
                    && (yyt->MPC_ArrayType.NumberOfComponents == 0)) {
                    c_blank;
                    print2file("", "%s.Number=", DataVarName(yyt));
                    print_Expr(pSize);
                    print2file("", ";\n");
                } else {
                    c_blank;
                    print2file("", "%s.Number=", DataVarName(yyt));
                    print2file("", "%d",
                               yyt->MPC_ArrayType.NumberOfComponents);
                    print2file("", ";\n");
                }

                if (is_dynamic_step(yyt) && (yyt->MPC_ArrayType.Step == 0)) {
                    tTree pStep = yyt->MPC_ArrayType.DynStep;

                    c_blank;
                    print2file("", "%s.Step=", DataVarName(yyt));
                    PointerControl(pStep);
                    print_Expr(pStep);
                    print2file("", ";\n");
                }

                c_blank;
                print2file("", "%s%s=", DataVarName(yyt),
                           SHIFT_SIZE_POSTFIX);

                if ((yyt->MPC_ArrayType.ElementType->Kind ==
                     kMPC_ArrayType)
                    || (yyt->MPC_ArrayType.ElementType->Kind ==
                        kMPC_VectorType)) {
                    print2file("", "(%s.Base.Size",
                               DataVarName(yyt->MPC_ArrayType.
                                           ElementType));
                    print2file("", "/");
                    print2file("", "sizeof(");
                    print_Type_in_rts(First_Static_Type(yyt));
                    print2file("", "))");

                    if (is_dynamic_step(yyt)
                        && (yyt->MPC_ArrayType.Step == 0)) {
                        print2file("", "*%s.Step", DataVarName(yyt));
                    } else if (yyt->MPC_ArrayType.Step != 1) {
                        print2file("", "*%d", yyt->MPC_ArrayType.Step);
                    }
                } else {
                    if (is_dynamic_step(yyt)
                        && (yyt->MPC_ArrayType.Step == 0)) {
                        print2file("", "%s.Step", DataVarName(yyt));
                    } else {
                        print2file("", "%d", yyt->MPC_ArrayType.Step);
                    }
                }

                print2file("", ";\n");

                c_blank;
                print2file("", "%s%s=%s.Base.Size/", DataVarName(yyt),
                           REDUCED_SIZE_POSTFIX, DataVarName(yyt));

                print2file("", "sizeof(");
                print_Type_in_rts(First_Static_Type(yyt));
                print2file("", ");\n");

                if (yy->Type.VectorType != NoType)
                    print_rts_type_tree_2(yy->Type.VectorType);
                if (yy->Type.PointerType != NoType)
                    print_rts_type_tree_2(yy->Type.PointerType);
                if (yy->Type.EquivType)
                    for (pAux = yy->Type.EquivType; pAux != NoType;
                         pAux = pAux->Types.Next)
                        print_rts_type_tree_2(pAux->Types.Type);
                break;
            
            case kMPC_VectorType:
                if (set_gen_2)
                    yy->Type.Gen = PRTT_2PASS;
                pSize = yyt->MPC_VectorType.VectorSize;
                print_rts_type_tree_2(yyt->MPC_VectorType.ElementType->
                                      MPC_Type.pType);


                c_blank;
                print2file("", "%s.Base.Size=", DataVarName(yyt));
                print2file("", "%s.Base.Size*(",
                           DataVarName(yyt->MPC_VectorType.ElementType));

                if (yyt->MPC_VectorType.NumberOfComponents == 0) {
                    PointerControl(pSize);
                    print_Expr(pSize);
                } else
                    print2file("", "%d",
                               yyt->MPC_VectorType.NumberOfComponents);

                print2file("", ");\n");

                if (yyt->MPC_VectorType.NumberOfComponents == 0) {
                    c_blank;
                    print2file("", "%s.Number=", DataVarName(yyt));
                    print_Expr(pSize);
                    print2file("", ";\n");
                } else {
                    c_blank;
                    print2file("", "%s.Number=", DataVarName(yyt));
                    print2file("", "%d",
                               yyt->MPC_VectorType.NumberOfComponents ==
                               0);
                    print2file("", ";\n");
                }


                c_blank;
                print2file("", "%s%s=", DataVarName(yyt),
                           SHIFT_SIZE_POSTFIX);

                if ((yyt->MPC_VectorType.ElementType->Kind ==
                     kMPC_VectorType)
                    || (yyt->MPC_VectorType.ElementType->Kind ==
                        kMPC_VectorType)) {
                    print2file("", "(%s.Base.Size",
                               DataVarName(yyt->MPC_VectorType.
                                           ElementType));
                    print2file("", "/");
                    print2file("", "sizeof(");
                    print_Type_in_rts(First_Static_Type(yyt));
                    print2file("", "))");
                } else {
                    print2file("", "1");
                }

                print2file("", ";\n");
                break;
             
            case kMPC_PointerType:
                if (set_gen_2)
                    yy->Type.Gen = PRTT_2PASS;
                print_rts_type_tree_2(yyt->MPC_PointerType.ElementType->
                                      MPC_Type.pType);
                c_blank;
                print2file("", "%s%s=(", DataVarName(yyt),
                           SHIFT_SIZE_POSTFIX);
                if (is_dynamic_pointer(yyt)) {
                    tTree pStep = yyt->MPC_PointerType.DynStep;

                    PointerControl(pStep);
                    print_Expr (pStep);
                } else {
                    print2file("", "%d", yyt->MPC_PointerType.Step);
                }
                print2file("", ")");
                if (is_pointer_on_dynamic(yyt)) {
                    print2file("", "*%s%s",
                               DataVarName(yyt->MPC_PointerType.
                                           ElementType),
                               REDUCED_SIZE_POSTFIX);
                }
                print2file("", ";\n");
                break;

            default:
                break;
        } else if (Tree_IsType(yyt, kMPC_SU_Type)
                   && yyt->MPC_SU_Type.MemberDecls) {
            //print2file("", "%s = %s%s;\n", DataVarName(yyt), MPC_AUX_SU_NAME_PREFIX, DataVarName(yyt));
        }

    }
    not_check = old_not_check;
    */
}


tTree Strip_Typedef(tTree pType)
{
    PointerControl(pType);
    if (pType->Kind == kMPC_Typedef)
        return Strip_Typedef(pType->MPC_Typedef.Type);
    else
        return pType;
}

static tTree First_Static_Type(tTree pType)
{
    PointerControl(pType);
    pType = Strip_Typedef(pType);
    if (IS_DYN_ARRAY_OR_VECTOR(pType))
        return First_Static_Type(element_type(pType));
    else
        return pType;
}




tTree last_member(tTree pMemberList)
{
    tTree pMember, pNext;

    PointerControl(pMemberList);
    pMember = pMemberList->MPC_SU_MemberDecl.Member;
    PointerControl(pMember);
    while (1) {
        pNext = pMember->MPC_SU_Member.Next;
        PointerControl(pNext);
        if (prt)
            printf("last_member member=%d next=%d\n",
                   pMember->MPC_SU_Member.UniqueNumber,
                   pNext->Kind == kMPC_FreeNode ? -1 :
                   pNext->MPC_SU_Member.UniqueNumber);
        if (pNext->Kind == kMPC_FreeNode)
            break;
        else
            pMember = pNext;
    }
    if (prt)
        printf("last_member=%d\n", pMember->MPC_SU_Member.UniqueNumber);
    return pMember;
}

tTree last_member_list(tTree pMemberList)
{
    tTree pNext;

    PointerControl(pMemberList);
    while (1) {
        pNext = pMemberList->MPC_SU_MemberDecl.Next;
        PointerControl(pNext);
        if (pNext->Kind == kMPC_FreeNode)
            break;
        else
            pMemberList = pNext;
    }
    return pMemberList;
}

tTree next_member(tTree pMemberList, tTree pMember)
{
    tTree pNextMember, pNextMemberList = NoTree;

    PointerControl(pMemberList);
    PointerControl(pMember);
    pNextMember = pMember->MPC_SU_Member.Next;
    PointerControl(pNextMember);
    if (pNextMember->Kind == kMPC_FreeNode) {
        pNextMemberList = pMemberList->MPC_SU_MemberDecl.Next;
        PointerControl(pNextMemberList);
        if (pNextMemberList->Kind == kMPC_FreeNode) {
            fprintf(stderr, "wrong next member\n");
            internal_error();
        } else {
            /*pNextMember=last_member(pNextMemberList); */
            pNextMember = pNextMemberList->MPC_SU_MemberDecl.Member;
        }
    }
    if (prt)
        printf
            ("next_member Member.Num=%d Next.Num=%d list->num=%d next_list->num=%d\n",
             pMember->MPC_SU_Member.UniqueNumber,
             pNextMember->MPC_SU_Member.UniqueNumber,
             pMemberList->MPC_SU_MemberDecl.Member->MPC_SU_Member.
             UniqueNumber,
             pNextMemberList->Kind ==
             kMPC_SU_MemberDecl ? pNextMemberList->MPC_SU_MemberDecl.
             Member->MPC_SU_Member.UniqueNumber : -1);
    return pNextMember;
}

/**
 *  Generates MPC_List entries declarations for struct/union types for RTS type tree.
 *
 * @param yyt processing  struct or union type
 */
static void declare_SU_members_types(tTree yyt)
{
    int last = 1;
    tTree pMember;
    tTree pMemberList;

    pMemberList = yyt->MPC_SU_Type.MemberDecls;

    if (pMemberList != NoTree) {
        pMemberList = last_member_list(pMemberList);
        while (pMemberList->Kind != kMPC_FreeNode) {
            pMember = last_member(pMemberList);
            PointerControl(pMember);
            while (pMember->Kind != kMPC_FreeNode) {
                int LastListNum;
                char sname[MAX_NAME_LEN];
                char mname[MAX_NAME_LEN];

                pMember->MPC_SU_Member.UniqueNumber = ListNum++;
                print2file("", "static %s %s_%d;\n",
                           RTS_TYPE_LIST, MEMBER_NAME,
                           pMember->MPC_SU_Member.UniqueNumber);

                pMember = pMember->MPC_SU_Member.Prev;
                PointerControl(pMember);
            }
            pMemberList = pMemberList->MPC_SU_MemberDecl.Prev;
            PointerControl(pMemberList);
        }
    }
}

/**
 * Generates list of MPC_List structures for all struct and union memebers.
 *
 * @param yyt processing  struct or union type
 */
static void define_SU_members_types(tTree yyt)
{
    int last = 1;
    tTree pMember;
    tTree pMemberList;

    pMemberList = yyt->MPC_SU_Type.MemberDecls;
    if (pMemberList) {
        pMemberList = last_member_list(pMemberList);
        if (prt)
            printf("print_MemberList pMemberList=%p yyt=%p\n", pMemberList,
                   yyt);
        while (pMemberList->Kind != kMPC_FreeNode) {
            pMember = last_member(pMemberList);
            PointerControl(pMember);
            while (pMember->Kind != kMPC_FreeNode) {
                tTree pType = pMember->MPC_SU_Member.Type;
                int LastListNum;

                LastListNum = ListNum - 1;
                PointerControl(pType);
                print_rts_type_tree(pType->MPC_Type.pType);
                print2file("", "static %s %s_%d={",
                           RTS_TYPE_LIST, MEMBER_NAME,
                           pMember->MPC_SU_Member.UniqueNumber);
                print2file("", "(%s)&%s,", DATATYPE, DataVarName(pType));
                if (last) {
                    last = 0;
                    print2file("", "NoMPC_Type,");
                } else {
                    tTree pNextMember;

                    pNextMember = next_member(pMemberList, pMember);
                    PointerControl(pNextMember);
                    print2file("", "(%s)&%s_%d,", DATATYPE, MEMBER_NAME,
                               pNextMember->MPC_SU_Member.UniqueNumber);
                }
                {
                    tIdent Ident = pMember->MPC_SU_Member.Name;

                    IdentControl(Ident);
                    GetString(Ident, NameBuf);
                    cur_pos += print2file("", "\"%s\", ", NameBuf);
                }
                if ((yyt->MPC_Type.Flag.Local)
                    || Tree_IsType(yyt, kMPC_UnionType)
                    || (pMember->MPC_SU_Member.BitFieldLength != UNDEFINED))
                    cur_pos += print2file("", "MPC_UNDEFINED_OFFSET};\n");
                else {
                    char sname[MAX_NAME_LEN];
                    char mname[MAX_NAME_LEN];

                    GetString(yyt->MPC_SU_Type.SU_Tag, sname);
                    GetString(pMember->MPC_SU_Member.Name, mname);
                    cur_pos +=
                        print2file("", "offsetof(struct %s, %s)};\n",
                                   sname, mname);
                }

                pMember = pMember->MPC_SU_Member.Prev;
                PointerControl(pMember);
            }
            pMemberList = pMemberList->MPC_SU_MemberDecl.Prev;
            PointerControl(pMemberList);
        }
    }
}

/**
 * Assignes Offset field of MPC_List structures for all struct and union memebers
 * which were not initialized at static level. This is true for all struct/union
 * types with block scope.
 *
 * @param yyt processing  struct or union type
 */
static void assign_SU_members_offsets(tTree yyt)
{
    int last = 1;
    tTree pMember;
    tTree pMemberList;

    pMemberList = yyt->MPC_SU_Type.MemberDecls;

    if (pMemberList != NoTree && (!(Tree_IsType(yyt, kMPC_UnionType)))) {
        pMemberList = last_member_list(pMemberList);
        while (pMemberList->Kind != kMPC_FreeNode) {
            pMember = last_member(pMemberList);
            PointerControl(pMember);
            while (pMember->Kind != kMPC_FreeNode) {
                int LastListNum;
                char sname[MAX_NAME_LEN];
                char mname[MAX_NAME_LEN];

                print2file("", "int %s = (", GetMpcAuxInitName());
                print2file("", "%s_%d.Offset = ",
                           MEMBER_NAME,
                           pMember->MPC_SU_Member.UniqueNumber);
                GetString(yyt->MPC_SU_Type.SU_Tag, sname);
                GetString(pMember->MPC_SU_Member.Name, mname);
                cur_pos +=
                    print2file("", "offsetof(struct %s, %s), 0);\n", sname,
                               mname);
                pMember = pMember->MPC_SU_Member.Prev;
                PointerControl(pMember);
            }
            pMemberList = pMemberList->MPC_SU_MemberDecl.Prev;
            PointerControl(pMemberList);
        }
    }
}

static void print_Type_in_rts(tTree yyt)
{
    int old_in_print_rts_sizeof;

    old_in_print_rts_sizeof = in_print_rts_sizeof;
    in_print_rts_sizeof = 1;
    PointerControl(yyt);
    if (yyt->Kind == kMPC_PointerType)
        cur_pos += print2file("", "void *");
    else
        print_Type_in_sizeof(yyt);
    in_print_rts_sizeof = old_in_print_rts_sizeof;
}


void print_Type_in_sizeof(tTree yyt)
{
    int old_in_type = in_type;
    int old_source_only = source_only;
    int old_print_base_type = print_base_type;
    int old_in_sizeof = in_sizeof;

    in_sizeof = 1;
    PointerControl(yyt);
    source_only = 1;
    print_base_type = 1;
    in_type = 1;
    print_Type(yyt);
    source_only = 0;
    print_base_type = 0;
    print_LeftType(yyt, NoTree);
    print_RightType(yyt, NoTree);

    in_sizeof = old_in_sizeof;
    in_type = old_in_type;
    source_only = old_source_only;
    print_base_type = old_print_base_type;
}

void set_parent_used(tType pType)
{
    /*printf("set_parent_used pType=%p Used=%d\n",
       pType, pType->Type.Used); */
    if (pType != NoType) {
        while (pType != TypeRoot && pType != NoType) {
            tTree p_type = pType->Type.Origin;

            PointerControl(p_type);
            pType->Type.Used = 1;
            if (p_type->Kind == kMPC_StructType ||
                p_type->Kind == kMPC_UnionType) {
                tTree pMemberList;

                pMemberList = p_type->MPC_SU_Type.MemberDecls;
                if (pMemberList == NoTree) {
                    tTree pEquivType;

                    pEquivType = p_type->MPC_SU_Type.EquivType;
                    if (pEquivType == NoTree)
                        break;  /* ka 15.02.2002 */
                    pMemberList = pEquivType->MPC_SU_Type.MemberDecls;
                    while (pMemberList == NoTree) {
                        pEquivType = pEquivType->MPC_SU_Type.EquivType;
                        if (pEquivType == p_type) {
                            /*fprintf(stderr,
                               "there is not no null memberlist in struct ring\n");
                               internal_error(); */
                            break;
                        }
                        pMemberList = pEquivType->MPC_SU_Type.MemberDecls;
                    }
                }
                if (pMemberList != NoTree) {
                    /*printf("pMemberList=%p found\n",pMemberList); */
                    while (pMemberList->Kind != kMPC_FreeNode) {
                        tTree pMember =
                            pMemberList->MPC_SU_MemberDecl.Member;
                        /*last_member(pMemberList); */
                        PointerControl(pMember);
                        while (pMember->Kind != kMPC_FreeNode) {
                            tTree pType = pMember->MPC_SU_Member.Type;

                            PointerControl(pType);
                            pType = Strip_Typedef(pType);
                            PointerControl(pType);
                            set_parent_used(pType->MPC_Type.pType);
                            pMember = pMember->MPC_SU_Member.Next;
                            PointerControl(pMember);
                        }
                        pMemberList = pMemberList->MPC_SU_MemberDecl.Next;
                        PointerControl(pMemberList);
                    }
                }
            }
            if (p_type->Kind == kMPC_PointerType) {
#ifdef MPC_DEBUGGER
/* ka 04.01.2001 begin */
                tTree pElement = p_type->MPC_PointerType.ElementType;
                tType pElem;

                PointerControl(pElement);
                pElem = pElement->MPC_Type.pType;
                if (pElem != NoType && !pElem->Type.Used) {
                    set_parent_used(pElem);
                }
/* ka 04.01.2001 end */
#endif                          /*MPC_DEBUGGER */
                break;
            }
            if (pType != NoType)
                pType = pType->Type.Parent;
        }
    }
}

static tTree elem_type(tTree pExpr)
{
    tTree pElemType, pType;

    PointerControl(pExpr);
    pType = pExpr->MPC_Expr.Type;
    PointerControl(pType);
    if (prt)
        printf("elem_type Type->Kind=%d\n", pType->Kind);
    if (pType->Kind == kMPC_ArrayType) {
        pElemType = pType->MPC_ArrayType.ElementType;
    } else if (pType->Kind == kMPC_PointerType) {
        pElemType = pType->MPC_PointerType.ElementType;
    } else if (pType->Kind == kMPC_VectorType) {
        pElemType = pType->MPC_VectorType.ElementType;
    } else {
        //pElemType=NoTree;
        pElemType = pType;
    }
    return pElemType;
}

int compare_buffer_types(tType pS, tType pD)
{
    int ret;

    if (pS == pD)
        ret = ABSOLUTELY_EQUAL;
    else {
        carefull_compare = 0;
        if (same_type(pS->Type.Origin, pD->Type.Origin))
            ret = POSSIBLY_DIFFERENT;
        else
            ret = STRICKTLY_DIFFERENT;
        carefull_compare = 1;
    }

    return ret;
}

tTree buffer_type(tTree pArg)
{
    tTree pSource = NoTree, pDest = NoTree;
    tTree pSourceElType, pDestElType;
    tType pSEl, pDEl;
    int i = 0;

    PointerControl(pArg);
    while (pArg->Kind != kMPC_FreeNode) {
        i++;
        if (i == source_pos[built_in_fun - 1]) {
            pSource = pArg->MPC_Exprs.Expr;
            PointerControl(pSource);
            if (prt)
                printf("source pos=%d\n", i);
        }
        if (i == dest_pos[built_in_fun - 1]) {
            pDest = pArg->MPC_Exprs.Expr;
            PointerControl(pDest);
            if (prt)
                printf("dest pos=%d\n", i);
            break;
        }
        pArg = pArg->MPC_Exprs.Next;
        PointerControl(pArg);
    }
    if (i < dest_pos[built_in_fun - 1]) {
        fprintf(stderr,
                "wrong destination buffer position %d in built-in function list i=%d\n",
                dest_pos[built_in_fun - 1], i);
        internal_error();
    }
    pSourceElType = elem_type(pSource);
    if (pSourceElType == NoTree) {
        be_error("wrong type of the source buffer in built-in function\n");
    }
    pDestElType = elem_type(pDest);
    if (pDestElType == NoTree) {
        be_error
            ("wrong type of the destination buffer in built-in function\n");
    }
    pSEl = pSourceElType->MPC_Type.pType;
    TypeControl(pSEl);
    pDEl = pDestElType->MPC_Type.pType;
    TypeControl(pDEl);

    switch (compare_buffer_types(pSEl, pDEl)) {
    case STRICKTLY_DIFFERENT:
        be_error("element type of the source buffer is not equal to \n"
                 "element type of the destination buffer in built-in function\n");
        break;
    case POSSIBLY_DIFFERENT:
        break;
    }


    /*
       if(pSEl != pDEl) {
       be_error("element type of the source buffer is not equal to \n"
       "element type of the destination buffer in built-in function\n");
       }
     */
    return pSourceElType;
    /*print2file("","(%s)(&%s)",
       DATATYPE,DataVarName(pSourceElType)); */
}

/**
 * Fills RTS types stack for releasing later.
 *
 * @param yyt processing type tree
 */
static void AddToTypeTab(tTree yyt)
{
    if (in_expr) {
        ExprTab.Tab[ExprTab.Index++] = yyt;
        if (ExprTab.Index == ExprTab.ActualSize)
            ExtendArray(&ExprTab.Tab, &ExprTab.ActualSize, sizeof(tTree));
    }
    if (in_stat_decl) {
        BlockTab.Tab[BlockTab.Index++] = yyt;
        if (BlockTab.Index == BlockTab.ActualSize)
            ExtendArray(&BlockTab.Tab, &BlockTab.ActualSize,
                        sizeof(tTree));
    }
}

/**
 * Releases RTS types which where pushed to type stack.
 *
 * @param Tab type stack
 * @see AddToTypeTab
 */
void FreeTypeTab(TypeTab Tab)
{
    int i;

    for (i = Tab.Index - 1; i >= 0; i--) {
        c_blank;
        print2file("", "if(%s.Base.Datatype != MPC_DTN) {\n",
                   DataVarName(Tab.Tab[i]));
        cur_blank += SKIP;
        c_blank;
        print2file("", "MPC_Type_free(&(%s.Base.Datatype));\n",
                   DataVarName(Tab.Tab[i]));
        b_end;
    }
}
