/*
 * $Id: File_print.c,v 1.69 2006/03/31 10:00:25 zahar Exp $
 */


/* code generation for MPC_Root and MPC_Decls nodes */
/* Coded by A.Kalinov 10.95 .. */


#include "be_print.h"

#ifdef MPC_TRACER
#include "tracer.h"
#endif

/*#include <time.h>*/

/* NAMES:    File_print
   PURPOSE:  Generates code for MPC_Root node
   SYNOPSYS: s 
   RETURNS:  void
   */
static void set_gen_trees();
static void set_type_to_zero(tTree yyt);
/*static void set_used_dynamic(tTree yyt);*/
static void set_used_dynamic(tType pType);
static void set_used_atribute(tTree yyt);
static void create_pred_var_tree();
static void create_coord_var_tree();
static void create_init_tree();
static void print_basic_type_rts_tree();
static void set_gen_to_0(tType);
static void clear_gen(tType);
static void find_same_vector(tType pVector, tType pArray);
static void find_same_pointer(tType pArray);
static void find_same_dyn_type(tType pType);

/*tString SourceFile(tPosition VirtPos);
static int have_to_generate(tTree );*/
static void print_header(tString);
static tGen pGlobal = NoGen;

#ifdef MPC_DEBUGGER
static TypeTab FileTab;
void AddFileTab(tTree yyt);
static void FileTabPrint();
#endif                          /*MPC_DEBUGGER */


void File_print(tTree yyt)
{
    tTree pDecls;
    char *file_name;
    /*time_t timer; */
    PointerControl(yyt);
    /* Initialization of the external variables */
    if (pass_number == 1) {
        IdentBuf = malloc(MAX_IDENT_LEN);
        NameBuf = malloc(MAX_NAME_LEN);
        TypeBuf = malloc(MAX_TYPE_LEN);
        if(MPCC_DEBUG) 
            QueryTree(yyt); 

        TraverseTreeTD(yyt, TMP_rebracket);

        refactor(yyt->MPC_Root.Decls);
        if(MPCC_DEBUG)
            QueryTree(yyt); 
    }
    pRoot = yyt;
    topo_fun_code = NOT_TOPO_FUN;
    cur_net_type = NoTree;
    in_function = 0;
    cur_net_param_num = 0;
    is_not_parameter = 1;
    point_num = 0;
    ListNum = 0;
    set_gen_trees();
    cur_block = pRoot;
    creation_section_end = NoTree;
    creation_section_begin = NoTree;
    state_kind = KNOWN;
    blank_is_necessary = 0;
#ifdef MPC_DEBUGGER
    last_global_node.pNode=NoTree;
    last_global_node.Number=0;
    last_global_node_kind=0;
#endif                          /*MPC_DEBUGGER */
    if (pass_number == 1) {
        create_pred_var_tree();
        create_coord_var_tree();
#ifdef MPC_DEBUGGER
        create_init_tree();
#endif                          /*MPC_DEBUGGER */
        PointerControl(COMPUTING_SPACE_LIST);
        PointerControl(COMPUTING_SPACE);
        COMPUTING_SPACE->MPC_NetOrSubnet.MyList = COMPUTING_SPACE_LIST;
        COMPUTING_SPACE->MPC_NetOrSubnet.pGen = pGlobal;
        COMPUTING_SPACE->MPC_NetOrSubnet.Distribution = HOST;
        PointerControl(HOST_LIST);
        PointerControl(HOST);
        HOST->MPC_NetOrSubnet.MyList = HOST_LIST;
        PointerControl(SINGLE_NODE);
        PointerControl(SINGLE_NODE_LIST);
        SINGLE_NODE->MPC_NetOrSubnet.MyList = SINGLE_NODE_LIST;
    }
    cur_act_net = /*COMPUTING_SPACE_LIST */ SINGLE_NODE_LIST;
    enclosed_net = COMPUTING_SPACE_LIST;
    HOST->MPC_NetOrSubnet.pGen = int_gen_tree;
    ext_gen_tree = int_gen_tree;

    PointerControl(yyt->MPC_Root.Source);
    if (prt)
        printf("generation for file %s is started \n",
               yyt->MPC_Root.Source->MPC_Source.FileName);
    if (pass_number == 1) {
        TraverseTreeTD(yyt, create_MyList);
    }
    file_name = yyt->MPC_Root.Source->MPC_Source.FileName;
    source_file = file_name;
    not_dummy = open_c_file(file_name);
#ifdef MPC_DEBUGGER
    FileTab = InitTab;
    MakeArray(&FileTab.Tab, &FileTab.ActualSize, sizeof(tTree));
#endif                          /*MPC_DEBUGGER */
    if (prt)
        printf("before first writing to the file\n");
    print2file("", "/* This file was generated by mpC compiler\n");
    /*timer=time(NULL); */
    print2file("", "   From file %s*/\n\n", file_name);
    print2file("", "\nstatic char* MPC_file_name=\"%s\";\n\n", file_name);

    /*print2file("","\n#ifdef __cplusplus\n");
       print2file("","extern \"C\" {\n");
       print2file("","#endif\n\n"); */

#ifdef MPC_TRACER
    PRINT_TRACE_HEADERS
#endif

    print2file("", "#include <mpCinternal.h>\n");
    if (!CBRACKETS) {
        print2file("", "#include <topo.h>\n");
        if (macro)
            print2file("", "#include <mpc_macro.h>\n");
        print2file("", "#include \"mpcassig.h\"\n");
        if(MPF_SRC)
	    print2file("", "#include \"mpf_topo.h\"\n");
	if(MPF_SRC)
	    print2file("", "#include \"mpf_if.h\"\n");
#ifdef MPC_DEBUGGER
/* ka 04.01.2001 begin */
        if (DBG_CODE) {
            print2file("", "#include <mpC_C.h>\n");
            /* !!!!! should be removed begin */
            c_blank;
            print2file("",
                       "static yC_GlobalNet C_MPC_Net_single={{kC_GlobalNet,0},{0,0},(tmpC_C)NULL,\"single\",(tmpC_C)NULL,&MPC_Net_global};\n");
            c_blank;
            print2file("",
                       "static yC_GlobalNet C_MPC_Net_host={{kC_GlobalNet,0},{0,0},(tmpC_C)NULL,\"host\",(tmpC_C)NULL,&MPC_Net_host};\n");
            c_blank;
            print2file("",
                       "static yC_GlobalNet C_MPC_Net_global={{kC_GlobalNet,0},{0,0},(tmpC_C)NULL,\"global\",(tmpC_C)NULL,&MPC_Net_global};\n");
            c_blank;
            print2file("",
                       "static yC_GlobalNet C_MPC_Net_recon={{kC_GlobalNet,0},{0,0},(tmpC_C)NULL,\"recon\",(tmpC_C)NULL,&MPC_Net_recon};\n");
	    c_blank;
	    print2file("",
		       "static char MPC_Breakpoints_lines[%d];\n",
		       yyt->MPC_Root.TotalLines+1);
	}
        /* !!!!! should be removed end */
/* ka 04.01.2001 end */

#endif                          /*MPC_DEBUGGER */
    }

    pDecls = yyt->MPC_Root.Decls;
    PointerControl(pDecls);
    cur_blank = 0;
    cur_pos = cur_blank;
    if (pass_number == 1) {
        TypeRoot =
            mType(NoTree /*TreeRoot */ , NoType, 0, NoType, 0, 0, 0);
        TraverseTreeTD(pDecls, set_type_to_zero);
	TraverseTreeTD(pDecls, fill_be_type_tree);
	AllTypeTree_traverse(TypeRoot, find_same_pointer);
	AllTypeTree_traverse(TypeRoot, find_same_dyn_type);
        fflush(stdout);
        TraverseTreeTD(pDecls, set_used_atribute);
        AllTypeTree_traverse(TypeRoot, set_used_dynamic);
    }
    TraverseTypeTD(TypeRoot, clear_gen);

    print2file("", "/* start of RTS type tree declarations */\n");
    AllTypeTree_traverse(TypeRoot, declare_rts_type_tree);
    print2file("", "/* end of RTS type tree declarations */\n");

    parent_expr = NoTree;
    end_statement_is_needed = 1;
    Position = pDecls->MPC_Decls.Pos;
    Decls_print(pDecls);
#ifdef MPC_DEBUGGER
    if (DBG_CODE) {
        FileTabPrint();
    } else if(there_is_main_in_file) {
        print2file("", "void *MPC_Debug_file_tab=NULL;\n");
        print2file("", "void *MPC_Debug_file_names=NULL;\n");
        print2file("", "int MPC_File_tab_num=0;\n");
        print2file("", "void *MPC_Debug_break_tab=NULL;\n");
        print2file("", "char MPC_break_stop=(char)0;\n");
    }
#endif                          /*MPC_DEBUGGER */
    /*WriteType(stdout,TypeRoot); */
    /*print2file("","\n#ifdef __cplusplus\n");
       print2file("","}\n");
       print2file("","#endif\n"); */

    print2file("", "/* start of RTS type tree definitions */\n");
    AllTypeTree_traverse(TypeRoot, define_rts_type_tree);
    print2file("", "/* end of RTS type tree definitions */\n");

    if (strcmp(output, "stdout"))
        fclose(not_dummy);
    if (prt)
        printf("file generation is ended \n");
}

static int is_same_dyn_type(tTree pFType, tTree pSType)
{
    int ret;
    PointerControl(pFType);
    PointerControl(pSType);
    pFType = Strip_Typedef(pFType);
    pSType = Strip_Typedef(pSType);
    PointerControl(pFType);
    PointerControl(pSType);

    if (IS_DYN_ARRAY_OR_VECTOR(pFType)) {
        if (IS_DYN_ARRAY_OR_VECTOR(pSType)) {
            if (NUMBER_OF_COMPONENTS(pFType) == 0)
                ret = ((DYN_SIZE(pFType) == DYN_SIZE(pSType))
                       && is_same_dyn_type(element_type(pFType),
                                           element_type(pSType)));

            else
                ret =
                    ((NUMBER_OF_COMPONENTS(pFType) ==
                      NUMBER_OF_COMPONENTS(pSType))
                     && is_same_dyn_type(element_type(pFType),
                                         element_type(pSType)));

            if ((pFType->Kind == kMPC_ArrayType)
                && (pSType->Kind == kMPC_ArrayType)) {
                if (STEP(pFType) == 0) {
                    if (STEP(pSType) == 0)
                        ret = ret
                            && (DYN_STEP(pSType) == DYN_STEP(pFType));
                    else
                        ret = 0;
                } else
                    ret = ret && (STEP(pSType) == STEP(pFType));
            }
        } else
            ret = 0;

    } else {
        if (IS_DYN_ARRAY_OR_VECTOR(pSType))
            ret = 0;
        else
            ret = 1;
    }

    return ret;
}


static int is_same_array_type(tTree pVType, tTree pType)
{
    if ((pVType->Kind != kMPC_VectorType)
        || (pType->Kind != kMPC_ArrayType)) {
        /*
           printf("\n---- %d --- %d = %d ",pVType->Kind,pType->Kind,  same_type(pVType,pType));
         */
        return same_type(pVType, pType);
    } else {
        /*
           printf("\n %d %d \t %p %p\n", pVType->MPC_VectorType.NumberOfComponents,
           pType->MPC_ArrayType.NumberOfComponents,
           pVType->MPC_VectorType.VectorSize,
           pType->MPC_ArrayType.ArraySize);
           print_Expr(pVType->MPC_VectorType.VectorSize);
           printf("\t");
           print_Expr(pType->MPC_ArrayType.ArraySize);
         */

        if (pVType->MPC_VectorType.NumberOfComponents) {
            if (pVType->MPC_VectorType.NumberOfComponents ==
                pType->MPC_ArrayType.NumberOfComponents)
                return is_same_array_type(pVType->MPC_VectorType.
                                          ElementType,
                                          pType->MPC_ArrayType.
                                          ElementType);
            else
                return 0;
        } else {
            if (pVType->MPC_VectorType.VectorSize ==
                pType->MPC_ArrayType.ArraySize)
                return is_same_array_type(pVType->MPC_VectorType.
                                          ElementType,
                                          pType->MPC_ArrayType.
                                          ElementType);
            else
                return 0;
        }
    }
}

static void find_same_vector(tType pVector, tType pArray)
{
    tType pNextVector = NoType, pAux, children;
    tTree pVectorTree, pArrayTree = NoTree;

/*printf("\n%p %p\t",pVector,pArray);*/
    TypeControl(pVector);
    TypeControl(pArray);

/*printf("find_same_type : %d %d\n",pVector->Type.Number,pArray->Type.Number);*/

    if (pArray != TypeRoot) {
        pArrayTree = pArray->Type.Origin;
        PointerControl(pArrayTree);
    }

    if ((pArray == TypeRoot) || (pArrayTree->Kind != kMPC_ArrayType)) {
        /*printf("Default entry\n"); */
        children = pArray->Type.Children;
        pNextVector = pArray;
        if (children != NoType)
            for (pAux = children; pAux != NoType; pAux = pAux->Types.Next) {
                /*printf("#"); */
                find_same_vector(pNextVector, pAux->Types.Type);
            }
    } else {
        /*printf("Array entry\n"); */
        children = pVector->Type.Children;

        if (children != NoType)
            for (pAux = children; pAux != NoType; pAux = pAux->Types.Next) {
                /*printf("$"); */
                TypeControl(pAux);
                pVectorTree = pAux->Types.Type->Type.Origin;
                PointerControl(pVectorTree);
                if (pVectorTree->Kind == kMPC_VectorType)
                    if (is_same_array_type(pVectorTree, pArrayTree)) {
                        /*printf("!"); */
                        pArray->Type.VectorType = pAux->Types.Type;
                        pNextVector = pAux->Types.Type;
                        /*printf("\t%p\t",pNextVector); */
                        break;
                    }
            }

        if (pNextVector == NoType)
            return;

        /*printf("Vector type found\n"); */
        children = pArray->Type.Children;
        if (children != NoType)
            for (pAux = children; pAux != NoType; pAux = pAux->Types.Next) {
                /*printf("^"); */
                TypeControl(pAux);
                pArrayTree = pAux->Types.Type->Type.Origin;
                PointerControl(pArrayTree);
                if (pArrayTree->Kind == kMPC_ArrayType) {
                    /*printf("!"); */
                    find_same_vector(pNextVector, pAux->Types.Type);
                }
            }

    }
}


static tType find_pointer_on_type(tTree pArrayTree)
{
    tType pAux, p_ret = NoType;
    tTree pPointerTree;

    for (pAux = TypeRoot->Type.Children; pAux != NoType;
         pAux = pAux->Types.Next) {
        TypeControl(pAux);
        pPointerTree = pAux->Types.Type->Type.Origin;
        PointerControl(pPointerTree);
        if (pPointerTree->Kind == kMPC_PointerType) {
            PointerControl(pPointerTree->MPC_PointerType.ElementType);
            if (same_type
                (pArrayTree, pPointerTree->MPC_PointerType.ElementType)) {
                p_ret = pAux->Types.Type;
                break;
            }
        }
    }

    return p_ret;
}


static void find_same_pointer(tType pArray)
{
    tTree pArrayTree;

    TypeControl(pArray);
    pArrayTree = pArray->Type.Origin;
    if ((pArrayTree != NoTree) && (pArrayTree->Kind == kMPC_ArrayType)) {
        pArray->Type.PointerType = find_pointer_on_type(pArrayTree);
    }
}

static tType pCurrentArray = NoType;
static tType pCurrentChild = NoType;
static tTree pCurrentArrayTree = NoTree;

static void append_dyn_type(tType pType)
{
    if (pCurrentChild != NoType) {
        pCurrentChild->Types.Next = mTypes(pType, NoType);
        pCurrentChild = pCurrentChild->Types.Next;
    } else {
        pCurrentArray->Type.EquivType = mTypes(pType, NoType);
        pCurrentChild = pCurrentArray->Type.EquivType;
    }
    TypeControl(pCurrentChild);

}

static void fill_same_dyn_type(tType pType)
{
    tTree pTree;
    TypeControl(pType);
    if (pType != pCurrentArray) {
        pTree = pType->Type.Origin;
        if (pTree != NoTree) {
            if (is_same_dyn_type(pTree, pCurrentArrayTree))
                append_dyn_type(pType);
        }
    }

}

static void find_same_dyn_type(tType pArray)
{
    tTree pArrayTree;

    TypeControl(pArray);
    pArrayTree = pArray->Type.Origin;
    if ((pArrayTree != NoTree) && (pArrayTree->Kind == kMPC_ArrayType)
        && (is_dynamic_type(pArrayTree))) {
        pCurrentArrayTree = pArrayTree;
        pCurrentArray = pArray;
        pCurrentChild = pArray->Type.EquivType;
        AllTypeTree_traverse(TypeRoot, fill_same_dyn_type);
    }
}


void print_RTSNodeDeclare(tTree pVar)
{
    PointerControl(pVar);

    while (pVar->Kind != kMPC_FreeNode) {
        tTree pType = pVar->MPC_Var.Type;
        tType p_type;
        PointerControl(pType);
        p_type = pType->MPC_Type.pType;
        if (p_type != NoType)
            print_rts_type_tree(p_type);
        pVar = pVar->MPC_Var.Next;
        PointerControl(pVar);
    }
}

#ifdef POSYPKIN
/**
 * Function print_RTSNodeInit updates fields which are not
 * initialized in print_RTSNodeDeclare
 */
#endif

void print_RTSNodeInit(tTree pVar)
{
    int old_change_net = not_change_net;
    PointerControl(pVar);

    while (pVar->Kind != kMPC_FreeNode) {
        tTree pType = pVar->MPC_Var.Type;
        tType p_type;
        PointerControl(pType);
        p_type = pType->MPC_Type.pType;

        not_change_net = 1;
        if (p_type != NoType) {
            /*printf("yy->Kind: %d, yy->Type.Gen: %d, yy->Type.Used: %d\n", 
               p_type->Kind, p_type->Type.Gen, p_type->Type.Used); */
            print_rts_type_tree_2(p_type);
        }
        not_change_net = old_change_net;
        pVar = pVar->MPC_Var.Next;
        PointerControl(pVar);
    }
}

void Decls_print(tTree pDecls)
{
    tString new_source;
    if (prt)
        printf("Decls generation is started \n");
    PointerControl(pDecls);
    while (pDecls->Kind != kMPC_FreeNode) {
        if (!in_function)
            cur_FileDecls = pDecls;
        Position = pDecls->MPC_Decls.Pos;
        new_source = SourceFile(Position);
        /*if(have_to_generate(pDecls)) print_Decls(pDecls); */
        if (source_file != new_source) {
            print_header(new_source);
            /*c_blank;
               print2file("","MPC_Source_filename_set(%s);\n",new_source); */
            source_file = new_source;
        }
        /*in_type=1; */
        /*else { */
        c_blank;
        print_Decls(pDecls);
        switch (pDecls->Kind) {
        case kMPC_Function:
        case kMPC_NetDecl:
        case kMPC_SubnetDecl:
        case kMPC_VarDecl:
            break;
        default:
            if (!Tree_IsType(pDecls, kMPC_Type)) {
                if (end_statement_is_needed)
                    fputs(";\n", file);
            }
        }
        /*} */
        if (Tree_IsType(pDecls, kMPC_Type)) {
            tType p_type = pDecls->MPC_Type.pType;
            if (p_type != NoType)
                print_rts_type_tree(p_type);

            if ((pDecls->Kind == kMPC_StructType &&
                 pDecls->MPC_StructType.MemberDecls == NoTree) ||
                (pDecls->Kind == kMPC_UnionType &&
                 pDecls->MPC_UnionType.MemberDecls == NoTree) ||
                (pDecls->Kind == kMPC_EnumType)) {
                fputs(";\n", file);
            }
#ifdef MPC_DEBUGGER
/* ka 16.01.2001 begin */
            if (!in_function) {
                if (pDecls->Kind == kMPC_EnumType) {
                    C_enum_node_print(pDecls);
                } else if (pDecls->Kind == kMPC_Typedef) {
                    tTree pType = pDecls->MPC_Typedef.Type;
                    PointerControl(pType);
                    if (pType->Kind == kMPC_EnumType) {
                        C_enum_node_print(pType);
                    }
                    C_tdef_node_print(pDecls);
                }
            }
/* ka 16.01.2001 end */
#endif                          /*MPC_DEBUGGER */
        } else if (pDecls->Kind == kMPC_VarDecl) {
            tTree pVar = pDecls->MPC_VarDecl.Var;
            print_RTSNodeDeclare(pVar);
#ifdef MPC_DEBUGGER
/* ka 16.01.2001 begin */
            if (!in_function) {
                tTree pType = pDecls->MPC_VarDecl.DeclSpecifier;
                PointerControl(pType);
                if (pType->Kind == kMPC_EnumType) {
                    C_enum_node_print(pType);
                }
            }
            while (pVar->Kind != kMPC_FreeNode) {
            
                if (!in_function) {
                    C_var_node_print(pVar);
                } else {
                    /*print var table record */
                }
                pVar = pVar->MPC_Var.Next;
                PointerControl(pVar);
            }
        } else if (pDecls->Kind == kMPC_NetType) {
            C_nettype_node_print(pDecls);
        } else if (pDecls->Kind == kMPC_NetDecl) {
            tTree pNet = pDecls->MPC_NetDecl.Net;
            PointerControl(pNet);
            while (pNet->Kind == kMPC_Net) {
                if (!in_function) {
                    C_net_node_print(pNet);
                }
                pNet = pNet->MPC_Net.Next;
                PointerControl(pNet);
            }
        } else if (pDecls->Kind == kMPC_SubnetDecl) {
            tTree pSubnet = pDecls->MPC_SubnetDecl.Subnet;
            PointerControl(pSubnet);
            while (pSubnet->Kind == kMPC_Subnet) {
                if (!in_function) {
                    C_net_node_print(pSubnet);
                }
                pSubnet = pSubnet->MPC_Subnet.Next;
                PointerControl(pSubnet);
            }
/* ka 16.01.2001 end */
#endif                          /*MPC_DEBUGGER */
        }
        pDecls = pDecls->MPC_Decls.Next;
        PointerControl(pDecls);
    }
    if (prt)
        printf("Decls generation is ended \n");
}

static int have_dyn_t;

void check_dyn_t_var(tTree pVar)
{
    tTree pType;
    PointerControl(pVar);
    pType = pVar->MPC_Var.Type;
    PointerControl(pType);
    if (is_dynamic_type(pType)) {
        have_dyn_t = 1;
    }
}


static tTree pCompound4Alloc;


void print_VarAlloc(tTree pVar)
{
    tTree pType, pDistribution, pMyNet;
    int braces, i;
    int old_not_check;

    pType = pVar->MPC_Var.Type;
    PointerControl(pType);
    if (is_dynamic_type(pType) == DYNAMIC_ARRAY) {
        pDistribution = pVar->MPC_Var.Distribution;
        PointerControl(pDistribution);
        pMyNet = pDistribution->MPC_NetOrSubnet.MyList;
        PointerControl(pMyNet);

        /*prt=1;
           PrintNet(pDistribution,"net");
           PrintNetList(pMyNet,0,"var");
           PrintNetList(cur_act_net,0,"current");
           prt=0; */

        braces = check_enclosed_net(pMyNet, cur_act_net);
        old_not_check = not_check;
        not_check = 1;
        c_blank;
        print2file("", "if(!(*%s = ",
                   AuxPointerName(pVar, pCompound4Alloc));
        print2file("", "(void*)malloc(%s.Base.Size)))",
                   DataVarName(pType));
        print2file("",
                   "%s(\"\\\"%s\\\" array allocation failed.\\n\"),%s(1);\n",
                   CBRACKETS ? "printf" : "MPC_Printf", VarName(pVar),
                   CBRACKETS ? "exit" : "MPC_Exit");
        
#ifdef MPC_DEBUGGER 
	if(DBG_CODE){
	        c_blank;
        	print2file("","MPC_vt[%d].addr = *%s;\n",
        		pVar->MPC_Var.Index, 
        		AuxPointerName(pVar, pCompound4Alloc));
        }		
#endif        	
        if (braces) {
            for (i = 0; i < braces; i++) {
                b_end;
            }
        }
        not_check = old_not_check;
    }
}

void Decls_alloc(tTree pCompound)
{
    tTree pDecls;
    if (prt)
        printf("Decls allocation generation is started \n");
    PointerControl(pCompound);
    pDecls = pCompound->MPC_Compound.Decls;
    PointerControl(pDecls);
    if (pDecls == NoTree)
        return;
    have_dyn_t = 0;
    while (pDecls->Kind != kMPC_FreeNode) {

        if (pDecls->Kind == kMPC_VarDecl) {
            VarDecl_traverse(pDecls, check_dyn_t_var);
        }
        pDecls = pDecls->MPC_Decls.Next;
        PointerControl(pDecls);
    }
    if (have_dyn_t) {
        c_blank;
        print2file("", "if(!%s%d){\n", ALLOC_FLAG,
                   pCompound->MPC_Compound.UniqueNumber);
        cur_blank += SKIP;
        pDecls = pCompound->MPC_Compound.Decls;
        while (pDecls->Kind != kMPC_FreeNode) {

            if (pDecls->Kind == kMPC_VarDecl) {
                pCompound4Alloc = pCompound;
                VarDecl_traverse(pDecls, print_VarAlloc);
            }
            pDecls = pDecls->MPC_Decls.Next;
            PointerControl(pDecls);
        }
        c_blank;
        print2file("", "%s%d=1;\n", ALLOC_FLAG,
                   pCompound->MPC_Compound.UniqueNumber);
        b_end;
    }
    if (prt)
        printf("Decls allocation generation is ended \n");
}


static tTree pCompound4Free;

void print_VarFree(tTree pVar)
{
    tTree pType, pDistribution, pMyNet;
    int braces, i;
    int old_not_check;

    pType = pVar->MPC_Var.Type;
    PointerControl(pType);

    if (is_dynamic_type(pType) == DYNAMIC_ARRAY) {
        pDistribution = pVar->MPC_Var.Distribution;
        PointerControl(pDistribution);
        pMyNet = pDistribution->MPC_NetOrSubnet.MyList;
        PointerControl(pMyNet);
        braces = check_enclosed_net(pMyNet, cur_act_net);
        old_not_check = not_check;
        not_check = 1;
        c_blank;
        print2file("", "free");
        print2file("", "( ");
        print2file("", "*%s", AuxPointerName(pVar, pCompound4Free));
        print2file("", ");\n ");
#ifdef MPC_DEBUGGER 
	if(DBG_CODE)  {
		c_blank;      
        	print2file("","MPC_vt[%d].addr = NULL;\n",
        		pVar->MPC_Var.Index);
        }		
#endif        	
        
        if (braces) {
            for (i = 0; i < braces; i++) {
                b_end;
            }
        }
        not_check = old_not_check;
    }
}



void Decls_free(tTree pCompound)
{
    tTree pDecls;
    if (prt)
        printf("Decls allocation generation is started \n");
    PointerControl(pCompound);

    pDecls = pCompound->MPC_Compound.Decls;
    if (pDecls == NoTree)
        return;

    have_dyn_t = 0;
    while (pDecls->Kind != kMPC_FreeNode) {

        if (pDecls->Kind == kMPC_VarDecl) {
            VarDecl_traverse(pDecls, check_dyn_t_var);
        }
        pDecls = pDecls->MPC_Decls.Next;
        PointerControl(pDecls);
    }
    if (have_dyn_t) {
        pDecls = pCompound->MPC_Compound.Decls;
        c_blank;
        print2file("", "if(%s%d){\n", ALLOC_FLAG,
                   pCompound->MPC_Compound.UniqueNumber);
        cur_blank += SKIP;
        while (1) {
            tTree pDeclAux;
            pDeclAux = pDecls->MPC_Decls.Next;
            if (pDeclAux->Kind == kMPC_FreeNode)
                break;
            else
                pDecls = pDeclAux;
        }
        while (pDecls->Kind != kMPC_FreeNode) {
            if (pDecls->Kind == kMPC_VarDecl) {
                pCompound4Free = pCompound;
                VarDecl_reverse(pDecls, print_VarFree);
            }
            pDecls = pDecls->MPC_Decls.Prev;
            PointerControl(pDecls);
        }
        c_blank;
        print2file("", "%s%d=0;\n", ALLOC_FLAG,
                   pCompound->MPC_Compound.UniqueNumber);
        b_end;
    }

    if (prt)
        printf("Decls allocation generation is ended \n");
}

int is_loop_or_switch(tTree yyt)
{
    return ((yyt->Kind == kMPC_While) || (yyt->Kind == kMPC_DoWhile) ||
#ifdef _3XX
            (yyt->Kind == kMPC_ParScheme) ||
#endif /*_3XX*/
            (yyt->Kind == kMPC_For) || (yyt->Kind == kMPC_Switch));
}


void Break_free(tTree pBreak)
{
    tTree yyt;

    PointerControl(pBreak);

    yyt = pBreak;
    while (1) {
        PointerControl(yyt);
        if (is_loop_or_switch(yyt)) {
            break;
        } else if (yyt->Kind == kMPC_Compound) {
            Decls_free(yyt);
            print_free_nets_and_subnets(yyt, yyt->MPC_Compound.Decls);            
            yyt = get_parent_stat(yyt);
        } else
            yyt = get_parent_stat(yyt);
    }
}

void Return_free(tTree pReturn)
{
    tTree yyt;

    PointerControl(pReturn);

    yyt = pReturn;
    while (1) {
        PointerControl(yyt);
        if (yyt->Kind == kMPC_Compound) {
            Decls_free(yyt);
            if (yyt->MPC_Compound.FunctionBody)
                break;
            yyt = get_parent_stat(yyt);
        } else
            yyt = get_parent_stat(yyt);
    }
}

static int label_found;
static int curr_label;

void check_label(tTree yyt)
{
    if (yyt->Kind == kMPC_IdentLabel)
        if (yyt->MPC_IdentLabel.Ident == curr_label)
            label_found = 1;
}

void Goto_free(tTree pGoto)
{
    tTree yyt;

    PointerControl(pGoto);
    yyt = pGoto;

    while (1) {
        PointerControl(yyt);
        if (yyt->Kind == kMPC_Compound) {
            if (yyt->MPC_Compound.FunctionBody)
                break;
            else {
                tTree pStats;
                label_found = 0;
                curr_label = pGoto->MPC_Goto.Ident;
                PointerControl(yyt->MPC_Compound.Stats);
                pStats = yyt->MPC_Compound.Stats;
                Stat_traverse(pStats, check_label);
                if (label_found)
                    break;
                else
                    Decls_free(yyt);
                yyt = get_parent_stat(yyt);
            }
        } else
            yyt = get_parent_stat(yyt);
    }

}


void Label_alloc(tTree pLabel)
{
    tTree yyt;

    PointerControl(pLabel);
    yyt = pLabel;

    while (1) {
        PointerControl(yyt);
        if (yyt->Kind == kMPC_Compound) {
            if (yyt->MPC_Compound.FunctionBody)
                break;
            Decls_alloc(yyt);
            yyt = get_parent_stat(yyt);
        } else
            yyt = get_parent_stat(yyt);
    }
}






void RTS_init_print(tTree pDecls)
{
    tString new_source;
    if (prt)
        printf("RTS init generation is started \n");
    PointerControl(pDecls);
    while (pDecls->Kind != kMPC_FreeNode) {
        if (!in_function)
            cur_FileDecls = pDecls;
        Position = pDecls->MPC_Decls.Pos;
        new_source = SourceFile(Position);
        switch (pDecls->Kind) {
        case kMPC_Function:
        case kMPC_NetDecl:
        case kMPC_SubnetDecl:
        case kMPC_VarDecl:
            break;
        default:;
        }

        if (Tree_IsType(pDecls, kMPC_Type)) {
            tType p_type = pDecls->MPC_Type.pType;
            if (p_type != NoType)
                print_rts_type_tree_2(p_type);
        } else if (pDecls->Kind == kMPC_VarDecl) {
            tTree pVar = pDecls->MPC_VarDecl.Var;
            PointerControl(pVar);
            print_RTSNodeInit(pVar);

        }
        pDecls = pDecls->MPC_Decls.Next;
        PointerControl(pDecls);
    }
    if (prt)
        printf("RTS pass 2   generation is ended \n");
}




void check_dyn_t(tTree pDecls)
{
    if (pDecls->Kind == kMPC_VarDecl) {
        VarDecl_traverse(pDecls, check_dyn_t_var);
    }

}

void print_Alloc_Flags(tTree yyt)
{

    if (yyt->Kind == kMPC_Compound) {
        have_dyn_t = 0;
        StateDecls_traverse(yyt, check_dyn_t);
        if (have_dyn_t) {
            c_blank;
            print2file("", "int %s%d=0;\n", ALLOC_FLAG,
                       yyt->MPC_Compound.UniqueNumber);
        }
    }

}

static int there_is_init;

static void clear_gen(tType yyt)
{
    if (yyt != NoType && yyt->Kind == kType)
        yyt->Type.Gen = 0;
}

#ifdef MPC_DEBUGGER
static void look_for_init(tTree yyt)
{
    if (yyt != NoTree && yyt->Kind == kMPC_Var) {
        tTree pInit = yyt->MPC_Var.Init;
        there_is_init += (pInit != NoTree && pInit->Kind != kMPC_FreeNode);
    }
}

static void print_var_tab(tTree yyt)
{
    if (yyt != NoTree && yyt->Kind == kMPC_Var && yyt->MPC_Var.Flag.Source) {
        tTree pInit = yyt->MPC_Var.Init;
        if ( /*pInit != NoTree && pInit->Kind != kMPC_FreeNode&& */
            in_function) {
            tTree pT;
            tType p_t;
            tPosition real_pos;
            c_blank;
            print2file("", "MPC_Dt MPC_%s_init=", VarName(yyt));
            pT = yyt->MPC_Var.Type;
            print2file("", "(MPC_vt[%d].addr=%s%s,",
                       yyt->MPC_Var.Index,
                       (is_dynamic_type(pT) == DYNAMIC_ARRAY) ? " " : "&",
                       VarName(yyt));
            PointerControl(pT);
            p_t = pT->MPC_Type.pType;
            TypeControl(p_t);
            if (p_t->Type.Gen) {
                print2file("", "MPC_vt[%d].type=(MPC_Dt)&%s);\n",
                           yyt->MPC_Var.Index, DataVarName(pT));
            }
        }
    }
}
#endif

void print_Decls(tTree pDecls)
{
    int old_print_base_type;
    old_print_base_type = print_base_type;
    PointerControl(pDecls);
    if (Tree_IsType(pDecls, kMPC_Type)) {
        Position = pDecls->MPC_Decls.Pos;
        print_Type(pDecls);
        /*if(is_not_parameter) {
           print_rts_type(pDecls);
           } */
    } else {
        switch (pDecls->Kind) {
        case kMPC_UncompDecl:
                           /** IL 12.09.01 **/
            print2file("", pDecls->MPC_UncompDecl.uString);
            break;
        case kMPC_VarDecl:
        
#ifdef MPC_DEBUGGER
            if (DBG_CODE && in_function) {
                there_is_init = 0;
                VarDecl_traverse(pDecls, look_for_init);
                if (there_is_init) {
                    tPosition real_pos;
                    real_pos = RealPosition(pDecls->MPC_VarDecl.Pos);
                    print2file("",
			       //"int MPC_%s_call=(MPC_Agent(%d,%d,(tmpC_C)",
			        MPC_DBG_INIT_AGENT_CALL "(%s,%d,%d,",
                               VarName(pDecls->MPC_VarDecl.Var),
                               real_pos.Line, real_pos.Column);
                    last_node_print(cur_block->MPC_Compound.LastKind,
                                        cur_block->MPC_Compound.Ref);
                    print2file("", 
			       //"),0);\n");
			       ");\n");
                    c_blank;
                }
            }
#endif

            print_base_type = 0;
            print_VarDecl(pDecls);
            if (is_not_parameter) {
                fputs(";\n", file);
                end_statement_is_needed = 0;
            }
#ifdef MPC_DEBUGGER
            if (DBG_CODE && in_function && !is_topo_fun
                && is_not_parameter /* && there_is_init */ ) {
                VarDecl_traverse(pDecls, print_var_tab);
            }
#endif
            /*{
               tTree pVar,pType;
               pVar=pDecls->MPC_VarDecl.Var;
               PointerControl(pVar);
               print_base_type=1;
               while(pVar->Kind != kMPC_FreeNode) {
               pType=pVar->MPC_Var.Type;
               PointerControl(pType);
               if(is_not_parameter) print_rts_type(pType);
               pVar=pVar->MPC_Var.Next;
               PointerControl(pVar);
               }
               } */
            break;
        case kMPC_Function:
            print_base_type = 1;
            print_Function(pDecls);
            break;
        case kMPC_Ellipsis:
            cur_pos += fputs("...", file);
            break;
        case kMPC_NetType:
            print_NetType(pDecls);
            break;
        case kMPC_NetDecl:
            if (!in_function)
                print_NetDecl(pDecls);
            break;
        case kMPC_SubnetDecl:
            if (!in_function)
                print_SubnetDecl(pDecls);
            break;
        default:
            break;
        }
    }
    print_base_type = old_print_base_type;
}

static void set_gen_trees()
{
    tGen pSingle;
    int_gen_tree = mNet(CONST, KNOWN, 1, 0, 0, HOST, 1, 0, 0, pRoot, 0,
                        make_string("host"), NoGen, NoGen, 0,
                        PREDEFINE_NUM, NoTree, 0, 1);
    pSingle = mNet(CONST, KNOWN, 1, 0, 0, SINGLE_NODE, 1, 0, 0, pRoot, 0,
                   make_string("single"), NoGen, int_gen_tree, 0,
                   PREDEFINE_NUM, NoTree, 0, 1);
    SINGLE_NODE->MPC_Net.pGen = pSingle;
    pGlobal =
        mNet(CONST, KNOWN, 1, 0, 0, COMPUTING_SPACE, 1, 0, 0, pRoot, 0,
             make_string("global"), NoGen, int_gen_tree, 0, PREDEFINE_NUM,
             NoTree, 0, 1);
    int_gen_tree->Net.Children = mNets(pSingle, mNets(pGlobal, NoGen));;
    if (prt)
        printf
            ("int_gen_tree=%p pSingle=%p pGlobal=%p pGlobal->Parent=%p\n",
             int_gen_tree, pSingle, pGlobal, pGlobal->Net.Parent);
}

static void create_pred_var_tree()
{
    tmp_var_expr = nMPC_BinaryExpr();
    tmp_var_expr->MPC_BinaryExpr.TmpName = "";
    tmp_var_expr_left = nMPC_Expr();
    tmp_var_expr->MPC_BinaryExpr.OpCode = ASSIGN;
    tmp_var_expr->MPC_BinaryExpr.Loperand = tmp_var_expr_left;
    tmp_var_expr_left->MPC_Expr.Flag.Generated = 1;
}

static void create_coord_var_tree()
{
    tmp_coord_expr = nMPC_BinaryExpr();
    tmp_coord_expr->MPC_BinaryExpr.TmpName = "";
    tmp_coord_expr_left = nMPC_Expr();
    tmp_coord_expr->MPC_BinaryExpr.OpCode = ASSIGN;
    tmp_coord_expr->MPC_BinaryExpr.Loperand = tmp_coord_expr_left;
    tmp_coord_expr_left->MPC_Expr.Flag.Generated = 1;
    tmp_coord_expr_left->MPC_Expr.TmpName =
        "MPC_coord[                    ";
    /*malloc(sizeof(char)*256); */
}

#ifdef MPC_DEBUGGER
static void create_init_tree()
{
    tmp_init_expr = nMPC_BinaryExpr();
    tmp_init_expr->MPC_BinaryExpr.TmpName = "";
    tmp_init_expr_left = nMPC_Expr();
    tmp_init_expr->MPC_BinaryExpr.OpCode = ASSIGN;
    tmp_init_expr->MPC_BinaryExpr.Loperand = tmp_init_expr_left;
    tmp_init_expr_left->MPC_Expr.Flag.Generated = 1;
}
#endif                          /*MPC_DEBUGGER */


/*#define INCLUDED_NUM 3
static int have_to_generate(tTree pDecls) {
  char* included_by_rts[INCLUDED_NUM]=
  {"stdlib.h","limits.h","mpi.h"};
  int i;
  tString source_file;
  PointerControl(pDecls);
  source_file=SourceFile(pDecls->MPC_Decls.Pos);
  for(i=0; i<INCLUDED_NUM; i++) {
    if(strstr(source_file,included_by_rts[i]) != NULL) break;
  }
  return i == INCLUDED_NUM;
}*/

static tString cur_header = " ";
static void print_header(tString source_file)
{
    if (strcmp(source_file, cur_header)) {
        cur_header = source_file;
        c_blank;
        print2file("", "\n/*%s*/\n", source_file);
    }
}

static void set_type_to_zero(tTree yyt)
{
    if (yyt != NoTree && Tree_IsType(yyt, kMPC_Type)) {
        yyt->MPC_Type.pType = NoType;
    }
    /* begin of the debuging insertion */
    /*if(yyt != NoTree && Tree_IsType(yyt,kMPC_Stat)) {
       if(prt) printf("set_type_to_zero yyt=%p yyt->Kind=%d ExecNet=%p\n",yyt,
       yyt->Kind,yyt->MPC_Stat.ExecNet);
       } */

}


/**
 * Auxilary function for print_basic_type_rts_tree.
 * Travreses only static types suitable for printing at
 * file scope level.
 *
 * @param yyt processing type node
 * @param proc procedure for processing type node
 */
static void StaticTypeTree_traverse(tType inType, void (*proc) (tType))
{
    if (inType != NoType) {
        if (inType->Kind == kTypes) {
            while (inType != NoType) {
                StaticTypeTree_traverse(inType->Types.Type, proc);
                inType = inType->Types.Next;
            }
        } else if (inType->Kind == kType) {
            tTree yyt = inType->Type.Origin;
            tTypeFlags flag;
            PointerControl(yyt);
            flag = yyt->MPC_Type.Flag;
            /*
               if(!in_assign && is_dynamic_type(pType))
               return;
             */
            proc(inType);
            StaticTypeTree_traverse(inType->Type.Children, proc);
        }
    }
}



/**
 * Function print_basic_type_rts_tree()
 * outputs all static types in a file at the beginning of
 * code generation. Only basic types and array/vector
 * types with basic terminal elements are processed.
 */
static void print_basic_type_rts_tree()
{
/*
  tType pChildren;
  TypeControl(TypeRoot);
  pChildren=TypeRoot->Type.Children;
  while(pChildren != NoType) {
    tTree pOrigin;
    tType pChild=pChildren->Types.Type;
    TypeControl(pChild);
    pOrigin=pChild->Type.Origin;
    PointerControl(pOrigin);
    if(pOrigin->Kind == kMPC_BasicType) {
      StaticTypeTree_traverse(pChild, declare_rts_type_tree);
      StaticTypeTree_traverse(pChild, define_rts_type_tree);
    }
    pChildren=pChildren->Types.Next;
  }
*/
}


int is_dynamic_step(tTree yyt)
{

    PointerControl(yyt);
    /*if(yyt->Kind==kMPC_Typedef) yyt=get_true_type(yyt); */
    yyt = Strip_Typedef(yyt);
    if (yyt == NoTree)
        return STATIC_STEP;
    if (yyt->MPC_Type.Flag.DynStep)
        //||(Tree_IsType(yyt, kMPC_RegularType)&& (yyt->MPC_VectorType.Step == UNDEFINED)))
        return DYNAMIC_STEP;
    else
        return STATIC_STEP;
}

int is_dynamic_size(tTree yyt)
{

    PointerControl(yyt);
    /*if(yyt->Kind==kMPC_Typedef) yyt=get_true_type(yyt); */
    yyt = Strip_Typedef(yyt);
    if (yyt == NoTree)
        return STATIC_SIZE;
    if (Tree_IsType(yyt, kMPC_DerivedType)
        && (yyt->MPC_DerivedType.NumberOfComponents == 0))
        return DYNAMIC_SIZE;
    if (yyt->MPC_Type.Flag.DynArray)
        return DYNAMIC_SIZE;
    else
        return STATIC_SIZE;
}

int is_pointer_on_dynamic(tTree yyt)
{
    PointerControl(yyt);
/*if(yyt->Kind==kMPC_Typedef) yyt=get_true_type*/
    yyt = Strip_Typedef(yyt);
    if (yyt == NoTree)
        return 0;
    if ((yyt->Kind == kMPC_PointerType) &&
        (is_dynamic_type(yyt->MPC_PointerType.ElementType) ==
         DYNAMIC_ARRAY))

        return 1;
    else
        return 0;
}

int is_dynamic_pointer(tTree yyt)
{
    PointerControl(yyt);
    /*  if(yyt->Kind==kMPC_Typedef) yyt=get_true_type(yyt); */
    yyt = Strip_Typedef(yyt);
    if (yyt == NoTree)
        return 0;
    if ((yyt->Kind == kMPC_PointerType) &&
        (yyt->MPC_PointerType.Step == 0))
        return 1;
    else
        return 0;
}



int is_dynamic_type(tTree yyt)
{

    PointerControl(yyt);
    /*if(yyt->Kind==kMPC_Typedef) yyt=get_true_type(yyt); */
    yyt = Strip_Typedef(yyt);
    if (yyt == NoTree)
        return NOT_DYNAMIC_TYPE;


    if (yyt->Kind == kMPC_ArrayType) {
        if (yyt->MPC_ArrayType.NumberOfComponents == 0)
            return DYNAMIC_ARRAY;
        if (yyt->MPC_Type.Flag.DynArray || yyt->MPC_Type.Flag.DynStep)
            return DYNAMIC_ARRAY;
        else
            return NOT_DYNAMIC_TYPE;
    } else if (yyt->Kind == kMPC_VectorType) {                     
          
        if (yyt->MPC_VectorType.NumberOfComponents == 0)
            return DYNAMIC_VECTOR;

        if (yyt->MPC_Type.Flag.DynArray || yyt->MPC_Type.Flag.DynStep)
            return DYNAMIC_VECTOR;
        else
            return NOT_DYNAMIC_TYPE;
    } else if (yyt->Kind == kMPC_PointerType) {
        if (is_dynamic_pointer(yyt) || is_pointer_on_dynamic(yyt))
            return DYNAMIC_POINTER;
        else
            return NOT_DYNAMIC_TYPE;
    } else
        return NOT_DYNAMIC_TYPE;
}


/**
 * Sets Used attribute for dynamic types.
 *
 * @param pType processing back-end type node
 */
static void set_used_dynamic(tType pType)
{
    tTree yyt;
    TypeControl(pType);
    yyt = pType->Type.Origin;

    if ((yyt != NoTree) && is_dynamic_type(yyt)) {
        pType->Type.Used = 1;
        set_parent_used(pType);
    }

}


/**
 * Sets Used attribute of back-end type tree.
 * All AST tree is traversed. The function 
 * analyzes kind of statement traversed.
 *
 * @param yyt processing AST tree node
 */
static void set_used_atribute(tTree yyt)
{
    if (yyt != NoTree) {
        tTree pLType, pRType, pType;
        tType p_type = NoType;
        if (yyt->Kind == kMPC_BinaryExpr) {
            int OpCode = yyt->MPC_BinaryExpr.OpCode;
            int kind;
            if (OpCode == ASSIGN) {
                kind = PredAssign_kind(yyt, &pLType, &pRType);
                if (kind != WRONG && kind != ASYNCH &&
                    pLType != NoTree && pRType != NoTree) {
                    if (prt)
                        printf(" set Type.Used=1\n");
                    p_type = pLType->MPC_Type.pType;
                    TypeControl(p_type);
                    p_type->Type.Used = 1;
                    set_parent_used(p_type);
                    p_type = pRType->MPC_Type.pType;
                    TypeControl(p_type);
                    p_type->Type.Used = 1;
                    set_parent_used(p_type);
                }
            }
        } else if (yyt->Kind == kMPC_UnaryExpr &&
                   yyt->MPC_UnaryExpr.OpCode >= DISTRIBUTED) {
            tTree pOperand = yyt->MPC_UnaryExpr.Operand;
            tTree pType;
            tType p_type;
            PointerControl(pOperand);
            pType = pOperand->MPC_Expr.Type;
            PointerControl(pType);
            p_type = pType->MPC_Type.pType;
            TypeControl(p_type);
            p_type->Type.Used = 1;
            set_parent_used(p_type);
        } else if (yyt->Kind == kMPC_CallExpr) {
            built_in_fun = is_built_in_fun(yyt);
            if (built_in_fun && with_type[built_in_fun - 1]) {
                tTree pArg = yyt->MPC_CallExpr.ArgList;
                PointerControl(pArg);
                pType = buffer_type(pArg);
                p_type = pType->MPC_Type.pType;
            }
            if (p_type != NoType) {
                p_type->Type.Used = 1;
                set_parent_used(p_type);
            }
        }
#ifdef MPC_DEBUGGER
/* ka 04.01.2001 begin */
        else if (yyt->Kind == kMPC_Var) {
            pType = yyt->MPC_Var.Type;
            PointerControl(pType);
            p_type = pType->MPC_Type.pType;
            TypeControl(p_type);
            p_type->Type.Used = 1;
            set_parent_used(p_type);
        }
/* ka 04.01.2001 end */
#endif                          /*MPC_DEBUGGER */
    }
}

#ifdef MPC_DEBUGGER
void AddFileTab(tTree yyt)
{
    FileTab.Tab[FileTab.Index++] = yyt;
    if (FileTab.Index == FileTab.ActualSize)
        ExtendArray(&FileTab.Tab, &FileTab.ActualSize, sizeof(tTree));
}
static char *short_name(char *f_name)
{
    size_t size;
    char *name = f_name + 1;
    char *c_filename;
    char slash = '/', under = '_';
    int i, wrong = 0, dig_num = 0;
    if (prt)
        printf("f_name=%s\n", f_name);
    //    return name;
    while (1) {
        char *i_name;
        i_name = strchr(name, (int) slash);
        if (i_name == NULL)
            break;
        else {
            name = i_name + 1;
            if (prt)
                printf("name=%s slash=%c\n", name, slash);
            fflush(stdout);
        }
    }
    if (prt)
        printf("output file name %s\n", name);
    c_filename = malloc((strlen(name) + 1) * 2);
    size = strlen(name) - strlen(".mpc") - 1;
    for (i = 0; i < size; i++) {
        if (isalnum(name[i]) || name[i] == under) {
            c_filename[i] = name[i];
        } else {
            wrong++;
            c_filename[i] = under;
        }
    }
    if (wrong) {
        dig_num = sprintf(c_filename + size, "%d", wrong);
    }
    c_filename[size + dig_num + (wrong != 0)] = '\0';
    return c_filename;
}
static void FileTabPrint()
{
    char *filename, *shortname;
    int i;
    filename = pRoot->MPC_Root.Source->MPC_Source.FileName;
    shortname = short_name(filename);
    /*if(FileTab.Index != 0) {*/
    print2file("", "static tStatList MPC_file_tab[%d]= {\n",
               FileTab.Index + 1);
    for (i = 0; i < FileTab.Index; i++) {
        tPosition b_real_pos, e_real_pos;
        tPosition Pos;
        tTree pStat;
        pStat = FileTab.Tab[i];
        PointerControl(pStat);
        Pos =
            Tree_IsType(pStat,
                        kMPC_Stats) ? pStat->MPC_Stats.Pos : pStat->
            MPC_Var.Pos;
        b_real_pos = RealPosition(Pos);
        Pos =
            Tree_IsType(pStat,
                        kMPC_Stats) ? pStat->MPC_Stats.EndPos : pStat->
            MPC_Var.EndPos;
        e_real_pos = RealPosition(Pos);
        blank(2);
        if (pStat->Kind == kMPC_Compound) {
            print2file("", "{ (tmpC_C)");
            last_node_print(pStat->MPC_Compound.LastKind,
                            pStat->MPC_Compound.Ref);
        } else {
            print2file("", "{ NompC_C");
        }
        print2file("", ", %d, %d }", b_real_pos.Line, e_real_pos.Line);
        print2file("", ",\n");
    }
    blank(2);
    //      print2file("","{ NompC_C, 0, 0 }\n");
    print2file("", "{ (tmpC_C)");
    last_node_print(last_global_node_kind,last_global_node);


    //C_cur_stat.C_prev_kind,last_node(C_cur_stat));
    print2file("", ", 0, 0 }\n");
    print2file("", "};\n");
    print2file("", "void* MPC_file_tab_%s_mpc=MPC_file_tab;\n", 
        shortname);
    print2file("", 
	       "static MPC_Breakpoints MPC_break_tab={MPC_Breakpoints_lines,%d};\n",pRoot->MPC_Root.TotalLines+1);
    print2file("", "void* MPC_break_tab_%s_mpc=&MPC_break_tab;\n", 
	       shortname);
    if(there_is_main_in_file) {
      print2file("", "char MPC_break_stop=(char)0;\n");
    }

    /*} else {
        print2file("", "void* MPC_file_tab_%s_mpc=NULL;\n", shortname);
	}*/
}
#endif                          /*MPC_DEBUGGER */

/*int print_be_type_root() {
  tType pChildren;
  TypeControl(TypeRoot);
  pChildren=TypeRoot->Type.Children;
  while(pChildren != NoType) {
    tTree pOrigin;
    tType pChild=pChildren->Types.Type;
    TypeControl(pChild);
    pOrigin=pChild->Type.Origin;
    PointerControl(pOrigin);
    printf("be_type_root Child=%p pOrigin=%p Kind=%d name=%s",
           pChild,pOrigin,pOrigin->Kind,DataVarName(pOrigin));
    if(pOrigin->Kind == kMPC_BasicType) {
      printf(" Constr=%d",pOrigin->MPC_BasicType.TypeConstructor);
    }
    printf("\n");
    pChildren=pChildren->Types.Next;
  }
}*/
