/*
 * $Id: VarDecl_print.c,v 1.56 2005/02/26 14:48:43 posypkin Exp $
 */


/* code generation for MPC_VarDecl, MPC_Function and correspond nodes */
/* Coded by A.Kalinov 10.95 - */

#include "be_print.h"

#ifdef MPC_TRACER
#include "tracer.h"
#endif

static void print_Initializer(tTree, tTree);
static void set_net_fun_params(tTree);
static int InitLine(tTree);

/* POSYPKIN FIX 02.03.21
static int is_dyn_param(tTree );
static void print_param_rts_type_tree(tTree );
*/
/*int net_topology(tTree );*/

static tTree pCurInit;
static tTree pCurInitList;
static int last_init;
static int right_braces;
static int left_braces;

#ifdef MPC_DEBUGGER
static int first_item;
static tTree cur_var;
#endif


void print_VarDecl(tTree pVarDecl)
{
    tTree pDeclSpec;
    tTree pVar;
    int old_in_var_decl = in_var_decl;
    tTree old_pCurParamList = pCurParamList;
    tTree old_pCurExprs = pCurExprs;

    if (prt)
        printf("VarDecl generation is started \n");
    in_var_decl = 1;
    PointerControl(pVarDecl);
    pDeclSpec = pVarDecl->MPC_VarDecl.DeclSpecifier;
    PointerControl(pDeclSpec);
    pVar = pVarDecl->MPC_VarDecl.Var;
    PointerControl(pVar);
    /*c_blank; */
    print_VarStorageClass(pVarDecl->MPC_VarDecl.Flag);
    pCurDeclSpec = NoTree;
    if (pVar->Kind == kMPC_FreeNode)
        print_base_type = 1;
    print_Type(pDeclSpec);
    if (pVar->Kind == kMPC_FreeNode)
        print_base_type = 0;
    pCurDeclSpec = pDeclSpec;
    {
        while (pVar->Kind != kMPC_FreeNode) {
            set_net_fun_params(pVar);
            print_Var(pVar);
            pCurParamList = old_pCurParamList;
            pCurExprs = old_pCurExprs;
            pVar = pVar->MPC_Var.Next;
            PointerControl(pVar);
            if (pVar->Kind != kMPC_FreeNode) {
                fputs(",", file);
                cur_pos++;
            }
        }
    }
    pCurDeclSpec = NoTree;
    in_var_decl = old_in_var_decl;
    if (prt)
        printf("VarDecl generation is ended \n");
}

void print_VarStorageClass(tDeclFlags flag)
{
    char *ClassName[3] = { "extern", "static", "register" };
    int i, j = -1;

    i = flag.Auto + flag.Static + flag.Register + flag.Extern +
        flag.Exported;
    if (i == 0)
        return;
    if (i > 1) {
        fprintf(stderr, "invalid declaration flag \n");
        fprintf(stderr,
                "Auto=%u Static=%u Register=%u Extern=%u Exported=%u\n",
                flag.Auto, flag.Static, flag.Register, flag.Extern,
                flag.Exported);
        internal_error();
    }
    if (flag.Auto || flag.Exported)
        return;
    if (flag.Extern)
        j = 0;
    if (flag.Static)
        j = 1;
    if (flag.Register)
        j = 2;
    cur_pos += print2file("", "%s ", ClassName[j]);
}


static char aux_pointer[64];

char *AuxPointerName(tTree pVar, tTree pCompound)
{
    char buf[5] = "";

    aux_pointer[0] = 0;
    strcat(aux_pointer, AUX_POINTER);
    sprintf(buf, "%d", pCompound->MPC_Compound.UniqueNumber);
    strcat(aux_pointer, buf);
    strcat(aux_pointer, "_");
    strcat(aux_pointer, VarName(pVar));
    return aux_pointer;
}

void print_Var(tTree pVar)
{
    tTree pType, pInit;

    if (prt)
        printf("  Var generation is started \n");
    PointerControl(pVar);
    /*Position=pVar->MPC_Var.Pos; */
    pType = pVar->MPC_Var.Type;
    PointerControl(pType);
    print_LeftType(pType, NoTree);
    if (prt)
        printf("topo_fun_code=%d MAIN=%d NOT_TOPO_FUN=%d is_topo_fun=%d\n",
               topo_fun_code, MAIN, NOT_TOPO_FUN, is_topo_fun);
    print2file("", VarName(pVar));
    print_RightType(pType, NoTree);
    pInit = pVar->MPC_Var.Init;
    if (pInit != NoTree && pInit->Kind != kMPC_FreeNode) {
#ifdef MPC_DEBUGGER
        if (DBG_CODE && !is_topo_fun) {
            first_item = 1;
            cur_var = pVar;
            if (in_function && pVar->MPC_Var.Flag.Source)
                AddFileTab(pVar);
        }
#endif
        print_Initializer(pVar->MPC_Var.Init, pType);
    }
    if ((is_dynamic_type(pType) == DYNAMIC_ARRAY) && (!in_net_param_list)) {
        print2file("", " = NULL,");
        print_LeftType(pType, NoTree);
        print2file("", "* %s", AuxPointerName(pVar, cur_block));
        print_RightType(pType, NoTree);
        print2file("", " = &%s", VarName(pVar));
    }
    if (prt)
        printf("Var generation is ended \n");
}

static void fill_interval(tTree pElementType)
{
    be_error
        ("sorry, initialization of the array with step > 1 isn't supported now");
/*  PointerControl(pElementType);
  switch(pElementType->Kind) {
  case kMPC_BasicType:
  case kMPC_EnumType:
    if(last_init) 
      cur_pos+=fputs(",0",file);
    else 
      cur_pos+=fputs("0,",file);
    break;
  case kMPC_Typedef:
    {
      tTree pType=pElementType->MPC_Typedef.Type;
      PointerControl(pType);
      fill_interval(pType);
    }
    break;
  case kMPC_ArrayType:
    {
      int Num=pElementType->MPC_ArrayType.NumberOfComponents;
      tTree pType=pElementType->MPC_ArrayType.ElementType;
      int i;
      PointerControl(pType);
      for(i=0; i<Num; i++) {
        fill_interval(pType);
      }
    }
    break;
  case kMPC_PointerType:
    if(last_init) 
      cur_pos+=fputs(",NULL",file);
    else 
      cur_pos+=fputs("NULL,",file);
    break;
  case kMPC_StructType:
    {
      tTree pMemberDecls=pElementType->MPC_StructType.MemberDecls;
      PointerControl(pMemberDecls);
      while(pMemberDecls->Kind != kMPC_FreeNode) {
        tTree pMember=pMemberDecls->MPC_SU_MemberDecl.Member;
        tTree pMemberType;
        PointerControl(pMember);
        while(pMember->Kind != kMPC_FreeNode) {
          pMemberType=pMember->MPC_SU_Member.Type;
          PointerControl(pMemberType);
          fill_interval(pMemberType);
          pMember=pMember->MPC_SU_Member.Next;
          PointerControl(pMember);
        }
        pMemberDecls=pMemberDecls->MPC_SU_MemberDecl.Next;
        PointerControl(pMemberDecls);
      }
    }
    break;
  case kMPC_UnionType:
    be_error("sorry, interval of the union type isn't supported now");
    break;
  default:
    fprintf(stderr,"wrong type in InitList with step != 1\n");
    internal_error();
    break;
  }*/
}

static tTree NextInit(tTree pInit)
{
    PointerControl(pInit);
    switch (pInit->Kind) {
    case kMPC_SimpleInit:
        pInit = pInit->MPC_SimpleInit.Next;
        if (pInit == NoTree || pInit->Kind == kMPC_SimpleInit)
            break;
        while (pInit->Kind == kMPC_FreeNode) {
            pInit = pInit->MPC_FreeNode.Parent;
            right_braces++;
            /*cur_pos+=fputs("}",file); */
            PointerControl(pInit);
            /* I did not understand why the following line was deleted */
            if (pInit->Kind == kMPC_InitList) {
                /* */
                pInit = pInit->MPC_InitList.Next;
            }
            if (pInit == NoTree)
                break;
        }
        if (pInit == NoTree)
            break;
    case kMPC_InitList:
        while (pInit->Kind == kMPC_InitList) {
            left_braces++;
            /*cur_pos+=fputs("{",file); */
            pInit = pInit->MPC_InitList.List;
            PointerControl(pInit);
        }
        break;
    }
    last_init = pInit == NoTree || pInit->Kind == kMPC_FreeNode;
    return pInit;
}

static void print_Init(tTree pType)
{
    if (prt)
        printf("print_Init pCurInit=%p pCurInit->Kind=%d\n",
               pCurInit, pCurInit->Kind);
    PointerControl(pType);
    switch (pType->Kind) {
    case kMPC_ArrayType:
        if (prt)
            printf("print_Init array begin pType=%p", pType);
        {
            int Step = pType->MPC_ArrayType.Step;
            int Num = pType->MPC_ArrayType.NumberOfComponents;
            tTree pElementType = pType->MPC_ArrayType.ElementType;
            int i, j;

            PointerControl(pElementType);
            if (prt)
                printf(" Num=%d Step=%d ElemType=%p\n",
                       Num, Step, pElementType);
            /*for(i=0; i<Num; i++) { */
            i = 0;
            while (Num == UNDEFINED ? !last_init : i < Num) {
                if (pCurInit->Kind == kMPC_FreeNode)
                    break;
                print_Init(pElementType);
                if (last_init)
                    break;
                for (j = 1; j < Step; j++) {
                    fill_interval(pElementType);
                }
                i++;
            }
        }
        if (prt)
            printf("print_Init array end pType=%p\n", pType);
        break;
    case kMPC_StructType:
        if (prt)
            printf("print_Init struct begin pType=%p", pType);
        {
            tTree pMemberDecls = pType->MPC_StructType.MemberDecls;
            tTree pEquivType;

            pEquivType = pType;
            while (pMemberDecls == NoTree) {
                pEquivType = pEquivType->MPC_StructType.EquivType;
                pMemberDecls = pEquivType->MPC_StructType.MemberDecls;
            }
            PointerControl(pMemberDecls);
            while (pMemberDecls->Kind != kMPC_FreeNode) {
                tTree pMember = pMemberDecls->MPC_SU_MemberDecl.Member;
                tTree pMemberType;

                PointerControl(pMember);
                while (pMember->Kind != kMPC_FreeNode) {
                    pMemberType = pMember->MPC_SU_Member.Type;
                    PointerControl(pMemberType);
                    if (pCurInit->Kind == kMPC_FreeNode)
                        break;
                    print_Init(pMemberType);
                    if (last_init)
                        break;
                    pMember = pMember->MPC_SU_Member.Next;
                    PointerControl(pMember);
                }
                if (last_init)
                    break;
                pMemberDecls = pMemberDecls->MPC_SU_MemberDecl.Next;
                PointerControl(pMemberDecls);
            }
        }
        if (prt)
            printf("print_Init struct end pType=%p\n", pType);
        break;
    case kMPC_UnionType:
        if (prt)
            printf("print_Init union begin pType=%p", pType);
        {
            tTree pMemberDecls = pType->MPC_UnionType.MemberDecls;
            tTree pEquivType;

            pEquivType = pType;
            while (pMemberDecls == NoTree) {
                pEquivType = pEquivType->MPC_UnionType.EquivType;
                pMemberDecls = pEquivType->MPC_UnionType.MemberDecls;
            }
            PointerControl(pMemberDecls);
            /*while(pMemberDecls->Kind != kMPC_FreeNode) */  {
                tTree pMember = pMemberDecls->MPC_SU_MemberDecl.Member;
                tTree pMemberType;

                PointerControl(pMember);
                /*while(pMember->Kind != kMPC_FreeNode) */  {
                    pMemberType = pMember->MPC_SU_Member.Type;
                    PointerControl(pMemberType);
                    if (pCurInit->Kind == kMPC_FreeNode)
                        break;
                    print_Init(pMemberType);
                    if (last_init)
                        break;
                    pMember = pMember->MPC_SU_Member.Next;
                    PointerControl(pMember);
                }
                if (last_init)
                    break;
                pMemberDecls = pMemberDecls->MPC_SU_MemberDecl.Next;
                PointerControl(pMemberDecls);
            }
        }
        if (prt)
            printf("print_Init union end pType=%p\n", pType);
        break;
    case kMPC_Typedef:
        if (prt)
            printf("print_Init typedef begin pType=%p", pType);
        {
            tTree pElementType = pType->MPC_Typedef.Type;

            PointerControl(pElementType);
            print_Init(pElementType);
        }
        if (prt)
            printf("print_Init typedef end pType=%p", pType);
        break;
    default:
        if (prt)
            printf("print_Init other begin pType=%p\n", pType);
        {
            int cur_line;

            cur_line = InitLine(pCurInit);
            print_Expr(pCurInit->MPC_SimpleInit.Expr);
            pCurInit = NextInit(pCurInit);
            for (; right_braces > 0; right_braces--) {
                cur_pos += fputs("}", file);
            }
            if (pCurInit != NoTree && pCurInit->Kind != kMPC_FreeNode) {
                cur_pos += fputs(",", file);
                if (cur_line != InitLine(pCurInit)) {
                    cur_pos += fputs("\n  ", file);
                    c_blank;
                }
            }
        }
        for (; left_braces > 0; left_braces--) {
            cur_pos += fputs("{", file);
        }
        if (prt)
            printf("print_Init other end pType=%p\n", pType);
        break;
    }
}

static void print_Initializer(tTree pInit, tTree pType)
{
    int old_not_check = not_check;

    PointerControl(pInit);
    PointerControl(pType);
    not_check = 1;
    last_init = 0;
    cur_pos += fputs("=", file);
    if (pInit->Kind == kMPC_SimpleInit) {
        pCurInitList = NoTree;
        pCurInit = pInit;
    } else {
        pCurInit = NextInit(pInit);
        for (; left_braces > 0; left_braces--) {
            cur_pos += fputs("{", file);
        }
    }
    PointerControl(pCurInit);
    print_Init(pType);
    not_check = old_not_check;
}

static int InitLine(tTree pCurInit)
{
    tPosition Position;

    PointerControl(pCurInit);
    Position = pCurInit->MPC_Initializer.Pos;
    return RealPosition(Position).Line;
}

static int set_main_function(tTree pVar)
{
    tIdent Ident;
    int ret = 0;

    PointerControl(pVar);
    Ident = pVar->MPC_Var.Ident;
    if (Ident != NoIdent) {
        GetString(Ident, IdentBuf);
        ret = (strcmp(IdentBuf, "main") == 0);
    }
#ifdef MPC_DEBUGGER
    if(ret) there_is_main_in_file=1;
#endif                          /*MPC_DEBUGGER */

    return ret;
}

static int network_fun_kind(tTree pFun)
{
    int ret = 0;
    tTree pName, pType;

    PointerControl(pFun);
    pName = pFun->MPC_Function.Name;
    PointerControl(pName);
    pType = pName->MPC_Var.Type;
    PointerControl(pType);
    if (pType->MPC_FunctionType.Kind == NETWORK) {
        tTree pNetParamType = pType->MPC_FunctionType.NetParamType;

        ret++;
        if (pNetParamType != NoTree &&
            pNetParamType->Kind != kMPC_FreeNode) {
            tTree pArgList;

            {
                tTree pNext = pNetParamType->MPC_NetTypeSpecifier.NetType;

                PointerControl(pNext);
                while (pNext->Kind == kMPC_NetTypeSpecifier) {
                    pNetParamType = pNext;
                    pNext = pNext->MPC_NetTypeSpecifier.NetType;
                    PointerControl(pNext);
                }
            }
            pArgList = pNetParamType->MPC_NetTypeSpecifier.ArgList;
            ret++;
            if (pArgList != NoTree && pArgList->Kind != kMPC_FreeNode)
                ret++;
        }
    }
    if (prt)
        printf("network_fun_kind pFun=%p ret=%d\n", pFun, ret);
    return ret;
}

static void print_ArrayLen(tTree pType)
{
    int NumberOfComponents;

    PointerControl(pType);
    if (pType->Kind != kMPC_ArrayType) {
        fprintf(stderr, "not array type %p (Kind=%d)\n", pType,
                pType->Kind);
        internal_error();
    }
    NumberOfComponents = pType->MPC_ArrayType.NumberOfComponents;
    while (pType->Kind == kMPC_ArrayType) {
        if (NumberOfComponents == UNDEFINED || NumberOfComponents == 0) {
            tTree pSize = pType->MPC_ArrayType.ArraySize;

            PointerControl(pSize);
            cur_pos += print2file("", "(");
            if (prt)
                printf("\nbefore size pSize->Kind=%d\n\n", pSize->Kind);
            print_Expr(pSize);
            cur_pos += print2file("", ")");
        } else {
            cur_pos += print2file("", "%d", NumberOfComponents);
        }
        pType = pType->MPC_ArrayType.ElementType;
        PointerControl(pType);
        if (pType->Kind == kMPC_ArrayType) {
            cur_pos += print2file("", "*");
        }
    }
}

void print_ParamNumber(tTree pVar, int num)
{
    int n = 0;
    tTree old_parent_expr = parent_expr;
    int old_change_net = not_change_net;
    tTree old_pCurExprs = pCurExprs;
    int old_real_param = real_param;

    PointerControl(pVar);
    parent_expr = NoTree;
    not_change_net = 1;
    if (num == 0) {
        cur_pos += print2file("", "0");
        return;
    }
    pCurExprs = pVar;
    while (pVar->Kind != kMPC_FreeNode) {
        tTree pType = NoTree;

        switch (pVar->Kind) {
        case kMPC_Var:
            pType = pVar->MPC_Var.Type;
            break;
        case kMPC_Exprs:
            {
                tTree pExpr = pVar->MPC_Exprs.Expr;

                PointerControl(pExpr);
                pType = pExpr->MPC_Expr.Type;
            }
            break;
        default:
            fprintf(stderr, "invalid kind of the topology list element\n");
            internal_error();
            break;
        }
        PointerControl(pType);
        if (prt) {
            printf("print_ParamNumber Type->Kind=%d\n", pType->Kind);
            fflush(stdout);
        }
        if (n != 0) {
            cur_pos += print2file("", "+");
        }
        switch (pType->Kind) {
        case kMPC_BasicType:
            cur_pos += print2file("", "1");
            break;
        case kMPC_ArrayType:
            real_param = 1;
            print_ArrayLen(pType);
            real_param = old_real_param;
            break;
        default:
            fprintf(stderr, "invalid type of the topology parameter\n");
            internal_error();
            break;
        }
        if (n++ == num - 1)
            return;
        else {
            pVar = pVar->Kind == kMPC_Var ? pVar->MPC_Var.Next :
                pVar->MPC_Exprs.Next;
            PointerControl(pVar);
        }
    }
    not_change_net = old_change_net;
    parent_expr = old_parent_expr;
    pCurExprs = old_pCurExprs;
}

int all_known_len(tTree pVar)
{
    int ret = 0;

    PointerControl(pVar);
    while (pVar->Kind != kMPC_FreeNode) {
        tTree pType = NoTree;

        switch (pVar->Kind) {
        case kMPC_Var:
            pType = pVar->MPC_Var.Type;
            break;
        case kMPC_Exprs:
            {
                tTree pExpr = pVar->MPC_Exprs.Expr;

                PointerControl(pExpr);
                pType = pExpr->MPC_Expr.Type;
            }
            break;
        default:
            fprintf(stderr, "Invalid kind of the topology list element\n");
            internal_error();
            break;
        }
        PointerControl(pType);
        if (prt)
            printf("all_known_len Type->Kind=%d\n", pType->Kind);
        ret += variable_len_array(pType);
        pVar = pVar->Kind == kMPC_Var ? pVar->MPC_Var.Next :
            pVar->MPC_Exprs.Next;
        PointerControl(pVar);
    }
    return ret;
}

void print_CopyParams(tTree pNet, tTree pNetType, tTree pVar)
{
    int num = 0;
    int old_change_net = not_change_net;
    tTree pParamList;
    tTree pArgList = pVar;
    tTree old_pCurParamList = pCurParamList;
    tTree old_pCurExprs = pCurExprs;
    int old_real_param = real_param;

    PointerControl(pNet);
    PointerControl(pNetType);
    PointerControl(pVar);
    not_change_net = 1;
    parent_expr = NoTree;
    pParamList = pNetType->MPC_NetType.ParamList;
    PointerControl(pParamList);
    pCurParamList = pParamList;
    pCurExprs = pVar;
    if (all_known_len(pParamList) > 0) {
        int pos;

        c_blank;
        pos =
            cur_blank + print2file("", "%s_params=",
                                   VarName(pNet /*Type */ ));
        pos += print2file("", "(MPC_Parameters*)MPC_Malloc(");
        print2file("", "sizeof(MPC_Parameters)*\n");
        blank(pos);
        print2file("", "%s.count);\n", VarName(pNet));
    }
    c_blank;
    print2file("", "%s.params=", VarName(pNet));
    print2file("", "%s_params;\n", VarName(pNet /*Type */ ));
    if (pVar->Kind != kMPC_FreeNode) {
        c_blank;
        print2file("", "{\n");
        cur_blank += SKIP;
        {
            tTree pVarList = pVar;

            if (pVarList != NoTree) {
                while (pVarList->Kind != kMPC_FreeNode) {
                    tTree pType;

                    pType =
                        pVarList->Kind ==
                        kMPC_Var ? pVarList->MPC_Var.Type : pVarList->
                        MPC_Exprs.Expr->MPC_Expr.Type;
                    PointerControl(pType);
                    if (pType->Kind == kMPC_ArrayType) {
                        c_blank;
                        print2file("", "int MPC_ind,MPC_bound;\n");
                        break;
                    }
                    pVarList =
                        pVarList->Kind ==
                        kMPC_Var ? pVarList->MPC_Var.Next : pVarList->
                        MPC_Exprs.Next;
                    PointerControl(pVarList);
                }
            }
        }
        while (pVar->Kind != kMPC_FreeNode) {
            tTree pType, pArgVar, pTerminalType;
            int cast;

            pArgVar = pVar->Kind == kMPC_Var ? pVar : pVar->MPC_Exprs.Expr;
            PointerControl(pArgVar);
            pType = pVar->Kind == kMPC_Var ? pVar->MPC_Var.Type :
                pVar->MPC_Exprs.Expr->MPC_Expr.Type;
            PointerControl(pType);
            if (prt)
                printf
                    ("pVar=%p pType=%p pType->Kind=%d pArgVar->Kind=%d\n",
                     pVar, pType, pType->Kind, pArgVar->Kind);
            /* 17.03.99 bench changes begin */
            pTerminalType = get_TerminalAVType(pType);
            PointerControl(pTerminalType);
            if (pTerminalType->Kind != kMPC_BasicType) {
                fprintf(stderr,
                        "terminal type of the topo parameters is not BasicType Kind=%d \n",
                        pTerminalType->Kind);
                internal_error();
            }
            cast = pTerminalType->MPC_BasicType.TypeConstructor != -7;
            /* 17.03.99 bench changes end */
            c_blank;
            switch (pType->Kind) {
            case kMPC_ArrayType:
                print2file("", "MPC_bound=");
                real_param = 1;
                print_ArrayLen(pType);
                real_param = old_real_param;
                print2file("", ";\n");
                c_blank;
                print2file("",
                           "for(MPC_ind=0;MPC_ind<MPC_bound;MPC_ind++)\n");
                c_blank;
                print2file("", "  %s_params[", VarName(pNet));
                print_ParamNumber(pArgList, num++);
                print2file("", "+MPC_ind]=%s(%s(", cast ? "(int)" : "",
                           cast ? "MPC_FIXPOINT_SCALE*" : "");
                print2file("", "%s", cast ? "(double*)" : "(int*)");
                if (pArgVar->Kind == kMPC_Var) {
                    /*print2file("","+MPC_ind]=((int*)%s)[MPC_ind];\n",VarName(pArgVar)); */
                    print2file("", "%s", VarName(pArgVar));
                } else {
                    /*print2file("","+MPC_ind]=%s(%s(",cast ? "(int)" : "",
                       cast ? "MPC_FIXPOINT_SCALE*" : ""); */
                    print_Expr(pArgVar);
                    /*print2file("","))[MPC_ind];\n"); */
                }
                print2file("", ")[MPC_ind]);\n");
                break;
            case kMPC_BasicType:
                print2file("", "%s_params[", VarName(pNet));
                print_ParamNumber(pArgList, num++);
                print2file("", "]=");
                print2file("", "%s(", cast ? "MPC_FIXPOINT_SCALE*" : "");
                if (pArgVar->Kind == kMPC_Var) {
                    if (ordinar_var(pArgVar)) {
                        print2file("", "%s", VarName(pArgVar));
                    } else {
                        tTree pInit = pVar->MPC_Var.Init;

                        PointerControl(pInit);
                        print_Expr(pInit);
                    }
                } else {
                    print_Expr(pArgVar);
                }
                print2file("", ");\n");
                break;
            default:
                fprintf(stderr,
                        "invalid type of the topology parameter\n");
                internal_error();
                break;
            }
            pVar = pVar->Kind == kMPC_Var ? pVar->MPC_Var.Next :
                pVar->MPC_Exprs.Next;
            PointerControl(pVar);
        }
        b_end;
    }
    not_change_net = old_change_net;
    pCurParamList = old_pCurParamList;
    pCurExprs = old_pCurExprs;
    if (prt)
        printf("end of the print_CopyParams\n");
}

static void print_NetworkFunctionHead(tTree pFun)
{
    tTree pName, pType, pNet, pNetParamType, pNetworkParamList, pStat;
    tDeclFlags flag;

    PointerControl(pFun);
    pName = pFun->MPC_Function.Name;
    PointerControl(pName);
    pType = pName->MPC_Var.Type;
    PointerControl(pType);
    pNet = pType->MPC_FunctionType.NetParam;
    PointerControl(pNet);
    if (pNet->MPC_NetOrSubnet.pGen == NoGen) {
        tGen pNetNode;
        tGen pSingleNodeGen = SINGLE_NODE->MPC_Net.pGen;
        tGen pChild;

        GenControl(pSingleNodeGen);
        pChild = pSingleNodeGen->Net.Children;
        pStat = pFun->MPC_Function.Stats;
        PointerControl(pStat);

        pNetNode = mNet(DYNAMIC /*net_topology(pNet) */ , UNKNOWN,
                        pNet->MPC_NetOrSubnet.SingleNode,
                        pNet->Kind == kMPC_Net ? 0 : 1, 1,
                        pNet, 1, 1, 0,
                        pStat, 0, make_string(""),
                        NoGen, pSingleNodeGen, 0,
                        pStat->MPC_Compound.UniqueNumber, NoTree, 1, 1);
        pNet->MPC_NetOrSubnet.pGen = pNetNode;
        pSingleNodeGen->Net.Children = mNets(pNetNode,
                                             pSingleNodeGen->Net.Children);
    }
    pNetParamType = pType->MPC_FunctionType.NetParamType;
    pNetworkParamList = pType->MPC_FunctionType.NetworkParamList;
    pCurExprs = pNetworkParamList;
    real_param = 1;
    if (pNetParamType != NoTree && pNetParamType->Kind != kMPC_FreeNode) {
        tTree pNetType, pNetTypeSpec;
        int pos;

        flag.Auto = 1;
        flag.Extern = 0;
        flag.Static = 0;
        pNetTypeSpec = pNet->MPC_Net.NetType;
        PointerControl(pNetTypeSpec);
        {
            tTree pNext = pNetTypeSpec->MPC_NetTypeSpecifier.NetType;

            PointerControl(pNext);
            while (pNext->Kind == kMPC_NetTypeSpecifier) {
                pNetTypeSpec = pNext;
                pNext = pNext->MPC_NetTypeSpecifier.NetType;
                PointerControl(pNext);
            }
        }
        pNetType = pNetTypeSpec->MPC_NetTypeSpecifier.NetType;
        pCurParamList = pNetType->MPC_NetType.ParamList;
        /*PointerControl(pCurParamList); */
        var_fun_net = pNet;
        var_fun_net_type = pNetType;
        var_fun_net_paramlist = pNetworkParamList;
        var_fun_net_paramtype = pNetParamType;
        cur_pos += print2file("", "{\n");
        cur_blank += SKIP;
        print_CoordArray(pNet, pNetType, flag);
        if (pNetworkParamList != NoTree &&
            pNetworkParamList->Kind != kMPC_FreeNode) {
            c_blank;
            if (all_known_len(pNetworkParamList) == 0) {
                print2file("", "MPC_Parameters %s_params[", VarName(pNet));
                print_ParamNumber(pNetworkParamList, -1);
                print2file("", "];\n");
            } else {
                var_param_net = pNet;
                print2file("", "MPC_Parameters* %s_params=NULL;\n",
                           VarName(pNet));
            }
        }
        c_blank;
        pos = cur_pos + print2file("", "MPC_Net %s", VarName(pNet));
        pos += fputs("={", file);
        print2file("", "NULL,\n");
        blank(pos);
        print2file("", "&%s,\n", VarName(pNetType));
        blank(pos);
        fputs("0,NULL,MPC_AUTO_NET,NULL,0,\n", file);
        blank(pos);
        print2file("", "MPC_INIT_POWER,NULL,NULL,0,0,\n");
        blank(pos);
        print2file("", "NULL,NULL,NULL,NULL,NULL,NULL,\n");
        blank(pos);
        print2file("", "%s,0,NULL,NULL,\n", (pNetType->MPC_NetType.Bench) ?
                   "MPC_BENCH" : "MPC_NOT_BENCH");
        blank(pos);
        {
            tIdent Ident;

            Ident = pNet->MPC_Net.Ident;
            if (Ident != NoIdent) {
                GetString(Ident, IdentBuf);
            } else {
                internal_error("NoIdent name of network function net");
            }
        }
        {
            tPosition real_pos;
            tPosition Pos;

            Pos = pNet->MPC_Net.Pos;
            real_pos = RealPosition(Pos);
            print2file("", "0,\"%s\",%d,%d,1};\n", IdentBuf,
                       real_pos.Line, real_pos.Column);
        }
    }
}

void void_fun(tTree yyt)
{
    if (prt)
        printf("void_fun yyt=%p Kind=%d", yyt, yyt->Kind);
    if (yyt->Kind == kMPC_FreeNode) {
        if (prt)
            printf(" parent=%p\n", yyt->MPC_FreeNode.Parent);
    } else {
        if (prt)
            printf("\n");
    }
}

static void stat_numering(tTree yyt)
{
    if (yyt != NoTree && Tree_IsType(yyt, kMPC_Stat)) {
        yyt->MPC_Stat.UniqueNumber = ++stat_num;
    }
}

void print_Function(tTree pFun)
{
    tTree old_cur_act = cur_act_net;
    int old_in_var_decl = in_var_decl;
    tTree pVar;
    tTree pStats;
    tTree pDistribution;
    int brace;
    int braces_counter;
    tPosition Pos;
    int host_function = 0;

    BRACE_INIT_COUNTER(braces_counter);
    
    PointerControl(pFun);
    function_kind = pFun->MPC_Function.Kind;
    var_param_net = NoTree;
    var_fun_net = NoTree;
    if (prt)
        printf("\n print_Function pFun=%p Kind=%d\n\n", pFun,
               function_kind);
    Stat_stack_Init();
    /*  fputs("\n",file); */
    pVar = pFun->MPC_Function.Name;
    PointerControl(pVar);
    in_function = 1;            /* ka 14.01.2001 */
#ifdef MPC_DEBUGGER
    /* ka 11.01.2001 begin */
    if (!is_topo_fun) {
        print_ContextTree(pFun);
    }
/* ka 11.01.2001 end */
#endif                          /*MPC_DEBUGGER */
    is_main_function = set_main_function(pVar);
    if (is_main_function) {
        int pos;
        tTree pType = pVar->MPC_Var.Type;
        tTree pResultType;

        PointerControl(pType);
        pResultType = pType->MPC_FunctionType.ResultType;
        PointerControl(pResultType);
        main_function = pVar;
        print_base_type = 1;
        print_Type(pResultType);
        print_base_type = 0;
        cur_pos += print2file("", " main(int argc, char **argv)\n");
        BRACE_START(braces_counter);
        c_blank;
#ifdef WIN32        
        print2file("", "__try\n");
        BRACE_START(braces_counter);
        c_blank;            
#endif        
        print2file("", "MPC_Debug_source_name=MPC_file_name;\n");
        c_blank;
        pos = cur_pos + print2file("", "MPC_Init(");
        print2file("", "&argc,&argv,\n");
        blank(pos);
        if (!null_init) {
            print2file("", "MPC_The_init_strategy,\n");
            blank(pos);
            print2file("", "MPC_Trivial_error_print,\n");
            blank(pos);
            print2file("", "MPC_The_get_env,\n");
            blank(pos);
            print2file("", "MPC_The_strategy,\n");
            blank(pos);
            print2file("", "MPC_The_topology_data,\n");
            blank(pos);
            print2file("", "MPC_The_processors_info");
        } else {
            print2file("", "NULL,NULL,NULL,NULL,NULL,NULL");
        }
        print2file("", ");\n");

#ifdef MPC_TRACER        
        PRINT_TRACE_START(source_file);
#endif

        BRACE_START(braces_counter);        
    }
    pStats = pFun->MPC_Function.Stats;
    PointerControl(pStats);
    {
        tTree pCurStat = pStats->MPC_Compound.Stats;
        tTree pNext;

        while (pCurStat != NoTree && pCurStat->Kind != kMPC_FreeNode) {
            pNext = pCurStat->MPC_Stats.Next;
            if (pNext != 0 && pNext->Kind == kMPC_FreeNode &&
                pCurStat->Kind == kMPC_Return) {
                the_last_is_return = 1;
                break;
            }
            pCurStat = pNext;
        }
    }
    
    /* VERY SUPICTIOUS PLACE !!!!
    cur_blank = 0;
    cur_pos = 0;
    */
    
    pDistribution = pFun->MPC_Function.Distribution;
    PointerControl(pDistribution);
    cur_act_net = pDistribution->MPC_NetOrSubnet.MyList;
    fun_distr = pDistribution;
    if (pDistribution == HOST) {
        host_function = 1;
        /*host_stat=1; */
    }
    in_var_decl = 1;
    not_check = 1;
    if (pFun->MPC_Function.Flag.Static)
        cur_pos += print2file("", "static ");
    if (!is_main_function) {
        print_Var(pVar);
    }
    in_var_decl = old_in_var_decl;
    if (function_kind == BASIC) {
        first_waiting_point_in_function = 1;
    }
    /*
    cur_pos += fputs(" ", file);
    */
    blank_is_necessary = 0;
    stat_num = 0;
    if (prt)
        printf("before stat_numering\n");
    /*TraverseTreeTD(pFun,stat_numering); */
    Stat_traverse(pStats, stat_numering);
    if (prt)
        printf("after stat_numering\n");
    if (host_function && pass_number > 1) {
        print2file("", "{ ; }\n");
    } else {
        if (!is_topo_fun) {
            tTree pType = pFun->MPC_Function.Type;
            tTree pParamList;
            tTree pNetworkParamList;

            PointerControl(pType);
            BRACE_START(braces_counter);
            if (pType->MPC_FunctionType.Kind == NETWORK
                && network_fun_kind(pFun) > 1) {
                pNetworkParamList =
                    pType->MPC_FunctionType.NetworkParamList;
                PointerControl(pNetworkParamList);
                print_RTSNodeDeclare(pNetworkParamList);
            }
            pParamList = pFun->MPC_Function.ParamList;
            PointerControl(pParamList);
            while (pParamList->Kind == kMPC_VarDecl) {
                VarDecl_traverse(pParamList, print_RTSNodeDeclare);
                pParamList = pParamList->MPC_VarDecl.Next;
                PointerControl(pParamList);
            }
#ifdef MPC_DEBUGGER
            if (DBG_CODE) {
                tPosition real_pos;

                real_pos = RealPosition(pFun->MPC_Function.Pos);
                if (pFun->MPC_Function.TableSize) {
                    print2file("", "MPC_VarTable MPC_vt[%d];\n",
                               pFun->MPC_Function.TableSize);
                }
                Pos = pFun->MPC_Function.Pos;
                c_blank;
                print2file("", "tMPC_Frame MPC_Debug_frame={\"%s\",",
                           VarName(pVar));
                print2file("", "%s,{%d,%d},%s,NULL,NULL,NULL};\n",
                           SourceFile(Pos), real_pos.Line, real_pos.Column,
                           pFun->MPC_Function.
                           TableSize ? "MPC_vt" : "NULL");
                if (pFun->MPC_Function.TableSize) {
                    c_blank;
                    print2file("", "int MPC_vi;\n");
                }
                c_blank;
                print2file("",
                           "MPC_Debug_frame_init(&MPC_Debug_frame);\n");
                if (pFun->MPC_Function.TableSize) {
                    c_blank;
                    print2file("",
                               "for(MPC_vi=0; MPC_vi<%d; MPC_vi++) {\n",
                               pFun->MPC_Function.TableSize);
                    cur_blank += SKIP;
                    c_blank;
                    print2file("", "MPC_vt[MPC_vi].addr=NULL;\n");
                    c_blank;
                    print2file("", "MPC_vt[MPC_vi].type=NULL;\n");
                    b_end;
                }
            if (pType->MPC_FunctionType.Kind == NETWORK &&
                network_fun_kind(pFun) > 1) {
                pNetworkParamList =
                    pType->MPC_FunctionType.NetworkParamList;
                PointerControl(pNetworkParamList);
                /*        print_RTSNodeDeclare(pNetworkParamList); */
                while (pNetworkParamList->Kind == kMPC_Var) {
                    C_var_record_init(pNetworkParamList);
                    pNetworkParamList = pNetworkParamList->MPC_Var.Next;
                    PointerControl(pNetworkParamList);
                }
            }
            pParamList = pFun->MPC_Function.ParamList;
            PointerControl(pParamList);
            while (pParamList->Kind == kMPC_VarDecl) {
                VarDecl_traverse(pParamList, C_var_record_init);
                pParamList = pParamList->MPC_VarDecl.Next;
                PointerControl(pParamList);
            }
        }
/* ka 31.01.2001 end */
#endif                          /*MPC_DEBUGGER */
    }

#ifdef MPC_TRACER
            PRINT_TRACE_FUNC(VarName(pVar), pFun->MPC_Function.Pos)
            if(is_main_function) {
                PRINT_TRACE_OPERATOR(pFun->MPC_Function.Stats->MPC_Compound.Pos)
            }
#endif            

        {
            tTree pParamList = pFun->MPC_Function.ParamList;

            PointerControl(pParamList);
            /* POSYPKIN FIX 02.03.21
               brace=is_dyn_param(pParamList);
             */
            if (brace) {
               /** TMP_FIX 03.05.04
                c_blank;
                cur_pos += print2file("", "{\n");
                cur_blank += SKIP;
                */
                /* POSYPKIN FIX 02.03.21
                   print_param_rts_type_tree(pParamList);
                 */
            }
        }
        if (network_fun_kind(pFun) > 1) {
            print_NetworkFunctionHead(pFun);
        }
        not_check = 0;
        
        /*
        if(pFun->MPC_Function.Kind == BASIC) {
            BRACE_START(braces_counter);
            print_create_nets_and_subnets(TreeRoot->MPC_Root.Decls);
        }
        */
        
        c_blank;        
        Stats_print(pStats);
        if (function_kind == NETWORK) {
            /*if (var_param_net != NoTree) {
               c_blank;
               print2file("", "MPC_Free(%s_params);\n",
               VarName(var_param_net));
               var_param_net = NoTree;
               } */
            if (var_fun_net != NoTree) {
                if (!the_last_is_return) {
                    c_blank;
                    print2file("", "%s->oldroot=%s.oldroot;\n",
                               NET_PARAMETER, VarName(var_fun_net));
                }
                {
                    var_fun_net = NoTree;
                    b_end;
                }
            }
        }
        /*
        if (brace) {
            b_end;
        }
        */
#ifdef MPC_DEBUGGER
/* ka 31.01.2001 begin */
/*
        if (!is_topo_fun) {
            b_end;
        }
*/        
/* ka 31.01.2001 end */
#endif                          /*MPC_DEBUGGER */
        if (is_main_function) {
#ifdef MPC_TRACER        
        PRINT_TRACE_END
#endif
/*
            b_end;
            b_end;
*/            
        }
    }
#ifdef MPC_DEBUGGER
    if(DBG_CODE) {
        if (!is_topo_fun) {
          C_cur_stat.C_prev_kind=C_FUN;
        }
    }
#endif                          /*MPC_DEBUGGER */

#ifdef WIN32
        if (is_main_function) {
          CLOSE_N_BRACES(braces_counter, braces_counter - 1)
          c_blank;
          print2file("","__except(MPC_Exception_handler(_exception_code(), _exception_info()) ) {};\n");
        }
#endif         
   
    CLOSE_ALL_BRACES(braces_counter);
    not_check = 0;
    host_stat = 0;
    in_function = 0;
    state_kind = KNOWN;
    cur_block = pRoot;
    Stat_stack_Free();
    cur_act_net = old_cur_act;
    fun_distr = NoTree;
    pCurParamList = NoTree;
    pCurExprs = NoTree;
    real_param = 0;
    the_last_is_return = 0;
}

static void set_net_fun_params(tTree pVar)
{
    tTree pType;

    PointerControl(pVar);
    pType = pVar->MPC_Var.Type;
    PointerControl(pType);
    if (pType->Kind == kMPC_FunctionType &&
        pType->MPC_FunctionType.Kind == NETWORK) {
        tTree pNetParamType = pType->MPC_FunctionType.NetParamType;
        tTree pNetworkParamList = pType->MPC_FunctionType.NetworkParamList;

        if (pNetParamType != NoTree &&
            pNetParamType->Kind != kMPC_FreeNode) {
            tTree pNetType;

            {
                tTree pNext = pNetParamType->MPC_NetTypeSpecifier.NetType;

                PointerControl(pNext);
                while (pNext->Kind == kMPC_NetTypeSpecifier) {
                    pNetParamType = pNext;
                    pNext = pNext->MPC_NetTypeSpecifier.NetType;
                    PointerControl(pNext);
                }
            }
            pNetType = pNetParamType->MPC_NetTypeSpecifier.NetType;
            PointerControl(pNetType);
            pCurParamList = pNetType->MPC_NetType.ParamList;
            pCurExprs = pNetworkParamList;
        }
    }
}


#ifdef POSYPKIN
/**
 * Function is_dyn_param 
 * checks whether parameter list contains
 * pointer generated from array
 */
#endif

/* POSYPKIN FIX 02.03.21
static int is_dyn_param(tTree pParamList) {
  int brace=0;
  while(pParamList->Kind != kMPC_FreeNode) {
    tTree pVar=pParamList->MPC_VarDecl.Var;
    PointerControl(pVar);
    while(pVar->Kind != kMPC_FreeNode) {
      tTree pType=pVar->MPC_Var.Type;
      PointerControl(pType);
      brace+=pType->Kind == kMPC_PointerType &&
        pType->MPC_PointerType.GeneratedFrom != NoTree && 
        pType->MPC_PointerType.GeneratedFrom->Kind != kMPC_FreeNode;
      pVar=pVar->MPC_Var.Next;
      PointerControl(pVar);
    }
    pParamList=pParamList->MPC_VarDecl.Next;
  }
  return brace;
}
*/

#ifdef POSYPKIN
/**
 * Function print_param_rts_type_tree prints RTS
 * types structures for function parameters of pointer types
 * substituting pointer with the corresponding array
 */
#endif

/* POSYPKIN FIX 02.03.21

static void print_param_rts_type_tree(tTree pParamList) {
  while(pParamList->Kind != kMPC_FreeNode) {
    tTree pVar=pParamList->MPC_VarDecl.Var;
    PointerControl(pVar);
    while(pVar->Kind != kMPC_FreeNode) {
      tTree pType=pVar->MPC_Var.Type;
      PointerControl(pType);
      if(pType->Kind == kMPC_PointerType &&
        pType->MPC_PointerType.GeneratedFrom != NoTree && 
         pType->MPC_PointerType.GeneratedFrom->Kind != kMPC_FreeNode) {
        print_rts_type_tree(pType->MPC_PointerType.GeneratedFrom->
                            MPC_Type.pType);
      }
      pVar=pVar->MPC_Var.Next;
      PointerControl(pVar);
    }
    pParamList=pParamList->MPC_VarDecl.Next;
  }
}
*/

#ifdef MPC_DEBUGGER
/* ka 04.01.2001 begin */

static char *node_prefix[C_NET] = { "c", "v", "b", "f", "t" };

tLastNode last_node(C_status C_cur_stat)
{
    tLastNode ret;

    switch (C_cur_stat.C_prev_kind) {
    case C_CONST:
        ret.Number = C_cur_stat.const_number.prev;
        break;
    case C_VAR:
        ret.Number = C_cur_stat.var_number.prev;
        break;
    case C_BLOCK:
        ret.Number = C_cur_stat.block_number.prev;
        break;
    case C_FUN:
        ret.Number = C_cur_stat.fun_number.prev;
        break;
    case C_TDEF:
        ret.Number = C_cur_stat.tdef_number.prev;
        break;
    case C_NET:
        ret.pNode = C_cur_stat.net;
        break;
    case C_NETTYPE:
        ret.pNode = C_cur_stat.nettype;
        break;
    default:
        fprintf(stderr, "last_node C_cur_stat.C_prev_kind=%d\n",
                C_cur_stat.C_prev_kind);
        internal_error();
        break;
    }
    return ret;
}

void last_node_print(int Kind, tLastNode pLast_node)
{
    switch (Kind) {
    case C_CONST:
    case C_VAR:
    case C_BLOCK:
    case C_FUN:
    case C_TDEF:
        print2file("", "&C_%s%d", node_prefix[Kind - 1],
                   (int) pLast_node.Number);
        break;
    case C_NET:
    case C_NETTYPE:
        print2file("", "&C_%s", VarName((tTree) pLast_node.pNode));
        break;
    default:
        fprintf(stderr, "last_node_print Kind=%d\n", Kind);
        internal_error();
        break;
    }
}

static void C_prev_node_print()
{
    if (DBG_CODE) {
        print2file("", "(tmpC_C)");
        switch (C_cur_stat.C_prev_kind) {
        case NO_C:
            print2file("", "NompC_C");
            break;
        case C_CONST:
            print2file("", "&C_c%d", C_cur_stat.const_number.prev);
            break;
        case C_VAR:
            print2file("", "&C_v%d", C_cur_stat.var_number.prev);
            break;
        case C_BLOCK:
            print2file("", "&C_b%d", C_cur_stat.block_number.prev);
            break;
        case C_FUN:
            print2file("", "&C_f%d", C_cur_stat.fun_number.prev);
            break;
        case C_TDEF:
            print2file("", "&C_t%d", C_cur_stat.tdef_number.prev);
            break;
        case C_NET:
            {
                tTree pNet = C_cur_stat.net;

                PointerControl(pNet);
                print2file("", "&C_%s", VarName(pNet));
            }
            break;
        case C_NETTYPE:
            {
                tTree pNetType = C_cur_stat.nettype;

                PointerControl(pNetType);
                print2file("", "&C_%s", VarName(pNetType));
            }
            break;
        default:
            fprintf(stderr, "last_node_print C_cur_stat.C_prev_kind=%d\n",
                    C_cur_stat.C_prev_kind);
            internal_error();
            break;
        }
    }
}



static void print_Position(tTree pNode)
{
    if (DBG_CODE) {
        tPosition real_pos;
        tPosition Pos;

        PointerControl(pNode);
        Pos = pNode->MPC_Decls.Pos;
        /*  switch(pNode->Kind) {
           case kMPC_Decls:
           Pos=pNode->MPC_Decls.Pos;
           break;
           case kMPC_Stats:
           Pos=pNode->MPC_Stats.Pos;
           break;
           default:
           fprintf(stderr,"Unexpected Node kind Kind=%d\n",pNode->Kind);
           internal_error();
           break;
           } */
        real_pos = RealPosition(Pos);
        print2file("", "{%d,%d},", real_pos.Line, real_pos.Column);
    }
}

static void C_fun_node_print(tTree pVar)
{
    if (DBG_CODE) {
        PointerControl(pVar);
        c_blank;
        print2file("", "static yC_Function C_f%d={{kC_Function,0},",
                   C_cur_stat.fun_number);
        print_Position(pVar);
        C_prev_node_print();
        print2file("", ",\"%s\"};\n", VarName(pVar));
      last_global_node.pNode=pVar;
      last_global_node.Number=C_cur_stat.fun_number.cur;
      last_global_node_kind=C_FUN;

        C_cur_stat.C_prev_kind = C_FUN;
        C_cur_stat.fun_number.prev = C_cur_stat.fun_number.cur++;
    }
}

static void C_distr_print(tTree pDistr)
{
    if (DBG_CODE) {
        if (pDistr->Kind == kMPC_Subnet &&
            pDistr->MPC_Subnet.Flexible &&
            pDistr->MPC_Subnet.Ident == NoIdent) {
            tTree pPredicate = pDistr->MPC_Subnet.Predicate;
            tTree pNotFlex = pDistr->MPC_Subnet.Distribution;

            PointerControl(pNotFlex);
            PointerControl(pPredicate);
            print2file("", ",(tmpC_C)&C_%s", VarName(pNotFlex));
            print2file("", ",\"\"");
        } else {
            print2file("", ",(tmpC_C)&C_%s,NULL", VarName(pDistr));
        }
    }
}

void C_var_record_init(tTree pVar)
{
    if (DBG_CODE) {
        tTree pType;
        tType p_type;

        PointerControl(pVar);        
        c_blank;
        switch (pVar->Kind) {
        case kMPC_Var:
            if(pVar->MPC_Var.Flag.Source){
                
                tDeclFlags flag;

                pType = pVar->MPC_Var.Type;
                PointerControl(pType);
                flag = pVar->MPC_Var.Flag;
                if (flag.Used || pType->Kind != kMPC_FunctionType) {
                    print2file("", "MPC_vt[%d].addr=(void*)&%s;\n",
                               pVar->MPC_Var.Index, VarName(pVar));
                }
                pType = pVar->MPC_Var.Type;
                PointerControl(pType);
                p_type = pType->MPC_Type.pType;
                TypeControl(p_type);
                if (p_type->Type.Gen) {
                    c_blank;
                    print2file("", "MPC_vt[%d].type=(MPC_Dt)&%s;\n",
                               pVar->MPC_Var.Index, DataVarName(pType));
                }
            }
            break;
        case kMPC_Net:
            print2file("", "MPC_vt[%d].addr=&%s;\n",
                       pVar->MPC_Net.Index, VarName(pVar));
            break;
        case kMPC_Subnet:
            print2file("", "MPC_vt[%d].addr=&%s;\n",
                       pVar->MPC_Subnet.Index, VarName(pVar));
            break;
        }
    }
}

static int NotCompletedSU(tTree pType)
{
    tType p_type;

    /*printf("NotCompletedSU pType=%p Kind=%d\n",pType,pType->Kind); */
    //  pType=Strip_Typedef(pType);
    p_type = pType->MPC_Type.pType;
    if (p_type == NoType)
        return 1;
    else {
        tTree pT;

        pT = p_type->Type.Origin;
        if (pT == NoTree)
            return 1;
        else {
            if (pT->Kind == kMPC_StructType || pT->Kind == kMPC_UnionType) {
                return !p_type->Type.Gen
                    || (pT->MPC_SU_Type.MemberDecls == NoTree);
            }
        }
    }
    return 0;
}

void C_var_node_print(tTree pVar)
{
    if (DBG_CODE && pVar->MPC_Var.Flag.Source) {
        tTree pType, pDistr;
        tType p_type;
        int predicate = 0;
        PointerControl(pVar);
        pType = pVar->MPC_Var.Type;
        PointerControl(pType);
        p_type = pType->MPC_Type.pType;
        TypeControl(p_type);
        pDistr = pVar->MPC_Var.Distribution;
        PointerControl(pDistr);
        c_blank;
        print2file("", "static yC_%sVar C_v%d={{kC_%sVar,0},",
                   in_function ? "Local" : "Global",
                   C_cur_stat.var_number.cur,
                   in_function ? "Local" : "Global");
        print_Position(pVar);
        C_prev_node_print();
        print2file("", ",\"%s\",%s,%s",
                   VarName(pVar),
                   pType->MPC_Type.Flag.Const ? "1" : "0",
                   pType->MPC_Type.Flag.Repl ? "1" : "0");
        if (pType->Kind == kMPC_FunctionType &&
            pType->MPC_FunctionType.Kind == NETWORK) {
            print2file("", ",NompC_C,NULL");
        } else {
            C_distr_print(pDistr);
        }
        if (!in_function) {
            /*
               if (NotCompletedSU(pType) || pType->Kind == kMPC_FunctionType) {
               print2file("", ",NULL");
               } else {
               print2file("", ",(MPC_Dt)&%s", DataVarName(pType));
               }
             */
            print2file("", ",(MPC_Dt)&%s", DataVarName(pType));
            print2file("", ",&%s};\n", VarName(pVar));

      last_global_node.pNode=pVar;
      last_global_node.Number=C_cur_stat.var_number.cur;
      last_global_node_kind=C_VAR;
        } else {
            pVar->MPC_Var.Index = Aindex++;
            print2file("", ",%d, (MPC_Dt)&%s};\n", pVar->MPC_Var.Index,
                       DataVarName(pType));
        }
        C_cur_stat.C_prev_kind = C_VAR;
        C_cur_stat.var_number.prev = C_cur_stat.var_number.cur++;
    }
}

static void C_block_node_print(tTree pBlock)
{
    if (DBG_CODE) {
        PointerControl(pBlock);
        c_blank;
        print2file("", "static yC_Compound C_b%d={{kC_Compound,0},",
                   C_cur_stat.block_number.cur);
        print_Position(pBlock);
        C_prev_node_print();
        print2file("", "};\n");
        C_cur_stat.C_prev_kind = C_BLOCK;
        C_cur_stat.block_number.prev = C_cur_stat.block_number.cur++;
    }
}

void C_enum_node_print(tTree pEnum)
{
    if (DBG_CODE) {
        tTree t, pEnumList;
        int const_num = 0;

        PointerControl(pEnum);
        for(t = pEnum;
           (t->MPC_EnumType.EnumList == NoTree)&&(t->MPC_Type.EquivType != pEnum);
            t = t->MPC_Type.EquivType);                    
        
        pEnumList = t->MPC_EnumType.EnumList;
        PointerControl(pEnumList);
        while (pEnumList->Kind != kMPC_FreeNode) {
            c_blank;
            print2file("", "static yC_EnumConst C_c%d={{kC_EnumConst,0},",
                       C_cur_stat.const_number.cur);
            print_Position(t);
            C_prev_node_print();
            GetString(pEnumList->MPC_EnumConst.Name, IdentBuf);
            print2file("", ",\"%s\"", IdentBuf);
            if (pEnumList->MPC_EnumConst.Value != UNDEFINED) {
                const_num = pEnumList->MPC_EnumConst.Value;
            }
            print2file("", ",%d};\n", const_num++);
            C_cur_stat.C_prev_kind = C_CONST;
            C_cur_stat.const_number.prev = C_cur_stat.const_number.cur++;
            pEnumList = pEnumList->MPC_EnumConst.Next;
            PointerControl(pEnumList);
        }
    }
}

void C_tdef_node_print(tTree pDecl)
{
    if (DBG_CODE) {
        PointerControl(pDecl);
        c_blank;
        print2file("", "static yC_Typedef C_t%d={{kC_Typedef,0},",
                   C_cur_stat.tdef_number.cur);
        print_Position(pDecl);
        C_prev_node_print();
        GetString(pDecl->MPC_Typedef.TypedefName, IdentBuf);
        print2file("", ",\"%s\"};\n", IdentBuf);
        C_cur_stat.C_prev_kind = C_TDEF;
        C_cur_stat.tdef_number.prev = C_cur_stat.tdef_number.cur++;
    }
}

void C_net_node_print(tTree pDecl)
{
    if (DBG_CODE) {
        tTree pNet, pNetType;

        PointerControl(pDecl);
        if (pDecl != HOST) {
            c_blank;
            print2file("", "static yC_%sNet C_%s={{kC_%sNet,0},",
                       in_function ? "Local" : "Global", VarName(pDecl),
                       in_function ? "Local" : "Global");
            print_Position(pDecl);
            C_prev_node_print();
            GetString(pDecl->MPC_NetOrSubnet.Ident, IdentBuf);
            print2file("", ",\"%s\"", IdentBuf);
            pNet = pDecl->Kind == kMPC_Subnet ? net_parent(pDecl) : pDecl;
            pNetType = pNet->MPC_Net.NetType;
            PointerControl(pNetType);
            print2file("", ",(tmpC_C)&C_%s", VarName(pNetType));
            if (in_function) {
                pDecl->MPC_NetOrSubnet.Index = Aindex++;
                print2file("", ",%d};\n", pDecl->MPC_NetOrSubnet.Index);
            } else {
                print2file("", ",&%s};\n", VarName(pDecl));
            }
            C_cur_stat.C_prev_kind = C_NET;
            C_cur_stat.net = pDecl;
        }
    }
}

void C_nettype_node_print(tTree pDecl)
{
    if (DBG_CODE) {
        tTree pCoordDecl;
        int coord_num = 0, c_number;

        PointerControl(pDecl);
        pCoordDecl = pDecl->MPC_NetType.CoordDecl;
        PointerControl(pCoordDecl);
        c_number = coord_number(pDecl);
        for (coord_num = c_number - 1; coord_num >= 0; coord_num--) {
            tTree pCurCoordDecl = pCoordDecl;
            int i;

            for (i = 0; i < coord_num; i++) {
                pCurCoordDecl = pCurCoordDecl->MPC_CoordDecl.Next;
                PointerControl(pCurCoordDecl);
            }
            c_blank;
            print2file("", "static yC_Coord C_%s_%d={{kC_Coord,0},",
                       VarName(pDecl), coord_num);
            print_Position(pCurCoordDecl);
            GetString(pCurCoordDecl->MPC_CoordDecl.Ident, IdentBuf);
            print2file("", "\"%s\"", IdentBuf);
            if (coord_num == c_number - 1) {
                print2file("", ",NompC_C};\n");
            } else {
                print2file("", ",(tmpC_C)&C_%s_%d};\n",
                           VarName(pDecl), coord_num + 1);
            }
        }
        c_blank;
        print2file("", "static yC_NetType C_%s={{kC_NetType,0},",
                   VarName(pDecl));
        print_Position(pDecl);
        C_prev_node_print();
        GetString(pDecl->MPC_NetType.Ident, IdentBuf);
        print2file("", ",\"%s\"", IdentBuf);
        print2file("", ",%d,(tmpC_C)&C_%s_0};\n", c_number,
                   VarName(pDecl));
        C_cur_stat.C_prev_kind = C_NETTYPE;
        C_cur_stat.nettype = pDecl;
    }
}

static void C_nodes_print(tTree pDecl)
{
    PointerControl(pDecl);
    switch (pDecl->Kind) {
    case kMPC_Function:
        C_fun_node_print(pDecl);
        break;
    case kMPC_VarDecl:
        {
            tTree pType = pDecl->MPC_VarDecl.DeclSpecifier;

            PointerControl(pType);
            if (pType->Kind == kMPC_EnumType) {
                C_enum_node_print(pType);
            }
        }
        VarDecl_traverse(pDecl, C_var_node_print);
        break;
    case kMPC_EnumType:
        C_enum_node_print(pDecl);
        break;
    case kMPC_Typedef:
        {
            tTree pType = pDecl->MPC_Typedef.Type;

            PointerControl(pType);
            if (pType->Kind == kMPC_EnumType) {
                C_enum_node_print(pType);
            }
        }
        C_tdef_node_print(pDecl);
        break;
    case kMPC_NetDecl:
        {
            tTree pNet = pDecl->MPC_NetDecl.Net;

            PointerControl(pNet);
            while (pNet->Kind != kMPC_FreeNode) {
                pNet->MPC_Net.WithNumber = pDecl != HOST
                    && !pDecl->MPC_NetDecl.Flag.Extern;
                C_net_node_print(pNet);
                pNet = pNet->MPC_Net.Next;
                PointerControl(pNet);
            }
        }
        break;
    case kMPC_SubnetDecl:
        {
            tTree pSubnet = pDecl->MPC_SubnetDecl.Subnet;

            PointerControl(pSubnet);
            while (pSubnet->Kind != kMPC_FreeNode) {
                pSubnet->MPC_Subnet.WithNumber =
                    !pDecl->MPC_SubnetDecl.Flag.Extern;
                C_net_node_print(pSubnet);
                pSubnet = pSubnet->MPC_Subnet.Next;
                PointerControl(pSubnet);
            }
        }
        break;
        /*case kMPC_NetType:
           C_nettype_node_print(pDecl);
           break; */
    default:
        break;
    }
}

static void print_C_tree(tTree pStat)
{
    PointerControl(pStat);
    if (pStat->Kind == kMPC_Compound && 
        pStat->MPC_Compound.Flag.Source) {
        C_block_node_print(pStat);
        StateDecls_traverse(pStat, C_nodes_print);
    }
}
void print_ContextTree(tTree pFun)
{
    tTree pVar;
    tTree pStats, pType;
    tTree pParamList;

    PointerControl(pFun);
    function_kind = pFun->MPC_Function.Kind;
    var_param_net = NoTree;
    var_fun_net = NoTree;
    pVar = pFun->MPC_Function.Name;
    PointerControl(pVar);
    Aindex = 0;
    pFun->MPC_Function.TableSize = Aindex;
    is_main_function = set_main_function(pVar);
    C_fun_node_print(pVar);
    pType = pFun->MPC_Function.Type;
    PointerControl(pType);
    if (pType->MPC_FunctionType.Kind == NETWORK
        && network_fun_kind(pFun) > 1) {
        tTree pNetParam, pNetworkParamList;

        pNetParam = pType->MPC_FunctionType.NetParam;
        pNetParam->MPC_Net.WithNumber = 1;
        C_net_node_print(pNetParam);
        pNetworkParamList = pType->MPC_FunctionType.NetworkParamList;
        PointerControl(pNetworkParamList);
        while (pNetworkParamList->Kind == kMPC_Var) {
            C_var_node_print(pNetworkParamList);
            pNetworkParamList = pNetworkParamList->MPC_Var.Next;
            PointerControl(pNetworkParamList);
        }
    }
    pParamList = pFun->MPC_Function.ParamList;
    PointerControl(pParamList);
    while (pParamList->Kind == kMPC_VarDecl) {
        VarDecl_traverse(pParamList, C_var_node_print);
        pParamList = pParamList->MPC_VarDecl.Next;
        PointerControl(pParamList);
    }
    pStats = pFun->MPC_Function.Stats;
    in_C_print = 1;
    Stat_traverse(pStats, print_C_tree);
    in_C_print = 0;
    pFun->MPC_Function.TableSize = Aindex;
}

/* ka 04.01.2001 end */
#endif                          /*MPC_DEBUGGER */
