#ifndef _TRACER_H_
#define _TRACER_H_

#define PRINT_TRACE_MACRO_IF print2file("", "\n#ifdef TRASSA\n");

#define PRINT_TRACE_MACRO_ENDIF print2file("", "#endif\n");

#define PRINT_TRACE_HEADERS  {\
        PRINT_TRACE_MACRO_IF\
        /* print2file("", "#include <stdio.h>\n");\
        print2file("", "#include \"Write.h\"\n");\
        print2file("", "#include \"standdef.h\"\n");*/\
        PRINT_TRACE_MACRO_ENDIF\
}
    
#define PRINT_TRACE_START(filenam)  {\
        PRINT_TRACE_MACRO_IF\
        BRACE_OPEN;\
        c_blank;\
        print2file("","char* name;\n");\
        c_blank;\
        print2file("","name = (char*) malloc(%d);\n", MAX_NAME_LEN);\
        c_blank;\
        print2file("","sprintf(name,MPC_TRACE_PREFIX \"%%d\", MPC_Global_rank());\n");\
        c_blank;\
        print2file("","mpc_trace_start(name);\n");\
        BRACE_CLOSE;\
        PRINT_TRACE_MACRO_ENDIF\
}
    
#define PRINT_TRACE_BLOCK_START(position) {\
        tPosition real_pos;\
        PRINT_TRACE_MACRO_IF\
        c_blank;\
        real_pos = RealPosition(position);\
                print2file("", "mpc_trace(\"block start %d,%d\");\n",\
                real_pos.Line,\
                real_pos.Column\
                );\
        PRINT_TRACE_MACRO_ENDIF\
}

#define PRINT_TRACE_BLOCK_END(position) {\
        tPosition real_pos;\
        PRINT_TRACE_MACRO_IF\
        real_pos = RealPosition(position);\
        c_blank;\
        print2file("", "mpc_trace(\"block end %d\");\n", real_pos.Line);\
        PRINT_TRACE_MACRO_ENDIF\
}


#define PRINT_TRACE_FUNC(name, position) {\
        tPosition real_pos;\
        PRINT_TRACE_MACRO_IF\
        real_pos = RealPosition(position);\
        c_blank;\
        print2file("", "mpc_trace(\"function %s %d %d\");\n",\
            name,\
            real_pos.Line,\
            real_pos.Column\
            );\
        PRINT_TRACE_MACRO_ENDIF\
}

#define PRINT_TRACE_OPERATOR(position) {\
        tPosition real_pos;\
        PRINT_TRACE_MACRO_IF\
        real_pos = RealPosition(position);\
        c_blank;\
        print2file("", "mpc_trace(\"operator %d\");\n", real_pos.Line);\
        PRINT_TRACE_MACRO_ENDIF\
}


#define PRINT_TRACE_END {\
        PRINT_TRACE_MACRO_IF\
        PRINT_TRACE_MACRO_ENDIF\
}

#endif
