#ifndef _MPC_TAGS
#define _MPC_TAGS
/*****************************************************************************/
/* mpCtags.h - contains all MPI tags used in the mpC implementation          */
/* Coded by Dm. Arapov for A.Lastovtsky 1995-1996                            */
/* Release 1.10.96                                                           */
/* Modified and debugged by E.Kusikov 1997,1998,1999                         */
/* Release 28.01.99                                                          */
/*                            Revision history                               */
/*                                                                           */
/* DD-MM-YYYY          Description (Developer Name)                          */
/* ----------          ------------------------------------------------------*/
/* 01-11-2007  --      Consolidation of the MPC CVS rts and MPC3XX rts       */
/*                     into a single rts (Ravi Reddy)                        */
/*****************************************************************************/

#define MPC_FIRST_TAG (32767/4)*3
#define MPC_MSG_TAG (MPC_FIRST_TAG+1)
#define MPC_VARMSG_TAG (MPC_FIRST_TAG+2)
#define MPC_MSGTAIL_TAG (MPC_FIRST_TAG+3)
#define MPC_LENGTH_TAG (MPC_FIRST_TAG+4)
#define MPC_BODY_TAG (MPC_FIRST_TAG+5)
#define MPC_ERRHEAD_TAG (MPC_FIRST_TAG+6)
#define MPC_ERRBODY_TAG (MPC_FIRST_TAG+7)
#define MPC_ENDWORK_TAG (MPC_FIRST_TAG+8)
#define MPC_HOSTOUT_TAG (MPC_FIRST_TAG+9)
#define MPC_CREATENET_TAG (MPC_FIRST_TAG+10)
#define MPC_FREENET_TAG (MPC_FIRST_TAG+11)
#define MPC_TOPOINF_TAG (MPC_FIRST_TAG+12)
#define MPC_REPLY_TAG (MPC_FIRST_TAG+13)
#define MPC_BAGHEAD_TAG (MPC_FIRST_TAG+14)
#define MPC_BAGTAIL_TAG (MPC_FIRST_TAG+15)
#define MPC_CTRL_TAG (MPC_FIRST_TAG+16)
#define MPC_BURSTCREATENET_TAG (MPC_FIRST_TAG+17)
#define MPC_PRINTFHEAD_TAG (MPC_FIRST_TAG+18)
#define MPC_PRINTFBODY_TAG (MPC_FIRST_TAG+19)
#define MPC_ENVSIZE_TAG (MPC_FIRST_TAG+20)
#define MPC_ENVBODY_TAG (MPC_FIRST_TAG+21)
#define MPC_INFOPROC_TAG (MPC_FIRST_TAG+22)
#define MPC_INFONUM_TAG (MPC_FIRST_TAG+23)
#define MPC_INFOBODY_TAG (MPC_FIRST_TAG+24)
#define MPC_VARSEND_TAG (MPC_FIRST_TAG+25)
#define MPC_SENDEND_TAG (MPC_FIRST_TAG+26)
#define MPC_WAITBEGIN_TAG (MPC_FIRST_TAG+27)
#define MPC_INFOPROCSET_TAG (MPC_FIRST_TAG+28)
#define MPC_REQUEST_FOR_ENV_TAG (MPC_FIRST_TAG+29)
#define MPC_REQUEST_FOR_REFRESH_TAG (MPC_FIRST_TAG+30)
#define MPC_ENVREFRESH_TAG (MPC_FIRST_TAG+31)
#define MPC_GIVEBODY_TAG (MPC_FIRST_TAG+32)
#define MPC_HAVEBODY_TAG (MPC_FIRST_TAG+33)
#define MPC_ERRRETURN_TAG (MPC_FIRST_TAG+34)

/* Ravi Reddy (Thu Nov  1 11:05:40 GMT 2007)
 * Tag to get performances of processes,
 * to get number of free processes
 */
#define MPC_INFOPROCESSES_TAG (MPC_FIRST_TAG+36)
#define MPC_COMPUTERS_TAG     (MPC_FIRST_TAG+37)
#define MPC_COLLEAGUES_TAG    (MPC_FIRST_TAG+38)

/* Ravi Reddy (Tue Nov 20 11:51:02 GMT 2007)
 * Mismatch between the environment in the topology file 
 * and the mpi application startup
 */
#define MPC_ERR_TOPO_MISMATCH (MPC_FIRST_TAG+39)

#endif
