# ifndef yympcScan
# define yympcScan

/* $Id: Scanner.h,v 2.6 1992/08/07 15:29:41 grosch rel $ */

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

/* line 2 "mpc.rex" */


/* set of keywords: */


#include "Tree.h"
#include "context.h"
#include "options.h"
#include "mpc_diag.h"
#include "mpc_pass1.h"

#ifdef __WRK

#  include "c2mpC.h"

bool EmptyHeader;
#else
bool EmptyHeader;
#endif

extern int LinesInFile;

/* extern int NativeMode; -- declared in mpc_pass1.h and defined in make_ast.h; */

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; tIdent Ident; } yyIDENTIFIER;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; tIdent Ident; } yyNETorSUBNETname;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; tIdent Ident; } yyTYPEDEFname;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; double FloatConst; } yyFLOATINGconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; int IntConst; } yyINTEGERconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; int OctConst; } yyOCTALconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; int HexConst; } yyHEXconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; int CharConst; } yyCHARACTERconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; tString StrLit; } yySTRINGliteral;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; } yyHEADER;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; } yySOURCE;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; } yyOMP_DECL;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; } yyOMP_STAT;
typedef struct { tPosition yyPos; bool Ignore; } yybench;
typedef struct { tPosition yyPos; bool Ignore; } yycoord;
typedef struct { tPosition yyPos; bool Ignore; } yycoordof;
typedef struct { tPosition yyPos; bool Ignore; } yyfan;
typedef struct { tPosition yyPos; bool Ignore; } yyfast;
typedef struct { tPosition yyPos; bool Ignore; } yyflex;
typedef struct { tPosition yyPos; bool Ignore; } yyhost;
typedef struct { tPosition yyPos; bool Ignore; } yylength;
typedef struct { tPosition yyPos; bool Ignore; } yylink;
typedef struct { tPosition yyPos; bool Ignore; } yymemory;
typedef struct { tPosition yyPos; bool Ignore; } yynet;
typedef struct { tPosition yyPos; bool Ignore; } yynettype;
typedef struct { tPosition yyPos; bool Ignore; } yynode;
typedef struct { tPosition yyPos; bool Ignore; } yyparent;
typedef struct { tPosition yyPos; bool Ignore; } yyrecon;
typedef struct { tPosition yyPos; bool Ignore; } yyrelation;
typedef struct { tPosition yyPos; bool Ignore; } yyrepl;
typedef struct { tPosition yyPos; bool Ignore; } yyscalar;
typedef struct { tPosition yyPos; bool Ignore; } yyslow;
typedef struct { tPosition yyPos; bool Ignore; } yysubnet;
typedef struct { tPosition yyPos; bool Ignore; } yyvector;
typedef struct { tPosition yyPos; bool Ignore; } yypar;
typedef struct { tPosition yyPos; bool Ignore; } yyscheme;
typedef struct { tPosition yyPos; bool Ignore; } yytimeof;

typedef union {
 tPosition Position;
 yyIDENTIFIER IDENTIFIER;
 yyNETorSUBNETname NETorSUBNETname;
 yyTYPEDEFname TYPEDEFname;
 yyFLOATINGconstant FLOATINGconstant;
 yyINTEGERconstant INTEGERconstant;
 yyOCTALconstant OCTALconstant;
 yyHEXconstant HEXconstant;
 yyCHARACTERconstant CHARACTERconstant;
 yySTRINGliteral STRINGliteral;
 yyHEADER HEADER;
 yySOURCE SOURCE;
 yyOMP_DECL OMP_DECL;
 yyOMP_STAT OMP_STAT;
 yybench bench;
 yycoord coord;
 yycoordof coordof;
 yyfan fan;
 yyfast fast;
 yyflex flex;
 yyhost host;
 yylength length;
 yylink link;
 yymemory memory;
 yynet net;
 yynettype nettype;
 yynode node;
 yyparent parent;
 yyrecon recon;
 yyrelation relation;
 yyrepl repl;
 yyscalar scalar;
 yyslow slow;
 yysubnet subnet;
 yyvector vector;
 yypar par;
 yyscheme scheme;
 yytimeof timeof;
} mpcScan_tScanAttribute;

extern void mpcScan_ErrorAttribute ARGS((int Token, mpcScan_tScanAttribute * pAttribute));


 
# define mpcScan_EofToken	0
 
# ifdef lex_interface
#    define mpcScan_GetToken	yylex
#    define mpcScan_TokenLength	yyleng
# endif

extern	char *		mpcScan_TokenPtr	;
extern	short		mpcScan_TokenLength	;
extern	mpcScan_tScanAttribute	mpcScan_Attribute	;
extern	void		(* mpcScan_Exit) ()	;
 
extern	void		mpcScan_BeginScanner	();
extern	void		mpcScan_BeginFile	ARGS ((char * yyFileName));
extern	int		mpcScan_GetToken	();
extern	int		mpcScan_GetWord		ARGS ((char * yyWord));
extern	int		mpcScan_GetLower	ARGS ((char * yyWord));
extern	int		mpcScan_GetUpper	ARGS ((char * yyWord));
extern	void		mpcScan_CloseFile	();
extern	void		mpcScan_CloseScanner	();

# endif
