#include <string.h>
#include "gnu_kw.h"
#include "context.h"
#include "Tree.h"
#include "mpc_diag.h"
#include "options.h"
#include "mpc_pass2.h"
#include "mpcAttr.h"
#include "Errors.h"

int counter=0;
int tree_level=0;
int  i ;
FILE *file;

void SetOMPFile
#if defined __STDC__ | defined __cplusplus
	(FILE * OMP_file)
#else
	(OMP_file)
	FILE * OMP_file;
#endif
{
	file = OMP_file;
}

void WriteOMPTree
#if defined __STDC__ | defined __cplusplus
	(char * str, int node_flag)
#else
	(str, node_flag)
	char * str;
	int node_flag;
#endif
{
	if(SEE_OMP)
	{
		if(node_flag)
  		   for(i=0;i<tree_level;i=i+1)
		   fprintf(file,"   |");
		fprintf(file,str);
	}
} 

int Go_OMP
#if defined __STDC__ | defined __cplusplus
	(tTree Tree)
#else
	(Tree)
	tTree Tree;
#endif
{	
    int RC = 0;
    counter ++;

  if(Tree==NoTree) {
    WriteOMPTree("NoTree\n",0);
    if(SEE_OMP) 
    	return counter;
    	else return RC;
  }
  switch(Tree->Kind) {

    case kMPC_Root:
    /*************/ 
     WriteOMPTree("MPC_Root\n",0);
	WriteOMPTree("-Decls->",1); 
	RC |= Go_OMP(Tree->MPC_Root.Decls);
       tree_level --;
	 break;


    case kMPC_FreeNode:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_FreeNode\n",0);
	 tree_level --; 
	 break;

    case kMPC_UncompDecl:    /***!!!! Must be UncompDecl  !!!!!!*****/
    /*********************/ 
    tree_level ++; 
     WriteOMPTree("MPC_UncompDecl\n",0);
     WriteOMPTree("MPC_UncompDecl = ",0);
     WriteOMPTree(Tree->MPC_UncompDecl.uString,0);
     {
       tString directive=Tree->MPC_UncompDecl.uString;

       if(strncmp(directive,"#pragma",7)) goto DONE; /* not OMP directive at all */

       directive=Tree->MPC_UncompDecl.uString+11;
       while(*directive==' ') directive++;
       if (strncmp(directive,"threadprivate",13))
     	{
     		Make_Message(800, xxError, Tree->MPC_UncompDecl.Pos, Tree);
     		RC = 1;
     	}
     }
     DONE:
     WriteOMPTree("\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_BasicType:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_BasicType\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_EnumType:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_EnumType\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_Typedef:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Typedef\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_ArrayType:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_ArrayType\n",0);
 	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_VectorType:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_VectorType\n",0);
 	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_PointerType:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_PointerType\n",0);
 	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_StructType:
    /*******************/ 
    tree_level ++; 
     WriteOMPTree("MPC_StructType\n",0);
	WriteOMPTree("-Next->",1);
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_UnionType:
    /******************/ 
    tree_level ++; 
     WriteOMPTree("MPC_UnionType\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;
    
    case kMPC_FunctionType:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_FunctionType\n",0);

/*???*/
   	WriteOMPTree("-NetParamType->",1); 
   	RC |= Go_OMP(Tree->MPC_FunctionType.NetParamType);
   	WriteOMPTree("-NetParam->",1); 
   	RC |= Go_OMP(Tree->MPC_FunctionType.NetParam);
/*???*/
    	WriteOMPTree("-ParamList->",1); 
    	RC |= Go_OMP(Tree->MPC_FunctionType.ParamList);    	
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_VarDecl:
    /****************/ 
    tree_level ++; 
    WriteOMPTree("MPC_VarDecl\n",0);
     	WriteOMPTree("-Next->",1);
     	
     	while(Tree->MPC_Decls.Next->Kind == kMPC_VarDecl)
     	       Tree = Tree->MPC_Decls.Next; 
     	       
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_Function:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Function\n",0);
	WriteOMPTree("-Type->",1); 
	RC |= Go_OMP(Tree->MPC_Function.ParamList);
	WriteOMPTree("-Stats->",1); 
	RC |= Go_OMP(Tree->MPC_Function.Stats);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;
  
    case kMPC_Ellipsis:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Ellipsis\n",0);
	 tree_level --; 
	 break;

    case kMPC_NetDecl:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_NetDecl\n",0);
/*???*/
	WriteOMPTree("-NetTypeSpecifier->",1); 
	RC |= Go_OMP(Tree->MPC_NetDecl.NetTypeSpecifier);
	WriteOMPTree("-Net->",1); 
	RC |= Go_OMP(Tree->MPC_NetDecl.Net);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Decls.Next);
	 tree_level --; 
	 break;

    case kMPC_SubnetDecl:
    /*******************/ 
    tree_level ++; 
     WriteOMPTree("MPC_SubnetDecl\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_SubnetDecl.Next);
	 tree_level --; 
	 break;

    case kMPC_RelDecl:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_RelDecl\n",0);
/*???*/
	WriteOMPTree("-Relation->",1); 
	RC |= Go_OMP(Tree->MPC_RelDecl.Relation);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_RelDecl.Next);
	 tree_level --; 
	 break;

    case kMPC_NetType:
    /****************/ 
    tree_level ++; 
    WriteOMPTree("MPC_NetType\n",0);
	  WriteOMPTree("-Next->",1); 
	  RC |= Go_OMP(Tree->MPC_NetType.Next);
	 tree_level --; 
	 break;
	
    case kMPC_NetTypeSpecifier:
    /*************************/ 
    tree_level ++; 
    WriteOMPTree("MPC_NetTypeSpecifier\n",0);
 	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_NetTypeSpecifier.Next);
	 tree_level --; 
	 break;

    case kMPC_TopoFunctions:
    /**********************/ 
    tree_level ++; 
     WriteOMPTree("MPC_TopoFunctions\n",0);
	WriteOMPTree("-Node_Def->",1); 
	RC |= Go_OMP(Tree->MPC_TopoFunctions.Node_Def);
	WriteOMPTree("-Link_Def->",1); 
	RC |= Go_OMP(Tree->MPC_TopoFunctions.Link_Def);
	WriteOMPTree("-Main_Node_Def->",1); 
	RC |= Go_OMP(Tree->MPC_TopoFunctions.Main_Node_Def);
	WriteOMPTree("-Power_Def->",1); 
	RC |= Go_OMP(Tree->MPC_TopoFunctions.Power_Def);
	WriteOMPTree("-Node_Number_Def->",1); 
	RC |= Go_OMP(Tree->MPC_TopoFunctions.Node_Number_Def);
	WriteOMPTree("-Node_Coord_Def->",1); 
	RC |= Go_OMP(Tree->MPC_TopoFunctions.Node_Coord_Def);
#ifdef _3XX
	WriteOMPTree("-Mapping_Def->",1); 
	RC |= Go_OMP(Tree->MPC_TopoFunctions.Mapping_Def);
#endif
	 tree_level --; 
	 break;


    case kMPC_SU_MemberDecl:
    /**********************/ 
    tree_level ++; 
     WriteOMPTree("MPC_SU_MemberDecl\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_SU_MemberDecl.Next);
	 tree_level --; 
	 break;

    case kMPC_SU_Member:
    /******************/ 
    tree_level ++; 
     WriteOMPTree("MPC_SU_Member\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_SU_Member.Next);
	 tree_level --; 
	 break;

    case kMPC_Var:
    /************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Var\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Var.Next);
	 tree_level --; 
	 break;

    case kMPC_Node:
    /*************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Node\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Node.Next);
	 tree_level --; 
	 break;

#ifdef _3XX
    case kMPC_Scheme:
    /***************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Scheme\n",0);
	WriteOMPTree("-Body->",1); 
	RC |= Go_OMP(Tree->MPC_Scheme.Body);
	 tree_level --; 
	 break;
#endif

    case kMPC_NetList:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_NetList\n",0);
/*???*/
	WriteOMPTree("-Net->",1); 
	RC |= Go_OMP(Tree->MPC_NetList.Net);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_NetList.Next);
	 tree_level --; 
	 break;

    case kMPC_Net:
    /************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Net\n",0);
/*???*/
	WriteOMPTree("-NetType->",1); 
	RC |= Go_OMP(Tree->MPC_Net.NetType);
/*???*/
    	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Net.Next);
	 tree_level --; 
	 break;

    case kMPC_Subnet:
    /***************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Subnet\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Subnet.Next);
	 tree_level --; 
	 break;

    case kMPC_Relation:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Relation\n",0);
/*???*/
	WriteOMPTree("-LNet->",1); 
	RC |= Go_OMP(Tree->MPC_Relation.LNet);
	WriteOMPTree("-RNet->",1); 
	RC |= Go_OMP(Tree->MPC_Relation.RNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Relation.Next);
	 tree_level --; 
	 break;

/****************/
    case kMPC_UncompStat:
    {
      tString directive = Tree->MPC_UncompStat.uString+11; /* L. of prefix */
      while(*directive==' ') directive++;
      if (!strncmp(directive,"threadprivate",13))
     	{
     		Make_Message(801, xxError, Tree->MPC_UncompStat.Pos, Tree);
     		RC = 1;
     	}
    }
    tree_level ++; 
     WriteOMPTree("MPC_UncompStat\n",0);
        WriteOMPTree("-ExecNet->",1); 
        RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
        WriteOMPTree("MPC_UncompStat = ",0);
        WriteOMPTree(Tree->MPC_UncompStat.uString,0);
 	if(!strncmp(Tree->MPC_UncompStat.uString,"#pragma omp", 11) &&
           Tree->MPC_Stat.Next->Kind != kMPC_UncompStat)
	  if(!(Tree->MPC_Stat.Next->MPC_Stat.Flag.Asynchr))
		{
		   Make_Message(802, xxError, Tree->MPC_UncompStat.Pos, Tree);		   
		   RC = 1;
	   	}
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;
/********************/

    case kMPC_ExprStat:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_ExprStat\n",0);
        WriteOMPTree("-ExecNet->",1); 
/*???*/
        RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
	WriteOMPTree("-Next->",1); 
/*???*/
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_If:
    /***********/ 
    tree_level ++; 
     WriteOMPTree("MPC_If\n",0);
	WriteOMPTree("-Stats->",1); 
	RC |= Go_OMP(Tree->MPC_If.Stats);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_IfElse:
    /***************/ 
    tree_level ++; 
     WriteOMPTree("MPC_IfElse\n",0);
	WriteOMPTree("-Then->",1); 
	RC |= Go_OMP(Tree->MPC_IfElse.Then);
	WriteOMPTree("-Else->",1); 
	RC |= Go_OMP(Tree->MPC_IfElse.Else);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_Switch:
    /***************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Switch\n",0);
	WriteOMPTree("-Stats->",1); 
	RC |= Go_OMP(Tree->MPC_Switch.Stats);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_While:
    /**************/ 
    tree_level ++; 
     WriteOMPTree("MPC_While\n",0);
	WriteOMPTree("-Expr->",1); 
	WriteOMPTree("-Stats->",1); 
	RC |= Go_OMP(Tree->MPC_While.Stats);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_DoWhile:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_DoWhile\n",0);
	WriteOMPTree("-Stats->",1); 
	RC |= Go_OMP(Tree->MPC_DoWhile.Stats);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_For:
    /************/ 
    tree_level ++; 
     WriteOMPTree("MPC_For\n",0);
	WriteOMPTree("-Stats->",1); 
	RC |= Go_OMP(Tree->MPC_For.Stats);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_Goto:
    /*************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Goto\n",0);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_Continue:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Continue\n",0);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_Break:
    /**************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Break\n",0);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_BreakFan:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_BreakFan\n",0);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_Return:
    /***************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Return\n",0);
	WriteOMPTree("-Expr->",1); 
	RC |= Go_OMP(Tree->MPC_Return.Expr);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_Compound:
    /*****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Compound\n",0);
	WriteOMPTree("-Decls->",1); 
	RC |= Go_OMP(Tree->MPC_Compound.Decls);
	WriteOMPTree("-Stats->",1); 
	RC |= Go_OMP(Tree->MPC_Compound.Stats);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

#ifdef _3XX
    case kMPC_CompScheme:
    /*******************/ 
    tree_level ++; 
     WriteOMPTree("MPC_CompScheme\n",0);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_CommScheme:
    /*******************/ 
    tree_level ++; 
     WriteOMPTree("MPC_CommScheme\n",0);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_ParScheme:
    /******************/ 
    tree_level ++; 
     WriteOMPTree("MPC_ParScheme\n",0);
	WriteOMPTree("-Stats->",1); 
	RC |= Go_OMP(Tree->MPC_ParScheme.Stats);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;
#endif  /* _3XX */

    case kMPC_Fan:
    /************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Fan\n",0);
	WriteOMPTree("-Body->",1); 
	RC |= Go_OMP(Tree->MPC_Fan.Body);
/*???*/
	WriteOMPTree("-ExecNet->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.ExecNet);
/*???*/
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

    case kMPC_IdentLabel:
    /*******************/ 
    tree_level ++; 
     WriteOMPTree("MPC_IdentLabel\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stats.Next);
	 tree_level --; 
	 break;

    case kMPC_CaseLabel:
    /******************/ 
    tree_level ++; 
     WriteOMPTree("MPC_CaseLabel\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stats.Next);
	 tree_level --; 
	 break;

    case kMPC_Default:
    /****************/ 
    tree_level ++; 
     WriteOMPTree("MPC_Default\n",0);
	WriteOMPTree("-Next->",1); 
	RC |= Go_OMP(Tree->MPC_Stat.Next);
	 tree_level --; 
	 break;

  
    default:
    /******/ 
    tree_level ++; 
    WriteOMPTree("DEFAULT\n",0);
	 tree_level --; 
	 break;
  }
 /* end switch(Tree->Kind) */

 if(SEE_OMP) 
    	return counter;
    	else return RC;
}

