#ifndef _OPTIONS
#define _OPTIONS

#ifndef MAX_OPT_LEVEL
#define MAX_OPT_LEVEL   9
#endif


/* Global variables for command-line options & pragma of mpc-compiler: */
/* ==================================================================  */
/* Copyright (c) 1995,1996,1997 Institute for System Programming,      */
/*                              Russian Academy of Sciences.           */
/*            =============== Initial revision, 1995/09/05 ==========  */

#define  K_ANSI   1	/* ANSI C only;                            */
#define  K_SHORT  2	/* ANSI C  +  mpC-'short-formed'-keywords; */
#define  K_LONG   3	/* ANSI C  +  mpC-'long-formed'-keywords;  */
#define  K_ALL    4	/* ANSI C  +  all forms of mpC-keywords;   */

#ifndef __OPTIONS_C

extern  int
							/* -- default values: */
	CBRACKETS,	/* process the input file as C[]-program?     --false */
        MPF_SRC,        /* source file is mpF program?                --false */
	C_2_MPC,	/* work as the converter from C to mpC?       --false */
	DEMO_MODE,	/* forbid invoc. of many lib. functions?      --false */
	VERBOSE,	/* enable verbose mode (print statistics)?    --false */
	SEE_OMP,	/* put AST to ascii file to see OMP directives--false */
	MPCC_DEBUG,	/* enable/disable debugging mode of compiler? --false */
	DUMP,		/* print work data structures of compiler?    --false */
#ifdef MPC_DEBUGGER
	MPC_DBG_TRACE,  /* set _mpC_Dbg_Trace_Internal to TRUE?       --false */
#endif
	STORE_MESSAGES,	/* store error messages or print immediately? --true  */
	EVAL_CONST,	/* evaluate constant expressions or make AST? --false */
	BLOCK_TO_GRID,  /* replace [] with [:]...[:] operators?       --false */
	PUT_TREE,	/* put AST to binary file or keep in memory?  --false */
	GET_TREE,	/* get AST from binary file (disable parser)? --false */
	WRITE_TREE,	/* put AST to ascii file or keep in memory?   --false */
	READ_TREE,	/* get AST from ascii file (disable parser)?  --false */
	KEYWORDS,	/* suitable set of keywords (for scanner)     --SHORT */
	MAX_NET,	/* max. number of net/subnet in program file  -- 64   */
	PRAGMA_BIG,     /* BIG/(SMALL) net create strategy?           --true  */
	xopt,		/* special dbg options                        -- 0    */
	XOPT,		/*              needed by back end            -- 0    */
#ifdef MPC_DEBUGGER
        DBG_CODE,       /* Generate code for debugger?                --false */
#endif
	OPT_LEVEL;	/* Optimization level (-O0..-O<MAX...>)	      -- 0    */
			/*   (0 - no opt., 1-<MAX...> - optimize...)          */
			/*   NOTE:  -O without number means -O2               */

#endif /*__OPTIONS_C*/

#endif

