/* mpC-compiler, pass 2:        GENERATION OF TOPO-FUNCTIONS        */
/* ====================         ============================        */
/*                                                                  */
/* Copyright (c) 1995-1999      Institute for System Programming,   */
/*                              Russian Academy of Sciences.        */
/*         =============== Initial revision, 1999/06/09 ==========  */

#ifndef _TOPO_FUN
#define _TOPO_FUN

#ifndef ARGS
#if defined __STDC__ | defined __cplusplus
#define ARGS(parameters)	parameters
#else
#define ARGS(parameters)	()
#endif
#endif

#include "context.h"
#include "Tree.h"



#define NODE_FUNC	1
#define LINK_FUNC	2
#define PARENT_FUNC	3
#define POWER_FUNC	4
#define NUMBER_FUNC	5
#define COORD_FUNC	6
#define MAPPING_FUNC	7


void  Emit_TopoTypes	();
tTree Emit_Header	ARGS((int func));
tTree Emit_Node		ARGS((tTree NetType));
tTree Emit_Link		ARGS((tTree NetType));
tTree Emit_Parent	ARGS((tTree NetType));
tTree Emit_Power	ARGS((tTree NetType));
tTree Emit_Number	ARGS((tTree NetType));
tTree Emit_Coord	ARGS((tTree NetType));

#ifdef _3XX
tTree Emit_Mapping	ARGS((tTree NetType));
#endif

#endif
