# ifndef yympC_C
# define yympC_C

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

typedef struct { unsigned short Line, Column; } tPosition_eq;
/* Tree of run time types (tMPC_Type): */
#include "mpCtree.h"
//#include "mpCinternal.h"
typedef MPC_Net* pMPC_Net;
typedef void* pvoid;
typedef struct {
  void * addr;
  MPC_Dt type;
} MPC_VarTable;



# ifndef bool
# define bool char
# endif
# define NompC_C (tmpC_C) 0L
# define kmpC_C_Node 1
# define kC_SimpleIdent 2
# define kC_Typedef 3
# define kC_Var 4
# define kC_LocalVar 5
# define kC_GlobalVar 6
# define kC_EnumConst 7
# define kC_NetOrSubnet 8
# define kC_LocalNet 9
# define kC_GlobalNet 10
# define kC_Function 11
# define kC_NetType 12
# define kC_Coord 13
# define kC_Compound 14

typedef unsigned char mpC_C_tKind;
typedef unsigned short mpC_C_tMark;
typedef unsigned short mpC_C_tLabel;
typedef union u_mpC_C_Node * tmpC_C;
typedef void (* mpC_C_tProcTree) ARGS((tmpC_C));

# ifndef mpC_C_NodeHead
# define mpC_C_NodeHead
# endif
typedef struct { mpC_C_tKind yyKind; mpC_C_tMark yyMark; mpC_C_NodeHead } mpC_C_tNodeHead;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; } ympC_C_Node;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; } yC_SimpleIdent;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; } yC_Typedef;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; bool Const; bool Repl; tmpC_C Distribution; char* Predicate; } yC_Var;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; bool Const; bool Repl; tmpC_C Distribution; char* Predicate; int Aindex; tMPC_Type Type;} yC_LocalVar;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; bool Const; bool Repl; tmpC_C Distribution; char* Predicate; tMPC_Type Type;  pvoid Address;} yC_GlobalVar;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; int Value; } yC_EnumConst;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; tmpC_C Type; } yC_NetOrSubnet;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; tmpC_C Type; int Aindex; } yC_LocalNet;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; tmpC_C Type; pMPC_Net Descr; } yC_GlobalNet;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; } yC_Function;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; char* Name; int Dimension; tmpC_C Coords; } yC_NetType;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; char* Name; tmpC_C Next; } yC_Coord;
typedef struct { mpC_C_tNodeHead yyHead; tPosition_eq Pos; tmpC_C Prev; } yC_Compound;

union u_mpC_C_Node {
 mpC_C_tKind Kind;
 mpC_C_tNodeHead yyHead;
 ympC_C_Node mpC_C_Node;
 yC_SimpleIdent C_SimpleIdent;
 yC_Typedef C_Typedef;
 yC_Var C_Var;
 yC_LocalVar C_LocalVar;
 yC_GlobalVar C_GlobalVar;
 yC_EnumConst C_EnumConst;
 yC_NetOrSubnet C_NetOrSubnet;
 yC_LocalNet C_LocalNet;
 yC_GlobalNet C_GlobalNet;
 yC_Function C_Function;
 yC_NetType C_NetType;
 yC_Coord C_Coord;
 yC_Compound C_Compound;
};

extern tmpC_C mpC_CRoot;
extern unsigned long mpC_C_HeapUsed;
extern char * mpC_C_PoolFreePtr, * mpC_C_PoolMaxPtr;
extern unsigned short mpC_C_NodeSize [12 + 1];
extern char * mpC_C_NodeName [12 + 1];

extern void (* mpC_C_Exit) ();
extern tmpC_C mpC_C_Alloc ();
extern tmpC_C MakempC_C ARGS((mpC_C_tKind yyKind));
extern bool mpC_C_IsType ARGS((register tmpC_C yyt, register mpC_C_tKind yyKind));

//extern void WritempC_CNode ARGS((FILE * yyyf, tmpC_C yyt));
extern void QuerympC_C ARGS((tmpC_C yyt));
extern void BeginmpC_C ();
extern void ClosempC_C ();

typedef struct MPC_Frame tMPC_Frame;
struct MPC_Frame {
  void *FunName;
  void *FileName;
  tPosition_eq CallPoint;
  MPC_VarTable *CallContext;
  tmpC_C LastNode;
  tMPC_Frame *Next;
  tMPC_Frame *Prev; 
}; 

typedef struct {
  tmpC_C Context;
  unsigned short BegLine,EndLine;
} tStatList;

extern void** MPC_Debug_file_tab[];

void MPC_Debug_manager();
int MPC_Agent(int a,int b,tmpC_C CallContext);
void MPC_Debug_frame_init(tMPC_Frame *MPC_Debug_frame);
void MPC_Debug_frame_delete();
tmpC_C MPC_Debug_context_init(tmpC_C MPC_Debug_context, 
			      tmpC_C MPC_Debug_enclosed_context);
void MPC_Debug_red(int action);
void MPC_Debug_net_create_init(MPC_Net* net, MPC_Name id);
void MPC_Debug_waiting_for_free(MPC_Net *net);
void MPC_Debug_net_free(MPC_Net* net);
void MPC_Debug_net_create(MPC_Net* net, MPC_Name id);
void MPC_Debug_white(int begin,int line);
void MPC_Debug_global_barrier();
void MPC_Debug_send_end();
void MPC_Debug_recv_end(int count);
void MPC_Debug_subnet_create(MPC_Net* subnet, int is_flexible);

# endif
