#include <mpCinternal.h>
#include <topo.h>
#include <mpi.h>

int main
(
    int argc,
    char **argv
)
{
    MPC_Init(
        &argc,
        &argv,
        MPC_The_init_strategy,
        MPC_Trivial_error_print,
        MPC_The_get_env,
        MPC_The_strategy,
        MPC_The_topology_data,
        MPC_The_processors_info
    );

    {
       int num_of_processes;
       double *gperf;

       MPI_Comm_size(MPI_COMM_WORLD, &num_of_processes);

       gperf = (double*)malloc(
                        sizeof(double)
                        *
                        num_of_processes
       );

       MPC_Processes_static_info(
          gperf
       );

       if (MPC_Is_host())
       {
          int i;

          printf("Number of processes is = %d\n", num_of_processes);

          printf("Processes performances are\n");

          for (i = 0; i < num_of_processes; i++)
          {
              printf("%0.1f ", gperf[i]);
          }

          printf("\n");
       }

       free(gperf);
    }

    MPC_Exit(0);
}
