#include <mpCinternal.h>
#include <topo.h>

int main
(
    int argc,
    char **argv
)
{
    MPC_Init(
        &argc,
        &argv,
        MPC_The_init_strategy,
        MPC_Trivial_error_print,
        MPC_The_get_env,
        MPC_The_strategy,
        MPC_The_topology_data,
        MPC_The_processors_info
    );

    {
       int num_of_processors = MPC_Get_number_of_processors();
       double* gperf = (double*)malloc(
                                sizeof(double)
                                *
                                num_of_processors
       );

       MPC_Get_processors_info(
          NULL,
          gperf
       );

       if (MPC_Is_host())
       {
          int i;

          printf("Number of processors is = %d\n", num_of_processors);

          printf("Processor performances are\n");

          for (i = 0; i < num_of_processors; i++)
          {
              printf("%0.1f ", gperf[i]);
          }

          printf("\n");
       }

       free(gperf);
    }

    MPC_Exit(0);
}
