#include <mpCinternal.h>
#include <topo.h>

int product()
{
    int i, j, k, n = 100;
    double *a, *b, *c;

    a = (double*)malloc(
                 sizeof(double)
                 *
                 (n*n)
    );

    b = (double*)malloc(
                 sizeof(double)
                 *
                 (n*n)
    );

    c = (double*)malloc(
                 sizeof(double)
                 *
                 (n*n)
    );

    for (i = 0; i < n; i++)
    {
        for (j = 0; j < n; j++)
        {
            for (k = 0; k < n; k++)
            {
                c[i*n + j] += a[i*n + k] * b[k*n + j];
            }
        }
    }

    free(a);
    free(b);
    free(c);

    return 0;
}


int main
(
    int argc,
    char **argv
)
{
    int num_of_processors;

    MPC_Init(
        &argc,
        &argv,
        MPC_The_init_strategy,
        MPC_Trivial_error_print,
        MPC_The_get_env,
        MPC_The_strategy,
        MPC_The_topology_data,
        MPC_The_processors_info
    );


    if (MPC_Is_member(&MPC_Net_recon))
    {
       double bench_time = MPI_Wtime();

       product();

       bench_time = MPI_Wtime() - bench_time;

       MPC_Update_Processors_info(
          bench_time
       );
    }

    MPC_Exit(0);
}
