
    #include <math.h>
    #include <stdio.h>
    #include <stdlib.h>

    #include "mxm_i.h"

    /*----------------------------------------------------------------------------*/

    void rank2coord
    (
       int pnum,
       const int *ppar,
       int *pcoord
    )
    {
       int tmp;
       tmp =  * (ppar + 1);
        * pcoord = pnum / tmp;
       pnum = pnum % tmp;
        * (pcoord + 1) = pnum;
    }

    /*----------------------------------------------------------------------------*/

    int InitializeMatrices
    (
        int m,
        int n,
        int k,
        double *a,
        double *b,
        double *c
    )
    {
        int i;

        for (i = 0; i < (m*k); i++)
        {
            a[i] = MXM_CONSTANT_NUMBER1;
        }

        for (i = 0; i < (k*n); i++)
        {
            b[i] = MXM_CONSTANT_NUMBER2;
        }

        for (i = 0; i < (m*n); i++)
        {
            c[i] = 0.0;
        }

        return HMPI_OK;
    }

    /*----------------------------------------------------------------------------*/

    int Print_rectangle_2d_local_stdin(
        int p,
        int q,
        int m,
        int n,
        const int *w,
        const int *h
    )
    {
       int i, j, k, l;

       printf("The widths of rectangles are:\n");

       /*
       * COLUMN BASED; HENCE ONLY widths of first row are enough
       */
       {
           for (j = 0; j < q; j++)
           {
               printf("%d ", w[HMPI_RECT_INDEX(0, j, 0, j, p, q)]);
           }
           printf("\n");
       }

       printf("\n");

       printf("The heights of rectangles are:\n");

       for (i = 0; i < p; i++)
       {
           for (j = 0; j < q; j++)
           {
               for (k = 0; k < p; k++)
               {
                   for (l = 0; l < q; l++)
                   {
                      printf("%d ", h[HMPI_RECT_INDEX(i, j, k, l, p, q)]);
                   }
               }
               printf("\n");
           }
       }

       printf("\n");

       return 0;
    }

    /*----------------------------------------------------------------------------*/

    int Print_rectangle_2d_local(
        int p,
        int q,
        int m,
        int n,
        const int *w,
        const int *h
    )
    {
       int i, j, k, l;

       fprintf(dofp, "The widths of rectangles are:\n");

       /*
       * COLUMN BASED; HENCE ONLY widths of first row are enough
       */
       {
           for (j = 0; j < q; j++)
           {
               fprintf(dofp, "%d ", w[HMPI_RECT_INDEX(0, j, 0, j, p, q)]);
           }
           fprintf(dofp, "\n");
       }

       fprintf(dofp, "\n");

       fprintf(dofp, "The heights of rectangles are:\n");

       for (i = 0; i < p; i++)
       {
           for (j = 0; j < q; j++)
           {
               for (k = 0; k < p; k++)
               {
                   for (l = 0; l < q; l++)
                   {
                      fprintf(dofp, "%d ", h[HMPI_RECT_INDEX(i, j, k, l, p, q)]);
                   }
               }
               fprintf(dofp, "\n");
           }
       }

       fprintf(dofp, "\n");

       return 0;
    }

    /*----------------------------------------------------------------------------*/

