
   #ifndef _CHOLESKY_DATA_HH
   #define _CHOLESKY_DATA_HH

   /*
    * Number of data points for the 
    * speed function
    */
   #define  NSTEPS    17

   /*
    * Processor speed graphs for the machines
    * used for the experiments
    */
   typedef struct HMPI_Speed_mem{
       int n;
       double speed;
   } HMPI_SM;

   /*
    * Add the speed functions 
    * here from the include files
    * generated
    */

   void Fill_input_parameters(
       int p,
       int steps,
       double *speeds,
       int *mlimits
   );

   void Display_input_parameters(
       int p,
       int steps,
       double *speeds,
       int *mlimits
   );

   #endif
