
#ifndef __HSCAL_CB_CAXPY_HSCALFUNC_HH
#define __HSCAL_CB_CAXPY_HSCALFUNC_HH

#include "../../../include/hscalapack.h"

int hscal_caxpy(
    int *n,
    char *cca,
    int *incx,
    int *incy,
    double *tcomp
)
{
    hscalcomplex *ca;
    float r__1, r__2;

    *tcomp = 0.;

    if (*n <= 0) {
	return HSCAL_SUCCESS;
    }

    ca = (hscalcomplex*)cca;

    if ((r__1 = ca->r, dabs(r__1)) + (r__2 = hscal_r_imag(ca), dabs(r__2)) == 0.f) {
	return HSCAL_SUCCESS;
    }

    if (*incx == 1 && *incy == 1) {
       *tcomp += (*n * 10);
       return HSCAL_SUCCESS;
    }

    *tcomp += (*n * 12);

    return HSCAL_SUCCESS;
}

#endif

