
#ifndef __HSCAL_CB_CGERU_HH
#define __HSCAL_CB_CGERU_HH



#include "../../../include/hscalapack.h"

int hscal_cgeru(
    int *m, 
    int *n, 
    char *calpha,
    int *incx, 
    int *incy,
    int *lda, 
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4, i__5;
    int info;
    hscalcomplex temp;
    int i__, j, ix, jy, kx;
    hscalcomplex *alpha = (hscalcomplex*)calpha;
    hscaldoublereal tm, tn;

    info = 0;
    *tcomp = 0.;

    if (*m < 0) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*incy == 0) {
	info = 7;
    } else if (*lda < max(1,*m)) {
	info = 9;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }
    if (*m == 0 || *n == 0 || alpha->r == 0.f && alpha->i == 0.f) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (*incx == 1) {
       *tcomp += tn * (tm*14 + 9);
    } else {
       *tcomp += tn * (tm*15 + 9);
    }
    return HSCAL_SUCCESS;
}

#endif
