
#ifndef __HSCAL_CB_CHER_HH
#define __HSCAL_CB_CHER_HH



#include "../../../include/hscalapack.h"

int hscal_cher(
    char *uplo,
    int  *n, 
    char *calpha,
    int  *incx, 
    int  *lda, 
    double  *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4, i__5;
    int info;
    int i__, j;
    hscalreal* alpha = (hscalreal*)calpha;
    hscaldoublereal tn;

    info   = 0;
    *tcomp = 0.;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*lda < max(1,*n)) {
	info = 7;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }
    if (*n == 0 || *alpha == 0.f) {
	return HSCAL_SUCCESS;
    }

    tn = (double)(*n);

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1) {
            *tcomp += 20*tn + 14*(((tn-1)*tn)/2);
	} else {
            *tcomp += 21*tn + 15*(((tn-1)*tn)/2);
	}
    } else {
	if (*incx == 1) {
            *tcomp += 20*tn + 14*(((tn-1)*tn)/2);
	} else {
            *tcomp += 21*tn + 15*(((tn-1)*tn)/2);
	}
    }
    return HSCAL_SUCCESS;
}

#endif
