
#ifndef __HSCAL_CB_CTRMM_HH
#define __HSCAL_CB_CTRMM_HH



#include "../../../include/hscalapack.h"

int hscal_ctrmm(
    char   *side, 
    char   *uplo, 
    char   *transa, 
    char   *diag,
    int    *m, 
    int    *n, 
    char   *calpha, 
    int    *lda,
    int    *ldb,
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4, i__5, 
	    i__6;
    int info;
    int i__, j, k;
    hscallogical lside;
    int nrowa;
    hscallogical upper;
    hscallogical noconj, nounit;
    hscaldoublereal tm, tn;

    hscalcomplex *alpha = (hscalcomplex*)calpha;

    *tcomp = 0.;

    lside = hscal_lsame(side, "L");
    if (lside) {
	nrowa = *m;
    } else {
	nrowa = *n;
    }
    noconj = hscal_lsame(transa, "T");
    nounit = hscal_lsame(diag, "N");
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! lside && ! hscal_lsame(side, "R")) {
	info = 1;
    } else if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 2;
    } else if (! hscal_lsame(transa, "N") && ! hscal_lsame(transa,
	     "T") && ! hscal_lsame(transa, "C")) {
	info = 3;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, 
	    "N")) {
	info = 4;
    } else if (*m < 0) {
	info = 5;
    } else if (*n < 0) {
	info = 6;
    } else if (*lda < max(1,nrowa)) {
	info = 9;
    } else if (*ldb < max(1,*m)) {
	info = 11;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (alpha->r == 0.f && alpha->i == 0.f) {
       *tcomp += tn*tm*4;
       return HSCAL_SUCCESS;
    }

    if (lside) {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
                *tcomp += 14*tn*tm + 16*tn*(((tm-1)*tm)/2);
                if (nounit) {
                   *tcomp += 10*tn*tm;
                }   
	    } else {
                *tcomp += 14*tn*tm + 16*tn*(((tm-1)*tm)/2);
                if (nounit) {
                   *tcomp += 14*tn*tm;
                }
	    }
	} else {
	    if (upper) {
                *tcomp += tn*tm*14;
                if (noconj) {
                   if (nounit) {
                      *tcomp += tn*tm*10;
                   }
                   *tcomp += tn*(((tm-1)*tm)/2)*14;
                } else {
                   if (nounit) {
                      *tcomp += tn*tm*13;
                   }
                   *tcomp += tn*(((tm-1)*tm)/2)*17;
                }
	    } else {
                *tcomp += tn*tm*14;
                if (noconj) {
                   if (nounit) {
                      *tcomp += tn*tm*10;
                   }
                   *tcomp += tn*(((tm-1)*tm)/2)*14;
                } else {
                   if (nounit) {
                      *tcomp += tn*tm*13;
                   }
                   *tcomp += tn*(((tm-1)*tm)/2)*17;
                }
	    }
	}
    } else {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
                *tcomp += 2*tn;
                if (nounit) {
                   *tcomp += 10*tn;
                }
                *tcomp += tm*12*tn + (((tn-1)*tn)/2)*(tm*16 + 10);
	    } else {
                *tcomp += 2*tn;
                if (nounit) {
                   *tcomp += 10*tn;
                }
                *tcomp += tm*12*tn + (((tn-1)*tn)/2)*(tm*16 + 10);
	    }
	} else {
	    if (upper) {
                if (noconj) {
                   *tcomp += 10*(((tn-1)*tn)/2);
                } else {
                   *tcomp += 13*(((tn-1)*tn)/2);
                }
                *tcomp += tm*16*(((tn-1)*tn)/2) + 2*tn;
                if (nounit) {
                   if (noconj) {
                      *tcomp += 10*tn;
                   } else {
                      *tcomp += 13*tn;
                   }
                }
                *tcomp += tm*12*tn;
	    } else {
                if (noconj) {
                   *tcomp += 10*(((tn-1)*tn)/2);
                } else {
                   *tcomp += 13*(((tn-1)*tn)/2);
                }
                *tcomp += tm*16*(((tn-1)*tn)/2) + 2*tn;
                if (nounit) {
                   if (noconj) {
                      *tcomp += 10*tn;
                   } else {
                      *tcomp += 13*tn;
                   }
                }
                *tcomp += tm*12*tn;
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif
