
#ifndef __HSCAL_CB_CTRMV_HH
#define __HSCAL_CB_CTRMV_HH



#include "../../../include/hscalapack.h"

int hscal_ctrmv(
    char *uplo, 
    char *trans, 
    char *diag, 
    int *n, 
    int *lda, 
    int *incx,
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4, i__5;
    int info;
    int i__, j;
    hscallogical noconj, nounit;
    hscaldoublereal tn;

    *tcomp = 0.;

    info = 0;
    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (! hscal_lsame(trans, "N") && ! hscal_lsame(trans, 
	    "T") && ! hscal_lsame(trans, "C")) {
	info = 2;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, 
	    "N")) {
	info = 3;
    } else if (*n < 0) {
	info = 4;
    } else if (*lda < max(1,*n)) {
	info = 6;
    } else if (*incx == 0) {
	info = 8;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0) {
	return HSCAL_SUCCESS;
    }

    tn = (double)(*n);

    noconj = hscal_lsame(trans, "T");
    nounit = hscal_lsame(diag, "N");
    if (hscal_lsame(trans, "N")) {
	if (hscal_lsame(uplo, "U")) {
	    if (*incx == 1) {
                *tcomp += 2*tn + 12*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 10*tn;
                }
	    } else {
                *tcomp += 3*tn + 13*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 10*tn;
                }
	    }
	} else {
	    if (*incx == 1) {
                *tcomp += 2*tn + 12*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 10*tn;
                }
	    } else {
                *tcomp += 3*tn + 13*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 10*tn;
                }
	    }
	}
    } else {
	if (hscal_lsame(uplo, "U")) {
	    if (*incx == 1) {
                *tcomp += 4*tn;
                if (noconj) {
                   if (nounit) {
                      *tcomp += 10*tn;
                   }
                   *tcomp += 12*(((tn-1)*tn)/2);
                } else {
                   if (nounit) {
                      *tcomp += 11*tn;
                   }
                   *tcomp += 13*(((tn-1)*tn)/2);
                }
	    } else {
                *tcomp += 5*tn;               
                if (noconj) {
                   if (nounit) {
                      *tcomp += 10*tn;
                   }
                   *tcomp += 13*(((tn-1)*tn)/2);
                } else {
                   if (nounit) {
                      *tcomp += 11*tn;
                   }
                   *tcomp += 14*(((tn-1)*tn)/2);
                }
	    }
	} else {
	    if (*incx == 1) {
                *tcomp += 4*tn;
                if (noconj) {
                   if (nounit) {
                      *tcomp += 10*tn;
                   }
                   *tcomp += 12*(((tn-1)*tn)/2);
                } else {
                   if (nounit) {
                      *tcomp += 11*tn;
                   }
                   *tcomp += 13*(((tn-1)*tn)/2);
                }
	    } else {
                *tcomp += 5*tn;
                if (noconj) {
                   if (nounit) {
                      *tcomp += 10*tn;
                   }
                   *tcomp += 13*(((tn-1)*tn)/2);
                } else {
                   if (nounit) {
                      *tcomp += 14*tn;
                   }
                   *tcomp += 14*(((tn-1)*tn)/2);
                }
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
