
#ifndef __HSCAL_CB_DAGEMV_HH
#define __HSCAL_CB_DAGEMV_HH



#include "../../../include/hscalapack.h"

int hscal_dagemv(
    char *trans, 
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    int *incx, 
    char *cbeta, 
    int *incy,
    double *tcomp
)
{
    double *alpha, *beta;

    int a_dim1, a_offset, i__1, i__2;
    hscaldoublereal d__1;
    int i__, j, ix, iy, jx, jy, kx, ky, info;
    hscaldoublereal absx, temp;
    int lenx, leny;
    hscaldoublereal tm, tn;

    *tcomp = 0.;

    alpha = (double*)calpha;
    beta = (double*)cbeta;

    info = 0;

    if (! hscal_lsame(trans, "N") && ! hscal_lsame(trans, "T") && ! hscal_lsame(trans, "C")
	    ) {
	info = 1;
    } else if (*m < 0) {
	info = 2;
    } else if (*n < 0) {
	info = 3;
    } else if (*lda < max(1,*m)) {
	info = 6;
    } else if (*incx == 0) {
	info = 8;
    } else if (*incy == 0) {
	info = 11;
    }

    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*m == 0 || *n == 0 || *alpha == 0. && *beta == 1.) {
        return HSCAL_SUCCESS;
    }

    if (hscal_lsame(trans, "N")) {
        lenx = *n;
        leny = *m;
    } else {
        lenx = *m;
        leny = *n;
    }

    if (*incy == 1) {
        if (*beta == 0.) {
            *tcomp += leny;
        } else if (*beta == 1.) {
            *tcomp += leny;
        } else {
            *tcomp += leny;
        }
    } else {
        if (*beta == 0.) {
           *tcomp += 2*leny;
        } else if (*beta == 1.) {
           *tcomp += 2*leny;
        } else {
           *tcomp += 2*leny;
        }
    }

    if (*alpha == 0.) {
        return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (hscal_lsame(trans, "N")) {
        if (*incy == 1) {
           *tcomp += (tm*2 + 1) * tn;
        } else {
           *tcomp += (tm*2 + 1) * tn;
        }
    } else {
        if (*incx == 1) {
           *tcomp += (tm*2 + 3) * tn;
        } else {
           *tcomp += (tm*2 + 3) * tn;
        }
    }


    return HSCAL_SUCCESS;
}

#endif

