
#ifndef __HSCAL_CB_DAXPY_HSCALFUNC_HH
#define __HSCAL_CB_DAXPY_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_daxpy(
    int *n,
    char *cda,
    int *incx,
    int *incy,
    double *tcomp
)
{
    int m;
    double *da;

    *tcomp = 0.;

    if (*n <= 0) {
        return HSCAL_SUCCESS;
    }

    da = (double*)cda;

    if (*da == 0.) {
       return HSCAL_SUCCESS;
    }

    if (*incx == 1 && *incy == 1) {
       m = *n % 4;

       if (m == 0) {
          *tcomp += iceil((*n - m), 4)*8;
          return HSCAL_SUCCESS;
       }

       *tcomp += (m * 2);

       if (*n < 4) {
	  return HSCAL_SUCCESS;
       }

       *tcomp += iceil((*n - m), 4)*8;

       return HSCAL_SUCCESS;
    }

    *tcomp += (*n * 4);

    return HSCAL_SUCCESS;
}

#endif

