
#ifndef __HSCAL_CB_DGER_HH
#define __HSCAL_CB_DGER_HH



#include "../../../include/hscalapack.h"

int hscal_dger(
    int *m, 
    int *n, 
    char *calpha,
    int *incx, 
    int *incy,
    int *lda, 
    double *tcomp
)
{
    int info;
    hscaldoublereal *alpha = (hscaldoublereal*)calpha;
    hscaldoublereal tm, tn;

    info   = 0;
    *tcomp = 0.;

    if (*m < 0) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*incy == 0) {
	info = 7;
    } else if (*lda < max(1,*m)) {
	info = 9;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }
    if (*m == 0 || *n == 0 || *alpha == 0.) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (*incx == 1) {
       *tcomp += tn * (tm*4 + 2);
    } else {
       *tcomp += tn * (tm*5 + 2);
    }

    return HSCAL_SUCCESS;
}

#endif
