
#ifndef __HSCAL_CB_DSYR_HH
#define __HSCAL_CB_DSYR_HH



#include "../../../include/hscalapack.h"

int hscal_dsyr(
    char   *uplo, 
    int    *n, 
    char   *calpha, 
    int    *incx,
    int    *lda, 
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2;
    int info;
    int i__, j;
    hscaldoublereal *alpha = (hscaldoublereal*)calpha;
    hscaldoublereal tn;

    info    = 0;
    *tcomp = 0.;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*lda < max(1,*n)) {
	info = 7;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || *alpha == 0.) {
	return HSCAL_SUCCESS;
    }

    tn = (double)(*n);

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1) {
            *tcomp += tn + (((tn+1)*tn)/2)*4;
	} else {
            *tcomp += 2*tn + (((tn+1)*tn)/2)*5;
	}
    } else {
	if (*incx == 1) {
            *tcomp += tn + (((tn+1)*tn)/2)*4;
	} else {
            *tcomp += 2*tn + (((tn+1)*tn)/2)*5;
	}
    }

    return HSCAL_SUCCESS;
}

#endif
