
#ifndef __HSCAL_CB_DSYR2K_HH
#define __HSCAL_CB_DSYR2K_HH



#include "../../../include/hscalapack.h"

int hscal_dsyr2k(
    char   *uplo, 
    char   *trans, 
    int    *n, 
    int    *k, 
    char   *calpha, 
    int    *lda,
    int    *ldb,
    char   *cbeta,
    int    *ldc, 
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, c_dim1, c_offset, i__1, i__2, 
	    i__3;
    int info;
    int i__, j, l;
    int nrowa;
    hscallogical upper;

    hscaldoublereal *alpha = (hscaldoublereal*)calpha;
    hscaldoublereal *beta  = (hscaldoublereal*)cbeta;
    hscaldoublereal tn, tk;

    *tcomp = 0.;

    if (hscal_lsame(trans, "N")) {
	nrowa = *n;
    } else {
	nrowa = *k;
    }
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (! hscal_lsame(trans, "N") && ! hscal_lsame(trans, 
	    "T") && ! hscal_lsame(trans, "C")) {
	info = 2;
    } else if (*n < 0) {
	info = 3;
    } else if (*k < 0) {
	info = 4;
    } else if (*lda < max(1,nrowa)) {
	info = 7;
    } else if (*ldb < max(1,nrowa)) {
	info = 9;
    } else if (*ldc < max(1,*n)) {
	info = 12;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || (*alpha == 0. || *k == 0) && *beta == 1.) {
	return HSCAL_SUCCESS;
    }

    tn = (double)(*n);
    tk = (double)(*k);

    if (*alpha == 0.) {
	if (upper) {
	    if (*beta == 0.) {
                *tcomp += (((tn+1)*tn)/2)*2;
	    } else {
                *tcomp += (((tn+1)*tn)/2)*3;
	    }
	} else {
	    if (*beta == 0.) {
                *tcomp += (((tn+1)*tn)/2)*2;
	    } else {
                *tcomp += (((tn+1)*tn)/2)*3;
	    }
	}
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(trans, "N")) {
	if (upper) {
           if (*beta == 0.) {
              *tcomp += (((tn+1)*tn)/2)*2;
           } else if (*beta != 1.) {
              *tcomp += (((tn+1)*tn)/2)*3;
           }
           *tcomp += tk*(6*tn + (((tn+1)*tn)/2) * 9);
	} else {
           if (*beta == 0.) {
              *tcomp += (((tn+1)*tn)/2)*2;
           } else if (*beta != 1.) {
              *tcomp += (((tn+1)*tn)/2)*3;
           }
           

	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		if (*beta == 0.) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 2;
		    }
		} else if (*beta != 1.) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 3;
		    }
		}
                *tcomp += tk*(6*tn + (((tn+1)*tn)/2) * 9);
	    }
	}
    } else {
	if (upper) {
            *tcomp += tk*12*(((tn+1)*tn)/2);
            if (*beta == 0.) {
               *tcomp += 5*(((tn+1)*tn)/2);
            } else {
               *tcomp += 7*(((tn+1)*tn)/2);
            }
	} else {
            *tcomp += tk*12*(((tn+1)*tn)/2);
            if (*beta == 0.) {
               *tcomp += 5*(((tn+1)*tn)/2);
            } else {
               *tcomp += 7*(((tn+1)*tn)/2);
            }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
