
#ifndef __HSCAL_CB_DTRMM_HH
#define __HSCAL_CB_DTRMM_HH



#include "../../../include/hscalapack.h"

int hscal_dtrmm(
    char   *side, 
    char   *uplo, 
    char   *transa, 
    char   *diag,
    int    *m, 
    int    *n, 
    char   *calpha, 
    int    *lda,
    int    *ldb,
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3;
    int info;
    int i__, j, k;
    hscallogical lside;
    int nrowa;
    hscallogical upper;
    hscallogical nounit;
    hscaldoublereal tm, tn;

    hscaldoublereal *alpha = (hscaldoublereal*)calpha;

    *tcomp = 0.;

    lside = hscal_lsame(side, "L");
    if (lside) {
	nrowa = *m;
    } else {
	nrowa = *n;
    }
    nounit = hscal_lsame(diag, "N");
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! lside && ! hscal_lsame(side, "R")) {
	info = 1;
    } else if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 2;
    } else if (! hscal_lsame(transa, "N") && ! hscal_lsame(transa,
	     "T") && ! hscal_lsame(transa, "C")) {
	info = 3;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, 
	    "N")) {
	info = 4;
    } else if (*m < 0) {
	info = 5;
    } else if (*n < 0) {
	info = 6;
    } else if (*lda < max(1,nrowa)) {
	info = 9;
    } else if (*ldb < max(1,*m)) {
	info = 11;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0) {
	return HSCAL_SUCCESS;
    }

    if (*alpha == 0.) {
       *tcomp += (*n)*(*m)*2;
       return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (lside) {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
                *tcomp += 5*tn*tm + 6*tn*(((tm-1)*tm)/2);
                if (nounit) {
                   *tcomp += 3*tn*tm;
                }
	    } else {
                *tcomp += 5*tn*tm+6*tn*(((tm-1)*tm)/2);
                if (nounit) {
                   *tcomp += 5*tn*tm;
                }
	    }
	} else {
	    if (upper) {
                *tcomp += 5*tn*tm+6*tn*(((tm-1)*tm)/2);
                if (nounit) {
                   *tcomp += 3*tn*tm;
                }
	    } else {
                *tcomp += 5*tn*tm+6*tn*(((tm-1)*tm)/2);
                if (nounit) {
                   *tcomp += 3*tn*tm;
                }
	    }
	}
    } else {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
                *tcomp += tn + tn*tm*3;
                if (nounit) {
                   *tcomp += 3*tn;
                }
                *tcomp += (tm*6+3)*(((tn-1)*tn)/2);
	    } else {
                *tcomp += tn + tn*tm*3;
                if (nounit) {
                   *tcomp += 3*tn;
                }
                *tcomp += (tm*6+3)*(((tn-1)*tn)/2);
	    }
	} else {
	    if (upper) {
                *tcomp += (tm*6+3)*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
                *tcomp += tn + tn*tm*3;                                
	    } else {
                *tcomp += (tm*6+3)*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
                *tcomp += tn + tn*tm*3;
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
