
#ifndef __HSCAL_CB_DTRSM_HH
#define __HSCAL_CB_DTRSM_HH



#include "../../../include/hscalapack.h"

int hscal_dtrsm(
    char *side, 
    char *uplo, 
    char *transa, 
    char *diag, 
    int *m, 
    int *n, 
    char *alphac,
    int *lda, 
    int *ldb,
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3;
    int info;
    int i__, j, k;
    hscallogical lside;
    int nrowa;
    hscallogical upper;
    hscallogical nounit;
    hscaldoublereal *alpha = (hscaldoublereal*)alphac;
    hscaldoublereal tm, tn;

    *tcomp = 0.;

    lside = hscal_lsame(side, "L");
    if (lside) {
	nrowa = *m;
    } else {
	nrowa = *n;
    }
    nounit = hscal_lsame(diag, "N");
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! lside && ! hscal_lsame(side, "R")) {
	info = 1;
    } else if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 2;
    } else if (! hscal_lsame(transa, "N") && ! hscal_lsame(transa,
	     "T") && ! hscal_lsame(transa, "C")) {
	info = 3;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, 
	    "N")) {
	info = 4;
    } else if (*m < 0) {
	info = 5;
    } else if (*n < 0) {
	info = 6;
    } else if (*lda < max(1,nrowa)) {
	info = 9;
    } else if (*ldb < max(1,*m)) {
	info = 11;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (*alpha == 0.) {
       *tcomp += tn*tm*2;
	return HSCAL_SUCCESS;
    }

    if (lside) {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
               if (*alpha != 1.) {
                  *tcomp += tm*3*tn;
               }
               if (nounit) {
                  *tcomp += 5*tn*tm;
               }
               *tcomp += 8*tn*(((tm-1)*tm)/2);
	    } else {
               if (*alpha != 1.) {
                  *tcomp += tm*3*tn;
               }
               if (nounit) {
                  *tcomp += 5*tn*tm;
               }
               *tcomp += 8*tn*(((tm-1)*tm)/2);
	    }
	} else {
	    if (upper) {
                *tcomp += tm*5*tn + 6*tn*(((tm-1)*tm)/2);
                if (nounit) {
                   *tcomp += tm*3*tn;
                }
	    } else {
                *tcomp += tm*5*tn + 6*tn*(((tm-1)*tm)/2);
                if (nounit) {
                   *tcomp += tm*3*tn;
                }
	    }
	}
    } else {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
                if (*alpha != 1.) {
                   *tcomp += tm*3*tn;
                }
                *tcomp += tm*8*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += (3 + tm*3)*tn;
                }
	    } else {
                if (*alpha != 1.) {
                   *tcomp += tm*3*tn;
                }
                *tcomp += tm*8*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += (3 + tm*3)*tn;
                }
	    }
	} else {
	    if (upper) {
                if (nounit) {
                   *tcomp += (3 + tm*3)*tn;
                }
                *tcomp += (2 + tm*6)*(((tn-1)*tn)/2);
                if (*alpha != 1.) {
                   *tcomp += tm*3*tn;
                }
	    } else {
                if (nounit) {
                   *tcomp += (3 + tm*3)*tn;
                }
                *tcomp += (2 + tm*6)*(((tn-1)*tn)/2);
                if (*alpha != 1.) {
                   *tcomp += tm*3*tn;
                }
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
