
#ifndef __HSCAL_CB_SAXPY_HSCALFUNC_HH
#define __HSCAL_CB_SAXPY_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_saxpy(
    int *n,
    char *csa,
    int *incx,
    int *incy,
    double *tcomp
)
{
    int m;
    float *sa;

    *tcomp = 0.;

    if (*n <= 0) {
	return HSCAL_SUCCESS;
    }

    sa = (float*)csa;

    if (*sa == 0.f) {
       return HSCAL_SUCCESS;
    }

    if (*incx == 1 && *incy == 1) {
       m = *n % 4;

       if (m == 0) {
          *tcomp += iceil((*n - m), 4)*8;
          return HSCAL_SUCCESS;
       }

       *tcomp += (m * 2);

       if (*n < 4) {
	  return HSCAL_SUCCESS;
       }

       *tcomp += iceil((*n - m), 4)*8;

       return HSCAL_SUCCESS;
    }

    *tcomp += (*n * 4);

    return HSCAL_SUCCESS;
}

#endif

