
#ifndef __HSCAL_CB_SSCAL_HSCALFUNC_HH
#define __HSCAL_CB_SSCAL_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_sscal(
    int *n,
    char *csa,
    int *incx,
    double *tcomp
)
{
    int m;
    float *sa = (float*)csa;

    *tcomp = 0.;

    if (*n <= 0 || *incx <= 0) {
       return HSCAL_SUCCESS;
    }

    if (*incx == 1) {

       m = *n % 5;

       if (m == 0) {
          *tcomp += iceil((*n - m), 5)*5;
          return HSCAL_SUCCESS;
       }

       *tcomp += m;

       if (*n < 5) {
	  return HSCAL_SUCCESS;
       }

       *tcomp += iceil((*n - m), 5)*5;

       return HSCAL_SUCCESS;
    }

    *tcomp += (*n);

    return HSCAL_SUCCESS;
}

#endif

