
#ifndef __HSCAL_CB_SSYMM_HH
#define __HSCAL_CB_SSYMM_HH



#include "../../../include/hscalapack.h"

int hscal_ssymm(
    char   *side, 
    char   *uplo, 
    int    *m, 
    int    *n, 
    char   *calpha, 
    int    *lda,
    int    *ldb,
    char   *cbeta,
    int    *ldc, 
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, c_dim1, c_offset, i__1, i__2, 
	    i__3;
    int info;
    int i__, j, k;
    int nrowa;
    hscallogical upper;
    hscaldoublereal tm, tn;

    hscalreal *alpha = (hscalreal*)calpha;
    hscalreal *beta  = (hscalreal*)cbeta;

    *tcomp = 0.;

    if (hscal_lsame(side, "L")) {
	nrowa = *m;
    } else {
	nrowa = *n;
    }
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! hscal_lsame(side, "L") && ! hscal_lsame(side, "R")) {
	info = 1;
    } else if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 2;
    } else if (*m < 0) {
	info = 3;
    } else if (*n < 0) {
	info = 4;
    } else if (*lda < max(1,nrowa)) {
	info = 7;
    } else if (*ldb < max(1,*m)) {
	info = 9;
    } else if (*ldc < max(1,*m)) {
	info = 12;
    }

    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*m == 0 || *n == 0 || *alpha == 0.f && *beta == 1.f) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (*alpha == 0.f) {
	if (*beta == 0.f) {
          *tcomp += tn*tm*2;
	} else {
          *tcomp += tn*tm*3;
	}
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(side, "L")) {
	if (upper) {
            *tcomp += 4*tn*tm + 12*tn*(((tm-1)*tm)/2);
            if (*beta == 0.f) {
               *tcomp += 7*tn*tm;
            } else {
               *tcomp += 9*tn*tm;
            }
	} else {
            *tcomp += 4*tn*tm + 12*tn*(((tm-1)*tm)/2);
            if (*beta == 0.f) {
               *tcomp += 7*tn*tm;
            } else {
               *tcomp += 9*tn*tm;
            }
	}
    } else {
        *tcomp += 3*tn;
        if (*beta == 0.f) {
           *tcomp += tn*tm*3;
        } else {
           *tcomp += tm*5*tn;
        }
        if (upper) {
           *tcomp += 3*(((tn-1)*tn)/2);
        } else {
           *tcomp += 3*(((tn-1)*tn)/2);
        }
        *tcomp += tm*6*(((tn-1)*tn)/2);
        if (upper) {
           *tcomp += 3*(((tn-1)*tn)/2);
        } else {
           *tcomp += 3*(((tn-1)*tn)/2);
        }
        *tcomp += tm*6*(((tn-1)*tn)/2);
    }
    return HSCAL_SUCCESS;
}

#endif
