
#ifndef __HSCAL_CB_STRMV_HH
#define __HSCAL_CB_STRMV_HH



#include "../../../include/hscalapack.h"

int hscal_strmv(
    char *uplo, 
    char *trans, 
    char *diag, 
    int *n, 
    int *lda, 
    int *incx,
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2;
    int info;
    int i__, j;
    hscallogical nounit;
    hscaldoublereal tn;

    *tcomp = 0.;
    info = 0;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (! hscal_lsame(trans, "N") && ! hscal_lsame(trans, 
	    "T") && ! hscal_lsame(trans, "C")) {
	info = 2;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, 
	    "N")) {
	info = 3;
    } else if (*n < 0) {
	info = 4;
    } else if (*lda < max(1,*n)) {
	info = 6;
    } else if (*incx == 0) {
	info = 8;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }
    if (*n == 0) {
	return HSCAL_SUCCESS;
    }

    nounit = hscal_lsame(diag, "N");

    tn = (double)(*n);

    if (hscal_lsame(trans, "N")) {
	if (hscal_lsame(uplo, "U")) {
	    if (*incx == 1) {
                *tcomp += tn + 4*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
	    } else {
                *tcomp += 2*tn + 5*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
	    }
	} else {
	    if (*incx == 1) {
                *tcomp += tn + 4*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
	    } else {
                *tcomp += 2*tn + 5*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
	    }
	}
    } else {
	if (hscal_lsame(uplo, "U")) {
	    if (*incx == 1) {
                *tcomp += 2*tn + 4*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
	    } else {
                *tcomp += 3*tn + 5*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
	    }
	} else {
	    if (*incx == 1) {
                *tcomp += 2*tn + 4*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
	    } else {
                *tcomp += 3*tn + 5*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 3*tn;
                }
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
