
#ifndef __HSCAL_CB_ZHER2_HH
#define __HSCAL_CB_ZHER2_HH



#include "../../../include/hscalapack.h"

int hscal_zher2(
    char *uplo,
    int  *n, 
    char *calpha,
    int  *incx, 
    int  *incy, 
    int  *lda, 
    double  *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4, i__5, i__6;
    int info;
    int i__, j;
    hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
    hscaldoublereal tn;

    info   = 0;
    *tcomp = 0.;
    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*incy == 0) {
	info = 7;
    } else if (*lda < max(1,*n)) {
	info = 9;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }
    if (*n == 0 || alpha->r == 0. && alpha->i == 0.) {
	return HSCAL_SUCCESS;
    }

    tn = (double)(*n);

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1 && *incy == 1) {
            *tcomp += 43*tn + (((tn-1)*tn)/2)*22;
	} else {
            *tcomp += 45*tn + (((tn-1)*tn)/2)*24;
	}
    } else {
	if (*incx == 1 && *incy == 1) {
            *tcomp += 43*tn + (((tn-1)*tn)/2)*22;
	} else {
            *tcomp += 45*tn + (((tn-1)*tn)/2)*24;
	}
    }
    return HSCAL_SUCCESS;
}

#endif
