
#ifndef __HSCAL_CB_ZSYMM_HH
#define __HSCAL_CB_ZSYMM_HH



#include "../../../include/hscalapack.h"

int hscal_zsymm(
    char   *side, 
    char   *uplo, 
    int    *m, 
    int    *n, 
    char   *calpha, 
    int    *lda,
    int    *ldb,
    char   *cbeta,
    int    *ldc, 
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, c_dim1, c_offset, i__1, i__2, 
	    i__3, i__4, i__5, i__6;

    int info;
    int i__, j, k;
    int nrowa;
    hscallogical upper;
    hscaldoublereal tm, tn;

    hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
    hscaldoublecomplex *beta  = (hscaldoublecomplex*)cbeta;

    *tcomp = 0.;

    if (hscal_lsame(side, "L")) {
	nrowa = *m;
    } else {
	nrowa = *n;
    }
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! hscal_lsame(side, "L") && ! hscal_lsame(side, "R")) {
	info = 1;
    } else if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 2;
    } else if (*m < 0) {
	info = 3;
    } else if (*n < 0) {
	info = 4;
    } else if (*lda < max(1,nrowa)) {
	info = 7;
    } else if (*ldb < max(1,*m)) {
	info = 9;
    } else if (*ldc < max(1,*m)) {
	info = 12;
    }

    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*m == 0 || *n == 0 || alpha->r == 0. && alpha->i == 0. && (beta->r == 
	    1. && beta->i == 0.)) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (alpha->r == 0. && alpha->i == 0.) {
	if (beta->r == 0. && beta->i == 0.) {
          *tcomp += tn*tm*4;
	} else {
          *tcomp += tn*tm*12;
	}
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(side, "L")) {
	if (upper) {
            *tcomp += 12*tn*tm + 30*tn*(((tm-1)*tm)/2);
            if (beta->r == 0. && beta->i == 0.) {
               *tcomp += 20*tn*tm;
            } else {
               *tcomp += 30*tn*tm;
            }
	} else {
            *tcomp += 12*tn*tm + 30*tn*(((tm-1)*tm)/2);
            if (beta->r == 0. && beta->i == 0.) {
               *tcomp += 20*tn*tm;
            } else {
               *tcomp += 30*tn*tm;
            }
	}
    } else {
        *tcomp += 10*tn;
        if (beta->r == 0. && beta->i == 0.) {
           *tcomp += tm*12*tn;
        } else {
           *tcomp += tm*22*tn;
        }
        if (upper) {
           *tcomp += 10*(((tn-1)*tn)/2);
        } else {
           *tcomp += 10*(((tn-1)*tn)/2);
        }
        *tcomp += tm*16*(((tn-1)*tn)/2);
        if (upper) {
           *tcomp += 10*(((tn-1)*tn)/2);
        } else {
           *tcomp += 10*(((tn-1)*tn)/2);
        }
        *tcomp += tm*16*(((tn-1)*tn)/2);
    }
    return HSCAL_SUCCESS;
}

#endif
