
#ifndef __HSCALAPACK_PBSMATADD_HSCALFUNC_HH
#define __HSCALAPACK_PBSMATADD_HSCALFUNC_HH

#include "../../../include/hscalapack.h"

int hscal_pbsmatadd(
    hscalinteger *icontxt, char *mode, hscalinteger *m, 
    hscalinteger *n, hscalreal *alpha, hscalinteger *lda, 
    hscalreal *beta, hscalinteger *ldb, 
    double *tcomp
)
{
    hscalinteger c__1 = 1;

    /* System generated locals */
    hscalinteger a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;

    /* Local variables */
    hscalinteger i__, j;

    *tcomp = 0.;

    /* Function Body */
    if (*m <= 0 || *n <= 0 || *alpha == 0.f && *beta == 1.f) {
	return HSCAL_SUCCESS;
    }

/*     A is upper triangular or upper trapezoidal, */

    if (hscal_lsame(mode, "U")) {
	if (*alpha == 0.f) {
	    if (*beta == 0.f) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = min(j,*m);
                *tcomp += 2*i__2;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = min(j,*m);
                    *tcomp += 5*i__2;
	        }
            }
	} else if (*alpha == 1.f) {
	    if (*beta == 0.f) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = min(j,*m);
                *tcomp += 4*i__2;
		}
	    } else if (*beta == 1.f) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = min(j,*m);
                *tcomp += 7*i__2;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = min(j,*m);
                *tcomp += 7*i__2;
		}
	    }

	} else {
	    if (*beta == 0.f) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = min(j,*m);
                *tcomp += 5*i__2;
		}
	    } else if (*beta == 1.f) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = min(j,*m);
                *tcomp += 8*i__2;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = min(j,*m);
                *tcomp += 9*i__2;
		}
	    }
	}

/*     A is lower triangular or upper trapezoidal, */

    } else if (hscal_lsame(mode, "L")) {
	if (*alpha == 0.f) {
	    if (*beta == 0.f) {
            if ((*n) >= (*m))
            {
               *tcomp += 2*(((*m)*(*m+1))/2);
            }
            else
            {
               *tcomp += 2*(((*n) * (*m)) - (((*n)*(*n-1))/2));
            }
	    } else {
            if ((*n) >= (*m))
            {
               *tcomp += 5*(((*m)*(*m+1))/2);
            }
            else
            {
               *tcomp += 5*(((*n) * (*m)) - (((*n)*(*n-1))/2));
            }
	    }

	} else if (*alpha == 1.f) {
	    if (*beta == 0.f) {
            if ((*n) >= (*m))
            {
               *tcomp += 4*(((*m)*(*m+1))/2);
            }
            else
            {
               *tcomp += 4*(((*n) * (*m)) - (((*n)*(*n-1))/2));
            }
	    } else if (*beta == 1.f) {
            if ((*n) >= (*m))
            {
               *tcomp += 7*(((*m)*(*m+1))/2);
            }
            else
            {
               *tcomp += 7*(((*n) * (*m)) - (((*n)*(*n-1))/2));
            }
	    } else {
            if ((*n) >= (*m))
            {
               *tcomp += 8*(((*m)*(*m+1))/2);
            }
            else
            {
               *tcomp += 8*(((*n) * (*m)) - (((*n)*(*n-1))/2));
            }
	    }

	} else {
	    if (*beta == 0.f) {
            if ((*n) >= (*m))
            {
               *tcomp += 5*(((*m)*(*m+1))/2);
            }
            else
            {
               *tcomp += 5*(((*n) * (*m)) - (((*n)*(*n-1))/2));
            }
	    } else if (*beta == 1.f) {
            if ((*n) >= (*m))
            {
               *tcomp += 8*(((*m)*(*m+1))/2);
            }
            else
            {
               *tcomp += 8*(((*n) * (*m)) - (((*n)*(*n-1))/2));
            }
	    } else {
            if ((*n) >= (*m))
            {
               *tcomp += 9*(((*m)*(*m+1))/2);
            }
            else
            {
               *tcomp += 9*(((*n) * (*m)) - (((*n)*(*n-1))/2));
            }
	    }
	}

/*     If MODE = 'Transpose'/'Conjugate' */

    } else if (hscal_lsame(mode, "T") || hscal_lsame(mode, "C")) {
	if (*alpha == 0.f) {
	    if (*beta == 0.f) {
            *tcomp += 2*((*n) * (*m));
	    } else {
            *tcomp += 5*((*n) * (*m));
	    }

	} else if (*alpha == 1.f) {
	    if (*beta == 0.f) {
            *tcomp += 4*((*n) * (*m));
	    } else if (*beta == 1.f) {
            *tcomp += 7*((*n) * (*m));
	    } else {
            *tcomp += 8*((*n) * (*m));
	    }

	} else {
	    if (*beta == 0.f) {
            *tcomp += 5*((*n) * (*m));
	    } else if (*beta == 1.f) {
            *tcomp += 8*((*n) * (*m));
	    } else {
            *tcomp += 9*((*n) * (*m));
	    }
	}

/*     Other cases (for genral matrix additions) */

    } else {
	if (*alpha == 0.f) {
	    if (*beta == 0.f) {
            *tcomp += 2*((*n) * (*m));
	    } else {
		if (*m == *ldb) {
		    i__1 = *m * *n;
                {
                double t;
		    hscal_sscal(
                     &i__1, (char*)beta, &c__1,
                     &t
                );
                *tcomp += t;
                }
		} else if (hscal_lsame(mode, "V")) {
		    i__1 = *n;
		    {
                  double t;
			hscal_sscal(
                       m, (char*)beta, &c__1,
                       &t
                  );
                  *tcomp += (t * i__1);
		    }
		} else {
                *tcomp += 5*((*n) * (*m));
		}
	    }

	} else if (*alpha == 1.f) {
	    if (*beta == 0.f) {
		if (*m == *lda && *m == *ldb) {
		    i__1 = *m * *n;
                {
                double t;
		    hscal_scopy(
                     &i__1, &c__1, &c__1,
                     &t
                );
                *tcomp += t;
                }
		} else if (hscal_lsame(mode, "V")) {
		    i__1 = *n;
		    {
                  double t;
			hscal_scopy(
                       m, &c__1, &c__1,
                       &t
                  );
                  *tcomp += (t * i__1);
		    }
		} else {
                *tcomp += 4*((*n) * (*m));
		}

	    } else if (*beta == 1.f) {
            *tcomp += 7*((*n) * (*m));
	    } else {
            *tcomp += 8*((*n) * (*m));
	    }

	} else {
	    if (*beta == 0.f) {
            *tcomp += 5*((*n) * (*m));
	    } else if (*beta == 1.f) {
		if (*m == *lda && *m == *ldb) {
		    i__1 = *m * *n;
                {
                double t;
		    hscal_saxpy(
                     &i__1, (char*)alpha, &c__1, &c__1,
                     &t
                );
                *tcomp += t;
                }
		} else if (hscal_lsame(mode, "V")) {
		    i__1 = *n;
		    {
                  double t;
			hscal_saxpy(
                       m, (char*)alpha, &c__1, &c__1,
                       &t
                  );
                  *tcomp += (t * i__1);
		    }
		} else {
                *tcomp += 8*((*n) * (*m));
		}

	    } else {
            *tcomp += 9*((*n) * (*m));
	    }
	}
    }

    return HSCAL_SUCCESS;

/*     End of PBSMATADD */

}

#endif
