
#ifndef __HSCALAPACK_PBSTRSRT_HSCALFUNC_HH
#define __HSCALAPACK_PBSTRSRT_HSCALFUNC_HH
    
/*  
*  Include files
*/
#include "../../../include/hscalapack.h"

int hscal_pbstrsrt(
    hscalinteger *icontxt, char *adist, hscalinteger *m,
    hscalinteger *n, hscalinteger *nb, hscalinteger *lda, hscalreal *beta,
    hscalinteger *ldb, hscalinteger *lcmp, hscalinteger *lcmq, hscalinteger *nint,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
)
{
    hscalreal c_b6 = 1.f;

    /* System generated locals */
    hscalinteger a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4;

    /* Local variables */
    hscalinteger k;
    hscalinteger ja, jb, kk;
    hscalinteger njump;


/*  -- PB-BLAS routine (version 2.1) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory. */
/*     April 28, 1996 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  PBSTRSRT forms   T <== A + beta * T, where T is a sorted */
/*  condensed block row (or column) from a block column (or row) of A */
/*  with sorting index ISRT */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Variables .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. External Functions .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

    /* Function Body */
    if (hscal_lsame(adist, "R")) {
	njump = *nb * *lcmq;
	i__1 = *lcmq - 1;
	for (k = 0; k <= i__1; ++k) {
	    ja = *nint * (k * *lcmp % *lcmq) + 1;
	    jb = k * *nb + 1;

	    i__2 = hscal_iceil(nint, nb);
	    for (kk = 1; kk <= i__2; ++kk) {
		if (*n < jb) {
		    goto L20;
		}
/* Computing MIN */
		i__4 = *n - jb + 1;
		i__3 = min(i__4,*nb);
		pbsmatadd_tcomp_macro(
                         icontxt, "G", m, &i__3, &c_b6,
			 lda, beta, ldb,
                         nprow, npcol, myrow, mycol, tcomp
                );
		ja += *nb;
		jb += njump;
/* L10: */
	    }
L20:
	    ;
	}

/*     if( LSAME( ADIST, 'C') ) then */

    } else {
	njump = *nb * *lcmp;
	i__1 = *lcmp - 1;
	for (k = 0; k <= i__1; ++k) {
	    ja = 1;
	    jb = k * *nb + 1;

	    i__2 = hscal_iceil(nint, nb);
	    for (kk = 1; kk <= i__2; ++kk) {
		if (*m < jb) {
		    goto L40;
		}
/* Computing MIN */
		i__4 = *m - jb + 1;
		i__3 = min(i__4,*nb);
		pbsmatadd_tcomp_macro(
                         icontxt, "G", &i__3, n, &c_b6,
			 lda, beta, ldb,
                         nprow, npcol, myrow, mycol, tcomp
                );
		ja += *nb;
		jb += njump;
/* L30: */
	    }
L40:
	    ;
	}
    }

    return HSCAL_SUCCESS;

/*     End of PBSTRSRT */

} /* pbstrsrt_ */

#endif

