
#ifndef __HSCALAPACK_PBSVECADD_HSCALFUNC_HH
#define __HSCALAPACK_PBSVECADD_HSCALFUNC_HH

#include "../../../include/hscalapack.h"

int hscal_pbsvecadd(
    hscalinteger *icontxt, char *mode, hscalinteger *n, 
    hscalreal *alpha, hscalinteger *incx, hscalreal *beta, 
    hscalinteger *incy,
    double *tcomp
)
{
    /* System generated locals */
    hscalinteger i__1;

    /* Local variables */
    hscalinteger i__, ix, iy;

    *tcomp = 0.;

    /* Function Body */
    if (*n <= 0 || *alpha == 0.f && *beta == 1.f) {
	return HSCAL_SUCCESS;
    }

    if (*alpha == 0.f) {
	if (*beta == 0.f) {
	    if (*incy == 1) {
            *tcomp += (*n);
	    } else {
            *tcomp += 2*(*n);
	    }

	} else {
	    if (hscal_lsame(mode, "V")) {
            {
            double t;
		hscal_sscal(
                 n, (char*)beta, incy,
                 &t
            );
            *tcomp += t;
            }
	    } else if (*incy == 1) {
            *tcomp += 2*(*n);
	    } else {
            *tcomp += 3*(*n);
	    }
	}

    } else {
	if (*alpha == 1.f) {
	    if (*beta == 0.f) {
		if (hscal_lsame(mode, "V")) {
                {
                double t;
		    hscal_scopy(
                     n, incx, incy,
                     &t
                );
                *tcomp += t;
                }
		} else if (*incx == 1 && *incy == 1) {
                *tcomp += (*n);
		} else {
                *tcomp += 3*(*n);
		}

	    } else if (*beta == 1.f) {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 2*(*n);
		} else {
                *tcomp += 4*(*n);
		}

	    } else {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 3*(*n);
		} else {
                *tcomp += 5*(*n);
		}
	    }

	} else {
	    if (*beta == 0.f) {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 2*(*n);
		} else {
                *tcomp += 3*(*n);
		}

	    } else if (*beta == 1.f) {
		if (hscal_lsame(mode, "V")) {
                {
                double t;
		    hscal_saxpy(
                     n, (char*)alpha, incx, incy,
                     &t
                );
                *tcomp += t;
                }
		} else if (*incx == 1 && *incy == 1) {
                *tcomp += 3*(*n);
		} else {
                *tcomp += 5*(*n);
		}

	    } else {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 4*(*n);
		} else {
                *tcomp += 6*(*n);
		}
	    }
	}
    }

    return HSCAL_SUCCESS;

/*     End of PBSVECADD */

}

#endif
