
#ifndef __HSCALAPACK_PBZTRST1_HSCALFUNC_HH
#define __HSCALAPACK_PBZTRST1_HSCALFUNC_HH

/*
*  Include files
*/
#include "../../../include/hscalapack.h"

int hscal_pbztrst1(
    hscalinteger *icontxt, char *xdist, hscalinteger *n,
    hscalinteger *nb, hscalinteger *nz, hscalinteger *incx, hscaldoublecomplex *beta,
    hscalinteger *incy, hscalinteger *lcmp, hscalinteger *lcmq, hscalinteger *nint,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
)
{
    hscaldoublecomplex c_b1 = {1.,0.};

    /* System generated locals */
    hscalinteger i__1, i__2, i__3, i__4;

    /* Local variables */
    hscalinteger k;
    hscalinteger kk, ix, iy, kz, iter;
    hscalinteger njump;


/*  -- PB-BLAS routine (version 2.1) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory. */
/*     April 28, 1996 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  PBZTRST1 forms  y <== x + beta * y, where y is a sorted */
/*  condensed row (or column) vector from a column (or row) vector of x. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Variables .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. External Functions .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

    /* Function Body */
    iter = hscal_iceil(nint, nb);
    kz = *nz;

    if (hscal_lsame(xdist, "R")) {
	njump = *nb * *lcmq;

	i__1 = *lcmq - 1;
	for (kk = 0; kk <= i__1; ++kk) {
	    ix = *nint * (kk * *lcmp % *lcmq);
/* Computing MAX */
	    i__2 = 0, i__3 = *nb * kk - *nz;
	    iy = max(i__2,i__3);
	    if (*n < iy) {
		goto L50;
	    }

	    if (iter > 1) {
		i__2 = *nb - kz;
		pbzvecadd_tcomp_macro(icontxt, "G", &i__2, &c_b1,
			incx, beta, incy,
                        nprow, npcol, myrow, mycol, tcomp
                );
		ix = ix + *nb - kz;
		iy = iy + njump - kz;
		kz = 0;

		i__2 = iter - 1;
		for (k = 2; k <= i__2; ++k) {
		    pbzvecadd_tcomp_macro(icontxt, "G", nb, &c_b1,
			    incx, beta, incy,
                        nprow, npcol, myrow, mycol, tcomp
                );
		    ix += *nb;
		    iy += njump;
/* L10: */
		}
	    }

/* Computing MIN */
	    i__3 = *nb - kz, i__4 = *n - iy;
	    i__2 = min(i__3,i__4);
	    pbzvecadd_tcomp_macro(icontxt, "G", &i__2, &c_b1, incx, 
		    beta, incy,
                        nprow, npcol, myrow, mycol, tcomp
                );
	    kz = 0;
/* L20: */
	}

/*     if( LSAME( XDIST, 'C' ) ) then */

    } else {
	njump = *nb * *lcmp;

	i__1 = *lcmp - 1;
	for (kk = 0; kk <= i__1; ++kk) {
	    ix = *nint * (kk * *lcmq % *lcmp);
/* Computing MAX */
	    i__2 = 0, i__3 = *nb * kk - *nz;
	    iy = max(i__2,i__3);
	    if (*n < iy) {
		goto L50;
	    }

	    if (iter > 1) {
		i__2 = *nb - kz;
		pbzvecadd_tcomp_macro(icontxt, "G", &i__2, &c_b1,
			incx, beta, incy,
                        nprow, npcol, myrow, mycol, tcomp
                );
		ix = ix + *nb - kz;
		iy = iy + njump - kz;
		kz = 0;

		i__2 = iter - 1;
		for (k = 2; k <= i__2; ++k) {
		    pbzvecadd_tcomp_macro(icontxt, "G", nb, &c_b1,
			    incx, beta, incy,
                        nprow, npcol, myrow, mycol, tcomp
                );
		    ix += *nb;
		    iy += njump;
/* L30: */
		}
	    }

/* Computing MIN */
	    i__3 = *nb - kz, i__4 = *n - iy;
	    i__2 = min(i__3,i__4);
	    pbzvecadd_tcomp_macro(icontxt, "G", &i__2, &c_b1, incx, 
		    beta, incy,
                        nprow, npcol, myrow, mycol, tcomp
                );
	    kz = 0;
/* L40: */
	}
    }

L50:

    return HSCAL_SUCCESS;

/*     End of PBZTRST1 */

} /* pbztrst1_ */

#endif

