
#ifndef __HSCALAPACK_PBZVECADD_HSCALFUNC_HH
#define __HSCALAPACK_PBZVECADD_HSCALFUNC_HH

#include "../../../include/hscalapack.h"

int hscal_pbzvecadd(
    hscalinteger *icontxt, char *mode, hscalinteger *n, 
    hscaldoublecomplex *alpha, hscalinteger *incx, hscaldoublecomplex *beta,
    hscalinteger *incy,
    double *tcomp
)
{
    /* System generated locals */
    hscalinteger i__1, i__2, i__3, i__4;
    hscaldoublecomplex q__1, q__2, q__3, q__4;

    /* Local variables */
    hscalinteger i__, ix, iy;

    *tcomp = 0.;

    /* Function Body */
    if (*n <= 0 || alpha->r == 0. && alpha->i == 0. && (beta->r == 1. && 
	    beta->i == 0.)) {
	return HSCAL_SUCCESS;
    }

    if (alpha->r == 0. && alpha->i == 0.) {
	if (beta->r == 0. && beta->i == 0.) {
	    if (*incy == 1) {
            *tcomp += 2*(*n);
	    } else {
            *tcomp += 3*(*n);
	    }

	} else {
	    if (hscal_lsame(mode, "V")) {
            {
            double t;
		hscal_zscal(
                 n, (char*)beta, incy,
                 &t
            );
            *tcomp += t;
            }
	    } else if (*incy == 1) {
            *tcomp += 8*(*n);
	    } else {
            *tcomp += 9*(*n);
	    }
	}

    } else if (! hscal_lsame(mode, "C")) {
	if (alpha->r == 1. && alpha->i == 0.) {
	    if (beta->r == 0. && beta->i == 0.) {
		if (hscal_lsame(mode, "V")) {
                {
                double t;
		    hscal_zcopy(
                     n, incx, incy,
                     &t
                );
                *tcomp += t;
                }
		} else if (*incx == 1 && *incy == 1) {
                *tcomp += 2*(*n);
		} else {
                *tcomp += 4*(*n);
		}

	    } else if (beta->r == 1. && beta->i == 0.) {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 4*(*n);
		} else {
                *tcomp += 6*(*n);
		}

	    } else {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 10*(*n);
		} else {
                *tcomp += 12*(*n);
		}
	    }

	} else {
	    if (beta->r == 0. && beta->i == 0.) {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 8*(*n);
		} else {
                *tcomp += 4*(*n);
		}

	    } else if (beta->r == 1. && beta->i == 0.) {
		if (hscal_lsame(mode, "V")) {
                {
                double t;
		    hscal_zaxpy(
                     n, (char*)alpha, incx, incy,
                     &t
                );
                *tcomp += t;
                }
		} else if (*incx == 1 && *incy == 1) {
                *tcomp += 10*(*n);
		} else {
                *tcomp += 12*(*n);
		}

	    } else {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 16*(*n);
		} else {
                *tcomp += 18*(*n);
		}
	    }
	}

    } else {
	if (alpha->r == 1. && alpha->i == 0.) {
	    if (beta->r == 0. && beta->i == 0.) {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 5*(*n);
		} else {
                *tcomp += 7*(*n);
		}

	    } else if (beta->r == 1. && beta->i == 0.) {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 7*(*n);
		} else {
                *tcomp += 9*(*n);
		}

	    } else {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 13*(*n);
		} else {
                *tcomp += 15*(*n);
		}
	    }

	} else {
	    if (beta->r == 0. && beta->i == 0.) {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 11*(*n);
		} else {
                *tcomp += 13*(*n);
		}

	    } else if (beta->r == 1. && beta->i == 0.) {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 13*(*n);
		} else {
                *tcomp += 15*(*n);
		}

	    } else {
		if (*incx == 1 && *incy == 1) {
                *tcomp += 19*(*n);
		} else {
                *tcomp += 21*(*n);
		}
	    }
	}
    }

    return HSCAL_SUCCESS;

/*     End of PBZVECADD */

}

#endif
