
#ifndef __HSCAL_PTZB_CATRMV_HSCALFUNC_HH
#define __HSCAL_PTZB_CATRMV_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_catrmv(
    char *uplo, 
    char *trans, 
    char *diag, 
    int *n, 
    char *calpha, 
    int *lda, 
    int *incx, 
    char *cbeta, 
    int *incy,
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4;

    int i__, j, ix, iy, jx, jy, kx, ky, info;
    hscallogical nounit;
    hscaldoublereal tn;

    hscalreal *alpha = (hscalreal*)calpha;
    hscalreal *beta  = (hscalreal*)cbeta;

    *tcomp = 0.;
    info = 0;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (! hscal_lsame(trans, "N") && ! hscal_lsame(trans, "T") && ! hscal_lsame(trans, "C")) {
	info = 2;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, "N")) {
	info = 3;
    } else if (*n < 0) {
	info = 4;
    } else if (*lda < max(1,*n)) {
	info = 7;
    } else if (*incx == 0) {
	info = 9;
    } else if (*incy == 0) {
	info = 12;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || *alpha == 0.f && *beta == 1.f) {
	return HSCAL_SUCCESS;
    }

    nounit = hscal_lsame(diag, "N");

    if (*incy == 1) {
	if (*beta == 0.f) {
            *tcomp += (*n);
	} else if (*beta == 1.f) {
            *tcomp += (*n);
	} else {
            *tcomp += (*n);
	}
    } else {
	if (*beta == 0.f) {
            *tcomp += (*n)*2;
	} else if (*beta == 1.f) {
            *tcomp += (*n)*2;
	} else {
            *tcomp += (*n)*2;
	}
    }

    if (*alpha == 0.f) {
	return HSCAL_SUCCESS;
    }

    tn = (double)(*n);

    if (hscal_lsame(trans, "N")) {
	if (hscal_lsame(uplo, "U")) {
	    if (*incy == 1) {
                *tcomp += 3*tn + 7*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 7*tn;
                } else {
                   *tcomp += tn;
                }
	    } else {
                *tcomp += 3*tn + 8*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 7*tn;
                } else {
                   *tcomp += tn;
                }
	    }
	} else {
	    if (*incy == 1) {
                *tcomp += 3*tn + 7*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 7*tn;
                } else {
                   *tcomp += tn;
                }
	    } else {
                *tcomp += 3*tn + 8*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 7*tn;
                } else {
                   *tcomp += tn;
                }
	    }
	}
    } else {
	if (hscal_lsame(uplo, "U")) {
	    if (*incx == 1) {
                *tcomp += 3*tn + 8*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 8*tn;
                } else {
                   *tcomp += 2*tn;
                }
	    } else {
                *tcomp += 3*tn + 9*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 8*tn;
                } else {
                   *tcomp += 2*tn;
                }
	    }
	} else {
	    if (*incx == 1) {
                *tcomp += 3*tn + 8*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 7*tn;
                } else {
                   *tcomp += tn;
                }
	    } else {
                *tcomp += 3*tn + 9*(((tn-1)*tn)/2);
                if (nounit) {
                   *tcomp += 7*tn;
                } else {
                   *tcomp += tn;
                }
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif
