
#ifndef __HSCAL_PTZB_CMMADD_HSCALFUNC_HH
#define __HSCAL_PTZB_CMMADD_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_cmmadd(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
hscalcomplex c_b1 = {1.f,0.f};
int c__1 = 1;
hscalcomplex *alpha = (hscalcomplex*)calpha;
hscalcomplex *beta = (hscalcomplex*)cbeta;
hscaldoublereal tm, tn;

*tcomp = 0.;
{
    int i__1, i__2, i__3, i__4, i__5;
    hscalcomplex q__1, q__2, q__3;
    int i__, j;

    tm = (double)(*m);
    tn = (double)(*n);

    if (alpha->r == 1.f && alpha->i == 0.f) {
	if (beta->r == 0.f && beta->i == 0.f) {
            hscal_ccopy(
                 m, &c__1, &c__1, tcomp
            );
            *tcomp *= *n;
	} else if (beta->r != 1.f || beta->i != 0.f) {
            *tcomp += tn * tm * 16;
	} else {
            hscal_caxpy(
                 m, (char*)(&c_b1), &c__1, &c__1, tcomp
            );
            *tcomp *= *n;
	}
    } else if (alpha->r != 0.f || alpha->i != 0.f) {
	if (beta->r == 0.f && beta->i == 0.f) {
           *tcomp += tn * tm * 12;  
	} else if (beta->r != 1.f || beta->i != 0.f) {
           *tcomp += tn * tm * 22;
	} else {
            hscal_caxpy(
                 m, calpha, &c__1, &c__1, tcomp
            );
            *tcomp *= *n;
	}
    } else {
	if (beta->r == 0.f && beta->i == 0.f) {
           *tcomp += tn * tm * 4;
	} else if (beta->r != 1.f || beta->i != 0.f) {
	    hscal_cscal(
                 m, cbeta, &c__1, tcomp
            );
            *tcomp *= *n;
	}
    }
}

return HSCAL_SUCCESS;
}


#endif

