
#ifndef __HSCAL_PTZB_CMMDDAT_HSCALFUNC_HH
#define __HSCAL_PTZB_CMMDDAT_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_cmmddat(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
hscalcomplex c_b1 = {1.f,0.f};
int c__1 = 1;
hscalcomplex *alpha = (hscalcomplex*)calpha;
hscalcomplex *beta = (hscalcomplex*)cbeta;
hscaldoublereal tm, tn;

*tcomp = 0.;
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4, i__5;
    int i__, j;

    tm = (double)(*m);
    tn = (double)(*n);

    if (*m >= *n) {
	if (beta->r == 1.f && beta->i == 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
		hscal_ccopy(
                     m, ldb, &c__1, tcomp
                );
                *tcomp *= *n;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
                *tcomp += tn * tm * 16;
	    } else {
		hscal_caxpy(
                     m, (char*)&c_b1, ldb, &c__1,
                     tcomp
                );
                *tcomp *= *n;
	    }
	} else if (beta->r != 0.f || beta->i != 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += tn * tm * 12;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
                *tcomp += tn * tm * 22;
	    } else {
		hscal_caxpy(
                     m, cbeta, ldb, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	} else {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += tn * tm * 4;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
		hscal_cscal(
                     m, calpha, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	}
    } else {
	if (beta->r == 1.f && beta->i == 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
		hscal_ccopy(
                     n, &c__1, lda, tcomp
                );
                *tcomp *= *m;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
                *tcomp += tn * tm * 16;
	    } else {
		hscal_caxpy(
                     n, (char*)&c_b1, &c__1, lda, tcomp
                );
                *tcomp *= *m;
	    }
	} else if (beta->r != 0.f || beta->i != 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += tn * tm * 12;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
                *tcomp += tn * tm * 22;
	    } else {
		hscal_caxpy(
                     n, cbeta, &c__1, lda, tcomp
                );
                *tcomp *= *m;
	    }
	} else {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += tn * tm * 4;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
		hscal_cscal(
                     m, calpha, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	}
    }

    return HSCAL_SUCCESS;
}
}

#endif
