
#ifndef __HSCAL_PTZB_CMMTADD_HSCALFUNC_HH
#define __HSCAL_PTZB_CMMTADD_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_cmmtadd(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
hscalcomplex c_b1 = {1.f,0.f};
int c__1 = 1;
hscalcomplex *alpha = (hscalcomplex*)calpha;
hscalcomplex *beta = (hscalcomplex*)cbeta;
hscaldoublereal tm, tn;

*tcomp = 0.;
{
    tm = (double)(*m);
    tn = (double)(*n);

    if (*m >= *n) {
	if (alpha->r == 1.f && alpha->i == 0.f) {
	    if (beta->r == 0.f && beta->i == 0.f) {
	        hscal_ccopy(
                     m, &c__1, ldb, tcomp
                );
                *tcomp *= *n;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                *tcomp += tn * tm * 16;
	    } else {
                hscal_caxpy(
                     m, (char*)(&c_b1), &c__1, ldb, tcomp
                );
                *tcomp *= *n;
	    }
	} else if (alpha->r != 0.f || alpha->i != 0.f) {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += tn * tm * 12;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                *tcomp += tn * tm * 22;
	    } else {
                hscal_caxpy(
                     m, calpha, &c__1, ldb, tcomp
                );
                *tcomp *= *n;
	    }
	} else {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += tn * tm * 4;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
         	hscal_cscal(
                     n, cbeta, &c__1, tcomp
                );
                *tcomp *= *m;
	    }
	}
    } else {
	if (alpha->r == 1.f && alpha->i == 0.f) {
	    if (beta->r == 0.f && beta->i == 0.f) {
                hscal_ccopy(
                     n, lda, &c__1, tcomp
                );
                *tcomp *= *m;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                *tcomp += tn * tm * 16;
	    } else {
   	        hscal_caxpy(
                     n, (char*)(&c_b1), lda, &c__1, tcomp
                );
                *tcomp *= *m;
	    }
	} else if (alpha->r != 0.f || alpha->i != 0.f) {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += tn * tm * 12;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                *tcomp += tn * tm * 22;
	    } else {
  	        hscal_caxpy(
                     n, calpha, lda, &c__1, tcomp
                );
                *tcomp *= *m;
	    }
	} else {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += tn * tm * 4;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                hscal_cscal(
                     n, cbeta, &c__1, tcomp
                );
                *tcomp *= *m;
	    }
	}
    }
}

return HSCAL_SUCCESS;
}

#endif

