
#ifndef __HSCAL_PTZB_CTZSCAL_HSCALFUNC_HH
#define __HSCAL_PTZB_CTZSCAL_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_ctzscal(
    char *uplo, 
    int *m, 
    int *n, 
    int *ioffd, 
    char *calpha, 
    int *lda,
    double *tcomp
)
{
hscalcomplex c_b2 = {0.f,0.f};
int c__1 = 1;
hscalcomplex *alpha = (hscalcomplex*)calpha;
hscaldoublereal tm, tn;

*tcomp = 0.;

{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4;
    hscalcomplex q__1;
    int j, mn, jtmp;

    if (*m <= 0 || *n <= 0) {
	return HSCAL_SUCCESS;
    }

    if (alpha->r == 1.f && alpha->i == 0.f) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (alpha->r == 0.f && alpha->i == 0.f) {
	hscal_ctzpad(
             uplo, "N", m, n,
             ioffd, (char*)(&c_b2), (char*)(&c_b2), lda,
             tcomp
        );
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(uplo, "L")) {
	i__1 = 0, i__2 = -(*ioffd);
	mn = max(i__1,i__2);
	i__1 = min(mn,*n);
	{
            double t;
	    hscal_cscal(
                 m, calpha, &c__1,
                 &t
            );
            *tcomp += t*i__1;
	}
	i__2 = *m - *ioffd;
	i__1 = min(i__2,*n);
	for (j = mn + 1; j <= i__1; ++j) {
	    jtmp = j + *ioffd;
	    if (*m >= jtmp) {
                double t;
		i__2 = *m - jtmp + 1;
		hscal_cscal(
                     &i__2, calpha, &c__1,
                     &t
                );
                *tcomp += t;
	    }
	}
    } else if (hscal_lsame(uplo, "U")) {
	i__1 = *m - *ioffd;
	mn = min(i__1,*n);
	i__1 = 0, i__2 = -(*ioffd);
	i__3 = mn;
	for (j = max(i__1,i__2) + 1; j <= i__3; ++j) {
            double t;
	    i__1 = j + *ioffd;
	    hscal_cscal(
                 &i__1, calpha, &c__1,
                 &t
            );
            *tcomp += t;
	}
	i__3 = *n;
	{
            double t;
	    hscal_cscal(
                 m, calpha, &c__1,
                 &t
            );
            *tcomp += t*(i__3 - max(0,mn));
	}
    } else if (hscal_lsame(uplo, "D")) {
	i__3 = 0, i__1 = -(*ioffd);
	i__4 = *m - *ioffd;
	i__2 = min(i__4,*n);
        j = max(i__3,i__1);
        *tcomp += ((i__2 - j) * 13);
    } else {
	{
            double t;
	    hscal_cscal(
                 m, calpha, &c__1,
                 &t
            );
            *tcomp += t*tn;
	}
    }
}

return HSCAL_SUCCESS;
}

#endif

