
#ifndef __HSCAL_PTZB_DASCAL_HSCALFUNC_HH
#define __HSCAL_PTZB_DASCAL_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_dascal(
    int *n,
    char *calpha,
    int *incx,
    double *tcomp
)
{
    double *alpha = (double*)calpha;
    int i__, m, ix, mp1, info;

    *tcomp = 0.;

    info = 0;
    if (*n < 0) {
        info = 1;
    } else if (*incx == 0) {
        info = 4;
    }
    if (info != 0) {
        return HSCAL_SUCCESS;
    }

    if (*n <= 0) {
        return HSCAL_SUCCESS;
    }

    if (*incx == 1) {
        goto L40;
    }

    if (*alpha == 0.) {
        *tcomp += (*n);
    } else if (*alpha == 1.) {
        *tcomp += (*n);
    } else {
        *tcomp += (*n);
    }

    return HSCAL_SUCCESS;
L40:
    m = *n % 4;

    if (m == 0) {
        goto L80;
    }

    if (*alpha == 0.) {
        *tcomp += m;
    } else if (*alpha == 1.) {
        *tcomp += m;
    } else {
        *tcomp += m;
    }

    if (*n < 4) {
        return HSCAL_SUCCESS;
    }

L80:
    if (*alpha == 0.) {
       *tcomp += iceil((*n - m), 4)*4;
    } else if (*alpha == 1.) {
       *tcomp += iceil((*n - m), 4)*4;
    } else {
       *tcomp += iceil((*n - m), 4)*4;
    }

    return HSCAL_SUCCESS;
}

#endif

