
#ifndef __HSCAL_PTZB_DMMDDA_HSCALFUNC_HH
#define __HSCAL_PTZB_DMMDDA_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_dmmdda(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta, 
    int *ldb,
    double *tcomp
)
{
int c__1 = 1;
hscaldoublereal c_b8 = 1.;

hscaldoublereal *alpha = (hscaldoublereal*)calpha;
hscaldoublereal *beta = (hscaldoublereal*)cbeta;
hscaldoublereal tm, tn;

*tcomp = 0.;

{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;
    int i__, j;

    tm = (double)(*m);
    tn = (double)(*n);

    if (*beta == 1.) {
	if (*alpha == 0.) {
            hscal_dcopy(
                 m, &c__1, &c__1, tcomp
            );
            *tcomp *= *n;
	} else if (*alpha != 1.) {
            *tcomp += (tn * tm * 8);
	} else {
	    hscal_daxpy(
                 m, (char*)&c_b8, &c__1, &c__1, tcomp
            );
            *tcomp *= *n;
	}
    } else if (*beta != 0.) {
	if (*alpha == 0.) {
            *tcomp += (tn * tm * 5);
	} else if (*alpha != 1.) {
            *tcomp += (tn * tm * 9);
	} else {
	    hscal_daxpy(
                 m, cbeta, &c__1, &c__1, tcomp
            );
            *tcomp *= *n;
	}
    } else {
	if (*alpha == 0.) {
            *tcomp += (tn * tm * 2);
	} else if (*alpha != 1.) {
            hscal_dscal(
                 m, calpha, &c__1,
                 tcomp
            );
            *tcomp *= *n;
	}
    }

    return HSCAL_SUCCESS;

}
}

#endif
