
#ifndef __HSCAL_PTZB_DSET_HSCALFUNC_HH
#define __HSCAL_PTZB_DSET_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_dset(
    int *n, 
    char *calpha,
    int *incx,
    double *tcomp
)
{
    int m, info;
    hscaldoublereal *alpha = (hscaldoublereal*)calpha;

    *tcomp = 0.;

    info = 0;

    if (*n < 0) {
        info = 1;
    } else if (*incx == 0) {
        info = 4;
    }

    if (info != 0) {
        return HSCAL_SUCCESS;
    }

    if (*n <= 0) {
        return HSCAL_SUCCESS;
    }

    if (*incx == 1) {
       m = *n % 4;

       if (m == 0) {
          *tcomp += iceil((*n - m), 4) * 4;
          return HSCAL_SUCCESS;  
       }

       *tcomp += m;

       if (*n < 4) {
          return HSCAL_SUCCESS;
       }

       *tcomp += iceil((*n - m), 4) * 4;

       return HSCAL_SUCCESS;
    }

    *tcomp += *n * 2;

    return HSCAL_SUCCESS;
}

#endif

