
#ifndef __HSCAL_PTZB_IMMADD_HSCALFUNC_HH
#define __HSCAL_PTZB_IMMADD_HSCALFUNC_HH

/*
*  Include for macros
*/


#include "../../../include/hscalapack.h"

int hscal_immadd(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta, 
    int *ldb,
    double *tcomp
)
{
    int *alpha = (int*)calpha;
    int *beta = (int*)cbeta;
    hscaldoublereal tm, tn;

    *tcomp = 0.;

    tm = (double)(*m);
    tn = (double)(*n);

    if (*alpha == 1) {
	if (*beta == 0) {
           *tcomp += (tn * tm * 4);
	} else if (*beta != 1) {
           *tcomp += (tn * tm * 8);
	} else {
           *tcomp += (tn * tm * 7);
	}
    } else if (*alpha != 0) {
	if (*beta == 0) {
           *tcomp += (tn * tm * 5);
	} else if (*beta != 1) {
           *tcomp += (tn * tm * 9);
	} else {
           *tcomp += (tn * tm * 8);
	}
    } else {
	if (*beta == 0) {
           *tcomp += (tn * tm * 2);
	} else if (*beta != 1) {
           *tcomp += (tn * tm * 5);
	}
    }

    return HSCAL_SUCCESS;
}

#endif

