
#ifndef __HSCAL_PTZB_SMMDDACT_HSCALFUNC_HH
#define __HSCAL_PTZB_SMMDDACT_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_smmddact(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta, 
    int *ldb,
    double *tcomp
)
{
int c__1 = 1;
hscalreal c_b7 = 1.f;
hscalreal *alpha = (hscalreal*)calpha;
hscalreal *beta = (hscalreal*)cbeta;
hscaldoublereal tm, tn;

*tcomp = 0.;
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;
    int i__, j;

    tm = (double)(*m);
    tn = (double)(*n);

    if (*m >= *n) {
	if (*beta == 1.f) {
	    if (*alpha == 0.f) {
		hscal_scopy(
                     m, ldb, &c__1, tcomp
                );
                *tcomp *= *n;
	    } else if (*alpha != 1.f) {
                *tcomp += (tn * tm * 8);
	    } else {
		hscal_saxpy(
                     m, (char*)&c_b7, ldb, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	} else if (*beta != 0.f) {
	    if (*alpha == 0.f) {
                *tcomp += (tn * tm * 5);
	    } else if (*alpha != 1.f) {
                *tcomp += (tn * tm * 9);
	    } else {
		hscal_saxpy(
                     m, cbeta, ldb, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	} else {
	    if (*alpha == 0.f) {
                *tcomp += (tn * tm * 2);
	    } else if (*alpha != 1.f) {
		hscal_sscal(
                     m, calpha, &c__1, tcomp
                );
                *tcomp *= *n;
            }
	}
    } else {
	if (*beta == 1.f) {
	    if (*alpha == 0.f) {
		hscal_scopy(
                     n, &c__1, lda, tcomp
                );
                *tcomp *= *m;
	    } else if (*alpha != 1.f) {
                *tcomp += (tn * tm * 8);
	    } else {
		hscal_saxpy(
                     n, (char*)&c_b7, &c__1, lda, tcomp
                );
                *tcomp *= *m;
	    }
	} else if (*beta != 0.f) {
	    if (*alpha == 0.f) {
                *tcomp += (tn * tm * 5);
	    } else if (*alpha != 1.f) {
                *tcomp += (tn * tm * 9);
	    } else {
		hscal_saxpy(
                     n, cbeta, &c__1, lda,
                     tcomp
                );
                *tcomp *= *m;
	    }
	} else {
	    if (*alpha == 0.f) {
                *tcomp += (tn * tm * 2);
	    } else if (*alpha != 1.f) {
		hscal_sscal(
                     m, calpha, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	}
    }

    return HSCAL_SUCCESS;
}
}

#endif
