
#ifndef __HSCAL_PTZB_SMMTCADD_HSCALFUNC_HH
#define __HSCAL_PTZB_SMMTCADD_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_smmtcadd(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta, 
    int *ldb,
    double *tcomp
)
{
int c__1 = 1;
hscalreal c_b7 = 1.f;
hscalreal *alpha = (hscalreal*)calpha;
hscalreal *beta = (hscalreal*)cbeta;
hscaldoublereal tm, tn;

*tcomp = 0.;
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;
    int i__, j;

    tm = (double)(*m);
    tn = (double)(*n);

    if (*m >= *n) {
	if (*alpha == 1.f) {
	    if (*beta == 0.f) {
		i__1 = *n;
		{
                    double t;
		    hscal_scopy(
                         m, &c__1, ldb,
                         &t
                    );
                    *tcomp += t*i__1;
		}
	    } else if (*beta != 1.f) {
                *tcomp += (tn * tm * 8);
	    } else {
		i__1 = *n;
		{
                    double t;
		    hscal_saxpy(
                         m, (char*)&c_b7, &c__1, ldb,
                         &t
                    );
                    *tcomp += t*i__1;
		}
	    }
	} else if (*alpha != 0.f) {
	    if (*beta == 0.f) {
                *tcomp += (tn * tm * 5);
	    } else if (*beta != 1.f) {
                *tcomp += (tn * tm * 9);
	    } else {
		i__1 = *n;
		{
                    double t;
		    hscal_saxpy(
                         m, calpha, &c__1, ldb,
                         &t
                    );
                    *tcomp += t*i__1;
		}
	    }
	} else {
	    if (*beta == 0.f) {
                *tcomp += (tn * tm * 2);
	    } else if (*beta != 1.f) {
		i__1 = *m;
		{
                    double t;
		    hscal_sscal(
                         n, cbeta, &c__1,
                         &t
                    );
                    *tcomp += t*i__1;
		}
	    }
	}
    } else {
	if (*alpha == 1.f) {
	    if (*beta == 0.f) {
		i__1 = *m;
		{
                    double t;
		    hscal_scopy(
                         n, lda, &c__1,
                         &t
                    );
                    *tcomp += t*i__1;
		}
	    } else if (*beta != 1.f) {
                *tcomp += (tn * tm * 8);
	    } else {
		i__1 = *m;
		{
                    double t;
		    hscal_saxpy(
                         n, (char*)&c_b7, lda, &c__1,
                         &t
                    );
                    *tcomp += t*i__1;
		}
	    }
	} else if (*alpha != 0.f) {
	    if (*beta == 0.f) {
                *tcomp += (tn * tm * 5);
	    } else if (*beta != 1.f) {
                *tcomp += (tn * tm * 9);
	    } else {
		i__1 = *m;
		{
                    double t;
		    hscal_saxpy(
                         n, calpha, lda, &c__1,
                         &t
                    );
                    *tcomp += t*i__1;
		}
	    }
	} else {
	    if (*beta == 0.f) {
                *tcomp += (tn * tm * 2);
	    } else if (*beta != 1.f) {
		i__1 = *m;
		{
                    double t;
		    hscal_sscal(
                         n, cbeta, &c__1,
                         &t
                    );
                    *tcomp += t*i__1;
		}
	    }
	}
    }
}

return HSCAL_SUCCESS;
}

#endif
