
#ifndef __HSCAL_PTZB_SSET_HSCALFUNC_HH
#define __HSCAL_PTZB_SSET_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_sset(
    int *n, 
    char *calpha, 
    int *incx,
    double *tcomp
)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    int i__, m, ix, mp1, info;

    hscalreal *alpha = (hscalreal*)calpha;

    info = 0;

    *tcomp = 0.;

    if (*n < 0) {
	info = 1;
    } else if (*incx == 0) {
	info = 4;
    }

    if (info != 0) {
	return HSCAL_SUCCESS;
    }

/*     Quick return if possible. */

    if (*n <= 0) {
	return HSCAL_SUCCESS;
    }

/*     Form  x := alpha */

    if (*incx == 1) {
       m = *n % 4;

       if (m == 0) {
          *tcomp += iceil((*n - m), 4) * 4;
          return HSCAL_SUCCESS;
       }

       *tcomp += m;
       if (*n < 4) {
          return HSCAL_SUCCESS;
       }

       *tcomp += iceil((*n - m), 4) * 4;
       return HSCAL_SUCCESS;
    }

/*     code for increments not equal to 1 */

    *tcomp += *n * 2;

    return HSCAL_SUCCESS;

}

#endif
