
#ifndef __HSCAL_PTZB_STZPAD_HSCALFUNC_HH
#define __HSCAL_PTZB_STZPAD_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_stzpad(
    char *uplo, 
    char *herm, 
    int *m, 
    int *n,
    int *ioffd, 
    char *calpha, 
    char *cbeta, 
    int *lda,
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4;
    int i__, j, mn, jtmp;
    hscalreal *alpha = (hscalreal*)calpha;
    hscalreal *beta = (hscalreal*)cbeta;
    hscaldoublereal tm, tn;

    *tcomp = 0.;

    tm = (double)(*m);
    tn = (double)(*n);

    if (*m <= 0 || *n <= 0) {
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(uplo, "L")) {
	i__1 = 0, i__2 = -(*ioffd);
	mn = max(i__1,i__2);
	i__1 = min(mn,*n);

        *tcomp += i__1 * tm * 2;

	if (hscal_lsame(herm, "Z")) {
	    i__2 = *m - *ioffd;
	    i__1 = min(i__2,*n);
	    for (j = mn + 1; j <= i__1; ++j) {
		jtmp = j + *ioffd;
		i__2 = *m;
                *tcomp += ((i__2 - jtmp) * 2 + 2);
	    }
	} else {
	    i__2 = *m - *ioffd;
	    i__1 = min(i__2,*n);
	    for (j = mn + 1; j <= i__1; ++j) {
		jtmp = j + *ioffd;
		i__2 = *m;
                *tcomp += ((i__2 - jtmp) * 2 + 4);
	    }
	}
    } else if (hscal_lsame(uplo, "U")) {
	i__1 = *m - *ioffd;
	mn = min(i__1,*n);
	if (hscal_lsame(herm, "Z")) {
	    i__1 = 0, i__2 = -(*ioffd);
	    i__3 = mn;
	    for (j = max(i__1,i__2) + 1; j <= i__3; ++j) {
		jtmp = j + *ioffd;
		i__1 = jtmp - 1;
                *tcomp += (i__1 * 2 + 2);
	    }
	} else {
	    i__3 = 0, i__1 = -(*ioffd);
	    i__2 = mn;
	    for (j = max(i__3,i__1) + 1; j <= i__2; ++j) {
		jtmp = j + *ioffd;
		i__3 = jtmp - 1;
                *tcomp += (i__3 * 2 + 4);
	    }
	}
        *tcomp += (tm * 2)*(tn - max(0,mn));
    } else if (hscal_lsame(uplo, "D")) {
	if (! hscal_lsame(herm, "Z")) {
	    if (*ioffd < *m && *ioffd > -(*n)) {
		i__2 = 0, i__3 = -(*ioffd);
		i__4 = *m - *ioffd;
		i__1 = min(i__4,*n);
                j = max(i__2,i__3);
                *tcomp += (i__1 - j)*3;
	    }
	}
    } else {
        *tcomp += (tn * tm * 2);
	if (*alpha != *beta && *ioffd < *m && *ioffd > -(*n)) {
	    i__1 = 0, i__2 = -(*ioffd);
	    i__4 = *m - *ioffd;
	    i__3 = min(i__4,*n);
            j = max(i__1,i__2);
            *tcomp += (i__3 - j) * 3;
	}
    }

    return HSCAL_SUCCESS;
}

#endif

