
#ifndef __HSCAL_CB_ZAHEMV_HH
#define __HSCAL_CB_ZAHEMV_HH



#include "../../../include/hscalapack.h"

int hscal_zahemv(
    char *uplo, 
    int *n, 
    char *calpha, 
    int *lda, 
    int *incx, 
    char *cbeta,
    int *incy,
    double *tcomp
)
{
    hscaldoublereal *alpha = (hscaldoublereal*)calpha;
    hscaldoublereal *beta  = (hscaldoublereal*)cbeta;
    hscaldoublereal tn;

    int a_dim1, a_offset, i__1, i__2, i__3;

    int i__, j, ix, iy, jx, jy, kx, ky, info;

    *tcomp = 0.;
    info = 0;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
        info = 1;
    } else if (*n < 0) {
        info = 2;
    } else if (*lda < max(1,*n)) {
        info = 5;
    } else if (*incx == 0) {
        info = 7;
    } else if (*incy == 0) {
        info = 10;
    }

    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || *alpha == 0. && *beta == 1.) {
        return HSCAL_SUCCESS;
    }

    if (*beta != 1.) {
        if (*incy == 1) {
            if (*beta == 0.) {
               *tcomp += (*n);
            } else {
               *tcomp += (*n);
            }
        } else {
            if (*beta == 0.) {
               *tcomp += (*n)*2;
            } else {
               *tcomp += (*n)*2;
            }
        }
    }

    if (*alpha == 0.) {
        return HSCAL_SUCCESS;
    }

    tn = (double)(*n);

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1 && *incy == 1) {
            *tcomp += 8*tn + 10*(((tn-1)*tn)/2);
	} else {
            *tcomp += 10*tn + 12*(((tn-1)*tn)/2);
	}
    } else {
	if (*incx == 1 && *incy == 1) {
            *tcomp += 8*tn + 10*(((tn-1)*tn)/2);
	} else {
            *tcomp += 10*tn + 12*(((tn-1)*tn)/2);
	}
    }

    return HSCAL_SUCCESS;
}

#endif
