
#ifndef __HSCAL_PTZB_ZHESCAL_HSCALFUNC_HH
#define __HSCAL_PTZB_ZHESCAL_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_zhescal(
    char *uplo, 
    int *m, 
    int *n, 
    int *ioffd, 
    char *calpha, 
    int *lda,
    double *tcomp
)
{
hscaldoublecomplex c_b1 = {0.,0.};
int c__1           = 1;
hscaldoublereal *alpha  = (hscaldoublereal*)calpha;
hscaldoublereal tm, tn;

*tcomp             = 0.;
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4;
    int j, mn, jtmp;

    if (*m <= 0 || *n <= 0) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (*alpha == 1.) {
	if (hscal_lsame(uplo, "L") || hscal_lsame(uplo, "U") || hscal_lsame(uplo, "D")) {
	    i__1 = 0, i__2 = -(*ioffd);
	    i__4 = *m - *ioffd;
	    i__3 = min(i__4,*n);
            *tcomp += 10*(i__3 - max(i__1,i__2));
	}
	return HSCAL_SUCCESS;
    } else if (*alpha == 0.) {
	hscal_ztzpad(
             uplo, "N", m, n, ioffd, (char*)&c_b1, (char*)&c_b1, lda, 
             tcomp
        );
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(uplo, "L")) {
	i__3 = 0, i__1 = -(*ioffd);
	mn = max(i__3,i__1);
	i__3 = min(mn,*n);
	{
            double t;
	    hscal_zdscal(
                 m, (char*)alpha, &c__1,
                 &t
            );
            *tcomp += t*i__3;
	}
	i__1 = *m - *ioffd;
	i__3 = min(i__1,*n);
	for (j = mn + 1; j <= i__3; ++j) {
            *tcomp += 10;
	    jtmp = j + *ioffd;
	    if (*m > jtmp) {
                double t;
		i__1 = *m - jtmp;
		hscal_zdscal(
                     (int*)&i__1, (char*)alpha, &c__1,
                     &t
                );
                *tcomp += t;
	    }
	}

    } else if (hscal_lsame(uplo, "U")) {
	i__3 = *m - *ioffd;
	mn = min(i__3,*n);
	i__3 = 0, i__1 = -(*ioffd);
	i__2 = mn;
	for (j = max(i__3,i__1) + 1; j <= i__2; ++j) {
            double t;
	    jtmp = j + *ioffd;
	    i__3 = jtmp - 1;
	    hscal_zdscal(
                 (int*)&i__3, (char*)alpha, &c__1,
                 &t
            );
            *tcomp += t;
            *tcomp += 10;
	}
	{
            double t;
	    hscal_zdscal(
                 m, (char*)alpha, &c__1,
                 &t
            );
            *tcomp += t*(tn - max(0,mn));
	}
    } else if (hscal_lsame(uplo, "D")) {
	i__2 = 0, i__3 = -(*ioffd);
	i__4 = *m - *ioffd;
	i__1 = min(i__4,*n);
        *tcomp += 10*(i__1 - max(i__2,i__3));
    } else {
	{
            double t;
	    hscal_zdscal(
                 m, (char*)alpha, &c__1,
                 &t
            );
            *tcomp += t*tn;
	}

    }

    return HSCAL_SUCCESS;
}
}

#endif
