
#ifndef __HSCAL_PTZB_ZMMTADD_HSCALFUNC_HH
#define __HSCAL_PTZB_ZMMTADD_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_zmmtadd(
    int *m, 
    int *n, 
    char *calpha,
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
hscaldoublecomplex c_b1 = {1.,0.};
hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
hscaldoublecomplex *beta = (hscaldoublecomplex*)cbeta;
int c__1 = 1;
hscaldoublereal tm, tn;

*tcomp = 0.;
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4, i__5;
    int i__, j;

    tm = (double)(*m);
    tn = (double)(*n);

    if (*m >= *n) {
	if (alpha->r == 1. && alpha->i == 0.) {
	    if (beta->r == 0. && beta->i == 0.) {
		{
                    double t;
		    hscal_zcopy(
                         m, &c__1, ldb,
                         &t
                    );
                    *tcomp += t*tn;
		}
	    } else if (beta->r != 1. || beta->i != 0.) {
                *tcomp += (tn * tm * 16);
	    } else {
		{
                    double t;
		    hscal_zaxpy(
                         m, (char*)&c_b1, &c__1, ldb,
                         &t
                    );
                    *tcomp += t*tn;
		}
	    }
	} else if (alpha->r != 0. || alpha->i != 0.) {
	    if (beta->r == 0. && beta->i == 0.) {
                *tcomp += (tn * tm * 12);
	    } else if (beta->r != 1. || beta->i != 0.) {
                *tcomp += (tn * tm * 22);
	    } else {
		{
                    double t;
		    hscal_zaxpy(
                         m, calpha, &c__1, ldb,
                         &t
                    );
                    *tcomp += t*tn;
		}
	    }
	} else {
	    if (beta->r == 0. && beta->i == 0.) {
                *tcomp += (tn * tm * 4);
	    } else if (beta->r != 1. || beta->i != 0.) {
		{
                    double t;
		    hscal_zscal(
                         n, cbeta, &c__1,
                         &t
                    );
                    *tcomp += t*tm;
		}
	    }
	}
    } else {
	if (alpha->r == 1. && alpha->i == 0.) {
	    if (beta->r == 0. && beta->i == 0.) {
		{
                    double t;
		    hscal_zcopy(
                         n, lda, &c__1,
                         &t
                    );
                    *tcomp += t*tm;
		}
	    } else if (beta->r != 1. || beta->i != 0.) {
                *tcomp += (tn * tm * 16);
	    } else {
		{
                    double t;
		    hscal_zaxpy(
                         n, (char*)&c_b1, lda, &c__1,
                         &t
                    );
                    *tcomp += t*tm;
		}
	    }
	} else if (alpha->r != 0. || alpha->i != 0.) {
	    if (beta->r == 0. && beta->i == 0.) {
                *tcomp += (tn * tm * 12);
	    } else if (beta->r != 1. || beta->i != 0.) {
                *tcomp += (tn * tm * 22);
	    } else {
		{
                    double t;
		    hscal_zaxpy(
                         n, calpha, lda, &c__1,
                         &t
                    );
                    *tcomp += t*tm;
		}
	    }
	} else {
	    if (beta->r == 0. && beta->i == 0.) {
                *tcomp += (tn * tm * 4);
	    } else if (beta->r != 1. || beta->i != 0.) {
		{
                    double t;
		    hscal_zscal(
                         n, cbeta, &c__1,
                         &t
                    );
                    *tcomp += t*tm;
		}
	    }
	}
    }
}

return HSCAL_SUCCESS;
}

#endif
