
#ifndef __HSCAL_PTZB_ZSYMV_HSCALFUNC_HH
#define __HSCAL_PTZB_ZSYMV_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_zsymv(
    char *uplo, 
    int *n, 
    char *calpha, 
    int *lda, 
    int *incx, 
    char *cbeta, 
    int *incy,
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4, i__5;
    int i__, j, ix, iy, jx, jy, kx, ky, info;
    hscaldoublereal tn;

    hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
    hscaldoublecomplex *beta  = (hscaldoublecomplex*)cbeta;

    info = 0;
    *tcomp = 0.;
    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*lda < max(1,*n)) {
	info = 5;
    } else if (*incx == 0) {
	info = 7;
    } else if (*incy == 0) {
	info = 10;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || alpha->r == 0. && alpha->i == 0. && (beta->r == 1. && 
	    beta->i == 0.)) {
	return HSCAL_SUCCESS;
    }

    tn = (double)(*n);

    if (beta->r != 1. || beta->i != 0.) {
	if (*incy == 1) {
	    if (beta->r == 0. && beta->i == 0.) {
             *tcomp += (*n)*3;
	    } else {
             *tcomp += (*n)*10;
	    }
	} else {
	    if (beta->r == 0. && beta->i == 0.) {
             *tcomp += (*n)*4;
	    } else {
             *tcomp += (*n)*11;
	    }
	}
    }

    if (alpha->r == 0. && alpha->i == 0.) {
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1 && *incy == 1) {
            *tcomp += 36*tn + 29*(((tn-1)*tn)/2);
	} else {
            *tcomp += 36*tn + 29*(((tn-1)*tn)/2);
	}
    } else {
	if (*incx == 1 && *incy == 1) {
            *tcomp += 36*tn + 29*(((tn-1)*tn)/2);
	} else {
            *tcomp += 36*tn + 29*(((tn-1)*tn)/2);
	}
    }

    return HSCAL_SUCCESS;
}

#endif
