
#ifndef __HSCAL_PTZB_ZSYR_HSCALFUNC_HH
#define __HSCAL_PTZB_ZSYR_HSCALFUNC_HH

#include "../../../include/hscalapack.h"

int hscal_zsyr(
    char   *uplo, 
    int    *n, 
    char   *calpha, 
    int    *incx,
    int    *lda, 
    double *tcomp
)
{
    hscalinteger info;
    hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
    double tn;

    info    = 0;
    *tcomp = 0.;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*lda < max(1,*n)) {
	info = 7;
    }
    if (info != 0) {
	hscal_xerbla("ZSYR", &info);
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || alpha->r == 0. && alpha->i == 0.) {
	return HSCAL_SUCCESS;
    }

    tn = (double)(*n);

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1) {
            *tcomp += 8*tn + (((tn+1)*tn)/2)*14;
	} else {
            *tcomp += 8*tn + (((tn+1)*tn)/2)*14;
	}
    } else {
	if (*incx == 1) {
            *tcomp += 8*tn + (((tn+1)*tn)/2)*14;
	} else {
            *tcomp += 8*tn + (((tn+1)*tn)/2)*14;
	}
    }

    return HSCAL_SUCCESS;
}

#endif

