
#ifndef __HSCAL_PTZB_ZTZCNJG_HSCALFUNC_HH
#define __HSCAL_PTZB_ZTZCNJG_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_ztzcnjg(
    char *uplo, 
    int *m, 
    int *n, 
    int *ioffd, 
    char *calpha, 
    int *lda,
    double *tcomp
)
{
hscaldoublecomplex c_b2 = {0.,0.};
hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
hscaldoublereal tm, tn;

{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4;
    int i__, j, mn, jtmp;

    *tcomp = 0.;

    if (*m <= 0 || *n <= 0) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (alpha->r == 0. && alpha->i == 0.) {
	 hscal_ztzpad(
            uplo, "N", m, n, ioffd, (char*)&c_b2, (char*)&c_b2, lda, 
            tcomp
       );
    } else if (alpha->r == 1. && alpha->i == 0.) {
	if (hscal_lsame(uplo, "L")) {
	    i__1 = 0, i__2 = -(*ioffd);
	    mn = max(i__1,i__2);
	    i__1 = min(mn,*n);
            *tcomp += (i__1)*(*m)*7;
	    i__2 = *m - *ioffd;
	    i__1 = min(i__2,*n);
	    for (j = mn + 1; j <= i__1; ++j) {
                *tcomp += 7*(tm - j - *ioffd + 1);
	    }
	} else if (hscal_lsame(uplo, "U")) {
	    i__1 = *m - *ioffd;
	    mn = min(i__1,*n);
	    i__1 = 0, i__2 = -(*ioffd);
	    i__3 = mn;
	    for (j = max(i__1,i__2) + 1; j <= i__3; ++j) {
                *tcomp += 7*(j + *ioffd);
	    }
	    i__3 = *n;
	    for (j = max(0,mn) + 1; j <= i__3; ++j) {
                *tcomp += 7*tm;
	    }
	} else if (hscal_lsame(uplo, "D")) {
	    i__3 = 0, i__1 = -(*ioffd);
	    i__4 = *m - *ioffd;
	    i__2 = min(i__4,*n);
            *tcomp += 8*(i__2 - max(i__3,i__1));
	} else {
          *tcomp += tn*tm*7;
	}
    } else {
	if (hscal_lsame(uplo, "L")) {
	    i__2 = 0, i__3 = -(*ioffd);
	    mn = max(i__2,i__3);
	    i__2 = min(mn,*n);
            *tcomp += (i__2)*tm*13;
	    i__3 = *m - *ioffd;
	    i__2 = min(i__3,*n);
	    for (j = mn + 1; j <= i__2; ++j) {
                *tcomp += 13*(tm - j - *ioffd +1);
	    }
	} else if (hscal_lsame(uplo, "U")) {
	    i__2 = *m - *ioffd;
	    mn = min(i__2,*n);
	    i__2 = 0, i__3 = -(*ioffd);
	    i__1 = mn;
	    for (j = max(i__2,i__3) + 1; j <= i__1; ++j) {
                *tcomp += 13*(j + *ioffd);
	    }
	    i__1 = *n;
	    for (j = max(0,mn) + 1; j <= i__1; ++j) {
                *tcomp += 13*tm;
	    }
	} else if (hscal_lsame(uplo, "D")) {
	    i__1 = 0, i__2 = -(*ioffd);
	    i__4 = *m - *ioffd;
	    i__3 = min(i__4,*n);
            *tcomp += 14*(i__3 - max(i__1,i__2));
	} else {
          *tcomp += tn*tm*13;
	}
    }
    return HSCAL_SUCCESS;
}
}

#endif
