
#ifndef __HSCAL_PTZB_ZTZPAD_HSCALFUNC_HH
#define __HSCAL_PTZB_ZTZPAD_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_ztzpad(
    char *uplo, 
    char *herm, 
    int *m, 
    int *n,
    int *ioffd, 
    char *calpha, 
    char *cbeta, 
    int *lda,
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4;
    hscaldoublecomplex z__1;
    int i__, j, mn, jtmp;
    hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
    hscaldoublecomplex *beta = (hscaldoublecomplex*)cbeta;
    hscaldoublereal tm, tn;

    *tcomp = 0.;

    if (*m <= 0 || *n <= 0) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (hscal_lsame(uplo, "L")) {
	i__1 = 0, i__2 = -(*ioffd);
	mn = max(i__1,i__2);
	i__1 = min(mn,*n);
        
        *tcomp += i__1 * tm * 4;

	if (hscal_lsame(herm, "Z")) {
	    i__2 = *m - *ioffd;
	    i__1 = min(i__2,*n);
	    for (j = mn + 1; j <= i__1; ++j) {
		jtmp = j + *ioffd;
		i__2 = *m;
                *tcomp += ((i__2 - jtmp)*4+11);
	    }
	} else {
	    i__2 = *m - *ioffd;
	    i__1 = min(i__2,*n);
	    for (j = mn + 1; j <= i__1; ++j) {
		jtmp = j + *ioffd;
		i__2 = *m;
                *tcomp += ((i__2 - jtmp)*4+6);
	    }
	}
    } else if (hscal_lsame(uplo, "U")) {
	i__1 = *m - *ioffd;
	mn = min(i__1,*n);
	if (hscal_lsame(herm, "Z")) {
	    i__1 = 0, i__2 = -(*ioffd);
	    i__3 = mn;
	    for (j = max(i__1,i__2) + 1; j <= i__3; ++j) {
		jtmp = j + *ioffd;
		i__1 = jtmp - 1;
                *tcomp += (i__1*4+11);
	    }
	} else {
	    i__3 = 0, i__1 = -(*ioffd);
	    i__2 = mn;
	    for (j = max(i__3,i__1) + 1; j <= i__2; ++j) {
		jtmp = j + *ioffd;
		i__3 = jtmp - 1;
                *tcomp += (i__3*4+6);
	    }
	}

	i__2 = *n;
        j = max(0,mn);
        *tcomp += ((i__2 - j) * tm * 4);
    } else if (hscal_lsame(uplo, "D")) {
	if (hscal_lsame(herm, "Z")) {
	    if (*ioffd < *m && *ioffd > -(*n)) {
		i__2 = 0, i__3 = -(*ioffd);
		i__4 = *m - *ioffd;
		i__1 = min(i__4,*n);
                j = max(i__2,i__3);
                *tcomp += (i__1 - j) * 10;
	    }
	} else {
	    if (*ioffd < *m && *ioffd > -(*n)) {
		i__1 = 0, i__2 = -(*ioffd);
		i__4 = *m - *ioffd;
		i__3 = min(i__4,*n);
                j = max(i__1,i__2);
                *tcomp += (i__3 - j) * 5;
	    }
	}
    } else {
        *tcomp += (*m) * 4 * (*n);
	if ((alpha->r != beta->r || alpha->i != beta->i) && *ioffd < *m && *
		ioffd > -(*n)) {
	    i__3 = 0, i__1 = -(*ioffd);
	    i__4 = *m - *ioffd;
	    i__2 = min(i__4,*n);
            j = max(i__3,i__1);
            *tcomp += (i__2 - j) * 5;
	}
    }

    return HSCAL_SUCCESS;
}

#endif

