
#ifndef __HSCAL_PTZB_ZTZPADCPY_HSCALFUNC_HH
#define __HSCAL_PTZB_ZTZPADCPY_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_ztzpadcpy(
    char *uplo, 
    char *diag, 
    int *m,
    int *n,
    int *ioffd,
    int *lda,
    int *ldb,
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4;
    int i__, j, mn, itmp, jtmp;
    hscaldoublereal tm, tn;

    if (*m <= 0 || *n <= 0) {
	return HSCAL_SUCCESS;
    }

    *tcomp = 0.;
    tm = (double)(*m);
    tn = (double)(*n);

    if (hscal_lsame(uplo, "L")) {
	i__1 = 0, i__2 = -(*ioffd);
	mn = max(i__1,i__2);
	i__1 = min(mn,*n);
        *tcomp += (i__1)*tm*6;

	i__1 = *m - *ioffd;
	jtmp = min(i__1,*n);

	if (hscal_lsame(diag, "N")) {
	    i__1 = jtmp;
	    for (j = mn + 1; j <= i__1; ++j) {
		itmp = j + *ioffd;
		i__2 = itmp - 1;
                *tcomp += (i__2)*4;
		i__2 = *m;
                *tcomp += (i__2 - itmp + 1)*6;
	    }
	} else {
	    i__1 = jtmp;
	    for (j = mn + 1; j <= i__1; ++j) {
		itmp = j + *ioffd;
		i__2 = itmp - 1;
                *tcomp += (i__2)*4+4;
		i__2 = *m;
                *tcomp += (i__2 - itmp)*6;
	    }
	}

	i__1 = *n;
        *tcomp += (i__1 - jtmp)*tm*4;
    } else if (hscal_lsame(uplo, "U")) {
	i__1 = 0, i__2 = -(*ioffd);
	jtmp = max(i__1,i__2);
	i__1 = jtmp;
        *tcomp += (i__1)*(*m)*4;
	i__1 = *m - *ioffd;
	mn = min(i__1,*n);
	if (hscal_lsame(diag, "N")) {
	    i__1 = mn;
	    for (j = jtmp + 1; j <= i__1; ++j) {
		itmp = j + *ioffd;
		i__2 = itmp;
                *tcomp += (i__2)*6;
		i__2 = *m;
                *tcomp += (i__2 - itmp)*4;
	    }
	} else {
	    i__1 = mn;
	    for (j = jtmp + 1; j <= i__1; ++j) {
		itmp = j + *ioffd;
		i__2 = itmp - 1;
                *tcomp += (i__2)*6+4;
		i__2 = *m;
                *tcomp += (i__2 - itmp)*4;
	    }
	}

	i__1 = *n;
        j = max(0,mn) + 1;
        *tcomp += (i__1 - j)*tm*6;
    } else {
        *tcomp += tn*tm*6;
    }

    return HSCAL_SUCCESS;

/*     End of ZTZPADCPY */

} /* ztzpadcpy_ */

#endif
