
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_caxpy_benchmark(
    int     *n,
    hscalcomplex *ca,
    hscalcomplex *cx,
    int     *incx,
    hscalcomplex *cy,
    int     *incy
)
{
    caxpy_(
           n,
           (char*)ca,
           (char*)cx,
           incx,
           (char*)cy,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_daxpy_benchmark(
    int        *n,
    hscaldoublereal *da,
    hscaldoublereal *dx,
    int        *incx,
    hscaldoublereal *dy,
    int        *incy
)
{
    daxpy_(
           n,
           (char*)da,
           (char*)dx,
           incx,
           (char*)dy,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_saxpy_benchmark(
    int     *n,
    hscalreal *sa,
    hscalreal *sx,
    int     *incx,
    hscalreal *sy,
    int     *incy
)
{
    saxpy_(
           n,
           (char*)sa,
           (char*)sx,
           incx,
           (char*)sy,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_zaxpy_benchmark(
    int           *n,
    hscaldoublecomplex *za,
    hscaldoublecomplex *zx,
    int           *incx,
    hscaldoublecomplex *zy,
    int           *incy
)
{
    zaxpy_(
           n,
           (char*)za,
           (char*)zx,
           incx,
           (char*)zy,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

