
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_cgemm_benchmark(
    char *transa,
    char *transb,
    int     *m,
    int     *n,
    int     *k,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *b,
    int     *ldb,
    hscalcomplex *beta,
    hscalcomplex *c__,
    int     *ldc
)
{
    cgemm_(
           transa,
           transb,
           m,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dgemm_benchmark(
    char *transa,
    char *transb,
    int     *m,
    int     *n,
    int     *k,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    int     *lda,
    hscaldoublereal *b,
    int     *ldb,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    int     *ldc
)
{
    dgemm_(
           transa,
           transb,
           m,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_sgemm_benchmark(
    char *transa,
    char *transb,
    int     *m,
    int     *n,
    int     *k,
    hscalreal *alpha,
    hscalreal *a,
    int     *lda,
    hscalreal *b,
    int     *ldb,
    hscalreal *beta,
    hscalreal *c__,
    int     *ldc
)
{
    sgemm_(
           transa,
           transb,
           m,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_zgemm_benchmark(
    char          *transa,
    char          *transb,
    int           *m,
    int           *n,
    int           *k,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int           *lda,
    hscaldoublecomplex *b,
    int           *ldb,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    int           *ldc
)
{
    zgemm_(
           transa,
           transb,
           m,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

