
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_cgemv_benchmark(
    char    *trans,
    int     *m,
    int     *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *x,
    int     *incx,
    hscalcomplex *beta,
    hscalcomplex *y,
    int     *incy
)
{
    cgemv_(
           trans,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)x,
           incx,
           (char*)beta,
           (char*)y,
           incy
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_sgemv_benchmark(
    char *trans,
    int     *m,
    int     *n,
    hscalreal *alpha,
    hscalreal *a,
    int     *lda,
    hscalreal *x,
    int     *incx,
    hscalreal *beta,
    hscalreal *y,
    int     *incy
)
{
    sgemv_(
           trans,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)x,
           incx,
           (char*)beta,
           (char*)y,
           incy
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_dgemv_benchmark(
    char *trans,
    int     *m,
    int     *n,
    hscaldoublereal * alpha,
    hscaldoublereal *a,
    int     *lda,
    hscaldoublereal *x,
    int     *incx,
    hscaldoublereal *beta,
    hscaldoublereal *y,
    int     *incy
)
{
    dgemv_(
           trans,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)x,
           incx,
           (char*)beta,
           (char*)y,
           incy
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_zgemv_benchmark(
    char *trans,
    int     *m,
    int     *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int     *lda,
    hscaldoublecomplex *x,
    int     *incx,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *y,
    int     *incy
)
{
    zgemv_(
           trans,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)x,
           incx,
           (char*)beta,
           (char*)y,
           incy
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

