
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_cscal_benchmark(
    int     *n,
    hscalcomplex *ca,
    hscalcomplex *cx,
    int     *incx
)
{
    cscal_(
           n,
           (char*)ca,
           (char*)cx,
           incx
    );

    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_csscal_benchmark(
    int     *n,
    hscalreal    *sa,
    hscalcomplex *cx,
    int     *incx
)
{
    csscal_(
           n,
           (char*)sa,
           (char*)cx,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dscal_benchmark(
    int     *n,
    hscaldoublereal *da,
    hscaldoublereal *dx,
    int     *incx
)
{
    dscal_(
           n,
           (char*)da,
           (char*)dx,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_sscal_benchmark(
    int  *n,
    hscalreal *sa,
    hscalreal *sx,
    int  *incx
)
{
    sscal_(
           n,
           (char*)sa,
           (char*)sx,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_zscal_benchmark(
    int           *n,
    hscaldoublecomplex *za,
    hscaldoublecomplex *zx,
    int           *incx
)
{
    zscal_(
           n,
           (char*)za,
           (char*)zx,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_zdscal_benchmark(
    int           *n,
    hscaldoublereal    *da,
    hscaldoublecomplex *zx,
    int           *incx
)
{
    zdscal_(
           n,
           (char*)da,
           (char*)zx,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/
