
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_csymm_benchmark(
    char    *side,
    char    *uplo,
    int     *m,
    int     *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *b,
    int     *ldb,
    hscalcomplex *beta,
    hscalcomplex *c__,
    int     *ldc
)
{
    csymm_(
           side,
           uplo,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_zsymm_benchmark(
    char          *side,
    char          *uplo,
    int           *m,
    int           *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int           *lda,
    hscaldoublecomplex *b,
    int           *ldb,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    int           *ldc
)
{
    zsymm_(
           side,
           uplo,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dsymm_benchmark(
    char *side,
    char *uplo,
    int     *m,
    int     *n,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    int     *lda,
    hscaldoublereal *b,
    int     *ldb,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    int     *ldc
)
{
    dsymm_(
           side,
           uplo,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ssymm_benchmark(
    char *side,
    char *uplo,
    int     *m,
    int     *n,
    hscalreal *alpha,
    hscalreal *a,
    int     *lda,
    hscalreal *b,
    int     *ldb,
    hscalreal *beta,
    hscalreal *c__,
    int     *ldc
)
{
    ssymm_(
           side,
           uplo,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

