
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_csyr2k_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *b,
    int     *ldb,
    hscalcomplex *beta,
    hscalcomplex *c__,
    int     *ldc
)
{
    csyr2k_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dsyr2k_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    int     *lda,
    hscaldoublereal *b,
    int     *ldb,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    int     *ldc
)
{
    dsyr2k_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ssyr2k_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscalreal *alpha,
    hscalreal *a,
    int     *lda,
    hscalreal *b,
    int     *ldb,
    hscalreal *beta,
    hscalreal *c__,
    int     *ldc
)
{
    ssyr2k_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/


int hscal_zsyr2k_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int     *lda,
    hscaldoublecomplex *b,
    int     *ldb,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    int     *ldc
)
{
    zsyr2k_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

