
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_csyrk_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *beta,
    hscalcomplex *c__,
    int     *ldc
)
{
    csyrk_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dsyrk_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    int     *lda,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    int     *ldc
)
{
    dsyrk_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ssyrk_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscalreal *alpha,
    hscalreal *a,
    int     *lda,
    hscalreal *beta,
    hscalreal *c__,
    int     * ldc
)
{
    ssyrk_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_zsyrk_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int     *lda,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    int     *ldc
)
{
    zsyrk_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)beta,
           (char*)c__,
           ldc
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

