
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_ctrmm_benchmark(
    char    *side,
    char    *uplo,
    char    *transa,
    char    *diag,
    int     *m,
    int     *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *b,
    int     *ldb
)
{
    ctrmm_(
           side,
           uplo,
           transa,
           diag,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dtrmm_benchmark(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    int     *m,
    int     *n,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    int     *lda,
    hscaldoublereal *b,
    int     *ldb
)
{
    dtrmm_(
           side,
           uplo,
           transa,
           diag,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_strmm_benchmark(
    char    *side,
    char    *uplo,
    char    *transa,
    char    *diag,
    int     *m,
    int     *n,
    hscalreal    *alpha,
    hscalreal    *a,
    int     *lda,
    hscalreal    *b,
    int     *ldb
)
{
    strmm_(
           side,
           uplo,
           transa,
           diag,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ztrmm_benchmark(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    int     *m,
    int     *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int     *lda,
    hscaldoublecomplex *b,
    int     *ldb
)
{
    ztrmm_(
           side,
           uplo,
           transa,
           diag,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

