
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_ctrsm_benchmark(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    int     *m,
    int     *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *b,
    int     *ldb
)
{
    ctrsm_(
           side,
           uplo,
           transa,
           diag,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dtrsm_benchmark(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    int     *m,
    int     *n,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    int     *lda,
    hscaldoublereal *b,
    int     *ldb
)
{
    dtrsm_(
           side,
           uplo,
           transa,
           diag,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_strsm_benchmark(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    int     *m,
    int     *n,
    hscalreal *alpha,
    hscalreal *a,
    int     *lda,
    hscalreal *b,
    int     *ldb
)
{
    strsm_(
           side,
           uplo,
           transa,
           diag,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ztrsm_benchmark(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    int     *m,
    int     *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int     *lda,
    hscaldoublecomplex *b,
    int     *ldb
)
{
    ztrsm_(
           side,
           uplo,
           transa,
           diag,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

