
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_ctrsv_benchmark(
    char *uplo,
    char *trans,
    char *diag,
    int     *n,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *x,
    int     *incx
)
{
    ctrsv_(
           uplo,
           trans,
           diag,
           n,
           (char*)a,
           lda,
           (char*)x,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dtrsv_benchmark(
    char *uplo,
    char *trans,
    char *diag,
    int     *n,
    double *a,
    int     *lda,
    double *x,
    int     *incx
)
{
    dtrsv_(
           uplo,
           trans,
           diag,
           n,
           (char*)a,
           lda,
           (char*)x,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_strsv_benchmark(
    char *uplo,
    char *trans,
    char *diag,
    int     *n,
    hscalreal *a,
    int     *lda,
    hscalreal *x,
    int     *incx
)
{
    strsv_(
           uplo,
           trans,
           diag,
           n,
           (char*)a,
           lda,
           (char*)x,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ztrsv_benchmark(
    char *uplo,
    char *trans,
    char *diag,
    int     *n,
    hscaldoublecomplex *a,
    int     *lda,
    hscaldoublecomplex *x,
    int     *incx
)
{
    ztrsv_(
           uplo,
           trans,
           diag,
           n,
           (char*)a,
           lda,
           (char*)x,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

