
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK TEST Helpers             *
*                 ====================================             *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_PBLAS_TEST_HELPERS_HH
#define __HMPI_SCALAPACK_PBLAS_TEST_HELPERS_HH

/*------------------------------------------------------------------*/

int hscalt_print_tcomp_tcomm(
    int nprow,
    int npcol,
    const double *tcomp,
    const int *tcomm
)
{
   int myrow, mycol, ireceiver, jreceiver;

   printf(
     "Computations, Communications for Grid arrangement (%d, %d)\n",
     nprow,
     npcol
   );

   printf(
     "==========================================================\n"
   );

   printf("Computations\n");
   printf("------------\n");

   for (myrow = 0; myrow < nprow; myrow++)
   {
      for (mycol = 0; mycol < npcol; mycol++)
      {
         printf("%f ", tcomp[myrow*npcol + mycol]);
      }
      printf("\n");
   }

   printf("\n");

   printf("Communications\n");
   printf("--------------\n");

   for (myrow = 0; myrow < nprow; myrow++) 
   {
      for (mycol = 0; mycol < npcol; mycol++) 
      {
         printf("Communications (%d, %d)->\n", myrow, mycol);
         for (ireceiver = 0; ireceiver < nprow; ireceiver++) 
         {
            for (jreceiver = 0; jreceiver < npcol; jreceiver++) 
            {
               printf(
                 "%d ", 
                 TCOMM(myrow, mycol, ireceiver,jreceiver, nprow, npcol)
               );
            }
            printf("\n");
         }
         printf("\n");
      }
   }

   printf("\n");

   return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscalt_print_tcomp(
    int nprow,
    int npcol,
    const double *tcomp
)
{
   int myrow, mycol;

   printf(
     "Computations for Grid arrangement (%d, %d)\n",
     nprow,
     npcol
   );

   printf(
     "==========================================================\n"
   );

   printf("Computations\n");
   printf("------------\n");

   for (myrow = 0; myrow < nprow; myrow++)
   {
      for (mycol = 0; mycol < npcol; mycol++)
      {
         printf("%f ", tcomp[myrow*npcol + mycol]);
      }
      printf("\n");
   }

   printf("\n");

   return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

#endif
