#!/bin/sh

for file in $( find . -name 'valgrind*' )
do
	echo -n "$file: Checking for errors..."
	ERRORS=`grep "ERROR SUMMARY" $file | awk '{ print $4 }'`
	if [ "$ERRORS" -gt "0" ]; then
		echo "ERRORS detected in $file"
	else
		echo "0"
	fi

	LEAKSEXISTING=`grep "No malloc'd blocks -- no leaks are possible" $file`
	if [ "$LEAKSEXISTING" = "" ]; then
		echo "$file: Checking for leaks..."
		LEAKS=`grep "definitely lost:" $file | awk '{print $4}'`
		if [ "$LEAKS" -gt "0" ]; then
			echo "LEAK of $LEAKS bytes detected in $file"
		fi
	fi
done
