
#include <stdio.h>
#include <stdlib.h>

#include <scalapack.h>
#include "problem_pcsscal_parameters.h"
#include "../common/hscaltesthelpers.h"

int main()
{
   int DESCX[DLEN_];
   double *tcomp;
   int rc;

   tcomp = (double*)calloc(nprow*npcol, sizeof(double));

   DESCX[DTYPE_] = BLOCK_CYCLIC_2D_INB;
   DESCX[CTXT_]  = 0;
   DESCX[M_]     = N;
   DESCX[N_]     = 1;
   DESCX[IMB_]   = NB;
   DESCX[INB_]   = 1;
   DESCX[MB_]    = NB;
   DESCX[NB_]    = 1;
   DESCX[RSRC_]  = 0;
   DESCX[CSRC_]  = 0;
   DESCX[LLD_]   = 0;

   //hscal_set_debug(HSCAL_LOG_VERBOSE);

   rc = hscal_pcsscal_tcomp
        (
             N, ALPHA,
             IX, JX, DESCX, INCX,
             nprow, npcol,
             tcomp
   );

   if (rc != HSCAL_SUCCESS)
   {
      free(tcomp);

      return rc;
   }

   hscalt_print_tcomp(
      nprow,
      npcol,
      tcomp
   );

   free(tcomp);

   return HSCAL_SUCCESS;
}
