
#include <stdio.h>
#include <stdlib.h>

#include <scalapack.h>
#include "problem_pscnrm2_parameters.h"
#include "../common/hscaltesthelpers.h"

int main()
{
   int DESCX[DLEN_], DESCY[DLEN_];
   int *tcomm;
   double *tcomp;
   int rc;

   tcomp = (double*)calloc(nprow*npcol, sizeof(double));
   tcomm = (int*)calloc(nprow*npcol*nprow*npcol, sizeof(int));

   DESCX[DTYPE_] = BLOCK_CYCLIC_2D_INB;
   DESCX[CTXT_]  = 0;
   DESCX[M_]     = N;
   DESCX[N_]     = 1;
   DESCX[IMB_]   = NB;
   DESCX[INB_]   = 1;
   DESCX[MB_]    = NB;
   DESCX[NB_]    = 1;
   DESCX[RSRC_]  = 0;
   DESCX[CSRC_]  = 0;
   DESCX[LLD_]   = 0;

   //hscal_set_debug(HSCAL_LOG_VERBOSE);

   rc = hscal_pscnrm2_tcomp_tcomm
        (
             N,
             IX, JX, DESCX, INCX,
             nprow, npcol,
             tcomp, tcomm
   );

   if (rc != HSCAL_SUCCESS)
   {
      free(tcomm);
      free(tcomp);

      return rc;
   }

   hscalt_print_tcomp_tcomm(
      nprow,
      npcol,
      tcomp,
      tcomm
   );

   free(tcomp);
   free(tcomm);

   return HSCAL_SUCCESS;
}
