#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -lt "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > problem_pzgemv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> problem_pzgemv_parameters.h
	echo ""                                                     >> problem_pzgemv_parameters.h
	echo "int     TRANSI           = 'N';"                      >> problem_pzgemv_parameters.h
	echo "int     M                = $PSIZE;"                   >> problem_pzgemv_parameters.h
	echo "int     N                = $PSIZE;"                   >> problem_pzgemv_parameters.h
	echo "int     MB               = 32;"                       >> problem_pzgemv_parameters.h
	echo "int     NB               = 32;"                       >> problem_pzgemv_parameters.h
	echo "int     ALPHA[2]         = {1, 1};"                   >> problem_pzgemv_parameters.h
	echo "int     BETA[2]          = {1, 1};"                   >> problem_pzgemv_parameters.h
	echo "int     IA               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     JA               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     IX               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     JX               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     IY               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     JY               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     INCX             = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     INCY             = 1;"                        >> problem_pzgemv_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> problem_pzgemv_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> problem_pzgemv_parameters.h
	echo ""                                                     >> problem_pzgemv_parameters.h
	echo "#endif"                                               >> problem_pzgemv_parameters.h

	hscal_execute pzgemv

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -lt "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > problem_pzgemv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> problem_pzgemv_parameters.h
	echo ""                                                     >> problem_pzgemv_parameters.h
	echo "int     TRANSI           = 'T';"                      >> problem_pzgemv_parameters.h
	echo "int     M                = $PSIZE;"                   >> problem_pzgemv_parameters.h
	echo "int     N                = $PSIZE;"                   >> problem_pzgemv_parameters.h
	echo "int     MB               = 32;"                       >> problem_pzgemv_parameters.h
	echo "int     NB               = 32;"                       >> problem_pzgemv_parameters.h
	echo "int     ALPHA[2]         = {1, 1};"                   >> problem_pzgemv_parameters.h
	echo "int     BETA[2]          = {1, 1};"                   >> problem_pzgemv_parameters.h
	echo "int     IA               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     JA               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     IX               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     JX               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     IY               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     JY               = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     INCX             = 1;"                        >> problem_pzgemv_parameters.h
	echo "int     INCY             = 1;"                        >> problem_pzgemv_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> problem_pzgemv_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> problem_pzgemv_parameters.h
	echo ""                                                     >> problem_pzgemv_parameters.h
	echo "#endif"                                               >> problem_pzgemv_parameters.h

	hscal_execute pzgemv

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done
