
#include <stdio.h>
#include <stdlib.h>

#include <scalapack.h>
#include "problem_pcagemv_parameters.h"
#include "../common/hscaltesthelpers.h"

int main()
{
   int DESCA[DLEN_], DESCX[DLEN_], DESCY[DLEN_];
   int *tcomm;
   double *tcomp;
   int rc;

   char TRANSC = TRANSI;
   char *TRANS = &TRANSC;

   tcomp = (double*)calloc(nprow*npcol, sizeof(double));
   tcomm = (int*)calloc(nprow*npcol*nprow*npcol, sizeof(int));

   DESCA[DTYPE_] = BLOCK_CYCLIC_2D_INB;
   DESCA[M_]     = M;
   DESCA[N_]     = N;
   DESCA[IMB_]   = MB;
   DESCA[INB_]   = NB;
   DESCA[MB_]    = MB;
   DESCA[NB_]    = NB;
   DESCA[RSRC_]  = 0;
   DESCA[CSRC_]  = 0;

   if (TRANSC == 'N')
   {
      DESCX[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCX[M_]     = 1;
      DESCX[N_]     = N;
      DESCX[IMB_]   = 1;
      DESCX[INB_]   = NB;
      DESCX[MB_]    = 1;
      DESCX[NB_]    = NB;
      DESCX[RSRC_]  = 0;
      DESCX[CSRC_]  = 0;

      DESCY[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCY[M_]     = 1;
      DESCY[N_]     = M;
      DESCY[IMB_]   = 1;
      DESCY[INB_]   = MB;
      DESCY[MB_]    = 1;
      DESCY[NB_]    = MB;
      DESCY[RSRC_]  = 0;
      DESCY[CSRC_]  = 0;
   }
   else
   {
      DESCX[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCX[M_]     = 1;
      DESCX[N_]     = M;
      DESCX[IMB_]   = 1;
      DESCX[INB_]   = MB;
      DESCX[MB_]    = 1;
      DESCX[NB_]    = MB;
      DESCX[RSRC_]  = 0;
      DESCX[CSRC_]  = 0;

      DESCY[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCY[M_]     = 1;
      DESCY[N_]     = N;
      DESCY[IMB_]   = 1;
      DESCY[INB_]   = NB;
      DESCY[MB_]    = 1;
      DESCY[NB_]    = NB;
      DESCY[RSRC_]  = 0;
      DESCY[CSRC_]  = 0;
   }

   hscal_set_debug(HSCAL_LOG_VERBOSE);

   rc = hscal_pcagemv_tcomp_tcomm
        (
             TRANSI,
             M, N,
             ALPHA, IA, JA, DESCA,
             IX, JX, DESCX, INCX, BETA,
             IY, JY, DESCY, INCY,
             nprow, npcol,
             tcomp, tcomm
   );

   if (rc != HSCAL_SUCCESS)
   {
      free(tcomm);
      free(tcomp);

      return rc;
   }

   hscalt_print_tcomp_tcomm(
      nprow,
      npcol,
      tcomp,
      tcomm
   );

   free(tcomp);
   free(tcomm);

   return HSCAL_SUCCESS;
}
