
#include <stdio.h>
#include <stdlib.h>

#include <scalapack.h>
#include "problem_pdger_parameters.h"
#include "../common/hscaltesthelpers.h"

int main()
{
   int DESCA[DLEN_], DESCX[DLEN_], DESCY[DLEN_];
   int *tcomm;
   double *tcomp;
   int rc;

   tcomp = (double*)calloc(nprow*npcol, sizeof(double));
   tcomm = (int*)calloc(nprow*npcol*nprow*npcol, sizeof(int));

   DESCA[DTYPE_] = BLOCK_CYCLIC_2D_INB;
   DESCA[CTXT_]  = 0;
   DESCA[M_]     = M;
   DESCA[N_]     = N;
   DESCA[IMB_]   = MB;
   DESCA[INB_]   = NB;
   DESCA[MB_]    = MB;
   DESCA[NB_]    = NB;
   DESCA[RSRC_]  = 0;
   DESCA[CSRC_]  = 0;
   DESCA[LLD_]   = 0;

   DESCX[DTYPE_] = BLOCK_CYCLIC_2D_INB;
   DESCX[CTXT_]  = 0;
   DESCX[M_]     = M;
   DESCX[N_]     = 1;
   DESCX[IMB_]   = MB;
   DESCX[INB_]   = 1;
   DESCX[MB_]    = MB;
   DESCX[NB_]    = 1;
   DESCX[RSRC_]  = 0;
   DESCX[CSRC_]  = 0;
   DESCX[LLD_]   = 0;

   DESCY[DTYPE_] = BLOCK_CYCLIC_2D_INB;
   DESCY[CTXT_]  = 0;
   DESCY[M_]     = N;
   DESCY[N_]     = 1;
   DESCY[IMB_]   = NB;
   DESCY[INB_]   = 1;
   DESCY[MB_]    = NB;
   DESCY[NB_]    = 1;
   DESCY[RSRC_]  = 0;
   DESCY[CSRC_]  = 0;
   DESCY[LLD_]   = 0;

   //hscal_set_debug(HSCAL_LOG_VERBOSE);

   rc = hscal_pdger_tcomp_tcomm
        (
             M, N,
             ALPHA,
             IX, JX, DESCX, INCX,
             IY, JY, DESCY, INCY,
             IA, JA, DESCA,
             nprow, npcol,
             tcomp, tcomm
   );

   if (rc != HSCAL_SUCCESS)
   {
      free(tcomm);
      free(tcomp);

      return rc;
   }

   hscalt_print_tcomp_tcomm(
      nprow,
      npcol,
      tcomp,
      tcomm
   );

   free(tcomp);
   free(tcomm);

   return HSCAL_SUCCESS;
}
