#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -lt "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > problem_pdgemm_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> problem_pdgemm_parameters.h
	echo ""                                                     >> problem_pdgemm_parameters.h
	echo "int     TRANSAI          = 'N';"                      >> problem_pdgemm_parameters.h
	echo "int     TRANSBI          = 'N';"                      >> problem_pdgemm_parameters.h
	echo "int     M                = $PSIZE;"                   >> problem_pdgemm_parameters.h
	echo "int     N                = $PSIZE;"                   >> problem_pdgemm_parameters.h
	echo "int     K                = $PSIZE;"                   >> problem_pdgemm_parameters.h
	echo "int     MB               = 32;"                       >> problem_pdgemm_parameters.h
	echo "int     NB               = 32;"                       >> problem_pdgemm_parameters.h
	echo "int     KB               = 32;"                       >> problem_pdgemm_parameters.h
	echo "int     ALPHA            = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     BETA             = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     IA               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     JA               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     IB               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     JB               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     IC               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     JC               = 1;"                        >> problem_pdgemm_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> problem_pdgemm_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> problem_pdgemm_parameters.h
	echo ""                                                     >> problem_pdgemm_parameters.h
	echo "#endif"                                               >> problem_pdgemm_parameters.h

	hscal_execute pdgemm

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -lt "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > problem_pdgemm_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> problem_pdgemm_parameters.h
	echo ""                                                     >> problem_pdgemm_parameters.h
	echo "int     TRANSAI          = 'C';"                      >> problem_pdgemm_parameters.h
	echo "int     TRANSBI          = 'C';"                      >> problem_pdgemm_parameters.h
	echo "int     M                = $PSIZE;"                   >> problem_pdgemm_parameters.h
	echo "int     N                = $PSIZE;"                   >> problem_pdgemm_parameters.h
	echo "int     K                = $PSIZE;"                   >> problem_pdgemm_parameters.h
	echo "int     MB               = 32;"                       >> problem_pdgemm_parameters.h
	echo "int     NB               = 32;"                       >> problem_pdgemm_parameters.h
	echo "int     KB               = 32;"                       >> problem_pdgemm_parameters.h
	echo "int     ALPHA            = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     BETA             = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     IA               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     JA               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     IB               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     JB               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     IC               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     JC               = 1;"                        >> problem_pdgemm_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> problem_pdgemm_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> problem_pdgemm_parameters.h
	echo ""                                                     >> problem_pdgemm_parameters.h
	echo "#endif"                                               >> problem_pdgemm_parameters.h

	hscal_execute pdgemm

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -lt "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > problem_pdgemm_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> problem_pdgemm_parameters.h
	echo ""                                                     >> problem_pdgemm_parameters.h
	echo "int     TRANSAI          = 'T';"                      >> problem_pdgemm_parameters.h
	echo "int     TRANSBI          = 'T';"                      >> problem_pdgemm_parameters.h
	echo "int     M                = $PSIZE;"                   >> problem_pdgemm_parameters.h
	echo "int     N                = $PSIZE;"                   >> problem_pdgemm_parameters.h
	echo "int     K                = $PSIZE;"                   >> problem_pdgemm_parameters.h
	echo "int     MB               = 32;"                       >> problem_pdgemm_parameters.h
	echo "int     NB               = 32;"                       >> problem_pdgemm_parameters.h
	echo "int     KB               = 32;"                       >> problem_pdgemm_parameters.h
	echo "int     ALPHA            = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     BETA             = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     IA               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     JA               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     IB               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     JB               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     IC               = 1;"                        >> problem_pdgemm_parameters.h
	echo "int     JC               = 1;"                        >> problem_pdgemm_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> problem_pdgemm_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> problem_pdgemm_parameters.h
	echo ""                                                     >> problem_pdgemm_parameters.h
	echo "#endif"                                               >> problem_pdgemm_parameters.h

	hscal_execute pdgemm

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done
