
#include <stdio.h>
#include <stdlib.h>

#include <scalapack.h>
#include "problem_pchemm_parameters.h"
#include "../common/hscaltesthelpers.h"

int main()
{
   int DESCA[DLEN_], DESCB[DLEN_], DESCC[DLEN_];
   int *tcomm;
   double *tcomp;
   int rc;

   char SIDEC = SIDEI;
   char UPLOC = UPLOI;

   tcomp = (double*)calloc(nprow*npcol, sizeof(double));
   tcomm = (int*)calloc(nprow*npcol*nprow*npcol, sizeof(int));

   if (SIDEC == 'L')
   {
      DESCA[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCA[CTXT_]  = 0;
      DESCA[M_]     = M;
      DESCA[N_]     = M;
      DESCA[IMB_]   = MB;
      DESCA[INB_]   = MB;
      DESCA[MB_]    = MB;
      DESCA[NB_]    = MB;
      DESCA[RSRC_]  = 0;
      DESCA[CSRC_]  = 0;
      DESCA[LLD_]   = 0;
   }
   else
   {
      DESCA[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCA[CTXT_]  = 0;
      DESCA[M_]     = N;
      DESCA[N_]     = N;
      DESCA[IMB_]   = NB;
      DESCA[INB_]   = NB;
      DESCA[MB_]    = NB;
      DESCA[NB_]    = NB;
      DESCA[RSRC_]  = 0;
      DESCA[CSRC_]  = 0;
      DESCA[LLD_]   = 0;
   }

   DESCB[DTYPE_] = BLOCK_CYCLIC_2D_INB;
   DESCB[CTXT_]  = 0;
   DESCB[M_]     = M;
   DESCB[N_]     = N;
   DESCB[IMB_]   = MB;
   DESCB[INB_]   = NB;
   DESCB[MB_]    = MB;
   DESCB[NB_]    = NB;
   DESCB[RSRC_]  = 0;
   DESCB[CSRC_]  = 0;
   DESCB[LLD_]   = 0;

   DESCC[DTYPE_] = BLOCK_CYCLIC_2D_INB;
   DESCC[CTXT_]  = 0;
   DESCC[M_]     = M;
   DESCC[N_]     = N;
   DESCC[IMB_]   = MB;
   DESCC[INB_]   = NB;
   DESCC[MB_]    = MB;
   DESCC[NB_]    = NB;
   DESCC[RSRC_]  = 0;
   DESCC[CSRC_]  = 0;
   DESCC[LLD_]   = 0;

   //hscal_set_debug(HSCAL_LOG_VERBOSE);

   rc = hscal_pchemm_tcomp_tcomm
        (
             SIDEI, UPLOI,
             M, N,
             ALPHA, 
             IA, JA, DESCA,
             IB, JB, DESCB, 
             BETA,
             IC, JC, DESCC,
             nprow, npcol,
             tcomp, tcomm
   );

   if (rc != HSCAL_SUCCESS)
   {
      free(tcomm);
      free(tcomp);

      return rc;
   }

   hscalt_print_tcomp_tcomm(
      nprow,
      npcol,
      tcomp,
      tcomm
   );

   free(tcomp);
   free(tcomm);

   return HSCAL_SUCCESS;
}
