
#include <stdio.h>
#include <stdlib.h>

#include <scalapack.h>
#include "problem_pzher2k_parameters.h"
#include "../common/hscaltesthelpers.h"

int main()
{
   int DESCA[DLEN_], DESCB[DLEN_], DESCC[DLEN_];
   int *tcomm;
   double *tcomp;
   int rc;

   char UPLOC  = UPLOI;
   char TRANSC = TRANSI;

   tcomp = (double*)calloc(nprow*npcol, sizeof(double));
   tcomm = (int*)calloc(nprow*npcol*nprow*npcol, sizeof(int));

   if (TRANSC == 'N')
   {
      DESCA[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCA[CTXT_]  = 0;
      DESCA[M_]     = N;
      DESCA[N_]     = K;
      DESCA[IMB_]   = NB;
      DESCA[INB_]   = KB;
      DESCA[MB_]    = NB;
      DESCA[NB_]    = KB;
      DESCA[RSRC_]  = 0;
      DESCA[CSRC_]  = 0;
      DESCA[LLD_]   = 0;
   }
   else
   {
      DESCA[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCA[CTXT_]  = 0;
      DESCA[M_]     = K;
      DESCA[N_]     = N;
      DESCA[IMB_]   = KB;
      DESCA[INB_]   = NB;
      DESCA[MB_]    = KB;
      DESCA[NB_]    = NB;
      DESCA[RSRC_]  = 0;
      DESCA[CSRC_]  = 0;
      DESCA[LLD_]   = 0;
   }

   if (TRANSC == 'N')
   {
      DESCB[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCB[CTXT_]  = 0;
      DESCB[M_]     = N;
      DESCB[N_]     = K;
      DESCB[IMB_]   = NB;
      DESCB[INB_]   = KB;
      DESCB[MB_]    = NB;
      DESCB[NB_]    = KB;
      DESCB[RSRC_]  = 0;
      DESCB[CSRC_]  = 0;
      DESCB[LLD_]   = 0;
   }
   else
   {
      DESCB[DTYPE_] = BLOCK_CYCLIC_2D_INB;
      DESCB[CTXT_]  = 0;
      DESCB[M_]     = K;
      DESCB[N_]     = N;
      DESCB[IMB_]   = KB;
      DESCB[INB_]   = NB;
      DESCB[MB_]    = KB;
      DESCB[NB_]    = NB;
      DESCB[RSRC_]  = 0;
      DESCB[CSRC_]  = 0;
      DESCB[LLD_]   = 0;
   }

   DESCC[DTYPE_] = BLOCK_CYCLIC_2D_INB;
   DESCC[CTXT_]  = 0;
   DESCC[M_]     = N;
   DESCC[N_]     = N;
   DESCC[IMB_]   = NB;
   DESCC[INB_]   = NB;
   DESCC[MB_]    = NB;
   DESCC[NB_]    = NB;
   DESCC[RSRC_]  = 0;
   DESCC[CSRC_]  = 0;
   DESCC[LLD_]   = 0;

   //hscal_set_debug(HSCAL_LOG_VERBOSE);

   rc = hscal_pzher2k_tcomp_tcomm
        (
             UPLOI, TRANSI,
             N, K,
             ALPHA, 
             IA, JA, DESCA,
             IB, JB, DESCB, 
             BETA,
             IC, JC, DESCC,
             nprow, npcol,
             tcomp, tcomm
   );

   if (rc != HSCAL_SUCCESS)
   {
      free(tcomm);
      free(tcomp);

      return rc;
   }

   hscalt_print_tcomp_tcomm(
      nprow,
      npcol,
      tcomp,
      tcomm
   );

   free(tcomp);
   free(tcomm);

   return HSCAL_SUCCESS;
}
