
#ifndef __HSCAL_CLAPACK_CLATCPY_HH
#define __HSCAL_CLAPACK_CLATCPY_HH

#include "../../include/hscalapack.h"

int hscal_clatcpy(
    char *uplo, 
    int *m, 
    int *n,
    int *lda, 
    int *ldb, 
    double *tcomp
)
{
    /* System generated locals */
    hscalinteger a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3;
    hscalcomplex q__1;

    /* Local variables */
    hscalinteger i__, j;

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  CLATCPY copies all or part of a two-dimensional matrix A to another */
/*  matrix B in transpose form. */

/*  Arguments */
/*  ========= */

/*  UPLO    (input) CHARACTER*1 */
/*          Specifies the part of the matrix A to be copied to B. */
/*          = 'U':      Upper triangular part */
/*          = 'L':      Lower triangular part */
/*          Otherwise:  All of the matrix A */

/*  M       (input) INTEGER */
/*          The number of rows of the matrix A.  M >= 0. */

/*  N       (input) INTEGER */
/*          The number of columns of the matrix A.  N >= 0. */

/*  LDA     (input) INTEGER */
/*          The leading dimension of the array A.  LDA >= max(1,M). */

/*  LDB     (input) INTEGER */
/*          The leading dimension of the array B.  LDB >= max(1,N). */

/*  ===================================================================== */

/*     .. Local Scalars .. */
/*     .. */
/*     .. External Functions .. */
/*     .. */
/*     .. Intrinsic Functions .. */

/*     .. */
/*     .. Executable Statements .. */

    *tcomp = 0.;

    /* Function Body */
    if (hscal_lsame(uplo, "U")) {
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    i__2 = min(j,*m);
          *tcomp += 9*i__2;
/* L20: */
	}
    } else if (hscal_lsame(uplo, "L")) {
        i__1 = *n;
        for (j = 1; j <= i__1; ++j) {
            i__2 = *m;
            *tcomp += (i__2 - j + 1)*9;
        }
    } else {
      *tcomp += (*n)*(*m)*9;
    }

    return HSCAL_SUCCESS;

/*     End of CLATCPY */

}

#endif
