
#ifndef __HSCAL_CLAPACK_DLASET_HH
#define __HSCAL_CLAPACK_DLASET_HH

#include "../../include/hscalapack.h"

int hscal_dlaset(
    char *uplo, 
    int *m, int *n,
    char *alpha, char *beta, 
    hscalinteger *lda,
    double *tcomp
)
{
    /* System generated locals */
    hscalinteger a_dim1, a_offset, i__1, i__2, i__3;
    /* Local variables */
    hscalinteger i__, j;

    *tcomp = 0.;

    /* Function Body */
    if (hscal_lsame(uplo, "U")) {

/*        Set the strictly upper triangular or trapezoidal part of the   
          array to ALPHA. */

	i__1 = *n;
	for (j = 2; j <= i__1; ++j) {
/* Computing MIN */
	    i__3 = j - 1;
	    i__2 = min(i__3,*m);
          *tcomp += 3*i__2;
	}

    } else if (hscal_lsame(uplo, "L")) {

/*        Set the strictly lower triangular or trapezoidal part of the   
          array to ALPHA. */

	i__1 = min(*m,*n);
	for (j = 1; j <= i__1; ++j) {
	    i__2 = *m;
          *tcomp += 3*(i__2 - j);
	}

    } else {

/*        Set the leading m-by-n submatrix to ALPHA. */
      *tcomp += 3*(*n)*(*m);
    }

/*     Set the first min(M,N) diagonal elements to BETA. */
    i__1 = min(*m,*n);
    *tcomp += 3*(i__1);

    return HSCAL_SUCCESS;

/*     End of DLASET */

}

#endif
