
#ifndef __HSCAL_CL_ZLACGV_HH
#define __HSCAL_CL_ZLACGV_HH

#include "../../include/hscalapack.h"

int hscal_zlacgv(
    int *n,
    int *incx,
    double *tcomp
)
{
/*  -- LAPACK auxiliary routine (version 3.0) --   
       Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,   
       Courant Institute, Argonne National Lab, and Rice University   
       October 31, 1992   


    Purpose   
    =======   

    ZLACGV conjugates a complex vector of length N.   

    Arguments   
    =========   

    N       (input) INTEGER   
            The length of the vector X.  N >= 0.   

    X       (input/output) COMPLEX*16 array, dimension   
                           (1+(N-1)*abs(INCX))   
            On entry, the vector of length N to be conjugated.   
            On exit, X is overwritten with conjg(X).   

    INCX    (input) INTEGER   
            The spacing between successive elements of X.   

   =====================================================================   


       Parameter adjustments */
    /* System generated locals */
    hscalinteger i__1, i__2;
    /* Local variables */
    hscalinteger ioff, i__;
    hscaldoublereal tn;

    *tcomp = 0.;

    tn = (double)(*n);

    /* Function Body */
    if (*incx == 1) {
        *tcomp += 5*tn;
    } else {
        *tcomp += 5*tn;
    }

    return HSCAL_SUCCESS;
/*     End of ZLACGV */

} /* zlacgv_ */

#endif

