
#ifndef __HSCAL_CLAPACK_ZLASET_HH
#define __HSCAL_CLAPACK_ZLASET_HH

#include "../../include/hscalapack.h"

int hscal_zlaset(
    char *uplo, 
    int *m, int *n,
    char *alpha, char *beta, 
    hscalinteger *lda,
    double *tcomp
)
{
    hscalinteger a_dim1, a_offset, i__1, i__2, i__3;
    /* Local variables */
    hscalinteger i__, j;

    *tcomp = 0.;

    /* Function Body */
    if (hscal_lsame(uplo, "U")) {

/*        Set the diagonal to BETA and the strictly upper triangular   
          part of the array to ALPHA. */
	i__1 = *n;
	for (j = 2; j <= i__1; ++j) {
/* Computing MIN */
	    i__3 = j - 1;
	    i__2 = min(i__3,*m);
          *tcomp += 4*i__2;
	}
	i__1 = min(*n,*m);
      *tcomp += 4*i__1;
    } else if (hscal_lsame(uplo, "L")) {

/*        Set the diagonal to BETA and the strictly lower triangular   
          part of the array to ALPHA. */

	i__1 = min(*m,*n);
	for (j = 1; j <= i__1; ++j) {
	    i__2 = *m;
          *tcomp += 4*(i__2 - j);
	}
	i__1 = min(*n,*m);
      *tcomp += 4*i__1;
    } else {

/*        Set the array to BETA on the diagonal and ALPHA on the   
          offdiagonal. */
      *tcomp += 4*(*n)*(*m);
	i__1 = min(*m,*n);
      *tcomp += 4*i__1;
    }

    return HSCAL_SUCCESS;

/*     End of ZLASET */

}

#endif
