
#include <stdio.h>
#include <stdlib.h>

#include <scalapack.h>
#include "problem_pdgetrs_parameters.h"
#include "../../PBLAS/TESTING/common/hscaltesthelpers.h"

int main()
{
   int DESCA[DLEN_], DESCB[DLEN_];
   int *tcomm;
   double *tcomp;
   int rc;

   int IRSRC = 0;
   int ICSRC = 0;
   int ICTXT = -1;
   int ILLD  = -1;

   char TRANSC = TRANSI; char *TRANS = &TRANSC;

   tcomp = (double*)calloc(nprow*npcol, sizeof(double));
   tcomm = (int*)calloc(nprow*npcol*nprow*npcol, sizeof(int));

   descset_(
       DESCA,
       &N,
       &N,
       &NB,
       &NB,
       &IRSRC,
       &ICSRC,
       &ICTXT,
       &ILLD
   );

   descset_(
       DESCB,
       &N,
       &NRHS,
       &NB,
       &NB,
       &IRSRC,
       &ICSRC,
       &ICTXT,
       &ILLD
   );

   //hscal_set_debug(HSCAL_LOG_VERBOSE);

   rc = hscal_pdgetrs_info
        (
             TRANS,
             &N, &NRHS,
             &IA, &JA, DESCA,
             &IB, &JB, DESCB,
             nprow, npcol,
             tcomp, tcomm
   );

   if (rc != HSCAL_SUCCESS)
   {
      free(tcomm);
      free(tcomp);

      return rc;
   }

   hscalt_print_tcomp_tcomm(
      nprow,
      npcol,
      tcomp,
      tcomm
   );

   free(tcomp);
   free(tcomm);

   return HSCAL_SUCCESS;
}

