 
#include "../include/hscalapack.h"

/*---------------------------------------------------------------------------*/

int hscal_heuristic_fn_all
(
    int np,
    int *dp,
    const int *model_params,
    int param_count
)
{
    return 1;
}

/*---------------------------------------------------------------------------*/

int hscal_heuristic_fn_1xp
(
    int np,
    int *dp,
    const int *model_params,
    int param_count
)
{
    if (dp[0] == 1)
    {
       return 1;
    }

    return 0;
}

/*---------------------------------------------------------------------------*/

int hscal_heuristic_fn_row
(
    int np,
    int *dp,
    const int *model_params,
    int param_count
)
{
    if (dp[0] == 1)
    {
       return 1;
    }

    return 0;
}

/*---------------------------------------------------------------------------*/

int hscal_heuristic_fn_column
(
    int np,
    int *dp,
    const int *model_params,
    int param_count
)
{
    if (dp[1] == 1)
    {
       return 1;
    }

    return 0;
}

/*---------------------------------------------------------------------------*/

int hscal_heuristic_fn_linear
(
    int np,
    int *dp,
    const int *model_params,
    int param_count
)
{
    if ((dp[0] == 1) || (dp[1] == 1))
    {
       return 1;
    }

    return 0;
}

/*---------------------------------------------------------------------------*/

int hscal_heuristic_fn_nonlinear
(
    int np,
    int *dp,
    const int *model_params,
    int param_count
)
{
    if ((dp[0] == 1) || (dp[1] == 1))
    {
       return 0;
    }

    return 1;
}

/*---------------------------------------------------------------------------*/

int hscal_heuristic_fn_lean
(
    int np,
    int *dp,
    const int *model_params,
    int param_count
)
{
    if ((dp[0] == 1) || (dp[1] == 1))
    {
       return 1;
    }

    if ((dp[0] == 2) || (dp[1] == 2))
    {
       return 1;
    }

    return 0;
}

/*---------------------------------------------------------------------------*/

int hscal_heuristic_fn_square
(
    int np,
    int *dp,
    const int *model_params,
    int param_count
)
{
    if ((np == 2) && (dp[0] == dp[1]))
    {
       return 1;
    }

    return 0;
}

/*---------------------------------------------------------------------------*/

int hscal_heuristic_fn_p_lt_q
(
    int np,
    int *dp,
    const int *model_params,
    int param_count
)
{
    if ((dp[0] == 1) || (dp[1] == 1))
    {
       return 0;
    }

    if (dp[0] <= dp[1])
    {
       return 1;
    }

    return 0;
}

/*---------------------------------------------------------------------------*/
