
#ifndef __HSCALAPACK_PSDBTRSV_HSCALFUNC_HH
#define __HSCALAPACK_PSDBTRSV_HSCALFUNC_HH

/*
*  Include files
*/
#include "../include/hscalapack.h"

int hscal_psdbtrsv(
    char *uplo, char *trans, hscalinteger *n, 
    hscalinteger *bwl, hscalinteger *bwu, hscalinteger *nrhs, hscalinteger *ja, 
    hscalinteger *desca, hscalinteger *ib, hscalinteger *descb,
    hscalinteger *info, 
    int nprow, int npcol, int myrow, int mycol, double *tcomp,
    int *tcomm
)
{
    HSCALBLACSCONTEXT   * blacsctxt;

    hscalinteger c__18 = 18;
    hscalinteger c__1 = 1;
    hscalinteger c__0 = 0;
    hscalreal c_b32 = -1.f;
    hscalreal c_b33 = 1.f;
    hscalreal c_b39 = 0.f;

    /* System generated locals */
    hscalinteger i__1, i__2, i__3, i__4, i__5, i__6;

    /* Local variables */
    hscalinteger odd_size__, desca_1xp__[7], descb_px1__[7], store_m_b__, 
	    store_n_a__, part_size__, ictxt_new__, nb, np, level_dist__, 
	    ictxt_save__, first_proc__, param_check__[54]	/* was [18][3]
	     */, mbw2, return_code__, part_offset__, my_num_cols__, llda, 
	    lldb, csrc, ofst;
    hscalinteger idum1, idum2, idum3;
    hscalinteger ictxt;
    hscalinteger work_size_min__, ja_new__, max_bw__;
    hscalinteger work_u__;
    hscalinteger np_save__;

/*  -- ScaLAPACK routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     April 3, 2000 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */


/*  Purpose */
/*  ======= */

/*  PSDBTRSV solves a banded triangular system of linear equations */

/*                      A(1:N, JA:JA+N-1) * X = B(IB:IB+N-1, 1:NRHS) */
/*                                 or */
/*                      A(1:N, JA:JA+N-1)^T * X = B(IB:IB+N-1, 1:NRHS) */

/*  where A(1:N, JA:JA+N-1) is a banded */
/*  triangular matrix factor produced by the */
/*  Gaussian elimination code PD@(dom_pre)BTRF */
/*  and is stored in A(1:N,JA:JA+N-1) and AF. */
/*  The matrix stored in A(1:N, JA:JA+N-1) is either */
/*  upper or lower triangular according to UPLO, */
/*  and the choice of solving A(1:N, JA:JA+N-1) or A(1:N, JA:JA+N-1)^T */
/*  is dictated by the user by the parameter TRANS. */

/*  Routine PSDBTRF MUST be called first. */

/*  ===================================================================== */

/*  Arguments */
/*  ========= */

/*  UPLO    (global input) CHARACTER */
/*          = 'U':  Upper triangle of A(1:N, JA:JA+N-1) is stored; */
/*          = 'L':  Lower triangle of A(1:N, JA:JA+N-1) is stored. */

/*  TRANS   (global input) CHARACTER */
/*          = 'N':  Solve with A(1:N, JA:JA+N-1); */
/*          = 'T' or 'C':  Solve with A(1:N, JA:JA+N-1)^T; */

/*  N       (global input) INTEGER */
/*          The number of rows and columns to be operated on, i.e. the */
/*          order of the distributed submatrix A(1:N, JA:JA+N-1). N >= 0. */

/*  BWL     (global input) INTEGER */
/*          Number of subdiagonals. 0 <= BWL <= N-1 */

/*  BWU     (global input) INTEGER */
/*          Number of superdiagonals. 0 <= BWU <= N-1 */

/*  NRHS    (global input) INTEGER */
/*          The number of right hand sides, i.e., the number of columns */
/*          of the distributed submatrix B(IB:IB+N-1, 1:NRHS). */
/*          NRHS >= 0. */

/*  JA      (global input) INTEGER */
/*          The index in the global array A that points to the start of */
/*          the matrix to be operated on (which may be either all of A */
/*          or a submatrix of A). */

/*  DESCA   (global and local input) INTEGER array of dimension DLEN. */
/*          if 1D type (DTYPE_A=501), DLEN >= 7; */
/*          if 2D type (DTYPE_A=1), DLEN >= 9 . */
/*          The array descriptor for the distributed matrix A. */
/*          Contains information of mapping of A to memory. Please */
/*          see NOTES below for full description and options. */

/*  IB      (global input) INTEGER */
/*          The row index in the global array B that points to the first */
/*          row of the matrix to be operated on (which may be either */
/*          all of B or a submatrix of B). */

/*  DESCB   (global and local input) INTEGER array of dimension DLEN. */
/*          if 1D type (DTYPE_B=502), DLEN >=7; */
/*          if 2D type (DTYPE_B=1), DLEN >= 9. */
/*          The array descriptor for the distributed matrix B. */
/*          Contains information of mapping of B to memory. Please */
/*          see NOTES below for full description and options. */

/*  LAF     (local input) INTEGER */
/*          Size of user-input Auxiliary Fillin space AF. Must be >= */
/*          NB*(bwl+bwu)+6*max(bwl,bwu)*max(bwl,bwu) */
/*          If LAF is not large enough, an error code will be returned */
/*          and the minimum acceptable size will be returned in AF( 1 ) */

/*  LWORK   (local input or global input) INTEGER */
/*          Size of user-input workspace WORK. */
/*          If LWORK is too small, the minimal acceptable size will be */
/*          returned in WORK(1) and an error code is returned. LWORK>= */
/*          (max(bwl,bwu)*NRHS) */

/*  ===================================================================== */


/*  Restrictions */
/*  ============ */

/*  The following are restrictions on the input parameters. Some of these */
/*    are temporary and will be removed in future releases, while others */
/*    may reflect fundamental technical limitations. */

/*    Non-cyclic restriction: VERY IMPORTANT! */
/*      P*NB>= mod(JA-1,NB)+N. */
/*      The mapping for matrices must be blocked, reflecting the nature */
/*      of the divide and conquer algorithm as a task-parallel algorithm. */
/*      This formula in words is: no processor may have more than one */
/*      chunk of the matrix. */

/*    Blocksize cannot be too small: */
/*      If the matrix spans more than one processor, the following */
/*      restriction on NB, the size of each block on each processor, */
/*      must hold: */
/*      NB >= 2*MAX(BWL,BWU) */
/*      The bulk of parallel computation is done on the matrix of size */
/*      O(NB) on each processor. If this is too small, divide and conquer */
/*      is a poor choice of algorithm. */

/*    Submatrix reference: */
/*      JA = IB */
/*      Alignment restriction that prevents unnecessary communication. */


/*  ===================================================================== */


/*  Notes */
/*  ===== */

/*  If the factorization routine and the solve routine are to be called */
/*    separately (to solve various sets of righthand sides using the same */
/*    coefficient matrix), the auxiliary space AF *must not be altered* */
/*    between calls to the factorization routine and the solve routine. */

/*  The best algorithm for solving banded and tridiagonal linear systems */
/*    depends on a variety of parameters, especially the bandwidth. */
/*    Currently, only algorithms designed for the case N/P >> bw are */
/*    implemented. These go by many names, including Divide and Conquer, */
/*    Partitioning, domain decomposition-type, etc. */

/*  Algorithm description: Divide and Conquer */

/*    The Divide and Conqer algorithm assumes the matrix is narrowly */
/*      banded compared with the number of equations. In this situation, */
/*      it is best to distribute the input matrix A one-dimensionally, */
/*      with columns atomic and rows divided amongst the processes. */
/*      The basic algorithm divides the banded matrix up into */
/*      P pieces with one stored on each processor, */
/*      and then proceeds in 2 phases for the factorization or 3 for the */
/*      solution of a linear system. */
/*      1) Local Phase: */
/*         The individual pieces are factored independently and in */
/*         parallel. These factors are applied to the matrix creating */
/*         fillin, which is stored in a non-inspectable way in auxiliary */
/*         space AF. Mathematically, this is equivalent to reordering */
/*         the matrix A as P A P^T and then factoring the principal */
/*         leading submatrix of size equal to the sum of the sizes of */
/*         the matrices factored on each processor. The factors of */
/*         these submatrices overwrite the corresponding parts of A */
/*         in memory. */
/*      2) Reduced System Phase: */
/*         A small (max(bwl,bwu)* (P-1)) system is formed representing */
/*         interaction of the larger blocks, and is stored (as are its */
/*         factors) in the space AF. A parallel Block Cyclic Reduction */
/*         algorithm is used. For a linear system, a parallel front solve */
/*         followed by an analagous backsolve, both using the structure */
/*         of the factored matrix, are performed. */
/*      3) Backsubsitution Phase: */
/*         For a linear system, a local backsubstitution is performed on */
/*         each processor in parallel. */


/*  Descriptors */
/*  =========== */

/*  Descriptors now have *types* and differ from ScaLAPACK 1.0. */

/*  Note: banded codes can use either the old two dimensional */
/*    or new one-dimensional descriptors, though the processor grid in */
/*    both cases *must be one-dimensional*. We describe both types below. */

/*  Each global data object is described by an associated description */
/*  vector.  This vector stores the information required to establish */
/*  the mapping between an object element and its corresponding process */
/*  and memory location. */

/*  Let A be a generic term for any 2D block cyclicly distributed array. */
/*  Such a global array has an associated description vector DESCA. */
/*  In the following comments, the character _ should be read as */
/*  "of the global array". */

/*  NOTATION        STORED IN      EXPLANATION */
/*  --------------- -------------- -------------------------------------- */
/*  DTYPE_A(global) DESCA( DTYPE_ )The descriptor type.  In this case, */
/*                                 DTYPE_A = 1. */
/*  CTXT_A (global) DESCA( CTXT_ ) The BLACS context handle, indicating */
/*                                 the BLACS process grid A is distribu- */
/*                                 ted over. The context itself is glo- */
/*                                 bal, but the handle (the hscalinteger */
/*                                 value) may vary. */
/*  M_A    (global) DESCA( M_ )    The number of rows in the global */
/*                                 array A. */
/*  N_A    (global) DESCA( N_ )    The number of columns in the global */
/*                                 array A. */
/*  MB_A   (global) DESCA( MB_ )   The blocking factor used to distribute */
/*                                 the rows of the array. */
/*  NB_A   (global) DESCA( NB_ )   The blocking factor used to distribute */
/*                                 the columns of the array. */
/*  RSRC_A (global) DESCA( RSRC_ ) The process row over which the first */
/*                                 row of the array A is distributed. */
/*  CSRC_A (global) DESCA( CSRC_ ) The process column over which the */
/*                                 first column of the array A is */
/*                                 distributed. */
/*  LLD_A  (local)  DESCA( LLD_ )  The leading dimension of the local */
/*                                 array.  LLD_A >= MAX(1,LOCr(M_A)). */

/*  Let K be the number of rows or columns of a distributed matrix, */
/*  and assume that its process grid has dimension p x q. */
/*  LOCr( K ) denotes the number of elements of K that a process */
/*  would receive if K were distributed over the p processes of its */
/*  process column. */
/*  Similarly, LOCc( K ) denotes the number of elements of K that a */
/*  process would receive if K were distributed over the q processes of */
/*  its process row. */
/*  The values of LOCr() and LOCc() may be determined via a call to the */
/*  ScaLAPACK tool function, NUMROC: */
/*          LOCr( M ) = NUMROC( M, MB_A, MYROW, RSRC_A, NPROW ), */
/*          LOCc( N ) = NUMROC( N, NB_A, MYCOL, CSRC_A, NPCOL ). */
/*  An upper bound for these quantities may be computed by: */
/*          LOCr( M ) <= ceil( ceil(M/MB_A)/NPROW )*MB_A */
/*          LOCc( N ) <= ceil( ceil(N/NB_A)/NPCOL )*NB_A */


/*  One-dimensional descriptors: */

/*  One-dimensional descriptors are a new addition to ScaLAPACK since */
/*    version 1.0. They simplify and shorten the descriptor for 1D */
/*    arrays. */

/*  Since ScaLAPACK supports two-dimensional arrays as the fundamental */
/*    object, we allow 1D arrays to be distributed either over the */
/*    first dimension of the array (as if the grid were P-by-1) or the */
/*    2nd dimension (as if the grid were 1-by-P). This choice is */
/*    indicated by the descriptor type (501 or 502) */
/*    as described below. */

/*    IMPORTANT NOTE: the actual BLACS grid represented by the */
/*    CTXT entry in the descriptor may be *either*  P-by-1 or 1-by-P */
/*    irrespective of which one-dimensional descriptor type */
/*    (501 or 502) is input. */
/*    This routine will interpret the grid properly either way. */
/*    ScaLAPACK routines *do not support intercontext operations* so that */
/*    the grid passed to a single ScaLAPACK routine *must be the same* */
/*    for all array descriptors passed to that routine. */

/*    NOTE: In all cases where 1D descriptors are used, 2D descriptors */
/*    may also be used, since a one-dimensional array is a special case */
/*    of a two-dimensional array with one dimension of size unity. */
/*    The two-dimensional array used in this case *must* be of the */
/*    proper orientation: */
/*      If the appropriate one-dimensional descriptor is DTYPEA=501 */
/*      (1 by P type), then the two dimensional descriptor must */
/*      have a CTXT value that refers to a 1 by P BLACS grid; */
/*      If the appropriate one-dimensional descriptor is DTYPEA=502 */
/*      (P by 1 type), then the two dimensional descriptor must */
/*      have a CTXT value that refers to a P by 1 BLACS grid. */


/*  Summary of allowed descriptors, types, and BLACS grids: */
/*  DTYPE           501         502         1         1 */
/*  BLACS grid      1xP or Px1  1xP or Px1  1xP       Px1 */
/*  ----------------------------------------------------- */
/*  A               OK          NO          OK        NO */
/*  B               NO          OK          NO        OK */

/*  Note that a consequence of this chart is that it is not possible */
/*    for *both* DTYPE_A and DTYPE_B to be 2D_type(1), as these lead */
/*    to opposite requirements for the orientation of the BLACS grid, */
/*    and as noted before, the *same* BLACS context must be used in */
/*    all descriptors in a single ScaLAPACK subroutine call. */

/*  Let A be a generic term for any 1D block cyclicly distributed array. */
/*  Such a global array has an associated description vector DESCA. */
/*  In the following comments, the character _ should be read as */
/*  "of the global array". */

/*  NOTATION        STORED IN  EXPLANATION */
/*  --------------- ---------- ------------------------------------------ */
/*  DTYPE_A(global) DESCA( 1 ) The descriptor type. For 1D grids, */
/*                                TYPE_A = 501: 1-by-P grid. */
/*                                TYPE_A = 502: P-by-1 grid. */
/*  CTXT_A (global) DESCA( 2 ) The BLACS context handle, indicating */
/*                                the BLACS process grid A is distribu- */
/*                                ted over. The context itself is glo- */
/*                                bal, but the handle (the hscalinteger */
/*                                value) may vary. */
/*  N_A    (global) DESCA( 3 ) The size of the array dimension being */
/*                                distributed. */
/*  NB_A   (global) DESCA( 4 ) The blocking factor used to distribute */
/*                                the distributed dimension of the array. */
/*  SRC_A  (global) DESCA( 5 ) The process row or column over which the */
/*                                first row or column of the array */
/*                                is distributed. */
/*  LLD_A  (local)  DESCA( 6 ) The leading dimension of the local array */
/*                                storing the local blocks of the distri- */
/*                                buted array A. Minimum value of LLD_A */
/*                                depends on TYPE_A. */
/*                                TYPE_A = 501: LLD_A >= */
/*                                   size of undistributed dimension, 1. */
/*                                TYPE_A = 502: LLD_A >=NB_A, 1. */
/*  Reserved        DESCA( 7 ) Reserved for future use. */



/*  ===================================================================== */

/*  Code Developer: Andrew J. Cleary, University of Tennessee. */
/*    Current address: Lawrence Livermore National Labs. */
/*  Last modified by:  Peter Arbenz, Institute of Scientific Computing, */
/*    ETH, Zurich. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. Local Arrays .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. External Functions .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

/*     Test the input parameters */

    /* Parameter adjustments */
    --descb;
    --desca;

    /* Function Body */
    *info = 0;

/*     Convert descriptor into standard form for easy access to */
/*        parameters, check that grid is of right shape. */

    desca_1xp__[0] = 501;
    descb_px1__[0] = 502;

    desc_convert__(&desca[1], desca_1xp__, &return_code__);

    if (return_code__ != 0) {
	*info = -902;
    }

    desc_convert__(&descb[1], descb_px1__, &return_code__);

    if (return_code__ != 0) {
	*info = -1202;
    }

/*     Consistency checks for DESCA and DESCB. */

/*     Context must be the same */
    if (desca_1xp__[1] != descb_px1__[1]) {
	*info = -1202;
    }

/*        These are alignment restrictions that may or may not be removed */
/*        in future releases. -Andy Cleary, April 14, 1996. */

/*     Block sizes must be the same */
    if (desca_1xp__[3] != descb_px1__[3]) {
	*info = -1204;
    }

/*     Source processor must be the same */

    if (desca_1xp__[4] != descb_px1__[4]) {
	*info = -1205;
    }

/*     Get values out of descriptor for use in code. */

    ictxt = desca_1xp__[1];
    csrc = desca_1xp__[4];
    nb = desca_1xp__[3];
    llda = desca_1xp__[5];
    store_n_a__ = desca_1xp__[2];
    lldb = descb_px1__[5];
    store_m_b__ = descb_px1__[2];

/*     Get grid parameters */


/*     Size of separator blocks is maximum of bandwidths */

    max_bw__ = max(*bwl,*bwu);
    mbw2 = max_bw__ * max_bw__;

    np = nprow * npcol;



    if (hscal_lsame(uplo, "U")) {
	idum1 = 'U';
    } else if (hscal_lsame(uplo, "L")) {
	idum1 = 'L';
    } else {
	*info = -1;
    }

    if (hscal_lsame(trans, "N")) {
	idum2 = 'N';
    } else if (hscal_lsame(trans, "T")) {
	idum2 = 'T';
    } else if (hscal_lsame(trans, "C")) {
	idum2 = 'T';
    } else {
	*info = -2;
    }

    idum3 = 1;

    if (*n < 0) {
	*info = -3;
    }

    if (*n + *ja - 1 > store_n_a__) {
	*info = -906;
    }

    if (*bwl > *n - 1 || *bwl < 0) {
	*info = -4;
    }

    if (*bwu > *n - 1 || *bwu < 0) {
	*info = -5;
    }

    if (llda < *bwl + *bwu + 1) {
	*info = -906;
    }

    if (nb <= 0) {
	*info = -904;
    }

    if (*n + *ib - 1 > store_m_b__) {
	*info = -1203;
    }

    if (lldb < nb) {
	*info = -1206;
    }

    if (*nrhs < 0) {
	*info = -6;
    }

/*     Current alignment restriction */

    if (*ja != *ib) {
	*info = -8;
    }

/*     Argument checking that is specific to Divide & Conquer routine */

    if (nprow != 1) {
	*info = -902;
    }

    if (*n > np * nb - (*ja - 1) % nb) {
	*info = -3;
	i__1 = -(*info);
        hscal_PB_Cabort(
           "PSDBTRSV, D&C alg.: only 1 block per proc",
           i__1,
           nprow, npcol, myrow, mycol
        );
        return HSCAL_ERR_INPUT;
    }

    if (*ja + *n - 1 > nb && nb < max(*bwl,*bwu) << 1) {
	*info = -904;
	i__1 = -(*info);
        hscal_PB_Cabort(
           "PSDBTRSV, D&C alg.: NB too small",
           i__1,
           nprow, npcol, myrow, mycol
        );
        return HSCAL_ERR_INPUT;
    }


    work_size_min__ = max(*bwl,*bwu) * *nrhs;

/*     Pack params and positions into arrays for global consistency check */

    param_check__[17] = descb[5];
    param_check__[16] = descb[4];
    param_check__[15] = descb[3];
    param_check__[14] = descb[2];
    param_check__[13] = descb[1];
    param_check__[12] = *ib;
    param_check__[11] = desca[5];
    param_check__[10] = desca[4];
    param_check__[9] = desca[3];
    param_check__[8] = desca[1];
    param_check__[7] = *ja;
    param_check__[6] = *nrhs;
    param_check__[5] = *bwu;
    param_check__[4] = *bwl;
    param_check__[3] = *n;
    param_check__[2] = idum3;
    param_check__[1] = idum2;
    param_check__[0] = idum1;

    param_check__[35] = 1205;
    param_check__[34] = 1204;
    param_check__[33] = 1203;
    param_check__[32] = 1202;
    param_check__[31] = 1201;
    param_check__[30] = 11;
    param_check__[29] = 905;
    param_check__[28] = 904;
    param_check__[27] = 903;
    param_check__[26] = 901;
    param_check__[25] = 8;
    param_check__[24] = 6;
    param_check__[23] = 5;
    param_check__[22] = 4;
    param_check__[21] = 3;
    param_check__[20] = 16;
    param_check__[19] = 2;
    param_check__[18] = 1;

/*     Want to find errors with MIN( ), so if no error, set it to a big */
/*     number. If there already is an error, multiply by the the */
/*     descriptor multiplier. */

    if (*info >= 0) {
	*info = 10000;
    } else if (*info < -100) {
	*info = -(*info);
    } else {
	*info = -(*info) * 100;
    }

/*     Check consistency across processors */

    hscal_globchk(&ictxt, &c__18, param_check__, &c__18, &param_check__[36], info,
                  &myrow, &mycol, &nprow, &npcol                  
    );

/*     Prepare output: set info = 0 if no error, and divide by DESCMULT */
/*     if error is not in a descriptor entry. */

    if (*info == 10000) {
	*info = 0;
    } else if (*info % 100 == 0) {
	*info = -(*info) / 100;
    } else {
	*info = -(*info);
    }

    if (*info < 0) {
	i__1 = -(*info);
        hscal_PB_Cabort(
            "PSDBTRSV",
            i__1,
            nprow, npcol, myrow, mycol
        );
	return HSCAL_ERR_INPUT;
    }

/*     Quick return if possible */

    if (*n == 0) {
	return HSCAL_SUCCESS;
    }

    if (*nrhs == 0) {
	return HSCAL_SUCCESS;
    }


/*     Adjust addressing into matrix space to properly get into */
/*        the beginning part of the relevant data */

    part_offset__ = nb * ((*ja - 1) / (npcol * nb));

    if (mycol - csrc < (*ja - part_offset__ - 1) / nb) {
	part_offset__ += nb;
    }

    if (mycol < csrc) {
	part_offset__ -= nb;
    }

/*     Form a new BLACS grid (the "standard form" grid) with only procs */
/*        holding part of the matrix, of size 1xNP where NP is adjusted, */
/*        starting at csrc=0, with JA modified to reflect dropped procs. */

/*     First processor to hold part of the matrix: */

    first_proc__ = ((*ja - 1) / nb + csrc) % npcol;

/*     Calculate new JA one while dropping off unused processors. */

    ja_new__ = (*ja - 1) % nb + 1;

/*     Save and compute new value of NP */

    np_save__ = np;
    np = (ja_new__ + *n - 2) / nb + 1;

/*     Call utility routine that forms "standard-form" grid */
/*
*    reshape_(&ictxt, &c__1, &ictxt_new__, &c__1, &first_proc__, &c__1, &np);
*/
/*     Use new context from standard grid as context. */
/*
*    ictxt_save__ = ictxt;
*    ictxt = ictxt_new__;
*    desca_1xp__[1] = ictxt_new__;
*    descb_px1__[1] = ictxt_new__;
*/
/*     Get information about new grid. */
/*
*    blacs_gridinfo__(&ictxt, &nprow, &npcol, &myrow, &mycol);
*/
/*     Drop out processors that do not have part of the matrix. */
/*
*    if (myrow < 0) {
*	goto L200;
*    }
*/

/*
* The new grid is of the shape 1*np, therefore use it.
*/
nprow = 1;
npcol = np;

if ((mycol > (np - 1)))
{
   return HSCAL_SUCCESS;
}

/*     ******************************** */
/*     Values reused throughout routine */

/*     User-input value of partition size */

    part_size__ = nb;

/*     Number of columns in each processor */

    my_num_cols__ = numroc_(n, &part_size__, &mycol, &c__0, &npcol);

/*     Offset in columns to beginning of main partition in each proc */

    if (mycol == 0) {
	part_offset__ += (ja_new__ - 1) % part_size__;
	my_num_cols__ -= (ja_new__ - 1) % part_size__;
    }

/*     Offset in elements */

    ofst = part_offset__ * llda;

/*     Size of main (or odd) partition in each processor */

    odd_size__ = my_num_cols__;
    if (mycol < np - 1) {
	odd_size__ -= max_bw__;
    }

/*     Offset to workspace for Upper triangular factor */

    work_u__ = *bwu * odd_size__ + mbw2 * 3;



/*     Begin main code */

    if (hscal_lsame(uplo, "L")) {

	if (hscal_lsame(trans, "N")) {

/*        Frontsolve */


/* ***************************************** */
/*       Local computation phase */
/* ***************************************** */

/*       Use main partition in each processor to solve locally */

	    stbtrs_tcomp_macro(uplo, "N", "U", &odd_size__, bwl, nrhs,
		    &llda, &lldb, info, 
                nprow, npcol, myrow, mycol, tcomp
          );


	    if (mycol < np - 1) {
/*         Use factorization of odd-even connection block to modify */
/*           locally stored portion of right hand side(s) */


/*           First copy and multiply it into temporary storage, */
/*             then use it on RHS */

		slacpy_tcomp_macro("N", bwl, nrhs, 
			&lldb, &max_bw__, 
                nprow, npcol, myrow, mycol, tcomp
            );

		i__1 = llda - 1;
		strmm_tcomp_macro("L", "U", "N", "N", bwl, nrhs, (char*)&c_b32,
			&i__1, &max_bw__, 
                nprow, npcol, myrow, mycol, tcomp
            );

		smatadd_tcomp_macro(bwl, nrhs, &c_b33, &max_bw__, &c_b33,
			&lldb,
                nprow, npcol, myrow, mycol, tcomp
            );

	    }

/*       Clear garbage out of workspace block */

	    i__1 = work_size_min__;
          if (tcomp != NULL)
          {
             TCOMP((myrow), (mycol), (nprow), (npcol)) += i__1;
          }

	    if (mycol != 0) {

/*         Use the "spike" fillin to calculate contribution to previous */
/*           processor's righthand-side. */

		sgemm_tcomp_macro("N", "N", bwu, nrhs, &odd_size__, (char*)&c_b32, bwu, 
			&lldb, (char*)&c_b39, &max_bw__,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }


/* *********************************************** */
/*       Formation and solution of reduced system */
/* *********************************************** */

/*
*  Retrieve process grid information
*/
    Cblacs_gridinit_nocomm(&blacsctxt, "r", nprow, npcol);

/*       Send modifications to prior processor's right hand sides */

	    if (mycol > 0) {

		i__1 = mycol - 1;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs, max_bw__, c__0, 
			i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }

/*       Receive modifications to processor's right hand sides */

	    if (mycol < npcol - 1) {

		i__1 = mycol + 1;

/*         Combine contribution to locally stored right hand sides */

		smatadd_tcomp_macro(&max_bw__, nrhs, &c_b33, &max_bw__, &c_b33,
			 &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }


/*       The last processor does not participate in the solution of the */
/*       reduced system, having sent its contribution already. */
	    if (mycol == npcol - 1) {
		goto L40;
	    }


/*       ************************************* */
/*       Modification Loop */

/*       The distance for sending and receiving for each level starts */
/*         at 1 for the first level. */
	    level_dist__ = 1;

/*       Do until this proc is needed to modify other procs' equations */

L20:
	    if ((mycol + 1) / level_dist__ % 2 != 0) {
		goto L30;
	    }

/*         Receive and add contribution to righthand sides from left */

	    if (mycol - level_dist__ >= 0) {

		i__1 = mycol - level_dist__;

		smatadd_tcomp_macro(&max_bw__, nrhs, &c_b33, &max_bw__, &c_b33,
			 &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }

/*         Receive and add contribution to righthand sides from right */

	    if (mycol + level_dist__ < npcol - 1) {

		i__1 = mycol + level_dist__;
		smatadd_tcomp_macro(&max_bw__, nrhs, &c_b33, &max_bw__, &c_b33,
			 &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }

	    level_dist__ <<= 1;

	    goto L20;
L30:
/*       [End of GOTO Loop] */



/*       ********************************* */
/*       Calculate and use this proc's blocks to modify other procs */

/*       Solve with diagonal block */

/* Computing MIN */
	    i__2 = *bwl, i__3 = max_bw__ - 1;
	    i__1 = min(i__2,i__3);
	    i__4 = max_bw__ + 1;
	    stbtrs_tcomp_macro("L", "N", "U", &max_bw__, &i__1, nrhs,
		    &i__4, &lldb, info, 
                nprow, npcol, myrow, mycol, tcomp
          );


/*       ********* */
	    if (mycol / level_dist__ <= (npcol - 1) / level_dist__ - 2) {

/*         Calculate contribution from this block to next diagonal block */

		sgemm_tcomp_macro("T", "N", &max_bw__, nrhs, &max_bw__, (char*)&c_b32,
			&max_bw__,
			&lldb, (char*)&c_b39, &max_bw__, 
                  nprow, npcol, myrow, mycol, tcomp
            );

/*         Send contribution to diagonal block's owning processor. */

		i__1 = mycol + level_dist__;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs, max_bw__, c__0, 
			i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }
/*       End of "if( mycol/level_dist .le. (npcol-1)/level_dist-2 )..." */

/*       ************ */
	    if (mycol / level_dist__ > 0 && mycol / level_dist__ <= (npcol - 
		    1) / level_dist__ - 1) {


/*         Use offdiagonal block to calculate modification to diag block */
/*           of processor to the left */

		sgemm_tcomp_macro("N", "N", &max_bw__, nrhs, &max_bw__, (char*)&c_b32,
		 	&max_bw__, &lldb, (char*)&c_b39, &max_bw__,
                  nprow, npcol, myrow, mycol, tcomp
            );

/*         Send contribution to diagonal block's owning processor. */

		i__1 = mycol - level_dist__;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs, max_bw__, c__0, 
			i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }
/*       End of "if( mycol/level_dist.le. (npcol-1)/level_dist -1 )..." */

L40:

	    ;
	} else {

/* ******************* BACKSOLVE ************************************* */

/* ******************************************************************* */
/*     .. Begin reduced system phase of algorithm .. */
/* ******************************************************************* */



/*       The last processor does not participate in the solution of the */
/*       reduced system and just waits to receive its solution. */
	    if (mycol == npcol - 1) {
		goto L90;
	    }

/*       Determine number of steps in tree loop */

	    level_dist__ = 1;
L50:
	    if ((mycol + 1) / level_dist__ % 2 != 0) {
		goto L60;
	    }

	    level_dist__ <<= 1;

	    goto L50;
L60:


	    if (mycol / level_dist__ > 0 && mycol / level_dist__ <= (npcol - 
		    1) / level_dist__ - 1) {

/*         Receive solution from processor to left */

		i__1 = mycol - level_dist__;


/*         Use offdiagonal block to calculate modification to RHS stored */
/*           on this processor */

		sgemm_tcomp_macro("T", "N", &max_bw__, nrhs, &max_bw__, (char*)&c_b32,
			&max_bw__, &max_bw__, (char*)&c_b33, &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );
	    }
/*       End of "if( mycol/level_dist.le. (npcol-1)/level_dist -1 )..." */


	    if (mycol / level_dist__ <= (npcol - 1) / level_dist__ - 2) {

/*         Receive solution from processor to right */

		i__1 = mycol + level_dist__;

/*         Calculate contribution from this block to next diagonal block */

		sgemm_tcomp_macro("N", "N", &max_bw__, nrhs, &max_bw__, (char*)&c_b32,
			&max_bw__, &max_bw__, (char*)&c_b33,
			&lldb, 
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }
/*       End of "if( mycol/level_dist .le. (npcol-1)/level_dist-2 )..." */


/*       Solve with diagonal block */

/* Computing MIN */
	    i__2 = *bwl, i__3 = max_bw__ - 1;
	    i__1 = min(i__2,i__3);
	    i__4 = max_bw__ + 1;
	    stbtrs_tcomp_macro("L", "T", "U", &max_bw__, &i__1, nrhs,
		    &i__4, &lldb, info,
                nprow, npcol, myrow, mycol, tcomp
          );


/* **Modification Loop ******* */

L70:
	    if (level_dist__ == 1) {
		goto L80;
	    }

	    level_dist__ /= 2;

/*         Send solution to the right */

	    if (mycol + level_dist__ < npcol - 1) {

		i__1 = mycol + level_dist__;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs,
			lldb, c__0, i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }

/*         Send solution to left */

	    if (mycol - level_dist__ >= 0) {

		i__1 = mycol - level_dist__;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs,
			lldb, c__0, i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }

	    goto L70;
L80:
/*       [End of GOTO Loop] */

L90:
/*          [Processor npcol - 1 jumped to here to await next stage] */

/* ****************************** */
/*       Reduced system has been solved, communicate solutions to nearest */
/*         neighbors in preparation for local computation phase. */


/*       Send elements of solution to next proc */

	    if (mycol < npcol - 1) {

		i__1 = mycol + 1;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs,
			lldb, c__0, i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }

/*       Receive modifications to processor's right hand sides */

	    if (mycol > 0) {

		i__1 = mycol - 1;

	    }



/* ********************************************* */
/*       Local computation phase */
/* ********************************************* */

	    if (mycol != 0) {
/*         Use the "spike" fillin to calculate contribution from previous */
/*           processor's solution. */

		sgemm_tcomp_macro("T", "N", &odd_size__, nrhs, bwu, (char*)&c_b32, bwu, 
			&max_bw__, (char*)&c_b33, &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }


	    if (mycol < np - 1) {
/*         Use factorization of odd-even connection block to modify */
/*           locally stored portion of right hand side(s) */


/*         First copy and multiply it into temporary storage, */
/*           then use it on RHS */

		slacpy_tcomp_macro("N", bwl, nrhs, &lldb, &max_bw__, 
                  nprow, npcol, myrow, mycol, tcomp
            );

		i__1 = llda - 1;
		strmm_tcomp_macro("L", "U", "T", "N", bwl, nrhs, (char*)&c_b32, 
                  &i__1, &max_bw__, 
                  nprow, npcol, myrow, mycol, tcomp
            );

		smatadd_tcomp_macro(bwl, nrhs, &c_b33,
                  &max_bw__, &c_b33, &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }

/*       Use main partition in each processor to solve locally */

	    stbtrs_tcomp_macro(uplo, "T", "U", &odd_size__, bwl, nrhs,
		    &llda, &lldb, info, 
                nprow, npcol, myrow, mycol, tcomp
          );

	}
/*     End of "IF( LSAME( TRANS, 'N' ) )"... */


    } else {
/* ************************************************************** */
/*     CASE UPLO = 'U'                                         * */
/* ************************************************************** */
	if (hscal_lsame(trans, "T")) {

/*        Frontsolve */


/* ***************************************** */
/*       Local computation phase */
/* ***************************************** */

/*       Use main partition in each processor to solve locally */

	    stbtrs_tcomp_macro(uplo, "T", "N", &odd_size__, bwu, nrhs, 
                &llda, &lldb, info, 
                nprow, npcol, myrow, mycol, tcomp
          );


	    if (mycol < np - 1) {
/*         Use factorization of odd-even connection block to modify */
/*           locally stored portion of right hand side(s) */


/*           First copy and multiply it into temporary storage, */
/*             then use it on RHS */

		slacpy_tcomp_macro("N", bwu, nrhs, 
			&lldb, &max_bw__, 
                  nprow, npcol, myrow, mycol, tcomp
            );

		i__1 = llda - 1;
		strmm_tcomp_macro("L", "L", "T", "N", bwu, nrhs, (char*)&c_b32,
			&i__1, &max_bw__, 
                  nprow, npcol, myrow, mycol, tcomp
            );

		smatadd_tcomp_macro(bwu, nrhs, &c_b33, &max_bw__, &c_b33, &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }

/*       Clear garbage out of workspace block */

	    i__1 = work_size_min__;
          if (tcomp != NULL)
          {
             TCOMP((myrow), (mycol), (nprow), (npcol)) += i__1;
          }

	    if (mycol != 0) {
/*         Use the "spike" fillin to calculate contribution to previous */
/*           processor's righthand-side. */

		sgemm_tcomp_macro("N", "N", bwl, nrhs, &odd_size__, (char*)&c_b32,
			bwl, &lldb, (char*)&c_b39, &max_bw__, 
                  nprow, npcol, myrow, mycol, tcomp
            );
	    }


/* *********************************************** */
/*       Formation and solution of reduced system */
/* *********************************************** */


/*       Send modifications to prior processor's right hand sides */

	    if (mycol > 0) {

		i__1 = mycol - 1;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs, max_bw__, c__0, 
			i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }

/*       Receive modifications to processor's right hand sides */

	    if (mycol < npcol - 1) {

		i__1 = mycol + 1;

/*         Combine contribution to locally stored right hand sides */

		smatadd_tcomp_macro(&max_bw__, nrhs, &c_b33, &max_bw__, &c_b33,
			 &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }


/*       The last processor does not participate in the solution of the */
/*       reduced system, having sent its contribution already. */
	    if (mycol == npcol - 1) {
		goto L130;
	    }


/*       ************************************* */
/*       Modification Loop */

/*       The distance for sending and receiving for each level starts */
/*         at 1 for the first level. */
	    level_dist__ = 1;

/*       Do until this proc is needed to modify other procs' equations */

L110:
	    if ((mycol + 1) / level_dist__ % 2 != 0) {
		goto L120;
	    }

/*         Receive and add contribution to righthand sides from left */

	    if (mycol - level_dist__ >= 0) {

		i__1 = mycol - level_dist__;

		smatadd_tcomp_macro(&max_bw__, nrhs, &c_b33, &max_bw__, &c_b33,
			 &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }

/*         Receive and add contribution to righthand sides from right */

	    if (mycol + level_dist__ < npcol - 1) {

		i__1 = mycol + level_dist__;

		smatadd_tcomp_macro(&max_bw__, nrhs, &c_b33, &max_bw__, &c_b33,
			 &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }

	    level_dist__ <<= 1;

	    goto L110;
L120:
/*       [End of GOTO Loop] */



/*       ********************************* */
/*       Calculate and use this proc's blocks to modify other procs */

/*       Solve with diagonal block */

/* Computing MIN */
	    i__2 = *bwu, i__3 = max_bw__ - 1;
	    i__1 = min(i__2,i__3);
/* Computing MIN */
	    i__4 = *bwu, i__5 = max_bw__ - 1;
	    i__6 = max_bw__ + 1;
	    stbtrs_tcomp_macro("U", "T", "N", &max_bw__, &i__1, nrhs,
		    &i__6, &lldb, info,
                nprow, npcol, myrow, mycol, tcomp
          );

/*       ********* */
	    if (mycol / level_dist__ <= (npcol - 1) / level_dist__ - 2) {

/*         Calculate contribution from this block to next diagonal block */

		sgemm_tcomp_macro("T", "N", &max_bw__, nrhs, &max_bw__, (char*)&c_b32, 
			&max_bw__, &lldb, (char*)&c_b39, &max_bw__,
                nprow, npcol, myrow, mycol, tcomp
            );

/*         Send contribution to diagonal block's owning processor. */

		i__1 = mycol + level_dist__;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs, max_bw__, c__0, 
			i__1,
                nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }
/*       End of "if( mycol/level_dist .le. (npcol-1)/level_dist-2 )..." */

/*       ************ */
	    if (mycol / level_dist__ > 0 && mycol / level_dist__ <= (npcol - 
		    1) / level_dist__ - 1) {


/*         Use offdiagonal block to calculate modification to diag block */
/*           of processor to the left */

		sgemm_tcomp_macro("N", "N", &max_bw__, nrhs, &max_bw__, (char*)&c_b32,
			&max_bw__, &lldb, (char*)&c_b39, &max_bw__,
                nprow, npcol, myrow, mycol, tcomp
            );

/*         Send contribution to diagonal block's owning processor. */

		i__1 = mycol - level_dist__;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs, max_bw__, c__0, 
			i__1,
                nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }
/*       End of "if( mycol/level_dist.le. (npcol-1)/level_dist -1 )..." */

L130:

	    ;
	} else {

/* ******************* BACKSOLVE ************************************* */

/* ******************************************************************* */
/*     .. Begin reduced system phase of algorithm .. */
/* ******************************************************************* */



/*       The last processor does not participate in the solution of the */
/*       reduced system and just waits to receive its solution. */
	    if (mycol == npcol - 1) {
		goto L180;
	    }

/*       Determine number of steps in tree loop */

	    level_dist__ = 1;
L140:
	    if ((mycol + 1) / level_dist__ % 2 != 0) {
		goto L150;
	    }

	    level_dist__ <<= 1;

	    goto L140;
L150:


	    if (mycol / level_dist__ > 0 && mycol / level_dist__ <= (npcol - 
		    1) / level_dist__ - 1) {

/*         Receive solution from processor to left */

		i__1 = mycol - level_dist__;

/*         Use offdiagonal block to calculate modification to RHS stored */
/*           on this processor */

		sgemm_tcomp_macro("T", "N", &max_bw__, nrhs, &max_bw__, (char*)&c_b32,
			&max_bw__, &max_bw__, (char*)&c_b33, &lldb, 
                  nprow, npcol, myrow, mycol, tcomp
            );
	    }
/*       End of "if( mycol/level_dist.le. (npcol-1)/level_dist -1 )..." */


	    if (mycol / level_dist__ <= (npcol - 1) / level_dist__ - 2) {

/*         Receive solution from processor to right */

		i__1 = mycol + level_dist__;

/*         Calculate contribution from this block to next diagonal block */

		sgemm_tcomp_macro("N", "N", &max_bw__, nrhs, &max_bw__, (char*)&c_b32,
			&max_bw__, &max_bw__, (char*)&c_b33, &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }
/*       End of "if( mycol/level_dist .le. (npcol-1)/level_dist-2 )..." */


/*       Solve with diagonal block */

/* Computing MIN */
	    i__2 = *bwu, i__3 = max_bw__ - 1;
	    i__1 = min(i__2,i__3);
/* Computing MIN */
	    i__4 = *bwu, i__5 = max_bw__ - 1;
	    i__6 = max_bw__ + 1;
	    stbtrs_tcomp_macro("U", "N", "N", &max_bw__, &i__1, nrhs, &i__6, 
                &lldb, info, 
                nprow, npcol, myrow, mycol, tcomp
          );

/* **Modification Loop ******* */

L160:
	    if (level_dist__ == 1) {
		goto L170;
	    }

	    level_dist__ /= 2;

/*         Send solution to the right */

	    if (mycol + level_dist__ < npcol - 1) {

		i__1 = mycol + level_dist__;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs, lldb, c__0, i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }

/*         Send solution to left */

	    if (mycol - level_dist__ >= 0) {

		i__1 = mycol - level_dist__;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs,
			lldb, c__0, i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }

	    goto L160;
L170:
/*       [End of GOTO Loop] */

L180:
/*          [Processor npcol - 1 jumped to here to await next stage] */

/* ****************************** */
/*       Reduced system has been solved, communicate solutions to nearest */
/*         neighbors in preparation for local computation phase. */


/*       Send elements of solution to next proc */

	    if (mycol < npcol - 1) {

		i__1 = mycol + 1;
		hscal_Csgesd2d(blacsctxt, max_bw__, *nrhs,
			lldb, c__0, i__1,
                  nprow, npcol, myrow, mycol, tcomp, tcomm
            );

	    }

/*       Receive modifications to processor's right hand sides */

	    if (mycol > 0) {

		i__1 = mycol - 1;

	    }



/* ********************************************* */
/*       Local computation phase */
/* ********************************************* */

	    if (mycol != 0) {
/*         Use the "spike" fillin to calculate contribution from previous */
/*           processor's solution. */

		sgemm_tcomp_macro("T", "N", &odd_size__, nrhs, bwl, (char*)&c_b32,
			bwl, &max_bw__, (char*)&c_b33, &lldb, 
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }


	    if (mycol < np - 1) {
/*         Use factorization of odd-even connection block to modify */
/*           locally stored portion of right hand side(s) */


/*         First copy and multiply it into temporary storage, */
/*           then use it on RHS */

		i__1 = max_bw__ + *bwl;
		slacpy_tcomp_macro("N", bwu, nrhs, 
                  &lldb, &i__1, 
                  nprow, npcol, myrow, mycol, tcomp
            );

		i__1 = llda - 1;
		i__2 = max_bw__ + *bwl;
		strmm_tcomp_macro("L", "L", "N", "N", bwu, nrhs, (char*)&c_b32,
			&i__1, &i__2,
                  nprow, npcol, myrow, mycol, tcomp
            );

		i__1 = max_bw__ + *bwl;
		smatadd_tcomp_macro(bwu, nrhs, &c_b33, &i__1,
			 &c_b33, &lldb,
                  nprow, npcol, myrow, mycol, tcomp
            );

	    }

/*       Use main partition in each processor to solve locally */

	    stbtrs_tcomp_macro(uplo, "N", "N", &odd_size__, bwu, nrhs, 
                &llda, &lldb, info, 
                nprow, npcol, myrow, mycol, tcomp
          );

	}
/*     End of "IF( LSAME( TRANS, 'N' ) )"... */


    }
/*     End of "IF( LSAME( UPLO, 'L' ) )"... */

    Cblacs_gridexit_nocomm(blacsctxt);

    return HSCAL_SUCCESS;

/*     End of PSDBTRSV */

}

#endif
