
#ifndef __HSCALAPACK_PSLASCL_HSCALFUNC_HH
#define __HSCALAPACK_PSLASCL_HSCALFUNC_HH

/*
*  Include files
*/
#include "../include/hscalapack.h"

int hscal_pslascl(
    char *type__,
    hscalinteger *m, hscalinteger *n,
    hscalinteger *ia, hscalinteger *ja, hscalinteger *desca,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
)
{
    hscalinteger c__4 = 4;
    hscalinteger c__6 = 6;
    hscalinteger c__9 = 9;

    /* System generated locals */
    hscalinteger i__1, i__2, i__3, i__4, i__5, i__6;

    /* Local variables */
    hscalinteger j, jb, ii, jj, kk, jn, ll, mp, nq, lda, iia, jja;
    hscalreal mul, cto1;
    hscallogical done;
    hscalreal ctoc;
    hscalinteger ioffa;
    hscalinteger iacol;
    hscalinteger iarow, itype, ictxt;
    hscalreal cfrom1;
    hscalinteger icoffa, iroffa;
    hscalreal cfromc, bignum;
    hscalreal smlnum;
    hscalinteger icurcol, icurrow, inxtrow;

    hscalreal cfrom_l = 0.5, *cfrom = &cfrom_l;
    hscalreal cto_l = 0.5, *cto = &cto_l;
    int     info_l, *info = &info_l;

/*  -- ScaLAPACK auxiliary routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  PSLASCL multiplies the M-by-N real distributed matrix sub( A ) */
/*  denoting A(IA:IA+M-1,JA:JA+N-1) by the real scalar CTO/CFROM.  This */
/*  is done without over/underflow as long as the final result */
/*  CTO * A(I,J) / CFROM does not over/underflow. TYPE specifies that */
/*  sub( A ) may be full, upper triangular, lower triangular or upper */
/*  Hessenberg. */

/*  Notes */
/*  ===== */

/*  Each global data object is described by an associated description */
/*  vector.  This vector stores the information required to establish */
/*  the mapping between an object element and its corresponding process */
/*  and memory location. */

/*  Let A be a generic term for any 2D block cyclicly distributed array. */
/*  Such a global array has an associated description vector DESCA. */
/*  In the following comments, the character _ should be read as */
/*  "of the global array". */

/*  NOTATION        STORED IN      EXPLANATION */
/*  --------------- -------------- -------------------------------------- */
/*  DTYPE_A(global) DESCA( DTYPE_ )The descriptor type.  In this case, */
/*                                 DTYPE_A = 1. */
/*  CTXT_A (global) DESCA( CTXT_ ) The BLACS context handle, indicating */
/*                                 the BLACS process grid A is distribu- */
/*                                 ted over. The context itself is glo- */
/*                                 bal, but the handle (the integer */
/*                                 value) may vary. */
/*  M_A    (global) DESCA( M_ )    The number of rows in the global */
/*                                 array A. */
/*  N_A    (global) DESCA( N_ )    The number of columns in the global */
/*                                 array A. */
/*  MB_A   (global) DESCA( MB_ )   The blocking factor used to distribute */
/*                                 the rows of the array. */
/*  NB_A   (global) DESCA( NB_ )   The blocking factor used to distribute */
/*                                 the columns of the array. */
/*  RSRC_A (global) DESCA( RSRC_ ) The process row over which the first */
/*                                 row of the array A is distributed. */
/*  CSRC_A (global) DESCA( CSRC_ ) The process column over which the */
/*                                 first column of the array A is */
/*                                 distributed. */
/*  LLD_A  (local)  DESCA( LLD_ )  The leading dimension of the local */
/*                                 array.  LLD_A >= MAX(1,LOCr(M_A)). */

/*  Let K be the number of rows or columns of a distributed matrix, */
/*  and assume that its process grid has dimension p x q. */
/*  LOCr( K ) denotes the number of elements of K that a process */
/*  would receive if K were distributed over the p processes of its */
/*  process column. */
/*  Similarly, LOCc( K ) denotes the number of elements of K that a */
/*  process would receive if K were distributed over the q processes of */
/*  its process row. */
/*  The values of LOCr() and LOCc() may be determined via a call to the */
/*  ScaLAPACK tool function, NUMROC: */
/*          LOCr( M ) = NUMROC( M, MB_A, MYROW, RSRC_A, NPROW ), */
/*          LOCc( N ) = NUMROC( N, NB_A, MYCOL, CSRC_A, NPCOL ). */
/*  An upper bound for these quantities may be computed by: */
/*          LOCr( M ) <= ceil( ceil(M/MB_A)/NPROW )*MB_A */
/*          LOCc( N ) <= ceil( ceil(N/NB_A)/NPCOL )*NB_A */

/*  Arguments */
/*  ========= */

/*  TYPE    (global input) CHARACTER */
/*          TYPE indices the storage type of the input distributed */
/*          matrix. */
/*          = 'G':  sub( A ) is a full matrix, */
/*          = 'L':  sub( A ) is a lower triangular matrix, */
/*          = 'U':  sub( A ) is an upper triangular matrix, */
/*          = 'H':  sub( A ) is an upper Hessenberg matrix. */

/*  CFROM   (global input) REAL */
/*  CTO     (global input) REAL */
/*          The distributed matrix sub( A ) is multiplied by CTO/CFROM. */
/*          A(I,J) is computed without over/underflow if the final */
/*          result CTO * A(I,J) / CFROM can be represented without */
/*          over/underflow.  CFROM must be nonzero. */

/*  M       (global input) INTEGER */
/*          The number of rows to be operated on i.e the number of rows */
/*          of the distributed submatrix sub( A ). M >= 0. */

/*  N       (global input) INTEGER */
/*          The number of columns to be operated on i.e the number of */
/*          columns of the distributed submatrix sub( A ). N >= 0. */

/*  A       (local input/local output) REAL pointer into the */
/*          local memory to an array of dimension (LLD_A,LOCc(JA+N-1)). */
/*          This array contains the local pieces of the distributed */
/*          matrix sub( A ). On exit, this array contains the local */
/*          pieces of the distributed matrix multiplied by CTO/CFROM. */

/*  IA      (global input) INTEGER */
/*          The row index in the global array A indicating the first */
/*          row of sub( A ). */

/*  JA      (global input) INTEGER */
/*          The column index in the global array A indicating the */
/*          first column of sub( A ). */

/*  DESCA   (global and local input) INTEGER array of dimension DLEN_. */
/*          The array descriptor for the distributed matrix A. */

/*  INFO    (local output) INTEGER */
/*          = 0:  successful exit */
/*          < 0:  If the i-th argument is an array and the j-entry had */
/*                an illegal value, then INFO = -(i*100+j), if the i-th */
/*                argument is a scalar and had an illegal value, then */
/*                INFO = -i. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. External Functions .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

/*     Get grid parameters */

    /* Parameter adjustments */
    --desca;

/*     Test the input parameters */

    if (nprow == -1) {
	*info = -907;
    } else {
	*info = 0;
	hscal_chk1mat(
             m, &c__4, n, &c__6, ia, ja, &desca[1], &c__9, info,
             myrow, mycol, nprow, npcol
        );
	if (*info == 0) {
	    if (hscal_lsame(type__, "G")) {
		itype = 0;
	    } else if (hscal_lsame(type__, "L")) {
		itype = 1;
	    } else if (hscal_lsame(type__, "U")) {
		itype = 2;
	    } else if (hscal_lsame(type__, "H")) {
		itype = 3;
	    } else {
		itype = -1;
	    }
	    if (itype == -1) {
		*info = -1;
	    } else if (*cfrom == 0.f) {
		*info = -4;
	    }
	}
    }

    if (*info != 0) {
	i__1 = -(*info);
        hscal_PB_Cabort(
             "PSLASCL",
             i__1,
             nprow, npcol, myrow, mycol
        );
	return HSCAL_SUCCESS;
    }

/*     Quick return if possible */

    if (*n == 0 || *m == 0) {
	return HSCAL_SUCCESS;
    }

/*     Compute local indexes */

    lda = desca[9];
    iroffa = (*ia - 1) % desca[5];
    icoffa = (*ja - 1) % desca[6];
/* Computing MIN */
    i__1 = iceil_(ja, &desca[6]) * desca[6], i__2 = *ja + *n - 1;
    jn = min(i__1,i__2);
    infog2l_(ia, ja, &desca[1], &nprow, &npcol, &myrow, &mycol, &iia, &jja, &
	    iarow, &iacol);
    i__1 = *m + iroffa;
    mp = numroc_(&i__1, &desca[5], &myrow, &iarow, &nprow);
    if (myrow == iarow) {
	mp -= iroffa;
    }
    i__1 = *n + icoffa;
    nq = numroc_(&i__1, &desca[6], &mycol, &iacol, &npcol);
    if (mycol == iacol) {
	nq -= icoffa;
    }

    ioffa = (jja - 1) * lda;
    icurrow = iarow;
    icurcol = iacol;

    if (itype == 0) {

/*        Full matrix */
        if (tcomp != NULL)
        {
           TCOMP((myrow), (mycol), (nprow), (npcol)) += nq*mp;
        }

    } else if (itype == 1) {

/*        Lower triangular matrix */

	ii = iia;
	jj = jja;
	jb = jn - *ja + 1;

	if (mycol == icurcol) {
	    if (myrow == icurrow) {
		i__1 = jj + jb - 1;
		for (ll = jj; ll <= i__1; ++ll) {
		    i__2 = iia + mp - 1;
                    kk = ii + ll - jj;
                    if (tcomp != NULL)
                    {
                       TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__2 - kk + 1);
                    }
		}
	    } else {
		i__1 = jj + jb - 1;
		for (ll = jj; ll <= i__1; ++ll) {
		    i__2 = iia + mp - 1;
                    kk = ii;
                    if (tcomp != NULL)
                    {
                       TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__2 - kk + 1);
                    }
		}
	    }
	    jj += jb;
	}

	if (myrow == icurrow) {
	    ii += jb;
	}
	icurrow = (icurrow + 1) % nprow;
	icurcol = (icurcol + 1) % npcol;

/*        Loop over remaining block of columns */

	i__1 = *ja + *n - 1;
	i__2 = desca[6];
	for (j = jn + 1; i__2 < 0 ? j >= i__1 : j <= i__1; j += i__2) {
/* Computing MIN */
	    i__3 = *ja + *n - j;
	    jb = min(i__3,desca[6]);

	    if (mycol == icurcol) {
		if (myrow == icurrow) {
		    i__3 = jj + jb - 1;
		    for (ll = jj; ll <= i__3; ++ll) {
			i__4 = iia + mp - 1;
                        kk = ii + ll - jj;
                        if (tcomp != NULL)
                        {
                           TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__4 - kk + 1);
                        }
		    }
		} else {
		    i__3 = jj + jb - 1;
		    for (ll = jj; ll <= i__3; ++ll) {
			i__4 = iia + mp - 1;
                        kk = ii;
                        if (tcomp != NULL)
                        {
                           TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__4 - kk + 1);
                        }
		    }
		}
		jj += jb;
	    }

	    if (myrow == icurrow) {
		ii += jb;
	    }
	    icurrow = (icurrow + 1) % nprow;
	    icurcol = (icurcol + 1) % npcol;

/* L120: */
	}

    } else if (itype == 2) {

/*        Upper triangular matrix */

	ii = iia;
	jj = jja;
	jb = jn - *ja + 1;

	if (mycol == icurcol) {
	    if (myrow == icurrow) {
		i__2 = jj + jb - 1;
		for (ll = jj; ll <= i__2; ++ll) {
/* Computing MIN */
		    i__3 = ii + ll - jj, i__4 = iia + mp - 1;
		    i__1 = min(i__3,i__4);
                    kk = iia;
                    if (tcomp != NULL)
                    {
                       TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__1 - kk + 1);
                    }
		}
	    } else {
		i__2 = jj + jb - 1;
		for (ll = jj; ll <= i__2; ++ll) {
/* Computing MIN */
		    i__3 = ii - 1, i__4 = iia + mp - 1;
		    i__1 = min(i__3,i__4);
                    kk = iia;
                    if (tcomp != NULL)
                    {
                       TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__1 - kk + 1);
                    }
		}
	    }
	    jj += jb;
	}

	if (myrow == icurrow) {
	    ii += jb;
	}
	icurrow = (icurrow + 1) % nprow;
	icurcol = (icurcol + 1) % npcol;

/*        Loop over remaining block of columns */

	i__2 = *ja + *n - 1;
	i__1 = desca[6];
	for (j = jn + 1; i__1 < 0 ? j >= i__2 : j <= i__2; j += i__1) {
/* Computing MIN */
	    i__3 = *ja + *n - j;
	    jb = min(i__3,desca[6]);

	    if (mycol == icurcol) {
		if (myrow == icurrow) {
		    i__3 = jj + jb - 1;
		    for (ll = jj; ll <= i__3; ++ll) {
/* Computing MIN */
			i__5 = ii + ll - jj, i__6 = iia + mp - 1;
			i__4 = min(i__5,i__6);
                        kk = iia;
                        if (tcomp != NULL)
                        {
                           TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__4 - kk + 1);
                        }
		    }
		} else {
		    i__3 = jj + jb - 1;
		    for (ll = jj; ll <= i__3; ++ll) {
/* Computing MIN */
			i__5 = ii - 1, i__6 = iia + mp - 1;
			i__4 = min(i__5,i__6);
                        kk = iia;
                        if (tcomp != NULL)
                        {
                           TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__4 - kk + 1);
                        }
		    }
		}
		jj += jb;
	    }

	    if (myrow == icurrow) {
		ii += jb;
	    }
	    icurrow = (icurrow + 1) % nprow;
	    icurcol = (icurcol + 1) % npcol;

/* L210: */
	}

    } else if (itype == 3) {

/*        Upper Hessenberg matrix */

	ii = iia;
	jj = jja;
	jb = jn - *ja + 1;

/*        Only one process row */

	if (nprow == 1) {

/*           Handle first block of columns separately */

	    if (mycol == icurcol) {
		i__1 = jj + jb - 1;
		for (ll = jj; ll <= i__1; ++ll) {
/* Computing MIN */
		    i__3 = ii + ll - jj + 1, i__4 = iia + mp - 1;
		    i__2 = min(i__3,i__4);
                    kk = iia;
                    if (tcomp != NULL)
                    {
                       TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__2 - kk + 1);
                    }
		}
		jj += jb;
	    }

	    icurcol = (icurcol + 1) % npcol;

/*           Loop over remaining block of columns */

	    i__1 = *ja + *n - 1;
	    i__2 = desca[6];
	    for (j = jn + 1; i__2 < 0 ? j >= i__1 : j <= i__1; j += i__2) {
/* Computing MIN */
		i__3 = *ja + *n - j;
		jb = min(i__3,desca[6]);

		if (mycol == icurcol) {
		    i__3 = jj + jb - 1;
		    for (ll = jj; ll <= i__3; ++ll) {
/* Computing MIN */
			i__5 = ii + ll - jj + 1, i__6 = iia + mp - 1;
			i__4 = min(i__5,i__6);
                        kk = iia;
                        if (tcomp != NULL)
                        {
                           TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__4 - kk + 1);
                        }
		    }
		    jj += jb;
		}

		ii += jb;
		icurcol = (icurcol + 1) % npcol;

/* L260: */
	    }

	} else {

/*           Handle first block of columns separately */

	    inxtrow = (icurrow + 1) % nprow;
	    if (mycol == icurcol) {
		if (myrow == icurrow) {
		    i__2 = jj + jb - 1;
		    for (ll = jj; ll <= i__2; ++ll) {
/* Computing MIN */
			i__3 = ii + ll - jj + 1, i__4 = iia + mp - 1;
			i__1 = min(i__3,i__4);
                        kk = iia;
                        if (tcomp != NULL)
                        {
                           TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__1 - kk + 1);
                        }
		    }
		} else {
		    i__2 = jj + jb - 1;
		    for (ll = jj; ll <= i__2; ++ll) {
/* Computing MIN */
			i__3 = ii - 1, i__4 = iia + mp - 1;
			i__1 = min(i__3,i__4);
                        kk = iia;
                        if (tcomp != NULL)
                        {
                           TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__1 - kk + 1);
                        }
		    }
		    if (myrow == inxtrow && ii <= iia + mp - 1) {
			;
		    }
		}
		jj += jb;
	    }

	    if (myrow == icurrow) {
		ii += jb;
	    }
	    icurrow = inxtrow;
	    icurrow = (icurrow + 1) % nprow;
	    icurcol = (icurcol + 1) % npcol;

/*           Loop over remaining block of columns */

	    i__2 = *ja + *n - 1;
	    i__1 = desca[6];
	    for (j = jn + 1; i__1 < 0 ? j >= i__2 : j <= i__2; j += i__1) {
/* Computing MIN */
		i__3 = *ja + *n - j;
		jb = min(i__3,desca[6]);

		if (mycol == icurcol) {
		    if (myrow == icurrow) {
			i__3 = jj + jb - 1;
			for (ll = jj; ll <= i__3; ++ll) {
/* Computing MIN */
			    i__5 = ii + ll - jj + 1, i__6 = iia + mp - 1;
			    i__4 = min(i__5,i__6);
                            kk = iia;
                            if (tcomp != NULL)
                            {
                               TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__4 - kk + 1);
                            }
			}
		    } else {
			i__3 = jj + jb - 1;
			for (ll = jj; ll <= i__3; ++ll) {
/* Computing MIN */
			    i__5 = ii - 1, i__6 = iia + mp - 1;
			    i__4 = min(i__5,i__6);
                            kk = iia;
                            if (tcomp != NULL)
                            {
                               TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__4 - kk + 1);
                            }
			}
			if (myrow == inxtrow && ii <= iia + mp - 1) {
			    ;
			}
		    }
		    jj += jb;
		}

		if (myrow == icurrow) {
		    ii += jb;
		}
		icurrow = inxtrow;
		icurrow = (icurrow + 1) % nprow;
		icurcol = (icurcol + 1) % npcol;

/* L350: */
	    }

	}

    }

    return HSCAL_SUCCESS;

/*     End of PSLASCL */

} /* pslascl_ */

#endif

