
#ifndef __HSCALAPACK_PSLASET_HSCALFUNC_HH
#define __HSCALAPACK_PSLASET_HSCALFUNC_HH

/*
*  Include files
*/
#include "../include/hscalapack.h"

int hscal_pslaset(
    char *uplo, hscalinteger *m, hscalinteger *n, hscalreal *alpha,
    hscalreal *beta, hscalinteger *ia, hscalinteger *ja, hscalinteger *desca, 
    int nprow, int npcol, int myrow, int mycol, double *tcomp
)
{
    /* System generated locals */
    hscalinteger i__1, i__2, i__3, i__4;

    /* Local variables */
    hscalinteger i__, j, in, jn, iaa, jaa, iblk, jblk, itmp, jtmp;

/*  -- ScaLAPACK auxiliary routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  PSLASET initializes an M-by-N distributed matrix sub( A ) denoting */
/*  A(IA:IA+M-1,JA:JA+N-1) to BETA on the diagonal and ALPHA on the */
/*  offdiagonals. */

/*  Notes */
/*  ===== */

/*  Each global data object is described by an associated description */
/*  vector.  This vector stores the information required to establish */
/*  the mapping between an object element and its corresponding process */
/*  and memory location. */

/*  Let A be a generic term for any 2D block cyclicly distributed array. */
/*  Such a global array has an associated description vector DESCA. */
/*  In the following comments, the character _ should be read as */
/*  "of the global array". */

/*  NOTATION        STORED IN      EXPLANATION */
/*  --------------- -------------- -------------------------------------- */
/*  DTYPE_A(global) DESCA( DTYPE_ )The descriptor type.  In this case, */
/*                                 DTYPE_A = 1. */
/*  CTXT_A (global) DESCA( CTXT_ ) The BLACS context handle, indicating */
/*                                 the BLACS process grid A is distribu- */
/*                                 ted over. The context itself is glo- */
/*                                 bal, but the handle (the hscalinteger */
/*                                 value) may vary. */
/*  M_A    (global) DESCA( M_ )    The number of rows in the global */
/*                                 array A. */
/*  N_A    (global) DESCA( N_ )    The number of columns in the global */
/*                                 array A. */
/*  MB_A   (global) DESCA( MB_ )   The blocking factor used to distribute */
/*                                 the rows of the array. */
/*  NB_A   (global) DESCA( NB_ )   The blocking factor used to distribute */
/*                                 the columns of the array. */
/*  RSRC_A (global) DESCA( RSRC_ ) The process row over which the first */
/*                                 row of the array A is distributed. */
/*  CSRC_A (global) DESCA( CSRC_ ) The process column over which the */
/*                                 first column of the array A is */
/*                                 distributed. */
/*  LLD_A  (local)  DESCA( LLD_ )  The leading dimension of the local */
/*                                 array.  LLD_A >= MAX(1,LOCr(M_A)). */

/*  Let K be the number of rows or columns of a distributed matrix, */
/*  and assume that its process grid has dimension p x q. */
/*  LOCr( K ) denotes the number of elements of K that a process */
/*  would receive if K were distributed over the p processes of its */
/*  process column. */
/*  Similarly, LOCc( K ) denotes the number of elements of K that a */
/*  process would receive if K were distributed over the q processes of */
/*  its process row. */
/*  The values of LOCr() and LOCc() may be determined via a call to the */
/*  ScaLAPACK tool function, NUMROC: */
/*          LOCr( M ) = NUMROC( M, MB_A, MYROW, RSRC_A, NPROW ), */
/*          LOCc( N ) = NUMROC( N, NB_A, MYCOL, CSRC_A, NPCOL ). */
/*  An upper bound for these quantities may be computed by: */
/*          LOCr( M ) <= ceil( ceil(M/MB_A)/NPROW )*MB_A */
/*          LOCc( N ) <= ceil( ceil(N/NB_A)/NPCOL )*NB_A */

/*  Arguments */
/*  ========= */

/*  UPLO    (global input) CHARACTER */
/*          Specifies the part of the distributed matrix sub( A ) to be */
/*          set: */
/*          = 'U':      Upper triangular part is set; the strictly lower */
/*                      triangular part of sub( A ) is not changed; */
/*          = 'L':      Lower triangular part is set; the strictly upper */
/*                      triangular part of sub( A ) is not changed; */
/*          Otherwise:  All of the matrix sub( A ) is set. */

/*  M       (global input) INTEGER */
/*          The number of rows to be operated on i.e the number of rows */
/*          of the distributed submatrix sub( A ). M >= 0. */

/*  N       (global input) INTEGER */
/*          The number of columns to be operated on i.e the number of */
/*          columns of the distributed submatrix sub( A ). N >= 0. */

/*  ALPHA   (global input) REAL */
/*          The constant to which the offdiagonal elements are to be */
/*          set. */

/*  BETA    (global input) REAL */
/*          The constant to which the diagonal elements are to be set. */

/*  A       (local output) REAL pointer into the local memory */
/*          to an array of dimension (LLD_A,LOCc(JA+N-1)).  This array */
/*          contains the local pieces of the distributed matrix sub( A ) */
/*          to be set.  On exit, the leading M-by-N submatrix sub( A ) */
/*          is set as follows: */

/*          if UPLO = 'U', A(IA+i-1,JA+j-1) = ALPHA, 1<=i<=j-1, 1<=j<=N, */
/*          if UPLO = 'L', A(IA+i-1,JA+j-1) = ALPHA, j+1<=i<=M, 1<=j<=N, */
/*          otherwise,     A(IA+i-1,JA+j-1) = ALPHA, 1<=i<=M, 1<=j<=N, */
/*                                                   IA+i.NE.JA+j, */
/*          and, for all UPLO, A(IA+i-1,JA+i-1) = BETA, 1<=i<=min(M,N). */

/*  IA      (global input) INTEGER */
/*          The row index in the global array A indicating the first */
/*          row of sub( A ). */

/*  JA      (global input) INTEGER */
/*          The column index in the global array A indicating the */
/*          first column of sub( A ). */

/*  DESCA   (global and local input) INTEGER array of dimension DLEN_. */
/*          The array descriptor for the distributed matrix A. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. External Functions .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

    /* Parameter adjustments */
    --desca;

    /* Function Body */
    if (*m == 0 || *n == 0) {
	return HSCAL_SUCCESS;
    }

    if (*m <= desca[5] - (*ia - 1) % desca[5] || *n <= desca[6] - (*ja - 1) % 
	    desca[6]) {
	hscal_pslase2(uplo, m, n, alpha, beta, ia, ja, &desca[1], 
                      nprow, npcol, myrow, mycol, tcomp
        );
    } else {

	if (hscal_lsame(uplo, "U")) {
/* Computing MIN */
	    i__1 = hscal_iceil(ia, &desca[5]) * desca[5], i__2 = *ia + *m - 1;
	    in = min(i__1,i__2);
	    i__1 = in - *ia + 1;
	    hscal_pslase2(uplo, &i__1, n, alpha, beta, ia, ja, &desca[1],
                      nprow, npcol, myrow, mycol, tcomp
	    );
	    i__1 = *ia + *m - 1;
	    i__2 = desca[5];
	    for (i__ = in + 1; i__2 < 0 ? i__ >= i__1 : i__ <= i__1; i__ += 
		    i__2) {
		itmp = i__ - *ia;
/* Computing MIN */
		i__3 = desca[5], i__4 = *m - itmp;
		iblk = min(i__3,i__4);
		jaa = *ja + itmp;
		i__3 = *n - itmp;
		hscal_pslase2(uplo, &iblk, &i__3, alpha, beta, &i__, &jaa, &
			desca[1], 
                      nprow, npcol, myrow, mycol, tcomp
                );
/* L10: */
	    }
	} else if (hscal_lsame(uplo, "L")) {
/* Computing MIN */
	    i__2 = hscal_iceil(ja, &desca[6]) * desca[6], i__1 = *ja + *n - 1;
	    jn = min(i__2,i__1);
	    i__2 = jn - *ja + 1;
	    hscal_pslase2(uplo, m, &i__2, alpha, beta, ia, ja, &desca[1],
                      nprow, npcol, myrow, mycol, tcomp
	    );
	    i__2 = *ja + *n - 1;
	    i__1 = desca[6];
	    for (j = jn + 1; i__1 < 0 ? j >= i__2 : j <= i__2; j += i__1) {
		jtmp = j - *ja;
/* Computing MIN */
		i__3 = desca[6], i__4 = *n - jtmp;
		jblk = min(i__3,i__4);
		iaa = *ia + jtmp;
		i__3 = *m - jtmp;
		hscal_pslase2(uplo, &i__3, &jblk, alpha, beta, &iaa, &j, &
			desca[1], 
                      nprow, npcol, myrow, mycol, tcomp
                );
/* L20: */
	    }
	} else {
	    if (*m <= *n) {
/* Computing MIN */
		i__1 = hscal_iceil(ia, &desca[5]) * desca[5], i__2 = *ia + *m - 1;
		in = min(i__1,i__2);
		i__1 = in - *ia + 1;
		hscal_pslase2(uplo, &i__1, n, alpha, beta, ia, ja, &desca[1], 
                      nprow, npcol, myrow, mycol, tcomp
                );
		i__1 = *ia + *m - 1;
		i__2 = desca[5];
		for (i__ = in + 1; i__2 < 0 ? i__ >= i__1 : i__ <= i__1; i__ 
			+= i__2) {
		    itmp = i__ - *ia;
/* Computing MIN */
		    i__3 = desca[5], i__4 = *m - itmp;
		    iblk = min(i__3,i__4);
		    i__3 = i__ - *ia;
		    hscal_pslase2(uplo, &iblk, &i__3, alpha, alpha, &i__, 
			    ja, &desca[1], 
                      nprow, npcol, myrow, mycol, tcomp
                    );
		    i__3 = *n - i__ + *ia;
		    i__4 = *ja + i__ - *ia;
		    hscal_pslase2(uplo, &iblk, &i__3, alpha, beta, &i__, &
			    i__4, &desca[1],
                      nprow, npcol, myrow, mycol, tcomp
                    );
/* L30: */
		}
	    } else {
/* Computing MIN */
		i__2 = hscal_iceil(ja, &desca[6]) * desca[6], i__1 = *ja + *n - 1;
		jn = min(i__2,i__1);
		i__2 = jn - *ja + 1;
		hscal_pslase2(uplo, m, &i__2, alpha, beta, ia, ja, &desca[1], 
                      nprow, npcol, myrow, mycol, tcomp
                );
		i__2 = *ja + *n - 1;
		i__1 = desca[6];
		for (j = jn + 1; i__1 < 0 ? j >= i__2 : j <= i__2; j += i__1) 
			{
		    jtmp = j - *ja;
/* Computing MIN */
		    i__3 = desca[6], i__4 = *n - jtmp;
		    jblk = min(i__3,i__4);
		    i__3 = j - *ja;
		    hscal_pslase2(uplo, &i__3, &jblk, alpha, alpha, ia, &j, 
			    &desca[1], 
                      nprow, npcol, myrow, mycol, tcomp
                    );
		    i__3 = *m - j + *ja;
		    i__4 = *ia + j - *ja;
		    hscal_pslase2(uplo, &i__3, &jblk, alpha, beta, &i__4, &
			    j, &desca[1], 
                      nprow, npcol, myrow, mycol, tcomp
                    );
/* L40: */
		}
	    }
	}

    }

    return HSCAL_SUCCESS;

/*     End of PSLASET */

} /* pslaset_ */

#endif

