
#ifndef __HSCALAPACK_PZLANGE_HSCALFUNC_HH
#define __HSCALAPACK_PZLANGE_HSCALFUNC_HH

/*
*  Include files
*/
#include "../include/hscalapack.h"

int hscal_pzlange(
    char *norm, hscalinteger *m, hscalinteger *n,
    hscalinteger *ia, hscalinteger *ja, hscalinteger *desca,
    int nprow, int npcol, int myrow, int mycol, double *tcomp,
    int *tcomm
)
{
    hscalinteger c__1 = 1;
    hscalinteger c_n1 = -1;
    hscalinteger c__0 = 0;
    hscalinteger c__2 = 2;

    /* System generated locals */
    hscalinteger i__1, i__2, i__3;
    hscaldoublereal ret_val, d__1, d__2;

    /* Local variables */
    hscalinteger i__, j, ii, jj, mp, nq;
    hscalinteger lda;
    hscalinteger ioffa, icoff, iacol;
    hscalinteger iroff;
    hscalinteger iarow, ictxt;

    HSCALBLACSCONTEXT   * blacsctxt;

/*  -- ScaLAPACK auxiliary routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  PZLANGE returns the value of the one norm, or the Frobenius norm, */
/*  or the infinity norm, or the element of largest absolute value of a */
/*  distributed matrix sub( A ) = A(IA:IA+M-1, JA:JA+N-1). */

/*  PZLANGE returns the value */

/*     ( max(abs(A(i,j))),  NORM = 'M' or 'm' with IA <= i <= IA+M-1, */
/*     (                                      and  JA <= j <= JA+N-1, */
/*     ( */
/*     ( norm1( sub( A ) ), NORM = '1', 'O' or 'o' */
/*     ( */
/*     ( normI( sub( A ) ), NORM = 'I' or 'i' */
/*     ( */
/*     ( normF( sub( A ) ), NORM = 'F', 'f', 'E' or 'e' */

/*  where norm1 denotes the  one norm of a matrix (maximum column sum), */
/*  normI denotes the  infinity norm  of a matrix  (maximum row sum) and */
/*  normF denotes the  Frobenius norm of a matrix (square root of sum of */
/*  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm. */

/*  Notes */
/*  ===== */

/*  Each global data object is described by an associated description */
/*  vector.  This vector stores the information required to establish */
/*  the mapping between an object element and its corresponding process */
/*  and memory location. */

/*  Let A be a generic term for any 2D block cyclicly distributed array. */
/*  Such a global array has an associated description vector DESCA. */
/*  In the following comments, the character _ should be read as */
/*  "of the global array". */

/*  NOTATION        STORED IN      EXPLANATION */
/*  --------------- -------------- -------------------------------------- */
/*  DTYPE_A(global) DESCA( DTYPE_ )The descriptor type.  In this case, */
/*                                 DTYPE_A = 1. */
/*  CTXT_A (global) DESCA( CTXT_ ) The BLACS context handle, indicating */
/*                                 the BLACS process grid A is distribu- */
/*                                 ted over. The context itself is glo- */
/*                                 bal, but the handle (the hscalinteger */
/*                                 value) may vary. */
/*  M_A    (global) DESCA( M_ )    The number of rows in the global */
/*                                 array A. */
/*  N_A    (global) DESCA( N_ )    The number of columns in the global */
/*                                 array A. */
/*  MB_A   (global) DESCA( MB_ )   The blocking factor used to distribute */
/*                                 the rows of the array. */
/*  NB_A   (global) DESCA( NB_ )   The blocking factor used to distribute */
/*                                 the columns of the array. */
/*  RSRC_A (global) DESCA( RSRC_ ) The process row over which the first */
/*                                 row of the array A is distributed. */
/*  CSRC_A (global) DESCA( CSRC_ ) The process column over which the */
/*                                 first column of the array A is */
/*                                 distributed. */
/*  LLD_A  (local)  DESCA( LLD_ )  The leading dimension of the local */
/*                                 array.  LLD_A >= MAX(1,LOCr(M_A)). */

/*  Let K be the number of rows or columns of a distributed matrix, */
/*  and assume that its process grid has dimension p x q. */
/*  LOCr( K ) denotes the number of elements of K that a process */
/*  would receive if K were distributed over the p processes of its */
/*  process column. */
/*  Similarly, LOCc( K ) denotes the number of elements of K that a */
/*  process would receive if K were distributed over the q processes of */
/*  its process row. */
/*  The values of LOCr() and LOCc() may be determined via a call to the */
/*  ScaLAPACK tool function, NUMROC: */
/*          LOCr( M ) = NUMROC( M, MB_A, MYROW, RSRC_A, NPROW ), */
/*          LOCc( N ) = NUMROC( N, NB_A, MYCOL, CSRC_A, NPCOL ). */
/*  An upper bound for these quantities may be computed by: */
/*          LOCr( M ) <= ceil( ceil(M/MB_A)/NPROW )*MB_A */
/*          LOCc( N ) <= ceil( ceil(N/NB_A)/NPCOL )*NB_A */

/*  Arguments */
/*  ========= */

/*  NORM    (global input) CHARACTER */
/*          Specifies the value to be returned in PZLANGE as described */
/*          above. */

/*  M       (global input) INTEGER */
/*          The number of rows to be operated on i.e the number of rows */
/*          of the distributed submatrix sub( A ). When M = 0, PZLANGE */
/*          is set to zero. M >= 0. */

/*  N       (global input) INTEGER */
/*          The number of columns to be operated on i.e the number of */
/*          columns of the distributed submatrix sub( A ). When N = 0, */
/*          PZLANGE is set to zero. N >= 0. */

/*  A       (local input) COMPLEX*16 pointer into the local memory */
/*          to an array of dimension (LLD_A, LOCc(JA+N-1)) containing the */
/*          local pieces of the distributed matrix sub( A ). */

/*  IA      (global input) INTEGER */
/*          The row index in the global array A indicating the first */
/*          row of sub( A ). */

/*  JA      (global input) INTEGER */
/*          The column index in the global array A indicating the */
/*          first column of sub( A ). */

/*  DESCA   (global and local input) INTEGER array of dimension DLEN_. */
/*          The array descriptor for the distributed matrix A. */

/*  WORK    (local workspace) DOUBLE PRECISION array dimension (LWORK) */
/*          LWORK >=   0 if NORM = 'M' or 'm' (not referenced), */
/*                   Nq0 if NORM = '1', 'O' or 'o', */
/*                   Mp0 if NORM = 'I' or 'i', */
/*                     0 if NORM = 'F', 'f', 'E' or 'e' (not referenced), */
/*          where */

/*          IROFFA = MOD( IA-1, MB_A ), ICOFFA = MOD( JA-1, NB_A ), */
/*          IAROW = INDXG2P( IA, MB_A, MYROW, RSRC_A, NPROW ), */
/*          IACOL = INDXG2P( JA, NB_A, MYCOL, CSRC_A, NPCOL ), */
/*          Mp0 = NUMROC( M+IROFFA, MB_A, MYROW, IAROW, NPROW ), */
/*          Nq0 = NUMROC( N+ICOFFA, NB_A, MYCOL, IACOL, NPCOL ), */

/*          INDXG2P and NUMROC are ScaLAPACK tool functions; MYROW, */
/*          MYCOL, NPROW and NPCOL can be determined by calling the */
/*          subroutine BLACS_GRIDINFO. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. Local Arrays .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. External Functions .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

/*     Get grid parameters. */

    /* Parameter adjustments */
    --desca;

    /* Function Body */

    infog2l_(ia, ja, &desca[1], &nprow, &npcol, &myrow, &mycol, &ii, &jj, &
	    iarow, &iacol);
    iroff = (*ia - 1) % desca[5];
    icoff = (*ja - 1) % desca[6];
    i__1 = *m + iroff;
    mp = numroc_(&i__1, &desca[5], &myrow, &iarow, &nprow);
    i__1 = *n + icoff;
    nq = numroc_(&i__1, &desca[6], &mycol, &iacol, &npcol);
    if (myrow == iarow) {
	mp -= iroff;
    }
    if (mycol == iacol) {
	nq -= icoff;
    }
    lda = desca[9];

    Cblacs_gridinit_nocomm(&blacsctxt, "r", nprow, npcol);

    if (min(*m,*n) == 0) {

	;

    } else if (hscal_lsame(norm, "M")) {

/*        Find max(abs(A(i,j))). */

	if (nq > 0 && mp > 0) {
            if (tcomp != NULL)
            {
               TCOMP((myrow), (mycol), (nprow), (npcol)) += nq*mp*3;
            }
	}
	hscal_Cdgamx2d(
             blacsctxt, "All", " ", c__1, c__1, c__1, &i__, &j,
             c_n1, c__0, c__0, 
             nprow, npcol, myrow, mycol, tcomp, tcomm
        );
    } else if (hscal_lsame(norm, "O") || *(unsigned char *)norm == '1') {

/*        Find norm1( sub( A ) ). */

	if (nq > 0) {
	    i__1 = jj + nq - 1;
	    for (j = jj; j <= i__1; ++j) {
		if (mp > 0) {
		    i__2 = mp + ii - 1;
                    i__ = ii;
                    if (tcomp != NULL)
                    {
                       TCOMP((myrow), (mycol), (nprow), (npcol)) += (i__2 - ii + 1)*2;
                    }
		}
	    }
	}

/*        Find sum of global matrix columns and store on row 0 of */
/*        process grid */

	hscal_Cdgsum2d(
             blacsctxt, "Columnwise", " ", c__1, nq, c__1,
	     c__0, mycol,
             nprow, npcol, myrow, mycol, tcomp, tcomm
        );

/*        Find maximum sum of columns for 1-norm */

	if (myrow == 0) {
	    if (nq > 0) {
                ;
	    } else {
                ;
	    }
	    hscal_Cdgamx2d(
                 blacsctxt, "Rowwise", " ", c__1, c__1, c__1,
	         &i__, &j, c_n1, c__0, c__0,
                 nprow, npcol, myrow, mycol, tcomp, tcomm
            );
	}

    } else if (hscal_lsame(norm, "I")) {

/*        Find normI( sub( A ) ). */

	if (mp > 0) {
	    ioffa = ii + (jj - 1) * lda;
	    i__1 = ii + mp - 1;
	    for (i__ = ii; i__ <= i__1; ++i__) {
		if (nq > 0) {
		    i__2 = ioffa + nq * lda - 1;
		    i__3 = lda;
                    j = ioffa;
                    if (tcomp != NULL)
                    {
                       int num = (i__2 - j + 1);
                       int den = i__3;
                       int ni = hscal_iceil(&num, &den);

                       if (ni < 0)
                       {
                          ni *= -1;
                       }

                       TCOMP((myrow), (mycol), (nprow), (npcol)) += 2*ni;
                    }
		}
		++ioffa;
/* L60: */
	    }
	}

/*        Find sum of global matrix rows and store on column 0 of */
/*        process grid */

	i__1 = max(1,mp);
	hscal_Cdgsum2d(
             blacsctxt, "Rowwise", " ", mp, c__1, i__1, myrow, 
             c__0,
             nprow, npcol, myrow, mycol, tcomp, tcomm
        );

/*        Find maximum sum of rows for supnorm */

	if (mycol == 0) {
	    if (mp > 0) {
                ;
	    } else {
		;
	    }
	    hscal_Cdgamx2d(
                 blacsctxt, "Columnwise", " ", c__1, c__1, c__1,
	         &i__, &j, c_n1, c__0, c__0,
                 nprow, npcol, myrow, mycol, tcomp, tcomm
            );
	}

    } else if (hscal_lsame(norm, "F") || hscal_lsame(norm, "E")) {

/*        Find normF( sub( A ) ). */

	ioffa = ii + (jj - 1) * lda;
	if (nq > 0) {
	    i__1 = ioffa + nq * lda - 1;
	    i__3 = lda;
            j = ioffa;
            if (tcomp != NULL)
            {
               double t;
               int num = (i__1 - j + 1);
               int den = i__3;
               int ni = hscal_iceil(&num, &den);

               hscal_zlassq(
                    &mp, &c__1, &t
               );

               if (ni < 0)
               {
                  ni *= -1;
               }

               TCOMP((myrow), (mycol), (nprow), (npcol)) += t*ni;
            }
	}

/*        Perform the global scaled sum */

	hscal_pdtreecomb(
             &ictxt, "All", &c__2, &c__0, &c__0,
	     (HSCAL_S_fp)hscal_dcombssq, 
             nprow, npcol, myrow, mycol, tcomp, tcomm
        );

    }

    if (myrow == 0 && mycol == 0) {
	hscal_Cdgebs2d(
             blacsctxt, "All", " ", c__1, c__1, c__1,
             nprow, npcol, myrow, mycol, tcomp, tcomm
        );
    } else {
	hscal_Cdgebr2d(
             blacsctxt, "All", " ", c__1, c__1, c__1, c__0,
	     c__0,
             nprow, npcol, myrow, mycol, tcomp, tcomm
        );
    }

    Cblacs_gridexit_nocomm(blacsctxt);

    return HSCAL_SUCCESS;

/*     End of PZLANGE */

} /* pzlange_ */

#endif

