
#ifndef __HSCALAPACK_TOOLS_CMATADD_HH
#define __HSCALAPACK_TOOLS_CMATADD_HH

#include "../include/hscalapack.h"

int hscal_cmatadd(
    int *m, 
    int *n, 
    char *calpha, 
    hscalinteger *lda, 
    char *cbeta, 
    hscalinteger *ldc,
    double *tcomp
)
{
    /* System generated locals */
    hscalinteger a_dim1, a_offset, c_dim1, c_offset, i__1, i__2, i__3, i__4, i__5;

    /* Local variables */
    hscalinteger i__, j;

    hscaldoublereal tn, tm;

    hscalcomplex *alpha = (hscalcomplex*)calpha;
    hscalcomplex *beta  = (hscalcomplex*)cbeta;

    tm = (double)(*m);
    tn = (double)(*n);
    *tcomp = 0.;

    /* Function Body */
    if (*m == 0 || *n == 0 || alpha->r == 0.f && alpha->i == 0.f && (beta->r 
	    == 1.f && beta->i == 0.f)) {
	return HSCAL_SUCCESS;
    }

    if (*n == 1) {
	if (beta->r == 0.f && beta->i == 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += tm*3;
	    } else {
                *tcomp += tm*10;
	    }
	} else {
	    if (alpha->r == 1.f && alpha->i == 0.f) {
		if (beta->r == 1.f && beta->i == 0.f) {
                    *tcomp += tm*7;
		} else {
                    *tcomp += tm*13;
		}
	    } else if (beta->r == 1.f && beta->i == 0.f) {
                *tcomp += tm*13;
	    } else {
                *tcomp += tm*19;
	    }
	}
    } else {
	if (beta->r == 0.f && beta->i == 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += tn*tm*4;
	    } else {
                *tcomp += tn*tm*12;
	    }
	} else {
	    if (alpha->r == 1.f && alpha->i == 0.f) {
		if (beta->r == 1.f && beta->i == 0.f) {
                    *tcomp += tn*tm*10;
		} else {
                    *tcomp += tn*tm*16;
		}
	    } else if (beta->r == 1.f && beta->i == 0.f) {
                *tcomp += tn*tm*16;
	    } else {
                *tcomp += tn*tm*22;
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif

