
#ifndef __HSCALAPACK_TOOLS_DMATADD_HH
#define __HSCALAPACK_TOOLS_DMATADD_HH

#include "../include/hscalapack.h"

int hscal_dmatadd(
    int *m,
    int *n,
    char *calpha,
    hscalinteger *lda,
    char *cbeta,
    hscalinteger *ldc,
    double *tcomp
)
{
    /* System generated locals */
    hscalinteger a_dim1, a_offset, c_dim1, c_offset, i__1, i__2;

    /* Local variables */
    hscalinteger i__, j;

    hscaldoublereal tn, tm;

    hscaldoublereal *alpha = (hscaldoublereal*)calpha;
    hscaldoublereal *beta  = (hscaldoublereal*)cbeta;

    tm = (double)(*m);
    tn = (double)(*n);
    *tcomp = 0.;

    if (*m == 0 || *n == 0 || *alpha == 0. && *beta == 1.) {
	return HSCAL_SUCCESS;
    }

    if (*n == 1) {
	if (*beta == 0.) {
	    if (*alpha == 0.) {
                *tcomp += tm;
	    } else {
                *tcomp += tm*3;
	    }
	} else {
	    if (*alpha == 1.) {
		if (*beta == 1.) {
                    *tcomp += tm*4;
		} else {
                    *tcomp += tm*5;
		}
	    } else if (*beta == 1.) {
                *tcomp += tm*5;
	    } else {
                *tcomp += tm*6;
	    }
	}
    } else {
	if (*beta == 0.) {
	    if (*alpha == 0.) {
                *tcomp += tm*tn*2;
	    } else {
                *tcomp += tm*tn*5;
	    }
	} else {
	    if (*alpha == 1.) {
		if (*beta == 1.) {
                    *tcomp += tm*tn*7;
		} else {
                    *tcomp += tm*tn*8;
		}
	    } else if (*beta == 1.) {
                *tcomp += tm*tn*6;
	    } else {
                *tcomp += tm*tn*9;
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif

