
/*
* ScaLAPACK TOOLS
*
* Ravi Reddy
* Version 1.0
* School of Computer Science and Informatics,
* UCD,
* Dublin,
* November 18, 2007
*/

#ifndef __HSCAL_TOOLS_ILACPY_HH
#define __HSCAL_TOOLS_ILACPY_HH

/*
*  Include files
*/
#include "../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_ilacpy(
         char *uplo, 
         hscalinteger *m, 
         hscalinteger *n, 
	 hscalinteger *lda, 
         hscalinteger *ldb, 
         double *tcomp
)
{
    hscalinteger i__1, i__2, j;
    double tm, tn;

    *tcomp = 0.;

    tm = (double)(*m);
    tn = (double)(*n);

    if (hscal_lsame(uplo, "U")) {
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    i__2 = min(j,*m);
            *tcomp += i__2 * 5;
	}
    } else if (hscal_lsame(uplo, "L")) {
        *tcomp += 5*tn*(((tm+1)*tm)/2);        
    } else {
        *tcomp += 5*tn*tm;
    }

    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

#endif

