
/*
* ScaLAPACK TOOLS
*
* Ravi Reddy
* Version 1.0
* School of Computer Science and Informatics,
* UCD,
* Dublin,
* November 18, 2007
*/

/*
*  Include files
*/
#include "../include/hscalapack.h"

/*------------------------------------------------------------------*/

hscalinteger hscal_ilcm(hscalinteger *m, hscalinteger *n)
{
    /* System generated locals */
    hscalinteger ret_val;

    /* Local variables */
    static hscalinteger ia, iq, ir;


/*  -- ScaLAPACK tools routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  ILCM computes and returns the Least Common Multiple (LCM) of two */
/*  positive hscalintegers M and N. In fact the routine computes the greatest */
/*  common divisor (GCD) and use the fact that M*N = GCD*LCM. */

/*  Arguments */
/*  ========= */

/*  M       (input) INTEGER */
/*          On entry, M >=0. Unchanged on exit. */

/*  N       (input) INTEGER */
/*          On entry, N >=0. Unchanged on exit. */

/*  ===================================================================== */

/*     .. Local Scalars .. */
/*     .. */
/*     .. Executable Statements .. */

    if (*m >= *n) {
	ia = *m;
	ret_val = *n;
    } else {
	ia = *n;
	ret_val = *m;
    }

L10:
    iq = ia / ret_val;
    ir = ia - iq * ret_val;
    if (ir == 0) {
	ret_val = *m * *n / ret_val;
	return ret_val;
    }
    ia = ret_val;
    ret_val = ir;
    goto L10;
}

/*------------------------------------------------------------------*/


