
/*
* ScaLAPACK TOOLS
*
* Ravi Reddy
* Version 1.0
* School of Computer Science and Informatics,
* UCD,
* Dublin,
* November 18, 2007
*/

/*
*  Include files
*/
#include "../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_indicative_complex(
    hscalcomplex *hc, 
    hscalinteger *ihc
)
{
   if (hc->r == 0.f)
   {
      ihc[REAL_PART] = 0;
   }
   else if (hc->r == 1.f)
   {
      ihc[REAL_PART] = 1;
   }
   else if (hc->r == -0.f)
   {
      ihc[REAL_PART] = 0;
   }
   else if (hc->r == -1.f)
   {
      ihc[REAL_PART] = 1;
   }
   else
   {
      ihc[REAL_PART] = 2;
   }

   if (hc->i == 0.f)
   {
      ihc[IMAG_PART] = 0;
   }
   else if (hc->i == 1.f)
   {
      ihc[IMAG_PART] = 1;
   }
   else if (hc->i == -0.f)
   {
      ihc[IMAG_PART] = 0;
   }
   else if (hc->i == -1.f)
   {
      ihc[IMAG_PART] = 1;
   }
   else
   {
      ihc[IMAG_PART] = 2;
   }

   return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_indicative_doublecomplex(
    hscaldoublecomplex *hdc,
    hscalinteger *ihdc
)
{
   if (hdc->r == 0.)
   {
      ihdc[REAL_PART] = 0;
   }
   else if (hdc->r == 1.)
   {
      ihdc[REAL_PART] = 1;
   }
   else if (hdc->r == -0.)
   {
      ihdc[REAL_PART] = 0;
   }
   else if (hdc->r == -1.)
   {
      ihdc[REAL_PART] = 1;
   }
   else
   {
      ihdc[REAL_PART] = 2;
   }

   if (hdc->i == 0.)
   {
      ihdc[IMAG_PART] = 0;
   }
   else if (hdc->i == 1.)
   {
      ihdc[IMAG_PART] = 1;
   }
   else if (hdc->i == -0.)
   {
      ihdc[IMAG_PART] = 0;
   }
   else if (hdc->i == -1.)
   {
      ihdc[IMAG_PART] = 1;
   }
   else
   {
      ihdc[IMAG_PART] = 2;
   }

   return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

