
/*
* ScaLAPACK TOOLS
*
* Ravi Reddy
* Version 1.0
* School of Computer Science and Informatics, 
* UCD, 
* Dublin,
* November 18, 2007
*/

/*
*  Include files
*/
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../include/hscalapack.h"

#define  HSCAL_MAX_CHK_CALLS  12

static hscalinteger *hscal_iwork00_1[HSCAL_MAX_CHK_CALLS], 
                    *hscal_iwork00_2[HSCAL_MAX_CHK_CALLS];
static hscalinteger  hscal_iwork00len_1, 
                     hscal_iwork00len_2, 
                     hscal_tcallnum_1, 
                     hscal_tcallnum_2, 
                     hscal_curcallnum_1, 
                     hscal_curcallnum_2;

/*------------------------------------------------------------------*/

int hscal_pchk1mat(
         hscalinteger *ma, 
         hscalinteger *mapos0, 
         hscalinteger *na, 
	 hscalinteger *napos0, 
         hscalinteger *ia, 
         hscalinteger *ja, 
         hscalinteger *desca, 
         hscalinteger *descapos0, 
         hscalinteger *nextra, 
         hscalinteger *ex, 
         hscalinteger *expos, 
         hscalinteger *info,
         hscalinteger *myrow,
         hscalinteger *mycol,
         hscalinteger *nprow,
         hscalinteger *npcol
)
{
    hscalinteger c__25 = 25;
    hscalinteger c__35 = 35;
    hscalinteger c__50 = 50;
    hscalinteger c__1 = 1;
    hscalinteger c__0 = 0;
    hscalinteger c_n1 = -1;

    /* System generated locals */
    hscalinteger i__1;

    /* Local variables */
    hscalinteger k;
    hscalinteger *iwork;
    hscalinteger descpos;


/*  -- ScaLAPACK tools routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  PCHK1MAT checks that the values associated with one distributed */
/*  matrix are consistant across the entire process grid. */

/*  Notes */
/*  ===== */

/*  This routine checks that all values are the same across the grid. */
/*  It does no local checking; it is therefore legal to abuse the */
/*  definitions of the non-descriptor arguments, i.e., if the routine */
/*  you are checking does not possess a MA value, you may pass some */
/*  other hscalinteger that must be global into this argument instead. */

/*  Arguments */
/*  ========= */

/*  MA      (global input) INTEGER */
/*          The global number of matrix rows of A being operated on. */

/*  MAPOS0  (global input) INTEGER */
/*          Where in the calling routine's parameter list MA appears. */

/*  NA      (global input) INTEGER */
/*          The global number of matrix columns of A being operated on. */

/*  NAPOS0  (global input) INTEGER */
/*          Where in the calling routine's parameter list NA appears. */

/*  IA      (global input) INTEGER */
/*          The row index in the global array A indicating the first */
/*          row of sub( A ). */

/*  JA      (global input) INTEGER */
/*          The column index in the global array A indicating the */
/*          first column of sub( A ). */

/*  DESCA   (global and local input) INTEGER array of dimension DLEN_. */
/*          The array descriptor for the distributed matrix A. */

/*  DESCAPOS0 (global input) INTEGER */
/*          Where in the calling routine's parameter list DESCA */
/*          appears.  Note that we assume IA and JA are respectively 2 */
/*          and 1 entries behind DESCA. */

/*  NEXTRA  (global input) INTEGER */
/*          The number of extra parameters (i.e., besides the ones */
/*          above) to check.  NEXTRA <= LDW - 11. */

/*  EX      (local input) INTEGER array of dimension (NEXTRA) */
/*          The values of these extra parameters */

/*  EXPOS   (local input) INTEGER array of dimension (NEXTRA) */
/*          The parameter list positions of these extra values. */

/*  INFO    (local input/global output) INTEGER */
/*          = 0:  successful exit */
/*          < 0:  If the i-th argument is an array and the j-entry had */
/*                an illegal value, then INFO = -(i*100+j), if the i-th */
/*                argument is a scalar and had an illegal value, then */
/*                INFO = -i. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. Local Arrays .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. Executable Statements .. */

/*     Want to find errors with MIN( ), so if no error, set it to a big */
/*     number. If there already is an error, multiply by the the */
/*     descriptor multiplier. */

    /*
    * Do not worry about parameter checks at the moment
    */
    return HSCAL_SUCCESS;

    /* Parameter adjustments */
    --desca;
    --expos;
    --ex;

    /* Function Body */
    if (*info >= 0) {
	*info = 10000;
    } else if (*info < -100) {
	*info = -(*info);
    } else {
	*info = -(*info) * 100;
    }

/*     Pack values and their positions in the parameter list, factoring */
/*     in the descriptor multiplier */

    if ((*myrow == 0) && (*mycol == 0))
    {
       hscal_iwork00len_1 = c__50;
       hscal_iwork00_1[hscal_tcallnum_1] = (hscalinteger*)calloc(
                                              hscal_iwork00len_1,
                                              sizeof(hscalinteger)
       );

       if (hscal_iwork00_1[hscal_tcallnum_1] == NULL)
       { 
          return HSCAL_ERR_LOW_MEMORY;
       }

       iwork = hscal_iwork00_1[hscal_tcallnum_1];
    }
    else
    {
       iwork = (hscalinteger*)calloc(
                              c__50,
                              sizeof(hscalinteger)
       );

       if (iwork == NULL)
       { 
          return HSCAL_ERR_LOW_MEMORY;
       }
    }

    iwork[0] = *ma;
    iwork[25] = *mapos0 * 100;
    iwork[1] = *na;
    iwork[26] = *napos0 * 100;
    iwork[2] = *ia;
    iwork[27] = (*descapos0 - 2) * 100;
    iwork[3] = *ja;
    iwork[28] = (*descapos0 - 1) * 100;
    descpos = *descapos0 * 100;

    iwork[4] = desca[1];
    iwork[29] = descpos + 1;
    iwork[5] = desca[3];
    iwork[30] = descpos + 3;
    iwork[6] = desca[4];
    iwork[31] = descpos + 4;
    iwork[7] = desca[5];
    iwork[32] = descpos + 5;
    iwork[8] = desca[6];
    iwork[33] = descpos + 6;
    iwork[9] = desca[7];
    iwork[34] = descpos + 7;
    iwork[10] = desca[8];
    iwork[35] = descpos + 8;

    if (*nextra > 0) {
	i__1 = *nextra;
	for (k = 1; k <= i__1; ++k) {
	    iwork[k + 10] = ex[k];
	    iwork[k + 35] = expos[k];
/* L10: */
	}
    }
    k = *nextra + 11;

/*     Get the smallest error detected anywhere (BIGNUM if no error) */

    if ((*myrow == 0)
        && (*mycol == 0
       )
    )
    {
       hscal_tcallnum_1++;
    }
    else
    {
       hscalinteger *iwork00 = hscal_iwork00_1[hscal_curcallnum_1];

       hscal_globchk(&desca[2], &k, iwork, &c__25, iwork00, info,
                     myrow, mycol, nprow, npcol
       );

       free(iwork);

       hscal_curcallnum_1++;

       if (hscal_curcallnum_1 == hscal_tcallnum_1)
       {
          if ((*myrow == (*nprow - 1)) && (*mycol == (*npcol - 1)))
              ;
          else
          {
             hscal_curcallnum_1 = 0;
          }
       }
    }

/*     Prepare output: set info = 0 if no error, and divide by DESCMULT if */
/*     error is not in a descriptor entry */

    if (*info == 10000) {
	*info = 0;
    } else if (*info % 100 == 0) {
	*info = -(*info) / 100;
    } else {
	*info = -(*info);
    }
 
    /*
    * Test for *nprow-1 and *npcol-1 
    * suggests it is a last iteration.
    * If *info is not 0, we do not come back here
    * So in both the cases, delete the pointer
    */
    if (((*myrow == (*nprow - 1))
        && (*mycol == (*npcol - 1))
        ) || (*info != 0)
    )
    {
       int fcallnum_1 = hscal_curcallnum_1 - 1;
       //free(hscal_iwork00_1[fcallnum_1]);
    }

    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_pchk2mat(
         hscalinteger *ma, 
         hscalinteger *mapos0, 
         hscalinteger *na, 
	 hscalinteger *napos0, 
         hscalinteger *ia, 
         hscalinteger *ja, 
         hscalinteger *desca, 
         hscalinteger *descapos0, 
         hscalinteger *mb, 
         hscalinteger *mbpos0, 
         hscalinteger *nb, 
         hscalinteger *nbpos0,
	 hscalinteger *ib, 
         hscalinteger *jb, 
         hscalinteger *descb, 
         hscalinteger *descbpos0, 
	 hscalinteger *nextra, 
         hscalinteger *ex, 
         hscalinteger *expos, 
         hscalinteger *info,
         hscalinteger *myrow,
         hscalinteger *mycol,
         hscalinteger *nprow,
         hscalinteger *npcol
)
{
    hscalinteger c__25 = 25;
    hscalinteger c__35 = 35;
    hscalinteger c__70 = 70;
    hscalinteger c__1 = 1;
    hscalinteger c__0 = 0;
    hscalinteger c_n1 = -1;

    /* System generated locals */
    hscalinteger i__1;

    /* Local variables */
    hscalinteger k;
    hscalinteger *iwork;
    hscalinteger descpos;


/*  -- ScaLAPACK tools routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  PCHK2MAT checks that the values associated with two distributed */
/*  matrices are consistant across the entire process grid. */

/*  Notes */
/*  ===== */

/*  This routine checks that all values are the same across the grid. */
/*  It does no local checking; it is therefore legal to abuse the */
/*  definitions of the non-descriptor arguments, i.e., if the routine */
/*  you are checking does not possess a MA value, you may pass some */
/*  other hscalinteger that must be global into this argument instead. */

/*  Arguments */
/*  ========= */

/*  MA      (global input) INTEGER */
/*          The global number of matrix rows of A being operated on. */

/*  MAPOS0  (global input) INTEGER */
/*          Where in the calling routine's parameter list MA appears. */

/*  NA      (global input) INTEGER */
/*          The global number of matrix columns of A being operated on. */

/*  NAPOS0  (global input) INTEGER */
/*          Where in the calling routine's parameter list NA appears. */

/*  IA      (global input) INTEGER */
/*          The row index in the global array A indicating the first */
/*          row of sub( A ). */

/*  JA      (global input) INTEGER */
/*          The column index in the global array A indicating the */
/*          first column of sub( A ). */

/*  DESCA   (global and local input) INTEGER array of dimension DLEN_. */
/*          The array descriptor for the distributed matrix A. */

/*  DESCAPOS0 (global input) INTEGER */
/*          Where in the calling routine's parameter list DESCA */
/*          appears.  Note that we assume IA and JA are respectively 2 */
/*          and 1 entries behind DESCA. */

/*  MB      (global input) INTEGER */
/*          The global number of matrix rows of B being operated on. */

/*  MBPOS0  (global input) INTEGER */
/*          Where in the calling routine's parameter list MB appears. */

/*  NB      (global input) INTEGER */
/*          The global number of matrix columns of B being operated on. */

/*  NBPOS0  (global input) INTEGER */
/*          Where in the calling routine's parameter list NB appears. */

/*  IB      (global input) INTEGER */
/*          The row index in the global array B indicating the first */
/*          row of sub( B ). */

/*  JB      (global input) INTEGER */
/*          The column index in the global array B indicating the */
/*          first column of sub( B ). */

/*  DESCB   (global and local input) INTEGER array of dimension DLEN_. */
/*          The array descriptor for the distributed matrix B. */

/*  DESCBPOS0 (global input) INTEGER */
/*          Where in the calling routine's parameter list DESCB */
/*          appears. Note that we assume IB and JB are respectively 2 */
/*          and 1 entries behind DESCB. */

/*  NEXTRA  (global input) INTEGER */
/*          The number of extra parameters (i.e., besides the ones */
/*          above) to check.  NEXTRA <= LDW - 22. */

/*  EX      (local input) INTEGER array of dimension (NEXTRA) */
/*          The values of these extra parameters */

/*  EXPOS   (local input) INTEGER array of dimension (NEXTRA) */
/*          The parameter list positions of these extra values. */

/*  INFO    (local input/global output) INTEGER */
/*          = 0:  successful exit */
/*          < 0:  If the i-th argument is an array and the j-entry had */
/*                an illegal value, then INFO = -(i*100+j), if the i-th */
/*                argument is a scalar and had an illegal value, then */
/*                INFO = -i. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. Local Arrays .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

/*     Want to find errors with MIN( ), so if no error, set it to a big */
/*     number. If there already is an error, multiply by the the */
/*     descriptor multiplier. */

    /*
    * Do not worry about parameter checks at the moment
    */
    return HSCAL_SUCCESS;

    /* Parameter adjustments */
    --desca;
    --descb;
    --expos;
    --ex;

    /* Function Body */
    if (*info >= 0) {
	*info = 10000;
    } else if (*info < -100) {
	*info = -(*info);
    } else {
	*info = -(*info) * 100;
    }

/*     Pack values and their positions in the parameter list, factoring */
/*     in the descriptor multiplier */

    if ((*myrow == 0) && (*mycol == 0))
    {
       hscal_iwork00len_2 = c__70;
       hscal_iwork00_2[hscal_tcallnum_2] = (hscalinteger*)calloc(
                                                          hscal_iwork00len_2,
                                                          sizeof(hscalinteger)
       );

       if (hscal_iwork00_2[hscal_tcallnum_2] == NULL)
       { 
          return HSCAL_ERR_LOW_MEMORY;
       }

       iwork = hscal_iwork00_2[hscal_tcallnum_2];
    }
    else
    {
       iwork = (hscalinteger*)calloc(
                              c__70,
                              sizeof(hscalinteger)
       );

       if (iwork == NULL)
       { 
          return HSCAL_ERR_LOW_MEMORY;
       }
    }

    iwork[0] = *ma;
    iwork[35] = *mapos0 * 100;
    iwork[1] = *na;
    iwork[36] = *napos0 * 100;
    iwork[2] = *ia;
    iwork[37] = (*descapos0 - 2) * 100;
    iwork[3] = *ja;
    iwork[38] = (*descapos0 - 1) * 100;
    descpos = *descapos0 * 100;

    iwork[4] = desca[1];
    iwork[39] = descpos + 1;
    iwork[5] = desca[3];
    iwork[40] = descpos + 3;
    iwork[6] = desca[4];
    iwork[41] = descpos + 4;
    iwork[7] = desca[5];
    iwork[42] = descpos + 5;
    iwork[8] = desca[6];
    iwork[43] = descpos + 6;
    iwork[9] = desca[7];
    iwork[44] = descpos + 7;
    iwork[10] = desca[8];
    iwork[45] = descpos + 8;

    iwork[11] = *mb;
    iwork[46] = *mbpos0 * 100;
    iwork[12] = *nb;
    iwork[47] = *nbpos0 * 100;
    iwork[13] = *ib;
    iwork[48] = (*descbpos0 - 2) * 100;
    iwork[14] = *jb;
    iwork[49] = (*descbpos0 - 1) * 100;
    descpos = *descbpos0 * 100;

    iwork[15] = descb[1];
    iwork[50] = descpos + 1;
    iwork[16] = descb[3];
    iwork[51] = descpos + 3;
    iwork[17] = descb[4];
    iwork[52] = descpos + 4;
    iwork[18] = descb[5];
    iwork[53] = descpos + 5;
    iwork[19] = descb[6];
    iwork[54] = descpos + 6;
    iwork[20] = descb[7];
    iwork[55] = descpos + 7;
    iwork[21] = descb[8];
    iwork[56] = descpos + 8;

    if (*nextra > 0) {
	i__1 = *nextra;
	for (k = 1; k <= i__1; ++k) {
	    iwork[k + 21] = ex[k];
	    iwork[k + 56] = expos[k];
/* L10: */
	}
    }
    k = *nextra + 22;

/*     Get the smallest error detected anywhere (BIGNUM if no error) */

    if ((*myrow == 0)
        && (*mycol == 0
       )
    )
    {
       hscal_tcallnum_2++;;
    }
    else
    {
       hscalinteger *iwork00 = hscal_iwork00_2[hscal_curcallnum_2];

       hscal_globchk(&desca[2], &k, iwork, &c__35, iwork00, info,
                  myrow, mycol, nprow, npcol
       );

       free(iwork);

       hscal_curcallnum_2++;

       if (hscal_curcallnum_2 == hscal_tcallnum_2)
       {
          if ((*myrow == (*nprow - 1)) && (*mycol == (*npcol - 1)))
              ;
          else
          {
             hscal_curcallnum_2 = 0;
          }
       }
    }

/*     Prepare output: set info = 0 if no error, and divide by DESCMULT */
/*     if error is not in a descriptor entry. */

    if (*info == 10000) {
	*info = 0;
    } else if (*info % 100 == 0) {
	*info = -(*info) / 100;
    } else {
	*info = -(*info);
    }

    /*
    * Test for *nprow-1 and *npcol-1 
    * suggests it is a last iteration.
    * If *info is not 0, we do not come back here
    * So in both the cases, delete the pointer
    */
    if (((*myrow == (*nprow - 1))
        && (*mycol == (*npcol - 1))
        ) || (*info != 0)
    )
    {
       int fcallnum_2 = hscal_curcallnum_2 - 1;
       //free(hscal_iwork00_2[fcallnum_2]);
    }

    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_globchk(
         hscalinteger *ictxt, 
         hscalinteger *n, 
         hscalinteger *x, 
         hscalinteger *ldx, 
         hscalinteger *iwork00, 
         hscalinteger *info,
         hscalinteger *myrow,
         hscalinteger *mycol,
         hscalinteger *nprow,
         hscalinteger *npcol
)
{
    hscalinteger c__25 = 25;
    hscalinteger c__35 = 35;
    hscalinteger c__1 = 1;
    hscalinteger c__0 = 0;
    hscalinteger c_n1 = -1;

    /* System generated locals */
    hscalinteger x_dim1, x_offset, i__1, i__2, i__3;

    /* Local variables */
    hscalinteger k;

/*  -- ScaLAPACK tools routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  GLOBCHK checks that values in X(i,1) are the same on all processes */
/*  in the process grid indicated by ICTXT. */

/*  Arguments */
/*  ========= */

/*  ICTXT   (global input) INTEGER */
/*          The BLACS context handle indicating the context over which */
/*          the values are to be the same. */

/*  N       (global input) INTEGER */
/*          The number of values to be compared. */

/*  X       (local input) INTEGER array, dimension (N,2) */
/*          The 1st column contains the values which should be the same */
/*          on all processes.  The 2nd column indicates where in the */
/*          calling routine's parameter list the corresponding value */
/*          from column 1 came from. */

/*  LDX     (local input) INTEGER */
/*          The leading dimension of the array X. LDX >= MAX(1,N). */

/*  IWORK   (local workspace) INTEGER array, dimension (N) */
/*          Used to receive other processes' values for comparing with X. */

/*  INFO    (local input/global output) INTEGER */
/*          On entry, the smallest error flag so far generated, or BIGNUM */
/*          for no error. On exit: */
/*          = BIGNUM : no error */
/*          < 0: if INFO = -i*100, the i-th argument had an illegal */
/*               value, or was different between processes. */

/*  ===================================================================== */

/*     .. Local Scalars .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

    /*
    * Do not worry about parameter checks at the moment
    */
    return HSCAL_SUCCESS;

    /* Parameter adjustments */
    --iwork00;
    x_dim1 = *ldx;
    x_offset = 1 + x_dim1;
    x -= x_offset;

    /* Function Body */
    {
	i__1 = *n;
	for (k = 1; k <= i__1; ++k) {
	    if (x[k + x_dim1] != iwork00[k]) {
/* Computing MIN */
		i__2 = *info, i__3 = x[k + (x_dim1 << 1)];
		*info = min(i__2,i__3);
	    }
/* L10: */
	}
    }

    /*
    * This is a global variable; so restore the pointer
    */
    ++iwork00;

    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

