
#ifndef __HSCALAPACK_TOOLS_ZMATADD_HH
#define __HSCALAPACK_TOOLS_ZMATADD_HH

#include "../include/hscalapack.h"

int hscal_zmatadd(
    int *m,
    int *n,
    char *calpha,
    hscalinteger *lda,
    char *cbeta,
    hscalinteger *ldc,
    double *tcomp
)
{
    /* System generated locals */
    hscalinteger a_dim1, a_offset, c_dim1, c_offset, i__1, i__2, i__3, i__4, i__5;

    /* Local variables */
    hscalinteger i__, j;

    hscaldoublereal tn, tm;

    hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
    hscaldoublecomplex *beta  = (hscaldoublecomplex*)cbeta;

    tm = (double)(*m);
    tn = (double)(*n);
    *tcomp = 0.;

    /* Function Body */
    if (*m == 0 || *n == 0 || alpha->r == 0. && alpha->i == 0. && (beta->r == 
	    1. && beta->i == 0.)) {
	return HSCAL_SUCCESS;
    }

    if (*n == 1) {
	if (beta->r == 0. && beta->i == 0.) {
	    if (alpha->r == 0. && alpha->i == 0.) {
                *tcomp += tm*3;
	    } else {
                *tcomp += tm*10;
	    }
	} else {
	    if (alpha->r == 1. && alpha->i == 0.) {
		if (beta->r == 1. && beta->i == 0.) {
                    *tcomp += tm*7;
		} else {
                    *tcomp += tm*13;
		}
	    } else if (beta->r == 1. && beta->i == 0.) {
                *tcomp += tm*13;
	    } else {
                *tcomp += tm*19;
	    }
	}
    } else {
	if (beta->r == 0. && beta->i == 0.) {
	    if (alpha->r == 0. && alpha->i == 0.) {
                *tcomp += tn*tm*4;
	    } else {
                *tcomp += tn*tm*12;
	    }
	} else {
	    if (alpha->r == 1. && alpha->i == 0.) {
		if (beta->r == 1. && beta->i == 0.) {
                    *tcomp += tn*tm*10;
		} else {
                    *tcomp += tn*tm*16;
		}
	    } else if (beta->r == 1. && beta->i == 0.) {
                *tcomp += tn*tm*16;
	    } else {
                *tcomp += tn*tm*22;
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif

