/*******************************************************************
*                                                                  *
*                       Heterogeneous ScaLAPACK                    *
*                 Computation and Communication Routines           *
*                             (INTERNAL)                           *
*                 ====================================             *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_COMP_COMM_FUNCS_HH
#define __HMPI_SCALAPACK_COMP_COMM_FUNCS_HH

/*
* pcgesv
*/
double hscal_pcgesv_recon_tcomp(
   int n,
   int nrhs
);

double hscal_pcgesv_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcgesv_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgesv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgesv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgesv_tcomp_tcomm(
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdgesv
*/
double hscal_pdgesv_recon_tcomp(
   int n,
   int nrhs
);

double hscal_pdgesv_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdgesv_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgesv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgesv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgesv_tcomp_tcomm(
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* psgesv
*/
double hscal_psgesv_recon_tcomp(
   int n,
   int nrhs
);

double hscal_psgesv_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psgesv_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgesv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgesv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgesv_tcomp_tcomm(
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pzgesv
*/
double hscal_pzgesv_recon_tcomp(
   int n,
   int nrhs
);

double hscal_pzgesv_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzgesv_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgesv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgesv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgesv_tcomp_tcomm(
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pcgetrf
*/
double hscal_pcgetrf_recon_tcomp(
   int M,
   int N
);

double hscal_pcgetrf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcgetrf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgetrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgetrf_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgetrf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdgetrf
*/
double hscal_pdgetrf_recon_tcomp(
   int M,
   int N
);

double hscal_pdgetrf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdgetrf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgetrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgetrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgetrf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* psgetrf
*/
double hscal_psgetrf_recon_tcomp(
   int M,
   int N
);

double hscal_psgetrf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psgetrf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgetrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgetrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgetrf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pzgetrf
*/
double hscal_pzgetrf_recon_tcomp(
   int M,
   int N
);

double hscal_pzgetrf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzgetrf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgetrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgetrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgetrf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pcgetrs
*/
double hscal_pcgetrs_recon_tcomp(
   int TRANS,
   int N,
   int NRHS
);

double hscal_pcgetrs_my_tcomp(
   int myrow,
   int mycol,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcgetrs_my_tcomm(
   int myrow,
   int mycol,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgetrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgetrs_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgetrs_tcomp_tcomm(
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdgetrs
*/
double hscal_pdgetrs_recon_tcomp(
   int TRANS,
   int N,
   int NRHS
);

double hscal_pdgetrs_my_tcomp(
   int myrow,
   int mycol,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdgetrs_my_tcomm(
   int myrow,
   int mycol,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgetrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgetrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgetrs_tcomp_tcomm(
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* psgetrs
*/
double hscal_psgetrs_recon_tcomp(
   int TRANS,
   int N,
   int NRHS
);

double hscal_psgetrs_my_tcomp(
   int myrow,
   int mycol,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psgetrs_my_tcomm(
   int myrow,
   int mycol,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgetrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgetrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgetrs_tcomp_tcomm(
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pzgetrs
*/
double hscal_pzgetrs_recon_tcomp(
   int TRANS,
   int N,
   int NRHS
);

double hscal_pzgetrs_my_tcomp(
   int myrow,
   int mycol,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzgetrs_my_tcomm(
   int myrow,
   int mycol,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgetrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgetrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgetrs_tcomp_tcomm(
   int TRANS,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pcgetf2
*/
double hscal_pcgetf2_recon_tcomp(
   int M,
   int N
);

double hscal_pcgetf2_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcgetf2_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgetf2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgetf2_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgetf2_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgetf2_info(
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pcgetf2_info_i(
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdgetf2
*/
double hscal_pdgetf2_recon_tcomp(
   int M,
   int N
);

double hscal_pdgetf2_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdgetf2_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgetf2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgetf2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgetf2_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgetf2_info(
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pdgetf2_info_i(
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* psgetf2
*/
double hscal_psgetf2_recon_tcomp(
   int M,
   int N
);

double hscal_psgetf2_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psgetf2_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgetf2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgetf2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgetf2_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgetf2_info(
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_psgetf2_info_i(
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzgetf2
*/
double hscal_pzgetf2_recon_tcomp(
   int M,
   int N
);

double hscal_pzgetf2_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzgetf2_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgetf2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgetf2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgetf2_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgetf2_info(
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pzgetf2_info_i(
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pclapiv
*/
double hscal_pclapiv_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int N
);

double hscal_pclapiv_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pclapiv_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pclapiv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pclapiv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pclapiv_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pclapiv_info(
   char *DIRECC,
   char *ROWCOLC,
   char *PIVROCC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pclapiv_info_i(
   char *DIRECC,
   char *ROWCOLC,
   char *PIVROCC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdlapiv
*/
double hscal_pdlapiv_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int N
);

double hscal_pdlapiv_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdlapiv_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdlapiv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdlapiv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdlapiv_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdlapiv_info(
   char *DIRECC,
   char *ROWCOLC,
   char *PIVROCC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pdlapiv_info_i(
   char *DIRECC,
   char *ROWCOLC,
   char *PIVROCC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pslapiv
*/
double hscal_pslapiv_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int N
);

double hscal_pslapiv_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pslapiv_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pslapiv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pslapiv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pslapiv_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pslapiv_info(
   char *DIRECC,
   char *ROWCOLC,
   char *PIVROCC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pslapiv_info_i(
   char *DIRECC,
   char *ROWCOLC,
   char *PIVROCC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzlapiv
*/
double hscal_pzlapiv_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int N
);

double hscal_pzlapiv_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzlapiv_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzlapiv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzlapiv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzlapiv_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int PIVROCI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzlapiv_info(
   char *DIRECC,
   char *ROWCOLC,
   char *PIVROCC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pzlapiv_info_i(
   char *DIRECC,
   char *ROWCOLC,
   char *PIVROCC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pclapv2
*/
double hscal_pclapv2_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int N
);

double hscal_pclapv2_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pclapv2_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pclapv2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pclapv2_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pclapv2_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pclapv2_info(
   char *DIRECC,
   char *ROWCOLC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pclapv2_info_i(
   char *DIRECC,
   char *ROWCOLC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdlapv2
*/
double hscal_pdlapv2_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int N
);

double hscal_pdlapv2_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdlapv2_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdlapv2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdlapv2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdlapv2_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdlapv2_info(
   char *DIRECC,
   char *ROWCOLC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pdlapv2_info_i(
   char *DIRECC,
   char *ROWCOLC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pslapv2
*/
double hscal_pslapv2_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int N
);

double hscal_pslapv2_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pslapv2_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pslapv2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pslapv2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pslapv2_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pslapv2_info(
   char *DIRECC,
   char *ROWCOLC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pslapv2_info_i(
   char *DIRECC,
   char *ROWCOLC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzlapv2
*/
double hscal_pzlapv2_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int N
);

double hscal_pzlapv2_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzlapv2_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzlapv2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzlapv2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzlapv2_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IP,
   int JP,
   int DESCP[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzlapv2_info(
   char *DIRECC,
   char *ROWCOLC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pzlapv2_info_i(
   char *DIRECC,
   char *ROWCOLC,
   int * M,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IP,
   int * JP,
   int * DESCP,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pclaswp
*/
double hscal_pclaswp_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int N
);

double hscal_pclaswp_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol
);

int hscal_pclaswp_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pclaswp_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pclaswp_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pclaswp_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pclaswp_info(
   char *DIRECC,
   char *ROWCOLC,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * K1,
   int * K2,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pclaswp_info_i(
   char *DIRECC,
   char *ROWCOLC,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * K1,
   int * K2,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdlaswp
*/
double hscal_pdlaswp_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int N
);

double hscal_pdlaswp_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol
);

int hscal_pdlaswp_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdlaswp_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdlaswp_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdlaswp_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdlaswp_info(
   char *DIRECC,
   char *ROWCOLC,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * K1,
   int * K2,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pdlaswp_info_i(
   char *DIRECC,
   char *ROWCOLC,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * K1,
   int * K2,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pslaswp
*/
double hscal_pslaswp_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int N
);

double hscal_pslaswp_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol
);

int hscal_pslaswp_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pslaswp_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pslaswp_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pslaswp_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pslaswp_info(
   char *DIRECC,
   char *ROWCOLC,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * K1,
   int * K2,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pslaswp_info_i(
   char *DIRECC,
   char *ROWCOLC,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * K1,
   int * K2,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzlaswp
*/
double hscal_pzlaswp_recon_tcomp(
   int DIRECI,
   int ROWCOLI,
   int N
);

double hscal_pzlaswp_my_tcomp(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol
);

int hscal_pzlaswp_my_tcomm(
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzlaswp_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzlaswp_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzlaswp_tcomp_tcomm(
   int DIRECI,
   int ROWCOLI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int K1,
   int K2,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzlaswp_info(
   char *DIRECC,
   char *ROWCOLC,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * K1,
   int * K2,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

int hscal_pzlaswp_info_i(
   char *DIRECC,
   char *ROWCOLC,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * K1,
   int * K2,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcposv
*/
double hscal_pcposv_recon_tcomp(
   int UPLOI,
   int N,
   int NRHS
);

double hscal_pcposv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcposv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcposv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcposv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcposv_tcomp_tcomm(
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdposv
*/
double hscal_pdposv_recon_tcomp(
   int UPLOI,
   int N,
   int NRHS
);

double hscal_pdposv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdposv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdposv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdposv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdposv_tcomp_tcomm(
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* psposv
*/
double hscal_psposv_recon_tcomp(
   int UPLOI,
   int N,
   int NRHS
);

double hscal_psposv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psposv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psposv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psposv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psposv_tcomp_tcomm(
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pzposv
*/
double hscal_pzposv_recon_tcomp(
   int UPLOI,
   int N,
   int NRHS
);

double hscal_pzposv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzposv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzposv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzposv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzposv_tcomp_tcomm(
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pcgetrs
*/
double hscal_pcpotrs_recon_tcomp(
   int UPLOI,
   int N,
   int NRHS
);

double hscal_pcpotrs_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcpotrs_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcpotrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcpotrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcpotrs_tcomp_tcomm(
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdpotrs
*/
double hscal_pdpotrs_recon_tcomp(
   int UPLOI,
   int N,
   int NRHS
);

double hscal_pdpotrs_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdpotrs_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdpotrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdpotrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdpotrs_tcomp_tcomm(
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pspotrs
*/
double hscal_pspotrs_recon_tcomp(
   int UPLOI,
   int N,
   int NRHS
);

double hscal_pspotrs_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pspotrs_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pspotrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pspotrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pspotrs_tcomp_tcomm(
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pzpotrs
*/
double hscal_pzpotrs_recon_tcomp(
   int UPLOI,
   int N,
   int NRHS
);

double hscal_pzpotrs_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzpotrs_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzpotrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzpotrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzpotrs_tcomp_tcomm(
   int UPLOI,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pcpotrf
*/
double hscal_pcpotrf_recon_tcomp(
   int UPLOI,
   int N
);

double hscal_pcpotrf_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcpotrf_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcpotrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcpotrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcpotrf_tcomp_tcomm(
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdpotrf
*/
double hscal_pdpotrf_recon_tcomp(
   int UPLOI,
   int N
);

double hscal_pdpotrf_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdpotrf_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdpotrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdpotrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdpotrf_tcomp_tcomm(
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pspotrf
*/
double hscal_pspotrf_recon_tcomp(
   int UPLOI,
   int N
);

double hscal_pspotrf_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pspotrf_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pspotrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pspotrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pspotrf_tcomp_tcomm(
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pzpotrf
*/
double hscal_pzpotrf_recon_tcomp(
   int UPLOI,
   int N
);

double hscal_pzpotrf_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzpotrf_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzpotrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzpotrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzpotrf_tcomp_tcomm(
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pcpotf2
*/
double hscal_pcpotf2_recon_tcomp(
   int UPLOI,
   int N
);

double hscal_pcpotf2_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int ihscal_pcpotf2_tcomp(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp
);

int hscal_pcpotf2_tcomp(
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp
);

/*
* pdpotf2
*/
double hscal_pdpotf2_recon_tcomp(
   int UPLOI,
   int N
);

double hscal_pdpotf2_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int ihscal_pdpotf2_tcomp(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp
);

int hscal_pdpotf2_tcomp(
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp
);

/*
* pspotf2
*/
double hscal_pspotf2_recon_tcomp(
   int UPLOI,
   int N
);

double hscal_pspotf2_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int ihscal_pspotf2_tcomp(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp
);

int hscal_pspotf2_tcomp(
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp
);


/*
* pzpotf2
*/
double hscal_pzpotf2_recon_tcomp(
   int UPLOI,
   int N
);

double hscal_pzpotf2_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int ihscal_pzpotf2_tcomp(
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp
);

int hscal_pzpotf2_tcomp(
   int UPLOI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp
);

/*
* pxdbsv
*/
double hscal_pcdbsv_recon_tcomp(
   int N,
   int BWL, 
   int BWU,
   int NRHS
);

double hscal_pcdbsv_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcdbsv_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcdbsv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcdbsv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcdbsv_tcomp_tcomm(
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pddbsv_recon_tcomp(
   int N,
   int BWL, 
   int BWU,
   int NRHS
);

double hscal_pddbsv_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pddbsv_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pddbsv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pddbsv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pddbsv_tcomp_tcomm(
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_psdbsv_recon_tcomp(
   int N,
   int BWL, 
   int BWU,
   int NRHS
);

double hscal_psdbsv_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psdbsv_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psdbsv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psdbsv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psdbsv_tcomp_tcomm(
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pzdbsv_recon_tcomp(
   int N,
   int BWL, 
   int BWU,
   int NRHS
);

double hscal_pzdbsv_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzdbsv_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzdbsv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzdbsv_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzdbsv_tcomp_tcomm(
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pxdbtrf
*/
double hscal_pcdbtrf_recon_tcomp(
   int N,
   int BWL, 
   int BWU
);

double hscal_pcdbtrf_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcdbtrf_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcdbtrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcdbtrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcdbtrf_tcomp_tcomm(
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pddbtrf_recon_tcomp(
   int N,
   int BWL, 
   int BWU
);

double hscal_pddbtrf_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pddbtrf_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pddbtrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pddbtrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pddbtrf_tcomp_tcomm(
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_psdbtrf_recon_tcomp(
   int N,
   int BWL, 
   int BWU
);

double hscal_psdbtrf_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psdbtrf_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psdbtrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psdbtrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psdbtrf_tcomp_tcomm(
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pzdbtrf_recon_tcomp(
   int N,
   int BWL, 
   int BWU
);

double hscal_pzdbtrf_my_tcomp(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzdbtrf_my_tcomm(
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzdbtrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzdbtrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzdbtrf_tcomp_tcomm(
   int N,
   int BWL, 
   int BWU,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pxdbtrs
*/
double hscal_pcdbtrs_recon_tcomp(
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS
);

double hscal_pcdbtrs_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcdbtrs_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcdbtrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcdbtrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcdbtrs_tcomp_tcomm(
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pddbtrs_recon_tcomp(
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS
);

double hscal_pddbtrs_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pddbtrs_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pddbtrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pddbtrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pddbtrs_tcomp_tcomm(
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_psdbtrs_recon_tcomp(
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS
);

double hscal_psdbtrs_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psdbtrs_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psdbtrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psdbtrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psdbtrs_tcomp_tcomm(
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pzdbtrs_recon_tcomp(
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS
);

double hscal_pzdbtrs_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzdbtrs_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzdbtrs_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzdbtrs_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzdbtrs_tcomp_tcomm(
   int TRANSI,
   int N,
   int BWL, 
   int BWU,
   int NRHS,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pxgelq2
*/
double hscal_pcgelq2_recon_tcomp(
   int M,
   int N
);

double hscal_pcgelq2_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcgelq2_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgelq2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA, 
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgelq2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgelq2_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_], 
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pdgelq2_recon_tcomp(
   int M,
   int N
);

double hscal_pdgelq2_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdgelq2_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgelq2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA, 
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgelq2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgelq2_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_], 
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_psgelq2_recon_tcomp(
   int M,
   int N
);

double hscal_psgelq2_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psgelq2_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgelq2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA, 
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgelq2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgelq2_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_], 
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pzgelq2_recon_tcomp(
   int M,
   int N
);

double hscal_pzgelq2_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzgelq2_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgelq2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA, 
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgelq2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgelq2_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_], 
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pxlarfc
*/
double hscal_pclarfc_recon_tcomp(
   int sidei,
   int m,
   int n
);

double hscal_pclarfc_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pclarfc_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pclarfc_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pclarfc_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pclarfc_tcomp_tcomm(
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pzlarfc_recon_tcomp(
   int sidei,
   int m,
   int n
);

double hscal_pzlarfc_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzlarfc_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzlarfc_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzlarfc_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzlarfc_tcomp_tcomm(
   int SIDEI,
   int M,
   int N,
   int IV,
   int JV,
   int DESCV[DLEN_],
   int INCV,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pxunmlq
*/
double hscal_pcunmlq_recon_tcomp(
   int sidei,
   int transi,
   int m,
   int n,
   int k
);

double hscal_pcunmlq_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcunmlq_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcunmlq_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcunmlq_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcunmlq_tcomp_tcomm(
   int SIDEI,
   int TRANSI,
   int M, 
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC, 
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pzunmlq_recon_tcomp(
   int sidei,
   int transi,
   int m,
   int n,
   int k
);

double hscal_pzunmlq_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzunmlq_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzunmlq_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzunmlq_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzunmlq_tcomp_tcomm(
   int SIDEI,
   int TRANSI,
   int M, 
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC, 
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pxgeqrf
*/
double hscal_pcgeqrf_recon_tcomp(
   int M,
   int N
);

double hscal_pcgeqrf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcgeqrf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgeqrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgeqrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M, 
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgeqrf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pdgeqrf_recon_tcomp(
   int M,
   int N
);

double hscal_pdgeqrf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdgeqrf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgeqrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgeqrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M, 
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgeqrf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_psgeqrf_recon_tcomp(
   int M,
   int N
);

double hscal_psgeqrf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psgeqrf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgeqrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgeqrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M, 
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgeqrf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pzgeqrf_recon_tcomp(
   int M,
   int N
);

double hscal_pzgeqrf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzgeqrf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgeqrf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgeqrf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M, 
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgeqrf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pxorml2
*/
double hscal_pdorml2_recon_tcomp(
   int sidei,
   int transi,
   int m,
   int n,
   int k
);

double hscal_pdorml2_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdorml2_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdorml2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdorml2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdorml2_tcomp_tcomm(
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_psorml2_recon_tcomp(
   int sidei,
   int transi,
   int m,
   int n,
   int k
);

double hscal_psorml2_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_psorml2_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psorml2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psorml2_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psorml2_tcomp_tcomm(
   int SIDEI,
   int TRANSI,
   int M,
   int N,
   int K,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/* 
* pxgelqf
*/ 
double hscal_pcgelqf_recon_tcomp(
   int M,
   int N
);
   
double hscal_pcgelqf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
); 

int hscal_pcgelqf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
); 
   
int hscal_pcgelqf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgelqf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgelqf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pdgelqf_recon_tcomp(
   int M,
   int N
);

double hscal_pdgelqf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdgelqf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
); 
   
int hscal_pdgelqf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
); 
   
int hscal_pdgelqf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N, 
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
); 
   
int hscal_pdgelqf_tcomp_tcomm(
   int M,
   int N, 
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);
   
double hscal_psgelqf_recon_tcomp(
   int M,
   int N
); 
   
double hscal_psgelqf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
); 
   
int hscal_psgelqf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgelqf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgelqf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgelqf_tcomp_tcomm(
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pzgelqf_recon_tcomp(
   int M,
   int N
);

double hscal_pzgelqf_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol
); 
   
int hscal_pzgelqf_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
); 
   
int hscal_pzgelqf_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
); 
   
int hscal_pzgelqf_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N, 
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
); 
   
int hscal_pzgelqf_tcomp_tcomm(
   int M,
   int N, 
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pxgels
*/
double hscal_pcgels_recon_tcomp(
   int TRANSI,
   int M,
   int N,
   int NRHS
);

double hscal_pcgels_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pcgels_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgels_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgels_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgels_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pdgels_recon_tcomp(
   int TRANSI,
   int M,
   int N,
   int NRHS
);

double hscal_pdgels_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pdgels_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgels_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgels_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgels_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_psgels_recon_tcomp(
   int TRANSI,
   int M,
   int N,
   int NRHS
);

double hscal_psgels_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_psgels_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgels_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgels_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgels_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

double hscal_pzgels_recon_tcomp(
   int TRANSI,
   int M,
   int N,
   int NRHS
);

double hscal_pzgels_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol
);

int hscal_pzgels_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgels_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgels_my_tcomp_tcomm(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgels_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int NRHS,
   int IA,
   int JA,
   int DESCA[DLEN1_],
   int IB,
   int JB,
   int DESCB[DLEN1_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

#endif

