
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                      CONTEXT  API                                *
*                 =============================                    *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_CONTEXT_API_INCLUDE_HH
#define __HMPI_SCALAPACK_CONTEXT_API_INCLUDE_HH

/*
* pxgesv
*/
int hscal_pcgesv_ctxt(
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pdgesv_ctxt(
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_psgesv_ctxt(
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pzgesv_ctxt(
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pxgetrf
*/
int hscal_pcgetrf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pdgetrf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_psgetrf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pzgetrf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pxgetrs
*/
int hscal_pcgetrs_ctxt(
   char   * TRANS,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pdgetrs_ctxt(
   char   * TRANS,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_psgetrs_ctxt(
   char   * TRANS,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pzgetrs_ctxt(
   char   * TRANS,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pxposv
*/
int hscal_pcposv_ctxt(
   char   * UPLO,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pdposv_ctxt(
   char   * UPLO,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_psposv_ctxt(
   char   * UPLO,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pzposv_ctxt(
   char   * UPLO,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pxpotrf
*/
int hscal_pcpotrf_ctxt(
   char   * UPLO,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pdpotrf_ctxt(
   char   * UPLO,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pspotrf_ctxt(
   char   * UPLO,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pzpotrf_ctxt(
   char   * UPLO,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pxpotrs
*/
int hscal_pcpotrs_ctxt(
   char   * UPLO,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pdpotrs_ctxt(
   char   * UPLO,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pspotrs_ctxt(
   char   * UPLO,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pzpotrs_ctxt(
   char   * UPLO,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pxdbsv
*/
int hscal_pcdbsv_ctxt(
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * NRHS,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pddbsv_ctxt(
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * NRHS,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_psdbsv_ctxt(
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * NRHS,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pzdbsv_ctxt(
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * NRHS,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pxdbtrf
*/

int hscal_pcdbtrf_ctxt(
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pddbtrf_ctxt(
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_psdbtrf_ctxt(
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pzdbtrf_ctxt(
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pxdbtrs
*/

int hscal_pcdbtrs_ctxt(
   char   * TRANS,
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * NRHS,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pddbtrs_ctxt(
   char   * TRANS,
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * NRHS,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_psdbtrs_ctxt(
   char   * TRANS,
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * NRHS,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pzdbtrs_ctxt(
   char   * TRANS,
   int    * N,
   int    * BWL,
   int    * BWU,
   int    * NRHS,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pxgels
*/
int hscal_pcgels_ctxt(
   char   * TRANS,
   int    * M,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pdgels_ctxt(
   char   * TRANS,
   int    * M,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_psgels_ctxt(
   char   * TRANS,
   int    * M,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

int hscal_pzgels_ctxt(
   char   * TRANS,
   int    * M,
   int    * N,
   int    * NRHS,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pxgelqf
*/
int hscal_pcgelqf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pdgelqf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_psgelqf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pzgelqf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pxgeqrf
*/
int hscal_pcgeqrf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pdgeqrf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_psgeqrf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

int hscal_pzgeqrf_ctxt(
   int    * M,
   int    * N,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

#endif

