
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                       MPC Macros                                 *
*                         (INTERNAL)                               *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HSCALAPACK_MPC_MACROS_HH_
#define __HSCALAPACK_MPC_MACROS_HH_

#define    HSCAL_PXGESV_INIT_LLDS( \
                  DESCA, \
                  DESCB, \
                  myrow, nprow \
           ) \
              { \
                 DESCA[LLD1_] = max(1, PB_Cnumroc(DESCA[M1_], \
                                                  0, \
                                                  DESCA[MB1_], \
                                                  DESCA[MB1_], \
                                                  myrow, \
                                                  DESCA[RSRC1_], \
                                                  nprow \
                               ) \
                 ); \
                 DESCB[LLD1_] = max(1, PB_Cnumroc(DESCB[M1_], \
                                                  0, \
                                                  DESCB[MB1_], \
                                                  DESCB[MB1_], \
                                                  myrow, \
                                                  DESCB[RSRC1_], \
                                                  nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXGETRS_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXDBTRS_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXDBTRSV_INIT_LLDS              HSCAL_PXGESV_INIT_LLDS

#define    HSCAL_PXGELS_INIT_LLDS                HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXLARFB_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXLARFC_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXLARF_INIT_LLDS                HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXUNMLQ_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXUNML2_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXUNM2R_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXUNMQR_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXORML2_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXORM2R_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXORMQR_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXORMLQ_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS

#define    HSCAL_PXGETF2_INIT_LLDS( \
                  DESCA, \
                  myrow, nprow \
           ) \
              { \
                 DESCA[LLD1_] = max(1, PB_Cnumroc(DESCA[M1_], \
                                                  0, \
                                                  DESCA[MB1_], \
                                                  DESCA[MB1_], \
                                                  myrow, \
                                                  DESCA[RSRC1_], \
                                                  nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXGETRF_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXLASWP_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXLAPIV_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXLAPV2_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXDBTRF_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS

#define    HSCAL_PXGELQ2_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXGELQF_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXGEQR2_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXGEQRF_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXLARFG_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXLARFT_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS

#define    HSCAL_PXGETRS_ALLOC_INTER_DATA( \
                DESCIP, \
                nprow, npcol \
           ) \
           { \
             DESCIP = (int(*)[DLEN1_])malloc(nprow*npcol*sizeof(int[DLEN1_])); \
             if (DESCIP == NULL) \
             { \
                break; \
             } \
           }

#define    HSCAL_PXGETRS_FREE_INTER_DATA( \
                DESCIP \
           ) \
           { \
             { \
                free(DESCIP); \
             } \
           }

#define    HSCAL_PXLAPIV_ALLOC_INTER_DATA       HSCAL_PXGETRS_ALLOC_INTER_DATA
#define    HSCAL_PXLAPIV_FREE_INTER_DATA        HSCAL_PXGETRS_FREE_INTER_DATA

#define    HSCAL_PXPOSV_INIT_LLDS                HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXPOTRS_INIT_LLDS               HSCAL_PXGESV_INIT_LLDS
#define    HSCAL_PXPOTRF_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS
#define    HSCAL_PXPOTF2_INIT_LLDS               HSCAL_PXGETF2_INIT_LLDS

#define    HSCAL_PXDBTRF_ALLOC_INTER_DATA( \
                level_dist__, \
                llda, \
                nprow, npcol \
           ) \
           { \
             level_dist__ = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (level_dist__ == NULL) \
             { \
                break; \
             } \
             llda = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (llda == NULL) \
             { \
                free(level_dist__); \
                break; \
             } \
           }

#define    HSCAL_PXDBTRF_FREE_INTER_DATA( \
                level_dist__, \
                llda \
           ) \
           { \
             { \
                free(level_dist__); \
                free(llda); \
             } \
           }

#define    HSCAL_PXDBTRSV_ALLOC_INTER_DATA( \
                level_dist__, \
                llda, \
                lldb, \
                nprow, npcol \
           ) \
           { \
             level_dist__ = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (level_dist__ == NULL) \
             { \
                break; \
             } \
             llda = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (llda == NULL) \
             { \
                free(level_dist__); \
                break; \
             } \
             lldb = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (lldb == NULL) \
             { \
                free(level_dist__); \
                free(llda); \
                break; \
             } \
           }

#define    HSCAL_PXDBTRSV_FREE_INTER_DATA( \
                level_dist__, \
                llda, \
                lldb \
           ) \
           { \
             { \
                free(level_dist__); \
                free(llda); \
                free(lldb); \
             } \
           }

#define    HSCAL_PXLARFB_ALLOC_INTER_DATA( \
                ldc, \
                ldv, \
                mpc, \
                nqc, \
                nprow, npcol \
           ) \
           { \
             ldc = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (ldc == NULL) \
             { \
                break; \
             } \
             ldv = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (ldv == NULL) \
             { \
                free(ldc); \
                break; \
             } \
             mpc = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (mpc == NULL) \
             { \
                free(ldc); \
                free(ldv); \
                break; \
             } \
             nqc = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (nqc == NULL) \
             { \
                free(ldc); \
                free(ldv); \
                free(mpc); \
                break; \
             } \
           }

#define    HSCAL_PXLARFB_FREE_INTER_DATA( \
                ldc, \
                ldv, \
                mpc, \
                nqc \
           ) \
           { \
             { \
                free(ldc); \
                free(ldv); \
                free(mpc); \
                free(nqc); \
             } \
           }

#define    HSCAL_PXLARFC_ALLOC_INTER_DATA       HSCAL_PXLARFB_ALLOC_INTER_DATA
#define    HSCAL_PXLARFC_FREE_INTER_DATA        HSCAL_PXLARFB_FREE_INTER_DATA

#define    HSCAL_PXLARF_ALLOC_INTER_DATA( \
                ldc, \
                ldv, \
                ioffc, \
                ioffv, \
                mp, \
                nq, \
                nprow, npcol \
           ) \
           { \
             ldc = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (ldc == NULL) \
             { \
                break; \
             } \
             ldv = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (ldv == NULL) \
             { \
                free(ldc); \
                break; \
             } \
             ioffc = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (ioffc == NULL) \
             { \
                free(ldc); \
                free(ldv); \
                break; \
             } \
             ioffv = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (ioffv == NULL) \
             { \
                free(ldc); \
                free(ldv); \
                free(ioffc); \
                break; \
             } \
             mp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (mp == NULL) \
             { \
                free(ldc); \
                free(ldv); \
                free(ioffc); \
                free(ioffv); \
                break; \
             } \
             nq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (nq == NULL) \
             { \
                free(ldc); \
                free(ldv); \
                free(ioffc); \
                free(ioffv); \
                free(mp); \
                break; \
             } \
           }


#define    HSCAL_PXLARF_FREE_INTER_DATA( \
                ldc, \
                ldv, \
                ioffc, \
                ioffv, \
                mp, \
                nq \
           ) \
           { \
             { \
                free(ldc); \
                free(ldv); \
                free(ioffc); \
                free(ioffv); \
                free(mp); \
                free(nq); \
             } \
           }

#endif

