/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK Optimal                  *
*                 Determination functions                          *
*                 ===============================                  *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_OPTIMALS_INCLUDE_HH
#define __HMPI_SCALAPACK_OPTIMALS_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       FUNCTION PROTOTYPES FOR OPTIMAL BLOCKING FACTOR...
* ------------------------------------------------------------------
*/
int hscal_pilaenv
(
    char *precision
);

int hscal_pilaenv_n
(
    const int m,
    char *precision
);

int hscal_pilaenv_m_n
(
    const int m,
    const int n,
    char *precision
);

int hscal_pilaenv_m_n_k
(
    const int m,
    const int n,
    const int k,
    char *precision
);

int hscal_pilaenv_recon
(
    char *precision
);

/*
* pzgemm optimal block b
*/
double hscal_pzgemm_recon_tcomp_optimal_b
(
   int transai,
   int transbi,
   int m,
   int n,
   int k,
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pzgemm_my_tcomp_optimal_b(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int OPTIMALB,
   int nprow,
   int npcol
);

int hscal_pzgemm_my_tcomm_optimal_b(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int OPTIMALB,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgemm_my_tcomm_to_ij_optimal_b(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int OPTIMALB,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgemm_my_tcomp_tcomm_optimal_b(
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int OPTIMALB,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgemm_tcomp_tcomm_optimal_b(
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int OPTIMALB,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

#endif  /* __HMPI_SCALAPACK_OPTIMALS_INCLUDE_HH */
