
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK BLACS                    *
*                         (INTERNAL)                               *
*                 =============================                    *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_BLACS_INCLUDE_HH
#define __HMPI_SCALAPACK_BLACS_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       FUNCTION PROTOTYPES and mpC MACROS FOR
*       BLACS COMMUNICATIONS
* ------------------------------------------------------------------
*/
typedef void           (*HSCALGESD2D_T)   ( HSCALBLACSCONTEXT *,       
                                            int, int,
                                            int, int, int,
                                            int, int, int, int, double*, int*);
typedef void           (*HSCALGEBS2D_T)   ( HSCALBLACSCONTEXT*,
                                            char *, char *,
                                            int, int, int,
                                            int, int, int, int, double*, int*);
typedef void           (*HSCALGEBR2D_T)   ( HSCALBLACSCONTEXT *,
                                            char *, char *,
                                            int, int, 
                                            int, int, int,
                                            int, int, int, int, double*, int*);
typedef void           (*HSCALGSUM2D_T)   ( HSCALBLACSCONTEXT *,       
                                            char *, char *,
                                            int, int,
                                            int, int, int,
                                            int, int, int, int, double*, int*);
void hscal_Ccgebs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cdgebs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cigebs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Csgebs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Czgebs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Ccgebr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cdgebr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Csgebr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Czgebr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cigebr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Ccgesd2d(
     HSCALBLACSCONTEXT *ctxt, 
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cdgesd2d(
     HSCALBLACSCONTEXT *ctxt, 
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cigesd2d(
     HSCALBLACSCONTEXT *ctxt, 
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Csgesd2d(
     HSCALBLACSCONTEXT *ctxt, 
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Czgesd2d(
     HSCALBLACSCONTEXT *ctxt, 
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Ccgsum2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, 
     int lda, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Cdgsum2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, 
     int lda, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Cigsum2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, 
     int lda, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Csgsum2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, 
     int lda, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Czgsum2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, 
     int m, int n, 
     int lda, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

typedef void (*HSCALVVFUNPTR)(int, int, int, int, int, double*);
typedef void (*HSCALSDPTR)(int, int, int, int, int, int, int, double*, int*);

void hscal_BI_MPI_Allreduce_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALVVFUNPTR Xvvop,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_MPI_Bcast_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, int root,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_MPI_Reduce_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALVVFUNPTR Xvvop, int root, 
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_cMPI_sum(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_cvvsum(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_dvvsum(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_ivvsum(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_svvsum(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_zvvsum(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_HypBS_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send, int *error,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_BI_IdringBS_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send, int step,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_BI_MpathBR_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send, int src, int npaths,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_BI_MpathBS_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send, int npaths,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_BI_MPI_SUM(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_MringComb_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALVVFUNPTR Xvvop,
     int dest, int nrings,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_BI_MPI_Send_nocomm(
     int N, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_SringBS_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_BI_TreeBS_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send, int nbranches,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_BI_TreeComb_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALVVFUNPTR Xvvop,
     int dest, int nbranches,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_BI_zMPI_sum(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_HypBR_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send, int src, int * error,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_TreeBR_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send, int src, int nbranches,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_IdringBR_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send, int src, int step,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_SringBR_nocomm(
     HSCALBLACSCONTEXT *ctxt, int N,  int nbytes, HSCALSDPTR send, int src,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_cvmcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_dvmcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_svmcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_zvmcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_ivmcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_cmvcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_dmvcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_smvcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_zmvcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_imvcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_Ccgamx2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int *rA, int *cA, int ldia, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Cdgamx2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int *rA, int *cA, int ldia, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Cigamx2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int *rA, int *cA, int ldia, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Csgamx2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int *rA, int *cA, int ldia, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Czgamx2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, int m, int n,
     int lda, int *rA, int *cA, int ldia, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_cvvamx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_cvvamx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_dvvamx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_dvvamx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_ivvamx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_ivvamx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_svvamx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_svvamx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_zvvamx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_zvvamx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_cMPI_amx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_cMPI_amx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_dMPI_amx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_dMPI_amx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_iMPI_amx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_iMPI_amx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_sMPI_amx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_sMPI_amx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_zMPI_amx2_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_zMPI_amx_nocomm(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_TransDist_nocomm(
     HSCALBLACSCONTEXT *ctxt, 
     char scope, int m, int n, int *rA,
     int *cA, int ldrc, BI_DistType *dist, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_BI_BeComb_nocomm(
     HSCALBLACSCONTEXT *ctxt, int NC, int N, HSCALVVFUNPTR Xvvop,
     int nprow, int npcol, int myrow, int mycol,
     double *tcomp, int *tcomm
);

void hscal_Cctrsd2d(
     HSCALBLACSCONTEXT *ctxt, 
     char *uplo, char *diag,
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Cdtrsd2d(
     HSCALBLACSCONTEXT *ctxt, 
     char *uplo, char *diag,
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Citrsd2d(
     HSCALBLACSCONTEXT *ctxt, 
     char *uplo, char *diag,
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Cstrsd2d(
     HSCALBLACSCONTEXT *ctxt, 
     char *uplo, char *diag,
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_Cztrsd2d(
     HSCALBLACSCONTEXT *ctxt, 
     char *uplo, char *diag,
     int m, int n, int lda,
     int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_BI_GetMpiTrType(char uplo, char diag,
                           int m, int n, int lda, int *N);

void hscal_Cctrbr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cdtrbr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Citrbr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cstrbr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cztrbr2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda, int rsrc, int csrc,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cctrbs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cdtrbs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Citrbs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cstrbs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

void hscal_Cztrbs2d(
     HSCALBLACSCONTEXT *ctxt, char *scope, char *top, char *uplo, char *diag,
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm 
);

#endif  /* __HMPI_SCALAPACK_BLACS_INCLUDE_HH */

