
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                 BLAS BUILTIN FUNCTIONS                           *
*                         (INTERNAL)                               *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_BLAS_BUILTIN_FUNCTIONS_HH
#define __HMPI_SCALAPACK_BLAS_BUILTIN_FUNCTIONS_HH

double hscal_d_imag(hscaldoublecomplex *);
double hscal_r_imag(hscalcomplex *);
hscaldoublereal hscal_dcabs1(hscaldoublecomplex *);
hscallogical hscal_lsame(char *, char *);
int hscal_xerbla(char *, hscalinteger *);
void hscal_r_cnjg(hscalcomplex *, hscalcomplex *);
void hscal_d_cnjg(hscaldoublecomplex *, hscaldoublecomplex *);
double hscal_c_abs(hscalcomplex *);
double hscal_d_abs(hscaldoublereal *);
double hscal_r_abs(hscalreal *);
double hscal_z_abs(hscaldoublecomplex *);
double hscal_d_sign(hscaldoublereal *, hscaldoublereal *);
void hscal_z_div(hscaldoublecomplex *, hscaldoublecomplex *, hscaldoublecomplex *);
void hscal_c_div(hscalcomplex *c, hscalcomplex *a, hscalcomplex *b);
hscalinteger hscal_iceil(hscalinteger *inum, hscalinteger *idenom);
double hscal_f__cabs(double real, double imag);

#endif  /* __HMPI_SCALAPACK_BLAS_BUILTIN_FUNCTIONS_HH */

