
/*******************************************************************
*                                                                  *
*                     Heterogeneous ScaLAPACK CBLAS                *
*                     auxiliary information functions              *
*                 =====================================            *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_CBLAS_AUX_INFO_INCLUDE_HH
#define __HMPI_SCALAPACK_CBLAS_AUX_INFO_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       BLAS LEVEL 1
* ------------------------------------------------------------------
*/
#define hscal_srotg_info hscal_srotg
#define hscal_drotg_info hscal_drotg
#define hscal_srotmg_info hscal_srotmg
#define hscal_drotmg_info hscal_drotmg
#define hscal_srot_info hscal_srot
#define hscal_drot_info hscal_drot
#define hscal_srotm_info hscal_srotm
#define hscal_drotm_info hscal_drotm
#define hscal_sswap_info hscal_sswap
#define hscal_dswap_info hscal_dswap
#define hscal_cswap_info hscal_cswap
#define hscal_zswap_info hscal_zswap
#define hscal_sscal_info hscal_sscal
#define hscal_dscal_info hscal_dscal
#define hscal_cscal_info hscal_cscal
#define hscal_zscal_info hscal_zscal
#define hscal_csscal_info hscal_csscal
#define hscal_zdscal_info hscal_zdscal
#define hscal_scopy_info hscal_scopy
#define hscal_dcopy_info hscal_dcopy
#define hscal_ccopy_info hscal_ccopy
#define hscal_zcopy_info hscal_zcopy
#define hscal_saxpy_info hscal_saxpy
#define hscal_daxpy_info hscal_daxpy
#define hscal_caxpy_info hscal_caxpy
#define hscal_zaxpy_info hscal_zaxpy
#define hscal_sdot_info hscal_sdot
#define hscal_ddot_info hscal_ddot
#define hscal_cdotu_info hscal_cdotu
#define hscal_zdotu_info hscal_zdotu
#define hscal_cdotc_info hscal_cdotc
#define hscal_zdotc_info hscal_zdotc
#define hscal_snrm2_info hscal_snrm2
#define hscal_dnrm2_info hscal_dnrm2
#define hscal_scnrm2_info hscal_scnrm2
#define hscal_dznrm2_info hscal_dznrm2
#define hscal_sasum_info hscal_sasum
#define hscal_dasum_info hscal_dasum
#define hscal_scasum_info hscal_scasum
#define hscal_dzasum_info hscal_dzasum
#define hscal_isamax_info hscal_isamax
#define hscal_idamax_info hscal_idamax
#define hscal_icamax_info hscal_icamax
#define hscal_izamax_info hscal_izamax
 
/*
* ------------------------------------------------------------------
*       BLAS LEVEL 2
* ------------------------------------------------------------------
*/
#define hscal_sgemv_info hscal_sgemv
#define hscal_dgemv_info hscal_dgemv
#define hscal_cgemv_info hscal_cgemv
#define hscal_zgemv_info hscal_zgemv
#define hscal_sgbmv_info hscal_sgbmv
#define hscal_dgbmv_info hscal_dgbmv
#define hscal_cgbmv_info hscal_cgbmv
#define hscal_zgbmv_info hscal_zgbmv
#define hscal_chemv_info hscal_chemv
#define hscal_zhemv_info hscal_zhemv
#define hscal_chbmv_info hscal_chbmv
#define hscal_zhbmv_info hscal_zhbmv
#define hscal_chpmv_info hscal_chpmv
#define hscal_zhpmv_info hscal_zhpmv
#define hscal_ssymv_info hscal_ssymv
#define hscal_dsymv_info hscal_dsymv
#define hscal_ssbmv_info hscal_ssbmv
#define hscal_dsbmv_info hscal_dsbmv
#define hscal_sspmv_info hscal_sspmv
#define hscal_dspmv_info hscal_dspmv
#define hscal_strmv_info hscal_strmv
#define hscal_dtrmv_info hscal_dtrmv
#define hscal_ctrmv_info hscal_ctrmv
#define hscal_ztrmv_info hscal_ztrmv
#define hscal_stbmv_info hscal_stbmv
#define hscal_dtbmv_info hscal_dtbmv
#define hscal_ctbmv_info hscal_ctbmv
#define hscal_ztbmv_info hscal_ztbmv
#define hscal_stpmv_info hscal_stpmv
#define hscal_dtpmv_info hscal_dtpmv
#define hscal_ctpmv_info hscal_ctpmv
#define hscal_ztpmv_info hscal_ztpmv
#define hscal_strsv_info hscal_strsv
#define hscal_dtrsv_info hscal_dtrsv
#define hscal_ctrsv_info hscal_ctrsv
#define hscal_ztrsv_info hscal_ztrsv
#define hscal_stbsv_info hscal_stbsv
#define hscal_dtbsv_info hscal_dtbsv
#define hscal_ctbsv_info hscal_ctbsv
#define hscal_ztbsv_info hscal_ztbsv
#define hscal_stpsv_info hscal_stpsv
#define hscal_dtpsv_info hscal_dtpsv
#define hscal_ctpsv_info hscal_ctpsv
#define hscal_ztpsv_info hscal_ztpsv
#define hscal_sger_info hscal_sger
#define hscal_dger_info hscal_dger
#define hscal_cgeru_info hscal_cgeru
#define hscal_zgeru_info hscal_zgeru
#define hscal_cgerc_info hscal_cgerc
#define hscal_zgerc_info hscal_zgerc
#define hscal_cher_info hscal_cher
#define hscal_zher_info hscal_zher
#define hscal_chpr_info hscal_chpr
#define hscal_zhpr_info hscal_zhpr
#define hscal_cher2_info hscal_cher2
#define hscal_zher2_info hscal_zher2
#define hscal_chpr2_info hscal_chpr2
#define hscal_zhpr2_info hscal_zhpr2
#define hscal_ssyr_info hscal_ssyr
#define hscal_dsyr_info hscal_dsyr
#define hscal_sspr_info hscal_sspr
#define hscal_dspr_info hscal_dspr
#define hscal_ssyr2_info hscal_ssyr2
#define hscal_dsyr2_info hscal_dsyr2
#define hscal_sspr2_info hscal_sspr2
#define hscal_dspr2_info hscal_dspr2
 
/*
* ------------------------------------------------------------------
*       BLAS LEVEL 3
* ------------------------------------------------------------------
*/
#define hscal_sgemm_info hscal_sgemm
#define hscal_dgemm_info hscal_dgemm
#define hscal_cgemm_info hscal_cgemm
#define hscal_zgemm_info hscal_zgemm
#define hscal_ssymm_info hscal_ssymm
#define hscal_dsymm_info hscal_dsymm
#define hscal_csymm_info hscal_csymm
#define hscal_zsymm_info hscal_zsymm
#define hscal_chemm_info hscal_chemm
#define hscal_zhemm_info hscal_zhemm
#define hscal_ssyrk_info hscal_ssyrk
#define hscal_dsyrk_info hscal_dsyrk
#define hscal_csyrk_info hscal_csyrk
#define hscal_zsyrk_info hscal_zsyrk
#define hscal_cherk_info hscal_cherk
#define hscal_zherk_info hscal_zherk
#define hscal_ssyr2k_info hscal_ssyr2k
#define hscal_dsyr2k_info hscal_dsyr2k
#define hscal_csyr2k_info hscal_csyr2k
#define hscal_zsyr2k_info hscal_zsyr2k
#define hscal_cher2k_info hscal_cher2k
#define hscal_zher2k_info hscal_zher2k
#define hscal_strmm_info hscal_strmm
#define hscal_dtrmm_info hscal_dtrmm
#define hscal_ctrmm_info hscal_ctrmm
#define hscal_ztrmm_info hscal_ztrmm
#define hscal_strsm_info hscal_strsm
#define hscal_dtrsm_info hscal_dtrsm
#define hscal_ctrsm_info hscal_ctrsm
#define hscal_ztrsm_info hscal_ztrsm

#endif

