
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HSCALAPACK_DEBUG_HH_
#define __HSCALAPACK_DEBUG_HH_

#define  HSCAL_DATE_STR_LENGTH  128
#define  HSCAL_LOG_LENGTH       2048

enum {
   HSCAL_LOG_NONE           = 0,   /* No logging */
   HSCAL_LOG_TIMINGS        = 1,   /* Documentation comments */
   HSCAL_LOG_PERFORMANCE    = 2,   /* Performance */
   HSCAL_LOG_DEBUG          = 4,   /* Debug comments */
   HSCAL_LOG_VERBOSE        = 7,   /* Most verbose logging */
   HSCAL_LOG_TODO           = 8    /* TODO list */
};

/*
* HSCALAPACK diagnostics
*/
extern int hscal_debug_flag;

int hscal_set_debug(
    int debug_level
);

int hscal_get_debug();

void HSCAL_DEBUG(
     const char *file, const char *function, int line,
     const char *form, ...
);

void HSCAL_TODO(
     const char *file, const char *function, int line,
     const char *form, ...
);

void HSCAL_TIMINGS(
     const char *form, ...
);

#endif  /* __HSCALAPACK_DEBUG_HH_ */
