
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK Environment              *
*                 ===================================              *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_ENVIRONMENT_INCLUDE_HH
#define __HMPI_SCALAPACK_ENVIRONMENT_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       SCALAPACK Environment and Context Functions
* ------------------------------------------------------------------
*/
#define   HSCAL_HASH_ENTRIES            16

typedef struct {
    double time;        /* Estimated time to execute the routine */
    int optp;           /* Optimal process grid arrangement (process rows) */
    int optq;           /* Optimal process grid arrangement (process columns) */
    HMPI_Group *gid;    /* Handle to the HeteroMPI group of MPI processes */
} HSCALCONTEXT;

int hscal_init
(
    int *pargc,
    char*** pargv
);

int hscal_finalize(
    int exit_code
);

int hscal_in_ctxt
(
    int *ctxt
);

double hscal_timeof
(
    int *ctxt
);

int hscal_store_gid_to_ctxt_mapping
(
    int *ctxt,
    HSCALCONTEXT *hctxt
);

int hscal_free_ctxt
(
    int *ctxt
);

MPI_Comm* hscal_get_comm
(
    int *ctxt
);   

#endif  /* __HMPI_SCALAPACK_ENVIRONMENT_INCLUDE_HH */
