
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                     F2C DECLARATIONS                             *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_F2C_INCLUDE_HH
#define __HMPI_SCALAPACK_F2C_INCLUDE_HH

typedef int hscalinteger;
typedef float hscalreal;
typedef double hscaldoublereal;
typedef struct { hscalreal r, i; } hscalcomplex;
typedef struct { hscaldoublereal r, i; } hscaldoublecomplex;
typedef int hscallogical;

#define abs(x) ((x) >= 0 ? (x) : -(x))
#define dabs(x) (hscaldoublereal)abs(x)
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define dmin(a,b) (hscaldoublereal)min(a,b)
#define dmax(a,b) (hscaldoublereal)max(a,b)

#endif /* __HMPI_SCALAPACK_F2C_INCLUDE_HH */

