
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK Heuristic Functions      *
*                         (INTERNAL)                               *
*                 ===========================================      *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_HEURISTIC_FUNCTIONS_HH
#define __HMPI_SCALAPACK_HEURISTIC_FUNCTIONS_HH

/*
* ------------------------------------------------------------------
*       HeteroMPI Group create heuristic functions
* ------------------------------------------------------------------
*/
int hscal_heuristic_fn_all(
    int np, int *dp, const int *modelp, int paramc
);

int hscal_heuristic_fn_nonlinear(
    int np, int *dp, const int *modelp, int paramc
);

int hscal_heuristic_fn_linear(
    int np, int *dp, const int *modelp, int paramc
);

int hscal_heuristic_fn_square(
    int np, int *dp, const int *modelp, int paramc
);

int hscal_heuristic_fn_column(
    int np, int *dp, const int *modelp, int paramc
);

int hscal_heuristic_fn_row(
    int np, int *dp, const int *modelp, int paramc
);

int hscal_heuristic_fn_lean(
    int np, int *dp, const int *modelp, int paramc
);

int hscal_heuristic_fn_p_lt_q(
    int np, int *dp, const int *modelp, int paramc
);

int hscal_heuristic_fn_1xp(
    int np, int *dp, const int *modelp, int paramc
);

#endif /* __HMPI_SCALAPACK_HEURISTIC_FUNCTIONS_HH */
