
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                         (INTERNAL)                               *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HSCALAPACK_PAR_MPC_MACROS_HH_
#define __HSCALAPACK_PAR_MPC_MACROS_HH_

/*
* ------------------------------------------------------------------
*                      PAR HSCALAPACK MACROS
* ------------------------------------------------------------------
*/
#define    HSCAL_PRE_PAR( myrow, mycol, nprow, npcol ) \
                 { \
                    int i; \
                    for (i = 0; i < (nprow)*(npcol); i++) \
                    { \
                       tcomp_l[i] = 0; \
                    } \
                    for (i = 0; i < (nprow)*(npcol)*(nprow)*(npcol); i++) \
                    { \
                       tcomm_l[i] = 0; \
                    } \
                 } \
                 par ((myrow) = 0; (myrow) < (nprow); (myrow)++) \
                 { \
                    par ((mycol) = 0; (mycol) < (npcol); (mycol)++) \
                    {

#define    HSCAL_PRE_COMP_PAR( myrow, mycol, nprow, npcol ) \
                 { \
                    int i; \
                    for (i = 0; i < (nprow)*(npcol); i++) \
                    { \
                       tcomp_l[i] = 0; \
                    } \
                 } \
                 par ((myrow) = 0; (myrow) < (nprow); (myrow)++) \
                 { \
                    par ((mycol) = 0; (mycol) < (npcol); (mycol)++) \
                    {

#define    HSCAL_EVAL_POST_COMP( myrow, mycol, nprow, npcol ) \
                    if (TCOMPL((myrow), (mycol), (nprow), (npcol)) != 0) \
                    { \
                       (100.*TCOMPL((myrow), (mycol), (nprow), (npcol)) \
                            / \
                             TCOMP((myrow), (mycol), (nprow), (npcol)) \
                       ) \
                       %% [(myrow), (mycol)]; \
                    }

#define    HSCAL_POST_COMP_PAR( myrow, mycol, nprow, npcol ) \
                    if (TCOMPL((myrow), (mycol), (nprow), (npcol)) != 0) \
                    { \
                       (100.*TCOMPL((myrow), (mycol), (nprow), (npcol)) \
                            / \
                             TCOMP((myrow), (mycol), (nprow), (npcol)) \
                       ) \
                       %% [(myrow), (mycol)]; \
                    } \
                 } \
              }

#define    HSCAL_EVAL_POST_COMP_COMM( myrow, mycol, nprow, npcol ) \
                    if (TCOMPL((myrow), (mycol), (nprow), (npcol)) != 0) \
                    { \
                       (100.*TCOMPL((myrow), (mycol), (nprow), (npcol)) \
                            / \
                            TCOMP((myrow), (mycol), (nprow), (npcol)) \
                       ) \
                       %% [(myrow), (mycol)]; \
                    } \
                    { \
                       int i, j; \
                       for (i = 0; i < (nprow); i++) \
                       { \
                          for (j = 0; j < (npcol); j++) \
                          { \
                             if ((i != (myrow)) \
                                 && (j != (mycol)) \
                                 && (TCOMML((myrow), (mycol), i, j, (nprow), (npcol)) != 0 \
                                ) \
                             ) \
                             { \
                                (100.*TCOMML((myrow), (mycol), i, j, (nprow), (npcol)) \
                                     / \
                                      TCOMM((myrow), (mycol), i, j, (nprow), (npcol)) \
                                ) \
                                %% [(myrow), (mycol)] -> [i, j]; \
                             } \
                          } \
                       } \
                    }

#define    HSCAL_POST_COMP_COMM_PAR( myrow, mycol, nprow, npcol ) \
                    if (TCOMPL((myrow), (mycol), (nprow), (npcol)) != 0) \
                    { \
                       (100.*TCOMPL((myrow), (mycol), (nprow), (npcol)) \
                            / \
                            TCOMP((myrow), (mycol), (nprow), (npcol)) \
                       ) \
                       %% [(myrow), (mycol)]; \
                    } \
                    { \
                       int i, j; \
                       for (i = 0; i < (nprow); i++) \
                       { \
                          for (j = 0; j < (npcol); j++) \
                          { \
                             if ((i != (myrow)) \
                                 && (j != (mycol)) \
                                 && (TCOMML((myrow), (mycol), i, j, (nprow), (npcol)) != 0 \
                                ) \
                             ) \
                             { \
                                (100.*TCOMML((myrow), (mycol), i, j, (nprow), (npcol)) \
                                     / \
                                      TCOMM((myrow), (mycol), i, j, (nprow), (npcol)) \
                                ) \
                                %% [(myrow), (mycol)] -> [i, j]; \
                             } \
                          } \
                       } \
                    } \
                 } \
              }

#endif  /* __HSCALAPACK_PAR_MPC_MACROS_HH_ */

