
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK PBLAS                    *
*                     Benchmark functions                          *
*                         (INTERNAL)                               *
*                 =============================                    *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_BLAS_BENCHMARKI_INCLUDE_HH
#define __HMPI_SCALAPACK_BLAS_BENCHMARKI_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 1
* ------------------------------------------------------------------
*/
int hscal_cswap_benchmark_i(
    hscalinteger   *n,
    hscalcomplex *cx,
    hscalinteger   *incx,
    hscalcomplex *cy,
    hscalinteger   *incy
);

int hscal_dswap_benchmark_i(
    hscalinteger   *n,
    hscaldoublereal *cx,
    hscalinteger   *incx,
    hscaldoublereal *cy,
    hscalinteger   *incy
);

int hscal_sswap_benchmark_i(
    hscalinteger   *n,
    hscalreal *cx,
    hscalinteger   *incx,
    hscalreal *cy,
    hscalinteger   *incy
);

int hscal_zswap_benchmark_i(
    hscalinteger   *n,
    hscaldoublecomplex *cx,
    hscalinteger   *incx,
    hscaldoublecomplex *cy,
    hscalinteger   *incy
);

int hscal_cscal_benchmark_i(
    hscalinteger   *n,
    hscalcomplex *ca,
    hscalcomplex *cx,
    hscalinteger   *incx
);

int hscal_csscal_benchmark_i(
    hscalinteger   *n,
    hscalreal      *sa,
    hscalcomplex   *cx,
    hscalinteger   *incx
);

int hscal_dscal_benchmark_i(
    hscalinteger   *n,
    hscaldoublereal *da,
    hscaldoublereal *dx,
    hscalinteger   *incx
);

int hscal_sscal_benchmark_i(
    hscalinteger   *n,
    hscalreal *sa,
    hscalreal *sx,
    hscalinteger   *incx
);

int hscal_zscal_benchmark_i(
    hscalinteger   *n,
    hscaldoublecomplex *za,
    hscaldoublecomplex *zx,
    hscalinteger   *incx
);

int hscal_zdscal_benchmark_i(
    hscalinteger       *n,
    hscaldoublereal    *da,
    hscaldoublecomplex *zx,
    hscalinteger       *incx
);

int hscal_ccopy_benchmark_i(
    hscalinteger   *n,
    hscalcomplex *cx,
    hscalinteger   *incx,
    hscalcomplex *cy,
    hscalinteger   *incy
);

int hscal_dcopy_benchmark_i(
    hscalinteger   *n,
    hscaldoublereal *dx,
    hscalinteger   *incx,
    hscaldoublereal *dy,
    hscalinteger   *incy
);

int hscal_icopy_benchmark_i(
    hscalinteger   *n,
    int       *cx,
    hscalinteger   *incx,
    int       *cy,
    hscalinteger   *incy
);

int hscal_scopy_benchmark_i(
    hscalinteger   *n,
    hscalreal *sx,
    hscalinteger   *incx,
    hscalreal *sy,
    hscalinteger   *incy
);

int hscal_zcopy_benchmark_i(
    hscalinteger   *n,
    hscaldoublecomplex *zx,
    hscalinteger   *incx,
    hscaldoublecomplex *zy,
    hscalinteger   *incy
);

int hscal_caxpy_benchmark_i(
    hscalinteger   *n,
    hscalcomplex *ca,
    hscalcomplex *cx,
    hscalinteger   *incx,
    hscalcomplex *cy,
    hscalinteger   *incy
);

int hscal_daxpy_benchmark_i(
    hscalinteger   *n,
    hscaldoublereal *da,
    hscaldoublereal *dx,
    hscalinteger   *incx,
    hscaldoublereal *dy,
    hscalinteger   *incy
);

int hscal_saxpy_benchmark_i(
    hscalinteger   *n,
    hscalreal *sa,
    hscalreal *sx,
    hscalinteger   *incx,
    hscalreal *sy,
    hscalinteger   *incy
);

int hscal_zaxpy_benchmark_i(
    hscalinteger   *n,
    hscaldoublecomplex *za,
    hscaldoublecomplex *zx,
    hscalinteger   *incx,
    hscaldoublecomplex *zy,
    hscalinteger   *incy
);

int       hscal_icamax_benchmark_i(
        hscalinteger   *n,
        hscalcomplex *cx,
        hscalinteger   *incx
);

int       hscal_idamax_benchmark_i(
        hscalinteger   *n,
        hscaldoublereal *dx,
        hscalinteger   *incx
);

int       hscal_isamax_benchmark_i(
        hscalinteger   *n,
        hscalreal    *sx,
        hscalinteger   *incx
);

int       hscal_izamax_benchmark_i(
        hscalinteger         *n,
        hscaldoublecomplex *zx,
        hscalinteger         *incx
);

hscaldoublereal hscal_dasum_benchmark_i(
           hscalinteger   *n,
           hscaldoublereal *dx,
           hscalinteger   *incx
);

hscaldoublereal hscal_scasum_benchmark_i(
           hscalinteger   *n,
           hscalcomplex *cx,
           hscalinteger   *incx
);

hscaldoublereal hscal_dzasum_benchmark_i(
           hscalinteger   *n,
           hscaldoublecomplex *zx,
           hscalinteger   *incx
);

hscaldoublereal hscal_sasum_benchmark_i(
           hscalinteger   *n,
           hscalreal    *sx,
           hscalinteger   *incx
);

hscaldoublereal hscal_dnrm2_benchmark_i(
           hscalinteger   *n,
           hscaldoublereal *x,
           hscalinteger   *incx
);

hscaldoublereal hscal_scnrm2_benchmark_i(
           hscalinteger   *n,
           hscalcomplex *x,
           hscalinteger   *incx
);

hscaldoublereal hscal_dznrm2_benchmark_i(
           hscalinteger   *n,
           hscaldoublecomplex *x,
           hscalinteger   *incx
);

hscaldoublereal hscal_snrm2_benchmark_i(
           hscalinteger   *n,
           hscalreal *x,
           hscalinteger   *incx
);

hscaldoublereal hscal_ddot_benchmark_i(
           hscalinteger      *n,
           hscaldoublereal *dx,
           hscalinteger      *incx,
           hscaldoublereal *dy,
           hscalinteger      *incy
);

hscaldoublereal hscal_sdot_benchmark_i(
           hscalinteger   *n,
           hscalreal    *sx,
           hscalinteger   *incx,
           hscalreal    *sy,
           hscalinteger   *incy
);

void hscal_cdotc_benchmark_i(
     hscalcomplex * ret_val,
     hscalinteger   *n,
     hscalcomplex *cx,
     hscalinteger   *incx,
     hscalcomplex *cy,
     hscalinteger   *incy
);

void hscal_cdotu_benchmark_i(
     hscalcomplex * ret_val,
     hscalinteger   * n,
     hscalcomplex * cx,
     hscalinteger   * incx,
     hscalcomplex * cy,
     hscalinteger   * incy
);

void hscal_zdotc_benchmark_i(
     hscaldoublecomplex * ret_val,
     hscalinteger         * n,
     hscaldoublecomplex * zx,
     hscalinteger         * incx,
     hscaldoublecomplex * zy,
     hscalinteger         * incy
);

void hscal_zdotu_benchmark_i(
     hscaldoublecomplex * ret_val,
     hscalinteger         * n,
     hscaldoublecomplex * zx,
     hscalinteger         * incx,
     hscaldoublecomplex * zy,
     hscalinteger         * incy
);

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 2
* ------------------------------------------------------------------
*/
int hscal_cgemv_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *x,
    hscalinteger   *incx,
    hscalcomplex *beta,
    hscalcomplex *y,
    hscalinteger   *incy
);

int hscal_dgemv_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal * alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *x,
    hscalinteger   *incx,
    hscaldoublereal *beta,
    hscaldoublereal *y,
    hscalinteger   *incy
);

int hscal_sgemv_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *x,
    hscalinteger   *incx,
    hscalreal *beta,
    hscalreal *y,
    hscalinteger   *incy
);

int hscal_zgemv_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *x,
    hscalinteger   *incx,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *y,
    hscalinteger   *incy
);

int hscal_cagemv_benchmark_i(
    char    *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal    *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *x,
    hscalinteger   *incx,
    hscalreal    *beta,
    hscalreal    *y,
    hscalinteger   *incy
);

int hscal_dagemv_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal * alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *x,
    hscalinteger   *incx,
    hscaldoublereal *beta,
    hscaldoublereal *y,
    hscalinteger   *incy
);

int hscal_sagemv_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *x,
    hscalinteger   *incx,
    hscalreal *beta,
    hscalreal *y,
    hscalinteger   *incy
);

int hscal_zagemv_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *x,
    hscalinteger   *incx,
    hscaldoublereal *beta,
    hscaldoublereal *y,
    hscalinteger   *incy
);

int hscal_dsymv_benchmark_i(
    char *uplo,
    hscalinteger   *n,
    hscaldoublereal * alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *x,
    hscalinteger   *incx,
    hscaldoublereal *beta,
    hscaldoublereal *y,
    hscalinteger   *incy
);

int hscal_ssymv_benchmark_i(
    char *uplo,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *x,
    hscalinteger   *incx,
    hscalreal *beta,
    hscalreal *y,
    hscalinteger   *incy
);

int hscal_zhemv_benchmark_i(
    char *uplo,
    hscalinteger   *n,
    hscaldoublecomplex * alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *x,
    hscalinteger   *incx,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *y,
    hscalinteger   *incy
);

int hscal_chemv_benchmark_i(
    char *uplo,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *x,
    hscalinteger   *incx,
    hscalcomplex *beta,
    hscalcomplex *y,
    hscalinteger   *incy
);

int hscal_zahemv_benchmark_i(
    char *uplo,
    hscalinteger   *n,
    hscaldoublereal * alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *x,
    hscalinteger   *incx,
    hscaldoublereal *beta,
    hscaldoublereal *y,
    hscalinteger   *incy
);

int hscal_cahemv_benchmark_i(
    char *trans,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *x,
    hscalinteger   *incx,
    hscalreal *beta,
    hscalreal *y,
    hscalinteger   *incy
);

int hscal_dasymv_benchmark_i(
    char *uplo,
    hscalinteger   *n,
    hscaldoublereal * alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *x,
    hscalinteger   *incx,
    hscaldoublereal *beta,
    hscaldoublereal *y,
    hscalinteger   *incy
);

int hscal_sasymv_benchmark_i(
    char *uplo,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *x,
    hscalinteger   *incx,
    hscalreal *beta,
    hscalreal *y,
    hscalinteger   *incy
);

int hscal_ctrmv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *x,
    hscalinteger   *incx
);

int hscal_dtrmv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *x,
    hscalinteger   *incx
);

int hscal_strmv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *x,
    hscalinteger   *incx
);

int hscal_ztrmv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *x,
    hscalinteger   *incx
);

int hscal_catrmv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscalreal * alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *x,
    hscalinteger   *incx,
    hscalreal *beta,
    hscalreal *y,
    hscalinteger   *incy
);

int hscal_satrmv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscalreal * alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *x,
    hscalinteger   *incx,
    hscalreal *beta,
    hscalreal *y,
    hscalinteger   *incy
);

int hscal_datrmv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    double * alpha,
    double *a,
    hscalinteger   *lda,
    double *x,
    hscalinteger   *incx,
    double *beta,
    double *y,
    hscalinteger   *incy
);

int hscal_zatrmv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    double * alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *x,
    hscalinteger   *incx,
    double *beta,
    double *y,
    hscalinteger   *incy
);

int hscal_ctrsv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *x,
    hscalinteger   *incx
);

int hscal_dtrsv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *x,
    hscalinteger   *incx
);

int hscal_strsv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *x,
    hscalinteger   *incx
);

int hscal_ztrsv_benchmark_i(
    char *uplo,
    char *trans,
    char *diag,
    hscalinteger   *n,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *x,
    hscalinteger   *incx
);

int hscal_sger_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *x,
    hscalinteger   *incx,
    hscalreal *y,
    hscalinteger   *incy,
    hscalreal *a,
    hscalinteger   *lda
);

int hscal_dger_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal *alpha,
    hscaldoublereal *x,
    hscalinteger   *incx,
    hscaldoublereal *y,
    hscalinteger   *incy,
    hscaldoublereal *a,
    hscalinteger   *lda
);

int hscal_cgerc_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *x,
    hscalinteger   *incx,
    hscalcomplex *y,
    hscalinteger   *incy,
    hscalcomplex *a,
    hscalinteger   *lda
);

int hscal_zgerc_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *x,
    hscalinteger   *incx,
    hscaldoublecomplex *y,
    hscalinteger   *incy,
    hscaldoublecomplex *a,
    hscalinteger   *lda
);

int hscal_cgeru_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *x,
    hscalinteger   *incx,
    hscalcomplex *y,
    hscalinteger   *incy,
    hscalcomplex *a,
    hscalinteger   *lda
);

int hscal_zgeru_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *x,
    hscalinteger   *incx,
    hscaldoublecomplex *y,
    hscalinteger   *incy,
    hscaldoublecomplex *a,
    hscalinteger   *lda
);

int hscal_cher_benchmark_i(
    char    *uplo,
    hscalinteger   *n,
    hscalreal    *alpha,
    hscalcomplex *x,
    hscalinteger   *incx,
    hscalcomplex *a,
    hscalinteger   *lda
);

int hscal_zher_benchmark_i(
    char          *uplo,
    hscalinteger         *n,
    hscaldoublereal    *alpha,
    hscaldoublecomplex *x,
    hscalinteger         *incx,
    hscaldoublecomplex *a,
    hscalinteger         *lda
);

int hscal_cher2_benchmark_i(
    char    *uplo,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *x,
    hscalinteger   *incx,
    hscalcomplex *y,
    hscalinteger   *incy,
    hscalcomplex *a,
    hscalinteger   *lda
);

int hscal_zher2_benchmark_i(
    char          *uplo,
    hscalinteger         *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *x,
    hscalinteger         *incx,
    hscaldoublecomplex *y,
    hscalinteger         *incy,
    hscaldoublecomplex *a,
    hscalinteger         *lda
);

int hscal_ssyr_benchmark_i(
    char    *uplo,
    hscalinteger   *n,
    hscalreal    *alpha,
    hscalreal    *x,
    hscalinteger   *incx,
    hscalreal    *a,
    hscalinteger   *lda
);

int hscal_dsyr_benchmark_i(
    char       *uplo,
    hscalinteger      *n,
    hscaldoublereal *alpha,
    hscaldoublereal *x,
    hscalinteger      *incx,
    hscaldoublereal *a,
    hscalinteger      *lda
);

int hscal_ssyr2_benchmark_i(
    char    *uplo,
    hscalinteger   *n,
    hscalreal    *alpha,
    hscalreal    *x,
    hscalinteger   *incx,
    hscalreal    *y,
    hscalinteger   *incy,
    hscalreal    *a,
    hscalinteger   *lda
);

int hscal_dsyr2_benchmark_i(
    char       *uplo,
    hscalinteger      *n,
    hscaldoublereal *alpha,
    hscaldoublereal *x,
    hscalinteger      *incx,
    hscaldoublereal *y,
    hscalinteger      *incy,
    hscaldoublereal *a,
    hscalinteger      *lda
);

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 3
* ------------------------------------------------------------------
*/
int hscal_cherk_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *n,
    hscalinteger   *k,
    hscalreal *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalreal *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_zherk_benchmark_i(
    char          *uplo,
    char          *trans,
    hscalinteger         *n,
    hscalinteger         *k,
    hscaldoublereal    *alpha,
    hscaldoublecomplex *a,
    hscalinteger         *lda,
    hscaldoublereal    *beta,
    hscaldoublecomplex *c__,
    hscalinteger         *ldc
);

int hscal_csyrk_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *n,
    hscalinteger   *k,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_zsyrk_benchmark_i(
    char          *uplo,
    char          *trans,
    hscalinteger         *n,
    hscalinteger         *k,
    hscaldoublecomplex    *alpha,
    hscaldoublecomplex *a,
    hscalinteger         *lda,
    hscaldoublecomplex    *beta,
    hscaldoublecomplex *c__,
    hscalinteger         *ldc
);

int hscal_ssyrk_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *n,
    hscalinteger   *k,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *beta,
    hscalreal *c__,
    hscalinteger   *ldc
);

int hscal_dsyrk_benchmark_i(
    char          *uplo,
    char          *trans,
    hscalinteger         *n,
    hscalinteger         *k,
    hscaldoublereal    *alpha,
    hscaldoublereal    *a,
    hscalinteger         *lda,
    hscaldoublereal    *beta,
    hscaldoublereal    *c__,
    hscalinteger         *ldc
);

int hscal_cher2k_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *n,
    hscalinteger   *k,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *b,
    hscalinteger   *ldb,
    hscalreal *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_zher2k_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *n,
    hscalinteger   *k,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *b,
    hscalinteger   *ldb,
    hscaldoublereal *beta,
    hscaldoublecomplex *c__,
    hscalinteger   *ldc
);

int hscal_csyr2k_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *n,
    hscalinteger   *k,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *b,
    hscalinteger   *ldb,
    hscalcomplex *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_zsyr2k_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *n,
    hscalinteger   *k,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *b,
    hscalinteger   *ldb,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    hscalinteger   *ldc
);

int hscal_ssyr2k_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *n,
    hscalinteger   *k,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *b,
    hscalinteger   *ldb,
    hscalreal *beta,
    hscalreal *c__,
    hscalinteger   *ldc
);

int hscal_dsyr2k_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *n,
    hscalinteger   *k,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *b,
    hscalinteger   *ldb,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    hscalinteger   *ldc
);

int hscal_chemm_benchmark_i(
    char    *side,
    char    *uplo,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *b,
    hscalinteger   *ldb,
    hscalcomplex *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_zhemm_benchmark_i(
    char    *side,
    char    *uplo,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *b,
    hscalinteger   *ldb,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    hscalinteger   *ldc
);

int hscal_csymm_benchmark_i(
    char    *side,
    char    *uplo,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *b,
    hscalinteger   *ldb,
    hscalcomplex *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_dsymm_benchmark_i(
    char    *side,
    char    *uplo,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *b,
    hscalinteger   *ldb,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    hscalinteger   *ldc
);

int hscal_ssymm_benchmark_i(
    char    *side,
    char    *uplo,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *b,
    hscalinteger   *ldb,
    hscalreal *beta,
    hscalreal *c__,
    hscalinteger   *ldc
);

int hscal_zsymm_benchmark_i(
    char    *side,
    char    *uplo,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *b,
    hscalinteger   *ldb,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    hscalinteger   *ldc
);

int hscal_ctranc_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_ztranc_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    hscalinteger   *ldc
);

int hscal_ctranu_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_ztranu_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    hscalinteger   *ldc
);

int hscal_stran_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *beta,
    hscalreal *c__,
    hscalinteger   *ldc
);

int hscal_dtran_benchmark_i(
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    hscalinteger   *ldc
);

int hscal_ctrmm_benchmark_i(
    char    *side,
    char    *uplo,
    char    *transa,
    char    *diag,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *b,
    hscalinteger   *ldb
);

int hscal_strmm_benchmark_i(
    char    *side,
    char    *uplo,
    char    *transa,
    char    *diag,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *b,
    hscalinteger   *ldb
);

int hscal_dtrmm_benchmark_i(
    char    *side,
    char    *uplo,
    char    *transa,
    char    *diag,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *b,
    hscalinteger   *ldb
);

int hscal_ztrmm_benchmark_i(
    char    *side,
    char    *uplo,
    char    *transa,
    char    *diag,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *b,
    hscalinteger   *ldb
);

int hscal_cgemm_benchmark_i(
    char *transa,
    char *transb,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalinteger   *k,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *b,
    hscalinteger   *ldb,
    hscalcomplex *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_dgemm_benchmark_i(
    char *transa,
    char *transb,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalinteger   *k,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *b,
    hscalinteger   *ldb,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    hscalinteger   *ldc
);

int hscal_sgemm_benchmark_i(
    char *transa,
    char *transb,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalinteger   *k,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *b,
    hscalinteger   *ldb,
    hscalreal *beta,
    hscalreal *c__,
    hscalinteger   *ldc
);

int hscal_zgemm_benchmark_i(
    char *transa,
    char *transb,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalinteger   *k,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *b,
    hscalinteger   *ldb,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    hscalinteger   *ldc
);

int hscal_ctradd_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_dtradd_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    hscalinteger   *ldc
);

int hscal_stradd_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *beta,
    hscalreal *c__,
    hscalinteger   *ldc
);

int hscal_ztradd_benchmark_i(
    char *uplo,
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    hscalinteger   *ldc
);

int hscal_cgeadd_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *beta,
    hscalcomplex *c__,
    hscalinteger   *ldc
);

int hscal_dgeadd_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *beta,
    hscaldoublereal *c__,
    hscalinteger   *ldc
);

int hscal_sgeadd_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *beta,
    hscalreal *c__,
    hscalinteger   *ldc
);

int hscal_zgeadd_benchmark_i(
    char *trans,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    hscalinteger   *ldc
);

int hscal_ctrsm_benchmark_i(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    hscalinteger   *lda,
    hscalcomplex *b,
    hscalinteger   *ldb
);

int hscal_dtrsm_benchmark_i(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublereal *alpha,
    hscaldoublereal *a,
    hscalinteger   *lda,
    hscaldoublereal *b,
    hscalinteger   *ldb
);

int hscal_strsm_benchmark_i(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    hscalinteger   *m,
    hscalinteger   *n,
    hscalreal *alpha,
    hscalreal *a,
    hscalinteger   *lda,
    hscalreal *b,
    hscalinteger   *ldb
);

int hscal_ztrsm_benchmark_i(
    char *side,
    char *uplo,
    char *transa,
    char *diag,
    hscalinteger   *m,
    hscalinteger   *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    hscalinteger   *lda,
    hscaldoublecomplex *b,
    hscalinteger   *ldb
);

#endif /* __HMPI_SCALAPACK_BLAS_BENCHMARKI_INCLUDE_HH */
 
