
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK PBLAS                    *
*                      CONTEXT  API                                *
*                 =============================                    *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_PBLAS_CONTEXT_API_INCLUDE_HH
#define __HMPI_SCALAPACK_PBLAS_CONTEXT_API_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       Heterogeneous PBLAS LEVEL 1
* ------------------------------------------------------------------
*/

/*
*  pcswap
*/
int hscal_pcswap_ctxt(
   int   * N, 
   int   * IX, 
   int   * JX, 
   int   * DESCX, 
   int   * INCX,
   int   * IY, 
   int   * JY, 
   int   * DESCY, 
   int   * INCY,
   int   * ICTXT
);

/*
*  pdswap
*/
int hscal_pdswap_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
*  psswap
*/
int hscal_psswap_ctxt(
   int   * N,
   int   * IX,
   int   * JX,
   int   * DESCX,
   int   * INCX,
   int   * IY,
   int   * JY,
   int   * DESCY,
   int   * INCY,
   int   * ICTXT
);

/*
*  pzswap
*/
int hscal_pzswap_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* pcscal
*/
int hscal_pcscal_ctxt(
   int   * N, 
   float * ALPHA,
   int   * IX, 
   int   * JX, 
   int   * DESCX, 
   int   * INCX,
   int   * ICTXT
);

/*
* pcsscal
*/
int hscal_pcsscal_ctxt(
   int   * N, 
   float * ALPHA,
   int   * IX, 
   int   * JX, 
   int   * DESCX, 
   int   * INCX,
   int   * ICTXT
);

/*
* pdscal
*/
int hscal_pdscal_ctxt(
   int    * N, 
   double * ALPHA,
   int    * IX, 
   int    * JX, 
   int    * DESCX, 
   int    * INCX,
   int    * ICTXT
);

/*
* pdzscal
*/
int hscal_pzdscal_ctxt(
   int    * N, 
   double * ALPHA,
   int    * IX, 
   int    * JX, 
   int    * DESCX, 
   int    * INCX,
   int    * ICTXT
);

/*
* psscal
*/
int hscal_psscal_ctxt(
   int   * N, 
   float * ALPHA,
   int   * IX, 
   int   * JX, 
   int   * DESCX, 
   int   * INCX,
   int   * ICTXT
);

/*
* pzscal
*/
int hscal_pzscal_ctxt(
   int    * N,
   double * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * ICTXT
);

/*
* picopy
*/
int hscal_picopy_ctxt(
   int   * N, 
   int   * IX, 
   int   * JX, 
   int   * DESCX, 
   int   * INCX,
   int   * IY, 
   int   * JY, 
   int   * DESCY, 
   int   * INCY,
   int   * ICTXT
);

/*
* pccopy
*/
int hscal_pccopy_ctxt(
   int   * N, 
   int   * IX, 
   int   * JX, 
   int   * DESCX, 
   int   * INCX,
   int   * IY, 
   int   * JY, 
   int   * DESCY, 
   int   * INCY,
   int   * ICTXT
);

/*
* pdcopy
*/
int hscal_pdcopy_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* pscopy
*/
int hscal_pscopy_ctxt(
   int   * N,
   int   * IX,
   int   * JX,
   int   * DESCX,
   int   * INCX,
   int   * IY,
   int   * JY,
   int   * DESCY,
   int   * INCY,
   int   * ICTXT
);

/*
* pzcopy
*/
int hscal_pzcopy_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* pcaxpy
*/
int hscal_pcaxpy_ctxt(
   int   * N, 
   float * ALPHA,
   int   * IX, 
   int   * JX, 
   int   * DESCX, 
   int   * INCX,
   int   * IY, 
   int   * JY, 
   int   * DESCY, 
   int   * INCY,
   int   * ICTXT
);

/*
* pdaxpy
*/
int hscal_pdaxpy_ctxt(
   int    * N, 
   double * ALPHA,
   int    * IX, 
   int    * JX, 
   int    * DESCX, 
   int    * INCX,
   int    * IY, 
   int    * JY, 
   int    * DESCY, 
   int    * INCY,
   int    * ICTXT
);

/*
* psaxpy
*/
int hscal_psaxpy_ctxt(
   int   * N,
   float * ALPHA,
   int   * IX,
   int   * JX,
   int   * DESCX,
   int   * INCX,
   int   * IY,
   int   * JY,
   int   * DESCY,
   int   * INCY,
   int   * ICTXT
);

/*
* pzaxpy
*/
int hscal_pzaxpy_ctxt(
   int    * N,
   double * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* pcamax
*/
int hscal_pcamax_ctxt(
   int   * N,
   int   * IX,
   int   * JX,
   int   * DESCX,
   int   * INCX,
   int   * ICTXT
);

/*
* pdamax
*/
int hscal_pdamax_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * ICTXT
);

/*
* psamax
*/
int hscal_psamax_ctxt(
   int   * N,
   int   * IX,
   int   * JX,
   int   * DESCX,
   int   * INCX,
   int   * ICTXT
);

/*
* pzamax
*/
int hscal_pzamax_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * ICTXT
);

/*
* pdasum
*/
int hscal_pdasum_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * ICTXT
);

/*
* pscasum
*/
int hscal_pscasum_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * ICTXT
);

/*
* pdzasum
*/
int hscal_pdzasum_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * ICTXT
);

/*
* psasum
*/
int hscal_psasum_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * ICTXT
);

/*
* pdnrm2
*/
int hscal_pdnrm2_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * ICTXT
);

/*
* pscnrm2
*/
int hscal_pscnrm2_ctxt(
   int   * N,
   int   * IX,
   int   * JX,
   int   * DESCX,
   int   * INCX,
   int   * ICTXT
);

/*
* pdznrm2
*/
int hscal_pdznrm2_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * ICTXT
);

/*
* psnrm2
*/
int hscal_psnrm2_ctxt(
   int   * N,
   int   * IX,
   int   * JX,
   int   * DESCX,
   int   * INCX,
   int   * ICTXT
);

/*
* pddot
*/
int hscal_pddot_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* psdot
*/
int hscal_psdot_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* pcdotc
*/
int hscal_pcdotc_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* pcdotu
*/
int hscal_pcdotu_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* pzdotc
*/
int hscal_pzdotc_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* pzdotu
*/
int hscal_pzdotu_ctxt(
   int    * N,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * ICTXT
);

/*
* ------------------------------------------------------------------
*       Heterogeneous PBLAS LEVEL 2
* ------------------------------------------------------------------
*/
/*
*  pcgemv
*/
int hscal_pcgemv_ctxt(
   F_CHAR_T TRANS,
   int      * M,
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pdgemv
*/
int hscal_pdgemv_ctxt(
   F_CHAR_T TRANS,
   int      * M,
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  psgemv
*/
int hscal_psgemv_ctxt(
   F_CHAR_T TRANS,
   int      * M,
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pzgemv
*/
int hscal_pzgemv_ctxt(
   F_CHAR_T TRANS,
   int      * M,
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pcagemv
*/
int hscal_pcagemv_ctxt(
   F_CHAR_T TRANS,
   int      * M,
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pdagemv
*/
int hscal_pdagemv_ctxt(
   F_CHAR_T TRANS,
   int      * M,
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  psagemv
*/
int hscal_psagemv_ctxt(
   F_CHAR_T TRANS,
   int      * M,
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pzagemv
*/
int hscal_pzagemv_ctxt(
   F_CHAR_T TRANS,
   int      * M,
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pdsymv
*/
int hscal_pdsymv_ctxt(
   F_CHAR_T UPLO,
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pssymv
*/
int hscal_pssymv_ctxt(
   F_CHAR_T UPLO,
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pdasymv
*/
int hscal_pdasymv_ctxt(
   F_CHAR_T UPLO,
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  psasymv
*/
int hscal_psasymv_ctxt(
   F_CHAR_T UPLO,
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pchemv
*/
int hscal_pchemv_ctxt(
   F_CHAR_T UPLO, 
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pzhemv
*/
int hscal_pzhemv_ctxt(
   F_CHAR_T UPLO, 
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pcahemv
*/
int hscal_pcahemv_ctxt(
   F_CHAR_T UPLO, 
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pzahemv
*/
int hscal_pzahemv_ctxt(
   F_CHAR_T UPLO, 
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pctrmv
*/
int hscal_pctrmv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * ICTXT
);

/*
*  pdtrmv
*/
int hscal_pdtrmv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * ICTXT
);

/*
*  pstrmv
*/
int hscal_pstrmv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * ICTXT
);

/*
*  pztrmv
*/
int hscal_pztrmv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * ICTXT
);

/*
*  pcatrmv
*/
int hscal_pcatrmv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pdatrmv
*/
int hscal_pdatrmv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  psatrmv
*/
int hscal_psatrmv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   float    * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   float    * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pzatrmv
*/
int hscal_pzatrmv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   double   * ALPHA,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   double   * BETA,
   int      * IY,
   int      * JY,
   int      * DESCY,
   int      * INCY,
   int      * ICTXT
);

/*
*  pctrsv
*/
int hscal_pctrsv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * ICTXT
);

/*
*  pdtrsv
*/
int hscal_pdtrsv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * ICTXT
);

/*
*  pstrsv
*/
int hscal_pstrsv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * ICTXT
);

/*
*  pztrsv
*/
int hscal_pztrsv_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int      * N,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * ICTXT
);

/*
* pdger
*/
int hscal_pdger_ctxt(
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* psger
*/
int hscal_psger_ctxt(
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pcgerc
*/
int hscal_pcgerc_ctxt(
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pcgeru
*/
int hscal_pcgeru_ctxt(
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pzgerc
*/
int hscal_pzgerc_ctxt(
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pzgeru
*/
int hscal_pzgeru_ctxt(
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pcher
*/
int hscal_pcher_ctxt(
   F_CHAR_T UPLO,
   int      * N,
   float    * ALPHA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * ICTXT
);

/*
* pzher
*/
int hscal_pzher_ctxt(
   F_CHAR_T UPLO,
   int      * N,
   double   * ALPHA,
   int      * IX,
   int      * JX,
   int      * DESCX,
   int      * INCX,
   int      * IA,
   int      * JA,
   int      * DESCA,
   int      * ICTXT
);

/*
* pdsyr
*/
int hscal_pdsyr_ctxt(
   F_CHAR_T UPLO,
   int    * N,
   double * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pssyr
*/
int hscal_pssyr_ctxt(
   F_CHAR_T UPLO,
   int    * N,
   float  * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pdsyr2
*/
int hscal_pdsyr2_ctxt(
   F_CHAR_T UPLO,
   int    * N,
   double * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pssyr2
*/
int hscal_pssyr2_ctxt(
   F_CHAR_T UPLO,
   int    * N,
   float  * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pcher2
*/
int hscal_pcher2_ctxt(
   F_CHAR_T UPLO,
   int    * N,
   float  * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* pzher2
*/
int hscal_pzher2_ctxt(
   F_CHAR_T UPLO,
   int    * N,
   double * ALPHA,
   int    * IX,
   int    * JX,
   int    * DESCX,
   int    * INCX,
   int    * IY,
   int    * JY,
   int    * DESCY,
   int    * INCY,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * ICTXT
);

/*
* ------------------------------------------------------------------
*       Heterogeneous PBLAS LEVEL 3
* ------------------------------------------------------------------
*/
/*
* pcherk
*/
int hscal_pcherk_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pzherk
*/
int hscal_pzherk_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pcsyrk
*/
int hscal_pcsyrk_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pdsyrk
*/
int hscal_pdsyrk_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pssyrk
*/
int hscal_pssyrk_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pzsyrk
*/
int hscal_pzsyrk_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pcher2k
*/
int hscal_pcher2k_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pzher2k
*/
int hscal_pzher2k_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pcsyr2k
*/
int hscal_pcsyr2k_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pdsyr2k
*/
int hscal_pdsyr2k_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pssyr2k
*/
int hscal_pssyr2k_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pzsyr2k
*/
int hscal_pzsyr2k_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * N,
   int    * K,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pchemm
*/
int hscal_pchemm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pzhemm
*/
int hscal_pzhemm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pcsymm
*/
int hscal_pcsymm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pdsymm
*/
int hscal_pdsymm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pssymm
*/
int hscal_pssymm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pzsymm
*/
int hscal_pzsymm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pctranc
*/
int hscal_pctranc_ctxt(
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pztranc
*/
int hscal_pztranc_ctxt(
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pctranu
*/
int hscal_pctranu_ctxt(
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pztranu
*/
int hscal_pztranu_ctxt(
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pstran
*/
int hscal_pstran_ctxt(
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pdtran
*/
int hscal_pdtran_ctxt(
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pctrmm
*/
int hscal_pctrmm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pdtrmm
*/
int hscal_pdtrmm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pstrmm
*/
int hscal_pstrmm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pztrmm
*/
int hscal_pztrmm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pcgemm
*/
int hscal_pcgemm_ctxt(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int    * M,
   int    * N,
   int    * K,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pdgemm
*/
int hscal_pdgemm_ctxt(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int    * M,
   int    * N,
   int    * K,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* psgemm
*/
int hscal_psgemm_ctxt(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int    * M,
   int    * N,
   int    * K,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   float  * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pzgemm
*/
int hscal_pzgemm_ctxt(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int    * M,
   int    * N,
   int    * K,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pctrsm
*/
int hscal_pctrsm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pdtrsm
*/
int hscal_pdtrsm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pstrsm
*/
int hscal_pstrsm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int    * M,
   int    * N,
   float  * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pztrsm
*/
int hscal_pztrsm_ctxt(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   int    * IB,
   int    * JB,
   int    * DESCB,
   int    * ICTXT
);

/*
* pctradd
*/
int hscal_pctradd_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int   * M,
   int   * N,
   float * ALPHA,
   int   * IA,
   int   * JA,
   int   * DESCA,
   float * BETA,
   int   * IC,
   int   * JC,
   int   * DESCC,
   int   * ICTXT
);

/*
* pdtradd
*/
int hscal_pdtradd_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pstradd
*/
int hscal_pstradd_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int   * M,
   int   * N,
   float * ALPHA,
   int   * IA,
   int   * JA,
   int   * DESCA,
   float * BETA,
   int   * IC,
   int   * JC,
   int   * DESCC,
   int   * ICTXT
);

/*
* pztradd
*/
int hscal_pztradd_ctxt(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* pcgeadd
*/
int hscal_pcgeadd_ctxt(
   F_CHAR_T TRANS,
   int   * M,
   int   * N,
   float * ALPHA,
   int   * IA,
   int   * JA,
   int   * DESCA,
   float * BETA,
   int   * IC,
   int   * JC,
   int   * DESCC,
   int   * ICTXT
);

/*
* pdgeadd
*/
int hscal_pdgeadd_ctxt(
   F_CHAR_T TRANS,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

/*
* psgeadd
*/
int hscal_psgeadd_ctxt(
   F_CHAR_T TRANS,
   int   * M,
   int   * N,
   float * ALPHA,
   int   * IA,
   int   * JA,
   int   * DESCA,
   float * BETA,
   int   * IC,
   int   * JC,
   int   * DESCC,
   int   * ICTXT
);

/*
* pzgeadd
*/
int hscal_pzgeadd_ctxt(
   F_CHAR_T TRANS,
   int    * M,
   int    * N,
   double * ALPHA,
   int    * IA,
   int    * JA,
   int    * DESCA,
   double * BETA,
   int    * IC,
   int    * JC,
   int    * DESCC,
   int    * ICTXT
);

#endif /* __HMPI_SCALAPACK_PBLAS_CONTEXT_API_INCLUDE_HH */

