
/*******************************************************************
*                                                                  *
*                     Heterogeneous ScaLAPACK PBLAS                *
*                     auxiliary information functions              *
*                 =====================================            *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_PBLAS_AUX_INFO_INCLUDE_HH
#define __HMPI_SCALAPACK_PBLAS_AUX_INFO_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 1
* ------------------------------------------------------------------
*/
/*
*  pcswap
*/
int hscal_pcswap_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pdswap
*/
int hscal_pdswap_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  psswap
*/
int hscal_psswap_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pzswap
*/
int hscal_pzswap_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* PCSCAL
*/
int hscal_pcscal_info(
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp
);

/*
* pcsscal
*/
int hscal_pcsscal_info(
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp
);

/*
* pdscal
*/
int hscal_pdscal_info(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp
);

/*
* psscal
*/
int hscal_psscal_info(
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp
);

/*
* pzscal
*/
int hscal_pzscal_info(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp
);

/*
* pzdscal
*/
int hscal_pzdscal_info(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp
);

/*
* pccopy
*/
int hscal_pccopy_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);


/*
* pdcopy
*/
int hscal_pdcopy_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pscopy
*/
int hscal_pscopy_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzcopy
*/
int hscal_pzcopy_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* picopy
*/
int hscal_picopy_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcaxpy
*/
int hscal_pcaxpy_info(
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdaxpy
*/
int hscal_pdaxpy_info(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* psaxpy
*/
int hscal_psaxpy_info(
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzaxpy
*/
int hscal_pzaxpy_info(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcamax
*/
int hscal_pcamax_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdamax
*/
int hscal_pdamax_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* psamax
*/
int hscal_psamax_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);


/*
* pzamax
*/
int hscal_pzamax_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdasum
*/
int hscal_pdasum_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdzasum
*/
int hscal_pdzasum_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* psasum
*/
int hscal_psasum_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pscasum
*/
int hscal_pscasum_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdnrm2
*/
int hscal_pdnrm2_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdznrm2
*/
int hscal_pdznrm2_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* psnrm2
*/
int hscal_psnrm2_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pscnrm2
*/
int hscal_pscnrm2_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pddot
*/
int hscal_pddot_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* psdot
*/
int hscal_psdot_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcdotc
*/
int hscal_pcdotc_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzdotc
*/
int hscal_pzdotc_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcdotu
*/
int hscal_pcdotu_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzdotu
*/
int hscal_pzdotu_info(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 2
* ------------------------------------------------------------------
*/
/*
*  pcgemv
*/
int hscal_pcgemv_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pdgemv
*/
int hscal_pdgemv_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  psgemv
*/
int hscal_psgemv_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pzgemv
*/
int hscal_pzgemv_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pcagemv
*/
int hscal_pcagemv_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  psagemv
*/
int hscal_psagemv_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pdagemv
*/
int hscal_pdagemv_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);


/*
*  pzagemv
*/
int hscal_pzagemv_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pdsymv
*/
int hscal_pdsymv_info(
   F_CHAR_T UPLO,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pssymv
*/
int hscal_pssymv_info(
   F_CHAR_T UPLO,
   int * N,
   float  * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float  * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pzhemv
*/
int hscal_pzhemv_info(
   F_CHAR_T UPLO,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pchemv
*/
int hscal_pchemv_info(
   F_CHAR_T UPLO,
   int * N,
   float  * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float  * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pzahemv
*/
int hscal_pzahemv_info(
   F_CHAR_T UPLO,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pcahemv
*/
int hscal_pcahemv_info(
   F_CHAR_T UPLO,
   int * N,
   float  * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float  * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pdasymv
*/
int hscal_pdasymv_info(
   F_CHAR_T TRANS,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  psasymv
*/
int hscal_psasymv_info(
   F_CHAR_T TRANS,
   int * N,
   float  * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float  * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pctrmv
*/
int hscal_pctrmv_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pdtrmv
*/
int hscal_pdtrmv_info( 
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pstrmv
*/
int hscal_pstrmv_info( 
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pztrmv
*/
int hscal_pztrmv_info( 
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pcatrmv
*/
int hscal_pcatrmv_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  psatrmv
*/
int hscal_psatrmv_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pdatrmv
*/
int hscal_pdatrmv_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double* BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pzatrmv
*/
int hscal_pzatrmv_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double* BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pctrsv
*/
int hscal_pctrsv_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pdtrsv
*/
int hscal_pdtrsv_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pstrsv
*/
int hscal_pstrsv_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
*  pztrsv
*/
int hscal_pztrsv_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* psger
*/
int hscal_psger_info(
   int * M,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdger
*/
int hscal_pdger_info(
   int * M,
   int * N,
   double* ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcgerc
*/
int hscal_pcgerc_info(
   int * M,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzgerc
*/
int hscal_pzgerc_info(
   int * M,
   int * N,
   double* ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcgeru
*/
int hscal_pcgeru_info(
   int * M,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzgeru
*/
int hscal_pzgeru_info(
   int * M,
   int * N,
   double* ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcher
*/
int hscal_pcher_info(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzher
*/
int hscal_pzher_info(
   F_CHAR_T UPLO,
   int * N,
   double* ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcher2
*/
int hscal_pcher2_info(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzher2
*/
int hscal_pzher2_info(
   F_CHAR_T UPLO,
   int * N,
   double* ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pssyr
*/
int hscal_pssyr_info(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdsyr
*/
int hscal_pdsyr_info(
   F_CHAR_T UPLO,
   int * N,
   double* ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pssyr2
*/
int hscal_pssyr2_info(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdsyr2
*/
int hscal_pdsyr2_info(
   F_CHAR_T UPLO,
   int * N,
   double* ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 3
* ------------------------------------------------------------------
*/
/*
* pcherk
*/
int hscal_pcherk_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzherk
*/
int hscal_pzherk_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcsyrk
*/
int hscal_pcsyrk_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pssyrk
*/
int hscal_pssyrk_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdsyrk
*/
int hscal_pdsyrk_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzsyrk
*/
int hscal_pzsyrk_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcher2k
*/
int hscal_pcher2k_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzher2k
*/
int hscal_pzher2k_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcsyr2k
*/
int hscal_pcsyr2k_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pssyr2k
*/
int hscal_pssyr2k_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdsyr2k
*/
int hscal_pdsyr2k_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzsyr2k
*/
int hscal_pzsyr2k_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pchemm
*/
int hscal_pchemm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzhemm
*/
int hscal_pzhemm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcsymm
*/
int hscal_pcsymm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pssymm
*/
int hscal_pssymm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdsymm
*/
int hscal_pdsymm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzsymm
*/
int hscal_pzsymm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pctranc
*/
int hscal_pctranc_info(
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pztranc
*/
int hscal_pztranc_info(
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pctranu
*/
int hscal_pctranu_info(
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pztranu
*/
int hscal_pztranu_info(
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pstran
*/
int hscal_pstran_info(
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdtran
*/
int hscal_pdtran_info(
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pctrmm
*/
int hscal_pctrmm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdtrmm
*/
int hscal_pdtrmm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pstrmm
*/
int hscal_pstrmm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);


/*
* pztrmm
*/
int hscal_pztrmm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcgemm
*/
int hscal_pcgemm_info(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int * M,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* psgemm
*/
int hscal_psgemm_info(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int * M,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdgemm
*/
int hscal_pdgemm_info(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int * M,
   int * N,
   int * K,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzgemm
*/
int hscal_pzgemm_info(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int * M,
   int * N,
   int * K,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pctradd
*/
int hscal_pctradd_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pstradd
*/
int hscal_pstradd_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdtradd
*/
int hscal_pdtradd_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pztradd
*/
int hscal_pztradd_info(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pcgeadd
*/
int hscal_pcgeadd_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* psgeadd
*/
int hscal_psgeadd_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdgeadd
*/
int hscal_pdgeadd_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pzgeadd
*/
int hscal_pzgeadd_info(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double* BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pctrsm
*/
int hscal_pctrsm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pstrsm
*/
int hscal_pstrsm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pdtrsm
*/
int hscal_pdtrsm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

/*
* pztrsm
*/
int hscal_pztrsm_info(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   double* ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   int   nprow,
   int   npcol,
   double * tcomp,
   int    * tcomm
);

#endif

