
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK PBLAS LEVEL2             *
*                         (INTERNAL)                               *
*                 ====================================             *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_PBLAS_LEVEL2_COMP_COMM_FUNCS_HH
#define __HMPI_SCALAPACK_PBLAS_LEVEL2_COMP_COMM_FUNCS_HH

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 2
* ------------------------------------------------------------------
*/

/*
*  PCGEMV
*/
double hscal_pcgemv_recon_tcomp(
   int transi,
   int m,
   int n,
   int alpha[CNARG],
   int incx,
   int beta[CNARG],
   int incy
);

double hscal_pcgemv_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pcgemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgemv_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int * tcomm
);

int hscal_pcgemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgemv_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PDGEMV
*/
double hscal_pdgemv_recon_tcomp(
   int transi,
   int m,
   int n,
   int alpha,
   int incx,
   int beta,
   int incy
);

double hscal_pdgemv_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pdgemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgemv_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgemv_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PSGEMV
*/
double hscal_psgemv_recon_tcomp(
   int transi,
   int m,
   int n,
   int alpha,
   int incx,
   int beta,
   int incy
);

double hscal_psgemv_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_psgemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgemv_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgemv_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PZGEMV
*/
double hscal_pzgemv_recon_tcomp(
   int transi,
   int m,
   int n,
   int alpha[CNARG],
   int incx,
   int beta[CNARG],
   int incy
);

double hscal_pzgemv_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pzgemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgemv_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgemv_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PCAGEMV
*/
double hscal_pcagemv_recon_tcomp(
   int transi,
   int m,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pcagemv_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pcagemv_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcagemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcagemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcagemv_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PDAGEMV
*/
double hscal_pdagemv_recon_tcomp(
   int transi,
   int m,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pdagemv_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pdagemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdagemv_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdagemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdagemv_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PSAGEMV
*/
double hscal_psagemv_recon_tcomp(
   int transi,
   int m,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_psagemv_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_psagemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psagemv_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psagemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psagemv_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PZAGEMV
*/
double hscal_pzagemv_recon_tcomp(
   int transi,
   int m,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pzagemv_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pzagemv_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzagemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzagemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzagemv_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PCHEMV
*/
double hscal_pchemv_recon_tcomp(
   int uploi,
   int n,
   int alphai[CNARG],
   int incx,
   int betai[CNARG],
   int incy
);

double hscal_pchemv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pchemv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pchemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pchemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pchemv_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PZHEMV
*/
double hscal_pzhemv_recon_tcomp(
   int uploi,
   int n,
   int alphai[CNARG],
   int incx,
   int betai[CNARG],
   int incy
);

double hscal_pzhemv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pzhemv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzhemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzhemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzhemv_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA[CNARG],
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PZAHEMV
*/
double hscal_pzahemv_recon_tcomp(
   int uploi,
   int mb,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pzahemv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pzahemv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzahemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzahemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzahemv_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PCAHEMV
*/
double hscal_pcahemv_recon_tcomp(
   int uploi,
   int mb,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pcahemv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pcahemv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcahemv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcahemv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcahemv_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PDSYMV
*/
double hscal_pdsymv_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pdsymv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pdsymv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdsymv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdsymv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdsymv_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PSSYMV
*/
double hscal_pssymv_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pssymv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pssymv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pssymv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pssymv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pssymv_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PDASYMV
*/
double hscal_pdasymv_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pdasymv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pdasymv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdasymv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdasymv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdasymv_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PSASYMV
*/
double hscal_psasymv_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_psasymv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_psasymv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psasymv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psasymv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psasymv_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pctrmv
*/
double hscal_pctrmv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int incx
);

double hscal_pctrmv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol
);

int hscal_pctrmv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pctrmv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pctrmv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pctrmv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pdtrmv
*/
double hscal_pdtrmv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int incx
);

double hscal_pdtrmv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol
);

int hscal_pdtrmv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdtrmv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdtrmv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdtrmv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pstrmv
*/
double hscal_pstrmv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int incx
);

double hscal_pstrmv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol
);

int hscal_pstrmv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pstrmv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pstrmv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pstrmv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pztrmv
*/
double hscal_pztrmv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int incx
);

double hscal_pztrmv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol
);

int hscal_pztrmv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pztrmv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pztrmv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pztrmv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  PCATRMV
*/
double hscal_pcatrmv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pcatrmv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pcatrmv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcatrmv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcatrmv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcatrmv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pdatrmv
*/
double hscal_pdatrmv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pdatrmv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pdatrmv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdatrmv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdatrmv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdatrmv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  psatrmv
*/
double hscal_psatrmv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_psatrmv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_psatrmv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psatrmv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psatrmv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psatrmv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pzatrmv
*/
double hscal_pzatrmv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int alphai,
   int incx,
   int betai,
   int incy
);

double hscal_pzatrmv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol
);

int hscal_pzatrmv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzatrmv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzatrmv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETAI,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzatrmv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int BETA,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pctrsv
*/
double hscal_pctrsv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int incx
);

double hscal_pctrsv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol
);

int hscal_pctrsv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pctrsv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pctrsv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pctrsv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pdtrsv
*/
double hscal_pdtrsv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int incx
);

double hscal_pdtrsv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol
);

int hscal_pdtrsv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdtrsv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdtrsv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdtrsv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pstrsv
*/
double hscal_pstrsv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int incx
);

double hscal_pstrsv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol
);

int hscal_pstrsv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pstrsv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pstrsv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pstrsv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
*  pztrsv
*/
double hscal_pztrsv_recon_tcomp(
   int uploi,
   int transi,
   int diagi,
   int n,
   int incx
);

double hscal_pztrsv_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol
);

int hscal_pztrsv_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pztrsv_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pztrsv_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pztrsv_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int N,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PSGER
*/
double hscal_psger_recon_tcomp(
   int m,
   int n,
   int alphai,
   int incx,
   int incy
);

double hscal_psger_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_psger_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psger_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psger_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHAI,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psger_tcomp_tcomm(
   int M,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PDGER
*/
double hscal_pdger_recon_tcomp(
   int m,
   int n,
   int alphai,
   int incx,
   int incy
);

double hscal_pdger_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdger_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdger_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdger_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHAI,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdger_tcomp_tcomm(
   int M,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCGERC
*/
double hscal_pcgerc_recon_tcomp(
   int m,
   int n,
   int alphai[CNARG],
   int incx,
   int incy
);

double hscal_pcgerc_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcgerc_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgerc_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgerc_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgerc_tcomp_tcomm(
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PZGERC
*/
double hscal_pzgerc_recon_tcomp(
   int m,
   int n,
   int alphai[CNARG],
   int incx,
   int incy
);

double hscal_pzgerc_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzgerc_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgerc_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgerc_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgerc_tcomp_tcomm(
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCGERU
*/
double hscal_pcgeru_recon_tcomp(
   int m,
   int n,
   int alphai[CNARG],
   int incx,
   int incy
);

double hscal_pcgeru_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcgeru_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgeru_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgeru_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgeru_tcomp_tcomm(
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PZGERU
*/
double hscal_pzgeru_recon_tcomp(
   int m,
   int n,
   int alphai[CNARG],
   int incx,
   int incy
);

double hscal_pzgeru_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzgeru_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgeru_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgeru_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgeru_tcomp_tcomm(
   int M,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCHER
*/
double hscal_pcher_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx
);

double hscal_pcher_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcher_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcher_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcher_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcher_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PZHER
*/
double hscal_pzher_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx
);

double hscal_pzher_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzher_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzher_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzher_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzher_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);


/*
* PCHER2
*/
double hscal_pcher2_recon_tcomp(
   int uploi,
   int n,
   int alphai[CNARG],
   int incx,
   int incy
);

double hscal_pcher2_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcher2_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcher2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcher2_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcher2_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PZHER2
*/
double hscal_pzher2_recon_tcomp(
   int uploi,
   int n,
   int alphai[CNARG],
   int incx,
   int incy
);

double hscal_pzher2_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzher2_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzher2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzher2_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzher2_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA[CNARG],
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PDSYR
*/
double hscal_pdsyr_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx
);

double hscal_pdsyr_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdsyr_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdsyr_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdsyr_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdsyr_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdsyr_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PSSYR
*/
double hscal_pssyr_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx
);

double hscal_pssyr_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pssyr_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pssyr_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pssyr_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PDSYR2
*/
double hscal_pdsyr2_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx,
   int incy
);

double hscal_pdsyr2_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdsyr2_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdsyr2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdsyr2_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdsyr2_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PSSYR2
*/
double hscal_pssyr2_recon_tcomp(
   int uploi,
   int n,
   int alphai,
   int incx,
   int incy
);

double hscal_pssyr2_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol
);

int hscal_pssyr2_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pssyr2_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pssyr2_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int N,
   int ALPHAI,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pssyr2_tcomp_tcomm(
   int UPLOI,
   int N,
   int ALPHA,
   int IX,
   int JX,
   int DESCX[DLEN_],
   int INCX,
   int IY,
   int JY,
   int DESCY[DLEN_],
   int INCY,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

#endif  /* __HMPI_SCALAPACK_PBLAS_LEVEL2_COMP_COMM_FUNCS_HH */
