
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK LEVEL 3                  *
*                         (INTERNAL)                               *
*                 ===============================                  *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_PBLAS_LEVEL3_COMP_COMM_FUNCS_HH
#define __HMPI_SCALAPACK_PBLAS_LEVEL3_COMP_COMM_FUNCS_HH

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 3
* ------------------------------------------------------------------
*/

/*
* PCHERK
*/
double hscal_pcherk_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai,
   int betai
);

double hscal_pcherk_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcherk_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcherk_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcherk_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcherk_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PZHERK
*/
double hscal_pzherk_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai,
   int betai
);

double hscal_pzherk_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzherk_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzherk_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzherk_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzherk_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCHER2K
*/
double hscal_pcher2k_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai[CNARG],
   int betai
);

double hscal_pcher2k_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcher2k_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcher2k_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcher2k_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcher2k_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PZHER2K
*/
double hscal_pzher2k_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai[CNARG],
   int betai
);

double hscal_pzher2k_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzher2k_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzher2k_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzher2k_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzher2k_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCSYRK
*/
double hscal_pcsyrk_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pcsyrk_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcsyr2k_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcsyrk_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcsyrk_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcsyrk_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PDSYRK
*/
double hscal_pdsyrk_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai,
   int betai
);

double hscal_pdsyrk_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdsyrk_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdsyrk_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdsyrk_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdsyrk_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PSSYRK
*/
double hscal_pssyrk_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai,
   int betai
);

double hscal_pssyrk_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pssyrk_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pssyrk_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pssyrk_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pssyrk_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PZSYRK
*/
double hscal_pzsyrk_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pzsyrk_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzsyrk_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzsyrk_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzsyrk_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzsyrk_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCSYR2K
*/
double hscal_pcsyr2k_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pcsyr2k_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcsyr2k_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcsyr2k_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcsyr2k_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcsyr2k_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PDSYR2K
*/
double hscal_pdsyr2k_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai,
   int betai
);

double hscal_pdsyr2k_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdsyr2k_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdsyr2k_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdsyr2k_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdsyr2k_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PSSYR2K
*/
double hscal_pssyr2k_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai,
   int betai
);

double hscal_pssyr2k_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pssyr2k_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pssyr2k_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pssyr2k_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pssyr2k_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PZSYR2K
*/
double hscal_pzsyr2k_recon_tcomp(
   int uploi,
   int transi,
   int n,
   int k, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pzsyr2k_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzsyr2k_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzsyr2k_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzsyr2k_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzsyr2k_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCSYMM
*/
double hscal_pcsymm_recon_tcomp(
   int sidei,
   int uploi,
   int m,
   int n, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pcsymm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcsymm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcsymm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcsymm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcsymm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pzsymm
*/
double hscal_pzsymm_recon_tcomp(
   int sidei,
   int uploi,
   int m,
   int n, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pzsymm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzsymm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzsymm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzsymm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzsymm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdsymm
*/
double hscal_pdsymm_recon_tcomp(
   int sidei,
   int uploi,
   int m,
   int n, 
   int alphai,
   int betai
);

double hscal_pdsymm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdsymm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdsymm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdsymm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdsymm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pssymm
*/
double hscal_pssymm_recon_tcomp(
   int sidei,
   int uploi,
   int m,
   int n, 
   int alphai,
   int betai
);

double hscal_pssymm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pssymm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pssymm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pssymm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pssymm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCHEMM
*/
double hscal_pchemm_recon_tcomp(
   int sidei,
   int uploi,
   int m,
   int n, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pchemm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pchemm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pchemm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pchemm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pchemm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PZHEMM
*/
double hscal_pzhemm_recon_tcomp(
   int sidei,
   int uploi,
   int m,
   int n, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pzhemm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzhemm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzhemm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzhemm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzhemm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCTRANC
*/
double hscal_pctranc_recon_tcomp(
   int m,
   int n, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pctranc_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pctranc_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pctranc_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pctranc_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pctranc_tcomp_tcomm(
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pztranc
*/
double hscal_pztranc_recon_tcomp(
   int m,
   int n, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pztranc_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pztranc_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pztranc_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pztranc_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pztranc_tcomp_tcomm(
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pctranu
*/
double hscal_pctranu_recon_tcomp(
   int m,
   int n, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pctranu_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pctranu_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pctranu_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pctranu_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pctranu_tcomp_tcomm(
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pztranu
*/
double hscal_pztranu_recon_tcomp(
   int m,
   int n, 
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pztranu_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pztranu_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pztranu_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pztranu_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pztranu_tcomp_tcomm(
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdtran
*/
double hscal_pdtran_recon_tcomp(
   int m,
   int n, 
   int alphai,
   int betai
);

double hscal_pdtran_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdtran_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdtran_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdtran_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdtran_tcomp_tcomm(
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pstran
*/
double hscal_pstran_recon_tcomp(
   int m,
   int n, 
   int alphai,
   int betai
);

double hscal_pstran_my_tcomp(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pstran_my_tcomm(
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pstran_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pstran_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pstran_tcomp_tcomm(
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCTRMM
*/
double hscal_pctrmm_recon_tcomp(
   int sidei,
   int uploi,
   int transi,
   int diagi,
   int m,
   int n, 
   int alphai[CNARG]
);

double hscal_pctrmm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol
);

int hscal_pctrmm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pctrmm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pctrmm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pctrmm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pztrmm
*/
double hscal_pztrmm_recon_tcomp(
   int sidei,
   int uploi,
   int transi,
   int diagi,
   int m,
   int n, 
   int alphai[CNARG]
);

double hscal_pztrmm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol
);

int hscal_pztrmm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pztrmm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pztrmm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pztrmm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdtrmm
*/
double hscal_pdtrmm_recon_tcomp(
   int sidei,
   int uploi,
   int transi,
   int diagi,
   int m,
   int n, 
   int alphai
);

double hscal_pdtrmm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdtrmm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdtrmm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdtrmm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdtrmm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pstrmm
*/
double hscal_pstrmm_recon_tcomp(
   int sidei,
   int uploi,
   int transi,
   int diagi,
   int m,
   int n, 
   int alphai
);

double hscal_pstrmm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol
);

int hscal_pstrmm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pstrmm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pstrmm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pstrmm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCTRSM
*/
double hscal_pctrsm_recon_tcomp(
   int sidei,
   int uploi,
   int transi,
   int diagi,
   int m,
   int n, 
   int alphai[CNARG]
);

double hscal_pctrsm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol
);

int hscal_pctrsm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pctrsm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pctrsm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pctrsm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdtrsm
*/
double hscal_pdtrsm_recon_tcomp(
   int sidei,
   int uploi,
   int transi,
   int diagi,
   int m,
   int n, 
   int alphai
);

double hscal_pdtrsm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdtrsm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdtrsm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdtrsm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdtrsm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pstrsm
*/
double hscal_pstrsm_recon_tcomp(
   int sidei,
   int uploi,
   int transi,
   int diagi,
   int m,
   int n, 
   int alphai
);

double hscal_pstrsm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol
);

int hscal_pstrsm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pstrsm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pstrsm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pstrsm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pztrsm
*/
double hscal_pztrsm_recon_tcomp(
   int sidei,
   int uploi,
   int transi,
   int diagi,
   int m,
   int n, 
   int alphai[CNARG]
);

double hscal_pztrsm_my_tcomp(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol
);

int hscal_pztrsm_my_tcomm(
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pztrsm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pztrsm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pztrsm_tcomp_tcomm(
   int SIDEI,
   int UPLOI,
   int TRANSI,
   int DIAGI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCGEMM
*/
double hscal_pcgemm_recon_tcomp(
   int transai,
   int transbi,
   int m,
   int n,
   int k,
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pcgemm_my_tcomp(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcgemm_my_tcomm(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgemm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgemm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgemm_tcomp_tcomm(
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pzgemm
*/
double hscal_pzgemm_recon_tcomp(
   int transai,
   int transbi,
   int m,
   int n,
   int k,
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pzgemm_my_tcomp(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzgemm_my_tcomm(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgemm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgemm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgemm_tcomp_tcomm(
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdgemm
*/
double hscal_pdgemm_recon_tcomp(
   int transai,
   int transbi,
   int m,
   int n,
   int k,
   int alphai,
   int betai
);

double hscal_pdgemm_recon_tcomp_p_q(
   int transai,
   int transbi,
   int m,
   int n,
   int k, 
   int alphai,
   int betai,
   int p,
   int q
);  

double hscal_pdgemm_my_tcomp(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdgemm_my_tcomm(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgemm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgemm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgemm_tcomp_tcomm(
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* psgemm
*/
double hscal_psgemm_recon_tcomp(
   int transai,
   int transbi,
   int m,
   int n,
   int k,
   int alphai,
   int betai
);

double hscal_psgemm_my_tcomp(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_psgemm_my_tcomm(
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgemm_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgemm_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgemm_tcomp_tcomm(
   int TRANSAI,
   int TRANSBI,
   int M,
   int N,
   int K,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int IB,
   int JB,
   int DESCB[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* PCGEADD
*/
double hscal_pcgeadd_recon_tcomp(
   int transi,
   int m,
   int n,
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pcgeadd_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pcgeadd_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pcgeadd_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pcgeadd_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pcgeadd_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pzgeadd
*/
double hscal_pzgeadd_recon_tcomp(
   int transi,
   int m,
   int n,
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pzgeadd_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pzgeadd_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pzgeadd_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pzgeadd_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pzgeadd_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdgeadd
*/
double hscal_pdgeadd_recon_tcomp(
   int transi,
   int m,
   int n,
   int alphai,
   int betai
);

double hscal_pdgeadd_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdgeadd_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdgeadd_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdgeadd_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdgeadd_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* psgeadd
*/
double hscal_psgeadd_recon_tcomp(
   int transi,
   int m,
   int n,
   int alphai,
   int betai
);

double hscal_psgeadd_my_tcomp(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_psgeadd_my_tcomm(
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_psgeadd_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_psgeadd_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int TRANSI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_psgeadd_tcomp_tcomm(
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pctradd
*/
double hscal_pctradd_recon_tcomp(
   int uploi,
   int transi,
   int m,
   int n,
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pctradd_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pctradd_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pctradd_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pctradd_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pctradd_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pztradd
*/
double hscal_pztradd_recon_tcomp(
   int uploi,
   int transi,
   int m,
   int n,
   int alphai[CNARG],
   int betai[CNARG]
);

double hscal_pztradd_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pztradd_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pztradd_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pztradd_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHAI[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pztradd_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA[CNARG],
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA[CNARG],
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pdtradd
*/
double hscal_pdtradd_recon_tcomp(
   int uploi,
   int transi,
   int m,
   int n,
   int alphai,
   int betai
);

double hscal_pdtradd_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pdtradd_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pdtradd_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pdtradd_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pdtradd_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

/*
* pstradd
*/
double hscal_pstradd_recon_tcomp(
   int uploi,
   int transi,
   int m,
   int n,
   int alphai,
   int betai
);

double hscal_pstradd_my_tcomp(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol
);

int hscal_pstradd_my_tcomm(
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm
);

int hscal_pstradd_my_tcomm_to_ij(
   int myrow,
   int mycol,
   int ireceiver,
   int jreceiver,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   int *tcomm,
   int *tcomm_i
);

int hscal_pstradd_my_tcomp_tcomm( 
   int init_llds_f,
   int myrow,
   int mycol,
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHAI,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETAI,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

int hscal_pstradd_tcomp_tcomm(
   int UPLOI,
   int TRANSI,
   int M,
   int N,
   int ALPHA,
   int IA,
   int JA,
   int DESCA[DLEN_],
   int BETA,
   int IC,
   int JC,
   int DESCC[DLEN_],
   int nprow,
   int npcol,
   double *tcomp,
   int *tcomm
);

#endif  /* __HMPI_SCALAPACK_PBLAS_LEVEL3_COMP_COMM_FUNCS_HH */

