
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                     PBLAS MPC Macros                             *
*                         (INTERNAL)                               *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HSCALAPACK_PBLAS_MPC_MACROS_HH_
#define __HSCALAPACK_PBLAS_MPC_MACROS_HH_

/*
* ------------------------------------------------------------------
*                         PBLAS level1
* ------------------------------------------------------------------
*/
#define    HSCAL_PXSWAP_INIT_LLDS( \
                  N, \
                  Xd, IX, INCX, \
                  Yd, IY, INCY, \
                  myrow, nprow \
           ) \
              { \
                 if (INCX == Xd[M_]) \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX+N-1, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 if (INCY == Yd[M_]) \
                 { \
                    Yd[LLD_] = max(1, PB_Cnumroc(IY, \
                                                 0, \
                                                 Yd[IMB_], \
                                                 Yd[MB_], \
                                                 myrow, \
                                                 Yd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    Yd[LLD_] = max(1, PB_Cnumroc(IY+N-1, \
                                                 0, \
                                                 Yd[IMB_], \
                                                 Yd[MB_], \
                                                 myrow, \
                                                 Yd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
              }

#define    HSCAL_PXSCAL_INIT_LLDS( \
                  N, \
                  Xd, IX, INCX, \
                  myrow, nprow \
           ) \
              { \
                 if (INCX == Xd[M_]) \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX+N-1, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
              }

#define    HSCAL_PXCOPY_INIT_LLDS           HSCAL_PXSWAP_INIT_LLDS
#define    HSCAL_PXAXPY_INIT_LLDS           HSCAL_PXSWAP_INIT_LLDS
#define    HSCAL_PXASUM_INIT_LLDS           HSCAL_PXSCAL_INIT_LLDS
#define    HSCAL_PXAMAX_INIT_LLDS           HSCAL_PXSCAL_INIT_LLDS
#define    HSCAL_PXNRM2_INIT_LLDS           HSCAL_PXSCAL_INIT_LLDS
#define    HSCAL_PXDOTC_INIT_LLDS           HSCAL_PXSWAP_INIT_LLDS
#define    HSCAL_PXDOTU_INIT_LLDS           HSCAL_PXSWAP_INIT_LLDS
#define    HSCAL_PXDOT_INIT_LLDS            HSCAL_PXSWAP_INIT_LLDS

/*
* ------------------------------------------------------------------
*       PBLAS level2
* ------------------------------------------------------------------
*/
#define    HSCAL_PXAGEMV_INIT_LLDS( \
                  notran, \
                  M, N, \
                  Ad, \
                  Xd, IX, INCX, \
                  Yd, IY, INCY, \
                  myrow, nprow \
           ) \
              { \
                 Ad[LLD_] = max(1, PB_Cnumroc(Ad[M_], \
                                              0, \
                                              Ad[IMB_], \
                                              Ad[MB_], \
                                              myrow, \
                                              Ad[RSRC_], \
                                              nprow \
                               ) \
                 ); \
                 if (INCX == Xd[M_]) \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    if (notran) \
                    { \
                       Xd[LLD_] = max(1, PB_Cnumroc(IX+N-1, \
                                                    0, \
                                                    Xd[IMB_], \
                                                    Xd[MB_], \
                                                    myrow, \
                                                    Xd[RSRC_], \
                                                    nprow \
                                      ) \
                       ); \
                    } \
                    else \
                    { \
                       Xd[LLD_] = max(1, PB_Cnumroc(IX+M-1, \
                                                    0, \
                                                    Xd[IMB_], \
                                                    Xd[MB_], \
                                                    myrow, \
                                                    Xd[RSRC_], \
                                                    nprow \
                                     ) \
                       ); \
                    } \
                 } \
                 if (INCY == Yd[M_]) \
                 { \
                    Yd[LLD_] = max(1, PB_Cnumroc(IY, \
                                                 0, \
                                                 Yd[IMB_], \
                                                 Yd[MB_], \
                                                 myrow, \
                                                 Yd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    if (notran) \
                    { \
                       Yd[LLD_] = max(1, PB_Cnumroc(IY+M-1, \
                                                    0, \
                                                    Yd[IMB_], \
                                                    Yd[MB_], \
                                                    myrow, \
                                                    Yd[RSRC_], \
                                                    nprow \
                                     ) \
                       ); \
                    } \
                    else \
                    { \
                       Yd[LLD_] = max(1, PB_Cnumroc(IY+N-1, \
                                                    0, \
                                                    Yd[IMB_], \
                                                    Yd[MB_], \
                                                    myrow, \
                                                    Yd[RSRC_], \
                                                    nprow \
                                      ) \
                       ); \
                    } \
                 } \
              }

#define    HSCAL_PXAGEMV_ALLOC_INTER_DATA( \
                tbeta, \
                YApbY, \
                YAsum, \
                Ad0perf, \
                XAd, \
                YAd, \
                nprow, npcol \
           ) \
           { \
             tbeta = (char**)malloc(nprow*npcol*sizeof(char*)); \
             if (tbeta == NULL) \
             { \
                break; \
             } \
             YApbY = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (YApbY == NULL) \
             { \
                free(tbeta); \
                break; \
             } \
             YAsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (YAsum == NULL) \
             { \
                free(tbeta); \
                free(YApbY); \
                break; \
             } \
             Ad0perf = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0perf == NULL) \
             { \
                free(tbeta); \
                free(YApbY); \
                free(YAsum); \
                break; \
             } \
             XAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XAd == NULL) \
             { \
                free(tbeta); \
                free(YApbY); \
                free(YAsum); \
                free(Ad0perf); \
                break; \
             } \
             YAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (YAd == NULL) \
             { \
                free(tbeta); \
                free(YApbY); \
                free(YAsum); \
                free(Ad0perf); \
                free(XAd); \
                break; \
             } \
           }

#define    HSCAL_PXAGEMV_FREE_INTER_DATA( \
                tbeta, \
                YApbY, \
                YAsum, \
                Ad0perf, \
                XAd, \
                YAd \
           ) \
           { \
             free(tbeta); \
             free(YApbY); \
             free(YAsum); \
             free(Ad0perf); \
             free(XAd); \
             free(YAd); \
           }

#define    HSCAL_PXGEMV_INIT_LLDS           HSCAL_PXAGEMV_INIT_LLDS
#define    HSCAL_PXGEMV_ALLOC_INTER_DATA    HSCAL_PXAGEMV_ALLOC_INTER_DATA
#define    HSCAL_PXGEMV_FREE_INTER_DATA     HSCAL_PXAGEMV_FREE_INTER_DATA

#define    HSCAL_PXAHEMV_INIT_LLDS( \
                  N, \
                  Ad, \
                  Xd, IX, INCX, \
                  Yd, IY, INCY, \
                  myrow, nprow \
           ) \
              { \
                 Ad[LLD_] = max(1, PB_Cnumroc(Ad[M_], \
                                              0, \
                                              Ad[IMB_], \
                                              Ad[MB_], \
                                              myrow, \
                                              Ad[RSRC_], \
                                              nprow \
                               ) \
                 ); \
                 if (INCX == Xd[M_]) \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX+N-1, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 if (INCY == Yd[M_]) \
                 { \
                    Yd[LLD_] = max(1, PB_Cnumroc(IY, \
                                                 0, \
                                                 Yd[IMB_], \
                                                 Yd[MB_], \
                                                 myrow, \
                                                 Yd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    Yd[LLD_] = max(1, PB_Cnumroc(IY+N-1, \
                                                 0, \
                                                 Yd[IMB_], \
                                                 Yd[MB_], \
                                                 myrow, \
                                                 Yd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
              }

#define    HSCAL_PXAHEMV_ALLOC_INTER_DATA( \
                Yd, \
                INCY, \
                tbeta, \
                dtype, \
                XRd, \
                XCd, \
                YRd, \
                YCd, \
                YRsum, \
                YCsum, \
                Ad0perf, \
                Amp, \
                Anq, \
                YRpbY, \
                YCpbY, \
                nprow, npcol \
           ) \
           { \
             tbeta = (dtype**)malloc(nprow*npcol*sizeof(dtype*)); \
             if (tbeta == NULL) \
             { \
                break; \
             } \
             XRd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XRd == NULL) \
             { \
                free(tbeta); \
                break; \
             } \
             XCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XCd == NULL) \
             { \
                free(tbeta); \
                free(XRd); \
                break; \
             } \
             YRd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (YRd == NULL) \
             { \
                free(tbeta); \
                free(XRd); \
                free(XCd); \
                break; \
             } \
             YCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (YCd == NULL) \
             { \
                free(tbeta); \
                free(XRd); \
                free(XCd); \
                free(YRd); \
                break; \
             } \
             YRsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (YRsum == NULL) \
             { \
                free(tbeta); \
                free(XRd); \
                free(XCd); \
                free(YRd); \
                free(YCd); \
                break; \
             } \
             YCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (YCsum == NULL) \
             { \
                free(tbeta); \
                free(XRd); \
                free(XCd); \
                free(YRd); \
                free(YCd); \
                free(YRsum); \
                break; \
             } \
             Ad0perf = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0perf == NULL) \
             { \
                free(tbeta); \
                free(XRd); \
                free(XCd); \
                free(YRd); \
                free(YCd); \
                free(YRsum); \
                free(YCsum); \
                break; \
             } \
             Amp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp == NULL) \
             { \
                free(tbeta); \
                free(XRd); \
                free(XCd); \
                free(YRd); \
                free(YCd); \
                free(YRsum); \
                free(YCsum); \
                free(Ad0perf); \
                break; \
             } \
             Anq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq == NULL) \
             { \
                free(tbeta); \
                free(XRd); \
                free(XCd); \
                free(YRd); \
                free(YCd); \
                free(YRsum); \
                free(YCsum); \
                free(Ad0perf); \
                free(Amp); \
                break; \
             } \
             if ( INCY == Yd[M_] ) \
             { \
                YRpbY = (int*)malloc(nprow*npcol*sizeof(int)); \
                if (YRpbY == NULL) \
                { \
                   free(tbeta); \
                   free(XRd); \
                   free(XCd); \
                   free(YRd); \
                   free(YCd); \
                   free(YRsum); \
                   free(YCsum); \
                   free(Ad0perf); \
                   free(Amp); \
                   free(Anq); \
                   break; \
                } \
             } \
             else \
             { \
                YCpbY = (int*)malloc(nprow*npcol*sizeof(int)); \
                if (YCpbY == NULL) \
                { \
                   free(tbeta); \
                   free(XRd); \
                   free(XCd); \
                   free(YRd); \
                   free(YCd); \
                   free(YRsum); \
                   free(YCsum); \
                   free(Ad0perf); \
                   free(Amp); \
                   free(Anq); \
                   break; \
                } \
             } \
           }

#define    HSCAL_PXAHEMV_FREE_INTER_DATA( \
                Yd, \
                INCY, \
                tbeta, \
                XRd, \
                XCd, \
                YRd, \
                YCd, \
                YRsum, \
                YCsum, \
                Ad0perf, \
                Amp, \
                Anq, \
                YRpbY, \
                YCpbY \
           ) \
           { \
             { \
                free(tbeta); \
                free(XRd); \
                free(XCd); \
                free(YRd); \
                free(YCd); \
                free(YRsum); \
                free(YCsum); \
                free(Ad0perf); \
                free(Amp); \
                free(Anq); \
             } \
             if ( INCY == Yd[M_] ) \
             { \
                free(YRpbY); \
             } \
             else \
             { \
                free(YCpbY); \
             } \
           }

#define    HSCAL_PXHEMV_INIT_LLDS            HSCAL_PXAHEMV_INIT_LLDS
#define    HSCAL_PXHEMV_ALLOC_INTER_DATA     HSCAL_PXAHEMV_ALLOC_INTER_DATA
#define    HSCAL_PXHEMV_FREE_INTER_DATA      HSCAL_PXAHEMV_FREE_INTER_DATA

#define    HSCAL_PXASYMV_INIT_LLDS           HSCAL_PXAHEMV_INIT_LLDS
#define    HSCAL_PXASYMV_ALLOC_INTER_DATA    HSCAL_PXAHEMV_ALLOC_INTER_DATA
#define    HSCAL_PXASYMV_FREE_INTER_DATA     HSCAL_PXAHEMV_FREE_INTER_DATA

#define    HSCAL_PXSYMV_INIT_LLDS            HSCAL_PXASYMV_INIT_LLDS
#define    HSCAL_PXSYMV_ALLOC_INTER_DATA     HSCAL_PXASYMV_ALLOC_INTER_DATA
#define    HSCAL_PXSYMV_FREE_INTER_DATA      HSCAL_PXASYMV_FREE_INTER_DATA

#define    HSCAL_PXATRMV_INIT_LLDS           HSCAL_PXAHEMV_INIT_LLDS
#define    HSCAL_PXATRMV_ALLOC_INTER_DATA( \
                tbeta, \
                dtype, \
                XAd, \
                YAd, \
                YAsum, \
                YApbY, \
                Ad0perf, \
                Amp, \
                Anq, \
                nprow, npcol \
           ) \
           { \
             tbeta = (dtype**)malloc(nprow*npcol*sizeof(dtype*)); \
             if (tbeta == NULL) \
             { \
                break; \
             } \
             XAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XAd == NULL) \
             { \
                free(tbeta); \
                break; \
             } \
             YAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (YAd == NULL) \
             { \
                free(tbeta); \
                free(XAd); \
                break; \
             } \
             YAsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (YAsum == NULL) \
             { \
                free(tbeta); \
                free(XAd); \
                free(YAd); \
                break; \
             } \
             YApbY = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (YApbY == NULL) \
             { \
                free(tbeta); \
                free(XAd); \
                free(YAd); \
                free(YAsum); \
                break; \
             } \
             Ad0perf = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0perf == NULL) \
             { \
                free(tbeta); \
                free(XAd); \
                free(YAd); \
                free(YAsum); \
                free(YApbY); \
                break; \
             } \
             Amp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp == NULL) \
             { \
                free(tbeta); \
                free(XAd); \
                free(YAd); \
                free(YAsum); \
                free(YApbY); \
                free(Ad0perf); \
                break; \
             } \
             Anq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq == NULL) \
             { \
                free(tbeta); \
                free(XAd); \
                free(YAd); \
                free(YAsum); \
                free(YApbY); \
                free(Ad0perf); \
                free(Amp); \
                break; \
             } \
           }

#define    HSCAL_PXATRMV_FREE_INTER_DATA( \
                tbeta, \
                XAd, \
                YAd, \
                YAsum, \
                YApbY, \
                Ad0perf, \
                Amp, \
                Anq \
           ) \
           { \
             { \
                free(tbeta); \
                free(XAd); \
                free(YAd); \
                free(YAsum); \
                free(YApbY); \
                free(Ad0perf); \
                free(Amp); \
                free(Anq); \
             } \
           }

#define    HSCAL_PXTRMV_INIT_LLDS( \
                  N, \
                  Ad, \
                  Xd, IX, INCX, \
                  myrow, nprow \
           ) \
              { \
                 Ad[LLD_] = max(1, PB_Cnumroc(Ad[M_], \
                                              0, \
                                              Ad[IMB_], \
                                              Ad[MB_], \
                                              myrow, \
                                              Ad[RSRC_], \
                                              nprow \
                               ) \
                 ); \
                 if (INCX == Xd[M_]) \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX+N-1, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
              }

#define    HSCAL_PXTRMV_ALLOC_INTER_DATA   HSCAL_PXATRMV_ALLOC_INTER_DATA
#define    HSCAL_PXTRMV_FREE_INTER_DATA    HSCAL_PXATRMV_FREE_INTER_DATA

#define    HSCAL_PXTRSV_INIT_LLDS          HSCAL_PXTRMV_INIT_LLDS
#define    HSCAL_PXTRSV_ALLOC_INTER_DATA( \
                notran, \
                XACd, \
                XARd, \
                XACsum, \
                XARsum, \
                Ad0perf, \
                XACapbX, \
                XARapbX, \
                nprow, npcol \
           ) \
           { \
             XACd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XACd == NULL) \
             { \
                break; \
             } \
             XARd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XARd == NULL) \
             { \
                free(XACd); \
                break; \
             } \
             XACsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (XACsum == NULL) \
             { \
                free(XACd); \
                free(XARd); \
                break; \
             } \
             XARsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (XARsum == NULL) \
             { \
                free(XACd); \
                free(XARd); \
                free(XACsum); \
                break; \
             } \
             Ad0perf = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0perf == NULL) \
             { \
                free(XACd); \
                free(XARd); \
                free(XACsum); \
                free(XARsum); \
                break; \
             } \
             if ( notran ) \
             { \
                XACapbX = (int*)malloc(nprow*npcol*sizeof(int)); \
                if (XACapbX == NULL) \
                { \
                   free(XACd); \
                   free(XARd); \
                   free(XACsum); \
                   free(XARsum); \
                   free(Ad0perf); \
                   break; \
                } \
             } \
             else \
             { \
                XARapbX = (int*)malloc(nprow*npcol*sizeof(int)); \
                if (XARapbX == NULL) \
                { \
                   free(XACd); \
                   free(XARd); \
                   free(XACsum); \
                   free(XARsum); \
                   free(Ad0perf); \
                   break; \
                } \
             } \
           }

#define    HSCAL_PXTRSV_FREE_INTER_DATA( \
                notran, \
                XACd, \
                XARd, \
                XACsum, \
                XARsum, \
                Ad0perf, \
                XACapbX, \
                XARapbX \
           ) \
           { \
             { \
                free(XACd); \
                free(XARd); \
                free(XACsum); \
                free(XARsum); \
                free(Ad0perf); \
             } \
             if ( notran ) \
             { \
                free(XACapbX); \
             } \
             else \
             { \
                free(XARapbX); \
             } \
           }

#define    HSCAL_PXPTRSV_INIT_LLDS( \
                  Ad, \
                  myrow, nprow \
           ) \
              { \
                 Ad[LLD_] = max(1, PB_Cnumroc(Ad[M_], \
                                              0, \
                                              Ad[IMB_], \
                                              Ad[MB_], \
                                              myrow, \
                                              Ad[RSRC_], \
                                              nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXPTRSV_ALLOC_INTER_DATA( \
                Anp, \
                Anq, \
                n1p, \
                Anpprev, \
                n1pprev, \
                nprow, npcol \
           ) \
           { \
             Anp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anp == NULL) \
             { \
                break; \
             } \
             Anq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq == NULL) \
             { \
                free(Anp); \
                break; \
             } \
             n1p = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (n1p == NULL) \
             { \
                free(Anp); \
                free(Anq); \
                break; \
             } \
             Anpprev = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anpprev == NULL) \
             { \
                free(Anp); \
                free(Anq); \
                free(n1p); \
                break; \
             } \
             n1pprev = (int*)calloc(nprow*npcol, sizeof(int)); \
             if (n1pprev == NULL) \
             { \
                free(Anp); \
                free(Anq); \
                free(n1p); \
                free(Anpprev); \
                break; \
             } \
           }

#define    HSCAL_PXPTRSV_FREE_INTER_DATA( \
                Anp, \
                Anq, \
                n1p, \
                Anpprev, \
                n1pprev \
           ) \
           { \
             { \
                free(Anp); \
                free(Anq); \
                free(n1p); \
                free(Anpprev); \
                free(n1pprev); \
             } \
           }

#define    HSCAL_PXGERC_INIT_LLDS( \
                  N, \
                  Ad, \
                  Xd, IX, INCX, \
                  Yd, IY, INCY, \
                  myrow, nprow \
           ) \
              { \
                 Ad[LLD_] = max(1, PB_Cnumroc(Ad[M_], \
                                              0, \
                                              Ad[IMB_], \
                                              Ad[MB_], \
                                              myrow, \
                                              Ad[RSRC_], \
                                              nprow \
                               ) \
                 ); \
                 if (INCX == Xd[M_]) \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX+M-1, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 if (INCY == Yd[M_]) \
                 { \
                    Yd[LLD_] = max(1, PB_Cnumroc(IY, \
                                                 0, \
                                                 Yd[IMB_], \
                                                 Yd[MB_], \
                                                 myrow, \
                                                 Yd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    Yd[LLD_] = max(1, PB_Cnumroc(IY+N-1, \
                                                 0, \
                                                 Yd[IMB_], \
                                                 Yd[MB_], \
                                                 myrow, \
                                                 Yd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
              }

#define    HSCAL_PXGERC_ALLOC_INTER_DATA( \
                XAd, \
                YAd, \
                Ad0perf, \
                nprow, npcol \
           ) \
           { \
             XAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XAd == NULL) \
             { \
                break; \
             } \
             YAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (YAd == NULL) \
             { \
                free(XAd); \
                break; \
             } \
             Ad0perf = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0perf == NULL) \
             { \
                free(XAd); \
                free(YAd); \
                break; \
             } \
           }

#define    HSCAL_PXGERC_FREE_INTER_DATA( \
                XAd, \
                YAd, \
                Ad0perf \
           ) \
           { \
             { \
                free(XAd); \
                free(YAd); \
                free(Ad0perf); \
             } \
           }

#define    HSCAL_PXGERU_INIT_LLDS            HSCAL_PXGERC_INIT_LLDS
#define    HSCAL_PXGERU_ALLOC_INTER_DATA     HSCAL_PXGERC_ALLOC_INTER_DATA
#define    HSCAL_PXGERU_FREE_INTER_DATA      HSCAL_PXGERC_FREE_INTER_DATA

#define    HSCAL_PXGER_INIT_LLDS             HSCAL_PXGERC_INIT_LLDS
#define    HSCAL_PXGER_ALLOC_INTER_DATA      HSCAL_PXGERC_ALLOC_INTER_DATA
#define    HSCAL_PXGER_FREE_INTER_DATA       HSCAL_PXGERC_FREE_INTER_DATA

#define    HSCAL_PXHER_INIT_LLDS( \
                  N, \
                  Ad, \
                  Xd, IX, INCX, \
                  myrow, nprow \
           ) \
              { \
                 Ad[LLD_] = max(1, PB_Cnumroc(Ad[M_], \
                                              0, \
                                              Ad[IMB_], \
                                              Ad[MB_], \
                                              myrow, \
                                              Ad[RSRC_], \
                                              nprow \
                               ) \
                 ); \
                 if (INCX == Xd[M_]) \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
                 else \
                 { \
                    Xd[LLD_] = max(1, PB_Cnumroc(IX+N-1, \
                                                 0, \
                                                 Xd[IMB_], \
                                                 Xd[MB_], \
                                                 myrow, \
                                                 Xd[RSRC_], \
                                                 nprow \
                                  ) \
                    ); \
                 } \
              }

#define    HSCAL_PXHER_ALLOC_INTER_DATA( \
                XCd0, \
                XRd0, \
                Ad0perf, \
                Amp, \
                Anq, \
                nprow, npcol \
           ) \
           { \
             XCd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XCd0 == NULL) \
             { \
                break; \
             } \
             XRd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XRd0 == NULL) \
             { \
                free(XCd0); \
                break; \
             } \
             Ad0perf = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0perf == NULL) \
             { \
                free(XCd0); \
                free(XRd0); \
                break; \
             } \
             Amp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp == NULL) \
             { \
                free(XCd0); \
                free(XRd0); \
                free(Ad0perf); \
                break; \
             } \
             Anq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq == NULL) \
             { \
                free(XCd0); \
                free(XRd0); \
                free(Ad0perf); \
                free(Amp); \
                break; \
             } \
           }

#define    HSCAL_PXHER_FREE_INTER_DATA( \
                XCd0, \
                XRd0, \
                Ad0perf, \
                Amp, \
                Anq \
           ) \
           { \
             { \
                free(XCd0); \
                free(XRd0); \
                free(Ad0perf); \
                free(Amp); \
                free(Anq); \
             } \
           }

#define    HSCAL_PXSYR_INIT_LLDS             HSCAL_PXHER_INIT_LLDS
#define    HSCAL_PXSYR_ALLOC_INTER_DATA      HSCAL_PXHER_ALLOC_INTER_DATA
#define    HSCAL_PXSYR_FREE_INTER_DATA       HSCAL_PXHER_FREE_INTER_DATA

#define    HSCAL_PXHER2_INIT_LLDS            HSCAL_PXAHEMV_INIT_LLDS
#define    HSCAL_PXHER2_ALLOC_INTER_DATA( \
                XRd0, \
                XCd0, \
                YRd0, \
                YCd0, \
                Ad0perf, \
                Amp, \
                Anq, \
                nprow, npcol \
           ) \
           { \
             XRd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XRd0 == NULL) \
             { \
                break; \
             } \
             XCd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (XCd0 == NULL) \
             { \
                free(XRd0); \
                break; \
             } \
             YRd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (YRd0 == NULL) \
             { \
                free(XRd0); \
                free(XCd0); \
                break; \
             } \
             YCd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (YCd0 == NULL) \
             { \
                free(XRd0); \
                free(XCd0); \
                free(YRd0); \
                break; \
             } \
             Ad0perf = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0perf == NULL) \
             { \
                free(XRd0); \
                free(XCd0); \
                free(YRd0); \
                free(YCd0); \
                break; \
             } \
             Amp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp == NULL) \
             { \
                free(XRd0); \
                free(XCd0); \
                free(YRd0); \
                free(YCd0); \
                free(Ad0perf); \
                break; \
             } \
             Anq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq == NULL) \
             { \
                free(XRd0); \
                free(XCd0); \
                free(YRd0); \
                free(YCd0); \
                free(Ad0perf); \
                free(Amp); \
                break; \
             } \
           }

#define    HSCAL_PXHER2_FREE_INTER_DATA( \
                XRd0, \
                XCd0, \
                YRd0, \
                YCd0, \
                Ad0perf, \
                Amp, \
                Anq \
           ) \
           { \
             { \
                free(XRd0); \
                free(XCd0); \
                free(YRd0); \
                free(YCd0); \
                free(Ad0perf); \
                free(Amp); \
                free(Anq); \
             } \
           }

#define    HSCAL_PXSYR2_INIT_LLDS             HSCAL_PXHER2_INIT_LLDS
#define    HSCAL_PXSYR2_ALLOC_INTER_DATA      HSCAL_PXHER2_ALLOC_INTER_DATA
#define    HSCAL_PXSYR2_FREE_INTER_DATA       HSCAL_PXHER2_FREE_INTER_DATA

/*
* ------------------------------------------------------------------
*       PBLAS level3
* ------------------------------------------------------------------
*/
#define    HSCAL_PXSYRKA_INIT_LLDS( \
                  notran, \
                  N, K, \
                  DESCA, \
                  DESCC, \
                  myrow, nprow \
           ) \
              { \
                 DESCA[LLD_] = max(1, PB_Cnumroc(DESCA[M_], \
                                                 0, \
                                                 DESCA[IMB_], \
                                                 DESCA[MB_], \
                                                 myrow, \
                                                 DESCA[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCC[LLD_] = max(1, PB_Cnumroc(DESCC[M_], \
                                                 0, \
                                                 DESCC[IMB_], \
                                                 DESCC[MB_], \
                                                 myrow, \
                                                 DESCC[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXSYRKA_ALLOC_INTER_DATA( \
                Cd0, \
                DBUFA, \
                WACd0, \
                WARd0, \
                WARsum, \
                WACsum, \
                Cmp, \
                Cnq, \
                nprow, npcol \
           ) \
           { \
             Cd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Cd0 == NULL) \
             { \
                break; \
             } \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                free(Cd0); \
                break; \
             } \
             WACd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WACd0 == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                break; \
             } \
             WARd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WARd0 == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(WACd0); \
                break; \
             } \
             WARsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WARsum == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(WACd0); \
                free(WARd0); \
                break; \
             } \
             WACsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WACsum == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(WACd0); \
                free(WARd0); \
                free(WARsum); \
                break; \
             } \
             Cmp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cmp == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(WACd0); \
                free(WARd0); \
                free(WARsum); \
                free(WACsum); \
                break; \
             } \
             Cnq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cnq == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(WACd0); \
                free(WARd0); \
                free(WARsum); \
                free(WACsum); \
                free(Cmp); \
                break; \
             } \
           }

#define    HSCAL_PXSYRKA_FREE_INTER_DATA( \
                Cd0, \
                DBUFA, \
                WACd0, \
                WARd0, \
                WARsum, \
                WACsum, \
                Cmp, \
                Cnq \
           ) \
           { \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(WACd0); \
                free(WARd0); \
                free(WARsum); \
                free(WACsum); \
                free(Cmp); \
                free(Cnq); \
             } \
           }

#define    HSCAL_PXSYR2KA_INIT_LLDS( \
                  notran, \
                  N, K, \
                  DESCA, \
                  DESCB, \
                  DESCC, \
                  myrow, nprow \
           ) \
              { \
                 DESCA[LLD_] = max(1, PB_Cnumroc(DESCA[M_], \
                                                 0, \
                                                 DESCA[IMB_], \
                                                 DESCA[MB_], \
                                                 myrow, \
                                                 DESCA[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCB[LLD_] = max(1, PB_Cnumroc(DESCB[M_], \
                                                 0, \
                                                 DESCB[IMB_], \
                                                 DESCB[MB_], \
                                                 myrow, \
                                                 DESCB[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCC[LLD_] = max(1, PB_Cnumroc(DESCC[M_], \
                                                 0, \
                                                 DESCC[IMB_], \
                                                 DESCC[MB_], \
                                                 myrow, \
                                                 DESCC[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXSYR2KA_ALLOC_INTER_DATA( \
                Cd0, \
                DBUFA, \
                DBUFB, \
                WACd0, \
                WARd0, \
                WBCd0, \
                WBRd0, \
                WARsum, \
                WACsum, \
                WBRsum, \
                WBCsum, \
                Cmp, \
                Cnq, \
                AnpD, \
                BnpD, \
                nprow, npcol \
           ) \
           { \
             Cd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Cd0 == NULL) \
             { \
                break; \
             } \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                free(Cd0); \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                break; \
             } \
             WACd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WACd0 == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                break; \
             } \
             WARd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WARd0 == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                break; \
             } \
             WBCd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBCd0 == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                break; \
             } \
             WBRd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBRd0 == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                break; \
             } \
             WARsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WARsum == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                free(WBRd0); \
                break; \
             } \
             WACsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WACsum == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                free(WBRd0); \
                free(WARsum); \
                break; \
             } \
             WBRsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBRsum == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                free(WBRd0); \
                free(WARsum); \
                free(WACsum); \
                break; \
             } \
             WBCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBCsum == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                free(WBRd0); \
                free(WARsum); \
                free(WACsum); \
                free(WBRsum); \
                break; \
             } \
             Cmp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cmp == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                free(WBRd0); \
                free(WARsum); \
                free(WACsum); \
                free(WBRsum); \
                free(WBCsum); \
                break; \
             } \
             Cnq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cnq == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                free(WBRd0); \
                free(WARsum); \
                free(WACsum); \
                free(WBRsum); \
                free(WBCsum); \
                free(Cmp); \
                break; \
             } \
             AnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (AnpD == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                free(WBRd0); \
                free(WARsum); \
                free(WACsum); \
                free(WBRsum); \
                free(WBCsum); \
                free(Cmp); \
                free(Cnq); \
                break; \
             } \
             BnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (BnpD == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                free(WBRd0); \
                free(WARsum); \
                free(WACsum); \
                free(WBRsum); \
                free(WBCsum); \
                free(Cmp); \
                free(Cnq); \
                free(AnpD); \
                break; \
             } \
           }

#define    HSCAL_PXSYR2KA_FREE_INTER_DATA( \
                Cd0, \
                DBUFA, \
                DBUFB, \
                WACd0, \
                WARd0, \
                WBCd0, \
                WBRd0, \
                WARsum, \
                WACsum, \
                WBRsum, \
                WBCsum, \
                Cmp, \
                Cnq, \
                AnpD, \
                BnpD \
           ) \
           { \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WACd0); \
                free(WARd0); \
                free(WBCd0); \
                free(WBRd0); \
                free(WARsum); \
                free(WACsum); \
                free(WBRsum); \
                free(WBCsum); \
                free(Cmp); \
                free(Cnq); \
                free(AnpD); \
                free(BnpD); \
             } \
           }

#define    HSCAL_PXSYRKAC_INIT_LLDS             HSCAL_PXSYRKA_INIT_LLDS

#define    HSCAL_PXSYRKAC_ALLOC_INTER_DATA( \
                Ad0, \
                DBUFA, \
                WAd, \
                WCd, \
                WCsum, \
                Amp0, \
                Anq0, \
                nprow, npcol \
           ) \
           { \
             Ad0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0 == NULL) \
             { \
                break; \
             } \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                free(Ad0); \
                break; \
             } \
             WAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WAd == NULL) \
             { \
                free(Ad0); \
                free(DBUFA); \
                break; \
             } \
             WCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WCd == NULL) \
             { \
                free(Ad0); \
                free(DBUFA); \
                free(WAd); \
                break; \
             } \
             WCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WCsum == NULL) \
             { \
                free(Ad0); \
                free(DBUFA); \
                free(WAd); \
                free(WCd); \
                break; \
             } \
             Amp0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp0 == NULL) \
             { \
                free(Ad0); \
                free(DBUFA); \
                free(WAd); \
                free(WCd); \
                free(WCsum); \
                break; \
             } \
             Anq0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq0 == NULL) \
             { \
                free(Ad0); \
                free(DBUFA); \
                free(WAd); \
                free(WCd); \
                free(WCsum); \
                free(Amp0); \
                break; \
             } \
           }

#define    HSCAL_PXSYRKAC_FREE_INTER_DATA( \
                Ad0, \
                DBUFA, \
                WAd, \
                WCd, \
                WCsum, \
                Amp0, \
                Anq0 \
           ) \
           { \
             { \
                free(Ad0); \
                free(DBUFA); \
                free(WAd); \
                free(WCd); \
                free(WCsum); \
                free(Amp0); \
                free(Anq0); \
             } \
           }

#define    HSCAL_PXSYR2KAC_INIT_LLDS             HSCAL_PXSYR2KA_INIT_LLDS

#define    HSCAL_PXSYR2KAC_ALLOC_INTER_DATA( \
                Ad0, \
                Bd0, \
                DBUFA, \
                DBUFB, \
                WAd, \
                WBd, \
                WACd, \
                WBCd, \
                WACsum, \
                WBCsum, \
                Amp0, \
                Anq0, \
                Bmp0, \
                Bnq0, \
                nprow, npcol \
           ) \
           { \
             Ad0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0 == NULL) \
             { \
                break; \
             } \
             Bd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Bd0 == NULL) \
             { \
                break; \
             } \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                break; \
             } \
             WAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WAd == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                break; \
             } \
             WBd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBd == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                break; \
             } \
             WACd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WACd == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                break; \
             } \
             WBCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBCd == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WACd); \
                break; \
             } \
             WACsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WACsum == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WACd); \
                free(WBCd); \
                break; \
             } \
             WBCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBCsum == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WACd); \
                free(WBCd); \
                free(WACsum); \
                break; \
             } \
             Amp0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp0 == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WACd); \
                free(WBCd); \
                free(WACsum); \
                free(WBCsum); \
                break; \
             } \
             Anq0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq0 == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WACd); \
                free(WBCd); \
                free(WACsum); \
                free(WBCsum); \
                free(Amp0); \
                break; \
             } \
             Bmp0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bmp0 == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WACd); \
                free(WBCd); \
                free(WACsum); \
                free(WBCsum); \
                free(Amp0); \
                free(Anq0); \
                break; \
             } \
             Bnq0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bnq0 == NULL) \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WACd); \
                free(WBCd); \
                free(WACsum); \
                free(WBCsum); \
                free(Amp0); \
                free(Anq0); \
                free(Bmp0); \
                break; \
             } \
           }

#define    HSCAL_PXSYR2KAC_FREE_INTER_DATA( \
                Ad0, \
                Bd0, \
                DBUFA, \
                DBUFB, \
                WAd, \
                WBd, \
                WACd, \
                WBCd, \
                WACsum, \
                WBCsum, \
                Amp0, \
                Anq0, \
                Bmp0, \
                Bnq0 \
           ) \
           { \
             { \
                free(Ad0); \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WACd); \
                free(WBCd); \
                free(WACsum); \
                free(WBCsum); \
                free(Amp0); \
                free(Anq0); \
                free(Bmp0); \
                free(Bnq0); \
             } \
           }

#define    HSCAL_PXSYRK_INIT_LLDS( \
                  DESCA, \
                  DESCC, \
                  myrow, nprow \
           ) \
              { \
                 DESCA[LLD_] = max(1, PB_Cnumroc(DESCA[M_], \
                                                 0, \
                                                 DESCA[IMB_], \
                                                 DESCA[MB_], \
                                                 myrow, \
                                                 DESCA[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCC[LLD_] = max(1, PB_Cnumroc(DESCC[M_], \
                                                 0, \
                                                 DESCC[IMB_], \
                                                 DESCC[MB_], \
                                                 myrow, \
                                                 DESCC[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXHERK_INIT_LLDS             HSCAL_PXSYRK_INIT_LLDS

#define    HSCAL_PXSYR2K_INIT_LLDS( \
                  DESCA, \
                  DESCB, \
                  DESCC, \
                  myrow, nprow \
           ) \
              { \
                 DESCA[LLD_] = max(1, PB_Cnumroc(DESCA[M_], \
                                                 0, \
                                                 DESCA[IMB_], \
                                                 DESCA[MB_], \
                                                 myrow, \
                                                 DESCA[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCB[LLD_] = max(1, PB_Cnumroc(DESCB[M_], \
                                                 0, \
                                                 DESCB[IMB_], \
                                                 DESCB[MB_], \
                                                 myrow, \
                                                 DESCB[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCC[LLD_] = max(1, PB_Cnumroc(DESCC[M_], \
                                                 0, \
                                                 DESCC[IMB_], \
                                                 DESCC[MB_], \
                                                 myrow, \
                                                 DESCC[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXHER2K_INIT_LLDS             HSCAL_PXSYR2K_INIT_LLDS

#define    HSCAL_PXSYMM_INIT_LLDS( \
                  DESCA, \
                  DESCB, \
                  DESCC, \
                  myrow, nprow \
           ) \
              { \
                 DESCA[LLD_] = max(1, PB_Cnumroc(DESCA[M_], \
                                                 0, \
                                                 DESCA[IMB_], \
                                                 DESCA[MB_], \
                                                 myrow, \
                                                 DESCA[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCB[LLD_] = max(1, PB_Cnumroc(DESCB[M_], \
                                                 0, \
                                                 DESCB[IMB_], \
                                                 DESCB[MB_], \
                                                 myrow, \
                                                 DESCB[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCC[LLD_] = max(1, PB_Cnumroc(DESCC[M_], \
                                                 0, \
                                                 DESCC[IMB_], \
                                                 DESCC[MB_], \
                                                 myrow, \
                                                 DESCC[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXHEMM_INIT_LLDS             HSCAL_PXSYMM_INIT_LLDS

#define    HSCAL_PXSYMMBC_ALLOC_INTER_DATA( \
                Ad0, \
                DBUFB, \
                DBUFC, \
                WBCd, \
                WBRd, \
                WCCd, \
                WCRd, \
                WCRsum, \
                WCCsum, \
                Amp, \
                Anq, \
                BnpD, \
                CnpD, \
                nprow, npcol \
           ) \
           { \
             Ad0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0 == NULL) \
             { \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Ad0); \
                break; \
             } \
             DBUFC = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFC == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                break; \
             } \
             WBCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBCd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                break; \
             } \
             WBRd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBRd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                break; \
             } \
             WCCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WCCd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                free(WBRd); \
                break; \
             } \
             WCRd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WCRd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                free(WBRd); \
                free(WCCd); \
                break; \
             } \
             WCRsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WCRsum == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                free(WBRd); \
                free(WCCd); \
                free(WCRd); \
                break; \
             } \
             WCCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WCCsum == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                free(WBRd); \
                free(WCCd); \
                free(WCRd); \
                free(WCRsum); \
                break; \
             } \
             Amp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                free(WBRd); \
                free(WCCd); \
                free(WCRd); \
                free(WCRsum); \
                free(WCCsum); \
                break; \
             } \
             Anq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                free(WBRd); \
                free(WCCd); \
                free(WCRd); \
                free(WCRsum); \
                free(WCCsum); \
                free(Amp); \
                break; \
             } \
             BnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (BnpD == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                free(WBRd); \
                free(WCCd); \
                free(WCRd); \
                free(WCRsum); \
                free(WCCsum); \
                free(Amp); \
                free(Anq); \
                break; \
             } \
             CnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (CnpD == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                free(WBRd); \
                free(WCCd); \
                free(WCRd); \
                free(WCRsum); \
                free(WCCsum); \
                free(Amp); \
                free(Anq); \
                free(BnpD); \
                break; \
             } \
           }

#define    HSCAL_PXSYMMBC_FREE_INTER_DATA( \
                Ad0, \
                DBUFB, \
                DBUFC, \
                WBCd, \
                WBRd, \
                WCCd, \
                WCRd, \
                WCRsum, \
                WCCsum, \
                Amp, \
                Anq, \
                BnpD, \
                CnpD \
           ) \
           { \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBCd); \
                free(WBRd); \
                free(WCCd); \
                free(WCRd); \
                free(WCRsum); \
                free(WCCsum); \
                free(Amp); \
                free(Anq); \
                free(BnpD); \
                free(CnpD); \
             } \
           }

#define    HSCAL_PXSYMMAB_ALLOC_INTER_DATA( \
                Bd0, \
                Cd0, \
                DBUFA, \
                DBUFB, \
                WABd, \
                WACd, \
                WBCd, \
                WBCsum, \
                Bmp0, \
                Bnq0, \
                Cmp0, \
                Cnq0, \
                nprow, npcol \
           ) \
           { \
             Bd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Bd0 == NULL) \
             { \
                break; \
             } \
             Cd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Cd0 == NULL) \
             { \
                break; \
             } \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                break; \
             } \
             WABd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WABd == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                break; \
             } \
             WACd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WACd == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WABd); \
                break; \
             } \
             WBCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBCd == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WABd); \
                free(WACd); \
                break; \
             } \
             WBCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBCsum == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WABd); \
                free(WACd); \
                free(WBCd); \
                break; \
             } \
             Bmp0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bmp0 == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WABd); \
                free(WACd); \
                free(WBCd); \
                free(WBCsum); \
                break; \
             } \
             Bnq0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bnq0 == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WABd); \
                free(WACd); \
                free(WBCd); \
                free(WBCsum); \
                free(Bmp0); \
                break; \
             } \
             Cmp0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cmp0 == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WABd); \
                free(WACd); \
                free(WBCd); \
                free(WBCsum); \
                free(Bmp0); \
                free(Bnq0); \
                break; \
             } \
             Cnq0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cnq0 == NULL) \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WABd); \
                free(WACd); \
                free(WBCd); \
                free(WBCsum); \
                free(Bmp0); \
                free(Bnq0); \
                free(Cmp0); \
                break; \
             } \
           }

#define    HSCAL_PXSYMMAB_FREE_INTER_DATA( \
                Bd0, \
                Cd0, \
                DBUFA, \
                DBUFB, \
                WABd, \
                WACd, \
                WBCd, \
                WBCsum, \
                Bmp0, \
                Bnq0, \
                Cmp0, \
                Cnq0 \
           ) \
           { \
             { \
                free(Bd0); \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WABd); \
                free(WACd); \
                free(WBCd); \
                free(WBCsum); \
                free(Bmp0); \
                free(Bnq0); \
                free(Cmp0); \
                free(Cnq0); \
             } \
           }

#define    HSCAL_PXTRANC_INIT_LLDS             HSCAL_PXSYRK_INIT_LLDS
#define    HSCAL_PXTRANU_INIT_LLDS             HSCAL_PXSYRK_INIT_LLDS
#define    HSCAL_PXTRAN_INIT_LLDS              HSCAL_PXSYRK_INIT_LLDS
#define    HSCAL_PXPTRAN_INIT_LLDS             HSCAL_PXSYRK_INIT_LLDS

#define    HSCAL_PXPTRAN_ALLOC_INTER_DATA( \
                DBUFA, \
                DBUFC, \
                AnpD, \
                CnpD, \
                nprow, npcol \
           ) \
           { \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                break; \
             } \
             DBUFC = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFC == NULL) \
             { \
                free(DBUFA); \
                break; \
             } \
             AnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (AnpD == NULL) \
             { \
                free(DBUFA); \
                free(DBUFC); \
                break; \
             } \
             CnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (CnpD == NULL) \
             { \
                free(DBUFA); \
                free(DBUFC); \
                free(AnpD); \
                break; \
             } \
           }

#define    HSCAL_PXPTRAN_FREE_INTER_DATA( \
                DBUFA, \
                DBUFC, \
                AnpD, \
                CnpD \
           ) \
           { \
             { \
                free(DBUFA); \
                free(DBUFC); \
                free(AnpD); \
                free(CnpD); \
             } \
           }

#define    HSCAL_PXPTRMMB_INIT_LLDS( \
                  DESCA, \
                  DESCB, \
                  myrow, nprow \
           ) \
              { \
                 DESCA[LLD_] = max(1, PB_Cnumroc(DESCA[M_], \
                                                 0, \
                                                 DESCA[IMB_], \
                                                 DESCA[MB_], \
                                                 myrow, \
                                                 DESCA[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCB[LLD_] = max(1, PB_Cnumroc(DESCB[M_], \
                                                 0, \
                                                 DESCB[IMB_], \
                                                 DESCB[MB_], \
                                                 myrow, \
                                                 DESCB[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXPTRMMB_ALLOC_INTER_DATA( \
                Ad0, \
                DBUFB, \
                WCd, \
                WBd, \
                WCpbY, \
                WCsum, \
                Amp, \
                Anq, \
                nprow, npcol \
           ) \
           { \
             Ad0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0 == NULL) \
             { \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Ad0); \
                break; \
             } \
             WCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WCd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                break; \
             } \
             WBd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WCd); \
                break; \
             } \
             WCpbY = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WCpbY == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WCd); \
                free(WBd); \
                break; \
             } \
             WCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WCsum == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WCd); \
                free(WBd); \
                free(WCpbY); \
                break; \
             } \
             Amp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WCd); \
                free(WBd); \
                free(WCpbY); \
                free(WCsum); \
                break; \
             } \
             Anq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WCd); \
                free(WBd); \
                free(WCpbY); \
                free(WCsum); \
                free(Amp); \
                break; \
             } \
           }

#define    HSCAL_PXPTRMMB_FREE_INTER_DATA( \
                Ad0, \
                DBUFB, \
                WCd, \
                WBd, \
                WCpbY, \
                WCsum, \
                Amp, \
                Anq \
           ) \
           { \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WCd); \
                free(WBd); \
                free(WCpbY); \
                free(WCsum); \
                free(Amp); \
                free(Anq); \
             } \
           }

#define    HSCAL_PXPTRMMAB_INIT_LLDS             HSCAL_PXPTRMMB_INIT_LLDS

#define    HSCAL_PXPTRMMAB_ALLOC_INTER_DATA( \
                Bd0, \
                DBUFA, \
                DBUFB, \
                WAd, \
                WBd, \
                WBsum, \
                Bmp0, \
                Bnq0, \
                nprow, npcol \
           ) \
           { \
             Bd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Bd0 == NULL) \
             { \
                break; \
             } \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                free(Bd0); \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                break; \
             } \
             WAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WAd == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                break; \
             } \
             WBd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBd == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                break; \
             } \
             WBsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBsum == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                break; \
             } \
             Bmp0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bmp0 == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WBsum); \
                break; \
             } \
             Bnq0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bnq0 == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WBsum); \
                free(Bmp0); \
                break; \
             } \
           }

#define    HSCAL_PXPTRMMAB_FREE_INTER_DATA( \
                Bd0, \
                DBUFA, \
                DBUFB, \
                WAd, \
                WBd, \
                WBsum, \
                Bmp0, \
                Bnq0 \
           ) \
           { \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WBsum); \
                free(Bmp0); \
                free(Bnq0); \
             } \
           }

#define    HSCAL_PXTRMM_INIT_LLDS             HSCAL_PXPTRMMB_INIT_LLDS

#define    HSCAL_PXGEMM_INIT_LLDS             HSCAL_PXSYR2K_INIT_LLDS

#define    HSCAL_PXPGEMMAB_ALLOC_INTER_DATA( \
                Cd0, \
                DBUFA, \
                DBUFB, \
                WAd0, \
                WBd0, \
                WAsum, \
                WBsum, \
                Cmp, \
                Cnq, \
                AnpD, \
                BnpD, \
                nprow, npcol \
           ) \
           { \
             Cd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Cd0 == NULL) \
             { \
                break; \
             } \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                free(Cd0); \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                break; \
             } \
             WAd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WAd0 == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                break; \
             } \
             WBd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBd0 == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd0); \
                break; \
             } \
             WAsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WAsum == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd0); \
                free(WBd0); \
                break; \
             } \
             WBsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBsum == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd0); \
                free(WBd0); \
                free(WAsum); \
                break; \
             } \
             Cmp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cmp == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd0); \
                free(WBd0); \
                free(WAsum); \
                free(WBsum); \
                break; \
             } \
             Cnq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cnq == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd0); \
                free(WBd0); \
                free(WAsum); \
                free(WBsum); \
                free(Cmp); \
                break; \
             } \
             AnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (AnpD == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd0); \
                free(WBd0); \
                free(WAsum); \
                free(WBsum); \
                free(Cmp); \
                free(Cnq); \
                break; \
             } \
             BnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (BnpD == NULL) \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd0); \
                free(WBd0); \
                free(WAsum); \
                free(WBsum); \
                free(Cmp); \
                free(Cnq); \
                free(AnpD); \
                break; \
             } \
           }

#define    HSCAL_PXPGEMMAB_FREE_INTER_DATA( \
                Cd0, \
                DBUFA, \
                DBUFB, \
                WAd0, \
                WBd0, \
                WAsum, \
                WBsum, \
                Cmp, \
                Cnq, \
                AnpD, \
                BnpD \
           ) \
           { \
             { \
                free(Cd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd0); \
                free(WBd0); \
                free(WAsum); \
                free(WBsum); \
                free(Cmp); \
                free(Cnq); \
                free(AnpD); \
                free(BnpD); \
             } \
           }

#define    HSCAL_PXPGEMMAC_ALLOC_INTER_DATA( \
                Bd0, \
                DBUFA, \
                DBUFC, \
                WAd, \
                WBd, \
                WCsum, \
                Cnq, \
                AnpD, \
                Bmp, \
                Bnq, \
                nprow, npcol \
           ) \
           { \
             Bd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Bd0 == NULL) \
             { \
                break; \
             } \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                free(Bd0); \
                break; \
             } \
             DBUFC = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFC == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                break; \
             } \
             WAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WAd == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFC); \
                break; \
             } \
             WBd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBd == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFC); \
                free(WAd); \
                break; \
             } \
             WCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WCsum == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFC); \
                free(WAd); \
                free(WBd); \
                break; \
             } \
             Cnq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cnq == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFC); \
                free(WAd); \
                free(WBd); \
                free(WCsum); \
                break; \
             } \
             AnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (AnpD == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFC); \
                free(WAd); \
                free(WBd); \
                free(WCsum); \
                free(Cnq); \
                break; \
             } \
             Bmp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bmp == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFC); \
                free(WAd); \
                free(WBd); \
                free(WCsum); \
                free(Cnq); \
                free(AnpD); \
                break; \
             } \
             Bnq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bnq == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFC); \
                free(WAd); \
                free(WBd); \
                free(WCsum); \
                free(Cnq); \
                free(AnpD); \
                free(Bmp); \
                break; \
             } \
           }

#define    HSCAL_PXPGEMMAC_FREE_INTER_DATA( \
                Bd0, \
                DBUFA, \
                DBUFC, \
                WAd, \
                WBd, \
                WCsum, \
                Cnq, \
                AnpD, \
                Bmp, \
                Bnq \
           ) \
           { \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFC); \
                free(WAd); \
                free(WBd); \
                free(WCsum); \
                free(Cnq); \
                free(AnpD); \
                free(Bmp); \
                free(Bnq); \
             } \
           }

#define    HSCAL_PXPGEMMBC_ALLOC_INTER_DATA( \
                Ad0, \
                DBUFB, \
                DBUFC, \
                WBd, \
                WCd, \
                WCsum, \
                Cmp, \
                BnpD, \
                Amp, \
                Anq, \
                nprow, npcol \
           ) \
           { \
             Ad0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0 == NULL) \
             { \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Ad0); \
                break; \
             } \
             DBUFC = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFC == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                break; \
             } \
             WBd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                break; \
             } \
             WCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WCd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBd); \
                break; \
             } \
             WCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WCsum == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBd); \
                free(WCd); \
                break; \
             } \
             Cmp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Cmp == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBd); \
                free(WCd); \
                free(WCsum); \
                break; \
             } \
             BnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (BnpD == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBd); \
                free(WCd); \
                free(WCsum); \
                free(Cmp); \
                break; \
             } \
             Amp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBd); \
                free(WCd); \
                free(WCsum); \
                free(Cmp); \
                free(BnpD); \
                break; \
             } \
             Anq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBd); \
                free(WCd); \
                free(WCsum); \
                free(Cmp); \
                free(BnpD); \
                free(Amp); \
                break; \
             } \
           }

#define    HSCAL_PXPGEMMBC_FREE_INTER_DATA( \
                Ad0, \
                DBUFB, \
                DBUFC, \
                WBd, \
                WCd, \
                WCsum, \
                Cmp, \
                BnpD, \
                Amp, \
                Anq \
           ) \
           { \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(DBUFC); \
                free(WBd); \
                free(WCd); \
                free(WCsum); \
                free(Cmp); \
                free(BnpD); \
                free(Amp); \
                free(Anq); \
             } \
           }

#define    HSCAL_PXGEADD_INIT_LLDS             HSCAL_PXSYRK_INIT_LLDS
#define    HSCAL_PXTRADD_INIT_LLDS             HSCAL_PXSYRK_INIT_LLDS
#define    HSCAL_PXPTRADD_INIT_LLDS            HSCAL_PXSYRK_INIT_LLDS

#define    HSCAL_PXPTRADD_ALLOC_INTER_DATA( \
                DBUFA, \
                nprow, npcol \
           ) \
           { \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                break; \
             } \
           }

#define    HSCAL_PXPTRADD_FREE_INTER_DATA( \
                DBUFA \
           ) \
           { \
             { \
                free(DBUFA); \
             } \
           }

#define    HSCAL_PXPGEADD_INIT_LLDS             HSCAL_PXSYRK_INIT_LLDS

#define    HSCAL_PXPGEADD_ALLOC_INTER_DATA( \
                DBUFA, \
                DBUFC, \
                AnpD, \
                CnpD, \
                nprow, npcol \
           ) \
           { \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                break; \
             } \
             DBUFC = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFC == NULL) \
             { \
                free(DBUFA); \
                break; \
             } \
             AnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (AnpD == NULL) \
             { \
                free(DBUFA); \
                free(DBUFC); \
                break; \
             } \
             CnpD = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (CnpD == NULL) \
             { \
                free(DBUFA); \
                free(DBUFC); \
                free(AnpD); \
                break; \
             } \
           }

#define    HSCAL_PXPGEADD_FREE_INTER_DATA( \
                DBUFA, \
                DBUFC, \
                AnpD, \
                CnpD \
           ) \
           { \
             { \
                free(DBUFA); \
                free(DBUFC); \
                free(AnpD); \
                free(CnpD); \
             } \
           }

#define    HSCAL_PXCPTRSMAB_INIT_LLDS             HSCAL_PXPTRMMB_INIT_LLDS

#define    HSCAL_PXCPTRSMAB_ALLOC_INTER_DATA( \
                Bd0, \
                DBUFA, \
                DBUFB, \
                WAd, \
                WBd, \
                WBsum, \
                Bmp0, \
                Bnq0, \
                nprow, npcol \
           ) \
           { \
             Bd0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Bd0 == NULL) \
             { \
                break; \
             } \
             DBUFA = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFA == NULL) \
             { \
                free(Bd0); \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                break; \
             } \
             WAd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WAd == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                break; \
             } \
             WBd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBd == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                break; \
             } \
             WBsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBsum == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                break; \
             } \
             Bmp0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bmp0 == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WBsum); \
                break; \
             } \
             Bnq0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bnq0 == NULL) \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WBsum); \
                free(Bmp0); \
                break; \
             } \
           }

#define    HSCAL_PXCPTRSMAB_FREE_INTER_DATA( \
                Bd0, \
                DBUFA, \
                DBUFB, \
                WAd, \
                WBd, \
                WBsum, \
                Bmp0, \
                Bnq0 \
           ) \
           { \
             { \
                free(Bd0); \
                free(DBUFA); \
                free(DBUFB); \
                free(WAd); \
                free(WBd); \
                free(WBsum); \
                free(Bmp0); \
                free(Bnq0); \
             } \
           }

#define    HSCAL_PXCPTRSMB_INIT_LLDS( \
                  DESCA, \
                  DESCB, \
                  myrow, nprow \
           ) \
              { \
                 DESCA[LLD_] = max(1, PB_Cnumroc(DESCA[M_], \
                                                 0, \
                                                 DESCA[IMB_], \
                                                 DESCA[MB_], \
                                                 myrow, \
                                                 DESCA[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
                 DESCB[LLD_] = max(1, PB_Cnumroc(DESCB[M_], \
                                                 0, \
                                                 DESCB[IMB_], \
                                                 DESCB[MB_], \
                                                 myrow, \
                                                 DESCB[RSRC_], \
                                                 nprow \
                               ) \
                 ); \
              }

#define    HSCAL_PXCPTRSMB_ALLOC_INTER_DATA( \
                Ad0, \
                DBUFB, \
                WBCd, \
                WBRd, \
                WBCsum, \
                WBCapbX, \
                WBRsum, \
                WBRapbX, \
                Anp, \
                Anq, \
                nprow, \
                npcol \
           ) \
           { \
             Ad0 = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (Ad0 == NULL) \
             { \
                break; \
             } \
             DBUFB = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (DBUFB == NULL) \
             { \
                free(Ad0); \
                break; \
             } \
             WBCd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBCd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                break; \
             } \
             WBRd = (int(*)[DLEN_])malloc(nprow*npcol*sizeof(int[DLEN_])); \
             if (WBRd == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WBCd); \
                break; \
             } \
             WBCsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBCsum == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WBCd); \
                free(WBRd); \
                break; \
             } \
             WBCapbX = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBCapbX == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WBCd); \
                free(WBRd); \
                free(WBCsum); \
                break; \
             } \
             WBRsum = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBRsum == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WBCd); \
                free(WBRd); \
                free(WBCsum); \
                free(WBCapbX); \
                break; \
             } \
             WBRapbX = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (WBRapbX == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WBCd); \
                free(WBRd); \
                free(WBCsum); \
                free(WBCapbX); \
                free(WBRsum); \
                break; \
             } \
             Anp = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anp == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WBCd); \
                free(WBRd); \
                free(WBCsum); \
                free(WBCapbX); \
                free(WBRsum); \
                free(WBRapbX); \
                break; \
             } \
             Anq = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq == NULL) \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WBCd); \
                free(WBRd); \
                free(WBCsum); \
                free(WBCapbX); \
                free(WBRsum); \
                free(WBRapbX); \
                free(Anp); \
                break; \
             } \
           }

#define    HSCAL_PXCPTRSMB_FREE_INTER_DATA( \
                Ad0, \
                DBUFB, \
                WBCd, \
                WBRd, \
                WBCsum, \
                WBCapbX, \
                WBRsum, \
                WBRapbX, \
                Anp, \
                Anq \
           ) \
           { \
             { \
                free(Ad0); \
                free(DBUFB); \
                free(WBCd); \
                free(WBRd); \
                free(WBCsum); \
                free(WBCapbX); \
                free(WBRsum); \
                free(WBRapbX); \
                free(Anp); \
                free(Anq); \
             } \
           }

#define    HSCAL_PXCPTRSMAB0_INIT_LLDS             HSCAL_PXSYR2K_INIT_LLDS
#define    HSCAL_PXCPTRSMAB00_INIT_LLDS            HSCAL_PXSYRK_INIT_LLDS

#define    HSCAL_PXCPTRSMAB0_ALLOC_INTER_DATA( \
                Amp0, \
                Anq0, \
                Bmp0, \
                Bnq0, \
                nprow, npcol \
           ) \
           { \
             Amp0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Amp0 == NULL) \
             { \
                break; \
             } \
             Anq0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Anq0 == NULL) \
             { \
                free(Amp0); \
                break; \
             } \
             Bmp0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bmp0 == NULL) \
             { \
                free(Amp0); \
                free(Anq0); \
                break; \
             } \
             Bnq0 = (int*)malloc(nprow*npcol*sizeof(int)); \
             if (Bnq0 == NULL) \
             { \
                free(Amp0); \
                free(Anq0); \
                free(Bmp0); \
                break; \
             } \
           }

#define    HSCAL_PXCPTRSMAB0_FREE_INTER_DATA( \
                Amp0, \
                Anq0, \
                Bmp0, \
                Bnq0 \
           ) \
           { \
             { \
                free(Amp0); \
                free(Anq0); \
                free(Bmp0); \
                free(Bnq0); \
             } \
           }

#define    HSCAL_PXCPTRSM_INIT_LLDS             HSCAL_PXPTRSV_INIT_LLDS
#define    HSCAL_PXCPTRSM_ALLOC_INTER_DATA      HSCAL_PXPTRSV_ALLOC_INTER_DATA
#define    HSCAL_PXCPTRSM_FREE_INTER_DATA       HSCAL_PXPTRSV_FREE_INTER_DATA
#define    HSCAL_PXTRSM_INIT_LLDS               HSCAL_PXPTRMMB_INIT_LLDS

#define    HSCAL_PXCPTRSMAB1_INIT_LLDS          HSCAL_PXSYR2K_INIT_LLDS
#define    HSCAL_PXCPTRSMAB1_ALLOC_INTER_DATA   HSCAL_PXCPTRSMAB0_ALLOC_INTER_DATA
#define    HSCAL_PXCPTRSMAB1_FREE_INTER_DATA    HSCAL_PXCPTRSMAB0_FREE_INTER_DATA

#endif  /* __HSCALAPACK_PBLAS_MPC_MACROS_HH_ */

