
/*******************************************************************
*                                                                  *
*                     Heterogeneous ScaLAPACK PBLAS                *
*                         Group pauto functions                    *
*                 =====================================            *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_PBLAS_PAUTOF_INCLUDE_HH
#define __HMPI_SCALAPACK_PBLAS_PAUTOF_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 1
*       HeteroMPI group calls
* ------------------------------------------------------------------
*/
int hscal_pcswap_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdswap_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psswap_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzswap_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcscal_group_heuristic_pauto_create(
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcsscal_group_heuristic_pauto_create(
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdscal_group_heuristic_pauto_create(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psscal_group_heuristic_pauto_create(
   int * N,
   float  * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzscal_group_heuristic_pauto_create(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzdscal_group_heuristic_pauto_create(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pccopy_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdcopy_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_picopy_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pscopy_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzcopy_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcaxpy_group_heuristic_pauto_create(
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdaxpy_group_heuristic_pauto_create(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psaxpy_group_heuristic_pauto_create(
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzaxpy_group_heuristic_pauto_create(
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcamax_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdamax_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psamax_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzamax_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdasum_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pscasum_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdzasum_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psasum_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdnrm2_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pscnrm2_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdznrm2_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psnrm2_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pddot_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psdot_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcdotc_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcdotu_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzdotc_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzdotu_group_heuristic_pauto_create(
   int * N,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 2
*       HeteroMPI group calls
* ------------------------------------------------------------------
*/
int hscal_pcgemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdgemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psgemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzgemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcagemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdagemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psagemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzagemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdsymv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pssymv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzhemv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pchemv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzahemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcahemv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdasymv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psasymv_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pctrmv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdtrmv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pstrmv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pztrmv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcatrmv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psatrmv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   float * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdatrmv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzatrmv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   double * BETA,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pctrsv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdtrsv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pstrsv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pztrsv_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * N,
   int * IA,
   int * JA,
   int * DESCA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psger_group_heuristic_pauto_create(
   int * M,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdger_group_heuristic_pauto_create(
   int * M,
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcgerc_group_heuristic_pauto_create(
   int * M,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzgerc_group_heuristic_pauto_create(
   int * M,
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcgeru_group_heuristic_pauto_create(
   int * M,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzgeru_group_heuristic_pauto_create(
   int * M,
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcher_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzher_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcher2_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzher2_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pssyr_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdsyr_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pssyr2_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   float * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdsyr2_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   int * N,
   double * ALPHA,
   int * IX,
   int * JX,
   int * DESCX,
   int * INCX,
   int * IY,
   int * JY,
   int * DESCY,
   int * INCY,
   int * IA,
   int * JA,
   int * DESCA,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

/*
* ------------------------------------------------------------------
*       PBLAS LEVEL 3
*       HeteroMPI group calls
* ------------------------------------------------------------------
*/
int hscal_pcherk_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzherk_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcsyrk_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzsyrk_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pssyrk_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdsyrk_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcher2k_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzher2k_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcsyr2k_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzsyr2k_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pssyr2k_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdsyr2k_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * N,
   int * K,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pchemm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzhemm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcsymm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdsymm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pssymm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzsymm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pctranc_group_heuristic_pauto_create(
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pztranc_group_heuristic_pauto_create(
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pctranu_group_heuristic_pauto_create(
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pztranu_group_heuristic_pauto_create(
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pstran_group_heuristic_pauto_create(
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdtran_group_heuristic_pauto_create(
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pctrmm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pstrmm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdtrmm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pztrmm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcgemm_group_heuristic_pauto_create(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int * M,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdgemm_group_heuristic_pauto_create(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int * M,
   int * N,
   int * K,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psgemm_group_heuristic_pauto_create(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int * M,
   int * N,
   int * K,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzgemm_group_heuristic_pauto_create(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int * M,
   int * N,
   int * K,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pctradd_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdtradd_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pstradd_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pztradd_group_heuristic_pauto_create(
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pcgeadd_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdgeadd_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_psgeadd_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   float * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pzgeadd_group_heuristic_pauto_create(
   F_CHAR_T TRANS,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pctrsm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pdtrsm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pstrsm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   float * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

int hscal_pztrsm_group_heuristic_pauto_create(
   F_CHAR_T SIDE,
   F_CHAR_T UPLO,
   F_CHAR_T TRANS,
   F_CHAR_T DIAG,
   int * M,
   int * N,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   HMPI_Group* gid,
   const HMPI_Model* model,
   HMPI_Heuristic_function hfunc
);

#endif

