
/*******************************************************************
*                                                                  *
*                 Heterogeneous PBLAS Performance models           *
*                         (INTERNAL)                               *
*                 ==========================================       *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_PBLAS_PMODELS_INCLUDE_HH
#define __HMPI_SCALAPACK_PBLAS_PMODELS_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       Performance models of PBLAS level1 routines
* ------------------------------------------------------------------
*/
extern        HMPI_Model              MPC_NetType_pcswap;
#define       hscal_model_pcswap      (&MPC_NetType_pcswap)

extern        HMPI_Model              MPC_NetType_pdswap;
#define       hscal_model_pdswap      (&MPC_NetType_pdswap)

extern        HMPI_Model              MPC_NetType_psswap;
#define       hscal_model_psswap      (&MPC_NetType_psswap)

extern        HMPI_Model              MPC_NetType_pzswap;
#define       hscal_model_pzswap      (&MPC_NetType_pzswap)

extern        HMPI_Model              MPC_NetType_pcsscal;
#define       hscal_model_pcsscal     (&MPC_NetType_pcsscal)

extern        HMPI_Model              MPC_NetType_pcscal;
#define       hscal_model_pcscal      (&MPC_NetType_pcscal)

extern        HMPI_Model              MPC_NetType_pdscal;
#define       hscal_model_pdscal      (&MPC_NetType_pdscal)

extern        HMPI_Model              MPC_NetType_pzdscal;
#define       hscal_model_pzdscal     (&MPC_NetType_pzdscal)

extern        HMPI_Model              MPC_NetType_psscal;
#define       hscal_model_psscal      (&MPC_NetType_psscal)

extern        HMPI_Model              MPC_NetType_pzscal;
#define       hscal_model_pzscal      (&MPC_NetType_pzscal)

extern        HMPI_Model              MPC_NetType_pccopy;
#define       hscal_model_pccopy      (&MPC_NetType_pccopy)

extern        HMPI_Model              MPC_NetType_pdcopy;
#define       hscal_model_pdcopy      (&MPC_NetType_pdcopy)

extern        HMPI_Model              MPC_NetType_picopy;
#define       hscal_model_picopy      (&MPC_NetType_picopy)

extern        HMPI_Model              MPC_NetType_pscopy;
#define       hscal_model_pscopy      (&MPC_NetType_pscopy)

extern        HMPI_Model              MPC_NetType_pzcopy;
#define       hscal_model_pzcopy      (&MPC_NetType_pzcopy)

extern        HMPI_Model              MPC_NetType_pcaxpy;
#define       hscal_model_pcaxpy      (&MPC_NetType_pcaxpy)

extern        HMPI_Model              MPC_NetType_pdaxpy;
#define       hscal_model_pdaxpy      (&MPC_NetType_pdaxpy)

extern        HMPI_Model              MPC_NetType_psaxpy;
#define       hscal_model_psaxpy      (&MPC_NetType_psaxpy)

extern        HMPI_Model              MPC_NetType_pzaxpy;
#define       hscal_model_pzaxpy      (&MPC_NetType_pzaxpy)

extern        HMPI_Model              MPC_NetType_pcamax;
#define       hscal_model_pcamax      (&MPC_NetType_pcamax)

extern        HMPI_Model              MPC_NetType_pdamax;
#define       hscal_model_pdamax      (&MPC_NetType_pdamax)

extern        HMPI_Model              MPC_NetType_psamax;
#define       hscal_model_psamax      (&MPC_NetType_psamax)

extern        HMPI_Model              MPC_NetType_pzamax;
#define       hscal_model_pzamax      (&MPC_NetType_pzamax)

extern        HMPI_Model              MPC_NetType_pdasum;
#define       hscal_model_pdasum      (&MPC_NetType_pdasum)

extern        HMPI_Model              MPC_NetType_psasum;
#define       hscal_model_psasum      (&MPC_NetType_psasum)

extern        HMPI_Model              MPC_NetType_pscasum;
#define       hscal_model_pscasum     (&MPC_NetType_pscasum)

extern        HMPI_Model              MPC_NetType_pdzasum;
#define       hscal_model_pdzasum     (&MPC_NetType_pdzasum)

extern        HMPI_Model              MPC_NetType_pdnrm2;
#define       hscal_model_pdnrm2      (&MPC_NetType_pdnrm2)

extern        HMPI_Model              MPC_NetType_psnrm2;
#define       hscal_model_psnrm2      (&MPC_NetType_psnrm2)

extern        HMPI_Model              MPC_NetType_pscnrm2;
#define       hscal_model_pscnrm2     (&MPC_NetType_pscnrm2)

extern        HMPI_Model              MPC_NetType_pdznrm2;
#define       hscal_model_pdznrm2     (&MPC_NetType_pdznrm2)

extern        HMPI_Model              MPC_NetType_pddot;
#define       hscal_model_pddot       (&MPC_NetType_pddot)

extern        HMPI_Model              MPC_NetType_psdot;
#define       hscal_model_psdot       (&MPC_NetType_psdot)

extern        HMPI_Model              MPC_NetType_pcdotc;
#define       hscal_model_pcdotc      (&MPC_NetType_pcdotc)

extern        HMPI_Model              MPC_NetType_pcdotu;
#define       hscal_model_pcdotu      (&MPC_NetType_pcdotu)

extern        HMPI_Model              MPC_NetType_pzdotc;
#define       hscal_model_pzdotc      (&MPC_NetType_pzdotc)

extern        HMPI_Model              MPC_NetType_pzdotu;
#define       hscal_model_pzdotu      (&MPC_NetType_pzdotu)

/*
* ------------------------------------------------------------------
*       Performance models of PBLAS level2 routines
* ------------------------------------------------------------------
*/
extern        HMPI_Model              MPC_NetType_pcgemv;
#define       hscal_model_pcgemv      (&MPC_NetType_pcgemv)

extern        HMPI_Model              MPC_NetType_pdgemv;
#define       hscal_model_pdgemv      (&MPC_NetType_pdgemv)

extern        HMPI_Model              MPC_NetType_psgemv;
#define       hscal_model_psgemv      (&MPC_NetType_psgemv)

extern        HMPI_Model              MPC_NetType_pzgemv;
#define       hscal_model_pzgemv      (&MPC_NetType_pzgemv)

extern        HMPI_Model              MPC_NetType_pcagemv;
#define       hscal_model_pcagemv     (&MPC_NetType_pcagemv)

extern        HMPI_Model              MPC_NetType_pdagemv;
#define       hscal_model_pdagemv     (&MPC_NetType_pdagemv)

extern        HMPI_Model              MPC_NetType_psagemv;
#define       hscal_model_psagemv     (&MPC_NetType_psagemv)

extern        HMPI_Model              MPC_NetType_pzagemv;
#define       hscal_model_pzagemv     (&MPC_NetType_pzagemv)

extern        HMPI_Model              MPC_NetType_pchemv;
#define       hscal_model_pchemv      (&MPC_NetType_pchemv)

extern        HMPI_Model              MPC_NetType_pzhemv;
#define       hscal_model_pzhemv      (&MPC_NetType_pzhemv)

extern        HMPI_Model              MPC_NetType_pcahemv;
#define       hscal_model_pcahemv     (&MPC_NetType_pcahemv)

extern        HMPI_Model              MPC_NetType_pzahemv;
#define       hscal_model_pzahemv     (&MPC_NetType_pzahemv)

extern        HMPI_Model              MPC_NetType_pdsymv;
#define       hscal_model_pdsymv      (&MPC_NetType_pdsymv)

extern        HMPI_Model              MPC_NetType_pssymv;
#define       hscal_model_pssymv      (&MPC_NetType_pssymv)

extern        HMPI_Model              MPC_NetType_pdasymv;
#define       hscal_model_pdasymv     (&MPC_NetType_pdasymv)

extern        HMPI_Model              MPC_NetType_psasymv;
#define       hscal_model_psasymv     (&MPC_NetType_psasymv)

extern        HMPI_Model              MPC_NetType_pctrmv;
#define       hscal_model_pctrmv      (&MPC_NetType_pctrmv)

extern        HMPI_Model              MPC_NetType_pdtrmv;
#define       hscal_model_pdtrmv      (&MPC_NetType_pdtrmv)

extern        HMPI_Model              MPC_NetType_pstrmv;
#define       hscal_model_pstrmv      (&MPC_NetType_pstrmv)

extern        HMPI_Model              MPC_NetType_pztrmv;
#define       hscal_model_pztrmv      (&MPC_NetType_pztrmv)

extern        HMPI_Model              MPC_NetType_pcatrmv;
#define       hscal_model_pcatrmv     (&MPC_NetType_pcatrmv)

extern        HMPI_Model              MPC_NetType_pdatrmv;
#define       hscal_model_pdatrmv     (&MPC_NetType_pdatrmv)

extern        HMPI_Model              MPC_NetType_psatrmv;
#define       hscal_model_psatrmv     (&MPC_NetType_psatrmv)

extern        HMPI_Model              MPC_NetType_pzatrmv;
#define       hscal_model_pzatrmv     (&MPC_NetType_pzatrmv)

extern        HMPI_Model              MPC_NetType_pctrsv;
#define       hscal_model_pctrsv      (&MPC_NetType_pctrsv)

extern        HMPI_Model              MPC_NetType_pdtrsv;
#define       hscal_model_pdtrsv      (&MPC_NetType_pdtrsv)

extern        HMPI_Model              MPC_NetType_pstrsv;
#define       hscal_model_pstrsv      (&MPC_NetType_pstrsv)

extern        HMPI_Model              MPC_NetType_pztrsv;
#define       hscal_model_pztrsv      (&MPC_NetType_pztrsv)

extern        HMPI_Model              MPC_NetType_pctrsv_ex;
#define       hscal_model_pctrsv_ex   (&MPC_NetType_pctrsv_ex)

extern        HMPI_Model              MPC_NetType_pdtrsv_ex;
#define       hscal_model_pdtrsv_ex   (&MPC_NetType_pdtrsv_ex)

extern        HMPI_Model              MPC_NetType_pstrsv_ex;
#define       hscal_model_pstrsv_ex   (&MPC_NetType_pstrsv_ex)

extern        HMPI_Model              MPC_NetType_pztrsv_ex;
#define       hscal_model_pztrsv_ex   (&MPC_NetType_pztrsv_ex)

extern        HMPI_Model              MPC_NetType_pcgerc;
#define       hscal_model_pcgerc      (&MPC_NetType_pcgerc)

extern        HMPI_Model              MPC_NetType_pzgerc;
#define       hscal_model_pzgerc      (&MPC_NetType_pzgerc)

extern        HMPI_Model              MPC_NetType_pcgeru;
#define       hscal_model_pcgeru      (&MPC_NetType_pcgeru)

extern        HMPI_Model              MPC_NetType_pzgeru;
#define       hscal_model_pzgeru      (&MPC_NetType_pzgeru)

extern        HMPI_Model              MPC_NetType_pdger;
#define       hscal_model_pdger       (&MPC_NetType_pdger)

extern        HMPI_Model              MPC_NetType_psger;
#define       hscal_model_psger       (&MPC_NetType_psger)

extern        HMPI_Model              MPC_NetType_pdsyr;
#define       hscal_model_pdsyr       (&MPC_NetType_pdsyr)

extern        HMPI_Model              MPC_NetType_pssyr;
#define       hscal_model_pssyr       (&MPC_NetType_pssyr)

extern        HMPI_Model              MPC_NetType_pdsyr2;
#define       hscal_model_pdsyr2      (&MPC_NetType_pdsyr2)

extern        HMPI_Model              MPC_NetType_pssyr2;
#define       hscal_model_pssyr2      (&MPC_NetType_pssyr2)

extern        HMPI_Model              MPC_NetType_pcher;
#define       hscal_model_pcher       (&MPC_NetType_pcher)

extern        HMPI_Model              MPC_NetType_pzher;
#define       hscal_model_pzher       (&MPC_NetType_pzher)

extern        HMPI_Model              MPC_NetType_pcher2;
#define       hscal_model_pcher2      (&MPC_NetType_pcher2)

extern        HMPI_Model              MPC_NetType_pzher2;
#define       hscal_model_pzher2      (&MPC_NetType_pzher2)

/*
* ------------------------------------------------------------------
*       Performance models of PBLAS level3 routines
* ------------------------------------------------------------------
*/
extern        HMPI_Model              MPC_NetType_pcsyrk;
#define       hscal_model_pcsyrk      (&MPC_NetType_pcsyrk)

extern        HMPI_Model              MPC_NetType_pdsyrk;
#define       hscal_model_pdsyrk      (&MPC_NetType_pdsyrk)

extern        HMPI_Model              MPC_NetType_pssyrk;
#define       hscal_model_pssyrk      (&MPC_NetType_pssyrk)

extern        HMPI_Model              MPC_NetType_pzsyrk;
#define       hscal_model_pzsyrk      (&MPC_NetType_pzsyrk)

extern        HMPI_Model              MPC_NetType_pcsyr2k;
#define       hscal_model_pcsyr2k     (&MPC_NetType_pcsyr2k)

extern        HMPI_Model              MPC_NetType_pdsyr2k;
#define       hscal_model_pdsyr2k     (&MPC_NetType_pdsyr2k)

extern        HMPI_Model              MPC_NetType_pssyr2k;
#define       hscal_model_pssyr2k     (&MPC_NetType_pssyr2k)

extern        HMPI_Model              MPC_NetType_pzsyr2k;
#define       hscal_model_pzsyr2k     (&MPC_NetType_pzsyr2k)

extern        HMPI_Model              MPC_NetType_pcherk;
#define       hscal_model_pcherk      (&MPC_NetType_pcherk)

extern        HMPI_Model              MPC_NetType_pzherk;
#define       hscal_model_pzherk      (&MPC_NetType_pzherk)

extern        HMPI_Model              MPC_NetType_pcher2k;
#define       hscal_model_pcher2k     (&MPC_NetType_pcher2k)

extern        HMPI_Model              MPC_NetType_pzher2k;
#define       hscal_model_pzher2k     (&MPC_NetType_pzher2k)

extern        HMPI_Model              MPC_NetType_pcgemm;
#define       hscal_model_pcgemm      (&MPC_NetType_pcgemm)

extern        HMPI_Model              MPC_NetType_pdgemm_p_q;
#define       hscal_model_pdgemm_p_q  (&MPC_NetType_pdgemm_p_q)

extern        HMPI_Model              MPC_NetType_pdgemm;
#define       hscal_model_pdgemm      (&MPC_NetType_pdgemm)

extern        HMPI_Model              MPC_NetType_psgemm;
#define       hscal_model_psgemm      (&MPC_NetType_psgemm)

extern        HMPI_Model              MPC_NetType_pzgemm;
#define       hscal_model_pzgemm      (&MPC_NetType_pzgemm)

extern        HMPI_Model                         MPC_NetType_pzgemm_optimal_b;
#define       hscal_model_pzgemm_optimal_b      (&MPC_NetType_pzgemm_optimal_b)

extern        HMPI_Model              MPC_NetType_pctranc;
#define       hscal_model_pctranc     (&MPC_NetType_pctranc)

extern        HMPI_Model              MPC_NetType_pztranc;
#define       hscal_model_pztranc     (&MPC_NetType_pztranc)

extern        HMPI_Model              MPC_NetType_pctranu;
#define       hscal_model_pctranu     (&MPC_NetType_pctranu)

extern        HMPI_Model              MPC_NetType_pztranu;
#define       hscal_model_pztranu     (&MPC_NetType_pztranu)

extern        HMPI_Model              MPC_NetType_pdtran;
#define       hscal_model_pdtran      (&MPC_NetType_pdtran)

extern        HMPI_Model              MPC_NetType_pstran;
#define       hscal_model_pstran      (&MPC_NetType_pstran)

extern        HMPI_Model              MPC_NetType_pcsymm;
#define       hscal_model_pcsymm      (&MPC_NetType_pcsymm)

extern        HMPI_Model              MPC_NetType_pdsymm;
#define       hscal_model_pdsymm      (&MPC_NetType_pdsymm)

extern        HMPI_Model              MPC_NetType_pssymm;
#define       hscal_model_pssymm      (&MPC_NetType_pssymm)

extern        HMPI_Model              MPC_NetType_pzsymm;
#define       hscal_model_pzsymm      (&MPC_NetType_pzsymm)

extern        HMPI_Model              MPC_NetType_pchemm;
#define       hscal_model_pchemm      (&MPC_NetType_pchemm)

extern        HMPI_Model              MPC_NetType_pzhemm;
#define       hscal_model_pzhemm      (&MPC_NetType_pzhemm)

extern        HMPI_Model              MPC_NetType_pctrmm;
#define       hscal_model_pctrmm      (&MPC_NetType_pctrmm)

extern        HMPI_Model              MPC_NetType_pdtrmm;
#define       hscal_model_pdtrmm      (&MPC_NetType_pdtrmm)

extern        HMPI_Model              MPC_NetType_pstrmm;
#define       hscal_model_pstrmm      (&MPC_NetType_pstrmm)

extern        HMPI_Model              MPC_NetType_pztrmm;
#define       hscal_model_pztrmm      (&MPC_NetType_pztrmm)

extern        HMPI_Model              MPC_NetType_pctrsm;
#define       hscal_model_pctrsm      (&MPC_NetType_pctrsm)

extern        HMPI_Model              MPC_NetType_pdtrsm;
#define       hscal_model_pdtrsm      (&MPC_NetType_pdtrsm)

extern        HMPI_Model              MPC_NetType_pstrsm;
#define       hscal_model_pstrsm      (&MPC_NetType_pstrsm)

extern        HMPI_Model              MPC_NetType_pztrsm;
#define       hscal_model_pztrsm      (&MPC_NetType_pztrsm)

extern        HMPI_Model              MPC_NetType_pctrsm_ex;
#define       hscal_model_pctrsm_ex   (&MPC_NetType_pctrsm_ex)

extern        HMPI_Model              MPC_NetType_pdtrsm_ex;
#define       hscal_model_pdtrsm_ex   (&MPC_NetType_pdtrsm_ex)

extern        HMPI_Model              MPC_NetType_pstrsm_ex;
#define       hscal_model_pstrsm_ex   (&MPC_NetType_pstrsm_ex)

extern        HMPI_Model              MPC_NetType_pztrsm_ex;
#define       hscal_model_pztrsm_ex   (&MPC_NetType_pztrsm_ex)

extern        HMPI_Model              MPC_NetType_pcgeadd;
#define       hscal_model_pcgeadd     (&MPC_NetType_pcgeadd)

extern        HMPI_Model              MPC_NetType_pdgeadd;
#define       hscal_model_pdgeadd     (&MPC_NetType_pdgeadd)

extern        HMPI_Model              MPC_NetType_psgeadd;
#define       hscal_model_psgeadd     (&MPC_NetType_psgeadd)

extern        HMPI_Model              MPC_NetType_pzgeadd;
#define       hscal_model_pzgeadd     (&MPC_NetType_pzgeadd)

extern        HMPI_Model              MPC_NetType_pctradd;
#define       hscal_model_pctradd     (&MPC_NetType_pctradd)

extern        HMPI_Model              MPC_NetType_pdtradd;
#define       hscal_model_pdtradd     (&MPC_NetType_pdtradd)

extern        HMPI_Model              MPC_NetType_pstradd;
#define       hscal_model_pstradd     (&MPC_NetType_pstradd)

extern        HMPI_Model              MPC_NetType_pztradd;
#define       hscal_model_pztradd     (&MPC_NetType_pztradd)

#endif  /* __HMPI_SCALAPACK_PBLAS_PMODELS_INCLUDE_HH */
