
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK PTOOLS                   *
*                         (INTERNAL)                               *
*                 ==============================                   *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_PTOOLS_INCLUDE_HH
#define __HMPI_SCALAPACK_PTOOLS_INCLUDE_HH

/*
* ------------------------------------------------------------------
*       FUNCTION PROTOTYPES FOR PTOOLS
* ------------------------------------------------------------------
*/
void hscal_PB_Cwarn( 
     int nprow, int npcol, int myrow, int mycol,
     int LINE, char * ROUT, char * FORM, ... 
);

void hscal_PB_Cabort(
     char * ROUT, int INFO,
     int nprow, int npcol, int myrow, int mycol
);

void hscal_PB_Cchkmat( 
     char * ROUT, char * MNAME, int M, int MPOS0,
     int N, int NPOS0, int IA, int JA, int * DESCA, int DPOS0,
     int nprow, int npcol, int myrow, int mycol,
     int * INFO
);

void hscal_PB_Cchkvec( 
     char * ROUT, char * VNAME, int N, int NPOS0,
     int IX, int JX, int * DESCX, int INCX, int DPOS0,
     int nprow, int npcol, int myrow, int mycol,
     int * INFO
);

void hscal_PB_CInOutV2_C(
          PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
          int N, int KA, int * DESCA, int K, int IY,
          int JY, int * DESCY, char * YROC,
          int * DYA, int * YASUM, int * YAPBY,
          int nprow, int npcol, int myrow, int mycol, double *tcomp,
          int *tcomm
);

void hscal_PB_CInOutV2_D(
          PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
          int N, int KA, int * DESCA, int K, int IY,
          int JY, int * DESCY, char * YROC,
          int * DYA, int * YASUM, int * YAPBY,
          int nprow, int npcol, int myrow, int mycol, double *tcomp,
          int *tcomm
);

void hscal_PB_CInOutV2_S(
          PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
          int N, int KA, int * DESCA, int K, int IY,
          int JY, int * DESCY, char * YROC,
          int * DYA, int * YASUM, int * YAPBY,
          int nprow, int npcol, int myrow, int mycol, double *tcomp,
          int *tcomm
);

void hscal_PB_CInOutV2_Z(
          PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
          int N, int KA, int * DESCA, int K, int IY,
          int JY, int * DESCY, char * YROC,
          int * DYA, int * YASUM, int * YAPBY,
          int nprow, int npcol, int myrow, int mycol, double *tcomp,
          int *tcomm
);

void hscal_PB_CInOutV_C( 
                 PBTYP_T * TYPE, char * ROWCOL, int M, int N, int * DESCA,
                 int K, char * BETA,
                 int IY, int JY, int * DESCY, char * YROC,
                 char * * TBETA, int * DYA,
                 int * YASUM, int * YAPBY,
                 int nprow, int npcol, int myrow, int mycol, double *tcomp
);

void hscal_PB_CInOutV_D( 
                 PBTYP_T * TYPE, char * ROWCOL, int M, int N, int * DESCA,
                 int K, char * BETA,
                 int IY, int JY, int * DESCY, char * YROC,
                 char * * TBETA, int * DYA,
                 int * YASUM, int * YAPBY,
                 int nprow, int npcol, int myrow, int mycol, double *tcomp
);

void hscal_PB_CInOutV_S( 
                 PBTYP_T * TYPE, char * ROWCOL, int M, int N, int * DESCA,
                 int K, char * BETA,
                 int IY, int JY, int * DESCY, char * YROC,
                 char * * TBETA, int * DYA,
                 int * YASUM, int * YAPBY,
                 int nprow, int npcol, int myrow, int mycol, double *tcomp
);

void hscal_PB_CInOutV_Z( 
                 PBTYP_T * TYPE, char * ROWCOL, int M, int N, int * DESCA,
                 int K, char * BETA,
                 int IY, int JY, int * DESCY, char * YROC,
                 char * * TBETA, int * DYA,
                 int * YASUM, int * YAPBY,
                 int nprow, int npcol, int myrow, int mycol, double *tcomp
);

void hscal_PB_CInV_C( 
              PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
              int N, int * DESCA, int K, int IX, int JX,
              int * DESCX, char * XROC, int * DXA,
              int nprow, int npcol, int myrow, int mycol, 
              double *tcomp, int *tcomm
);

void hscal_PB_CInV_D( 
              PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
              int N, int * DESCA, int K, int IX, int JX,
              int * DESCX, char * XROC, int * DXA,
              int nprow, int npcol, int myrow, int mycol, 
              double *tcomp, int *tcomm
);

void hscal_PB_CInV_S( 
              PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
              int N, int * DESCA, int K, int IX, int JX,
              int * DESCX, char * XROC, int * DXA,
              int nprow, int npcol, int myrow, int mycol, 
              double *tcomp, int *tcomm
);

void hscal_PB_CInV_Z( 
              PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
              int N, int * DESCA, int K, int IX, int JX,
              int * DESCX, char * XROC, int * DXA,
              int nprow, int npcol, int myrow, int mycol, 
              double *tcomp, int *tcomm
);

void hscal_PB_COutV_C( 
              PBTYP_T * TYPE, char * ROWCOL, char * ZEROIT, int M,
              int N, int * DESCA, int K, int * DYA,
              int * YASUM,
              int nprow, int npcol, int myrow, int mycol, 
              double *tcomp
);

void hscal_PB_COutV_D( 
              PBTYP_T * TYPE, char * ROWCOL, char * ZEROIT, int M,
              int N, int * DESCA, int K, int * DYA,
              int * YASUM,
              int nprow, int npcol, int myrow, int mycol, 
              double *tcomp
);

void hscal_PB_COutV_S( 
              PBTYP_T * TYPE, char * ROWCOL, char * ZEROIT, int M,
              int N, int * DESCA, int K, int * DYA,
              int * YASUM,
              int nprow, int npcol, int myrow, int mycol, 
              double *tcomp
);

void hscal_PB_COutV_Z( 
              PBTYP_T * TYPE, char * ROWCOL, char * ZEROIT, int M,
              int N, int * DESCA, int K, int * DYA,
              int * YASUM,
              int nprow, int npcol, int myrow, int mycol, 
              double *tcomp
);

void hscal_PB_Cpaxpby_C(
                 PBTYP_T * TYPE, char * CONJUG, int M, int N,
                 char * ALPHA,
                 int IA, int JA, int * DESCA, char * AROC,
                 char * BETA,
                 int IB, int JB, int * DESCB, char * BROC,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp, int *tcomm 
);

void hscal_PB_Cpaxpby_D(
                 PBTYP_T * TYPE, char * CONJUG, int M, int N,
                 char * ALPHA,
                 int IA, int JA, int * DESCA, char * AROC,
                 char * BETA,
                 int IB, int JB, int * DESCB, char * BROC,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp, int *tcomm 
);

void hscal_PB_Cpaxpby_I(
                 PBTYP_T * TYPE, char * CONJUG, int M, int N,
                 char * ALPHA,
                 int IA, int JA, int * DESCA, char * AROC,
                 char * BETA,
                 int IB, int JB, int * DESCB, char * BROC,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp, int *tcomm 
);

void hscal_PB_Cpaxpby_S(
                 PBTYP_T * TYPE, char * CONJUG, int M, int N,
                 char * ALPHA,
                 int IA, int JA, int * DESCA, char * AROC,
                 char * BETA,
                 int IB, int JB, int * DESCB, char * BROC,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp, int *tcomm 
);

void hscal_PB_Cpaxpby_Z(
                 PBTYP_T * TYPE, char * CONJUG, int M, int N,
                 char * ALPHA,
                 int IA, int JA, int * DESCA, char * AROC,
                 char * BETA,
                 int IB, int JB, int * DESCB, char * BROC,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyDN_C( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyDN_D( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyDN_I( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyDN_S( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyDN_Z( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyND_C( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyND_D( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyND_I( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyND_S( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyND_Z( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyNN_C( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyNN_D( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyNN_I( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyNN_S( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC, 
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

void hscal_PB_CpaxpbyNN_Z( 
                   PBTYP_T * TYPE, char * CONJUG, int M, int N,
                   char * ALPHA,
                   int IA, int JA, int * DESCA, char * AROC,
                   char * BETA,
                   int IB, int JB, int * DESCB, char * BROC,
                   int nprow, int npcol, int myrow, int mycol, 
                   double *tcomp, int *tcomm 
);

typedef void       (*HSCALTZSYM_T)    ( PBTYP_T *, char *,    char *,
                                int,       int,       int,
                                int,       char *,
                                int,       int,
                                int,
                                int,       int,
                                int, int, int, int , double *
);

typedef void       (*HSCALTZTRM_T)    ( PBTYP_T *, char *,    char *,
                                char *,    char *,    int,
                                int,       int,       int,
                                char *,    int,
                                int,
                                int,
                                int, int, int, int , double *
);

typedef void       (*HSCALTZSYR_T)    ( PBTYP_T *, char *,    int,
                                       int,        int,       int,
                                       char *,     int,
                                       int,
                                       int,
                                       int, int, int, int , double *
);

typedef void       (*HSCALTZSYR2_T)   ( PBTYP_T *, char *,    int,
                                       int,       int,       int,
                                       char *,    int,
                                       int,
                                       int,       int,
                                       int,
                                       int, int, int, int , double *
);

void hscal_PB_Cpsym( 
              PBTYP_T * TYPE, PBTYP_T * UTYP, char * SIDE,
              char * UPLO, int N, int K, char * ALPHA,
              int IA, int JA, int * DESCA, int LDXC,
              int LDXR, int LDYC, int LDYR, HSCALTZSYM_T SYM,
              int nprow, int npcol, int myrow, int mycol, 
              double *tcomp
);

void hscal_PB_Cptrm( 
             PBTYP_T * TYPE, PBTYP_T * UTYP, char * SIDE, char * UPLO,
             char * TRANS, char * DIAG, int N, int K, char * ALPHA,
             int IA, int JA, int * DESCA,
             int LDX, int LDY,
             HSCALTZTRM_T TRM,
             int nprow, int npcol, int myrow, int mycol, 
             double *tcomp
);

void hscal_PB_Ctzhemv_C(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzhemv_D(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzhemv_S(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzhemv_Z(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzahemv_C( 
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzahemv_D( 
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzahemv_S( 
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzahemv_Z( 
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzsymv_C(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzsymv_D(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzsymv_S(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzsymv_Z(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzasymv_C(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzasymv_D(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzasymv_S(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzasymv_Z(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDXC, int LDXR, int LDYC, int LDYR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzatrmv_C(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDX, int LDY,
           int nprow, int npcol, int myrow, int mycol, 
           double *tcomp
);

void hscal_PB_Ctzatrmv_D(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDX, int LDY,
           int nprow, int npcol, int myrow, int mycol, 
           double *tcomp
);

void hscal_PB_Ctzatrmv_S(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDX, int LDY,
           int nprow, int npcol, int myrow, int mycol, 
           double *tcomp
);

void hscal_PB_Ctzatrmv_Z(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDX, int LDY,
           int nprow, int npcol, int myrow, int mycol, 
           double *tcomp
);

void hscal_PB_Ctztrmv_C(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDX, int LDY,
           int nprow, int npcol, int myrow, int mycol, 
           double *tcomp
);

void hscal_PB_Ctztrmv_D(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDX, int LDY,
           int nprow, int npcol, int myrow, int mycol, 
           double *tcomp
);

void hscal_PB_Ctztrmv_S(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDX, int LDY,
           int nprow, int npcol, int myrow, int mycol, 
           double *tcomp
);

void hscal_PB_Ctztrmv_Z(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDX, int LDY,
           int nprow, int npcol, int myrow, int mycol, 
           double *tcomp
);

void hscal_PB_Ctzher_C( 
          PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
          int IOFFD, char * ALPHA, int LDXC, 
          int LDXR, int LDA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Ctzher_Z( 
          PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
          int IOFFD, char * ALPHA, int LDXC, 
          int LDXR, int LDA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Ctzher_D( 
          PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
          int IOFFD, char * ALPHA, int LDXC, 
          int LDXR, int LDA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Ctzher_S( 
          PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
          int IOFFD, char * ALPHA, int LDXC, 
          int LDXR, int LDA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Ctzher2_C( 
          PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
          int IOFFD, char * ALPHA, int LDXC, int LDYC,
          int LDXR, int LDYR, int LDA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Ctzher2_Z( 
          PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
          int IOFFD, char * ALPHA, int LDXC, int LDYC,
          int LDXR, int LDYR, int LDA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Ctzher2_D(
          PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
          int IOFFD, char * ALPHA, int LDXC, int LDYC,
          int LDXR, int LDYR, int LDA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Ctzher2_S(
          PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
          int IOFFD, char * ALPHA, int LDXC, int LDYC,
          int LDXR, int LDYR, int LDA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Cpsyr( 
          PBTYP_T * TYPE, char * UPLO, int N, int K,
          char * ALPHA, int LDXC, int LDXR,
          int IA, int JA, int * DESCA, HSCALTZSYR_T SYR,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Cpsyr2( 
          PBTYP_T * TYPE, char * UPLO, int N, int K,
          char * ALPHA, int LDXC, int LDXR, int LDYC, int LDYR,
          int IA, int JA, int * DESCA, HSCALTZSYR2_T SYR,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_CpsyrkA_C( 
     PBTYP_T * TYPE, char * DIRECA, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsyrkA_D(
     PBTYP_T * TYPE, char * DIRECA, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsyrkA_S( 
     PBTYP_T * TYPE, char * DIRECA, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsyrkA_Z( 
     PBTYP_T * TYPE, char * DIRECA, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsyrkAC_C( 
     PBTYP_T * TYPE, char * DIRECA, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsyrkAC_D( 
     PBTYP_T * TYPE, char * DIRECA, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsyrkAC_S( 
     PBTYP_T * TYPE, char * DIRECA, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsyrkAC_Z(
     PBTYP_T * TYPE, char * DIRECA, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpsyr2kA_C( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpsyr2kA_D( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpsyr2kA_S( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpsyr2kA_Z( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpsyr2kAC_C(
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpsyr2kAC_D(
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpsyr2kAC_S(
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpsyr2kAC_Z(
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char * UPLO, char * TRANS, int N, int K, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Ctzher2k_C(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDBC, int LDAR,
     int LDBR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzher2k_D(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDBC, int LDAR,
     int LDBR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzher2k_S(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDBC, int LDAR,
     int LDBR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzher2k_Z(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDBC, int LDAR,
     int LDBR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzherk_C( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDAR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzherk_D( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDAR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzherk_S( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDAR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzherk_Z( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDAR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr2_C( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDXC,
     int LDYC, int LDXR,
     int LDYR, int LDA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr2_D(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDXC,
     int LDYC, int LDXR,
     int LDYR, int LDA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr2_S( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDXC,
     int LDYC, int LDXR,
     int LDYR, int LDA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr2_Z( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDXC,
     int LDYC, int LDXR,
     int LDYR, int LDA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr2k_C( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDBC, int LDAR,
     int LDBR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr2k_D( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDBC, int LDAR,
     int LDBR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr2k_S( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDBC, int LDAR,
     int LDBR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr2k_Z( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDBC, int LDAR,
     int LDBR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr_C( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDXC,
     int LDXR, int LDA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr_D( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDXC,
     int LDXR, int LDA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr_S( 
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDXC,
     int LDXR, int LDA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyr_Z(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDXC,
     int LDXR, int LDA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyrk_C(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDAR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyrk_D(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDAR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyrk_S(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDAR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Ctzsyrk_Z(
     PBTYP_T * TYPE, char * UPLO, int M, int N, int K,
     int IOFFD, char * ALPHA, int LDAC,
     int LDAR, int LDC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_CGatherV_C( 
     PBTYP_T * TYPE, char * ALLOC, char * DIRECA, int M, int N,
     int IA, int JA, int * DESCA, char * AROC,
     int * DESCB,
     int nprow, int npcol, int myrow, int mycol, double *tcomp,
     int *tcomm
);

void hscal_PB_CGatherV_D( 
     PBTYP_T * TYPE, char * ALLOC, char * DIRECA, int M, int N,
     int IA, int JA, int * DESCA, char * AROC,
     int * DESCB,
     int nprow, int npcol, int myrow, int mycol, double *tcomp,
     int *tcomm
);

void hscal_PB_CGatherV_S( 
     PBTYP_T * TYPE, char * ALLOC, char * DIRECA, int M, int N,
     int IA, int JA, int * DESCA, char * AROC,
     int * DESCB,
     int nprow, int npcol, int myrow, int mycol, double *tcomp,
     int *tcomm
);

void hscal_PB_CGatherV_Z( 
     PBTYP_T * TYPE, char * ALLOC, char * DIRECA, int M, int N,
     int IA, int JA, int * DESCA, char * AROC,
     int * DESCB,
     int nprow, int npcol, int myrow, int mycol, double *tcomp,
     int *tcomm
);

void hscal_PB_CScatterV_C( 
     PBTYP_T * TYPE, char * DIRECA, int M, int N,
     int IA, int JA, int * DESCA, char * AROC,
     char * ALPHA, int IB, int JB, int * DESCB,
     char * BROC,
     int nprow, int npcol, int myrow, int mycol, double *tcomp,
     int *tcomm
);

void hscal_PB_CScatterV_D( 
     PBTYP_T * TYPE, char * DIRECA, int M, int N,
     int IA, int JA, int * DESCA, char * AROC,
     char * ALPHA, int IB, int JB, int * DESCB,
     char * BROC,
     int nprow, int npcol, int myrow, int mycol, double *tcomp,
     int *tcomm
);

void hscal_PB_CScatterV_S( 
     PBTYP_T * TYPE, char * DIRECA, int M, int N,
     int IA, int JA, int * DESCA, char * AROC,
     char * ALPHA, int IB, int JB, int * DESCB,
     char * BROC,
     int nprow, int npcol, int myrow, int mycol, double *tcomp,
     int *tcomm
);

void hscal_PB_CScatterV_Z( 
     PBTYP_T * TYPE, char * DIRECA, int M, int N,
     int IA, int JA, int * DESCA, char * AROC,
     char * ALPHA, int IB, int JB, int * DESCB,
     char * BROC,
     int nprow, int npcol, int myrow, int mycol, double *tcomp,
     int *tcomm
);

void hscal_PB_Cplapad_C(
          PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
          int N, char * ALPHA, char * BETA, int IA,
          int JA, int * DESCA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Cplapad_D( 
          PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
          int N, char * ALPHA, char * BETA, int IA,
          int JA, int * DESCA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Cplapad_S( 
          PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
          int N, char * ALPHA, char * BETA, int IA,
          int JA, int * DESCA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Cplapad_Z( 
          PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
          int N, char * ALPHA, char * BETA, int IA,
          int JA, int * DESCA,
          int nprow, int npcol, int myrow, int mycol, 
          double *tcomp
);

void hscal_PB_Cplapd2_C( 
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, char * BETA, int IA,
     int JA, int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplapd2_D( 
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, char * BETA, int IA,
     int JA, int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplapd2_S( 
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, char * BETA, int IA,
     int JA, int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplapd2_Z( 
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, char * BETA, int IA,
     int JA, int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplascal_C( 
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, int IA, int JA,
     int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplascal_D( 
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, int IA, int JA,
     int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplascal_S( 
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, int IA, int JA,
     int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplascal_Z( 
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, int IA, int JA,
     int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplasca2_C(
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, int IA, int JA,
     int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplasca2_D(
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, int IA, int JA,
     int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplasca2_S(
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, int IA, int JA,
     int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplasca2_Z(
     PBTYP_T * TYPE, char * UPLO, char * CONJUG, int M,
     int N, char * ALPHA, int IA, int JA,
     int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_CInV2_C( 
     PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
     int N, int * DESCA, int K, int IX, int JX,
     int * DESCX, char * XROC, int IJXA,
     int * DXA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CInV2_D( 
     PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
     int N, int * DESCA, int K, int IX, int JX,
     int * DESCX, char * XROC, int IJXA,
     int * DXA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CInV2_S( 
     PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
     int N, int * DESCA, int K, int IX, int JX,
     int * DESCX, char * XROC, int IJXA,
     int * DXA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CInV2_Z( 
     PBTYP_T * TYPE, char * CONJUG, char * ROWCOL, int M,
     int N, int * DESCA, int K, int IX, int JX,
     int * DESCX, char * XROC, int IJXA,
     int * DXA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

typedef int     (*HSCALMMADD_T)    ( int  *,    int  *,    char *,
                                     int  *,    char *,
                                     int  *,    
                                     double*
);

int hscal_PB_CVMloc_C( 
    PBTYP_T * TYPE, PB_VM_T * VM,
    char * VROCS, char * ROCS, char * UNPA, char * TRANS,
    int MN, int K, char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMloc_D( 
    PBTYP_T * TYPE, PB_VM_T * VM,
    char * VROCS, char * ROCS, char * UNPA, char * TRANS,
    int MN, int K, char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMloc_I( 
    PBTYP_T * TYPE, PB_VM_T * VM,
    char * VROCS, char * ROCS, char * UNPA, char * TRANS,
    int MN, int K, char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMloc_S( 
    PBTYP_T * TYPE, PB_VM_T * VM,
    char * VROCS, char * ROCS, char * UNPA, char * TRANS,
    int MN, int K, char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMloc_Z( 
    PBTYP_T * TYPE, PB_VM_T * VM,
    char * VROCS, char * ROCS, char * UNPA, char * TRANS,
    int MN, int K, char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMpack_C( 
    PBTYP_T * TYPE, PB_VM_T * VM, char * VROCS, char * ROCS,
    char * UNPA, char * TRANS, int MN, int K,
    char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMpack_D( 
    PBTYP_T * TYPE, PB_VM_T * VM, char * VROCS, char * ROCS,
    char * UNPA, char * TRANS, int MN, int K,
    char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMpack_I( 
    PBTYP_T * TYPE, PB_VM_T * VM, char * VROCS, char * ROCS,
    char * UNPA, char * TRANS, int MN, int K,
    char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMpack_S( 
    PBTYP_T * TYPE, PB_VM_T * VM, char * VROCS, char * ROCS,
    char * UNPA, char * TRANS, int MN, int K,
    char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMpack_Z( 
    PBTYP_T * TYPE, PB_VM_T * VM, char * VROCS, char * ROCS,
    char * UNPA, char * TRANS, int MN, int K,
    char * ALPHA, int LDA,
    char * BETA,  int LDB,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMswp_C( 
    PBTYP_T * TYPE, PB_VM_T * VM, char * VROCS, char * ROCS,
    char * TRANS, int MN, int INCX,
    int INCY,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMswp_D( 
    PBTYP_T * TYPE, PB_VM_T * VM, char * VROCS, char * ROCS,
    char * TRANS, int MN, int INCX,
    int INCY,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMswp_S( 
    PBTYP_T * TYPE, PB_VM_T * VM, char * VROCS, char * ROCS,
    char * TRANS, int MN, int INCX,
    int INCY,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

int hscal_PB_CVMswp_Z( 
    PBTYP_T * TYPE, PB_VM_T * VM, char * VROCS, char * ROCS,
    char * TRANS, int MN, int INCX,
    int INCY,
    int nprow, int npcol, int myrow, int mycol, double *tcomp
);

void hscal_PB_CpswapND_C( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpswapND_D( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpswapND_S( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpswapND_Z( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpswapNN_C( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpswapNN_D( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpswapNN_S( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpswapNN_Z( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

typedef int    (*HSCALVVDOT_T)    ( int  *,
                                    int  *, int  *,
                                    double *
);

void hscal_PB_Cpdot11_C( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpdot11_D( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpdot11_S( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpdot11_Z( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpdotND_C( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpdotND_D( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpdotND_S( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpdotND_Z( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpdotNN_C( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpdotNN_D( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpdotNN_S( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpdotNN_Z( 
     PBTYP_T * TYPE, int N,
     int IX, int JX, int * DESCX, int INCX,
     int IY, int JY, int * DESCY, int INCY,
     HSCALVVDOT_T FDOT,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsymmAB_C( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char  *SIDE, char * UPLO, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsymmAB_D( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char  *SIDE, char * UPLO, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsymmAB_S( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char  *SIDE, char * UPLO, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsymmAB_Z( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char  *SIDE, char * UPLO, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsymmBC_C( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char  *SIDE, char * UPLO, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsymmBC_D( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char  *SIDE, char * UPLO, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsymmBC_S( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char  *SIDE, char * UPLO, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpsymmBC_Z( 
     PBTYP_T * TYPE, char * DIRECAB, char * CONJUG,
     char  *SIDE, char * UPLO, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Ctzhemm_C(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDBC, int LDBR,
                 int LDCC, int LDCR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzhemm_D(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDBC, int LDBR,
                 int LDCC, int LDCR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzhemm_S(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDBC, int LDBR,
                 int LDCC, int LDCR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzhemm_Z(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDBC, int LDBR,
                 int LDCC, int LDCR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzsymm_C(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDBC, int LDBR,
                 int LDCC, int LDCR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzsymm_D(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDBC, int LDBR,
                 int LDCC, int LDCR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzsymm_S(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDBC, int LDBR,
                 int LDCC, int LDCR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Ctzsymm_Z(
                 PBTYP_T * TYPE, char * SIDE, char * UPLO, int M, int N,
                 int K, int IOFFD, char * ALPHA, int LDA,
                 int LDBC, int LDBR,
                 int LDCC, int LDCR,
                 int nprow, int npcol, int myrow, int mycol, 
                 double *tcomp
);

void hscal_PB_Cptran_C(
     PBTYP_T * TYPE, char * CONJUG,
     int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptran_D(
     PBTYP_T * TYPE, char * CONJUG,
     int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptran_S(
     PBTYP_T * TYPE, char * CONJUG,
     int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptran_Z(
     PBTYP_T * TYPE, char * CONJUG,
     int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrmmAB_C( 
     PBTYP_T * TYPE, char * VARIANT, char * SIDE, char * UPLO,
     char * TRANSA, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrmmAB_D( 
     PBTYP_T * TYPE, char * VARIANT, char * SIDE, char * UPLO,
     char * TRANSA, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrmmAB_S( 
     PBTYP_T * TYPE, char * VARIANT, char * SIDE, char * UPLO,
     char * TRANSA, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrmmAB_Z( 
     PBTYP_T * TYPE, char * VARIANT, char * SIDE, char * UPLO,
     char * TRANSA, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrmmB_C( 
     PBTYP_T * TYPE, char * DIRECB, char * SIDE,
     char * UPLO, char * TRANSA, char * DIAG, int M, int N,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrmmB_D( 
     PBTYP_T * TYPE, char * DIRECB, char * SIDE,
     char * UPLO, char * TRANSA, char * DIAG, int M, int N,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrmmB_S( 
     PBTYP_T * TYPE, char * DIRECB, char * SIDE,
     char * UPLO, char * TRANSA, char * DIAG, int M, int N,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrmmB_Z( 
     PBTYP_T * TYPE, char * DIRECB, char * SIDE,
     char * UPLO, char * TRANSA, char * DIAG, int M, int N,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAB_C( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECB,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAB_D( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECB,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAB_S( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECB,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAB_Z( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECB,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAB_Z_optimal_b( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECB,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int OPTIMALB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAC_Z_optimal_b(
     PBTYP_T * TYPE, char * DIRECA, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     char * BETA,
     int IC, int JC, int * DESCC,
     int OPTIMALB,
     int nprow, int npcol, int myrow, int mycol,
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmBC_Z_optimal_b(
     PBTYP_T * TYPE, char * DIRECB, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA,
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     char * BETA,
     int IC, int JC, int * DESCC,
     int OPTIMALB,
     int nprow, int npcol, int myrow, int mycol,
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAC_C( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAC_D( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAC_S( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmAC_Z( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmBC_C(
     PBTYP_T * TYPE, char * DIRECB, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmBC_D(
     PBTYP_T * TYPE, char * DIRECB, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmBC_S(
     PBTYP_T * TYPE, char * DIRECB, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CpgemmBC_Z(
     PBTYP_T * TYPE, char * DIRECB, char * DIRECC,
     char * TRANSA, char * TRANSB, int M, int N, int K,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB, 
     char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpgeadd_C( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECC,
     char * CONJUG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpgeadd_D( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECC,
     char * CONJUG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpgeadd_S( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECC,
     char * CONJUG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cpgeadd_Z( 
     PBTYP_T * TYPE, char * DIRECA, char * DIRECC,
     char * CONJUG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, char * BETA,
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptradd_C( 
     PBTYP_T * TYPE, char * DIRECAC, char * UPLO, char * TRANS,
     int M, int N, 
     char * ALPHA, 
     int IA, int JA, int * DESCA, 
     char * BETA, 
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptradd_D( 
     PBTYP_T * TYPE, char * DIRECAC, char * UPLO, char * TRANS,
     int M, int N, 
     char * ALPHA, 
     int IA, int JA, int * DESCA, 
     char * BETA, 
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptradd_S( 
     PBTYP_T * TYPE, char * DIRECAC, char * UPLO, char * TRANS,
     int M, int N, 
     char * ALPHA, 
     int IA, int JA, int * DESCA, 
     char * BETA, 
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptradd_Z( 
     PBTYP_T * TYPE, char * DIRECAC, char * UPLO, char * TRANS,
     int M, int N, 
     char * ALPHA, 
     int IA, int JA, int * DESCA, 
     char * BETA, 
     int IC, int JC, int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cplacnjg_C( 
     PBTYP_T * TYPE, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplacnjg_D( 
     PBTYP_T * TYPE, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplacnjg_S( 
     PBTYP_T * TYPE, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cplacnjg_Z( 
     PBTYP_T * TYPE, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
);

void hscal_PB_Cptrsv_C(
     PBTYP_T * TYPE, int FBCAST, char * UPLO, char * TRANS,
     char * DIAG, int N, int IA, int JA,
     int * DESCA, int INCXC,
     int INCXR,
     int nprow, int npcol, int myrow, int mycol,
     double *tcomp, int *tcomm
);


void hscal_PB_Cptrsv_D(
     PBTYP_T * TYPE, int FBCAST, char * UPLO, char * TRANS,
     char * DIAG, int N, int IA, int JA,
     int * DESCA, int INCXC,
     int INCXR,
     int nprow, int npcol, int myrow, int mycol,
     double *tcomp, int *tcomm
);

void hscal_PB_Cptrsv_S(
     PBTYP_T * TYPE, int FBCAST, char * UPLO, char * TRANS,
     char * DIAG, int N, int IA, int JA,
     int * DESCA, int INCXC,
     int INCXR,
     int nprow, int npcol, int myrow, int mycol,
     double *tcomp, int *tcomm
);

void hscal_PB_Cptrsv_Z(
     PBTYP_T * TYPE, int FBCAST, char * UPLO, char * TRANS,
     char * DIAG, int N, int IA, int JA,
     int * DESCA, int INCXC,
     int INCXR,
     int nprow, int npcol, int myrow, int mycol,
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB_C( 
     PBTYP_T * TYPE, char * VARIANT, char * SIDE, char * UPLO,
     char * TRANSA, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB_D(
     PBTYP_T * TYPE, char * VARIANT, char * SIDE, char * UPLO,
     char * TRANSA, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB_S(
     PBTYP_T * TYPE, char * VARIANT, char * SIDE, char * UPLO,
     char * TRANSA, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB_Z(
     PBTYP_T * TYPE, char * VARIANT, char * SIDE, char * UPLO,
     char * TRANSA, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmB_C( 
     PBTYP_T * TYPE, char * DIRECB, char * SIDE,
     char * UPLO, char * TRANSA, char * DIAG, int M, int N,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmB_D( 
     PBTYP_T * TYPE, char * DIRECB, char * SIDE,
     char * UPLO, char * TRANSA, char * DIAG, int M, int N,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmB_S( 
     PBTYP_T * TYPE, char * DIRECB, char * SIDE,
     char * UPLO, char * TRANSA, char * DIAG, int M, int N,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmB_Z( 
     PBTYP_T * TYPE, char * DIRECB, char * SIDE,
     char * UPLO, char * TRANSA, char * DIAG, int M, int N,
     char * ALPHA, 
     int IA, int JA, int * DESCA,
     int IB, int JB, int * DESCB,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB0_C(
     PBTYP_T * TYPE, char * SIDE, char * UPLO, char * DIAG,
     int M, int N, char * ALPHA, 
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB0_D(
     PBTYP_T * TYPE, char * SIDE, char * UPLO, char * DIAG,
     int M, int N, char * ALPHA, 
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB0_S(
     PBTYP_T * TYPE, char * SIDE, char * UPLO, char * DIAG,
     int M, int N, char * ALPHA, 
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB0_Z(
     PBTYP_T * TYPE, char * SIDE, char * UPLO, char * DIAG,
     int M, int N, char * ALPHA, 
     int IA, int JA, int * DESCA, 
     int IB, int JB, int * DESCB,
     int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB1_C( 
     PBTYP_T * TYPE, char * SIDE, char * UPLO, char * TRANSA,
     char * DIAG, int M, int N, char * ALPHA, 
     int IA, int JA, int * DESCA,  
     int IB, int JB, int * DESCB,
     int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB1_D(
     PBTYP_T * TYPE, char * SIDE, char * UPLO, char * TRANSA,
     char * DIAG, int M, int N, char * ALPHA, 
     int IA, int JA, int * DESCA,  
     int IB, int JB, int * DESCB,
     int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB1_S(
     PBTYP_T * TYPE, char * SIDE, char * UPLO, char * TRANSA,
     char * DIAG, int M, int N, char * ALPHA, 
     int IA, int JA, int * DESCA,  
     int IB, int JB, int * DESCB,
     int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_CptrsmAB1_Z(
     PBTYP_T * TYPE, char * SIDE, char * UPLO, char * TRANSA,
     char * DIAG, int M, int N, char * ALPHA, 
     int IA, int JA, int * DESCA,  
     int IB, int JB, int * DESCB,
     int * DESCC,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Ctztrmm_C(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDB, int LDC,
           int nprow, int npcol, int myrow, int mycol,
           double *tcomp
);

void hscal_PB_Ctztrmm_D(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDB, int LDC,
           int nprow, int npcol, int myrow, int mycol,
           double *tcomp
);

void hscal_PB_Ctztrmm_S(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDB, int LDC,
           int nprow, int npcol, int myrow, int mycol,
           double *tcomp
);

void hscal_PB_Ctztrmm_Z(
           PBTYP_T * TYPE, char * SIDE, char * UPLO,
           char * TRANS, char * DIAG, int M, int N, int K,
           int IOFFD, char * ALPHA, int LDA,
           int LDB, int LDC,
           int nprow, int npcol, int myrow, int mycol,
           double *tcomp
);

void hscal_PB_Cptrsm_C( 
     PBTYP_T * TYPE, int FBCAST, char * SIDE, char * UPLO,
     char * TRANS, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int LDBC, int LDBR,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptrsm_D( 
     PBTYP_T * TYPE, int FBCAST, char * SIDE, char * UPLO,
     char * TRANS, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int LDBC, int LDBR,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptrsm_S( 
     PBTYP_T * TYPE, int FBCAST, char * SIDE, char * UPLO,
     char * TRANS, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int LDBC, int LDBR,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

void hscal_PB_Cptrsm_Z( 
     PBTYP_T * TYPE, int FBCAST, char * SIDE, char * UPLO,
     char * TRANS, char * DIAG, int M, int N, char * ALPHA,
     int IA, int JA, int * DESCA,
     int LDBC, int LDBR,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
);

#endif  /* __HMPI_SCALAPACK_PTOOLS_INCLUDE_HH */
