
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                         (INTERNAL)                               *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HSCALAPACK_SERIAL_MPC_MACROS_HH_
#define __HSCALAPACK_SERIAL_MPC_MACROS_HH_

/*
* ------------------------------------------------------------------
*                      SERIAL HSCALAPACK MACROS
* ------------------------------------------------------------------
*/
#define    HSCAL_SCHEME_START \
           { \
              int pm_hscal_i; \
              for (pm_hscal_i = 0; pm_hscal_i < 1; pm_hscal_i++) \
              {

#define    HSCAL_SCHEME_END \
              } \
           }

#define    HSCAL_PRE_SER( myrow, mycol, nprow, npcol ) \
           { \
              for ((myrow) = 0; (myrow) < (nprow); (myrow)++) \
              { \
                 for ((mycol) = 0; (mycol) < (npcol); (mycol)++) \
                 {

#define    HSCAL_POST_SER( myrow, mycol, nprow, npcol ) \
                 } \
              } \
           }

#define    HSCAL_ALLOC_TCOMP_TCOMM_ARRAYS( \
                tcomp_l, \
                tcomm_l, \
                tcomp, \
                nprow, \
                npcol \
           ) \
           { \
              tcomp_l = (double*)malloc(nprow*npcol*sizeof(double)); \
              if (tcomp_l == NULL) \
              { \
                 break; \
              } \
              tcomm_l = (int*)malloc(nprow*npcol*nprow*npcol*sizeof(int)); \
              if (tcomm_l == NULL) \
              { \
                 free(tcomp_l); \
                 break; \
              } \
              tcomp = (double*)malloc(nprow*npcol*sizeof(double)); \
              if (tcomp == NULL) \
              { \
                 free(tcomp_l); \
                 free(tcomm_l); \
                 break; \
              } \
           }

#define    HSCAL_FREE_TCOMP_TCOMM_ARRAYS( \
                tcomp_l, \
                tcomm_l, \
                tcomp \
           ) \
           { \
              free(tcomp_l); \
              free(tcomm_l); \
              free(tcomp); \
           } 

#define    HSCAL_ALLOC_TCOMP_ARRAYS( \
                tcomp_l, \
                tcomp, \
                nprow, \
                npcol \
           ) \
           { \
              tcomp_l = (double*)malloc(nprow*npcol*sizeof(double)); \
              if (tcomp_l == NULL) \
              { \
                 break; \
              } \
              tcomp = (double*)malloc(nprow*npcol*sizeof(double)); \
              if (tcomp == NULL) \
              { \
                 free(tcomp_l); \
                 break; \
              } \
           }

#define    HSCAL_FREE_TCOMP_ARRAYS( \
                tcomp_l, \
                tcomp \
           ) \
           { \
              free(tcomp_l); \
              free(tcomp); \
           } 

#define    HSCAL_ALLOC_TCOMP_ARRAY( \
                tcomp, \
                nprow, \
                npcol \
           ) \
           { \
              tcomp = (double*)malloc(nprow*npcol*sizeof(double)); \
              if (tcomp == NULL) \
              { \
                 break; \
              } \
           }

#define    HSCAL_FREE_TCOMP_ARRAY( \
                tcomp \
           ) \
           { \
              free(tcomp); \
           } 

#define    HSCAL_ALLOC_TCOMP_LARRAYS( \
                tcomp_l, \
                nprow, \
                npcol \
           ) \
           { \
              tcomp_l = (double*)malloc(nprow*npcol*sizeof(double)); \
              if (tcomp_l == NULL) \
              { \
                 break; \
              } \
           }

#define    HSCAL_FREE_TCOMP_LARRAYS( \
                tcomp_l \
           ) \
           { \
              free(tcomp_l); \
           } 

#define    HSCAL_ALLOC_TCOMP_TCOMM_LARRAYS( \
                tcomp_l, \
                tcomm_l, \
                nprow, \
                npcol \
           ) \
           { \
              tcomp_l = (double*)malloc(nprow*npcol*sizeof(double)); \
              if (tcomp_l == NULL) \
              { \
                 break; \
              } \
              tcomm_l = (int*)malloc(nprow*npcol*nprow*npcol*sizeof(int)); \
              if (tcomm_l == NULL) \
              { \
                 free(tcomp_l); \
                 break; \
              } \
           }

#define    HSCAL_FREE_TCOMP_TCOMM_LARRAYS( \
                tcomp_l, \
                tcomm_l \
           ) \
           { \
              free(tcomp_l); \
              free(tcomm_l); \
           } 

#endif  /* __HSCALAPACK_SERIAL_MPC_MACROS_HH_ */
