
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                    TEST HEADER                                   *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_TEST_INCLUDE_HH
#define __HMPI_SCALAPACK_TEST_INCLUDE_HH

int hscalt_ladd(hscalinteger *j, hscalinteger *k, hscalinteger *i__);
int hscalt_lmul(hscalinteger *k, hscalinteger *j, hscalinteger *i__);
int hscalt_xjumpm(
    hscalinteger *jumpm, hscalinteger *mult, 
    hscalinteger *iadd,
    hscalinteger *irann, hscalinteger *iranm, hscalinteger *iam, hscalinteger *icm);
int hscalt_setran(hscalinteger *iran, hscalinteger *ia, hscalinteger *ic);
int hscalt_jumpit(
    hscalinteger *mult, hscalinteger *iadd, hscalinteger *irann, 
    hscalinteger *iranm);
hscaldoublereal hscalt_psrand(hscalinteger *idumm);
hscaldoublereal hscalt_pdrand(hscalinteger *idumm);

int hscalt_pcmatgen(hscalinteger *ictxt, char *aform, char *diag,
        hscalinteger *m, hscalinteger *n, hscalinteger *mb, hscalinteger *nb, hscalcomplex *a, hscalinteger
        *lda, hscalinteger *iarow, hscalinteger *iacol, hscalinteger *iseed, hscalinteger *iroff,
        hscalinteger *irnum, hscalinteger *icoff, hscalinteger *icnum, hscalinteger *myrow,
        hscalinteger *mycol, hscalinteger *nprow, hscalinteger *npcol);

int hscalt_pdmatgen(hscalinteger *ictxt, char *aform, char *diag,
        hscalinteger *m, hscalinteger *n, hscalinteger *mb, hscalinteger *nb, hscaldoublereal *a,
        hscalinteger *lda, hscalinteger *iarow, hscalinteger *iacol, hscalinteger *iseed, hscalinteger
        *iroff, hscalinteger *irnum, hscalinteger *icoff, hscalinteger *icnum, hscalinteger *
        myrow, hscalinteger *mycol, hscalinteger *nprow, hscalinteger *npcol);

int hscalt_psmatgen(hscalinteger *ictxt, char *aform, char *diag,
        hscalinteger *m, hscalinteger *n, hscalinteger *mb, hscalinteger *nb, hscalreal *a, hscalinteger *
        lda, hscalinteger *iarow, hscalinteger *iacol, hscalinteger *iseed, hscalinteger *iroff,
        hscalinteger *irnum, hscalinteger *icoff, hscalinteger *icnum, hscalinteger *myrow,
        hscalinteger *mycol, hscalinteger *nprow, hscalinteger *npcol);

int hscalt_pzmatgen(hscalinteger *ictxt, char *aform, char *diag,
        hscalinteger *m, hscalinteger *n, hscalinteger *mb, hscalinteger *nb, hscaldoublecomplex *a,
        hscalinteger *lda, hscalinteger *iarow, hscalinteger *iacol, hscalinteger *iseed, hscalinteger
        *iroff, hscalinteger *irnum, hscalinteger *icoff, hscalinteger *icnum, hscalinteger *
        myrow, hscalinteger *mycol, hscalinteger *nprow, hscalinteger *npcol);

#endif /* __HMPI_SCALAPACK_TEST_INCLUDE_HH */

