/*
 *  This file includes the standard C libraries, as well as system dependant
 *  include files.  All BLACS routines include this file.
 */
#ifndef __HSCAL_BLACS_BCONFIG_H
#define __HSCAL_BLACS_BCONFIG_H

/*
 * These macros define the naming strategy needed for a fortran77
 * routine to call a C routine, and whether to build so they may be
 * called from C or f77.  For the f77 call C interface, ADD_ assumes that
 * f77 calls expect C routines to have an underscore postfixed to the name
 * (Suns, and the Intel expect this).  NOCHANGE indicates that f77 expects
 * the name called by fortran to be identical to that compiled by C
 * (RS6K's do this).  UPCASE says it expects C routines called by fortran
 * to be in all upcase (CRAY wants this).  The variable F77_CALL_C is always
 * set to one of these values.  If the BLACS will be called from C, we define
 * INTFACE to be CALL_C, otherwise, it is set to F77_CALL_C.
 */
#define ADD_     0
#define NOCHANGE 1
#define UPCASE   2
#define F77ISF2C 3
#define C_CALL   4

#ifdef UpCase
#define F77_CALL_C UPCASE
#endif

#ifdef NoChange
#define F77_CALL_C NOCHANGE
#endif

#ifdef Add_
#define F77_CALL_C ADD_
#endif

#ifdef f77IsF2C
#define F77_CALL_C F77ISF2C
#endif

#ifndef F77_CALL_C
#define F77_CALL_C ADD_
#endif

#ifdef CallFromC
#define INTFACE C_CALL
#else
#define INTFACE F77_CALL_C
#endif

#define    BLACS_CTOP_DEFAULT        ' '
#define    BLACS_CTOP_IRING          'I'
#define    BLACS_CTOP_DRING          'D'
#define    BLACS_CTOP_SRING          'S'
#define    BLACS_CTOP_HYPER          'H'
#define    BLACS_CTOP_FULL           'F'
#define    BLACS_CTOP_MRING          'M'
#define    BLACS_CTOP_TTREE          'T'
#define    BLACS_CTOP_TREE1          '1'
#define    BLACS_CTOP_TREE2          '2'
#define    BLACS_CTOP_TREE3          '3'
#define    BLACS_CTOP_TREE4          '4'
#define    BLACS_CTOP_TREE5          '5'
#define    BLACS_CTOP_TREE6          '6'
#define    BLACS_CTOP_TREE7          '7'
#define    BLACS_CTOP_TREE8          '8'
#define    BLACS_CTOP_TREE9          '9'

/*
 *  Substitute the topology of your
 *  choice to vary the default topology
 *  (TOP = ' ') for broadcast and combines.
For example, if you want to substitute HyperCube topology,
use the following macros
#define    DefBSTop            BLACS_CTOP_HYPER
#define    DefCombTop          BLACS_CTOP_HYPER       
 */
#define    DefBSTop            BLACS_CTOP_DEFAULT
#define    DefCombTop          BLACS_CTOP_DEFAULT

#endif
