
#include "../../../include/hscalapack.h"

/*------------------------------------------------------------------*/

/* Common Block Declarations */

struct {
    hscalinteger irand[2], ias[2], ics[2];
} hscal_rancom_;

#define hscal_rancom_1 hscal_rancom_

/*------------------------------------------------------------------*/

/*  ===================================================================== */
/*     SUBROUTINE LADD */
/*  ===================================================================== */

/* Subroutine */ int hscalt_ladd(hscalinteger *j, hscalinteger *k, hscalinteger *i__)
{

/*  -- ScaLAPACK routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Array Arguments .. */
/*     .. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

    /* Parameter adjustments */
    --i__;
    --k;
    --j;

    /* Function Body */
    i__[1] = (k[1] + j[1]) % 65536;
    i__[2] = ((k[1] + j[1]) / 65536 + k[2] + j[2]) % 32768;

    return 0;

/*     End of LADD */

} /* hscalt_ladd */


/*  ===================================================================== */
/*     SUBROUTINE LMUL */
/*  ===================================================================== */

/* Subroutine */ int hscalt_lmul(hscalinteger *k, hscalinteger *j, hscalinteger *i__)
{
    static hscalinteger kt, lt;


/*  -- ScaLAPACK routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Array Arguments .. */
/*     .. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Executable Statements .. */

    /* Parameter adjustments */
    --i__;
    --j;
    --k;

    /* Function Body */
    kt = k[1] * j[1];
    if (kt < 0) {
	kt += -2147483648;
    }
    i__[1] = kt % 65536;
    lt = k[1] * j[2] + k[2] * j[1];
    if (lt < 0) {
	lt += -2147483648;
    }
    kt = kt / 65536 + lt;
    if (kt < 0) {
	kt += -2147483648;
    }
    i__[2] = kt % 32768;

    return 0;

/*     End of LMUL */

} /* hscalt_lmul */


/*  ===================================================================== */
/*     SUBROUTINE XJUMPM */
/*  ===================================================================== */

/* Subroutine */ int hscalt_xjumpm(hscalinteger *jumpm, hscalinteger *mult, hscalinteger *iadd, 
	hscalinteger *irann, hscalinteger *iranm, hscalinteger *iam, hscalinteger *icm)
{
    /* System generated locals */
    hscalinteger i__1;

    /* Local variables */
    static hscalinteger i__, j[2];

/*  -- ScaLAPACK routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  ===================================================================== */

/*     .. Local Scalars .. */
/*     .. */
/*     .. Local Arrays .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. Executable Statements .. */

    /* Parameter adjustments */
    --icm;
    --iam;
    --iranm;
    --irann;
    --iadd;
    --mult;

    /* Function Body */
    if (*jumpm > 0) {
	for (i__ = 1; i__ <= 2; ++i__) {
	    iam[i__] = mult[i__];
	    icm[i__] = iadd[i__];
/* L10: */
	}
	i__1 = *jumpm - 1;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    hscalt_lmul(&iam[1], &mult[1], j);
	    iam[1] = j[0];
	    iam[2] = j[1];
	    hscalt_lmul(&icm[1], &mult[1], j);
	    hscalt_ladd(&iadd[1], j, &icm[1]);
/* L20: */
	}
	hscalt_lmul(&irann[1], &iam[1], j);
	hscalt_ladd(j, &icm[1], &iranm[1]);
    } else {
	iranm[1] = irann[1];
	iranm[2] = irann[2];
    }

    return 0;

/*     End of XJUMPM */

}


/*  ===================================================================== */
/*     SUBROUTINE SETRAN */
/*  ===================================================================== */

/* Subroutine */ int hscalt_setran(hscalinteger *iran, hscalinteger *ia, hscalinteger *ic)
{
    static hscalinteger i__;


/*  -- ScaLAPACK routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Array Arguments .. */
/*     .. */

/*  ===================================================================== */

/*     .. Local Scalars .. */
/*     .. */
/*     .. Local Arrays .. */
/*     .. */
/*     .. Common Blocks .. */
/*     .. */
/*     .. Executable Statements .. */

    /* Parameter adjustments */
    --ic;
    --ia;
    --iran;

    /* Function Body */
    for (i__ = 1; i__ <= 2; ++i__) {
	hscal_rancom_1.irand[i__ - 1] = iran[i__];
	hscal_rancom_1.ias[i__ - 1] = ia[i__];
	hscal_rancom_1.ics[i__ - 1] = ic[i__];
/* L10: */
    }

    return 0;

/*     End of SETRAN */

} /* hscalt_setran */


/*  ===================================================================== */
/*     SUBROUTINE JUMPIT */
/*  ===================================================================== */

/* Subroutine */ int hscalt_jumpit(hscalinteger *mult, hscalinteger *iadd, hscalinteger *irann, 
	hscalinteger *iranm)
{
    static hscalinteger j[2];

/*  -- ScaLAPACK routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Array Arguments .. */
/*     .. */

/*  ===================================================================== */

/*     .. Local Arrays .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. Common Blocks .. */
/*     .. */
/*     .. Executable Statements .. */

    /* Parameter adjustments */
    --iranm;
    --irann;
    --iadd;
    --mult;

    /* Function Body */
    hscalt_lmul(&irann[1], &mult[1], j);
    hscalt_ladd(j, &iadd[1], &iranm[1]);

    hscal_rancom_1.irand[0] = iranm[1];
    hscal_rancom_1.irand[1] = iranm[2];

    return 0;

/*     End of JUMPIT */

}


/*  ===================================================================== */
/*     REAL FUNCTION PSRAND */
/*  ===================================================================== */

hscaldoublereal hscalt_psrand(hscalinteger *idumm)
{
    /* System generated locals */
    hscalreal ret_val;

    /* Local variables */
    static hscalinteger j[2];

/*  -- ScaLAPACK routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Arrays .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Common Blocks .. */
/*     .. */
/*     .. Executable Statements .. */

    ret_val = ((hscalreal) hscal_rancom_1.irand[0] + (hscalreal) hscal_rancom_1.irand[1] * 65536.f) 
	    / 2147483648.f;

    hscalt_lmul(hscal_rancom_1.irand, hscal_rancom_1.ias, j);
    hscalt_ladd(j, hscal_rancom_1.ics, hscal_rancom_1.irand);

    return ret_val;

/*     End of PSRAND */

}


/*  ===================================================================== */
/*     DOUBLE PRECISION FUNCTION PDRAND */
/*  ===================================================================== */

hscaldoublereal hscalt_pdrand(hscalinteger *idumm)
{
    /* System generated locals */
    hscaldoublereal ret_val;

    /* Local variables */
    static hscalinteger j[2];

/*  -- ScaLAPACK routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Arrays .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. Common Blocks .. */
/*     .. */
/*     .. Executable Statements .. */

    ret_val = ((hscaldoublereal) hscal_rancom_1.irand[0] + (hscaldoublereal) hscal_rancom_1.irand[1]
	     * 65536.) / 2147483648.;

    hscalt_lmul(hscal_rancom_1.irand, hscal_rancom_1.ias, j);
    hscalt_ladd(j, hscal_rancom_1.ics, hscal_rancom_1.irand);

    return ret_val;

/*     End of PDRAND */

}

/*------------------------------------------------------------------*/
