
#include "../../../include/hscalapack.h"

/* Subroutine */ int hscalt_psmatgen(hscalinteger *ictxt, char *aform, char *diag, 
	hscalinteger *m, hscalinteger *n, hscalinteger *mb, hscalinteger *nb, hscalreal *a, hscalinteger *
	lda, hscalinteger *iarow, hscalinteger *iacol, hscalinteger *iseed, hscalinteger *iroff, 
	hscalinteger *irnum, hscalinteger *icoff, hscalinteger *icnum, hscalinteger *myrow, 
	hscalinteger *mycol, hscalinteger *nprow, hscalinteger *npcol)
{
    hscalinteger c__0 = 0;
    hscalinteger c__9 = 9;
    hscalinteger c__1 = 1;

    /* System generated locals */
    hscalinteger a_dim1, a_offset, i__1, i__2, i__3, i__4;
    hscalreal r__1;

    /* Local variables */
    static hscalinteger i__, j, ic, ik, jk, ir, mp, nq, ia1[2], ia2[2], ia3[2], 
	    ia4[2], ia5[2], ib1[2], ib2[2], ib3[2], ic1[2], ic2[2], ic3[2], 
	    ic4[2], ic5[2], iadd[2], mend, nend, moff, noff;
    static hscallogical herm;
    static hscalinteger info, npmb, nqnb;
    static hscallogical tran;
    static hscalinteger mult[2];
    static hscallogical symm;
    static hscalinteger iran1[2], iran2[2], iran3[2], iran4[2], itmp1[2], itmp2[2],
	     jump1, jump2, jump3, jump4, jump5, jump6, jump7, itmp3[2];
    static hscalinteger ioffc, jseed[2];
    static hscalinteger ioffr, mrcol, maxmn, mrrow;

/*  -- ScaLAPACK routine (version 1.7) -- */
/*     University of Tennessee, Knoxville, Oak Ridge National Laboratory, */
/*     and University of California, Berkeley. */
/*     May 1, 1997 */

/*     .. Scalar Arguments .. */
/*     .. */
/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  PSMATGEN : Parallel Real Single precision MATrix GENerator. */
/*  Generate (or regenerate) a distributed matrix A (or sub-matrix of A). */

/*  Arguments */
/*  ========= */

/*  ICTXT   (global input) INTEGER */
/*          The BLACS context handle, indicating the global context of */
/*          the operation. The context itself is global. */

/*  AFORM   (global input) CHARACTER*1 */
/*          if AFORM = 'S' : A is returned is a symmetric matrix. */
/*          if AFORM = 'H' : A is returned is a Hermitian matrix. */
/*          if AFORM = 'T' : A is overwritten with the transpose of */
/*                           what would normally be generated. */
/*          if AFORM = 'C' : A is overwritten with the conjugate trans- */
/*                           pose of what would normally be generated. */
/*          otherwise a random matrix is generated. */

/*  DIAG    (global input) CHARACTER*1 */
/*          if DIAG = 'D' : A is diagonally dominant. */

/*  M       (global input) INTEGER */
/*          The number of rows in the generated distributed matrix. */

/*  N       (global input) INTEGER */
/*          The number of columns in the generated distributed */
/*          matrix. */

/*  MB      (global input) INTEGER */
/*          The row blocking factor of the distributed matrix A. */

/*  NB      (global input) INTEGER */
/*          The column blocking factor of the distributed matrix A. */

/*  A       (local output) REAL, pointer into the local memory */
/*          to an array of dimension ( LDA, * ) containing the local */
/*          pieces of the distributed matrix. */

/*  LDA     (local input) INTEGER */
/*          The leading dimension of the array containing the local */
/*          pieces of the distributed matrix A. */

/*  IAROW   (global input) INTEGER */
/*          The row processor coordinate which holds the first block */
/*          of the distributed matrix A. */

/*  IACOL   (global input) INTEGER */
/*          The column processor coordinate which holds the first */
/*          block of the distributed matrix A. */

/*  ISEED   (global input) INTEGER */
/*          The seed number to generate the distributed matrix A. */

/*  IROFF   (local input) INTEGER */
/*          The number of local rows of A that have already been */
/*          generated.  It should be a multiple of MB. */

/*  IRNUM   (local input) INTEGER */
/*          The number of local rows to be generated. */

/*  ICOFF   (local input) INTEGER */
/*          The number of local columns of A that have already been */
/*          generated.  It should be a multiple of NB. */

/*  ICNUM   (local input) INTEGER */
/*          The number of local columns to be generated. */

/*  MYROW   (local input) INTEGER */
/*          The row process coordinate of the calling process. */

/*  MYCOL   (local input) INTEGER */
/*          The column process coordinate of the calling process. */

/*  NPROW   (global input) INTEGER */
/*          The number of process rows in the grid. */

/*  NPCOL   (global input) INTEGER */
/*          The number of process columns in the grid. */

/*  Notes */
/*  ===== */

/*  The code is originally developed by David Walker, ORNL, */
/*  and modified by Jaeyoung Choi, ORNL. */

/*  Reference: G. Fox et al. */
/*  Section 12.3 of "Solving problems on concurrent processors Vol. I" */

/*  ===================================================================== */

/*     .. Parameters .. */
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. Local Arrays .. */
/*     .. */
/*     .. External Subroutines .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*     .. */
/*     .. External Functions .. */
/*     .. */
/*     .. Executable Statements .. */

/*     Test the input arguments */

    /* Parameter adjustments */
    a_dim1 = *lda;
    a_offset = 1 + a_dim1;
    a -= a_offset;

    /* Function Body */
    mp = numroc_(m, mb, myrow, iarow, nprow);
    nq = numroc_(n, nb, mycol, iacol, npcol);
    symm = hscal_lsame(aform, "S");
    herm = hscal_lsame(aform, "H");
    tran = hscal_lsame(aform, "T");

    info = 0;
    if (! hscal_lsame(diag, "D") && ! hscal_lsame(diag, "N")) {
	info = 3;
    } else if (symm || herm) {
	if (*m != *n) {
	    info = 5;
	} else if (*mb != *nb) {
	    info = 7;
	}
    } else if (*m < 0) {
	info = 4;
    } else if (*n < 0) {
	info = 5;
    } else if (*mb < 1) {
	info = 6;
    } else if (*nb < 1) {
	info = 7;
    } else if (*lda < 0) {
	info = 9;
    } else if (*iarow < 0 || *iarow >= *nprow) {
	info = 10;
    } else if (*iacol < 0 || *iacol >= *npcol) {
	info = 11;
    } else if (*iroff % *mb > 0) {
	info = 13;
    } else if (*irnum > mp - *iroff) {
	info = 14;
    } else if (*icoff % *nb > 0) {
	info = 15;
    } else if (*icnum > nq - *icoff) {
	info = 16;
    } else if (*myrow < 0 || *myrow >= *nprow) {
	info = 17;
    } else if (*mycol < 0 || *mycol >= *npcol) {
	info = 18;
    }
    if (info != 0) {
	hscal_xerbla("PSMATGEN", &info);
	return 0;
    }

    mrrow = (*nprow + *myrow - *iarow) % *nprow;
    mrcol = (*npcol + *mycol - *iacol) % *npcol;
    npmb = *nprow * *mb;
    nqnb = *npcol * *nb;
    moff = *iroff / *mb;
    noff = *icoff / *nb;
    mend = hscal_iceil(irnum, mb) + moff;
    nend = hscal_iceil(icnum, nb) + noff;

    mult[0] = 20077;
    mult[1] = 16838;
    iadd[0] = 12345;
    iadd[1] = 0;
    jseed[0] = *iseed;
    jseed[1] = 0;

/*     Symmetric or Hermitian matrix will be generated. */

    if (symm || herm) {

/*        First, generate the lower triangular part (with diagonal block) */

	jump1 = 1;
	jump2 = npmb;
	jump3 = *m;
	jump4 = nqnb;
	jump5 = *nb;
	jump6 = mrcol;
	jump7 = *mb * mrrow;

	hscalt_xjumpm(&jump1, mult, iadd, jseed, iran1, ia1, ic1);
	hscalt_xjumpm(&jump2, mult, iadd, iran1, itmp1, ia2, ic2);
	hscalt_xjumpm(&jump3, mult, iadd, iran1, itmp1, ia3, ic3);
	hscalt_xjumpm(&jump4, ia3, ic3, iran1, itmp1, ia4, ic4);
	hscalt_xjumpm(&jump5, ia3, ic3, iran1, itmp1, ia5, ic5);
	hscalt_xjumpm(&jump6, ia5, ic5, iran1, itmp3, itmp1, itmp2);
	hscalt_xjumpm(&jump7, mult, iadd, itmp3, iran1, itmp1, itmp2);
	hscalt_xjumpm(&noff, ia4, ic4, iran1, itmp1, itmp2, itmp3);
	hscalt_xjumpm(&moff, ia2, ic2, itmp1, iran1, itmp2, itmp3);
	hscalt_setran(iran1, ia1, ic1);

	for (i__ = 1; i__ <= 2; ++i__) {
	    ib1[i__ - 1] = iran1[i__ - 1];
	    ib2[i__ - 1] = iran1[i__ - 1];
	    ib3[i__ - 1] = iran1[i__ - 1];
/* L10: */
	}

	jk = 1;
	i__1 = nend;
	for (ic = noff + 1; ic <= i__1; ++ic) {
	    ioffc = ((ic - 1) * *npcol + mrcol) * *nb;
	    i__2 = *nb;
	    for (i__ = 1; i__ <= i__2; ++i__) {
		if (jk > *icnum) {
		    goto L90;
		}

		ik = 1;
		i__3 = mend;
		for (ir = moff + 1; ir <= i__3; ++ir) {
		    ioffr = ((ir - 1) * *nprow + mrrow) * *mb;

		    if (ioffr > ioffc) {
			i__4 = *mb;
			for (j = 1; j <= i__4; ++j) {
			    if (ik > *irnum) {
				goto L60;
			    }
			    a[ik + jk * a_dim1] = 1.f - hscalt_psrand(&c__0) * 2.f;
			    ++ik;
/* L20: */
			}

		    } else if (ioffc == ioffr) {
			ik = ik + i__ - 1;
			if (ik > *irnum) {
			    goto L60;
			}
			i__4 = i__ - 1;
			for (j = 1; j <= i__4; ++j) {
			    a[ik + jk * a_dim1] = 1.f - hscalt_psrand(&c__0) * 2.f;
/* L30: */
			}
			a[ik + jk * a_dim1] = 1.f - hscalt_psrand(&c__0) * 2.f;
			i__4 = *mb - i__;
			for (j = 1; j <= i__4; ++j) {
			    if (ik + j > *irnum) {
				goto L60;
			    }
			    a[ik + j + jk * a_dim1] = 1.f - hscalt_psrand(&c__0) * 
				    2.f;
			    a[ik + (jk + j) * a_dim1] = a[ik + j + jk * 
				    a_dim1];
/* L40: */
			}
			ik = ik + *mb - i__ + 1;
		    } else {
			ik += *mb;
		    }

		    hscalt_jumpit(ia2, ic2, ib1, iran2);
		    ib1[0] = iran2[0];
		    ib1[1] = iran2[1];
/* L50: */
		}

L60:
		++jk;
		hscalt_jumpit(ia3, ic3, ib2, iran3);
		ib1[0] = iran3[0];
		ib1[1] = iran3[1];
		ib2[0] = iran3[0];
		ib2[1] = iran3[1];
/* L70: */
	    }

	    hscalt_jumpit(ia4, ic4, ib3, iran4);
	    ib1[0] = iran4[0];
	    ib1[1] = iran4[1];
	    ib2[0] = iran4[0];
	    ib2[1] = iran4[1];
	    ib3[0] = iran4[0];
	    ib3[1] = iran4[1];
/* L80: */
	}

/*        Next, generate the upper triangular part. */

L90:
	mult[0] = 20077;
	mult[1] = 16838;
	iadd[0] = 12345;
	iadd[1] = 0;
	jseed[0] = *iseed;
	jseed[1] = 0;

	jump1 = 1;
	jump2 = nqnb;
	jump3 = *n;
	jump4 = npmb;
	jump5 = *mb;
	jump6 = mrrow;
	jump7 = *nb * mrcol;

	hscalt_xjumpm(&jump1, mult, iadd, jseed, iran1, ia1, ic1);
	hscalt_xjumpm(&jump2, mult, iadd, iran1, itmp1, ia2, ic2);
	hscalt_xjumpm(&jump3, mult, iadd, iran1, itmp1, ia3, ic3);
	hscalt_xjumpm(&jump4, ia3, ic3, iran1, itmp1, ia4, ic4);
	hscalt_xjumpm(&jump5, ia3, ic3, iran1, itmp1, ia5, ic5);
	hscalt_xjumpm(&jump6, ia5, ic5, iran1, itmp3, itmp1, itmp2);
	hscalt_xjumpm(&jump7, mult, iadd, itmp3, iran1, itmp1, itmp2);
	hscalt_xjumpm(&moff, ia4, ic4, iran1, itmp1, itmp2, itmp3);
	hscalt_xjumpm(&noff, ia2, ic2, itmp1, iran1, itmp2, itmp3);
	hscalt_setran(iran1, ia1, ic1);

	for (i__ = 1; i__ <= 2; ++i__) {
	    ib1[i__ - 1] = iran1[i__ - 1];
	    ib2[i__ - 1] = iran1[i__ - 1];
	    ib3[i__ - 1] = iran1[i__ - 1];
/* L100: */
	}

	ik = 1;
	i__1 = mend;
	for (ir = moff + 1; ir <= i__1; ++ir) {
	    ioffr = ((ir - 1) * *nprow + mrrow) * *mb;
	    i__2 = *mb;
	    for (j = 1; j <= i__2; ++j) {
		if (ik > *irnum) {
		    goto L160;
		}
		jk = 1;
		i__3 = nend;
		for (ic = noff + 1; ic <= i__3; ++ic) {
		    ioffc = ((ic - 1) * *npcol + mrcol) * *nb;
		    if (ioffc > ioffr) {
			i__4 = *nb;
			for (i__ = 1; i__ <= i__4; ++i__) {
			    if (jk > *icnum) {
				goto L130;
			    }
			    a[ik + jk * a_dim1] = 1.f - hscalt_psrand(&c__0) * 2.f;
			    ++jk;
/* L110: */
			}
		    } else {
			jk += *nb;
		    }
		    hscalt_jumpit(ia2, ic2, ib1, iran2);
		    ib1[0] = iran2[0];
		    ib1[1] = iran2[1];
/* L120: */
		}

L130:
		++ik;
		hscalt_jumpit(ia3, ic3, ib2, iran3);
		ib1[0] = iran3[0];
		ib1[1] = iran3[1];
		ib2[0] = iran3[0];
		ib2[1] = iran3[1];
/* L140: */
	    }

	    hscalt_jumpit(ia4, ic4, ib3, iran4);
	    ib1[0] = iran4[0];
	    ib1[1] = iran4[1];
	    ib2[0] = iran4[0];
	    ib2[1] = iran4[1];
	    ib3[0] = iran4[0];
	    ib3[1] = iran4[1];
/* L150: */
	}
L160:

/*     (Conjugate) Transposed matrix A will be generated. */

	;
    } else if (tran || hscal_lsame(aform, "C")) {

	jump1 = 1;
	jump2 = nqnb;
	jump3 = *n;
	jump4 = npmb;
	jump5 = *mb;
	jump6 = mrrow;
	jump7 = *nb * mrcol;

	hscalt_xjumpm(&jump1, mult, iadd, jseed, iran1, ia1, ic1);
	hscalt_xjumpm(&jump2, mult, iadd, iran1, itmp1, ia2, ic2);
	hscalt_xjumpm(&jump3, mult, iadd, iran1, itmp1, ia3, ic3);
	hscalt_xjumpm(&jump4, ia3, ic3, iran1, itmp1, ia4, ic4);
	hscalt_xjumpm(&jump5, ia3, ic3, iran1, itmp1, ia5, ic5);
	hscalt_xjumpm(&jump6, ia5, ic5, iran1, itmp3, itmp1, itmp2);
	hscalt_xjumpm(&jump7, mult, iadd, itmp3, iran1, itmp1, itmp2);
	hscalt_xjumpm(&moff, ia4, ic4, iran1, itmp1, itmp2, itmp3);
	hscalt_xjumpm(&noff, ia2, ic2, itmp1, iran1, itmp2, itmp3);
	hscalt_setran(iran1, ia1, ic1);

	for (i__ = 1; i__ <= 2; ++i__) {
	    ib1[i__ - 1] = iran1[i__ - 1];
	    ib2[i__ - 1] = iran1[i__ - 1];
	    ib3[i__ - 1] = iran1[i__ - 1];
/* L170: */
	}

	ik = 1;
	i__1 = mend;
	for (ir = moff + 1; ir <= i__1; ++ir) {
	    ioffr = ((ir - 1) * *nprow + mrrow) * *mb;
	    i__2 = *mb;
	    for (j = 1; j <= i__2; ++j) {
		if (ik > *irnum) {
		    goto L230;
		}
		jk = 1;
		i__3 = nend;
		for (ic = noff + 1; ic <= i__3; ++ic) {
		    ioffc = ((ic - 1) * *npcol + mrcol) * *nb;
		    i__4 = *nb;
		    for (i__ = 1; i__ <= i__4; ++i__) {
			if (jk > *icnum) {
			    goto L200;
			}
			a[ik + jk * a_dim1] = 1.f - hscalt_psrand(&c__0) * 2.f;
			++jk;
/* L180: */
		    }
		    hscalt_jumpit(ia2, ic2, ib1, iran2);
		    ib1[0] = iran2[0];
		    ib1[1] = iran2[1];
/* L190: */
		}

L200:
		++ik;
		hscalt_jumpit(ia3, ic3, ib2, iran3);
		ib1[0] = iran3[0];
		ib1[1] = iran3[1];
		ib2[0] = iran3[0];
		ib2[1] = iran3[1];
/* L210: */
	    }

	    hscalt_jumpit(ia4, ic4, ib3, iran4);
	    ib1[0] = iran4[0];
	    ib1[1] = iran4[1];
	    ib2[0] = iran4[0];
	    ib2[1] = iran4[1];
	    ib3[0] = iran4[0];
	    ib3[1] = iran4[1];
/* L220: */
	}
L230:

/*     A random matrix is generated. */

	;
    } else {

	jump1 = 1;
	jump2 = npmb;
	jump3 = *m;
	jump4 = nqnb;
	jump5 = *nb;
	jump6 = mrcol;
	jump7 = *mb * mrrow;

	hscalt_xjumpm(&jump1, mult, iadd, jseed, iran1, ia1, ic1);
	hscalt_xjumpm(&jump2, mult, iadd, iran1, itmp1, ia2, ic2);
	hscalt_xjumpm(&jump3, mult, iadd, iran1, itmp1, ia3, ic3);
	hscalt_xjumpm(&jump4, ia3, ic3, iran1, itmp1, ia4, ic4);
	hscalt_xjumpm(&jump5, ia3, ic3, iran1, itmp1, ia5, ic5);
	hscalt_xjumpm(&jump6, ia5, ic5, iran1, itmp3, itmp1, itmp2);
	hscalt_xjumpm(&jump7, mult, iadd, itmp3, iran1, itmp1, itmp2);
	hscalt_xjumpm(&noff, ia4, ic4, iran1, itmp1, itmp2, itmp3);
	hscalt_xjumpm(&moff, ia2, ic2, itmp1, iran1, itmp2, itmp3);
	hscalt_setran(iran1, ia1, ic1);

	for (i__ = 1; i__ <= 2; ++i__) {
	    ib1[i__ - 1] = iran1[i__ - 1];
	    ib2[i__ - 1] = iran1[i__ - 1];
	    ib3[i__ - 1] = iran1[i__ - 1];
/* L240: */
	}

	jk = 1;
	i__1 = nend;
	for (ic = noff + 1; ic <= i__1; ++ic) {
	    ioffc = ((ic - 1) * *npcol + mrcol) * *nb;
	    i__2 = *nb;
	    for (i__ = 1; i__ <= i__2; ++i__) {
		if (jk > *icnum) {
		    goto L300;
		}
		ik = 1;
		i__3 = mend;
		for (ir = moff + 1; ir <= i__3; ++ir) {
		    ioffr = ((ir - 1) * *nprow + mrrow) * *mb;
		    i__4 = *mb;
		    for (j = 1; j <= i__4; ++j) {
			if (ik > *irnum) {
			    goto L270;
			}
			a[ik + jk * a_dim1] = 1.f - hscalt_psrand(&c__0) * 2.f;
			++ik;
/* L250: */
		    }
		    hscalt_jumpit(ia2, ic2, ib1, iran2);
		    ib1[0] = iran2[0];
		    ib1[1] = iran2[1];
/* L260: */
		}

L270:
		++jk;
		hscalt_jumpit(ia3, ic3, ib2, iran3);
		ib1[0] = iran3[0];
		ib1[1] = iran3[1];
		ib2[0] = iran3[0];
		ib2[1] = iran3[1];
/* L280: */
	    }

	    hscalt_jumpit(ia4, ic4, ib3, iran4);
	    ib1[0] = iran4[0];
	    ib1[1] = iran4[1];
	    ib2[0] = iran4[0];
	    ib2[1] = iran4[1];
	    ib3[0] = iran4[0];
	    ib3[1] = iran4[1];
/* L290: */
	}
L300:
	;
    }

/*     Diagonally dominant matrix will be generated. */

    if (hscal_lsame(diag, "D")) {
	if (*mb != *nb) {
            HSCAL_DEBUG(
                 __FILE__, __FUNCTION__,__LINE__,             
	         "Diagonally dominant matrices with rowNB no"
		 "t equal colNB is not supported!"
            );
	    return 0;
	}

	maxmn = max(*m,*n);
	jk = 1;
	i__1 = nend;
	for (ic = noff + 1; ic <= i__1; ++ic) {
	    ioffc = ((ic - 1) * *npcol + mrcol) * *nb;
	    ik = 1;
	    i__2 = mend;
	    for (ir = moff + 1; ir <= i__2; ++ir) {
		ioffr = ((ir - 1) * *nprow + mrrow) * *mb;
		if (ioffc == ioffr) {
		    i__3 = *mb - 1;
		    for (j = 0; j <= i__3; ++j) {
			if (ik > *irnum) {
			    goto L330;
			}
			a[ik + (jk + j) * a_dim1] = (r__1 = a[ik + (jk + j) * 
				a_dim1], dabs(r__1)) + maxmn;
			++ik;
/* L310: */
		    }
		} else {
		    ik += *mb;
		}
/* L320: */
	    }
L330:
	    jk += *nb;
/* L340: */
	}
    }

    return 0;

/*     End of PSMATGEN */

} /* psmatgen_ */

