#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pcatrmv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     DIAGI            = 'N';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pcatrmv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float ALPHA              = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float BETA               = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "#endif"                                               >> hscalapack_pcatrmv_parameters.h

	./run_hscal.sh test_hscal_pcatrmv_auto hscalapack_pcatrmv_parameters.h 

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pcatrmv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     TRANSI           = 'T';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     DIAGI            = 'N';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pcatrmv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float ALPHA              = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float BETA               = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "#endif"                                               >> hscalapack_pcatrmv_parameters.h

	./run_hscal.sh test_hscal_pcatrmv_auto hscalapack_pcatrmv_parameters.h 

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pcatrmv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     TRANSI           = 'C';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     DIAGI            = 'N';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pcatrmv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float ALPHA              = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float BETA               = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "#endif"                                               >> hscalapack_pcatrmv_parameters.h

	./run_hscal.sh test_hscal_pcatrmv_auto hscalapack_pcatrmv_parameters.h 

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pcatrmv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     DIAGI            = 'N';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pcatrmv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float ALPHA              = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float BETA               = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "#endif"                                               >> hscalapack_pcatrmv_parameters.h

	./run_hscal.sh test_hscal_pcatrmv_auto hscalapack_pcatrmv_parameters.h 

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pcatrmv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     TRANSI           = 'T';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     DIAGI            = 'N';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pcatrmv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float ALPHA              = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float BETA               = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "#endif"                                               >> hscalapack_pcatrmv_parameters.h

	./run_hscal.sh test_hscal_pcatrmv_auto hscalapack_pcatrmv_parameters.h 

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pcatrmv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     TRANSI           = 'C';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     DIAGI            = 'N';"                      >> hscalapack_pcatrmv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pcatrmv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float ALPHA              = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "float BETA               = 1.;"                       >> hscalapack_pcatrmv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pcatrmv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pcatrmv_parameters.h
	echo ""                                                     >> hscalapack_pcatrmv_parameters.h
	echo "#endif"                                               >> hscalapack_pcatrmv_parameters.h

	./run_hscal.sh test_hscal_pcatrmv_auto hscalapack_pcatrmv_parameters.h

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done
