#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdagemv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdagemv_parameters.h
	echo ""                                                     >> hscalapack_pdagemv_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pdagemv_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdagemv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdagemv_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdagemv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdagemv_parameters.h
	echo "double ALPHA             = 1.;"                       >> hscalapack_pdagemv_parameters.h
	echo "double BETA              = 1.;"                       >> hscalapack_pdagemv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pdagemv_parameters.h
	echo ""                                                     >> hscalapack_pdagemv_parameters.h
	echo "#endif"                                               >> hscalapack_pdagemv_parameters.h

	./run_hscal.sh test_hscal_pdagemv_auto hscalapack_pdagemv_parameters.h

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdagemv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdagemv_parameters.h
	echo ""                                                     >> hscalapack_pdagemv_parameters.h
	echo "int     TRANSI           = 'T';"                      >> hscalapack_pdagemv_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdagemv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdagemv_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdagemv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdagemv_parameters.h
	echo "double ALPHA             = 1.;"                       >> hscalapack_pdagemv_parameters.h
	echo "double BETA              = 1.;"                       >> hscalapack_pdagemv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pdagemv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pdagemv_parameters.h
	echo ""                                                     >> hscalapack_pdagemv_parameters.h
	echo "#endif"                                               >> hscalapack_pdagemv_parameters.h

	./run_hscal.sh test_hscal_pdagemv_auto hscalapack_pdagemv_parameters.h

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done
