#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdgemv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdgemv_parameters.h
	echo ""                                                     >> hscalapack_pdgemv_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pdgemv_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdgemv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdgemv_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdgemv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdgemv_parameters.h
	echo "double ALPHA             = 1.;"                       >> hscalapack_pdgemv_parameters.h
	echo "double BETA              = 1.;"                       >> hscalapack_pdgemv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> hscalapack_pdgemv_parameters.h
	echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> hscalapack_pdgemv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pdgemv_parameters.h
	echo ""                                                     >> hscalapack_pdgemv_parameters.h
	echo "#endif"                                               >> hscalapack_pdgemv_parameters.h

	./run_hscal.sh test_hscal_pdgemv_noauto hscalapack_pdgemv_parameters.h

      let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdgemv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdgemv_parameters.h
	echo ""                                                     >> hscalapack_pdgemv_parameters.h
	echo "int     TRANSI           = 'T';"                      >> hscalapack_pdgemv_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdgemv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdgemv_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdgemv_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdgemv_parameters.h
	echo "double ALPHA             = 1.;"                       >> hscalapack_pdgemv_parameters.h
	echo "double BETA              = 1.;"                       >> hscalapack_pdgemv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pdgemv_parameters.h
	echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> hscalapack_pdgemv_parameters.h
	echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> hscalapack_pdgemv_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pdgemv_parameters.h
	echo ""                                                     >> hscalapack_pdgemv_parameters.h
	echo "#endif"                                               >> hscalapack_pdgemv_parameters.h

	./run_hscal.sh test_hscal_pdgemv_noauto hscalapack_pdgemv_parameters.h

      let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done
