#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > scalapack_pzher2_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> scalapack_pzher2_parameters.h
	echo ""                                                     >> scalapack_pzher2_parameters.h
	echo "int     UPLOI            = 'U';"                      >> scalapack_pzher2_parameters.h
	echo "int     N                = $PSIZE;"                   >> scalapack_pzher2_parameters.h
	echo "int     NB               = 32;"                       >> scalapack_pzher2_parameters.h
	echo "double ALPHA[2]          = {1., 1.};"                 >> scalapack_pzher2_parameters.h
	echo "int     IA               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     JA               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     IX               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     JX               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     IY               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     JY               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     INCX             = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     INCY             = 1;"                        >> scalapack_pzher2_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> scalapack_pzher2_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> scalapack_pzher2_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> scalapack_pzher2_parameters.h
	echo ""                                                     >> scalapack_pzher2_parameters.h
	echo "#endif"                                               >> scalapack_pzher2_parameters.h

	./run_scal.sh test_scal_pzher2 scalapack_pzher2_parameters.h

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > scalapack_pzher2_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> scalapack_pzher2_parameters.h
	echo ""                                                     >> scalapack_pzher2_parameters.h
	echo "int     UPLOI            = 'L';"                      >> scalapack_pzher2_parameters.h
	echo "int     N                = $PSIZE;"                   >> scalapack_pzher2_parameters.h
	echo "int     NB               = 32;"                       >> scalapack_pzher2_parameters.h
	echo "double ALPHA[2]          = {1., 1.};"                 >> scalapack_pzher2_parameters.h
	echo "int     IA               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     JA               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     IX               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     JX               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     IY               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     JY               = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     INCX             = 1;"                        >> scalapack_pzher2_parameters.h
	echo "int     INCY             = 1;"                        >> scalapack_pzher2_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> scalapack_pzher2_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> scalapack_pzher2_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> scalapack_pzher2_parameters.h
	echo ""                                                     >> scalapack_pzher2_parameters.h
	echo "#endif"                                               >> scalapack_pzher2_parameters.h

	./run_scal.sh test_scal_pzher2 scalapack_pzher2_parameters.h

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done
