#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pctradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pctradd_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pctradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "float   ALPHA[2]         = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "float   BETA[2]          = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pctradd_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "#endif"                                               >> hscalapack_pctradd_parameters.h

	./run_hscal.sh test_hscal_pctradd_auto hscalapack_pctradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pctradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pctradd_parameters.h
	echo "int     TRANSI           = 'T';"                      >> hscalapack_pctradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "float   ALPHA[2]         = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "float   BETA[2]          = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pctradd_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "#endif"                                               >> hscalapack_pctradd_parameters.h

	./run_hscal.sh test_hscal_pctradd_auto hscalapack_pctradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pctradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pctradd_parameters.h
	echo "int     TRANSI           = 'C';"                      >> hscalapack_pctradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "float   ALPHA[2]         = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "float   BETA[2]          = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pctradd_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "#endif"                                               >> hscalapack_pctradd_parameters.h

	./run_hscal.sh test_hscal_pctradd_auto hscalapack_pctradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pctradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pctradd_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pctradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "float   ALPHA[2]         = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "float   BETA[2]          = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pctradd_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "#endif"                                               >> hscalapack_pctradd_parameters.h

	./run_hscal.sh test_hscal_pctradd_auto hscalapack_pctradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pctradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pctradd_parameters.h
	echo "int     TRANSI           = 'T';"                      >> hscalapack_pctradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "float   ALPHA[2]         = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "float   BETA[2]          = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pctradd_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "#endif"                                               >> hscalapack_pctradd_parameters.h

	./run_hscal.sh test_hscal_pctradd_auto hscalapack_pctradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pctradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pctradd_parameters.h
	echo "int     TRANSI           = 'C';"                      >> hscalapack_pctradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pctradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pctradd_parameters.h
	echo "float   ALPHA[2]         = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "float   BETA[2]          = {1.f, 1.f};"               >> hscalapack_pctradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pctradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pctradd_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> hscalapack_pctradd_parameters.h
	echo ""                                                     >> hscalapack_pctradd_parameters.h
	echo "#endif"                                               >> hscalapack_pctradd_parameters.h

	./run_hscal.sh test_hscal_pctradd_auto hscalapack_pctradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done
