#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdtradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  ALPHA            = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  BETA             = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "#endif"                                               >> hscalapack_pdtradd_parameters.h

	./run_hscal.sh test_hscal_pdtradd_auto hscalapack_pdtradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdtradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     TRANSI           = 'T';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  ALPHA            = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  BETA             = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "#endif"                                               >> hscalapack_pdtradd_parameters.h

	./run_hscal.sh test_hscal_pdtradd_auto hscalapack_pdtradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdtradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     TRANSI           = 'C';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  ALPHA            = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  BETA             = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "#endif"                                               >> hscalapack_pdtradd_parameters.h

	./run_hscal.sh test_hscal_pdtradd_auto hscalapack_pdtradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdtradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  ALPHA            = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  BETA             = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "#endif"                                               >> hscalapack_pdtradd_parameters.h

	./run_hscal.sh test_hscal_pdtradd_auto hscalapack_pdtradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdtradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     TRANSI           = 'T';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  ALPHA            = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  BETA             = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "#endif"                                               >> hscalapack_pdtradd_parameters.h

	./run_hscal.sh test_hscal_pdtradd_auto hscalapack_pdtradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdtradd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     TRANSI           = 'C';"                      >> hscalapack_pdtradd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdtradd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  ALPHA            = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "double  BETA             = 1.;"                       >> hscalapack_pdtradd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pdtradd_parameters.h
	echo ""                                                     >> hscalapack_pdtradd_parameters.h
	echo "#endif"                                               >> hscalapack_pdtradd_parameters.h

	./run_hscal.sh test_hscal_pdtradd_auto hscalapack_pdtradd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done
