#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_psgeadd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_psgeadd_parameters.h
	echo ""                                                     >> hscalapack_psgeadd_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_psgeadd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_psgeadd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_psgeadd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_psgeadd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_psgeadd_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> hscalapack_psgeadd_parameters.h
	echo "float   BETA             = 1.f;"                      >> hscalapack_psgeadd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo ""                                                     >> hscalapack_psgeadd_parameters.h
	echo "#endif"                                               >> hscalapack_psgeadd_parameters.h

	./run_hscal.sh test_hscal_psgeadd_auto hscalapack_psgeadd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_psgeadd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_psgeadd_parameters.h
	echo ""                                                     >> hscalapack_psgeadd_parameters.h
	echo "int     TRANSI           = 'T';"                      >> hscalapack_psgeadd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_psgeadd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_psgeadd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_psgeadd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_psgeadd_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> hscalapack_psgeadd_parameters.h
	echo "float   BETA             = 1.f;"                      >> hscalapack_psgeadd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo ""                                                     >> hscalapack_psgeadd_parameters.h
	echo "#endif"                                               >> hscalapack_psgeadd_parameters.h

	./run_hscal.sh test_hscal_psgeadd_auto hscalapack_psgeadd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_psgeadd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_psgeadd_parameters.h
	echo ""                                                     >> hscalapack_psgeadd_parameters.h
	echo "int     TRANSI           = 'C';"                      >> hscalapack_psgeadd_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_psgeadd_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_psgeadd_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_psgeadd_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_psgeadd_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> hscalapack_psgeadd_parameters.h
	echo "float   BETA             = 1.f;"                      >> hscalapack_psgeadd_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_psgeadd_parameters.h
	echo ""                                                     >> hscalapack_psgeadd_parameters.h
	echo "#endif"                                               >> hscalapack_psgeadd_parameters.h

	./run_hscal.sh test_hscal_psgeadd_auto hscalapack_psgeadd_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done
