#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pssymm_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pssymm_parameters.h
	echo ""                                                     >> hscalapack_pssymm_parameters.h
	echo "int     SIDEI            = 'L';"                      >> hscalapack_pssymm_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pssymm_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pssymm_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pssymm_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pssymm_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pssymm_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> hscalapack_pssymm_parameters.h
	echo "float   BETA             = 1.f;"                      >> hscalapack_pssymm_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo ""                                                     >> hscalapack_pssymm_parameters.h
	echo "#endif"                                               >> hscalapack_pssymm_parameters.h

	./run_hscal.sh test_hscal_pssymm_auto hscalapack_pssymm_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pssymm_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pssymm_parameters.h
	echo ""                                                     >> hscalapack_pssymm_parameters.h
	echo "int     SIDEI            = 'L';"                      >> hscalapack_pssymm_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pssymm_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pssymm_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pssymm_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pssymm_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pssymm_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> hscalapack_pssymm_parameters.h
	echo "float   BETA             = 1.f;"                      >> hscalapack_pssymm_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo ""                                                     >> hscalapack_pssymm_parameters.h
	echo "#endif"                                               >> hscalapack_pssymm_parameters.h

	./run_hscal.sh test_hscal_pssymm_auto hscalapack_pssymm_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pssymm_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pssymm_parameters.h
	echo ""                                                     >> hscalapack_pssymm_parameters.h
	echo "int     SIDEI            = 'R';"                      >> hscalapack_pssymm_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pssymm_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pssymm_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pssymm_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pssymm_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pssymm_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> hscalapack_pssymm_parameters.h
	echo "float   BETA             = 1.f;"                      >> hscalapack_pssymm_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo ""                                                     >> hscalapack_pssymm_parameters.h
	echo "#endif"                                               >> hscalapack_pssymm_parameters.h

	./run_hscal.sh test_hscal_pssymm_auto hscalapack_pssymm_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pssymm_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pssymm_parameters.h
	echo ""                                                     >> hscalapack_pssymm_parameters.h
	echo "int     SIDEI            = 'R';"                      >> hscalapack_pssymm_parameters.h
	echo "int     UPLOI            = 'L';"                      >> hscalapack_pssymm_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pssymm_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pssymm_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pssymm_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pssymm_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> hscalapack_pssymm_parameters.h
	echo "float   BETA             = 1.f;"                      >> hscalapack_pssymm_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pssymm_parameters.h
	echo ""                                                     >> hscalapack_pssymm_parameters.h
	echo "#endif"                                               >> hscalapack_pssymm_parameters.h

	./run_hscal.sh test_hscal_pssymm_auto hscalapack_pssymm_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done
