#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > scalapack_psgeadd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> scalapack_psgeadd_parameters.h
	echo ""                                                     >> scalapack_psgeadd_parameters.h
	echo "int     TRANSI           = 'N';"                      >> scalapack_psgeadd_parameters.h
	echo "int     M                = $PSIZE;"                   >> scalapack_psgeadd_parameters.h
	echo "int     N                = $PSIZE;"                   >> scalapack_psgeadd_parameters.h
	echo "int     MB               = 32;"                       >> scalapack_psgeadd_parameters.h
	echo "int     NB               = 32;"                       >> scalapack_psgeadd_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> scalapack_psgeadd_parameters.h
	echo "float   BETA             = 1.f;"                      >> scalapack_psgeadd_parameters.h
	echo "int     IA               = 1;"                        >> scalapack_psgeadd_parameters.h
	echo "int     JA               = 1;"                        >> scalapack_psgeadd_parameters.h
	echo "int     IC               = 1;"                        >> scalapack_psgeadd_parameters.h
	echo "int     JC               = 1;"                        >> scalapack_psgeadd_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> scalapack_psgeadd_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> scalapack_psgeadd_parameters.h
	echo ""                                                     >> scalapack_psgeadd_parameters.h
	echo "#endif"                                               >> scalapack_psgeadd_parameters.h

	./run_scal.sh test_scal_psgeadd scalapack_psgeadd_parameters.h

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > scalapack_psgeadd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> scalapack_psgeadd_parameters.h
	echo ""                                                     >> scalapack_psgeadd_parameters.h
	echo "int     TRANSI           = 'T';"                      >> scalapack_psgeadd_parameters.h
	echo "int     M                = $PSIZE;"                   >> scalapack_psgeadd_parameters.h
	echo "int     N                = $PSIZE;"                   >> scalapack_psgeadd_parameters.h
	echo "int     MB               = 32;"                       >> scalapack_psgeadd_parameters.h
	echo "int     NB               = 32;"                       >> scalapack_psgeadd_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> scalapack_psgeadd_parameters.h
	echo "float   BETA             = 1.f;"                      >> scalapack_psgeadd_parameters.h
	echo "int     IA               = 1;"                        >> scalapack_psgeadd_parameters.h
	echo "int     JA               = 1;"                        >> scalapack_psgeadd_parameters.h
	echo "int     IC               = 1;"                        >> scalapack_psgeadd_parameters.h
	echo "int     JC               = 1;"                        >> scalapack_psgeadd_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> scalapack_psgeadd_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> scalapack_psgeadd_parameters.h
	echo ""                                                     >> scalapack_psgeadd_parameters.h
	echo "#endif"                                               >> scalapack_psgeadd_parameters.h

	./run_scal.sh test_scal_psgeadd scalapack_psgeadd_parameters.h

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > scalapack_psgeadd_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> scalapack_psgeadd_parameters.h
	echo ""                                                     >> scalapack_psgeadd_parameters.h
	echo "int     TRANSI           = 'C';"                      >> scalapack_psgeadd_parameters.h
	echo "int     M                = $PSIZE;"                   >> scalapack_psgeadd_parameters.h
	echo "int     N                = $PSIZE;"                   >> scalapack_psgeadd_parameters.h
	echo "int     MB               = 32;"                       >> scalapack_psgeadd_parameters.h
	echo "int     NB               = 32;"                       >> scalapack_psgeadd_parameters.h
	echo "float   ALPHA            = 1.f;"                      >> scalapack_psgeadd_parameters.h
	echo "float   BETA             = 1.f;"                      >> scalapack_psgeadd_parameters.h
	echo "int     IA               = 1;"                        >> scalapack_psgeadd_parameters.h
	echo "int     JA               = 1;"                        >> scalapack_psgeadd_parameters.h
	echo "int     IC               = 1;"                        >> scalapack_psgeadd_parameters.h
	echo "int     JC               = 1;"                        >> scalapack_psgeadd_parameters.h
      echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> scalapack_psgeadd_parameters.h
      echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> scalapack_psgeadd_parameters.h
	echo ""                                                     >> scalapack_psgeadd_parameters.h
	echo "#endif"                                               >> scalapack_psgeadd_parameters.h

	./run_scal.sh test_scal_psgeadd scalapack_psgeadd_parameters.h

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done
