#!/bin/sh

. ./cparameters.sh

#
# M > N
#

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"
	let "NSIZE=$PSIZE - 1024"
        if [ "$NSIZE" = "0" ]; then
                let "NSIZE=960"
        fi

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdgels_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdgels_parameters.h
	echo ""                                                     >> hscalapack_pdgels_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pdgels_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdgels_parameters.h
	echo "int     N                = $NSIZE;"                   >> hscalapack_pdgels_parameters.h
	echo "int     NRHS             = $PSIZE;"                   >> hscalapack_pdgels_parameters.h
	echo "int     MB               = 64;"                       >> hscalapack_pdgels_parameters.h
	echo "int     NB               = 64;"                       >> hscalapack_pdgels_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdgels_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdgels_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pdgels_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pdgels_parameters.h
	echo ""                                                     >> hscalapack_pdgels_parameters.h
	echo "#endif"                                               >> hscalapack_pdgels_parameters.h

	./run_hscal.sh test_hscal_pdgels hscalapack_pdgels_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

#
# M < N
#

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"
	let "MSIZE=$PSIZE - 1024"
        if [ "$MSIZE" = "0" ]; then
                let "MSIZE=960"
        fi

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdgels_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdgels_parameters.h
	echo ""                                                     >> hscalapack_pdgels_parameters.h
	echo "int     TRANSI           = 'N';"                      >> hscalapack_pdgels_parameters.h
	echo "int     M                = $MSIZE;"                   >> hscalapack_pdgels_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdgels_parameters.h
	echo "int     NRHS             = $PSIZE;"                   >> hscalapack_pdgels_parameters.h
	echo "int     MB               = 64;"                       >> hscalapack_pdgels_parameters.h
	echo "int     NB               = 64;"                       >> hscalapack_pdgels_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdgels_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdgels_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pdgels_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pdgels_parameters.h
	echo ""                                                     >> hscalapack_pdgels_parameters.h
	echo "#endif"                                               >> hscalapack_pdgels_parameters.h

	./run_hscal.sh test_hscal_pdgels hscalapack_pdgels_parameters.h

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

