#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=11

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdgesv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdgesv_parameters.h
	echo ""                                                     >> hscalapack_pdgesv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdgesv_parameters.h
	echo "int     NRHS             = $PSIZE;"                   >> hscalapack_pdgesv_parameters.h
	echo "int     NB               = 64;"                       >> hscalapack_pdgesv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdgesv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdgesv_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pdgesv_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pdgesv_parameters.h
	echo ""                                                     >> hscalapack_pdgesv_parameters.h
	echo "#endif"                                               >> hscalapack_pdgesv_parameters.h

	./run_hscal.sh test_hscal_pdgesv hscalapack_pdgesv_parameters.h >> hscal_pdgesv.txt 2>&1

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

