#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdgesv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdgesv_parameters.h
	echo ""                                                     >> hscalapack_pdgesv_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdgesv_parameters.h
	echo "int     NRHS             = $PSIZE;"                   >> hscalapack_pdgesv_parameters.h
	echo "int     NB               = 64;"                       >> hscalapack_pdgesv_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdgesv_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdgesv_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pdgesv_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pdgesv_parameters.h
	echo ""                                                     >> hscalapack_pdgesv_parameters.h
	echo "#endif"                                               >> hscalapack_pdgesv_parameters.h

	#echo "PDGESV mapping" >> hscal_pdgesv_rmapping.txt
	#./run_hscal.sh test_hscal_pdgesv hscalapack_pdgesv_parameters.h

	#echo "PDGETRF mapping" >> hscal_pdgesv_rmapping.txt
	#./run_hscal.sh test_hscal_pdgesv_pdgetrf_rmapping hscalapack_pdgesv_parameters.h

	#echo "PDGEMM mapping" >> hscal_pdgesv_rmapping.txt
	./run_hscal.sh test_hscal_pdgesv_pdgemm_rmapping hscalapack_pdgesv_parameters.h >> hscal_pdgesv_pdgemm_rmapping.txt 2>&1

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

