#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdposv_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdposv_parameters.h
	echo ""                                                     >> hscalapack_pdposv_parameters.h
	echo "int     UPLOI            = 'U';"                      >> hscalapack_pdposv_parameters.h
        echo "int     N                = $PSIZE;"                   >> hscalapack_pdposv_parameters.h
        echo "int     NRHS             = $PSIZE;"                   >> hscalapack_pdposv_parameters.h
        echo "int     NB               = 64;"                       >> hscalapack_pdposv_parameters.h
        echo "int     IA               = 1;"                        >> hscalapack_pdposv_parameters.h
        echo "int     JA               = 1;"                        >> hscalapack_pdposv_parameters.h
        echo "int     IB               = 1;"                        >> hscalapack_pdposv_parameters.h
        echo "int     JB               = 1;"                        >> hscalapack_pdposv_parameters.h
	echo ""                                                     >> hscalapack_pdposv_parameters.h
	echo "#endif"                                               >> hscalapack_pdposv_parameters.h

	#echo "PDPOSV mapping" >> hscal_pdposv_rmapping.txt
	#./run_hscal.sh test_hscal_pdposv hscalapack_pdposv_parameters.h

	#echo "PDPOTRF mapping" >> hscal_pdposv_rmapping.txt
	#./run_hscal.sh test_hscal_pdposv_pdpotrf_rmapping hscalapack_pdposv_parameters.h

	#echo "PDSYRK mapping" >> hscal_pdposv_rmapping.txt
	./run_hscal.sh test_hscal_pdposv_pdsyrk_rmapping hscalapack_pdposv_parameters.h >> hscal_pdposv_pdsyrk_rmapping.txt 2>&1

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

