#!/bin/sh

. ./cparameters.sh

#
# M > N
#

PSIZE_COUNT=21

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"
	let "NSIZE=$PSIZE - 1024"

	if [ "$NSIZE" = "0" ]; then
		let "NSIZE=960"
	fi

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > scalapack_pdgels_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> scalapack_pdgels_parameters.h
	echo ""                                                     >> scalapack_pdgels_parameters.h
	echo "int     TRANSI           = 'N';"                      >> scalapack_pdgels_parameters.h
	echo "int     M                = $PSIZE;"                   >> scalapack_pdgels_parameters.h
	echo "int     N                = $NSIZE;"                   >> scalapack_pdgels_parameters.h
	echo "int     NRHS             = $PSIZE;"                   >> scalapack_pdgels_parameters.h
	echo "int     MB               = 64;"                       >> scalapack_pdgels_parameters.h
	echo "int     NB               = 64;"                       >> scalapack_pdgels_parameters.h
	echo "int     IA               = 1;"                        >> scalapack_pdgels_parameters.h
	echo "int     JA               = 1;"                        >> scalapack_pdgels_parameters.h
	echo "int     IB               = 1;"                        >> scalapack_pdgels_parameters.h
	echo "int     JB               = 1;"                        >> scalapack_pdgels_parameters.h
        echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> scalapack_pdgels_parameters.h
        echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> scalapack_pdgels_parameters.h
	echo ""                                                     >> scalapack_pdgels_parameters.h
	echo "#endif"                                               >> scalapack_pdgels_parameters.h

	./run_scal.sh test_scal_pdgels scalapack_pdgels_parameters.h

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

#
# M < N
#

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"
	let "MSIZE=$PSIZE - 1024"

	if [ "$MSIZE" = "0" ]; then
		let "MSIZE=960"
	fi

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > scalapack_pdgels_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> scalapack_pdgels_parameters.h
	echo ""                                                     >> scalapack_pdgels_parameters.h
	echo "int     TRANSI           = 'N';"                      >> scalapack_pdgels_parameters.h
	echo "int     M                = $MSIZE;"                   >> scalapack_pdgels_parameters.h
	echo "int     N                = $PSIZE;"                   >> scalapack_pdgels_parameters.h
	echo "int     NRHS             = $PSIZE;"                   >> scalapack_pdgels_parameters.h
	echo "int     MB               = 64;"                       >> scalapack_pdgels_parameters.h
	echo "int     NB               = 64;"                       >> scalapack_pdgels_parameters.h
	echo "int     IA               = 1;"                        >> scalapack_pdgels_parameters.h
	echo "int     JA               = 1;"                        >> scalapack_pdgels_parameters.h
	echo "int     IB               = 1;"                        >> scalapack_pdgels_parameters.h
	echo "int     JB               = 1;"                        >> scalapack_pdgels_parameters.h
        echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> scalapack_pdgels_parameters.h
        echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> scalapack_pdgels_parameters.h
	echo ""                                                     >> scalapack_pdgels_parameters.h
	echo "#endif"                                               >> scalapack_pdgels_parameters.h

	./run_scal.sh test_scal_pdgels scalapack_pdgels_parameters.h

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

