
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#include <hscalapack.h>

#include "scalapack_pdgels_parameters.h"

int main(int argc, char **argv)
{
    int DESCA[DLEN1_], DESCB[DLEN1_];
    int i, rc;
    int ictxt, myrow, mycol;
    int LLDa, Ka, LLDb_mp, LLDb_np, LLDb, Kb, lwork;
    int CHECK_RESULT = 0;
    int c__0    = 0;
    int max_M_N = max(M, N);

    int IRSRC = 0;
    int ICSRC = 0;
    int DLLD  = -1;
    int DCTXT = -1;
    int INFO;

    char TRANSC = TRANSI; 
    char *TRANS = &TRANSC;

    hscalinteger lcmp, mp, mq, np, nq, nrhsq, ltau, lwf, lws, lcm, mnp,
                 i__1, i__2, i__3, i__4, i__5, i__6, i__7, i__8, i__9;

    double time;

    //
    // Initialize HScaLAPACK runtime
    hscal_init(&argc, &argv);

    descset_(
        DESCA,
        &M,
        &N,
        &MB,
        &NB,
        &IRSRC,
        &ICSRC,
        &DCTXT,
        &DLLD
    );

    descset_(
        DESCB,
        &max_M_N,
        &NRHS,
        &MB,
        &NB,
        &IRSRC,
        &ICSRC,
        &DCTXT,
        &DLLD
    );

    {
    time = hscal_pdgels_timeof(
              TRANS,
              &M,
              &N,
              &NRHS,
              &IA,
              &JA,
              DESCA,
              &IB,
              &JB,
              DESCB,
              &nprow,
              &npcol,
              hscal_model_pdgels_m_ge_n
    );
    }

    /*
     * Print Execution time
     */
    {
       printf(
          "M=%d, N=%d, NRHS=%d, MB=%d, NB=%d, time=%f\n",
          M,
          N,
          NRHS,
          MB,
          NB,
          time
       );
    }

    hscal_finalize(0);
}
