
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#include <hscalapack.h>

#include "hscalapack_pzposv_parameters.h"

int main(int argc, char **argv)
{
    int DESCA[DLEN1_], DESCB[DLEN1_];
    int i, rc;
    int ictxt, myrow, mycol;
    int LLDa, Ka, LLDb, Kb;
    int CHECK_RESULT = 0;
    int c__0    = 0;

    int IRSRC = 0;
    int ICSRC = 0;
    int DLLD  = -1;
    int DCTXT = -1;
    int INFO;

    char UPLOC = UPLOI; char *UPLO = &UPLOC;

    int     p, q;
    hscaldoublecomplex    *A, *B;
 
    struct timeval start, end;
    struct timeval cstart, cend;
    struct timeval astart, aend;

    gettimeofday(&start, NULL);

    //
    // Initialize HScaLAPACK runtime
    hscal_init(&argc, &argv);

    if (HMPI_Is_host())
    {
        gettimeofday(&astart, NULL);
    }

    descset_(
        DESCA,
        &N,
        &N,
        &NB,
        &NB,
        &IRSRC,
        &ICSRC,
        &DCTXT,
        &DLLD
    );

    descset_(
        DESCB,
        &N,
        &NRHS,
        &NB,
        &NB,
        &IRSRC,
        &ICSRC,
        &DCTXT,
        &DLLD
    );

    if (HMPI_Is_host())
    {
       gettimeofday(&cstart, NULL);
    }

    HMPI_Debug(1);

    rc = hscal_pzposv_recon(
              UPLO,
              &N,
              &NRHS,
              &IA,
              &JA,
              DESCA,
              &IB,
              &JB,
              DESCB
    );
    
    if (rc != HSCAL_SUCCESS)
    {
       return HSCAL_ERR_RECON;
    }

    hscal_finalize(0);
}
