
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#include <scalapack.h>

#include "scalapack_pcgesv_parameters.h"

int main(int argc, char **argv)
{
    int myrow, mycol,  rc;
    int LLDa, Ka, LLDb, Kb;
    int IRSRC = 0, ICSRC = 0;
    int CN = JA+N-1;
    int CNRHS = JB+NRHS-1;
    int p = nprow, q = npcol;

    for (myrow = 0; myrow < nprow; myrow++)
    {
    for (mycol = 0; mycol < npcol; mycol++)
    {
    LLDa           = max(1, PB_Cnumroc(N,
                                       0,
                                       NB,
                                       NB,
                                       myrow,
                                       IRSRC,
                                       p
                        )
    );

    Ka            = max(1, PB_Cnumroc(JA+N-1,
                                      0,
                                      NB,
                                      NB,
                                      mycol,
                                      ICSRC,
                                      q
                       )
    );

    LLDb           = max(1, PB_Cnumroc(N,
                                       0,
                                       NB,
                                       NB,
                                       myrow,
                                       IRSRC,
                                       p
                        )
    );

    Kb            = max(1, PB_Cnumroc(JB+NRHS-1,
                                      0,
                                      NB,
                                      NB,
                                      mycol,
                                      ICSRC,
                                      q
                       )
    );

    printf("(%d, %d): PB_Cnumroc-->LLDa=%d, Ka=%d, LLDb=%d, Kb=%d\n", myrow, mycol, LLDa, Ka, LLDb, Kb);
    }
    }

    for (myrow = 0; myrow < nprow; myrow++)
    {
    for (mycol = 0; mycol < npcol; mycol++)
    {
    LLDa           = numroc_(&N,
                             &NB,
                             &myrow,
                             &IRSRC,
                             &p
    );

    Ka            = numroc_(&CN,
                            &NB,
                            &mycol,
                            &ICSRC,
                            &q
    );

    LLDb           = numroc_(&N,
                             &NB,
                             &myrow,
                             &IRSRC,
                             &p
    );

    Kb            = numroc_(&CNRHS,
                            &NB,
                            &mycol,
                            &ICSRC,
                            &q
    );

    printf("(%d, %d): numroc_-->LLDa=%d, Ka=%d, LLDb=%d, Kb=%d\n", myrow, mycol, LLDa, Ka, LLDb, Kb);
    }
    }

    return 0;
}
