/* $Id: Parser.c,v 2.15 1993/09/13 12:35:16 grosch rel $ */

# define bool		char
# define true		1
# define false		0

# include "mpcPars.h"

# ifdef __cplusplus
extern "C" {
#    include "rMemory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    include "Errors.h"
#    include <string.h>
#    ifndef BCOPY
#       include <memory.h>
#    endif
}
# else
#    include "rMemory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    include "Errors.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
# endif

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifdef lex_interface
#    define mpcScan_GetToken	yylex
     extern int yylex ();
#    ifndef AttributeDef
#	include "Positions.h"
        typedef struct { tPosition Position; } mpcScan_tScanAttribute;
        mpcScan_tScanAttribute	mpcScan_Attribute = {{ 0, 0 }};
#    endif
#    ifndef ErrorAttributeDef
#	define mpcScan_ErrorAttribute(Token, RepairAttribute)
#    endif
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) * yyAttrStackPtr = yylval
#    endif
# else
#    include "mpcScan.h"
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) (yyAttrStackPtr)->Scan = Attribute
#    endif
# endif

/* line 2 "mpcPars.lalr" */



 /* mpC-grammar -- massively-parallel extension of ANSI C; *
  * Copyright (C) 1995,1996 I.N.Ledovskih,                 *
  * All rights reserved                                    *
  * Portions copyright (C) 1989,1990 James A. Roskind.     */

#include "context.h"
#include "Tree.h"
#include "mpc_diag.h"
#include "mpc_pass1.h"
#include "mpc_pass2.h"
#include "topo_fun.h"
#include "options.h"



#ifndef __CB_COMPILER__
# include "mpc_demo.h"

extern bool FirstPass;

extern tTree MPI_Int_Type,
	     TopoGraph_Type;
extern void  Emit_TopoPattern();
#endif


char EmptyString[] = "";

int Default_Class = EXTERN;
int Scope_Depth = 0;

int SU_Scope = 0;


#ifndef __CB_COMPILER__
tIdent DummyIdent;           /* for generation of MPC_CoordExpr in case of network operand; */
tTree  DummyVar;             /* for generation of MPC_CoordExpr in case of network operand; */
#endif

static tTree LabelList;           /* pointer to list of all labels of the current function; */
static tTree Original_ParamList   /* point to list of formal params in function definition; */
                             = NoTree;




#ifdef __WRK
# include "c2mpC.h"
#else
# define END_OF_HEADER_STRING "header_end"
#endif


typedef struct { tTree Tree; bool IsIntConst; int Value; bool Ignore; tPosition Position; tPosition EndPos; } yyconstant;
typedef struct { tTree Tree; int Length; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yystring_literal_list;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyprimary_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yynet_cast_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yypostfix_expression;
typedef struct { short OpCode; tPosition Position; tPosition EndPos; } yypostfix_linear_operator;
typedef struct { tTree NetArgument; tTree NetworkArgList; bool Ignore; tPosition BegPos; } yyspecial_arguments;
typedef struct { tTree Tree; bool Ignore; } yyargument_expression_list_opt;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition BegPos; } yyargument_expression_list;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyunary_expression;
typedef struct { short OpCode; tPosition Position; } yyunary_operator;
typedef struct { short OpCode; tPosition Position; int Length; } yylinear_operator;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yycast_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yymultiplicative_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yymax_or_min_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyadditive_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyshift_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyrelational_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyequality_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyAND_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyexclusive_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyinclusive_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yylogical_AND_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yylogical_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconditional_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyquaternary_assignment;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyassignment_expression;
typedef struct { short OpCode; tPosition Position; } yyassignment_operator;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyexpression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; } yyexpression_opt;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_unary_expression;
typedef struct { short OpCode; tPosition Position; } yyconst_unary_operator;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_cast_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_multiplicative_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_max_or_min_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_additive_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_shift_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_relational_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_equality_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_AND_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_exclusive_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_inclusive_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_logical_AND_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_logical_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_conditional_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition EndPos; } yyconst_conditional_expression_opt;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconstant_expression;
typedef struct { tTree Tree; bool IsIntConst; bool Sizeof; int Value; bool Ignore; } yyconst_expression_opt;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yydeclaration;
typedef struct { tTree Tree; tTree NetType; int Class; bool Ignore; tPosition Position; } yynet_declaring_list;
typedef struct { tTree Tree; tTree NetType; int Class; bool Ignore; tPosition Position; } yysingle_net_declaring_list;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yynet_declarator;
typedef struct { tTree Tree; int Class; bool Exported; bool Ignore; tPosition Position; } yynet_declaration_specifier;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yynet_type_specifier;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yynet_type_declaration;
typedef struct { int Class; tPosition Position; } yystorage_class_opt;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yytopo_parameter_list;
typedef struct { tIdent Ident; tTree Type; bool Ignore; tPosition Position; tPosition EndPos; } yytopo_parameter;
typedef struct { tTree Tree; bool Ignore; } yynet_declaration;
typedef struct { tTree Tree; bool Ignore; } yycoord_declaration;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yycoord_list;
typedef struct { tIdent Ident; tTree Range; bool Ignore; tPosition Position; tPosition EndPos; } yycoord_declarator;
typedef struct { tTree Tree; bool Ignore; } yynode_declaration;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yynode_declaring_list;
typedef struct { tTree Predicate; tTree NodeQual; int NodeType; bool Dynamic; bool Ignore; tPosition Position; tPosition EndPos; } yynode_declarator;
typedef struct { tTree NodeQual; int NodeType; bool Dynamic; } yynode_type_specifier;
typedef struct { tTree Tree; int NodeQual; bool Dynamic; tPosition Position; } yyspeed_specifier;
typedef struct { tTree Tree; int NodeQual; tPosition Position; tPosition EndPos; } yyfast_node_specifier;
typedef struct { tTree Tree; int NodeQual; tPosition Position; tPosition EndPos; } yyslow_node_specifier;
typedef struct { tTree Tree; tPosition Position; tPosition EndPos; } yybench_node_specifier;
typedef struct { tTree Tree; bool Ignore; } yylink_declaration;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yylink_declaring_list;
typedef struct { tTree Predicate; tTree LinkTypeSpec; int LinkType; bool Dynamic; tTree LinkList; bool Ignore; tPosition Position; tPosition EndPos; } yylink_declaration_member;
typedef struct { tTree LinkTypeSpec; int LinkType; bool Dynamic; tTree LinkList; bool Ignore; } yylink_declarator_list;
typedef struct { tTree Tree; bool Pair; bool Ignore; } yylink_declarator;
typedef struct { tTree Tree; bool Ignore; } yyfree_coord_list;
typedef struct { tTree Tree; int LinkType; bool Dynamic; bool Ignore; } yylink_type_specifier;
typedef struct { tTree Tree; bool Ignore; } yyparent_node_declaration;
typedef struct { tTree Tree; bool Ignore; } yyconstant_expression_list;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yysubnet_declaring_list;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yysubnet_list;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yysubnet_declarator;
typedef struct { tTree Tree; bool Flexible; bool WithPredicate; bool Ignore; tPosition Position; tPosition EndPos; } yysubnet_specifier;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yyrelation_declaration;
typedef struct { tTree Tree; bool Ignore; } yyrelation_declarator;
typedef struct { int OpCode; tPosition Position; } yyrelational_operator;
typedef struct { tTree Tree; tTree Type; int Class; bool NoClass; bool Ignore; tPosition Position; tPosition EndPos; } yydefault_declaring_list;
typedef struct { tTree Tree; tTree Type; int Class; bool NoClass; bool Ignore; tPosition Position; tPosition EndPos; } yydeclaring_list;
typedef struct { tTree Type; int Class; bool Ignore; tPosition Position; tPosition EndPos; } yydeclaration_specifier;
typedef struct { tTree Type; int Class; bool Ignore; tPosition Position; tPosition EndPos; } yytype_specifier;
typedef struct { int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yydeclaration_qualifier_list;
typedef struct { tQual Qual; int Class; tPosition Position; tPosition EndPos; } yydeclaration_qualifier;
typedef struct { int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yytype_qualifier_list;
typedef struct { tQual Qual; tPosition Position; tPosition EndPos; } yytype_qualifier;
typedef struct { int TypeName; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yybasic_declaration_specifier;
typedef struct { int TypeName; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yybasic_type_specifier;
typedef struct { tTree Type; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yysue_declaration_specifier;
typedef struct { tTree Type; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yysue_type_specifier;
typedef struct { tTree Type; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yytypedef_declaration_specifier;
typedef struct { tTree Type; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yytypedef_type_specifier;
typedef struct { int Class; tPosition Position; tPosition EndPos; } yystorage_class;
typedef struct { int TypeName; bool Ignore; tPosition Position; tPosition EndPos; } yybasic_type_name;
typedef struct { tTree Type; bool Ignore; tPosition Position; tPosition EndPos; } yyelaborated_type_name;
typedef struct { tTree Type; tIdent Ident; bool Ignore; tPosition Position; tPosition EndPos; } yystruct_or_union_specifier;
typedef struct { tTree Tree; tPosition Position; } yystruct_or_union;
typedef struct { tTree Tree; bool Ignore; } yystruct_declaration_list;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yystruct_declaration;
typedef struct { tTree Tree; tTree Type; bool Ignore; tPosition Position; } yystruct_default_declaring_list;
typedef struct { tTree Tree; tTree Type; bool Ignore; tPosition Position; } yystruct_declaring_list;
typedef struct { tIdent Ident; int BitFieldLength; tTree BitFieldSize_Expr; bool Ignore; tPosition Position; tPosition EndPos; } yystruct_declarator;
typedef struct { int Length; tTree Tree; bool Ignore; tPosition EndPos; } yybit_field_size_opt;
typedef struct { tTree Tree; int Length; bool Ignore; tPosition Position; tPosition EndPos; } yybit_field_size;
typedef struct { tTree Type; bool Ignore; tPosition Position; tPosition EndPos; } yyenum_specifier;
typedef struct { tTree Tree; bool Ignore; } yyenumerator_list;
typedef struct { int Present; int Value; bool Ignore; tPosition EndPos; } yyenumerator_value_opt;
typedef struct { tTree Tree; int Length; bool Ignore; } yyparameter_type_list;
typedef struct { tTree Tree; int Length; bool Ignore; } yyparameter_list;
typedef struct { tTree Tree; bool WithIdent; bool Ignore; } yyparameter_declaration;
typedef struct { tTree Tree; bool Ignore; int Length; tPosition Position; } yyidentifier_list;
typedef struct { tTree Type; bool Ignore; } yytype_name;
typedef struct { tTree Tree; tPosition Position; tPosition EndPos; } yyinitializer_opt;
typedef struct { tTree Tree; tPosition Position; tPosition EndPos; } yyinitializer;
typedef struct { tTree Tree; int Length; } yyinitializer_list;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yyomp_declaration;
typedef struct { tTree Tree; tTree Chain; bool Ignore; tPosition EndPos; } yystatement;
typedef struct { tTree Tree; tTree Chain; bool Ignore; tPosition EndPos; } yylabeled_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yycompound_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yydeclaration_list;
typedef struct { tTree Tree; bool Ignore; } yystatement_list;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyexpression_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyselection_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyiteration_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyjump_statement;
typedef struct { tTree Tree; tTree Chain; bool Ignore; tPosition EndPos; } yyrecon_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyfan_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyomp_statement;
typedef struct { tTree Tree; bool Ignore; } yytranslation_unit;
typedef struct { tTree Tree; bool Ignore; } yyexternal_definition;
typedef struct { tTree Tree; bool Ignore; } yyfunction_definition;
typedef struct { tTree Var; tTree Type; bool Ignore; tPosition Position; } yyfunction_declarator;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yydeclarator;
typedef struct { tIdent Ident; tTree Distribution; int Pointer; bool Ignore; tPosition Position; tPosition EndPos; } yyunary_declarator;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yypostfix_declarator;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yyparen_declarator;
typedef struct { tTree Tree; bool Simple; bool Ignore; tPosition Position; } yynet_specifier;
typedef struct { tTree Tree; bool Simple; bool Ignore; tPosition Position; } yynet_name_specifier;
typedef struct { tIdent Ident; bool Ignore; tPosition Position; tPosition EndPos; } yygeneral_identifier;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yyold_function_declarator;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yypostfix_old_function_declarator;
typedef struct { bool Ignore; tPosition EndPos; } yyabstract_declarator;
typedef struct { bool Ignore; tPosition Position; tPosition EndPos; } yypostfixing_abstract_declarator;
typedef struct { bool Ignore; tPosition Position; tPosition EndPos; } yyarray_abstract_declarator;
typedef struct { bool Ignore; tPosition EndPos; } yyunary_abstract_declarator;
typedef struct { bool Ignore; tPosition EndPos; } yypostfix_abstract_declarator;
typedef struct { int Value; tTree Tree; bool Ignore; tPosition EndPos; } yystep;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Scope; bool Ignore; tPosition Position; } yygrid_step;
typedef struct { tTree Tree; int Class; bool Ignore; } yyempty_net_declaring_list;
typedef struct { tTree Tree; bool Ignore; } yyscheme_declaration;
typedef struct { tTree Tree; bool Ignore; } yyscheme_declaring_list;
typedef struct { tTree Tree; tTree Chain; bool Ignore; tPosition EndPos; } yyscheme_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yycomputation_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yycommunication_statement;

typedef union {
 mpcScan_tScanAttribute Scan;
 yyconstant constant;
 yystring_literal_list string_literal_list;
 yyprimary_expression primary_expression;
 yynet_cast_expression net_cast_expression;
 yypostfix_expression postfix_expression;
 yypostfix_linear_operator postfix_linear_operator;
 yyspecial_arguments special_arguments;
 yyargument_expression_list_opt argument_expression_list_opt;
 yyargument_expression_list argument_expression_list;
 yyunary_expression unary_expression;
 yyunary_operator unary_operator;
 yylinear_operator linear_operator;
 yycast_expression cast_expression;
 yymultiplicative_expression multiplicative_expression;
 yymax_or_min_expression max_or_min_expression;
 yyadditive_expression additive_expression;
 yyshift_expression shift_expression;
 yyrelational_expression relational_expression;
 yyequality_expression equality_expression;
 yyAND_expression AND_expression;
 yyexclusive_OR_expression exclusive_OR_expression;
 yyinclusive_OR_expression inclusive_OR_expression;
 yylogical_AND_expression logical_AND_expression;
 yylogical_OR_expression logical_OR_expression;
 yyconditional_expression conditional_expression;
 yyquaternary_assignment quaternary_assignment;
 yyassignment_expression assignment_expression;
 yyassignment_operator assignment_operator;
 yyexpression expression;
 yyexpression_opt expression_opt;
 yyconst_unary_expression const_unary_expression;
 yyconst_unary_operator const_unary_operator;
 yyconst_cast_expression const_cast_expression;
 yyconst_multiplicative_expression const_multiplicative_expression;
 yyconst_max_or_min_expression const_max_or_min_expression;
 yyconst_additive_expression const_additive_expression;
 yyconst_shift_expression const_shift_expression;
 yyconst_relational_expression const_relational_expression;
 yyconst_equality_expression const_equality_expression;
 yyconst_AND_expression const_AND_expression;
 yyconst_exclusive_OR_expression const_exclusive_OR_expression;
 yyconst_inclusive_OR_expression const_inclusive_OR_expression;
 yyconst_logical_AND_expression const_logical_AND_expression;
 yyconst_logical_OR_expression const_logical_OR_expression;
 yyconst_conditional_expression const_conditional_expression;
 yyconst_conditional_expression_opt const_conditional_expression_opt;
 yyconstant_expression constant_expression;
 yyconst_expression_opt const_expression_opt;
 yydeclaration declaration;
 yynet_declaring_list net_declaring_list;
 yysingle_net_declaring_list single_net_declaring_list;
 yynet_declarator net_declarator;
 yynet_declaration_specifier net_declaration_specifier;
 yynet_type_specifier net_type_specifier;
 yynet_type_declaration net_type_declaration;
 yystorage_class_opt storage_class_opt;
 yytopo_parameter_list topo_parameter_list;
 yytopo_parameter topo_parameter;
 yynet_declaration net_declaration;
 yycoord_declaration coord_declaration;
 yycoord_list coord_list;
 yycoord_declarator coord_declarator;
 yynode_declaration node_declaration;
 yynode_declaring_list node_declaring_list;
 yynode_declarator node_declarator;
 yynode_type_specifier node_type_specifier;
 yyspeed_specifier speed_specifier;
 yyfast_node_specifier fast_node_specifier;
 yyslow_node_specifier slow_node_specifier;
 yybench_node_specifier bench_node_specifier;
 yylink_declaration link_declaration;
 yylink_declaring_list link_declaring_list;
 yylink_declaration_member link_declaration_member;
 yylink_declarator_list link_declarator_list;
 yylink_declarator link_declarator;
 yyfree_coord_list free_coord_list;
 yylink_type_specifier link_type_specifier;
 yyparent_node_declaration parent_node_declaration;
 yyconstant_expression_list constant_expression_list;
 yysubnet_declaring_list subnet_declaring_list;
 yysubnet_list subnet_list;
 yysubnet_declarator subnet_declarator;
 yysubnet_specifier subnet_specifier;
 yyrelation_declaration relation_declaration;
 yyrelation_declarator relation_declarator;
 yyrelational_operator relational_operator;
 yydefault_declaring_list default_declaring_list;
 yydeclaring_list declaring_list;
 yydeclaration_specifier declaration_specifier;
 yytype_specifier type_specifier;
 yydeclaration_qualifier_list declaration_qualifier_list;
 yydeclaration_qualifier declaration_qualifier;
 yytype_qualifier_list type_qualifier_list;
 yytype_qualifier type_qualifier;
 yybasic_declaration_specifier basic_declaration_specifier;
 yybasic_type_specifier basic_type_specifier;
 yysue_declaration_specifier sue_declaration_specifier;
 yysue_type_specifier sue_type_specifier;
 yytypedef_declaration_specifier typedef_declaration_specifier;
 yytypedef_type_specifier typedef_type_specifier;
 yystorage_class storage_class;
 yybasic_type_name basic_type_name;
 yyelaborated_type_name elaborated_type_name;
 yystruct_or_union_specifier struct_or_union_specifier;
 yystruct_or_union struct_or_union;
 yystruct_declaration_list struct_declaration_list;
 yystruct_declaration struct_declaration;
 yystruct_default_declaring_list struct_default_declaring_list;
 yystruct_declaring_list struct_declaring_list;
 yystruct_declarator struct_declarator;
 yybit_field_size_opt bit_field_size_opt;
 yybit_field_size bit_field_size;
 yyenum_specifier enum_specifier;
 yyenumerator_list enumerator_list;
 yyenumerator_value_opt enumerator_value_opt;
 yyparameter_type_list parameter_type_list;
 yyparameter_list parameter_list;
 yyparameter_declaration parameter_declaration;
 yyidentifier_list identifier_list;
 yytype_name type_name;
 yyinitializer_opt initializer_opt;
 yyinitializer initializer;
 yyinitializer_list initializer_list;
 yyomp_declaration omp_declaration;
 yystatement statement;
 yylabeled_statement labeled_statement;
 yycompound_statement compound_statement;
 yydeclaration_list declaration_list;
 yystatement_list statement_list;
 yyexpression_statement expression_statement;
 yyselection_statement selection_statement;
 yyiteration_statement iteration_statement;
 yyjump_statement jump_statement;
 yyrecon_statement recon_statement;
 yyfan_statement fan_statement;
 yyomp_statement omp_statement;
 yytranslation_unit translation_unit;
 yyexternal_definition external_definition;
 yyfunction_definition function_definition;
 yyfunction_declarator function_declarator;
 yydeclarator declarator;
 yyunary_declarator unary_declarator;
 yypostfix_declarator postfix_declarator;
 yyparen_declarator paren_declarator;
 yynet_specifier net_specifier;
 yynet_name_specifier net_name_specifier;
 yygeneral_identifier general_identifier;
 yyold_function_declarator old_function_declarator;
 yypostfix_old_function_declarator postfix_old_function_declarator;
 yyabstract_declarator abstract_declarator;
 yypostfixing_abstract_declarator postfixing_abstract_declarator;
 yyarray_abstract_declarator array_abstract_declarator;
 yyunary_abstract_declarator unary_abstract_declarator;
 yypostfix_abstract_declarator postfix_abstract_declarator;
 yystep step;
 yygrid_step grid_step;
 yyempty_net_declaring_list empty_net_declaring_list;
 yyscheme_declaration scheme_declaration;
 yyscheme_declaring_list scheme_declaring_list;
 yyscheme_statement scheme_statement;
 yycomputation_statement computation_statement;
 yycommunication_statement communication_statement;
} tParsAttribute;


# if defined lex_interface & ! defined yylvalDef
     tParsAttribute yylval;
# endif

# ifndef yyInitStackSize
#    define yyInitStackSize	100
# endif
# define yyNoState		0

# define yyFirstTerminal	0
# define yyLastTerminal		137
# define yyTableMax		4748
# define yyNTableMax		7158
# define yyFirstReadState	1
# define yyLastReadState	564
# define yyFirstReadReduceState	565
# define yyLastReadReduceState	952
# define yyFirstReduceState	953
# define yyLastReduceState	1478
# define yyStartState		1
# define yyStopState		953

# define yyFirstFinalState	yyFirstReadReduceState

typedef unsigned short	yyStateRange	;
typedef unsigned short	yySymbolRange	;
typedef struct	{ yyStateRange Check, Next; } yyTCombType ;

	char *		mpcPars_TokenName	[yyLastTerminal + 2] = {
"_EndOfFile",
"IDENTIFIER",
"NETorSUBNETname",
"TYPEDEFname",
"FLOATINGconstant",
"INTEGERconstant",
"OCTALconstant",
"HEXconstant",
"CHARACTERconstant",
"STRINGliteral",
"HEADER",
"SOURCE",
"OMP_DECL",
"OMP_STAT",
"bench",
"coord",
"coordof",
"fan",
"fast",
"flex",
"host",
"length",
"link",
"memory",
"net",
"nettype",
"node",
"parent",
"recon",
"relation",
"repl",
"scalar",
"slow",
"subnet",
"vector",
"par",
"scheme",
"timeof",
"[",
"]",
"[*]",
"(",
",",
")",
":",
"[]",
".",
"->",
"++",
"--",
"[?<]",
"[?>]",
"[+]",
"[&]",
"[^]",
"[|]",
"[&&]",
"[||]",
"[<",
">]",
"[>",
"<]",
"&",
"*",
"+",
"-",
"~",
"!",
"sizeof",
"mpc_sizeof",
"void",
"char",
"short",
"int",
"long",
"float",
"double",
"signed",
"unsigned",
"const",
"volatile",
"struct",
"union",
"{",
"typedef",
"extern",
"static",
"auto",
"register",
"/",
"%",
"?<",
"?>",
"<<",
">>",
"<",
">",
"<=",
">=",
"==",
"!=",
"^",
"|",
"&&",
"||",
"?",
";",
"}",
"enum",
"=",
"...",
"*=",
"/=",
"%=",
"+=",
"-=",
"<<=",
">>=",
"&=",
"^=",
"|=",
"<-",
"@",
"@@",
"default",
"<->",
"case",
"if",
"else",
"switch",
"while",
"do",
"for",
"goto",
"continue",
"break",
"return",
"%%",
""
};
static	yyTCombType	yyTComb		[yyTableMax + 1] = {
{331, 954},
{1, 565},
{6, 574},
{116, 623},
{117, 624},
{3, 1145},
{3, 1145},
{3, 1145},
{230, 658},
{296, 297},
{221, 14},
{311, 690},
{313, 314},
{322, 1461},
{323, 691},
{325, 692},
{336, 310},
{511, 643},
{437, 14},
{533, 366},
{13, 222},
{17, 18},
{393, 377},
{541, 643},
{5, 962},
{133, 2},
{130, 570},
{15, 16},
{221, 222},
{354, 355},
{564, 953},
{0, 0},
{221, 2},
{0, 0},
{0, 0},
{22, 23},
{437, 438},
{0, 0},
{1, 13},
{14, 588},
{1, 657},
{1, 318},
{3, 1145},
{3, 1145},
{3, 1145},
{3, 4},
{5, 962},
{3, 1145},
{8, 9},
{10, 586},
{11, 587},
{12, 1468},
{16, 589},
{5, 962},
{5, 962},
{18, 19},
{22, 26},
{5, 962},
{23, 24},
{24, 592},
{26, 986},
{28, 22},
{5, 962},
{1, 319},
{30, 31},
{32, 33},
{5, 962},
{5, 962},
{34, 630},
{39, 1072},
{40, 608},
{41, 42},
{42, 1072},
{44, 1459},
{46, 1460},
{40, 1073},
{47, 17},
{49, 609},
{44, 45},
{50, 621},
{114, 28},
{108, 35},
{5, 962},
{108, 109},
{5, 962},
{122, 629},
{121, 35},
{119, 35},
{124, 125},
{128, 1461},
{129, 130},
{130, 581},
{130, 582},
{130, 583},
{130, 584},
{130, 585},
{131, 636},
{132, 637},
{134, 17},
{137, 138},
{139, 140},
{143, 642},
{5, 962},
{5, 962},
{119, 627},
{121, 628},
{148, 149},
{43, 1073},
{146, 644},
{25, 964},
{152, 645},
{43, 1073},
{153, 154},
{146, 147},
{153, 1331},
{155, 1446},
{155, 147},
{25, 593},
{207, 1124},
{208, 209},
{210, 647},
{112, 1072},
{54, 55},
{55, 1072},
{56, 57},
{110, 1072},
{111, 112},
{113, 114},
{211, 648},
{212, 1448},
{5, 962},
{25, 964},
{214, 1449},
{222, 651},
{153, 155},
{223, 652},
{224, 653},
{225, 654},
{25, 964},
{25, 964},
{223, 147},
{226, 655},
{25, 964},
{227, 656},
{231, 659},
{5, 962},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{43, 1073},
{229, 1446},
{229, 1446},
{229, 147},
{234, 147},
{236, 1402},
{236, 1402},
{236, 1402},
{241, 242},
{243, 660},
{231, 232},
{244, 1463},
{245, 246},
{25, 964},
{25, 964},
{43, 1073},
{43, 1073},
{43, 1073},
{248, 1448},
{248, 1448},
{238, 233},
{144, 1238},
{251, 661},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{238, 234},
{25, 964},
{38, 990},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{25, 964},
{144, 1238},
{145, 643},
{144, 1238},
{144, 1238},
{213, 631},
{144, 1238},
{144, 1238},
{144, 1238},
{38, 990},
{249, 631},
{252, 253},
{236, 1402},
{254, 662},
{25, 964},
{236, 1402},
{38, 990},
{38, 990},
{213, 1447},
{256, 257},
{38, 990},
{264, 672},
{249, 1447},
{249, 1447},
{268, 259},
{38, 990},
{144, 1238},
{271, 675},
{38, 990},
{38, 990},
{38, 990},
{154, 146},
{228, 565},
{279, 280},
{154, 154},
{280, 281},
{247, 146},
{145, 146},
{154, 646},
{247, 237},
{145, 154},
{282, 676},
{145, 1333},
{247, 646},
{145, 646},
{38, 990},
{217, 570},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{250, 1449},
{250, 1449},
{213, 632},
{213, 633},
{154, 155},
{253, 1454},
{253, 1454},
{249, 632},
{249, 633},
{283, 677},
{145, 155},
{265, 266},
{267, 268},
{38, 990},
{38, 990},
{290, 679},
{260, 1303},
{228, 221},
{260, 259},
{228, 657},
{228, 228},
{273, 1317},
{273, 1317},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{228, 229},
{38, 990},
{48, 991},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{38, 990},
{293, 680},
{217, 581},
{217, 582},
{217, 583},
{217, 584},
{217, 585},
{294, 987},
{288, 284},
{48, 991},
{295, 296},
{297, 298},
{298, 681},
{301, 1465},
{38, 990},
{302, 1467},
{48, 991},
{48, 991},
{265, 673},
{267, 674},
{48, 991},
{303, 304},
{314, 15},
{260, 1303},
{48, 39},
{48, 991},
{48, 591},
{48, 49},
{48, 991},
{48, 991},
{48, 991},
{48, 622},
{48, 116},
{48, 117},
{48, 625},
{48, 626},
{48, 594},
{48, 595},
{48, 596},
{48, 597},
{48, 598},
{48, 599},
{48, 600},
{48, 601},
{48, 118},
{48, 991},
{48, 120},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{316, 1212},
{242, 1409},
{242, 1409},
{242, 1409},
{255, 663},
{255, 664},
{255, 665},
{255, 666},
{255, 667},
{255, 668},
{255, 669},
{255, 670},
{255, 671},
{48, 991},
{48, 991},
{285, 1311},
{305, 682},
{308, 51},
{308, 683},
{305, 35},
{272, 643},
{288, 678},
{319, 147},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{242, 1409},
{48, 991},
{218, 1235},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{48, 991},
{52, 1019},
{272, 1326},
{272, 1326},
{324, 325},
{324, 693},
{328, 329},
{326, 631},
{242, 1409},
{52, 1019},
{330, 322},
{242, 1409},
{52, 1019},
{334, 695},
{48, 991},
{337, 697},
{344, 344},
{52, 1019},
{346, 700},
{356, 1461},
{52, 1019},
{52, 1019},
{52, 1019},
{285, 1311},
{218, 1235},
{285, 127},
{218, 1235},
{218, 1235},
{218, 1235},
{218, 1235},
{350, 13},
{218, 1235},
{350, 657},
{359, 360},
{359, 364},
{361, 1152},
{361, 1152},
{52, 1019},
{345, 346},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{332, 333},
{321, 1402},
{321, 1402},
{335, 336},
{364, 365},
{218, 1235},
{310, 684},
{310, 685},
{310, 686},
{310, 687},
{310, 688},
{310, 689},
{326, 632},
{326, 633},
{367, 368},
{371, 705},
{340, 341},
{372, 404},
{373, 374},
{357, 358},
{375, 376},
{377, 378},
{380, 381},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{52, 1019},
{321, 1402},
{52, 610},
{187, 1109},
{52, 611},
{52, 612},
{52, 613},
{52, 614},
{52, 615},
{52, 616},
{52, 617},
{52, 618},
{52, 619},
{52, 620},
{52, 53},
{52, 1019},
{52, 110},
{59, 1025},
{345, 701},
{347, 348},
{357, 533},
{382, 383},
{384, 706},
{332, 694},
{321, 1402},
{59, 1025},
{335, 696},
{321, 1402},
{59, 1025},
{386, 387},
{52, 1019},
{388, 707},
{187, 1109},
{59, 1025},
{389, 708},
{391, 379},
{59, 1025},
{59, 1025},
{59, 1025},
{340, 702},
{187, 1109},
{187, 1109},
{187, 1109},
{187, 1109},
{187, 1109},
{187, 1109},
{187, 1109},
{187, 1109},
{353, 317},
{381, 382},
{369, 370},
{392, 393},
{395, 396},
{59, 1025},
{396, 710},
{59, 1025},
{59, 1025},
{372, 1156},
{59, 1025},
{59, 1025},
{394, 390},
{397, 398},
{399, 370},
{399, 711},
{187, 1109},
{187, 1109},
{358, 1277},
{358, 1277},
{358, 1277},
{358, 1277},
{358, 1277},
{358, 1277},
{358, 1277},
{358, 1277},
{358, 1277},
{400, 401},
{401, 375},
{402, 403},
{403, 712},
{404, 405},
{405, 406},
{187, 1109},
{187, 1109},
{347, 703},
{149, 1464},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{59, 1025},
{63, 1028},
{187, 1109},
{187, 1109},
{187, 1109},
{187, 1109},
{187, 1109},
{187, 1109},
{187, 1109},
{63, 1028},
{149, 1464},
{353, 1213},
{63, 1028},
{369, 704},
{59, 1025},
{59, 1025},
{59, 1025},
{63, 1028},
{406, 407},
{408, 409},
{63, 1028},
{63, 1028},
{63, 1028},
{394, 709},
{220, 221},
{410, 1195},
{381, 386},
{220, 228},
{220, 1320},
{220, 1320},
{59, 1025},
{220, 646},
{418, 714},
{410, 1195},
{420, 421},
{422, 718},
{410, 1195},
{63, 1028},
{423, 424},
{63, 1028},
{63, 1028},
{274, 221},
{63, 1028},
{63, 1028},
{274, 228},
{274, 1323},
{274, 1323},
{424, 719},
{274, 646},
{220, 229},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{149, 1464},
{362, 157},
{425, 426},
{427, 428},
{274, 229},
{362, 1155},
{362, 1155},
{428, 720},
{362, 1155},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{63, 1028},
{65, 1026},
{429, 430},
{149, 1464},
{433, 313},
{436, 441},
{438, 439},
{439, 1416},
{441, 1072},
{65, 1026},
{442, 1073},
{443, 444},
{65, 1026},
{445, 446},
{63, 1028},
{63, 1028},
{63, 1028},
{65, 1026},
{447, 448},
{452, 453},
{65, 1026},
{65, 1026},
{65, 1026},
{410, 1195},
{455, 456},
{258, 565},
{450, 451},
{258, 643},
{457, 458},
{459, 460},
{63, 1028},
{461, 462},
{463, 464},
{413, 1191},
{465, 466},
{467, 468},
{470, 471},
{65, 1026},
{472, 473},
{65, 1026},
{65, 1026},
{413, 1191},
{65, 1026},
{65, 1026},
{413, 1191},
{474, 475},
{475, 1072},
{476, 477},
{479, 723},
{378, 590},
{416, 1194},
{219, 1238},
{378, 575},
{378, 576},
{378, 577},
{378, 578},
{378, 579},
{378, 580},
{416, 1194},
{480, 724},
{482, 725},
{416, 1194},
{258, 13},
{483, 1072},
{258, 657},
{258, 233},
{481, 482},
{481, 726},
{258, 259},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{65, 1026},
{67, 1027},
{258, 234},
{219, 1238},
{378, 20},
{219, 1238},
{219, 1238},
{219, 1238},
{219, 1238},
{67, 1027},
{219, 1238},
{484, 727},
{67, 1027},
{486, 487},
{65, 1026},
{65, 1026},
{65, 1026},
{67, 1027},
{488, 489},
{490, 491},
{67, 1027},
{67, 1027},
{67, 1027},
{493, 728},
{494, 495},
{339, 1238},
{485, 35},
{417, 1192},
{219, 1238},
{489, 490},
{65, 1026},
{413, 1191},
{478, 571},
{478, 572},
{478, 573},
{417, 1192},
{496, 1418},
{67, 1027},
{417, 1192},
{67, 1027},
{67, 1027},
{67, 60},
{67, 1027},
{67, 1027},
{492, 493},
{450, 722},
{417, 35},
{492, 385},
{416, 1194},
{497, 730},
{498, 499},
{500, 501},
{411, 1190},
{502, 503},
{503, 504},
{505, 35},
{505, 506},
{506, 731},
{517, 732},
{518, 733},
{411, 1190},
{519, 734},
{339, 1238},
{411, 1190},
{339, 1238},
{339, 1238},
{521, 522},
{67, 61},
{67, 62},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{67, 1027},
{68, 1031},
{339, 1238},
{489, 729},
{263, 1239},
{485, 1073},
{522, 735},
{411, 412},
{523, 524},
{68, 1031},
{524, 736},
{525, 1157},
{68, 1031},
{526, 373},
{67, 1027},
{67, 1027},
{67, 1027},
{68, 1031},
{527, 1159},
{209, 1121},
{68, 1031},
{68, 1031},
{68, 1031},
{528, 1162},
{529, 1163},
{417, 1192},
{534, 737},
{414, 1193},
{209, 1121},
{209, 1121},
{67, 1027},
{209, 1121},
{209, 1121},
{209, 1121},
{209, 1121},
{414, 1193},
{485, 486},
{68, 1031},
{414, 1193},
{68, 1031},
{68, 1031},
{263, 1239},
{509, 233},
{263, 1239},
{263, 1239},
{339, 699},
{263, 1239},
{263, 1239},
{263, 1239},
{419, 715},
{411, 1190},
{530, 425},
{209, 1121},
{516, 1335},
{536, 1389},
{531, 429},
{537, 1394},
{419, 716},
{542, 1390},
{543, 1395},
{419, 717},
{491, 128},
{548, 1387},
{549, 1392},
{509, 234},
{491, 134},
{263, 1239},
{414, 415},
{209, 1121},
{209, 1121},
{554, 1388},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{68, 1031},
{70, 1029},
{515, 233},
{491, 638},
{491, 639},
{491, 640},
{491, 641},
{491, 139},
{491, 148},
{70, 1029},
{209, 1121},
{209, 1121},
{70, 1029},
{526, 1158},
{68, 1031},
{68, 1031},
{68, 1031},
{70, 1029},
{555, 1393},
{559, 449},
{70, 1029},
{70, 1029},
{70, 1029},
{563, 1465},
{515, 234},
{414, 1193},
{276, 1236},
{0, 0},
{0, 0},
{532, 146},
{68, 1031},
{0, 0},
{516, 1335},
{532, 1151},
{532, 1151},
{516, 343},
{532, 646},
{70, 1029},
{0, 0},
{70, 1029},
{70, 1029},
{531, 1161},
{70, 1029},
{70, 1029},
{276, 570},
{0, 0},
{530, 1160},
{419, 1184},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{535, 565},
{0, 0},
{535, 650},
{0, 0},
{553, 565},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{276, 1236},
{0, 0},
{276, 1236},
{276, 1236},
{276, 1236},
{276, 1236},
{0, 0},
{276, 1236},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{70, 1029},
{72, 1030},
{0, 0},
{276, 1236},
{535, 13},
{0, 0},
{535, 657},
{535, 318},
{553, 13},
{72, 1030},
{553, 657},
{553, 318},
{72, 1030},
{0, 0},
{70, 1029},
{70, 1029},
{70, 1029},
{72, 1030},
{0, 0},
{0, 0},
{72, 1030},
{72, 1030},
{72, 1030},
{0, 0},
{276, 581},
{276, 582},
{276, 583},
{276, 584},
{276, 585},
{535, 319},
{70, 1029},
{0, 0},
{0, 0},
{553, 319},
{0, 0},
{0, 0},
{0, 0},
{72, 1030},
{0, 0},
{72, 1030},
{72, 1030},
{0, 0},
{72, 1030},
{72, 1030},
{562, 567},
{562, 568},
{562, 569},
{0, 0},
{421, 408},
{0, 0},
{0, 0},
{277, 1237},
{421, 411},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{421, 1186},
{562, 2},
{562, 1149},
{0, 0},
{0, 0},
{0, 0},
{562, 309},
{0, 0},
{421, 1186},
{421, 414},
{562, 312},
{421, 1186},
{72, 64},
{72, 66},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{72, 1030},
{73, 1034},
{0, 0},
{277, 1237},
{0, 0},
{277, 1237},
{277, 1237},
{277, 1237},
{277, 1237},
{73, 1034},
{277, 1237},
{0, 0},
{73, 1034},
{0, 0},
{72, 1030},
{72, 1030},
{72, 1030},
{73, 1034},
{0, 0},
{421, 713},
{73, 1034},
{73, 1034},
{73, 1034},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{277, 1237},
{0, 0},
{72, 1030},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{299, 1466},
{0, 0},
{73, 1034},
{0, 0},
{73, 1034},
{73, 1034},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{75, 1032},
{0, 0},
{0, 0},
{0, 0},
{278, 1239},
{421, 1186},
{0, 0},
{0, 0},
{75, 1032},
{0, 0},
{0, 0},
{75, 1032},
{299, 1466},
{0, 0},
{0, 0},
{0, 0},
{75, 1032},
{0, 0},
{0, 0},
{75, 1032},
{75, 1032},
{75, 1032},
{0, 0},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{73, 1034},
{75, 1032},
{0, 0},
{75, 1032},
{75, 1032},
{0, 0},
{278, 1239},
{0, 0},
{278, 1239},
{278, 1239},
{278, 1239},
{278, 1239},
{0, 0},
{278, 1239},
{73, 1034},
{73, 1034},
{73, 1034},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{299, 1466},
{73, 1034},
{278, 1239},
{0, 0},
{0, 0},
{0, 0},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{75, 1032},
{77, 1033},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{299, 1466},
{0, 0},
{0, 0},
{77, 1033},
{0, 0},
{0, 0},
{77, 1033},
{0, 0},
{75, 1032},
{75, 1032},
{75, 1032},
{77, 1033},
{0, 0},
{0, 0},
{77, 1033},
{77, 1033},
{77, 1033},
{0, 0},
{0, 0},
{195, 1113},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{75, 1032},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 1033},
{0, 0},
{77, 1033},
{77, 1033},
{0, 0},
{77, 69},
{77, 71},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{195, 1113},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{195, 1113},
{195, 1113},
{195, 1113},
{195, 1113},
{195, 1113},
{195, 1113},
{195, 1113},
{195, 1113},
{0, 0},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{77, 1033},
{78, 1039},
{195, 1113},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{78, 1039},
{0, 0},
{0, 0},
{78, 1039},
{0, 0},
{77, 1033},
{77, 1033},
{77, 1033},
{78, 1039},
{195, 1113},
{195, 1113},
{78, 1039},
{78, 1039},
{78, 1039},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 1033},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{215, 1462},
{0, 0},
{78, 1039},
{0, 0},
{78, 1039},
{78, 1039},
{195, 1113},
{195, 1113},
{195, 1113},
{195, 1113},
{195, 1113},
{195, 1113},
{0, 0},
{0, 0},
{0, 0},
{80, 1035},
{215, 1462},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{80, 1035},
{0, 0},
{0, 0},
{80, 1035},
{215, 1462},
{0, 0},
{0, 0},
{0, 0},
{80, 1035},
{0, 0},
{0, 0},
{80, 1035},
{80, 1035},
{80, 1035},
{0, 0},
{0, 0},
{0, 0},
{215, 1462},
{0, 0},
{78, 1039},
{78, 1039},
{78, 1039},
{78, 1039},
{78, 1039},
{78, 1039},
{78, 1039},
{78, 1039},
{78, 1039},
{80, 1035},
{0, 0},
{80, 1035},
{80, 1035},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{78, 1039},
{78, 1039},
{78, 1039},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{78, 1039},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{215, 1462},
{0, 0},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{80, 1035},
{82, 1036},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{215, 1462},
{0, 0},
{0, 0},
{82, 1036},
{0, 0},
{0, 0},
{82, 1036},
{0, 0},
{80, 1035},
{80, 1035},
{80, 1035},
{82, 1036},
{0, 0},
{0, 0},
{82, 1036},
{82, 1036},
{82, 1036},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{80, 1035},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{300, 566},
{0, 0},
{82, 1036},
{0, 0},
{82, 1036},
{82, 1036},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{84, 1037},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{84, 1037},
{0, 0},
{0, 0},
{84, 1037},
{300, 631},
{0, 0},
{0, 0},
{0, 0},
{84, 1037},
{0, 0},
{0, 0},
{84, 1037},
{84, 1037},
{84, 1037},
{0, 0},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{82, 1036},
{84, 1037},
{0, 0},
{84, 1037},
{84, 1037},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{82, 1036},
{82, 1036},
{82, 1036},
{300, 1277},
{300, 1277},
{300, 1277},
{300, 1277},
{300, 1277},
{300, 1277},
{300, 1277},
{300, 1277},
{300, 1277},
{300, 632},
{300, 633},
{300, 634},
{300, 635},
{82, 1036},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{84, 1037},
{86, 1038},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{300, 124},
{0, 0},
{0, 0},
{86, 1038},
{0, 0},
{0, 0},
{86, 1038},
{0, 0},
{84, 1037},
{84, 1037},
{84, 1037},
{86, 1038},
{0, 0},
{0, 0},
{86, 1038},
{86, 1038},
{86, 1038},
{0, 0},
{0, 0},
{87, 1042},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{84, 1037},
{0, 0},
{0, 0},
{87, 1042},
{0, 0},
{0, 0},
{87, 1042},
{86, 1038},
{0, 0},
{86, 1038},
{86, 1038},
{87, 1042},
{0, 0},
{0, 0},
{87, 1042},
{87, 1042},
{87, 1042},
{0, 0},
{0, 0},
{338, 1235},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{87, 1042},
{0, 0},
{87, 1042},
{87, 1042},
{0, 0},
{0, 0},
{338, 570},
{0, 0},
{0, 0},
{0, 0},
{86, 74},
{86, 76},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{86, 1038},
{338, 1235},
{0, 0},
{338, 1235},
{338, 1235},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{86, 1038},
{86, 1038},
{86, 1038},
{0, 0},
{87, 1042},
{87, 1042},
{87, 1042},
{87, 1042},
{87, 1042},
{87, 1042},
{87, 1042},
{89, 1040},
{338, 1235},
{0, 0},
{0, 0},
{0, 0},
{86, 1038},
{0, 0},
{0, 0},
{89, 1040},
{0, 0},
{0, 0},
{89, 1040},
{0, 0},
{87, 1042},
{87, 1042},
{87, 1042},
{89, 1040},
{0, 0},
{0, 0},
{89, 1040},
{89, 1040},
{89, 1040},
{338, 581},
{338, 582},
{338, 583},
{338, 584},
{338, 585},
{0, 0},
{0, 0},
{87, 1042},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{216, 1464},
{0, 0},
{89, 1040},
{0, 0},
{89, 1040},
{89, 1040},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{338, 698},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{91, 1041},
{216, 1464},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{91, 1041},
{0, 0},
{0, 0},
{91, 1041},
{216, 1464},
{0, 0},
{0, 0},
{0, 0},
{91, 1041},
{0, 0},
{0, 0},
{91, 1041},
{91, 1041},
{91, 1041},
{0, 0},
{0, 0},
{0, 0},
{216, 649},
{0, 0},
{89, 1040},
{89, 1040},
{89, 1040},
{89, 1040},
{89, 1040},
{89, 1040},
{89, 1040},
{89, 1040},
{89, 1040},
{91, 1041},
{0, 0},
{91, 1041},
{91, 1041},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{89, 1040},
{89, 1040},
{89, 1040},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{89, 1040},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{216, 1464},
{0, 0},
{91, 79},
{91, 81},
{91, 83},
{91, 85},
{91, 1041},
{91, 1041},
{91, 1041},
{91, 1041},
{91, 1041},
{91, 1041},
{91, 1041},
{91, 1041},
{91, 1041},
{92, 1044},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{216, 1464},
{0, 0},
{0, 0},
{92, 1044},
{0, 0},
{0, 0},
{92, 1044},
{0, 0},
{91, 1041},
{91, 1041},
{91, 1041},
{92, 1044},
{0, 0},
{0, 0},
{92, 1044},
{92, 1044},
{92, 1044},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{94, 1043},
{0, 0},
{0, 0},
{91, 1041},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{94, 1043},
{0, 0},
{92, 1044},
{94, 1043},
{92, 1044},
{0, 0},
{0, 0},
{0, 0},
{94, 1043},
{0, 0},
{0, 0},
{94, 1043},
{94, 1043},
{94, 1043},
{0, 0},
{0, 0},
{95, 1046},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{95, 1046},
{0, 0},
{0, 0},
{95, 1046},
{94, 1043},
{0, 0},
{94, 1043},
{94, 1043},
{95, 1046},
{0, 0},
{0, 0},
{95, 1046},
{95, 1046},
{95, 1046},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{92, 1044},
{92, 1044},
{92, 1044},
{92, 1044},
{92, 1044},
{92, 1044},
{92, 1044},
{0, 0},
{95, 1046},
{0, 0},
{95, 1046},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{92, 1044},
{92, 1044},
{92, 1044},
{0, 0},
{94, 88},
{94, 90},
{94, 1043},
{94, 1043},
{94, 1043},
{94, 1043},
{94, 1043},
{94, 1043},
{94, 1043},
{0, 0},
{0, 0},
{0, 0},
{92, 1044},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{94, 1043},
{94, 1043},
{94, 1043},
{0, 0},
{0, 0},
{95, 1046},
{95, 1046},
{95, 1046},
{95, 1046},
{95, 1046},
{95, 1046},
{97, 1045},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{94, 1043},
{0, 0},
{0, 0},
{97, 1045},
{0, 0},
{0, 0},
{97, 1045},
{0, 0},
{95, 1046},
{95, 1046},
{95, 1046},
{97, 1045},
{0, 0},
{0, 0},
{97, 1045},
{97, 1045},
{97, 1045},
{0, 0},
{0, 0},
{98, 1048},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{95, 1046},
{0, 0},
{0, 0},
{98, 1048},
{0, 0},
{0, 0},
{98, 1048},
{97, 1045},
{0, 0},
{97, 1045},
{97, 93},
{98, 1048},
{0, 0},
{0, 0},
{98, 1048},
{98, 1048},
{98, 1048},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{100, 1047},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{100, 1047},
{0, 0},
{98, 1048},
{100, 1047},
{98, 1048},
{0, 0},
{0, 0},
{0, 0},
{100, 1047},
{0, 0},
{0, 0},
{100, 1047},
{100, 1047},
{100, 1047},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{97, 1045},
{97, 1045},
{97, 1045},
{97, 1045},
{97, 1045},
{97, 1045},
{97, 1045},
{0, 0},
{100, 1047},
{0, 0},
{100, 1047},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{97, 1045},
{97, 1045},
{97, 1045},
{0, 0},
{0, 0},
{0, 0},
{98, 1048},
{98, 1048},
{98, 1048},
{98, 1048},
{98, 1048},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{97, 1045},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{98, 1048},
{98, 1048},
{98, 1048},
{0, 0},
{0, 0},
{0, 0},
{100, 96},
{100, 1047},
{100, 1047},
{100, 1047},
{100, 1047},
{100, 1047},
{100, 1047},
{101, 1050},
{0, 0},
{0, 0},
{98, 1048},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{101, 1050},
{0, 0},
{0, 0},
{101, 1050},
{0, 0},
{100, 1047},
{100, 1047},
{100, 1047},
{101, 1050},
{0, 0},
{0, 0},
{101, 1050},
{101, 1050},
{101, 1050},
{0, 0},
{103, 1049},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{100, 1047},
{0, 0},
{103, 1049},
{0, 0},
{0, 0},
{103, 1049},
{0, 0},
{101, 1050},
{0, 0},
{101, 1050},
{103, 1049},
{0, 0},
{0, 0},
{103, 1049},
{103, 1049},
{103, 1049},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{104, 1052},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{104, 1052},
{0, 0},
{103, 1049},
{104, 1052},
{103, 1049},
{0, 0},
{0, 0},
{0, 0},
{104, 1052},
{0, 0},
{0, 0},
{104, 1052},
{104, 1052},
{104, 1052},
{0, 0},
{451, 1267},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{101, 1050},
{101, 1050},
{101, 1050},
{101, 1050},
{104, 1052},
{0, 0},
{104, 1052},
{0, 0},
{0, 0},
{451, 1267},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{101, 1050},
{101, 1050},
{101, 1050},
{451, 1267},
{103, 99},
{103, 1049},
{103, 1049},
{103, 1049},
{103, 1049},
{103, 1049},
{106, 1051},
{451, 1267},
{0, 0},
{451, 1267},
{451, 1267},
{0, 0},
{101, 1050},
{451, 1424},
{106, 1051},
{0, 0},
{0, 0},
{106, 1051},
{0, 0},
{103, 1049},
{103, 1049},
{103, 1049},
{106, 1051},
{0, 0},
{0, 0},
{106, 1051},
{106, 1051},
{106, 1051},
{104, 105},
{104, 107},
{104, 1052},
{104, 1052},
{451, 1267},
{0, 0},
{0, 0},
{103, 1049},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{106, 1051},
{0, 0},
{106, 1051},
{104, 1052},
{104, 1052},
{104, 1052},
{451, 1267},
{451, 1267},
{0, 0},
{0, 0},
{0, 0},
{451, 1267},
{451, 1267},
{451, 1267},
{451, 1267},
{451, 1267},
{0, 0},
{0, 0},
{0, 0},
{104, 1052},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{106, 102},
{106, 1051},
{106, 1051},
{106, 1051},
{106, 1051},
{156, 1436},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 1436},
{156, 1436},
{156, 1436},
{0, 0},
{0, 0},
{0, 0},
{106, 1051},
{106, 1051},
{106, 1051},
{156, 1436},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 1436},
{156, 1436},
{0, 0},
{0, 0},
{0, 0},
{156, 1436},
{156, 1436},
{0, 0},
{106, 1051},
{156, 1436},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 157},
{0, 0},
{0, 0},
{0, 0},
{156, 1436},
{156, 1436},
{156, 1436},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{159, 1092},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{156, 1436},
{159, 1092},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{0, 0},
{156, 1436},
{0, 0},
{156, 1436},
{156, 1436},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{159, 1092},
{0, 0},
{159, 1092},
{159, 1092},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{159, 1092},
{159, 1092},
{163, 1095},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{159, 1092},
{0, 0},
{0, 0},
{163, 1095},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{0, 0},
{165, 1093},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 1093},
{0, 0},
{0, 0},
{163, 1095},
{163, 1095},
{0, 0},
{0, 0},
{0, 0},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{0, 0},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{163, 1095},
{165, 1093},
{0, 0},
{165, 1093},
{165, 1093},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 1093},
{165, 1093},
{167, 1094},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{165, 1093},
{0, 0},
{0, 0},
{167, 1094},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 1094},
{167, 160},
{167, 1094},
{167, 1094},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 1094},
{167, 1094},
{168, 1098},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 161},
{167, 162},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{167, 1094},
{0, 0},
{0, 0},
{168, 1098},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{0, 0},
{170, 1096},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{168, 1098},
{168, 1098},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 1096},
{0, 0},
{0, 0},
{168, 1098},
{168, 1098},
{0, 0},
{0, 0},
{0, 0},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{0, 0},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{168, 1098},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 1096},
{170, 1096},
{172, 1097},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{170, 1096},
{0, 0},
{0, 0},
{172, 1097},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{172, 1097},
{172, 1097},
{173, 1101},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{172, 164},
{172, 166},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{172, 1097},
{0, 0},
{0, 0},
{173, 1101},
{175, 1099},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{175, 1099},
{0, 0},
{173, 1101},
{173, 1101},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{0, 0},
{0, 0},
{0, 0},
{173, 1101},
{173, 1101},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{175, 1099},
{175, 1099},
{0, 0},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{173, 1101},
{0, 0},
{175, 1099},
{175, 1099},
{177, 1100},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{175, 1099},
{0, 0},
{0, 0},
{177, 1100},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{0, 0},
{178, 1106},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{177, 1100},
{177, 1100},
{177, 169},
{177, 171},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{178, 1106},
{0, 0},
{0, 0},
{177, 1100},
{177, 1100},
{0, 0},
{0, 0},
{0, 0},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{0, 0},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{177, 1100},
{178, 1106},
{178, 1106},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{178, 1106},
{178, 1106},
{180, 1102},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{262, 1237},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{178, 1106},
{0, 0},
{0, 0},
{180, 1102},
{182, 1103},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{262, 1237},
{0, 0},
{262, 1237},
{262, 1237},
{0, 0},
{262, 1237},
{262, 1237},
{262, 1237},
{0, 0},
{182, 1103},
{0, 0},
{180, 1102},
{180, 1102},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{262, 1237},
{0, 0},
{0, 0},
{180, 1102},
{180, 1102},
{0, 0},
{0, 0},
{262, 1277},
{262, 1277},
{262, 1277},
{262, 1277},
{262, 1277},
{262, 1277},
{262, 1277},
{262, 1277},
{262, 1277},
{182, 1103},
{182, 1103},
{0, 0},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{180, 1102},
{0, 0},
{182, 1103},
{182, 1103},
{184, 1104},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{275, 1234},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{182, 1103},
{0, 0},
{0, 0},
{184, 1104},
{186, 1105},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{275, 1234},
{0, 0},
{275, 1234},
{275, 1234},
{275, 1234},
{275, 1234},
{0, 0},
{275, 1234},
{0, 0},
{186, 1105},
{0, 0},
{184, 1104},
{184, 1104},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{275, 1234},
{0, 0},
{0, 0},
{184, 1104},
{184, 1104},
{0, 0},
{0, 0},
{275, 1277},
{275, 1277},
{275, 1277},
{275, 1277},
{275, 1277},
{275, 1277},
{275, 1277},
{275, 1277},
{275, 1277},
{186, 1105},
{186, 1105},
{0, 0},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{184, 1104},
{0, 0},
{186, 1105},
{186, 1105},
{189, 1107},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{186, 174},
{186, 176},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{186, 1105},
{0, 0},
{0, 0},
{189, 1107},
{191, 1108},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{191, 1108},
{0, 0},
{189, 1107},
{189, 1107},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{0, 0},
{0, 0},
{0, 0},
{189, 1107},
{189, 1107},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{191, 1108},
{191, 1108},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{189, 1107},
{0, 0},
{191, 1108},
{191, 1108},
{192, 1111},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{191, 179},
{191, 181},
{191, 183},
{191, 185},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{191, 1108},
{0, 0},
{0, 0},
{192, 1111},
{194, 1110},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{192, 1111},
{192, 1111},
{192, 1111},
{192, 1111},
{192, 1111},
{192, 1111},
{192, 1111},
{192, 1111},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{194, 1110},
{0, 0},
{0, 0},
{192, 1111},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{194, 1110},
{194, 1110},
{194, 1110},
{194, 1110},
{194, 1110},
{194, 1110},
{194, 1110},
{194, 1110},
{0, 0},
{0, 0},
{0, 0},
{192, 1111},
{192, 1111},
{0, 0},
{197, 1112},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{194, 1110},
{194, 1110},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{192, 1111},
{192, 1111},
{192, 1111},
{192, 1111},
{192, 1111},
{192, 1111},
{192, 1111},
{0, 0},
{194, 1110},
{194, 1110},
{197, 1112},
{198, 1115},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{197, 1112},
{197, 1112},
{197, 1112},
{197, 1112},
{197, 1112},
{197, 1112},
{197, 1112},
{197, 1112},
{0, 0},
{0, 0},
{194, 188},
{194, 190},
{194, 1110},
{194, 1110},
{194, 1110},
{194, 1110},
{194, 1110},
{194, 1110},
{194, 1110},
{0, 0},
{0, 0},
{0, 0},
{198, 1115},
{0, 0},
{197, 193},
{197, 1112},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{198, 1115},
{198, 1115},
{198, 1115},
{198, 1115},
{198, 1115},
{198, 1115},
{198, 1115},
{198, 1115},
{0, 0},
{0, 0},
{0, 0},
{197, 1112},
{197, 1112},
{0, 0},
{200, 1114},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{198, 1115},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{197, 1112},
{197, 1112},
{197, 1112},
{197, 1112},
{197, 1112},
{197, 1112},
{197, 1112},
{0, 0},
{198, 1115},
{198, 1115},
{200, 1114},
{201, 1117},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{200, 1114},
{200, 1114},
{200, 1114},
{200, 1114},
{200, 1114},
{200, 1114},
{200, 1114},
{200, 1114},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{198, 1115},
{198, 1115},
{198, 1115},
{198, 1115},
{198, 1115},
{0, 0},
{0, 0},
{0, 0},
{201, 1117},
{0, 0},
{0, 0},
{200, 1114},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{201, 1117},
{201, 1117},
{201, 1117},
{201, 1117},
{201, 1117},
{201, 1117},
{201, 1117},
{201, 1117},
{0, 0},
{0, 0},
{0, 0},
{200, 1114},
{200, 1114},
{0, 0},
{203, 1116},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{201, 1117},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{200, 196},
{200, 1114},
{200, 1114},
{200, 1114},
{200, 1114},
{200, 1114},
{200, 1114},
{0, 0},
{201, 1117},
{201, 1117},
{203, 1116},
{204, 1119},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{203, 1116},
{203, 1116},
{203, 1116},
{203, 1116},
{203, 1116},
{203, 1116},
{203, 1116},
{203, 1116},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{201, 1117},
{201, 1117},
{201, 1117},
{201, 1117},
{0, 0},
{0, 0},
{0, 0},
{204, 1119},
{0, 0},
{0, 0},
{203, 1116},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{204, 1119},
{204, 1119},
{204, 1119},
{204, 1119},
{204, 1119},
{204, 1119},
{204, 1119},
{204, 1119},
{0, 0},
{0, 0},
{0, 0},
{203, 1116},
{203, 1116},
{0, 0},
{206, 1118},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{204, 1119},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{203, 199},
{203, 1116},
{203, 1116},
{203, 1116},
{203, 1116},
{203, 1116},
{0, 0},
{204, 1119},
{204, 1119},
{206, 1118},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{206, 1118},
{206, 1118},
{206, 1118},
{206, 1118},
{206, 1118},
{206, 1118},
{206, 1118},
{206, 1118},
{237, 1461},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{204, 205},
{204, 207},
{204, 1119},
{204, 1119},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 1461},
{206, 1118},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 1461},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{206, 1118},
{206, 1118},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 1461},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{206, 202},
{206, 1118},
{206, 1118},
{206, 1118},
{206, 1118},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{269, 1290},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{237, 1461},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{269, 1290},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 1461},
{0, 0},
{0, 0},
{286, 1308},
{269, 1290},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{269, 1290},
{0, 0},
{269, 1290},
{269, 1290},
{269, 1290},
{269, 1290},
{269, 1290},
{269, 1290},
{0, 0},
{286, 1308},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{286, 1308},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{269, 1290},
{0, 0},
{0, 0},
{286, 1308},
{0, 0},
{286, 1308},
{286, 1308},
{286, 1308},
{286, 1308},
{286, 1308},
{286, 1308},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{269, 1290},
{269, 1290},
{0, 0},
{0, 0},
{269, 270},
{269, 1290},
{269, 1290},
{269, 1290},
{269, 1290},
{269, 1290},
{0, 0},
{0, 0},
{286, 1308},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{504, 5},
{269, 1290},
{286, 1308},
{286, 1308},
{0, 0},
{329, 1431},
{286, 287},
{286, 1308},
{286, 1308},
{286, 1308},
{286, 1308},
{286, 1308},
{329, 1431},
{329, 1431},
{329, 1431},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{329, 1431},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{329, 1431},
{329, 1431},
{0, 0},
{286, 1308},
{0, 0},
{329, 1431},
{329, 1431},
{0, 0},
{0, 0},
{329, 1431},
{504, 7},
{0, 0},
{0, 0},
{504, 591},
{504, 21},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{329, 1431},
{0, 0},
{504, 27},
{504, 29},
{504, 594},
{504, 595},
{504, 596},
{504, 597},
{504, 598},
{504, 599},
{504, 600},
{504, 601},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{504, 602},
{504, 603},
{504, 604},
{504, 605},
{504, 606},
{504, 607},
{504, 30},
{504, 32},
{0, 0},
{0, 0},
{0, 0},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{329, 1431},
{351, 1240},
{0, 0},
{351, 1240},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 1240},
{329, 1431},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 1150},
{0, 0},
{0, 0},
{430, 432},
{0, 0},
{351, 1240},
{0, 0},
{0, 0},
{351, 352},
{0, 0},
{430, 567},
{430, 568},
{430, 569},
{351, 1240},
{0, 0},
{351, 1240},
{351, 1240},
{0, 0},
{0, 0},
{430, 570},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{430, 2},
{430, 1149},
{0, 0},
{0, 0},
{0, 0},
{430, 309},
{430, 631},
{0, 0},
{0, 0},
{430, 312},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 1240},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{0, 0},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{351, 1240},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{430, 1277},
{430, 1277},
{430, 1277},
{430, 1277},
{430, 1277},
{430, 1277},
{430, 1277},
{430, 1277},
{430, 1277},
{430, 632},
{430, 633},
{430, 634},
{430, 635},
{351, 1240},
{430, 581},
{430, 582},
{430, 583},
{430, 584},
{430, 585},
{431, 6},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{430, 124},
{0, 0},
{0, 0},
{431, 962},
{0, 0},
{431, 962},
{431, 962},
{431, 962},
{0, 0},
{431, 1422},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{0, 0},
{431, 962},
{0, 0},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{0, 0},
{0, 0},
{431, 962},
{0, 0},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{431, 962},
{440, 1010},
{431, 962},
{0, 0},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{431, 962},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 1010},
{440, 1010},
{0, 0},
{440, 1010},
{440, 1010},
{0, 0},
{0, 0},
{440, 1417},
{0, 0},
{0, 0},
{0, 0},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{440, 1010},
{449, 1461},
{449, 1461},
{561, 1464},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{561, 1464},
{561, 1464},
{561, 1464},
{449, 1461},
{0, 0},
{0, 0},
{0, 0},
{449, 1461},
{0, 0},
{561, 1464},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{561, 1464},
{561, 1464},
{0, 0},
{0, 0},
{449, 1461},
{561, 1464},
{561, 1464},
{0, 0},
{0, 0},
{561, 1464},
{0, 0},
{449, 1461},
{0, 0},
{449, 1461},
{449, 1461},
{0, 0},
{449, 1461},
{449, 1461},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{449, 1461},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{561, 1464},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 1461},
{449, 1461},
{561, 1464},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 1461},
{0, 0},
{449, 1461},
{449, 1461},
{0, 0},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{449, 1461},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{0, 0},
{0, 0},
{0, 0},
{507, 1367},
{0, 0},
{0, 0},
{0, 0},
{507, 1367},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1367},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1367},
{0, 0},
{507, 1367},
{507, 1367},
{0, 0},
{507, 1367},
{507, 1367},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{508, 431},
{508, 572},
{508, 573},
{0, 0},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{508, 721},
{0, 0},
{0, 0},
{0, 0},
{508, 433},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1367},
{0, 0},
{508, 435},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{508, 436},
{560, 1461},
{0, 0},
{508, 437},
{0, 0},
{508, 440},
{0, 0},
{0, 0},
{560, 1461},
{560, 1461},
{560, 1461},
{0, 0},
{0, 0},
{0, 0},
{507, 1367},
{507, 1367},
{0, 0},
{560, 1461},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{560, 1461},
{560, 1461},
{0, 0},
{0, 0},
{0, 0},
{560, 1461},
{560, 1461},
{0, 0},
{0, 0},
{560, 1461},
{507, 1367},
{0, 0},
{507, 1367},
{507, 1367},
{507, 508},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{507, 1367},
{0, 0},
{0, 0},
{0, 0},
{508, 449},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1391},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{560, 1461},
{0, 0},
{0, 0},
{508, 452},
{0, 0},
{508, 454},
{508, 457},
{0, 0},
{508, 461},
{508, 465},
{508, 469},
{508, 470},
{508, 478},
{508, 480},
{508, 481},
{508, 483},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{560, 1461},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
static	unsigned short	yyNComb		[yyNTableMax - yyLastTerminal] = {
331,
564,
738,
25,
739,
0,
0,
230,
792,
738,
25,
742,
738,
25,
740,
122,
741,
36,
37,
38,
760,
761,
308,
137,
744,
47,
871,
759,
52,
58,
750,
8,
129,
143,
306,
792,
738,
25,
743,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
10,
11,
115,
152,
215,
840,
838,
290,
217,
332,
873,
334,
335,
337,
338,
339,
340,
347,
881,
293,
350,
3,
231,
763,
351,
354,
738,
25,
740,
766,
741,
36,
37,
38,
225,
286,
764,
226,
744,
47,
126,
787,
860,
58,
156,
269,
857,
12,
858,
307,
763,
133,
156,
156,
285,
156,
535,
944,
790,
541,
547,
553,
275,
276,
277,
278,
300,
783,
820,
255,
807,
808,
256,
738,
25,
740,
765,
741,
36,
37,
38,
849,
819,
788,
789,
744,
47,
131,
132,
854,
58,
738,
25,
740,
850,
741,
36,
37,
48,
283,
302,
765,
952,
949,
559,
560,
795,
321,
797,
211,
224,
241,
866,
738,
25,
740,
305,
741,
36,
37,
38,
216,
282,
245,
796,
744,
47,
303,
749,
52,
58,
750,
800,
801,
12,
802,
856,
763,
133,
859,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
34,
741,
36,
37,
38,
811,
812,
861,
156,
744,
47,
311,
749,
52,
58,
750,
299,
738,
25,
740,
862,
767,
36,
37,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
323,
741,
36,
37,
38,
874,
879,
294,
880,
744,
47,
295,
759,
52,
58,
750,
324,
156,
768,
158,
847,
787,
837,
842,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
126,
741,
36,
37,
38,
216,
356,
315,
780,
744,
47,
781,
782,
853,
58,
738,
25,
740,
817,
741,
36,
37,
38,
835,
789,
819,
357,
744,
47,
362,
883,
852,
58,
738,
25,
740,
34,
741,
36,
37,
38,
397,
315,
890,
315,
744,
47,
892,
749,
52,
58,
750,
291,
215,
400,
434,
818,
870,
255,
288,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
371,
741,
36,
37,
38,
372,
450,
479,
367,
744,
47,
922,
923,
851,
58,
738,
25,
740,
34,
741,
36,
37,
38,
369,
886,
924,
925,
744,
47,
863,
749,
52,
58,
750,
123,
156,
787,
525,
526,
530,
942,
833,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
367,
741,
36,
37,
38,
316,
864,
353,
864,
744,
47,
882,
762,
52,
58,
750,
885,
359,
532,
363,
834,
789,
935,
255,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
40,
741,
36,
37,
38,
41,
389,
891,
391,
744,
47,
936,
749,
52,
58,
750,
937,
251,
940,
255,
252,
254,
538,
539,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
43,
741,
36,
37,
38,
44,
738,
25,
887,
744,
47,
544,
749,
52,
58,
750,
738,
25,
740,
545,
767,
36,
37,
550,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
46,
741,
36,
37,
38,
394,
891,
391,
529,
744,
47,
938,
749,
52,
58,
750,
551,
768,
158,
771,
531,
306,
792,
941,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
534,
741,
36,
37,
38,
372,
556,
50,
557,
744,
47,
950,
759,
52,
58,
750,
738,
25,
740,
561,
767,
36,
37,
562,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
0,
741,
36,
37,
38,
872,
367,
858,
307,
744,
47,
0,
745,
52,
58,
750,
0,
768,
158,
772,
0,
399,
886,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
43,
741,
36,
37,
38,
54,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
738,
25,
740,
0,
767,
36,
37,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
43,
741,
36,
37,
38,
56,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
768,
158,
773,
527,
0,
528,
939,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
836,
741,
36,
37,
38,
817,
0,
0,
0,
744,
47,
0,
0,
746,
58,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
748,
738,
25,
740,
0,
741,
36,
37,
38,
0,
818,
0,
255,
744,
47,
0,
0,
747,
58,
751,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
752,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
753,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
741,
36,
37,
38,
65,
0,
0,
0,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
741,
36,
37,
38,
67,
0,
0,
0,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
741,
36,
37,
38,
59,
70,
0,
0,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
741,
36,
37,
38,
59,
72,
0,
0,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
741,
36,
37,
38,
59,
63,
75,
0,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
741,
36,
37,
38,
59,
63,
77,
0,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
741,
36,
37,
38,
59,
63,
68,
80,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
741,
36,
37,
38,
59,
63,
68,
82,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
741,
36,
37,
38,
59,
63,
68,
84,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
156,
741,
36,
37,
38,
59,
63,
68,
86,
744,
47,
0,
0,
747,
58,
750,
0,
0,
0,
0,
230,
792,
0,
0,
59,
63,
68,
73,
89,
738,
25,
740,
0,
741,
36,
37,
38,
778,
0,
0,
0,
744,
47,
0,
0,
747,
58,
750,
0,
0,
0,
0,
0,
0,
0,
779,
59,
63,
68,
73,
91,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
750,
780,
0,
0,
781,
782,
0,
0,
231,
59,
63,
68,
73,
78,
94,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
97,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
100,
738,
25,
740,
0,
741,
36,
37,
38,
244,
247,
797,
0,
744,
47,
882,
0,
747,
58,
750,
0,
0,
361,
363,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
103,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
767,
36,
37,
255,
59,
63,
68,
73,
78,
87,
92,
95,
98,
106,
738,
25,
740,
108,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
768,
158,
770,
165,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
750,
738,
25,
740,
0,
767,
36,
37,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
754,
738,
25,
740,
43,
741,
36,
37,
38,
111,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
768,
158,
770,
167,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
43,
741,
36,
37,
38,
113,
0,
230,
792,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
757,
58,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
758,
52,
58,
750,
231,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
119,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
289,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
121,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
240,
243,
797,
144,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
766,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
738,
25,
740,
136,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
846,
58,
0,
145,
0,
153,
0,
0,
262,
263,
0,
783,
820,
255,
807,
808,
256,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
144,
0,
848,
738,
25,
740,
34,
741,
36,
37,
38,
0,
0,
0,
766,
744,
47,
0,
749,
52,
58,
750,
135,
142,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
145,
0,
153,
0,
0,
262,
263,
0,
783,
820,
255,
807,
808,
256,
738,
25,
740,
34,
741,
36,
37,
38,
0,
0,
144,
0,
744,
47,
156,
749,
52,
58,
750,
141,
0,
0,
0,
0,
766,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
810,
156,
0,
212,
0,
0,
0,
0,
0,
0,
0,
783,
0,
0,
145,
0,
153,
0,
0,
262,
263,
0,
783,
820,
255,
807,
808,
256,
0,
784,
738,
25,
740,
0,
767,
36,
37,
0,
778,
813,
255,
807,
808,
256,
0,
738,
25,
740,
0,
767,
36,
37,
0,
213,
780,
0,
845,
781,
782,
0,
0,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
768,
158,
770,
159,
170,
0,
0,
0,
0,
0,
780,
156,
0,
781,
782,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
223,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
778,
0,
844,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
151,
785,
843,
58,
738,
25,
740,
34,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
150,
0,
0,
780,
0,
0,
781,
782,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
144,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
766,
0,
0,
0,
0,
0,
738,
25,
740,
227,
767,
36,
37,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
145,
0,
153,
0,
0,
262,
263,
0,
783,
820,
255,
807,
808,
256,
0,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
210,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
0,
747,
58,
769,
738,
25,
740,
0,
767,
36,
37,
738,
25,
740,
0,
767,
36,
37,
738,
25,
740,
0,
767,
36,
37,
738,
25,
740,
0,
767,
36,
37,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
0,
768,
158,
770,
159,
172,
0,
0,
768,
158,
770,
159,
163,
175,
0,
768,
158,
770,
159,
163,
177,
0,
768,
158,
770,
159,
163,
168,
180,
768,
158,
770,
159,
163,
168,
182,
738,
25,
740,
0,
767,
36,
37,
738,
25,
740,
0,
767,
36,
37,
738,
25,
740,
0,
767,
36,
37,
0,
738,
25,
740,
0,
767,
36,
37,
0,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
768,
158,
770,
159,
163,
168,
184,
768,
158,
770,
159,
163,
168,
186,
768,
158,
770,
159,
163,
168,
173,
189,
768,
158,
770,
159,
163,
168,
173,
191,
768,
158,
770,
159,
163,
168,
173,
178,
194,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
197,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
200,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
203,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
206,
738,
25,
740,
0,
767,
36,
37,
0,
0,
230,
792,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
215,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
208,
156,
777,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
776,
231,
218,
219,
230,
792,
0,
0,
0,
156,
0,
214,
791,
0,
0,
0,
0,
766,
0,
783,
0,
230,
792,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
786,
0,
747,
58,
855,
0,
0,
220,
0,
0,
272,
273,
274,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
780,
0,
0,
781,
782,
0,
0,
0,
279,
231,
841,
787,
0,
0,
0,
0,
803,
156,
0,
0,
0,
230,
792,
240,
243,
797,
231,
251,
0,
0,
252,
254,
738,
25,
740,
0,
767,
36,
37,
0,
0,
230,
792,
0,
804,
0,
0,
292,
230,
792,
0,
0,
0,
805,
789,
806,
255,
807,
808,
256,
0,
793,
0,
235,
0,
230,
792,
0,
0,
0,
0,
783,
825,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
231,
0,
223,
0,
144,
795,
236,
797,
156,
780,
0,
0,
781,
782,
0,
230,
792,
225,
766,
0,
231,
0,
795,
236,
797,
238,
0,
231,
0,
230,
792,
0,
230,
792,
0,
793,
0,
248,
0,
0,
0,
230,
792,
0,
231,
783,
0,
0,
145,
0,
153,
0,
0,
262,
263,
794,
783,
820,
255,
807,
808,
256,
798,
784,
239,
778,
0,
0,
0,
0,
0,
0,
783,
230,
792,
0,
0,
0,
0,
799,
0,
0,
231,
0,
795,
236,
797,
249,
780,
778,
156,
781,
782,
0,
0,
0,
231,
0,
0,
231,
0,
0,
0,
227,
795,
236,
797,
156,
231,
0,
0,
795,
236,
797,
0,
0,
156,
794,
0,
0,
0,
230,
792,
0,
0,
0,
0,
778,
795,
236,
797,
0,
0,
0,
798,
0,
250,
0,
0,
0,
231,
0,
0,
799,
783,
779,
0,
0,
156,
0,
0,
0,
0,
778,
230,
792,
0,
0,
144,
0,
0,
0,
786,
0,
0,
0,
795,
236,
797,
0,
780,
785,
766,
781,
782,
829,
0,
0,
0,
328,
240,
330,
797,
795,
236,
797,
866,
780,
231,
0,
781,
782,
795,
236,
797,
810,
780,
0,
0,
781,
782,
0,
258,
830,
261,
0,
0,
262,
263,
0,
783,
820,
255,
807,
808,
256,
264,
824,
265,
267,
0,
231,
0,
260,
795,
236,
797,
0,
780,
0,
0,
781,
782,
778,
813,
255,
807,
808,
256,
0,
0,
230,
792,
814,
0,
815,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
260,
0,
0,
0,
230,
792,
0,
0,
0,
144,
0,
0,
0,
0,
0,
0,
795,
236,
797,
0,
816,
0,
815,
766,
0,
0,
0,
0,
230,
792,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
809,
795,
236,
797,
231,
258,
0,
261,
0,
0,
262,
263,
0,
783,
820,
255,
807,
808,
256,
0,
821,
265,
267,
231,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
260,
0,
0,
0,
0,
0,
0,
0,
231,
0,
826,
0,
0,
0,
0,
810,
156,
0,
0,
260,
822,
0,
815,
230,
792,
0,
0,
0,
144,
0,
0,
0,
0,
0,
0,
0,
230,
792,
0,
823,
0,
815,
766,
827,
0,
0,
0,
0,
0,
795,
236,
797,
0,
778,
813,
255,
807,
808,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
795,
236,
797,
828,
258,
0,
261,
0,
0,
262,
263,
0,
783,
820,
255,
807,
808,
256,
271,
824,
265,
267,
231,
0,
795,
236,
797,
0,
780,
0,
156,
781,
782,
218,
219,
231,
0,
0,
230,
792,
0,
0,
0,
791,
230,
792,
0,
0,
766,
0,
301,
230,
792,
0,
0,
0,
0,
831,
0,
230,
792,
0,
230,
792,
0,
0,
0,
0,
230,
792,
342,
0,
0,
0,
0,
220,
230,
792,
272,
273,
274,
275,
276,
277,
278,
832,
783,
820,
255,
807,
808,
256,
0,
0,
0,
144,
0,
0,
0,
0,
0,
0,
0,
839,
0,
231,
795,
236,
797,
766,
780,
231,
0,
781,
782,
0,
0,
0,
231,
795,
236,
797,
0,
0,
0,
0,
231,
0,
0,
231,
0,
0,
0,
0,
0,
231,
0,
0,
0,
145,
349,
153,
0,
231,
262,
263,
514,
783,
820,
255,
807,
808,
256,
793,
0,
320,
0,
0,
0,
0,
0,
794,
0,
783,
516,
0,
0,
230,
792,
0,
798,
778,
327,
0,
0,
0,
0,
0,
799,
0,
783,
230,
792,
0,
0,
0,
0,
0,
778,
795,
236,
797,
0,
0,
0,
795,
236,
797,
0,
0,
871,
867,
795,
321,
797,
326,
0,
0,
866,
865,
795,
321,
797,
795,
236,
797,
866,
0,
869,
795,
321,
797,
0,
0,
0,
866,
868,
795,
321,
797,
0,
0,
0,
866,
231,
332,
873,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
0,
231,
763,
351,
354,
0,
0,
0,
766,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
548,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
535,
944,
0,
541,
547,
553,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
884,
549,
795,
321,
797,
0,
0,
0,
866,
0,
0,
0,
948,
949,
559,
560,
795,
321,
797,
738,
25,
740,
866,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
875,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
875,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
0,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
875,
52,
58,
750,
738,
25,
740,
0,
767,
36,
37,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
0,
0,
0,
0,
878,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
392,
0,
0,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
876,
345,
888,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
395,
0,
894,
0,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
877,
0,
0,
0,
0,
380,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
888,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
889,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
384,
767,
36,
37,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
888,
0,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
392,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
388,
767,
36,
37,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
893,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
392,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
420,
0,
0,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
417,
741,
36,
37,
38,
0,
402,
0,
894,
744,
47,
0,
749,
52,
58,
750,
0,
423,
899,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
410,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
418,
419,
895,
896,
897,
738,
25,
740,
413,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
416,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
417,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
738,
25,
740,
0,
767,
36,
37,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
420,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
422,
419,
895,
896,
897,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
0,
0,
230,
792,
0,
0,
0,
0,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
888,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
871,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
231,
427,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
0,
0,
0,
0,
332,
921,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
498,
500,
763,
351,
354,
554,
0,
0,
766,
0,
0,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
455,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
555,
795,
321,
797,
0,
0,
0,
866,
0,
0,
0,
0,
0,
0,
0,
900,
933,
902,
903,
904,
905,
906,
907,
908,
909,
910,
520,
0,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
523,
911,
912,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
900,
932,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
498,
500,
0,
0,
911,
912,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
900,
931,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
911,
912,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
900,
930,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
442,
741,
36,
37,
38,
443,
0,
911,
912,
744,
47,
0,
749,
52,
58,
750,
299,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
43,
741,
36,
37,
38,
445,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
43,
741,
36,
37,
38,
447,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
738,
25,
740,
459,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
871,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
0,
900,
929,
902,
903,
904,
905,
906,
907,
908,
909,
910,
332,
921,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
498,
500,
763,
351,
354,
911,
912,
0,
766,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
900,
926,
902,
903,
904,
905,
906,
907,
908,
909,
910,
517,
519,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
911,
912,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
900,
920,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
498,
500,
0,
0,
911,
912,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
900,
919,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
911,
912,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
900,
507,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
463,
741,
36,
37,
38,
0,
0,
911,
912,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
738,
25,
740,
467,
741,
36,
37,
38,
0,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
900,
917,
902,
903,
904,
905,
906,
907,
908,
909,
910,
230,
792,
0,
0,
0,
0,
0,
498,
500,
0,
0,
0,
0,
0,
0,
0,
0,
911,
912,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
0,
231,
0,
826,
0,
0,
0,
0,
810,
900,
916,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
498,
500,
0,
738,
25,
740,
43,
741,
36,
37,
38,
472,
512,
911,
912,
744,
47,
0,
749,
52,
58,
750,
778,
813,
255,
807,
808,
256,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
795,
236,
797,
0,
0,
0,
0,
900,
502,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
43,
741,
36,
37,
38,
474,
0,
911,
912,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
43,
741,
36,
37,
38,
476,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
738,
25,
740,
43,
741,
36,
37,
38,
484,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
0,
767,
36,
37,
0,
0,
0,
900,
915,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
911,
912,
888,
768,
158,
770,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
774,
0,
0,
888,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
488,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
492,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
900,
914,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
498,
500,
0,
0,
911,
912,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
900,
913,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
911,
912,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
900,
901,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
505,
741,
36,
37,
38,
0,
0,
911,
912,
744,
47,
0,
749,
52,
58,
750,
230,
792,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
871,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
231,
0,
787,
0,
0,
0,
0,
803,
0,
0,
0,
0,
0,
332,
921,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
498,
500,
763,
351,
354,
0,
0,
0,
766,
0,
510,
0,
0,
0,
0,
0,
0,
0,
0,
805,
789,
806,
255,
807,
808,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
0,
0,
0,
0,
0,
0,
795,
236,
797,
230,
792,
0,
0,
0,
0,
900,
918,
902,
903,
904,
905,
906,
907,
908,
909,
910,
540,
0,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
911,
912,
744,
47,
0,
749,
52,
58,
750,
0,
0,
943,
0,
0,
871,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
231,
0,
787,
0,
0,
0,
0,
803,
0,
0,
0,
0,
0,
0,
0,
0,
332,
927,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
498,
500,
763,
351,
354,
0,
0,
536,
766,
0,
0,
0,
0,
0,
0,
0,
805,
789,
806,
255,
807,
808,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
0,
0,
537,
795,
321,
797,
0,
0,
0,
866,
0,
0,
0,
0,
0,
900,
926,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
518,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
911,
912,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
498,
500,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
0,
0,
0,
744,
47,
0,
749,
52,
58,
750,
0,
0,
945,
0,
0,
871,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
0,
0,
0,
0,
0,
0,
0,
0,
900,
928,
902,
903,
904,
905,
906,
907,
908,
909,
910,
332,
927,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
498,
500,
763,
351,
354,
911,
912,
0,
766,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
0,
0,
0,
0,
0,
0,
230,
792,
0,
0,
0,
0,
0,
0,
0,
900,
933,
902,
903,
904,
905,
906,
907,
908,
909,
910,
0,
0,
0,
0,
0,
0,
0,
738,
25,
740,
485,
741,
494,
496,
38,
497,
521,
911,
912,
744,
47,
0,
749,
52,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
755,
756,
231,
0,
826,
0,
0,
0,
0,
810,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
498,
500,
0,
0,
542,
0,
0,
0,
0,
0,
0,
0,
0,
0,
778,
813,
255,
807,
808,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
871,
0,
0,
0,
0,
0,
0,
0,
543,
795,
321,
797,
0,
0,
0,
866,
0,
0,
0,
0,
0,
871,
0,
0,
900,
934,
902,
903,
904,
905,
906,
907,
908,
909,
910,
332,
921,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
0,
0,
763,
351,
354,
911,
912,
0,
766,
332,
921,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
0,
0,
763,
351,
354,
0,
0,
0,
766,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
946,
0,
0,
871,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
0,
0,
871,
0,
0,
546,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
332,
927,
334,
335,
337,
338,
339,
340,
347,
881,
552,
350,
0,
0,
763,
351,
354,
0,
0,
0,
766,
332,
921,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
0,
0,
763,
351,
354,
0,
0,
0,
766,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
947,
0,
0,
871,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
0,
0,
871,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
332,
927,
334,
335,
337,
338,
339,
340,
347,
881,
558,
350,
0,
0,
763,
351,
354,
0,
0,
0,
766,
332,
921,
334,
335,
337,
338,
339,
340,
347,
881,
0,
350,
0,
0,
763,
351,
354,
0,
0,
0,
766,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
951,
0,
0,
871,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
332,
927,
334,
335,
337,
338,
339,
340,
347,
881,
563,
350,
0,
0,
763,
351,
354,
0,
0,
0,
766,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
783,
820,
255,
807,
808,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
};
static	yyTCombType *	yyTBasePtr	[yyLastReadState + 1] = { 0,
& yyTComb [0],
& yyTComb [0],
& yyTComb [4],
& yyTComb [0],
& yyTComb [23],
& yyTComb [0],
& yyTComb [0],
& yyTComb [7],
& yyTComb [0],
& yyTComb [6],
& yyTComb [7],
& yyTComb [8],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [13],
& yyTComb [1],
& yyTComb [16],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [15],
& yyTComb [19],
& yyTComb [16],
& yyTComb [108],
& yyTComb [17],
& yyTComb [0],
& yyTComb [23],
& yyTComb [0],
& yyTComb [23],
& yyTComb [0],
& yyTComb [24],
& yyTComb [0],
& yyTComb [25],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [217],
& yyTComb [25],
& yyTComb [31],
& yyTComb [27],
& yyTComb [33],
& yyTComb [68],
& yyTComb [34],
& yyTComb [0],
& yyTComb [35],
& yyTComb [38],
& yyTComb [326],
& yyTComb [34],
& yyTComb [36],
& yyTComb [0],
& yyTComb [427],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1],
& yyTComb [2],
& yyTComb [0],
& yyTComb [0],
& yyTComb [528],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [613],
& yyTComb [0],
& yyTComb [698],
& yyTComb [0],
& yyTComb [783],
& yyTComb [868],
& yyTComb [0],
& yyTComb [953],
& yyTComb [0],
& yyTComb [1038],
& yyTComb [1123],
& yyTComb [0],
& yyTComb [1172],
& yyTComb [0],
& yyTComb [1257],
& yyTComb [1342],
& yyTComb [0],
& yyTComb [1391],
& yyTComb [0],
& yyTComb [1476],
& yyTComb [0],
& yyTComb [1525],
& yyTComb [0],
& yyTComb [1610],
& yyTComb [1634],
& yyTComb [0],
& yyTComb [1719],
& yyTComb [0],
& yyTComb [1768],
& yyTComb [1853],
& yyTComb [0],
& yyTComb [1879],
& yyTComb [1903],
& yyTComb [0],
& yyTComb [1988],
& yyTComb [2012],
& yyTComb [0],
& yyTComb [2038],
& yyTComb [2123],
& yyTComb [0],
& yyTComb [2146],
& yyTComb [2172],
& yyTComb [0],
& yyTComb [2231],
& yyTComb [0],
& yyTComb [39],
& yyTComb [0],
& yyTComb [2],
& yyTComb [3],
& yyTComb [0],
& yyTComb [6],
& yyTComb [39],
& yyTComb [0],
& yyTComb [2],
& yyTComb [3],
& yyTComb [0],
& yyTComb [45],
& yyTComb [0],
& yyTComb [44],
& yyTComb [46],
& yyTComb [0],
& yyTComb [5],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [48],
& yyTComb [49],
& yyTComb [7],
& yyTComb [53],
& yyTComb [54],
& yyTComb [1],
& yyTComb [60],
& yyTComb [0],
& yyTComb [0],
& yyTComb [56],
& yyTComb [0],
& yyTComb [59],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [58],
& yyTComb [194],
& yyTComb [230],
& yyTComb [69],
& yyTComb [0],
& yyTComb [65],
& yyTComb [615],
& yyTComb [0],
& yyTComb [0],
& yyTComb [67],
& yyTComb [71],
& yyTComb [224],
& yyTComb [72],
& yyTComb [2336],
& yyTComb [0],
& yyTComb [0],
& yyTComb [2395],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [2475],
& yyTComb [0],
& yyTComb [2521],
& yyTComb [0],
& yyTComb [2601],
& yyTComb [2681],
& yyTComb [0],
& yyTComb [2727],
& yyTComb [0],
& yyTComb [2807],
& yyTComb [2887],
& yyTComb [0],
& yyTComb [2917],
& yyTComb [0],
& yyTComb [2997],
& yyTComb [3043],
& yyTComb [0],
& yyTComb [3123],
& yyTComb [0],
& yyTComb [3153],
& yyTComb [0],
& yyTComb [3233],
& yyTComb [0],
& yyTComb [3263],
& yyTComb [536],
& yyTComb [0],
& yyTComb [3343],
& yyTComb [0],
& yyTComb [3373],
& yyTComb [3453],
& yyTComb [0],
& yyTComb [3483],
& yyTComb [1303],
& yyTComb [0],
& yyTComb [3534],
& yyTComb [3564],
& yyTComb [0],
& yyTComb [3615],
& yyTComb [3645],
& yyTComb [0],
& yyTComb [3696],
& yyTComb [3726],
& yyTComb [0],
& yyTComb [3777],
& yyTComb [74],
& yyTComb [75],
& yyTComb [879],
& yyTComb [81],
& yyTComb [89],
& yyTComb [86],
& yyTComb [206],
& yyTComb [89],
& yyTComb [1396],
& yyTComb [1773],
& yyTComb [258],
& yyTComb [435],
& yyTComb [770],
& yyTComb [621],
& yyTComb [8],
& yyTComb [94],
& yyTComb [96],
& yyTComb [97],
& yyTComb [98],
& yyTComb [102],
& yyTComb [104],
& yyTComb [262],
& yyTComb [133],
& yyTComb [7],
& yyTComb [143],
& yyTComb [0],
& yyTComb [0],
& yyTComb [134],
& yyTComb [0],
& yyTComb [137],
& yyTComb [3820],
& yyTComb [153],
& yyTComb [0],
& yyTComb [0],
& yyTComb [139],
& yyTComb [351],
& yyTComb [140],
& yyTComb [142],
& yyTComb [143],
& yyTComb [0],
& yyTComb [229],
& yyTComb [150],
& yyTComb [211],
& yyTComb [241],
& yyTComb [153],
& yyTComb [199],
& yyTComb [246],
& yyTComb [201],
& yyTComb [326],
& yyTComb [167],
& yyTComb [0],
& yyTComb [744],
& yyTComb [0],
& yyTComb [257],
& yyTComb [0],
& yyTComb [3136],
& yyTComb [893],
& yyTComb [145],
& yyTComb [252],
& yyTComb [0],
& yyTComb [253],
& yyTComb [211],
& yyTComb [3902],
& yyTComb [0],
& yyTComb [151],
& yyTComb [409],
& yyTComb [262],
& yyTComb [638],
& yyTComb [3246],
& yyTComb [1000],
& yyTComb [1110],
& yyTComb [1198],
& yyTComb [222],
& yyTComb [156],
& yyTComb [0],
& yyTComb [229],
& yyTComb [185],
& yyTComb [0],
& yyTComb [365],
& yyTComb [3930],
& yyTComb [0],
& yyTComb [306],
& yyTComb [0],
& yyTComb [255],
& yyTComb [0],
& yyTComb [0],
& yyTComb [298],
& yyTComb [304],
& yyTComb [307],
& yyTComb [7],
& yyTComb [312],
& yyTComb [309],
& yyTComb [1177],
& yyTComb [1530],
& yyTComb [310],
& yyTComb [312],
& yyTComb [318],
& yyTComb [0],
& yyTComb [369],
& yyTComb [0],
& yyTComb [0],
& yyTComb [367],
& yyTComb [0],
& yyTComb [404],
& yyTComb [9],
& yyTComb [0],
& yyTComb [10],
& yyTComb [318],
& yyTComb [0],
& yyTComb [286],
& yyTComb [0],
& yyTComb [0],
& yyTComb [370],
& yyTComb [0],
& yyTComb [452],
& yyTComb [12],
& yyTComb [13],
& yyTComb [411],
& yyTComb [14],
& yyTComb [426],
& yyTComb [0],
& yyTComb [412],
& yyTComb [4009],
& yyTComb [418],
& yyTComb [0],
& yyTComb [451],
& yyTComb [0],
& yyTComb [356],
& yyTComb [454],
& yyTComb [14],
& yyTComb [358],
& yyTComb [1680],
& yyTComb [829],
& yyTComb [467],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [382],
& yyTComb [445],
& yyTComb [360],
& yyTComb [511],
& yyTComb [0],
& yyTComb [0],
& yyTComb [441],
& yyTComb [4097],
& yyTComb [0],
& yyTComb [540],
& yyTComb [4],
& yyTComb [0],
& yyTComb [385],
& yyTComb [471],
& yyTComb [530],
& yyTComb [440],
& yyTComb [0],
& yyTComb [442],
& yyTComb [660],
& yyTComb [0],
& yyTComb [414],
& yyTComb [0],
& yyTComb [0],
& yyTComb [398],
& yyTComb [0],
& yyTComb [542],
& yyTComb [0],
& yyTComb [401],
& yyTComb [484],
& yyTComb [428],
& yyTComb [0],
& yyTComb [469],
& yyTComb [0],
& yyTComb [451],
& yyTComb [768],
& yyTComb [0],
& yyTComb [476],
& yyTComb [536],
& yyTComb [517],
& yyTComb [0],
& yyTComb [517],
& yyTComb [0],
& yyTComb [525],
& yyTComb [0],
& yyTComb [526],
& yyTComb [462],
& yyTComb [0],
& yyTComb [531],
& yyTComb [541],
& yyTComb [1],
& yyTComb [552],
& yyTComb [479],
& yyTComb [482],
& yyTComb [554],
& yyTComb [0],
& yyTComb [554],
& yyTComb [526],
& yyTComb [486],
& yyTComb [504],
& yyTComb [506],
& yyTComb [530],
& yyTComb [490],
& yyTComb [609],
& yyTComb [0],
& yyTComb [591],
& yyTComb [0],
& yyTComb [637],
& yyTComb [834],
& yyTComb [0],
& yyTComb [730],
& yyTComb [894],
& yyTComb [0],
& yyTComb [747],
& yyTComb [809],
& yyTComb [561],
& yyTComb [916],
& yyTComb [625],
& yyTComb [1094],
& yyTComb [564],
& yyTComb [566],
& yyTComb [576],
& yyTComb [661],
& yyTComb [0],
& yyTComb [661],
& yyTComb [598],
& yyTComb [639],
& yyTComb [4122],
& yyTComb [4195],
& yyTComb [0],
& yyTComb [686],
& yyTComb [0],
& yyTComb [0],
& yyTComb [684],
& yyTComb [16],
& yyTComb [687],
& yyTComb [683],
& yyTComb [4316],
& yyTComb [622],
& yyTComb [624],
& yyTComb [625],
& yyTComb [0],
& yyTComb [627],
& yyTComb [0],
& yyTComb [695],
& yyTComb [0],
& yyTComb [4385],
& yyTComb [743],
& yyTComb [2217],
& yyTComb [695],
& yyTComb [0],
& yyTComb [0],
& yyTComb [700],
& yyTComb [0],
& yyTComb [707],
& yyTComb [0],
& yyTComb [706],
& yyTComb [0],
& yyTComb [710],
& yyTComb [0],
& yyTComb [709],
& yyTComb [0],
& yyTComb [713],
& yyTComb [0],
& yyTComb [712],
& yyTComb [0],
& yyTComb [0],
& yyTComb [715],
& yyTComb [0],
& yyTComb [652],
& yyTComb [0],
& yyTComb [659],
& yyTComb [723],
& yyTComb [724],
& yyTComb [0],
& yyTComb [836],
& yyTComb [662],
& yyTComb [673],
& yyTComb [681],
& yyTComb [674],
& yyTComb [677],
& yyTComb [710],
& yyTComb [789],
& yyTComb [780],
& yyTComb [0],
& yyTComb [784],
& yyTComb [787],
& yyTComb [786],
& yyTComb [914],
& yyTComb [810],
& yyTComb [722],
& yyTComb [785],
& yyTComb [0],
& yyTComb [797],
& yyTComb [748],
& yyTComb [811],
& yyTComb [0],
& yyTComb [812],
& yyTComb [0],
& yyTComb [728],
& yyTComb [818],
& yyTComb [4006],
& yyTComb [818],
& yyTComb [756],
& yyTComb [4521],
& yyTComb [4578],
& yyTComb [891],
& yyTComb [0],
& yyTComb [14],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [936],
& yyTComb [901],
& yyTComb [756],
& yyTComb [757],
& yyTComb [759],
& yyTComb [0],
& yyTComb [764],
& yyTComb [790],
& yyTComb [791],
& yyTComb [794],
& yyTComb [794],
& yyTComb [881],
& yyTComb [801],
& yyTComb [806],
& yyTComb [807],
& yyTComb [914],
& yyTComb [909],
& yyTComb [966],
& yyTComb [4],
& yyTComb [809],
& yyTComb [1026],
& yyTComb [861],
& yyTComb [863],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [20],
& yyTComb [865],
& yyTComb [866],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [869],
& yyTComb [870],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1030],
& yyTComb [877],
& yyTComb [910],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [911],
& yyTComb [4611],
& yyTComb [4385],
& yyTComb [1094],
& yyTComb [915],
& yyTComb [30],
};
static	unsigned short*	yyNBasePtr	[yyLastReadState + 1] = { 0,
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-128],
& yyNComb [-138],
& yyNComb [-62],
& yyNComb [-131],
& yyNComb [-138],
& yyNComb [-111],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-111],
& yyNComb [-127],
& yyNComb [-138],
& yyNComb [25],
& yyNComb [-138],
& yyNComb [-127],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [65],
& yyNComb [65],
& yyNComb [-127],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [105],
& yyNComb [-15],
& yyNComb [65],
& yyNComb [145],
& yyNComb [163],
& yyNComb [181],
& yyNComb [221],
& yyNComb [239],
& yyNComb [-138],
& yyNComb [279],
& yyNComb [-131],
& yyNComb [-104],
& yyNComb [-131],
& yyNComb [319],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [359],
& yyNComb [-138],
& yyNComb [-134],
& yyNComb [399],
& yyNComb [-138],
& yyNComb [3],
& yyNComb [-131],
& yyNComb [439],
& yyNComb [-138],
& yyNComb [479],
& yyNComb [-126],
& yyNComb [519],
& yyNComb [-138],
& yyNComb [559],
& yyNComb [-138],
& yyNComb [599],
& yyNComb [617],
& yyNComb [-138],
& yyNComb [636],
& yyNComb [655],
& yyNComb [674],
& yyNComb [-138],
& yyNComb [693],
& yyNComb [-138],
& yyNComb [712],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [731],
& yyNComb [-138],
& yyNComb [750],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [769],
& yyNComb [-138],
& yyNComb [788],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [807],
& yyNComb [-138],
& yyNComb [826],
& yyNComb [-138],
& yyNComb [845],
& yyNComb [-138],
& yyNComb [864],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [883],
& yyNComb [-138],
& yyNComb [915],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [947],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [980],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1014],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1049],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1085],
& yyNComb [-138],
& yyNComb [1122],
& yyNComb [-138],
& yyNComb [1162],
& yyNComb [1201],
& yyNComb [-138],
& yyNComb [1241],
& yyNComb [-138],
& yyNComb [1281],
& yyNComb [1299],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1339],
& yyNComb [-138],
& yyNComb [1379],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1340],
& yyNComb [-124],
& yyNComb [-119],
& yyNComb [-138],
& yyNComb [1422],
& yyNComb [-130],
& yyNComb [-138],
& yyNComb [-24],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-125],
& yyNComb [1481],
& yyNComb [1413],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [85],
& yyNComb [1430],
& yyNComb [1536],
& yyNComb [1481],
& yyNComb [-128],
& yyNComb [-138],
& yyNComb [-129],
& yyNComb [1497],
& yyNComb [1621],
& yyNComb [1639],
& yyNComb [1698],
& yyNComb [1716],
& yyNComb [1692],
& yyNComb [-106],
& yyNComb [-138],
& yyNComb [-4],
& yyNComb [179],
& yyNComb [1470],
& yyNComb [-138],
& yyNComb [1777],
& yyNComb [1836],
& yyNComb [-138],
& yyNComb [378],
& yyNComb [458],
& yyNComb [538],
& yyNComb [-138],
& yyNComb [1104],
& yyNComb [-138],
& yyNComb [1181],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1606],
& yyNComb [-138],
& yyNComb [1855],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1862],
& yyNComb [-138],
& yyNComb [1869],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1876],
& yyNComb [-138],
& yyNComb [1883],
& yyNComb [-138],
& yyNComb [1931],
& yyNComb [-138],
& yyNComb [1938],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1945],
& yyNComb [-138],
& yyNComb [1953],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [1961],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [2011],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [2021],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [2032],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [2044],
& yyNComb [-138],
& yyNComb [2098],
& yyNComb [-138],
& yyNComb [2116],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [806],
& yyNComb [2075],
& yyNComb [1578],
& yyNComb [-132],
& yyNComb [-99],
& yyNComb [2111],
& yyNComb [-121],
& yyNComb [-104],
& yyNComb [2172],
& yyNComb [2267],
& yyNComb [-138],
& yyNComb [-137],
& yyNComb [-138],
& yyNComb [-122],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [2102],
& yyNComb [2251],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [901],
& yyNComb [1246],
& yyNComb [2189],
& yyNComb [2271],
& yyNComb [-124],
& yyNComb [-106],
& yyNComb [2278],
& yyNComb [2295],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-116],
& yyNComb [-124],
& yyNComb [-126],
& yyNComb [-138],
& yyNComb [-115],
& yyNComb [-124],
& yyNComb [2333],
& yyNComb [2350],
& yyNComb [2359],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-113],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-114],
& yyNComb [2416],
& yyNComb [2439],
& yyNComb [2569],
& yyNComb [-55],
& yyNComb [2472],
& yyNComb [87],
& yyNComb [-123],
& yyNComb [2523],
& yyNComb [-138],
& yyNComb [2559],
& yyNComb [-138],
& yyNComb [2578],
& yyNComb [-138],
& yyNComb [2629],
& yyNComb [2523],
& yyNComb [2602],
& yyNComb [2391],
& yyNComb [2684],
& yyNComb [186],
& yyNComb [55],
& yyNComb [528],
& yyNComb [56],
& yyNComb [-104],
& yyNComb [2703],
& yyNComb [-103],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-105],
& yyNComb [-125],
& yyNComb [-138],
& yyNComb [77],
& yyNComb [-138],
& yyNComb [-102],
& yyNComb [-138],
& yyNComb [2262],
& yyNComb [-90],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-47],
& yyNComb [2764],
& yyNComb [-9],
& yyNComb [13],
& yyNComb [-138],
& yyNComb [2196],
& yyNComb [-138],
& yyNComb [-23],
& yyNComb [-20],
& yyNComb [-138],
& yyNComb [-29],
& yyNComb [-26],
& yyNComb [-138],
& yyNComb [185],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [17],
& yyNComb [-138],
& yyNComb [150],
& yyNComb [2347],
& yyNComb [2780],
& yyNComb [2788],
& yyNComb [-124],
& yyNComb [86],
& yyNComb [-12],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [2797],
& yyNComb [2805],
& yyNComb [-138],
& yyNComb [45],
& yyNComb [-124],
& yyNComb [2910],
& yyNComb [-138],
& yyNComb [418],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [9],
& yyNComb [-138],
& yyNComb [-121],
& yyNComb [-104],
& yyNComb [-138],
& yyNComb [2697],
& yyNComb [6],
& yyNComb [3069],
& yyNComb [3109],
& yyNComb [-138],
& yyNComb [3149],
& yyNComb [-138],
& yyNComb [2767],
& yyNComb [8],
& yyNComb [-111],
& yyNComb [-125],
& yyNComb [187],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [83],
& yyNComb [152],
& yyNComb [-138],
& yyNComb [222],
& yyNComb [-138],
& yyNComb [992],
& yyNComb [97],
& yyNComb [-138],
& yyNComb [107],
& yyNComb [-138],
& yyNComb [148],
& yyNComb [161],
& yyNComb [-138],
& yyNComb [2992],
& yyNComb [-138],
& yyNComb [211],
& yyNComb [-138],
& yyNComb [179],
& yyNComb [167],
& yyNComb [3168],
& yyNComb [-138],
& yyNComb [230],
& yyNComb [-138],
& yyNComb [368],
& yyNComb [3190],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [3251],
& yyNComb [-138],
& yyNComb [3269],
& yyNComb [-138],
& yyNComb [3328],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [92],
& yyNComb [96],
& yyNComb [-138],
& yyNComb [309],
& yyNComb [-138],
& yyNComb [3349],
& yyNComb [-138],
& yyNComb [106],
& yyNComb [417],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [3408],
& yyNComb [3349],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [3426],
& yyNComb [-138],
& yyNComb [3494],
& yyNComb [-138],
& yyNComb [3534],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [3589],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [3629],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [3669],
& yyNComb [-138],
& yyNComb [3688],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [3747],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [3806],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [198],
& yyNComb [3963],
& yyNComb [4009],
& yyNComb [4055],
& yyNComb [-127],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [4212],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [4252],
& yyNComb [-138],
& yyNComb [4292],
& yyNComb [-138],
& yyNComb [4332],
& yyNComb [208],
& yyNComb [4423],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [4580],
& yyNComb [3849],
& yyNComb [-138],
& yyNComb [4626],
& yyNComb [-138],
& yyNComb [4378],
& yyNComb [-138],
& yyNComb [4672],
& yyNComb [-138],
& yyNComb [4829],
& yyNComb [-138],
& yyNComb [4869],
& yyNComb [-138],
& yyNComb [4915],
& yyNComb [-138],
& yyNComb [4955],
& yyNComb [5038],
& yyNComb [-138],
& yyNComb [5112],
& yyNComb [-138],
& yyNComb [5195],
& yyNComb [-138],
& yyNComb [5235],
& yyNComb [-138],
& yyNComb [5275],
& yyNComb [160],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [5321],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [5386],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [5404],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-131],
& yyNComb [5463],
& yyNComb [-104],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [5509],
& yyNComb [-138],
& yyNComb [5555],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [5712],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [-138],
& yyNComb [5752],
& yyNComb [5726],
& yyNComb [127],
& yyNComb [5014],
& yyNComb [128],
& yyNComb [2773],
& yyNComb [141],
& yyNComb [2791],
& yyNComb [142],
& yyNComb [5909],
& yyNComb [6066],
& yyNComb [6066],
& yyNComb [6157],
& yyNComb [6314],
& yyNComb [-138],
& yyNComb [6314],
& yyNComb [-138],
& yyNComb [219],
& yyNComb [500],
& yyNComb [248],
& yyNComb [328],
& yyNComb [253],
& yyNComb [340],
& yyNComb [255],
& yyNComb [97],
& yyNComb [366],
& yyNComb [-138],
& yyNComb [5880],
& yyNComb [127],
& yyNComb [322],
& yyNComb [326],
& yyNComb [5752],
& yyNComb [5909],
& yyNComb [6282],
& yyNComb [128],
& yyNComb [351],
& yyNComb [362],
& yyNComb [6405],
& yyNComb [6157],
& yyNComb [2896],
& yyNComb [141],
& yyNComb [363],
& yyNComb [399],
& yyNComb [6426],
& yyNComb [6507],
& yyNComb [3775],
& yyNComb [142],
& yyNComb [426],
& yyNComb [431],
& yyNComb [6528],
& yyNComb [6609],
& yyNComb [312],
& yyNComb [439],
& yyNComb [446],
& yyNComb [6630],
& yyNComb [6711],
& yyNComb [-138],
};
static	unsigned short	yyDefault	[yyLastReadState + 1] = { 0,
562,
478,
0,
504,
431,
114,
128,
0,
130,
0,
0,
350,
437,
314,
504,
0,
437,
0,
378,
504,
149,
437,
0,
378,
0,
504,
114,
504,
114,
504,
149,
504,
149,
505,
504,
378,
378,
48,
504,
305,
0,
39,
40,
0,
504,
305,
378,
0,
504,
308,
504,
0,
55,
0,
504,
0,
114,
504,
67,
504,
504,
504,
72,
504,
67,
504,
0,
77,
504,
72,
504,
0,
86,
504,
77,
504,
0,
91,
504,
86,
504,
86,
504,
86,
504,
0,
94,
504,
91,
504,
0,
97,
504,
0,
100,
504,
0,
103,
504,
0,
106,
504,
0,
0,
504,
0,
504,
0,
504,
504,
0,
504,
0,
504,
504,
0,
0,
504,
0,
504,
0,
0,
300,
478,
478,
285,
491,
0,
0,
133,
0,
0,
0,
149,
300,
301,
0,
491,
504,
149,
300,
301,
0,
326,
300,
491,
491,
504,
28,
300,
301,
0,
247,
237,
213,
0,
491,
504,
167,
491,
491,
491,
172,
491,
167,
491,
0,
177,
491,
172,
491,
0,
186,
491,
177,
491,
0,
191,
491,
186,
491,
186,
491,
186,
491,
0,
194,
491,
191,
491,
0,
197,
491,
0,
200,
491,
0,
203,
491,
0,
206,
491,
0,
0,
491,
0,
491,
0,
491,
223,
0,
213,
153,
213,
0,
0,
300,
276,
276,
535,
146,
0,
0,
0,
478,
0,
0,
154,
249,
0,
0,
515,
515,
238,
238,
247,
0,
326,
238,
244,
0,
247,
247,
0,
0,
247,
0,
249,
274,
249,
0,
0,
247,
0,
0,
478,
300,
300,
491,
0,
268,
326,
326,
300,
0,
268,
0,
515,
0,
300,
300,
220,
274,
553,
276,
326,
275,
276,
301,
217,
301,
0,
288,
478,
0,
0,
478,
0,
301,
0,
300,
301,
0,
308,
0,
0,
0,
0,
0,
0,
0,
0,
0,
504,
0,
478,
478,
0,
336,
0,
0,
433,
0,
0,
478,
353,
433,
553,
326,
326,
330,
237,
215,
0,
0,
553,
326,
0,
247,
243,
1,
0,
350,
0,
0,
0,
0,
326,
338,
0,
515,
516,
344,
504,
0,
344,
0,
515,
516,
478,
133,
433,
0,
0,
478,
128,
0,
478,
0,
358,
532,
0,
478,
0,
533,
478,
0,
491,
0,
478,
0,
526,
128,
401,
0,
393,
0,
0,
491,
492,
0,
0,
491,
492,
491,
0,
491,
492,
394,
391,
0,
0,
391,
0,
401,
0,
0,
478,
0,
0,
491,
401,
0,
0,
491,
0,
421,
0,
504,
417,
0,
504,
417,
0,
504,
417,
0,
0,
0,
0,
504,
0,
405,
0,
0,
491,
492,
0,
0,
508,
0,
451,
0,
508,
508,
508,
133,
0,
378,
0,
149,
34,
0,
483,
0,
475,
0,
508,
560,
430,
0,
0,
508,
491,
0,
508,
0,
504,
505,
508,
0,
504,
505,
508,
0,
504,
505,
508,
508,
0,
483,
0,
483,
0,
504,
0,
508,
0,
0,
0,
0,
0,
504,
0,
0,
0,
491,
492,
0,
0,
47,
0,
0,
378,
508,
378,
0,
0,
508,
0,
508,
0,
0,
47,
0,
0,
0,
483,
535,
516,
509,
516,
515,
516,
553,
0,
450,
508,
508,
430,
508,
0,
508,
0,
531,
530,
531,
530,
531,
531,
0,
0,
0,
0,
217,
516,
560,
561,
562,
563,
535,
516,
560,
561,
562,
563,
553,
516,
560,
561,
562,
563,
0,
516,
560,
561,
562,
563,
0,
0,
0,
217,
562,
0,
};
static	unsigned char	yyLength	[yyLastReduceState - yyFirstReduceState + 1] = {
2,
1,
1,
1,
1,
1,
1,
1,
2,
1,
1,
1,
3,
1,
2,
2,
4,
1,
2,
4,
7,
3,
4,
3,
3,
2,
2,
2,
4,
4,
1,
5,
8,
0,
1,
1,
3,
1,
2,
2,
2,
2,
2,
2,
6,
6,
3,
3,
5,
5,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
8,
1,
3,
3,
3,
1,
3,
3,
1,
3,
3,
1,
3,
3,
1,
3,
3,
3,
3,
1,
3,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
5,
7,
7,
1,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
3,
0,
1,
1,
2,
2,
2,
6,
6,
5,
5,
1,
1,
1,
1,
1,
6,
1,
3,
3,
3,
1,
3,
3,
1,
3,
3,
1,
3,
3,
1,
3,
3,
3,
3,
1,
3,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
5,
0,
1,
1,
0,
1,
2,
2,
2,
2,
2,
2,
2,
2,
1,
1,
1,
1,
3,
2,
1,
2,
2,
1,
2,
2,
5,
7,
10,
0,
1,
1,
3,
1,
2,
2,
1,
2,
2,
3,
2,
3,
3,
4,
2,
3,
3,
4,
3,
4,
4,
5,
3,
1,
3,
3,
5,
1,
2,
4,
4,
1,
2,
2,
1,
2,
0,
1,
1,
1,
1,
3,
1,
1,
3,
3,
5,
7,
1,
2,
4,
4,
1,
2,
3,
7,
7,
3,
3,
5,
1,
3,
2,
3,
1,
3,
2,
5,
5,
2,
3,
3,
1,
1,
1,
1,
1,
1,
3,
3,
4,
3,
3,
4,
1,
1,
1,
1,
1,
1,
1,
2,
2,
1,
1,
1,
2,
1,
1,
1,
2,
2,
2,
2,
1,
2,
2,
2,
2,
2,
2,
1,
2,
2,
2,
2,
2,
1,
2,
2,
1,
1,
1,
1,
1,
1,
2,
0,
2,
2,
2,
2,
2,
2,
2,
2,
1,
1,
4,
5,
2,
1,
1,
1,
2,
2,
2,
2,
3,
2,
3,
2,
1,
0,
1,
2,
4,
5,
2,
2,
4,
0,
2,
3,
5,
1,
3,
1,
2,
2,
1,
2,
2,
1,
2,
2,
1,
2,
2,
1,
3,
1,
2,
1,
2,
0,
2,
3,
4,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
3,
4,
3,
3,
3,
3,
4,
4,
5,
1,
2,
1,
2,
2,
5,
7,
5,
5,
7,
9,
3,
2,
2,
3,
3,
2,
3,
1,
1,
2,
1,
1,
2,
1,
2,
2,
2,
2,
1,
2,
2,
2,
2,
5,
6,
6,
6,
6,
1,
1,
1,
2,
3,
3,
4,
2,
4,
5,
6,
2,
2,
1,
3,
3,
1,
1,
3,
3,
4,
1,
1,
1,
1,
2,
3,
3,
4,
5,
3,
4,
1,
1,
1,
1,
4,
5,
1,
2,
3,
3,
4,
4,
5,
1,
2,
2,
3,
2,
3,
3,
4,
3,
3,
3,
4,
2,
0,
2,
0,
0,
0,
0,
0,
0,
0,
1,
5,
6,
1,
2,
1,
1,
2,
9,
6,
10,
};
static	yySymbolRange	yyLeftHandSide	[yyLastReduceState - yyFirstReduceState + 1] = {
309,
139,
140,
140,
140,
140,
140,
141,
141,
142,
142,
142,
142,
144,
144,
144,
144,
147,
147,
147,
147,
147,
147,
147,
147,
147,
147,
147,
147,
147,
151,
153,
153,
154,
154,
150,
150,
156,
156,
156,
156,
156,
156,
156,
156,
156,
156,
156,
156,
156,
157,
157,
157,
157,
157,
157,
157,
152,
152,
152,
152,
152,
152,
152,
152,
152,
158,
158,
167,
167,
167,
167,
168,
168,
168,
169,
169,
169,
170,
170,
170,
171,
171,
171,
171,
171,
172,
172,
172,
173,
173,
174,
174,
175,
175,
176,
176,
177,
177,
178,
178,
179,
179,
155,
155,
155,
180,
180,
180,
180,
180,
180,
180,
180,
180,
180,
180,
143,
143,
148,
148,
181,
181,
181,
181,
181,
181,
181,
181,
182,
182,
182,
182,
183,
183,
184,
184,
184,
184,
185,
185,
185,
186,
186,
186,
187,
187,
187,
188,
188,
188,
188,
188,
189,
189,
189,
190,
190,
191,
191,
192,
192,
193,
193,
194,
194,
195,
195,
197,
197,
198,
196,
196,
200,
200,
200,
200,
200,
200,
200,
200,
200,
200,
200,
199,
199,
164,
209,
209,
209,
210,
210,
213,
213,
203,
203,
215,
215,
217,
217,
218,
218,
218,
216,
216,
216,
216,
216,
216,
216,
216,
216,
216,
216,
216,
216,
216,
216,
216,
221,
226,
226,
227,
223,
228,
228,
229,
229,
230,
230,
230,
230,
230,
231,
231,
231,
231,
232,
232,
232,
233,
233,
234,
224,
224,
235,
235,
237,
237,
238,
238,
238,
239,
239,
236,
240,
222,
241,
241,
201,
201,
242,
242,
243,
145,
145,
202,
202,
244,
245,
245,
245,
245,
245,
245,
207,
207,
207,
206,
206,
206,
250,
250,
250,
251,
251,
251,
246,
246,
246,
256,
256,
249,
249,
257,
257,
257,
252,
252,
252,
252,
254,
254,
254,
254,
204,
204,
204,
205,
205,
205,
253,
253,
253,
255,
255,
255,
214,
214,
214,
214,
214,
214,
219,
259,
219,
219,
219,
219,
219,
219,
219,
219,
258,
258,
260,
260,
260,
262,
262,
263,
263,
264,
264,
266,
266,
265,
265,
267,
267,
268,
268,
269,
261,
261,
261,
270,
270,
271,
271,
273,
273,
272,
272,
274,
274,
274,
274,
274,
274,
274,
274,
274,
274,
274,
274,
276,
276,
160,
160,
160,
160,
248,
248,
277,
277,
277,
278,
278,
208,
280,
280,
280,
280,
280,
280,
280,
280,
280,
280,
279,
279,
279,
279,
279,
281,
281,
281,
281,
290,
290,
291,
291,
282,
283,
283,
283,
284,
284,
284,
285,
285,
285,
285,
285,
286,
287,
288,
138,
138,
292,
292,
293,
294,
294,
294,
294,
294,
294,
294,
294,
294,
294,
294,
294,
294,
294,
294,
247,
247,
296,
296,
296,
296,
296,
298,
298,
298,
298,
297,
297,
297,
297,
212,
212,
212,
146,
146,
146,
211,
211,
211,
295,
295,
295,
295,
295,
302,
302,
302,
275,
275,
275,
300,
300,
300,
220,
220,
220,
220,
220,
220,
220,
303,
303,
303,
303,
303,
303,
303,
303,
304,
304,
304,
304,
299,
149,
149,
162,
305,
301,
159,
161,
165,
166,
163,
225,
225,
306,
306,
289,
289,
289,
289,
307,
308,
};
static	yySymbolRange	yyContinuation	[yyLastReadState + 1] = { 0,
12,
1,
1,
1,
1,
1,
41,
41,
24,
43,
43,
43,
20,
39,
1,
39,
2,
39,
1,
1,
1,
2,
39,
1,
1,
43,
1,
1,
1,
1,
1,
1,
1,
43,
1,
1,
1,
1,
1,
39,
44,
39,
39,
39,
1,
39,
1,
1,
43,
43,
1,
23,
122,
122,
122,
122,
1,
1,
23,
1,
1,
1,
23,
1,
23,
1,
23,
23,
1,
23,
1,
23,
23,
1,
23,
1,
23,
23,
1,
23,
1,
23,
1,
23,
1,
23,
23,
1,
23,
1,
23,
23,
1,
23,
23,
1,
23,
23,
1,
23,
23,
1,
23,
23,
1,
23,
1,
44,
1,
123,
123,
121,
121,
1,
1,
1,
1,
1,
59,
1,
61,
39,
70,
1,
1,
42,
1,
41,
41,
24,
43,
43,
24,
1,
70,
43,
43,
1,
1,
1,
70,
43,
43,
1,
70,
39,
1,
1,
1,
70,
43,
43,
43,
3,
43,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
44,
44,
30,
39,
39,
43,
43,
43,
3,
43,
84,
1,
1,
42,
39,
39,
39,
39,
39,
39,
39,
3,
42,
1,
1,
1,
1,
1,
1,
42,
3,
1,
1,
43,
43,
42,
43,
43,
43,
45,
45,
42,
42,
42,
43,
43,
42,
43,
70,
1,
70,
70,
1,
42,
1,
1,
1,
107,
106,
1,
106,
1,
1,
70,
107,
84,
42,
42,
1,
1,
1,
1,
43,
84,
43,
43,
107,
1,
42,
1,
1,
107,
43,
43,
70,
43,
43,
43,
43,
2,
39,
43,
3,
70,
43,
43,
43,
1,
39,
1,
1,
43,
2,
99,
2,
38,
2,
44,
1,
106,
38,
1,
1,
1,
42,
1,
3,
43,
1,
1,
1,
43,
3,
43,
0,
106,
1,
106,
106,
2,
106,
1,
106,
106,
1,
42,
1,
1,
107,
1,
106,
1,
42,
1,
1,
38,
106,
25,
1,
41,
83,
1,
43,
1,
42,
42,
1,
83,
15,
1,
109,
1,
106,
1,
107,
107,
83,
1,
44,
38,
63,
1,
1,
39,
47,
38,
1,
39,
1,
38,
1,
39,
106,
38,
38,
44,
38,
106,
107,
106,
41,
1,
43,
83,
1,
107,
106,
83,
1,
44,
23,
63,
1,
23,
23,
1,
23,
23,
1,
23,
23,
106,
106,
44,
23,
106,
107,
106,
38,
1,
39,
106,
83,
106,
38,
44,
38,
106,
106,
106,
2,
39,
1,
1,
1,
43,
106,
106,
106,
43,
43,
106,
1,
107,
1,
44,
106,
1,
44,
106,
41,
1,
43,
106,
41,
1,
43,
106,
41,
1,
43,
106,
106,
41,
106,
106,
106,
106,
43,
43,
106,
1,
106,
106,
106,
106,
106,
106,
106,
38,
1,
39,
106,
38,
1,
39,
106,
1,
106,
1,
106,
44,
106,
44,
106,
130,
41,
1,
43,
106,
1,
106,
70,
42,
81,
42,
1,
42,
1,
42,
107,
107,
107,
106,
107,
106,
107,
106,
107,
107,
107,
107,
107,
107,
107,
42,
15,
107,
70,
42,
83,
3,
12,
83,
81,
42,
83,
3,
12,
83,
1,
42,
83,
3,
12,
83,
1,
42,
83,
3,
12,
83,
83,
83,
3,
12,
83,
0,
};
static	unsigned short	yyFinalToProd	[yyLastReadReduceState - yyFirstReadReduceState + 1] = {
1414,
1267,
1135,
1136,
1342,
1275,
1422,
1423,
1424,
1000,
955,
956,
957,
958,
959,
960,
1270,
1271,
1272,
1273,
1274,
1001,
1002,
1419,
1218,
962,
1010,
984,
961,
1011,
1012,
1013,
1014,
1015,
1016,
1017,
1018,
1003,
1004,
1005,
1006,
1007,
1008,
972,
974,
1059,
1060,
1061,
1062,
1063,
1064,
1065,
1066,
1067,
1068,
1069,
975,
971,
976,
977,
978,
979,
981,
982,
973,
965,
1249,
1247,
1248,
1291,
1292,
1080,
1081,
1082,
1083,
1084,
1085,
1078,
1268,
1440,
1079,
1439,
1444,
1445,
1437,
1265,
1416,
1442,
1443,
1420,
1421,
1441,
1417,
1413,
1412,
1415,
1456,
1455,
1276,
1278,
1279,
1280,
1281,
1282,
1283,
1284,
1285,
1288,
1295,
1296,
1289,
1438,
1306,
1307,
998,
997,
985,
1217,
1146,
1226,
1224,
1227,
1225,
1222,
1223,
1221,
1329,
1330,
1430,
1126,
1127,
1128,
1129,
1130,
1131,
1338,
1337,
1132,
1133,
1172,
1148,
1205,
1206,
1201,
1200,
1196,
1207,
1197,
1181,
1180,
1182,
1183,
1185,
1179,
1176,
1209,
1380,
1358,
1373,
1374,
1376,
1375,
1377,
1478,
1477,
1366,
1371,
1359,
1361,
1360,
1470,
1469,
1147,
963,
969,
966,
970,
967,
968,
1009,
989,
1054,
1019,
994,
1070,
1021,
1022,
1023,
1024,
1053,
1056,
1058,
1055,
1057,
988,
980,
983,
1071,
1143,
1144,
1263,
1254,
1074,
1086,
1075,
1088,
1089,
1090,
1091,
1123,
1122,
1120,
1125,
1246,
1452,
1435,
1433,
1434,
1245,
1450,
1453,
1451,
1244,
1260,
1243,
1258,
1240,
1418,
1404,
1406,
1401,
1408,
1403,
1405,
1407,
1410,
1411,
1457,
1251,
1322,
1242,
1259,
1286,
1287,
1305,
1255,
1301,
1304,
1262,
1297,
1302,
1299,
1257,
1256,
1269,
1261,
1294,
1300,
1298,
1293,
1321,
1241,
1328,
1327,
1319,
1318,
1325,
1324,
1253,
1252,
1266,
1250,
1264,
1314,
1316,
1313,
1315,
1332,
1077,
1458,
1334,
1076,
1087,
1312,
1309,
1310,
996,
995,
993,
992,
1020,
1142,
1139,
1140,
1141,
999,
1219,
1216,
1215,
1214,
1428,
1425,
1426,
1429,
1427,
1432,
1137,
1138,
1384,
1220,
1339,
1340,
1341,
1336,
1233,
1230,
1134,
1153,
1154,
1175,
1174,
1173,
1208,
1210,
1211,
1204,
1202,
1203,
1199,
1198,
1187,
1188,
1189,
1178,
1177,
1343,
1356,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1473,
1474,
1353,
1357,
1372,
1370,
1369,
1368,
1354,
1355,
1362,
1228,
1229,
1231,
1232,
1364,
1363,
1365,
1476,
1475,
1378,
1379,
1471,
1472,
1165,
1167,
1171,
1170,
1166,
1169,
1168,
1164,
1399,
1386,
1400,
1397,
1398,
1382,
1383,
1385,
1396,
1381,
};

static	void	yyErrorRecovery		ARGS((yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeContinuation	ARGS((yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet));
static	bool	yyIsContinuation	ARGS((yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeRestartPoints	ARGS((yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet));
static	yyStateRange yyNext		ARGS((yyStateRange yyState, yySymbolRange yySymbol));
static	void	BeginmpcPars		();

int mpcPars ()
   {
      register	yyStateRange	yyState		;
      register	long		yyTerminal	;
      register	yyStateRange *	yyStateStackPtr ;
      register	tParsAttribute *yyAttrStackPtr	;
      register	bool		yyIsRepairing	;
		unsigned long	yyStateStackSize= yyInitStackSize;
		unsigned long	yyAttrStackSize = yyInitStackSize;
		yyStateRange *	yyStateStack	;
		tParsAttribute* yyAttributeStack;
		tParsAttribute	yySynAttribute	;	/* synthesized attribute */
      register	yyStateRange *	yyEndOfStack	;
		int		yyErrorCount	= 0;
   
/* line 391 "mpcPars.lalr" */



#define  ErrorMessage	Make_ErrorMessage
#define  ErrorMessageI	Make_ErrorMessageI
#define  Message	Make_Message
#define  MessageI	Make_MessageI

#define EVAL_CONST_SUBEXPR(Tree,Value)  { tPosition pos=Tree->MPC_Expr.Pos; if(EVAL_CONST) {Tree=Make_IntConst(Value);Tree->MPC_Expr.Pos=pos;} }


extern tPosition CurrentPosition;
static bool 	 Opened_PrototypeScope;
static bool 	 Is_PrototypeScope=false;
static bool	 Opened_ParameterScope=false;
static bool	 Inside_topo_param_list=false;
static int	 DynArray_Possible = 0;




      BeginmpcPars ();
      yyState		= yyStartState;
      yyTerminal	= mpcScan_GetToken ();
      MakeArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
      MakeArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
      yyEndOfStack	= & yyStateStack [yyStateStackSize];
      yyStateStackPtr	= yyStateStack;
      yyAttrStackPtr	= yyAttributeStack;
      yyIsRepairing	= false;

   ParseLoop:
      for (;;) {
	 if (yyStateStackPtr >= yyEndOfStack) {
	    int yyyStateStackPtr= yyStateStackPtr - yyStateStack;
	    int yyyAttrStackPtr	= yyAttrStackPtr - yyAttributeStack;
	    ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
	    ExtendArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
	    yyStateStackPtr	= yyStateStack + yyyStateStackPtr;
	    yyAttrStackPtr	= yyAttributeStack + yyyAttrStackPtr;
	    yyEndOfStack	= & yyStateStack [yyStateStackSize];
	 }
	 * yyStateStackPtr = yyState;

   TermTrans:
	 for (;;) {	/* SPEC State = Next (State, Terminal); terminal transition */
	    register yyStateRange * yyTCombPtr;

	    yyTCombPtr = (yyStateRange *) (yyTBasePtr [yyState] + yyTerminal);
	    if (* yyTCombPtr ++ == yyState) { yyState = * yyTCombPtr; break; }
	    if ((yyState = yyDefault [yyState]) != yyNoState) goto TermTrans;

							/* syntax error */
	    if (! yyIsRepairing) {			/* report and recover */
	       yySymbolRange yyyTerminal = yyTerminal;

	       yyErrorCount ++;
	       yyErrorRecovery (& yyyTerminal, yyStateStack, yyStateStackSize, yyStateStackPtr - yyStateStack);
	       yyTerminal = yyyTerminal;
	       yyIsRepairing = true;
	    }
	    yyState = * yyStateStackPtr;
	    for (;;) {
	       if (yyNext (yyState, (yySymbolRange) yyTerminal) == yyNoState) { /* repair */
		  yySymbolRange		yyRepairToken;
		  mpcScan_tScanAttribute	yyRepairAttribute;
	    
		  yyRepairToken = yyContinuation [yyState];
		  yyState = yyNext (yyState, yyRepairToken);
		  if (yyState <= yyLastReadReduceState) {	/* read or read reduce ? */
		     mpcScan_ErrorAttribute ((int) yyRepairToken, & yyRepairAttribute);
		     ErrorMessageI (xxTokenInserted, xxRepair, mpcScan_Attribute.Position,
			xxString, mpcPars_TokenName [yyRepairToken]);
		     if (yyState >= yyFirstFinalState) {	/* avoid second push */
			yyState = yyFinalToProd [yyState - yyFirstReadReduceState];
		     }
		     yyGetAttribute (yyAttrStackPtr ++, yyRepairAttribute);
		     * ++ yyStateStackPtr = yyState;
		  }
		  if (yyState >= yyFirstFinalState) goto Final; /* final state ? */
	       } else {
		  yyState = yyNext (yyState, (yySymbolRange) yyTerminal);
		  goto Final;
	       }
	    }
	 }

   Final:
	 if (yyState >= yyFirstFinalState) {		/* final state ? */
	    if (yyState <= yyLastReadReduceState) {	/* read reduce ? */
	       yyStateStackPtr ++;
	       yyGetAttribute (yyAttrStackPtr ++, mpcScan_Attribute);
	       yyTerminal = mpcScan_GetToken ();
	       yyIsRepairing = false;
	       yyState = yyFinalToProd [yyState - yyFirstReadReduceState];
	    }

	    for (;;) {
	       /* register long yyNonterminal;		   left-hand side */
# define yyNonterminal yyState

switch (yyState) {
case 953: /* _0000_ : prog_start _EndOfFile .*/
  ReleaseArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
  ReleaseArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
  return yyErrorCount;

case 954: /* prog_start : translation_unit .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 139; {
/* line 755 "mpcPars.lalr" */

			  ;
{ 
			    IgnoreAll = false;
			    TreeRoot->MPC_Root.Decls =
					ReverseTree(yyAttrStackPtr [1-1].translation_unit.Tree);
			    TreeRoot->MPC_Root.TotalLines = LinesInFile;
			  ; }
			;

} break;
case 955: /* constant : FLOATINGconstant .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 140; {
/* line 765 "mpcPars.lalr" */

			    yySynAttribute.constant.Tree = mMPC_FloatConst(
					yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, DoubleType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.FLOATINGconstant.SymForm, yyAttrStackPtr [1-1].Scan.FLOATINGconstant.FloatConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.FLOATINGconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_FloatConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.FLOATINGconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = false;

			  yySynAttribute.constant.Value = 0;

			;

} break;
case 956: /* constant : INTEGERconstant .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 140; {
/* line 785 "mpcPars.lalr" */
  
			    yySynAttribute.constant.Tree = mMPC_IntConst(
					yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.INTEGERconstant.SymForm, yyAttrStackPtr [1-1].Scan.INTEGERconstant.IntConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;  
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.INTEGERconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_IntConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.INTEGERconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = true;

			  yySynAttribute.constant.Value  =  yyAttrStackPtr [1-1].Scan.INTEGERconstant.IntConst;

			;

} break;
case 957: /* constant : OCTALconstant .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 140; {
/* line 806 "mpcPars.lalr" */
  
			    yySynAttribute.constant.Tree = mMPC_IntConst(yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.OCTALconstant.SymForm, yyAttrStackPtr [1-1].Scan.OCTALconstant.OctConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;  
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.OCTALconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_IntConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.OCTALconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = true;

			  yySynAttribute.constant.Value  =  yyAttrStackPtr [1-1].Scan.OCTALconstant.OctConst;

			;

} break;
case 958: /* constant : HEXconstant .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 140; {
/* line 825 "mpcPars.lalr" */
  
			    yySynAttribute.constant.Tree = mMPC_IntConst(yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.HEXconstant.SymForm, yyAttrStackPtr [1-1].Scan.HEXconstant.HexConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;  
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.HEXconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_IntConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.HEXconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = true;

			  yySynAttribute.constant.Value  =  yyAttrStackPtr [1-1].Scan.HEXconstant.HexConst;

			;

} break;
case 959: /* constant : CHARACTERconstant .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 140; {
/* line 844 "mpcPars.lalr" */
  
			    yySynAttribute.constant.Tree = mMPC_IntConst(
					yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.CHARACTERconstant.SymForm, yyAttrStackPtr [1-1].Scan.CHARACTERconstant.CharConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;  
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.CHARACTERconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_IntConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.CHARACTERconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = true;

			  yySynAttribute.constant.Value  =  yyAttrStackPtr [1-1].Scan.CHARACTERconstant.CharConst;

			;

} break;
case 960: /* string_literal_list : STRINGliteral .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 141; {
/* line 864 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.string_literal_list.Tree = mMPC_StringLiteral(
					yySynAttribute.string_literal_list.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree ,
					NoTree , NoTree ,
					yyAttrStackPtr [1-1].Scan.STRINGliteral.SymForm, yySynAttribute.string_literal_list.Length=yyAttrStackPtr [1-1].Scan.STRINGliteral.Length,
					tmp , tmp 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.string_literal_list.Tree);
			    yySynAttribute.string_literal_list.Tree->MPC_Expr.BegPos = yySynAttribute.string_literal_list.EndPos = yySynAttribute.string_literal_list.Position;  
			    yySynAttribute.string_literal_list.EndPos.Column += yySynAttribute.string_literal_list.Length - 1 ;  
			    yySynAttribute.string_literal_list.Tree->MPC_Expr.EndPos = yySynAttribute.string_literal_list.EndPos;  
			    yySynAttribute.string_literal_list.Tree->MPC_StringLiteral.Flag.Const = YES;
			  ;

			  yySynAttribute.string_literal_list.Ignore  =  yyAttrStackPtr [1-1].Scan.STRINGliteral.Ignore;

			  yySynAttribute.string_literal_list.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 961: /* string_literal_list : string_literal_list STRINGliteral .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 141; {
/* line 887 "mpcPars.lalr" */
  
			    yySynAttribute.string_literal_list.Tree = mMPC_StringLiteral(
					yySynAttribute.string_literal_list.EndPos = yySynAttribute.string_literal_list.Position = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree ,
					NoTree , NoTree ,
					yyAttrStackPtr [2-1].Scan.STRINGliteral.SymForm, yyAttrStackPtr [2-1].Scan.STRINGliteral.Length,
					yyAttrStackPtr [1-1].string_literal_list.Tree ,
					yyAttrStackPtr [1-1].string_literal_list.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.string_literal_list.Tree);
			    yySynAttribute.string_literal_list.Tree->MPC_StringLiteral.BegPos = yyAttrStackPtr [1-1].string_literal_list.BegPos;  
			    yySynAttribute.string_literal_list.EndPos.Column += yyAttrStackPtr [2-1].Scan.STRINGliteral.Length - 1 ;  
			    yySynAttribute.string_literal_list.Tree->MPC_Expr.EndPos = yySynAttribute.string_literal_list.EndPos;  
			    yySynAttribute.string_literal_list.Tree->MPC_StringLiteral.Flag.Const = YES;
			    yySynAttribute.string_literal_list.Length = yyAttrStackPtr [1-1].string_literal_list.Length+yyAttrStackPtr [2-1].Scan.STRINGliteral.Length;
			  ;

			    yySynAttribute.string_literal_list.Ignore = yyAttrStackPtr [1-1].string_literal_list.Ignore && yyAttrStackPtr [2-1].Scan.STRINGliteral.Ignore;
			  ;

			  yySynAttribute.string_literal_list.BegPos  =  yyAttrStackPtr [1-1].string_literal_list.BegPos;
  
			;

} break;
case 962: /* primary_expression : IDENTIFIER .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 142; {
/* line 911 "mpcPars.lalr" */
  
			    yySynAttribute.primary_expression.Tree = mMPC_Ident(yySynAttribute.primary_expression.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, Find_Ident(yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, IDENT)
				   );
			    yySynAttribute.primary_expression.IsIntConst = false;
			    yySynAttribute.primary_expression.Value = 0;
			    if(yySynAttribute.primary_expression.Tree->MPC_Ident.Store!=NoTree) {
			      switch(yySynAttribute.primary_expression.Tree->MPC_Ident.Store->Kind) {
			        case kMPC_Function:
				     yySynAttribute.primary_expression.Tree->MPC_Ident.Store->MPC_Function.Flag.Used = YES;
				     break;
				case kMPC_Var:
				     yySynAttribute.primary_expression.Tree->MPC_Ident.Store->MPC_Var.Flag.Used = YES;
				     break;
				case kMPC_EnumConst:
				     yySynAttribute.primary_expression.IsIntConst = true;
				     yySynAttribute.primary_expression.Value = yySynAttribute.primary_expression.Tree->MPC_Ident.Store->MPC_EnumConst.Value;
				default:
				     break;
			      }
			    }
			    (void)Clean_OutAttributes(yySynAttribute.primary_expression.Tree);
			    yySynAttribute.primary_expression.Tree->MPC_Ident.BegPos = yySynAttribute.primary_expression.EndPos = yySynAttribute.primary_expression.Position;  
			    yySynAttribute.primary_expression.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.primary_expression.Tree->MPC_Ident.EndPos = yySynAttribute.primary_expression.EndPos ;  
			    yySynAttribute.primary_expression.Tree->MPC_Ident.Flag.Ignore = yySynAttribute.primary_expression.Ignore = yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.primary_expression.Sizeof = false;

			  yySynAttribute.primary_expression.Scope = false;

			  yySynAttribute.primary_expression.BegPos  =  yySynAttribute.primary_expression.Position;
  
			;

} break;
case 963: /* primary_expression : constant .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 142; {
/* line 949 "mpcPars.lalr" */

			    yySynAttribute.primary_expression.Tree = yyAttrStackPtr [1-1].constant.Tree;
			    yySynAttribute.primary_expression.Tree->MPC_Expr.EvalNet = CONST_NET_LIST;
			    yySynAttribute.primary_expression.Tree->MPC_Expr.StoreNet = CONST_NET;
			  ;

			  yySynAttribute.primary_expression.IsIntConst  =  yyAttrStackPtr [1-1].constant.IsIntConst;

			  yySynAttribute.primary_expression.Value  =  yyAttrStackPtr [1-1].constant.Value;

			  yySynAttribute.primary_expression.Sizeof = false;

			  yySynAttribute.primary_expression.Scope = false;

			  yySynAttribute.primary_expression.Ignore  =  yyAttrStackPtr [1-1].constant.Ignore;

			  yySynAttribute.primary_expression.Position  =  yyAttrStackPtr [1-1].constant.Position;

			  yySynAttribute.primary_expression.BegPos  =  yyAttrStackPtr [1-1].constant.Position;
  
			  yySynAttribute.primary_expression.EndPos  =  yyAttrStackPtr [1-1].constant.EndPos;
  
			;

} break;
case 964: /* primary_expression : string_literal_list .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 142; {
/* line 973 "mpcPars.lalr" */

			      yySynAttribute.primary_expression.Tree = ReverseTree(yyAttrStackPtr [1-1].string_literal_list.Tree);
			      NestedType_ON();
			      Push_Pattern(
				mMPC_ArrayType(
				  NoPosition, NoTree, NoTree,
				  Make_TypeFlag(YES,NO,NO,NO,NO,NO,NO,NO,NO,NO),
				  yyAttrStackPtr [1-1].string_literal_list.Length, 1, CharType
				)
			      );
			      TopType()->MPC_ArrayType.ArraySize =
				mMPC_IntConst(
					NoPosition, NoExprFlag, EmptyString, IntType,
					CONST_NET_LIST, CONST_NET, EmptyString,
					yyAttrStackPtr [1-1].string_literal_list.Length
				);
			      TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			      yySynAttribute.primary_expression.Tree->MPC_Expr.Type = Make_Type();
			      NestedType_OFF();
			      yySynAttribute.primary_expression.Tree->MPC_Expr.EvalNet = CONST_NET_LIST;
			      yySynAttribute.primary_expression.Tree->MPC_Expr.StoreNet = CONST_NET;
			    ;

			  yySynAttribute.primary_expression.IsIntConst = false;

			  yySynAttribute.primary_expression.Value = 0;

			  yySynAttribute.primary_expression.Sizeof = false;

			  yySynAttribute.primary_expression.Scope = false;

			  yySynAttribute.primary_expression.Ignore  =  yyAttrStackPtr [1-1].string_literal_list.Ignore;

			  yySynAttribute.primary_expression.Position  =  yyAttrStackPtr [1-1].string_literal_list.Position;

			  yySynAttribute.primary_expression.BegPos  =  yyAttrStackPtr [1-1].string_literal_list.BegPos;
  
			  yySynAttribute.primary_expression.EndPos  =  yyAttrStackPtr [1-1].string_literal_list.EndPos;
  
			;

} break;
case 965: /* primary_expression : '(' expression ')' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 142; {
/* line 1014 "mpcPars.lalr" */
yySynAttribute.primary_expression.EndPos = yyAttrStackPtr [2-1].expression.EndPos;

			  yySynAttribute.primary_expression.Scope  =  yyAttrStackPtr [2-1].expression.Scope;
  
			    if(yyAttrStackPtr [2-1].expression.Scope)
			      Restore_ExprScope();
			    yySynAttribute.primary_expression.Tree = yyAttrStackPtr [2-1].expression.Tree;
			    yySynAttribute.primary_expression.Tree->MPC_Expr.Flag.InParentheses = YES;
			    yySynAttribute.primary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.primary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.primary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.primary_expression.Position = CurrentPosition = yySynAttribute.primary_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			  yySynAttribute.primary_expression.IsIntConst  =  yyAttrStackPtr [2-1].expression.IsIntConst;

			  yySynAttribute.primary_expression.Value  =  yyAttrStackPtr [2-1].expression.Value;

			  yySynAttribute.primary_expression.Sizeof  =  yyAttrStackPtr [2-1].expression.Sizeof;

			  yySynAttribute.primary_expression.Ignore  =  yyAttrStackPtr [2-1].expression.Ignore;

			;

} break;
case 966: /* net_cast_expression : primary_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 144; {
/* line 1036 "mpcPars.lalr" */

			  yySynAttribute.net_cast_expression.Tree  =  yyAttrStackPtr [1-1].primary_expression.Tree;

			  yySynAttribute.net_cast_expression.IsIntConst  =  yyAttrStackPtr [1-1].primary_expression.IsIntConst;

			  yySynAttribute.net_cast_expression.Value  =  yyAttrStackPtr [1-1].primary_expression.Value;

			  yySynAttribute.net_cast_expression.Sizeof  =  yyAttrStackPtr [1-1].primary_expression.Sizeof;

			  yySynAttribute.net_cast_expression.Scope  =  yyAttrStackPtr [1-1].primary_expression.Scope;

			  yySynAttribute.net_cast_expression.Ignore  =  yyAttrStackPtr [1-1].primary_expression.Ignore;

			  yySynAttribute.net_cast_expression.Position  =  yyAttrStackPtr [1-1].primary_expression.Position;

			  yySynAttribute.net_cast_expression.BegPos  =  yyAttrStackPtr [1-1].primary_expression.BegPos;
  
			  yySynAttribute.net_cast_expression.EndPos  =  yyAttrStackPtr [1-1].primary_expression.EndPos;
  
			;

} break;
case 967: /* net_cast_expression : subnet_specifier primary_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 144; {
/* line 1057 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].subnet_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].subnet_specifier.Position, NoTree);
		
#endif
			  ; }
			  yySynAttribute.net_cast_expression.Sizeof  =  yyAttrStackPtr [2-1].primary_expression.Sizeof;
  
			    yySynAttribute.net_cast_expression.Tree = mMPC_NetCastExpr(yySynAttribute.net_cast_expression.Position=yyAttrStackPtr [1-1].subnet_specifier.Position, 
					NoExprFlag, EmptyString, NoTree, NoTree,
					yyAttrStackPtr [1-1].subnet_specifier.Tree,
					false, yyAttrStackPtr [2-1].primary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.net_cast_expression.Tree);
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.net_cast_expression.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore ||
								   yyAttrStackPtr [2-1].primary_expression.Ignore;
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.net_cast_expression.BegPos = yyAttrStackPtr [1-1].subnet_specifier.Position;  
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.net_cast_expression.EndPos = yyAttrStackPtr [2-1].primary_expression.EndPos;  
			  ;

			  yySynAttribute.net_cast_expression.Scope  =  yyAttrStackPtr [2-1].primary_expression.Scope;

			  yySynAttribute.net_cast_expression.IsIntConst  =  yyAttrStackPtr [2-1].primary_expression.IsIntConst;

			  yySynAttribute.net_cast_expression.Value  =  yyAttrStackPtr [2-1].primary_expression.Value;

			;

} break;
case 968: /* net_cast_expression : net_name_specifier primary_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 144; {
/* line 1089 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_name_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_name_specifier.Position, NoTree);
		
#endif
			  ; }
			  yySynAttribute.net_cast_expression.Sizeof  =  yyAttrStackPtr [2-1].primary_expression.Sizeof;
  
			    yySynAttribute.net_cast_expression.Tree = mMPC_NetCastExpr(yySynAttribute.net_cast_expression.Position=yyAttrStackPtr [1-1].net_name_specifier.Position, 
					NoExprFlag, EmptyString, NoTree,NoTree,
					yyAttrStackPtr [1-1].net_name_specifier.Tree,
					false, yyAttrStackPtr [2-1].primary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.net_cast_expression.Tree);
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.net_cast_expression.Ignore = yyAttrStackPtr [1-1].net_name_specifier.Ignore ||
								   yyAttrStackPtr [2-1].primary_expression.Ignore;
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.net_cast_expression.BegPos = yyAttrStackPtr [1-1].net_name_specifier.Position;  
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.net_cast_expression.EndPos = yyAttrStackPtr [2-1].primary_expression.EndPos;  
			    if(!yyAttrStackPtr [1-1].net_name_specifier.Simple) {
			      Make_Message(
				100, xxError, yyAttrStackPtr [1-1].net_name_specifier.Position, yySynAttribute.net_cast_expression.Tree
			      );
		
			      yySynAttribute.net_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.net_cast_expression.Ignore = YES;
			    }
			  ;

			  yySynAttribute.net_cast_expression.Scope  =  yyAttrStackPtr [2-1].primary_expression.Scope;

			  yySynAttribute.net_cast_expression.IsIntConst  =  yyAttrStackPtr [2-1].primary_expression.IsIntConst;

			  yySynAttribute.net_cast_expression.Value  =  yyAttrStackPtr [2-1].primary_expression.Value;

			;

} break;
case 969: /* net_cast_expression : '[' host ']' primary_expression .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 144; {
/* line 1128 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [1-1].Scan.Position,NoTree);
		
#endif
			  ; }
			  yySynAttribute.net_cast_expression.Sizeof  =  yyAttrStackPtr [4-1].primary_expression.Sizeof;
  
			    yySynAttribute.net_cast_expression.Tree = mMPC_NetCastExpr(yySynAttribute.net_cast_expression.Position=yyAttrStackPtr [3-1].Scan.Position, 
					NoExprFlag, EmptyString, NoTree,
					NoTree, HOST,
					false, yyAttrStackPtr [4-1].primary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.net_cast_expression.Tree);
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.net_cast_expression.Ignore = yyAttrStackPtr [4-1].primary_expression.Ignore;
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.net_cast_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.net_cast_expression.EndPos = yyAttrStackPtr [4-1].primary_expression.EndPos;  
			  ;

			  yySynAttribute.net_cast_expression.Scope  =  yyAttrStackPtr [4-1].primary_expression.Scope;

			  yySynAttribute.net_cast_expression.IsIntConst  =  yyAttrStackPtr [4-1].primary_expression.IsIntConst;

			  yySynAttribute.net_cast_expression.Value  =  yyAttrStackPtr [4-1].primary_expression.Value;

			;

} break;
case 970: /* postfix_expression : net_cast_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 147; {
/* line 1158 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Tree  =  yyAttrStackPtr [1-1].net_cast_expression.Tree;

			  yySynAttribute.postfix_expression.IsIntConst  =  yyAttrStackPtr [1-1].net_cast_expression.IsIntConst;

			  yySynAttribute.postfix_expression.Value  =  yyAttrStackPtr [1-1].net_cast_expression.Value;

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].net_cast_expression.Sizeof;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].net_cast_expression.Scope;

			  yySynAttribute.postfix_expression.Ignore  =  yyAttrStackPtr [1-1].net_cast_expression.Ignore;

			  yySynAttribute.postfix_expression.Position  =  yyAttrStackPtr [1-1].net_cast_expression.Position;

			  yySynAttribute.postfix_expression.BegPos  =  yyAttrStackPtr [1-1].net_cast_expression.BegPos;
  
			  yySynAttribute.postfix_expression.EndPos  =  yyAttrStackPtr [1-1].net_cast_expression.EndPos;
  
			;

} break;
case 971: /* postfix_expression : postfix_expression '[]' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 147; {
/* line 1179 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof = false;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_UnaryExpr(yySynAttribute.postfix_expression.Position=CurrentPosition=yyAttrStackPtr [2-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					BRACKETS, yyAttrStackPtr [1-1].postfix_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.postfix_expression.EndPos.Column++;  yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos.Column++;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 972: /* postfix_expression : postfix_expression '[' expression ']' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 147; {
/* line 1202 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof = false;
  
			    if(yyAttrStackPtr [3-1].expression.Scope)
			      Restore_ExprScope();
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position=CurrentPosition=yyAttrStackPtr [4-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					INDEX, yyAttrStackPtr [1-1].postfix_expression.Tree,
					yyAttrStackPtr [3-1].expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos ;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope = yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope;

			;

} break;
case 973: /* postfix_expression : postfix_expression '[' expression_opt ':' expression_opt grid_step ']' .*/
  yyStateStackPtr -= 7; yyAttrStackPtr -= 7; yyNonterminal = 147; {
/* line 1228 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof = false;
  
			    yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
					yyAttrStackPtr [3-1].expression_opt.Ignore || yyAttrStackPtr [5-1].expression_opt.Ignore ||
						   yyAttrStackPtr [6-1].grid_step.Ignore;
			    if(yyAttrStackPtr [3-1].expression_opt.Tree!=NoTree && yyAttrStackPtr [3-1].expression_opt.IsIntConst && yyAttrStackPtr [3-1].expression_opt.Value<0) {
			      yySynAttribute.postfix_expression.Ignore = true;
			      yySynAttribute.postfix_expression.Value = UNDEFINED;
			      Make_Message(280, xxError, yyAttrStackPtr [3-1].expression_opt.Position,
					   yyAttrStackPtr [3-1].expression_opt.Tree);
		
			    }
			    if(yyAttrStackPtr [5-1].expression_opt.Tree!=NoTree && yyAttrStackPtr [5-1].expression_opt.IsIntConst && yyAttrStackPtr [5-1].expression_opt.Value<=0) {
			      yySynAttribute.postfix_expression.Ignore = true;
			      yySynAttribute.postfix_expression.Value = UNDEFINED;
			      Make_Message(281, xxError, yyAttrStackPtr [5-1].expression_opt.Position,
					   yyAttrStackPtr [5-1].expression_opt.Tree);
		
			    }
			    if(yyAttrStackPtr [6-1].grid_step.Tree!=NoTree && yyAttrStackPtr [6-1].grid_step.IsIntConst && yyAttrStackPtr [6-1].grid_step.Value<=0) {
			      yySynAttribute.postfix_expression.Ignore = true;
			      yySynAttribute.postfix_expression.Value = UNDEFINED;
			      Make_Message(282, xxError, yyAttrStackPtr [6-1].grid_step.Position,
					   yyAttrStackPtr [6-1].grid_step.Tree);
		
			    }
			    if(yyAttrStackPtr [3-1].expression_opt.Scope || yyAttrStackPtr [5-1].expression_opt.Scope || yyAttrStackPtr [6-1].grid_step.Scope)
			      Restore_ExprScope();
			    yySynAttribute.postfix_expression.Tree = mMPC_QuaternaryExpr(yySynAttribute.postfix_expression.Position=CurrentPosition=yyAttrStackPtr [2-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					GRID, yyAttrStackPtr [1-1].postfix_expression.Tree,
					yyAttrStackPtr [3-1].expression_opt.Tree, yyAttrStackPtr [5-1].expression_opt.Tree,
					yyAttrStackPtr [6-1].grid_step.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    if(yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand2 == NoTree)
				yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand2 = mMPC_FreeNode(yySynAttribute.postfix_expression.Tree);
			    if(yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand3 == NoTree)
				yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand3 = mMPC_FreeNode(yySynAttribute.postfix_expression.Tree);
			    if(yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand4 == NoTree)
				yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand4 = mMPC_FreeNode(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [7-1].Scan.Position;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value=0;

			  yySynAttribute.postfix_expression.Scope = yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression_opt.Scope ||
					       yyAttrStackPtr [5-1].expression_opt.Scope || yyAttrStackPtr [6-1].grid_step.Scope;

			;

} break;
case 974: /* postfix_expression : postfix_expression '(' ')' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 147; {
/* line 1285 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;

			    if(yyAttrStackPtr [1-1].postfix_expression.Tree->Kind==kMPC_Ident &&
			       yyAttrStackPtr [1-1].postfix_expression.Tree->MPC_Ident.Store==NoTree)
				 Save_DefaultFunctionInfo(yyAttrStackPtr [1-1].postfix_expression.Tree);
			    CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;
			    yySynAttribute.postfix_expression.Tree = mMPC_CallExpr(yySynAttribute.postfix_expression.Position=yyAttrStackPtr [1-1].postfix_expression.EndPos ,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].postfix_expression.Tree,
					NoTree, NoTree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 975: /* postfix_expression : postfix_expression '(' argument_expression_list ')' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 147; {
/* line 1312 "mpcPars.lalr" */
yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [1-1].postfix_expression.EndPos;

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    if(yyAttrStackPtr [1-1].postfix_expression.Tree->Kind==kMPC_Ident &&
			       yyAttrStackPtr [1-1].postfix_expression.Tree->MPC_Ident.Store==NoTree)
				 Save_DefaultFunctionInfo(yyAttrStackPtr [1-1].postfix_expression.Tree);
			    CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;
			    yySynAttribute.postfix_expression.Tree = mMPC_CallExpr(yySynAttribute.postfix_expression.Position=yyAttrStackPtr [1-1].postfix_expression.EndPos ,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].postfix_expression.Tree,
					ReverseTree(yyAttrStackPtr [3-1].argument_expression_list.Tree),
					NoTree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree ->
			      MPC_CallExpr.ArgList ->
				MPC_Exprs.Prev -> MPC_FreeNode.Parent = yySynAttribute.postfix_expression.Tree;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								yyAttrStackPtr [3-1].argument_expression_list.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos ;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 976: /* postfix_expression : postfix_expression '.' IDENTIFIER .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 147; {
/* line 1345 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					DOT, yyAttrStackPtr [1-1].postfix_expression.Tree,
					mMPC_Ident(yyAttrStackPtr [3-1].Scan.Position, NoExprFlag, EmptyString,
						NoTree, NoTree, NoTree, yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ident,
						NoTree
					)
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.postfix_expression.EndPos.Column += yyAttrStackPtr [3-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_BinaryExpr.Roperand->MPC_Ident.BegPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.postfix_expression.Tree->MPC_BinaryExpr.Roperand->MPC_Ident.Flag.Ignore =
									yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 977: /* postfix_expression : postfix_expression '->' IDENTIFIER .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 147; {
/* line 1376 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					ARROW, yyAttrStackPtr [1-1].postfix_expression.Tree,
					mMPC_Ident(yyAttrStackPtr [3-1].Scan.Position, NoExprFlag, EmptyString,
						NoTree, NoTree, NoTree, yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ident,
						NoTree
					)
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.postfix_expression.EndPos.Column += yyAttrStackPtr [3-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_BinaryExpr.Roperand->MPC_Ident.BegPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.postfix_expression.Tree->MPC_BinaryExpr.Roperand->MPC_Ident.Flag.Ignore =
									yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 978: /* postfix_expression : postfix_expression '++' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 147; {
/* line 1407 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_UnaryExpr(yySynAttribute.postfix_expression.Position = CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [2-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					POST_INC, yyAttrStackPtr [1-1].postfix_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.EndPos.Column++; yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;   
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 979: /* postfix_expression : postfix_expression '--' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 147; {
/* line 1429 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_UnaryExpr(yySynAttribute.postfix_expression.Position = CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [2-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					POST_DEC, yyAttrStackPtr [1-1].postfix_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.EndPos.Column++; yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;   
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 980: /* postfix_expression : postfix_expression postfix_linear_operator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 147; {
/* line 1451 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].postfix_linear_operator.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [2-1].postfix_linear_operator.Position, NoTree);
		
#endif
			  ; }
			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_UnaryExpr(yySynAttribute.postfix_expression.Position=yyAttrStackPtr [2-1].postfix_linear_operator.Position,
					NoExprFlag, EmptyString, NoTree, NoTree,
					NoTree, yyAttrStackPtr [2-1].postfix_linear_operator.OpCode,
					yyAttrStackPtr [1-1].postfix_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [2-1].postfix_linear_operator.EndPos;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 981: /* postfix_expression : postfix_expression '[<' expression '>]' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 147; {
/* line 1482 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
		
#endif
			  ; }
			  yySynAttribute.postfix_expression.Sizeof = yyAttrStackPtr [1-1].postfix_expression.Sizeof || yyAttrStackPtr [3-1].expression.Sizeof;
  
			    if(yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope)
			      Restore_ExprScope();
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position = CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [4-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					DISTR_COMM_CALL, yyAttrStackPtr [1-1].postfix_expression.Tree,
					yyAttrStackPtr [3-1].expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.EndPos.Column++; yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope = yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope;

			;

} break;
case 982: /* postfix_expression : postfix_expression '[>' expression '<]' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 147; {
/* line 1516 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
		
#endif
			  ; }
			  yySynAttribute.postfix_expression.Sizeof = yyAttrStackPtr [1-1].postfix_expression.Sizeof || yyAttrStackPtr [3-1].expression.Sizeof;
  
			    if(yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope)
			      Restore_ExprScope();
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position = CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [4-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					DISTR_ASS_CALL, yyAttrStackPtr [1-1].postfix_expression.Tree,
					yyAttrStackPtr [3-1].expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.EndPos.Column++; yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope = yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope;

			;

} break;
case 983: /* postfix_linear_operator : linear_operator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 151; {
/* line 1550 "mpcPars.lalr" */

			    yySynAttribute.postfix_linear_operator.OpCode = yyAttrStackPtr [1-1].linear_operator.OpCode + POSTFIX;
			  ;
yySynAttribute.postfix_linear_operator.Position = CurrentPosition = yySynAttribute.postfix_linear_operator.EndPos = yyAttrStackPtr [1-1].linear_operator.Position;  
			     yySynAttribute.postfix_linear_operator.EndPos.Column += yyAttrStackPtr [1-1].linear_operator.Length; ;
  
			;

} break;
case 984: /* special_arguments : '(' '[' host ']' ')' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 153; {
/* line 1558 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
		
#endif
			  ; }
			  yySynAttribute.special_arguments.NetArgument = HOST;

			  yySynAttribute.special_arguments.NetworkArgList = NoTree;

			  yySynAttribute.special_arguments.Ignore = false;

			  yySynAttribute.special_arguments.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 985: /* special_arguments : '(' '[' '(' argument_expression_list_opt ')' NETorSUBNETname ']' ')' .*/
  yyStateStackPtr -= 8; yyAttrStackPtr -= 8; yyNonterminal = 153; {
/* line 1577 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
		
#endif
			  ; }  
			    CurrentPosition = yyAttrStackPtr [7-1].Scan.Position;
			    yySynAttribute.special_arguments.Ignore = yyAttrStackPtr [4-1].argument_expression_list_opt.Ignore ||
				     yyAttrStackPtr [6-1].Scan.NETorSUBNETname.Ignore;

			    yySynAttribute.special_arguments.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.special_arguments.NetworkArgList = yyAttrStackPtr [4-1].argument_expression_list_opt.Tree;
			    yySynAttribute.special_arguments.NetArgument = Find_Ident(yyAttrStackPtr [6-1].Scan.NETorSUBNETname.Ident,IDENT);
			    if(!yySynAttribute.special_arguments.NetArgument) {
			      yySynAttribute.special_arguments.Ignore = true;
			      Make_MessageI(283, xxError,
				yyAttrStackPtr [6-1].Scan.Position, xxIdent,
				(char*)&yyAttrStackPtr [6-1].Scan.NETorSUBNETname.Ident, NoTree);
		
			    }
			  ;

			;

} break;
case 986: /* argument_expression_list_opt : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 154; {
/* line 1604 "mpcPars.lalr" */

			  yySynAttribute.argument_expression_list_opt.Tree = NoTree;

			  yySynAttribute.argument_expression_list_opt.Ignore = false;

			;

} break;
case 987: /* argument_expression_list_opt : argument_expression_list .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 154; {
/* line 1611 "mpcPars.lalr" */

			    yySynAttribute.argument_expression_list_opt.Tree = ReverseTree(yyAttrStackPtr [1-1].argument_expression_list.Tree);
			  ;

			  yySynAttribute.argument_expression_list_opt.Ignore  =  yyAttrStackPtr [1-1].argument_expression_list.Ignore;

			;

} break;
case 988: /* argument_expression_list : assignment_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 150; {
/* line 1619 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.argument_expression_list.Tree = mMPC_Exprs(yySynAttribute.argument_expression_list.Position=yyAttrStackPtr [1-1].assignment_expression.Position,
					tmp, tmp, yyAttrStackPtr [1-1].assignment_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.argument_expression_list.Tree);
			    yySynAttribute.argument_expression_list.Tree->MPC_Exprs.BegPos = yySynAttribute.argument_expression_list.BegPos = yyAttrStackPtr [1-1].assignment_expression.BegPos;
			    yySynAttribute.argument_expression_list.Tree->MPC_Exprs.EndPos = yyAttrStackPtr [1-1].assignment_expression.EndPos;  
			  ;

			  yySynAttribute.argument_expression_list.Ignore  =  yyAttrStackPtr [1-1].assignment_expression.Ignore;

			;

} break;
case 989: /* argument_expression_list : argument_expression_list ',' assignment_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 150; {
/* line 1634 "mpcPars.lalr" */
  
			    yySynAttribute.argument_expression_list.Tree = mMPC_Exprs(yySynAttribute.argument_expression_list.Position=yyAttrStackPtr [3-1].assignment_expression.Position,
					yyAttrStackPtr [1-1].argument_expression_list.Tree,
					yyAttrStackPtr [1-1].argument_expression_list.Tree,
					yyAttrStackPtr [3-1].assignment_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.argument_expression_list.Tree);
			    yySynAttribute.argument_expression_list.Ignore = yyAttrStackPtr [1-1].argument_expression_list.Ignore ||
						yyAttrStackPtr [3-1].assignment_expression.Ignore;
			    yySynAttribute.argument_expression_list.Tree->MPC_Exprs.BegPos = yySynAttribute.argument_expression_list.BegPos = yyAttrStackPtr [1-1].argument_expression_list.BegPos; 
			    yySynAttribute.argument_expression_list.Tree->MPC_Exprs.EndPos = yyAttrStackPtr [3-1].assignment_expression.EndPos; 
			  ;

			;

} break;
case 990: /* unary_expression : postfix_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 156; {
/* line 1649 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;

			  yySynAttribute.unary_expression.Tree  =  yyAttrStackPtr [1-1].postfix_expression.Tree;

			  yySynAttribute.unary_expression.IsIntConst  =  yyAttrStackPtr [1-1].postfix_expression.IsIntConst;

			  yySynAttribute.unary_expression.Value  =  yyAttrStackPtr [1-1].postfix_expression.Value;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			  yySynAttribute.unary_expression.Ignore  =  yyAttrStackPtr [1-1].postfix_expression.Ignore;

			  yySynAttribute.unary_expression.Position  =  yyAttrStackPtr [1-1].postfix_expression.Position;

			  yySynAttribute.unary_expression.BegPos  =  yyAttrStackPtr [1-1].postfix_expression.BegPos;
  
			  yySynAttribute.unary_expression.EndPos  =  yyAttrStackPtr [1-1].postfix_expression.EndPos;
  
			;

} break;
case 991: /* unary_expression : special_arguments postfix_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 156; {
/* line 1670 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [2-1].postfix_expression.Sizeof;
  
			    yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [1-1].special_arguments.Ignore || yyAttrStackPtr [2-1].postfix_expression.Ignore;
			    yySynAttribute.unary_expression.Tree = yyAttrStackPtr [2-1].postfix_expression.Tree;
			    if(Tree_IsType(yySynAttribute.unary_expression.Tree, kMPC_CallExpr)) {
			      yySynAttribute.unary_expression.Tree->MPC_CallExpr.StoreNet = yyAttrStackPtr [1-1].special_arguments.NetArgument;
			      yySynAttribute.unary_expression.Tree->MPC_CallExpr.NetworkArgList =
							yyAttrStackPtr [1-1].special_arguments.NetworkArgList;
			    }
			    else {
			      yySynAttribute.unary_expression.Ignore = true;
			      Make_Message( 284, xxError,
					 yyAttrStackPtr [2-1].postfix_expression.Position, yySynAttribute.unary_expression.Tree);
		
			    }
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].special_arguments.BegPos;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].postfix_expression.EndPos;  
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].postfix_expression.Scope;

			  yySynAttribute.unary_expression.Position  =  yyAttrStackPtr [2-1].postfix_expression.Position;

			;

} break;
case 992: /* unary_expression : '++' unary_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 156; {
/* line 1701 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [2-1].unary_expression.Sizeof;
  
			    yySynAttribute.unary_expression.Tree = mMPC_UnaryExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					PRE_INC, yyAttrStackPtr [2-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;   
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.Position;   
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].unary_expression.Scope;

			;

} break;
case 993: /* unary_expression : '--' unary_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 156; {
/* line 1722 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [2-1].unary_expression.Sizeof;
  
			    yySynAttribute.unary_expression.Tree = mMPC_UnaryExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					PRE_DEC, yyAttrStackPtr [2-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;   
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.Position;   
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].unary_expression.Scope;

			;

} break;
case 994: /* unary_expression : unary_operator cast_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 156; {
/* line 1743 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [2-1].cast_expression.Sizeof;
  
			    yySynAttribute.unary_expression.Tree = mMPC_UnaryExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].unary_operator.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [1-1].unary_operator.OpCode, yyAttrStackPtr [2-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].cast_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].unary_operator.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].cast_expression.EndPos;  
			    if(yySynAttribute.unary_expression.IsIntConst=yyAttrStackPtr [2-1].cast_expression.IsIntConst) {
			      yySynAttribute.unary_expression.Value = Eval_UnaryExpr(yyAttrStackPtr [1-1].unary_operator.OpCode,
						     yyAttrStackPtr [2-1].cast_expression.Value,
						     yyAttrStackPtr [1-1].unary_operator.Position
				      );
			      if(!yySynAttribute.unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.unary_expression.Tree,yySynAttribute.unary_expression.Value);
			    }
			  ;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].cast_expression.Scope;

			;

} break;
case 995: /* unary_expression : sizeof unary_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 156; {
/* line 1767 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = true;
  
			    yySynAttribute.unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					false, 0,
					yyAttrStackPtr [2-1].unary_expression.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;
 ;

			  yySynAttribute.unary_expression.Value = 0;
          
					       
			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].unary_expression.Scope;

			;

} break;
case 996: /* unary_expression : mpc_sizeof unary_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 156; {
/* line 1791 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = false;
  
			    yySynAttribute.unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					true, 0,
					yyAttrStackPtr [2-1].unary_expression.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.EndPos;  
			    yySynAttribute.unary_expression.IsIntConst = true;
			    yySynAttribute.unary_expression.Value = Eval_SizeofExpr(yyAttrStackPtr [2-1].unary_expression.Tree, yyAttrStackPtr [1-1].Scan.Position);
			    if(!yySynAttribute.unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.unary_expression.Tree,yySynAttribute.unary_expression.Value);
			  ;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].unary_expression.Scope;

			;

} break;
case 997: /* unary_expression : sizeof '(' nested_type_on type_name nested_type_off ')' .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 156; {
/* line 1812 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = true;
  
			    CurrentPosition = yyAttrStackPtr [6-1].Scan.Position;
			    yySynAttribute.unary_expression.Tree = mMPC_Size_Of_Type(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					false, 0,
					yyAttrStackPtr [4-1].type_name.Type 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [6-1].Scan.Position;  
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;
 
			  yySynAttribute.unary_expression.Value = 0;
          
					       
			  yySynAttribute.unary_expression.Scope = true;

			;

} break;
case 998: /* unary_expression : mpc_sizeof '(' nested_type_on type_name nested_type_off ')' .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 156; {
/* line 1837 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = false;
  
			    CurrentPosition = yyAttrStackPtr [6-1].Scan.Position;
			    yySynAttribute.unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					true, 0,
					yyAttrStackPtr [4-1].type_name.Type 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [6-1].Scan.Position;  
			    yySynAttribute.unary_expression.IsIntConst = true;
			    yySynAttribute.unary_expression.Value = Eval_SizeofExpr(yyAttrStackPtr [4-1].type_name.Type, yyAttrStackPtr [1-1].Scan.Position);
			    if(!yySynAttribute.unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.unary_expression.Tree,yySynAttribute.unary_expression.Value);
			  ;

			  yySynAttribute.unary_expression.Scope = true;

			;

} break;
case 999: /* unary_expression : IDENTIFIER coordof unary_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 156; {
/* line 1859 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [2-1].Scan.Position, NoTree);
		
#endif
			  ; }
			  yySynAttribute.unary_expression.Sizeof = false;
  
			    yySynAttribute.unary_expression.Tree = mMPC_CoordExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident,
					yyAttrStackPtr [3-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [3-1].unary_expression.Ignore ||
								   yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [3-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [3-1].unary_expression.Scope;

			;

} break;
case 1000: /* unary_expression : IDENTIFIER coordof NETorSUBNETname .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 156; {
/* line 1891 "mpcPars.lalr" */
  
			    tTree Network, Dummy, NetList;
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [2-1].Scan.Position, NoTree);
		
#endif

			    Network = Find_Ident(yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ident,IDENT);
			    if(!Network) {
			      yySynAttribute.unary_expression.Ignore = true;
			      Make_MessageI(283, xxError,
				yyAttrStackPtr [3-1].Scan.Position, xxIdent,
				(char*)&yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ident, NoTree);
		
			    }
			    NetList = Clean_OutAttributes(mMPC_NetList(NoTree, NoTree, Network));
			    DummyVar = mMPC_Var(
					  yyAttrStackPtr [3-1].Scan.Position, DummyIdent, NoDeclFlag, NoTree, NoTree,
					  VoidType, Network, NoTree
				       );
			    (void)Clean_OutAttributes(DummyVar);
                            DummyVar->MPC_Var.Flag.Distributed = YES;
				        
			    Dummy = mMPC_Ident(
					yyAttrStackPtr [3-1].Scan.Position, NoExprFlag, EmptyString, VoidType,
					NoTree, NoTree, DummyIdent, DummyVar
				    );
			    yySynAttribute.unary_expression.Tree = mMPC_CoordExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, Dummy
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
                            yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Distributed = YES;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ignore ||
								   yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.unary_expression.EndPos.Column += yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Length - 1 ;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos ;  
			  ;

			  yySynAttribute.unary_expression.Sizeof = false;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope = false;

			;

} break;
case 1001: /* unary_expression : timeof new_scope '(' empty_net_declaring_list ')' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 156; {
/* line 1944 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = false;

			  yySynAttribute.unary_expression.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.unary_expression.EndPos  =  yyAttrStackPtr [5-1].Scan.Position;

			    yySynAttribute.unary_expression.Tree = mMPC_TimeofExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
						   DoubleType, CONST_NET_LIST, CONST_NET,
						   yyAttrStackPtr [4-1].empty_net_declaring_list.Tree
				   );
			    yyAttrStackPtr [4-1].empty_net_declaring_list.Tree->MPC_NetDecl.Next =
				yyAttrStackPtr [4-1].empty_net_declaring_list.Tree->MPC_NetDecl.Prev = mMPC_FreeNode(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Ignore = yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yyAttrStackPtr [4-1].empty_net_declaring_list.Ignore;
			    Close_Scope(), Scope_Depth--;
			  ;

			  yySynAttribute.unary_expression.Scope = true;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;
 
			;

} break;
case 1002: /* unary_expression : timeof new_scope '(' single_net_declaring_list ')' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 156; {
/* line 1969 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = false;

			  yySynAttribute.unary_expression.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.unary_expression.EndPos  =  yyAttrStackPtr [5-1].Scan.Position;

			    yySynAttribute.unary_expression.Tree = mMPC_TimeofExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
						   DoubleType, CONST_NET_LIST, CONST_NET,
						   yyAttrStackPtr [4-1].single_net_declaring_list.Tree
				   );
			    yyAttrStackPtr [4-1].single_net_declaring_list.Tree->MPC_NetDecl.Next =
				yyAttrStackPtr [4-1].single_net_declaring_list.Tree->MPC_NetDecl.Prev = mMPC_FreeNode(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Ignore = yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yyAttrStackPtr [4-1].single_net_declaring_list.Ignore;
			    Close_Scope(), Scope_Depth--;
			  ;

			  yySynAttribute.unary_expression.Scope = true;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;
 
			;

} break;
case 1003: /* unary_operator : '&' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 157; {
/* line 1994 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=ADDRESS;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1004: /* unary_operator : '*' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 157; {
/* line 1998 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=STAR;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1005: /* unary_operator : '+' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 157; {
/* line 2002 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=PLUS;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1006: /* unary_operator : '-' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 157; {
/* line 2006 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=NEG;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1007: /* unary_operator : '~' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 157; {
/* line 2010 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=NOT;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1008: /* unary_operator : '!' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 157; {
/* line 2014 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=LOG_NOT;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1009: /* unary_operator : linear_operator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 157; {
/* line 2018 "mpcPars.lalr" */

			  yySynAttribute.unary_operator.OpCode  =  yyAttrStackPtr [1-1].linear_operator.OpCode;
 yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].linear_operator.Position; ;

			;

} break;
case 1010: /* linear_operator : '[*]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 152; {
/* line 2024 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_MULT;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1011: /* linear_operator : '[?<]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 152; {
/* line 2028 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_MIN;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 yySynAttribute.linear_operator.Length = 4 ;

} break;
case 1012: /* linear_operator : '[?>]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 152; {
/* line 2032 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_MAX;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 yySynAttribute.linear_operator.Length = 4 ;

} break;
case 1013: /* linear_operator : '[+]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 152; {
/* line 2036 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_PLUS;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1014: /* linear_operator : '[&]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 152; {
/* line 2040 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_AND;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1015: /* linear_operator : '[^]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 152; {
/* line 2044 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_EXCL_OR;
 yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1016: /* linear_operator : '[|]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 152; {
/* line 2048 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_INCL_OR;
 yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1017: /* linear_operator : '[&&]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 152; {
/* line 2052 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_LOG_AND;
 yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 yySynAttribute.linear_operator.Length = 4 ;

} break;
case 1018: /* linear_operator : '[||]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 152; {
/* line 2056 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_LOG_OR;
  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 yySynAttribute.linear_operator.Length = 4 ;

} break;
case 1019: /* cast_expression : unary_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 158; {
/* line 2060 "mpcPars.lalr" */

			  yySynAttribute.cast_expression.Tree  =  yyAttrStackPtr [1-1].unary_expression.Tree;

			  yySynAttribute.cast_expression.IsIntConst  =  yyAttrStackPtr [1-1].unary_expression.IsIntConst;

			  yySynAttribute.cast_expression.Value  =  yyAttrStackPtr [1-1].unary_expression.Value;

			  yySynAttribute.cast_expression.Sizeof  =  yyAttrStackPtr [1-1].unary_expression.Sizeof;

			  yySynAttribute.cast_expression.Ignore  =  yyAttrStackPtr [1-1].unary_expression.Ignore;

			  yySynAttribute.cast_expression.Position  =  yyAttrStackPtr [1-1].unary_expression.Position;

			  yySynAttribute.cast_expression.BegPos  =  yyAttrStackPtr [1-1].unary_expression.BegPos;
  
			  yySynAttribute.cast_expression.EndPos  =  yyAttrStackPtr [1-1].unary_expression.EndPos;
  
			  yySynAttribute.cast_expression.Scope  =  yyAttrStackPtr [1-1].unary_expression.Scope;

			;

} break;
case 1020: /* cast_expression : '(' nested_type_on enable_dyn_array type_name nested_type_off disable_dyn_array ')' cast_expression .*/
  yyStateStackPtr -= 8; yyAttrStackPtr -= 8; yyNonterminal = 158; {
/* line 2081 "mpcPars.lalr" */

			  yySynAttribute.cast_expression.Sizeof  =  yyAttrStackPtr [8-1].cast_expression.Sizeof;
  
			    yySynAttribute.cast_expression.Tree = mMPC_CastExpr(yySynAttribute.cast_expression.Position=yyAttrStackPtr [7-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [4-1].type_name.Type, yyAttrStackPtr [8-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.cast_expression.Tree);
			    yySynAttribute.cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.cast_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore ||
								   yyAttrStackPtr [8-1].cast_expression.Ignore;
			    yySynAttribute.cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.cast_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.cast_expression.EndPos = yyAttrStackPtr [8-1].cast_expression.EndPos;  
			  ;

			  yySynAttribute.cast_expression.IsIntConst = yyAttrStackPtr [8-1].cast_expression.IsIntConst && yyAttrStackPtr [4-1].type_name.Type!=NoTree &&
					yyAttrStackPtr [4-1].type_name.Type->Kind==kMPC_BasicType &&
					yyAttrStackPtr [4-1].type_name.Type->MPC_BasicType.TypeConstructor<VOID &&
					yyAttrStackPtr [4-1].type_name.Type->MPC_BasicType.TypeConstructor>FLOAT;

			  yySynAttribute.cast_expression.Value  =  yyAttrStackPtr [8-1].cast_expression.Value;

			  yySynAttribute.cast_expression.Scope = true;

			;

} break;
case 1021: /* multiplicative_expression : cast_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 167; {
/* line 2106 "mpcPars.lalr" */

			  yySynAttribute.multiplicative_expression.Tree  =  yyAttrStackPtr [1-1].cast_expression.Tree;

			  yySynAttribute.multiplicative_expression.IsIntConst  =  yyAttrStackPtr [1-1].cast_expression.IsIntConst;

			  yySynAttribute.multiplicative_expression.Value  =  yyAttrStackPtr [1-1].cast_expression.Value;

			  yySynAttribute.multiplicative_expression.Sizeof  =  yyAttrStackPtr [1-1].cast_expression.Sizeof;

			  yySynAttribute.multiplicative_expression.Scope  =  yyAttrStackPtr [1-1].cast_expression.Scope;

			  yySynAttribute.multiplicative_expression.Ignore  =  yyAttrStackPtr [1-1].cast_expression.Ignore;

			  yySynAttribute.multiplicative_expression.Position  =  yyAttrStackPtr [1-1].cast_expression.Position;

			  yySynAttribute.multiplicative_expression.BegPos  =  yyAttrStackPtr [1-1].cast_expression.BegPos;
  
			  yySynAttribute.multiplicative_expression.EndPos  =  yyAttrStackPtr [1-1].cast_expression.EndPos;
  
			;

} break;
case 1022: /* multiplicative_expression : multiplicative_expression '*' cast_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 167; {
/* line 2127 "mpcPars.lalr" */

			  yySynAttribute.multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].multiplicative_expression.Sizeof || yyAttrStackPtr [3-1].cast_expression.Sizeof;
  
			    yySynAttribute.multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MULT, yyAttrStackPtr [1-1].multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.multiplicative_expression.Tree);
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.multiplicative_expression.Ignore =
							  yyAttrStackPtr [1-1].multiplicative_expression.Ignore ||
							  yyAttrStackPtr [3-1].cast_expression.Ignore;
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.multiplicative_expression.BegPos = yyAttrStackPtr [1-1].multiplicative_expression.BegPos;  
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.multiplicative_expression.EndPos = yyAttrStackPtr [3-1].cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].multiplicative_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].cast_expression.IsIntConst) {
			      yySynAttribute.multiplicative_expression.IsIntConst = true;
			      yySynAttribute.multiplicative_expression.Value = Eval_BinaryExpr(MULT,
					yyAttrStackPtr [1-1].multiplicative_expression.Value,
					yyAttrStackPtr [3-1].cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.multiplicative_expression.Tree,yySynAttribute.multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.multiplicative_expression.IsIntConst = false;
			      yySynAttribute.multiplicative_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.multiplicative_expression.Scope = yyAttrStackPtr [1-1].multiplicative_expression.Scope || yyAttrStackPtr [3-1].cast_expression.Scope;

			;

} break;
case 1023: /* multiplicative_expression : multiplicative_expression '/' cast_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 167; {
/* line 2161 "mpcPars.lalr" */

			  yySynAttribute.multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].multiplicative_expression.Sizeof || yyAttrStackPtr [3-1].cast_expression.Sizeof;
  
			    yySynAttribute.multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					DIV, yyAttrStackPtr [1-1].multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.multiplicative_expression.Tree);
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.multiplicative_expression.Ignore =
							  yyAttrStackPtr [1-1].multiplicative_expression.Ignore ||
							  yyAttrStackPtr [3-1].cast_expression.Ignore;
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.multiplicative_expression.BegPos = yyAttrStackPtr [1-1].multiplicative_expression.BegPos;  
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.multiplicative_expression.EndPos = yyAttrStackPtr [3-1].cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].multiplicative_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].cast_expression.IsIntConst) {
			      yySynAttribute.multiplicative_expression.IsIntConst = true;
			      yySynAttribute.multiplicative_expression.Value = Eval_BinaryExpr(DIV,
					yyAttrStackPtr [1-1].multiplicative_expression.Value,
					yyAttrStackPtr [3-1].cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.multiplicative_expression.Tree,yySynAttribute.multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.multiplicative_expression.IsIntConst = false;
			      yySynAttribute.multiplicative_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.multiplicative_expression.Scope = yyAttrStackPtr [1-1].multiplicative_expression.Scope || yyAttrStackPtr [3-1].cast_expression.Scope;

			;

} break;
case 1024: /* multiplicative_expression : multiplicative_expression '%' cast_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 167; {
/* line 2195 "mpcPars.lalr" */

			  yySynAttribute.multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].multiplicative_expression.Sizeof || yyAttrStackPtr [3-1].cast_expression.Sizeof;
  
			    yySynAttribute.multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MOD, yyAttrStackPtr [1-1].multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.multiplicative_expression.Tree);
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.multiplicative_expression.Ignore =
							  yyAttrStackPtr [1-1].multiplicative_expression.Ignore ||
							  yyAttrStackPtr [3-1].cast_expression.Ignore;
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.multiplicative_expression.BegPos = yyAttrStackPtr [1-1].multiplicative_expression.BegPos;  
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.multiplicative_expression.EndPos = yyAttrStackPtr [3-1].cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].multiplicative_expression.IsIntConst &&
			      yyAttrStackPtr [3-1].cast_expression.IsIntConst) {
			      yySynAttribute.multiplicative_expression.IsIntConst = true;
			      yySynAttribute.multiplicative_expression.Value = Eval_BinaryExpr(MOD,
					yyAttrStackPtr [1-1].multiplicative_expression.Value,
					yyAttrStackPtr [3-1].cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.multiplicative_expression.Tree,yySynAttribute.multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.multiplicative_expression.IsIntConst = false;
			      yySynAttribute.multiplicative_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.multiplicative_expression.Scope = yyAttrStackPtr [1-1].multiplicative_expression.Scope || yyAttrStackPtr [3-1].cast_expression.Scope;

			;

} break;
case 1025: /* max_or_min_expression : multiplicative_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 168; {
/* line 2229 "mpcPars.lalr" */

			  yySynAttribute.max_or_min_expression.Tree  =  yyAttrStackPtr [1-1].multiplicative_expression.Tree;

			  yySynAttribute.max_or_min_expression.IsIntConst  =  yyAttrStackPtr [1-1].multiplicative_expression.IsIntConst;

			  yySynAttribute.max_or_min_expression.Value  =  yyAttrStackPtr [1-1].multiplicative_expression.Value;

			  yySynAttribute.max_or_min_expression.Sizeof  =  yyAttrStackPtr [1-1].multiplicative_expression.Sizeof;

			  yySynAttribute.max_or_min_expression.Scope  =  yyAttrStackPtr [1-1].multiplicative_expression.Scope;

			  yySynAttribute.max_or_min_expression.Ignore  =  yyAttrStackPtr [1-1].multiplicative_expression.Ignore;

			  yySynAttribute.max_or_min_expression.Position  =  yyAttrStackPtr [1-1].multiplicative_expression.Position;

			  yySynAttribute.max_or_min_expression.BegPos  =  yyAttrStackPtr [1-1].multiplicative_expression.BegPos;
  
			  yySynAttribute.max_or_min_expression.EndPos  =  yyAttrStackPtr [1-1].multiplicative_expression.EndPos;
  
			;

} break;
case 1026: /* max_or_min_expression : max_or_min_expression '?<' multiplicative_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 168; {
/* line 2250 "mpcPars.lalr" */

			  yySynAttribute.max_or_min_expression.Sizeof = yyAttrStackPtr [1-1].max_or_min_expression.Sizeof || yyAttrStackPtr [3-1].multiplicative_expression.Sizeof;
  
			    yySynAttribute.max_or_min_expression.Tree = mMPC_BinaryExpr(yySynAttribute.max_or_min_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MIN, yyAttrStackPtr [1-1].max_or_min_expression.Tree,
					yyAttrStackPtr [3-1].multiplicative_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.max_or_min_expression.Tree);
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.max_or_min_expression.Ignore =
							  yyAttrStackPtr [1-1].max_or_min_expression.Ignore ||
							  yyAttrStackPtr [3-1].multiplicative_expression.Ignore;
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.BegPos = yySynAttribute.max_or_min_expression.BegPos = yyAttrStackPtr [1-1].max_or_min_expression.BegPos;  
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.EndPos = yySynAttribute.max_or_min_expression.EndPos = yyAttrStackPtr [3-1].multiplicative_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].max_or_min_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].multiplicative_expression.IsIntConst) {
			      yySynAttribute.max_or_min_expression.IsIntConst = true;
			      yySynAttribute.max_or_min_expression.Value = Eval_BinaryExpr(MIN,
					yyAttrStackPtr [1-1].max_or_min_expression.Value,
					yyAttrStackPtr [3-1].multiplicative_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.max_or_min_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.max_or_min_expression.Tree,yySynAttribute.max_or_min_expression.Value);
			    }
			    else {
			      yySynAttribute.max_or_min_expression.IsIntConst = false;
			      yySynAttribute.max_or_min_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.max_or_min_expression.Scope = yyAttrStackPtr [1-1].max_or_min_expression.Scope || yyAttrStackPtr [3-1].multiplicative_expression.Scope;

			;

} break;
case 1027: /* max_or_min_expression : max_or_min_expression '?>' multiplicative_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 168; {
/* line 2284 "mpcPars.lalr" */

			  yySynAttribute.max_or_min_expression.Sizeof = yyAttrStackPtr [1-1].max_or_min_expression.Sizeof || yyAttrStackPtr [3-1].multiplicative_expression.Sizeof;
  
			    yySynAttribute.max_or_min_expression.Tree = mMPC_BinaryExpr(yySynAttribute.max_or_min_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MAX, yyAttrStackPtr [1-1].max_or_min_expression.Tree,
					yyAttrStackPtr [3-1].multiplicative_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.max_or_min_expression.Tree);
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.max_or_min_expression.Ignore =
							  yyAttrStackPtr [1-1].max_or_min_expression.Ignore ||
							  yyAttrStackPtr [3-1].multiplicative_expression.Ignore;
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.BegPos = yySynAttribute.max_or_min_expression.BegPos = yyAttrStackPtr [1-1].max_or_min_expression.BegPos;  
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.EndPos = yySynAttribute.max_or_min_expression.EndPos = yyAttrStackPtr [3-1].multiplicative_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].max_or_min_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].multiplicative_expression.IsIntConst) {
			      yySynAttribute.max_or_min_expression.IsIntConst = true;
			      yySynAttribute.max_or_min_expression.Value = Eval_BinaryExpr(MAX,
					yyAttrStackPtr [1-1].max_or_min_expression.Value,
					yyAttrStackPtr [3-1].multiplicative_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.max_or_min_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.max_or_min_expression.Tree,yySynAttribute.max_or_min_expression.Value);
			    }
			    else {
			      yySynAttribute.max_or_min_expression.IsIntConst = false;
			      yySynAttribute.max_or_min_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.max_or_min_expression.Scope = yyAttrStackPtr [1-1].max_or_min_expression.Scope || yyAttrStackPtr [3-1].multiplicative_expression.Scope;

			;

} break;
case 1028: /* additive_expression : max_or_min_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 169; {
/* line 2318 "mpcPars.lalr" */

			  yySynAttribute.additive_expression.Tree  =  yyAttrStackPtr [1-1].max_or_min_expression.Tree;

			  yySynAttribute.additive_expression.IsIntConst  =  yyAttrStackPtr [1-1].max_or_min_expression.IsIntConst;

			  yySynAttribute.additive_expression.Value  =  yyAttrStackPtr [1-1].max_or_min_expression.Value;

			  yySynAttribute.additive_expression.Sizeof  =  yyAttrStackPtr [1-1].max_or_min_expression.Sizeof;

			  yySynAttribute.additive_expression.Scope  =  yyAttrStackPtr [1-1].max_or_min_expression.Scope;

			  yySynAttribute.additive_expression.Ignore  =  yyAttrStackPtr [1-1].max_or_min_expression.Ignore;

			  yySynAttribute.additive_expression.Position  =  yyAttrStackPtr [1-1].max_or_min_expression.Position;

			  yySynAttribute.additive_expression.BegPos  =  yyAttrStackPtr [1-1].max_or_min_expression.BegPos;
  
			  yySynAttribute.additive_expression.EndPos  =  yyAttrStackPtr [1-1].max_or_min_expression.EndPos;
  
			;

} break;
case 1029: /* additive_expression : additive_expression '+' max_or_min_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 169; {
/* line 2339 "mpcPars.lalr" */
yySynAttribute.additive_expression.Value = yyAttrStackPtr [3-1].max_or_min_expression.Value;

			  yySynAttribute.additive_expression.Sizeof = yyAttrStackPtr [1-1].additive_expression.Sizeof || yyAttrStackPtr [3-1].max_or_min_expression.Sizeof;
  
			    yySynAttribute.additive_expression.Tree = mMPC_BinaryExpr(yySynAttribute.additive_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					PLUS, yyAttrStackPtr [1-1].additive_expression.Tree,
					yyAttrStackPtr [3-1].max_or_min_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.additive_expression.Tree);
			    yySynAttribute.additive_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.additive_expression.Ignore =
							  yyAttrStackPtr [1-1].additive_expression.Ignore ||
							  yyAttrStackPtr [3-1].max_or_min_expression.Ignore;
			    yySynAttribute.additive_expression.Tree->MPC_Expr.BegPos = yySynAttribute.additive_expression.BegPos = yyAttrStackPtr [1-1].additive_expression.BegPos;  
			    yySynAttribute.additive_expression.Tree->MPC_Expr.EndPos = yySynAttribute.additive_expression.EndPos = yyAttrStackPtr [3-1].max_or_min_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].additive_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].max_or_min_expression.IsIntConst) {
			      yySynAttribute.additive_expression.IsIntConst = true;
			      yySynAttribute.additive_expression.Value = Eval_BinaryExpr(PLUS,
					yyAttrStackPtr [1-1].additive_expression.Value,
					yyAttrStackPtr [3-1].max_or_min_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.additive_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.additive_expression.Tree,yySynAttribute.additive_expression.Value);
			    }
			    else {
			      yySynAttribute.additive_expression.IsIntConst = false;
			      yySynAttribute.additive_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.additive_expression.Scope = yyAttrStackPtr [1-1].additive_expression.Scope || yyAttrStackPtr [3-1].max_or_min_expression.Scope;

			;

} break;
case 1030: /* additive_expression : additive_expression '-' max_or_min_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 169; {
/* line 2374 "mpcPars.lalr" */

			  yySynAttribute.additive_expression.Sizeof = yyAttrStackPtr [1-1].additive_expression.Sizeof || yyAttrStackPtr [3-1].max_or_min_expression.Sizeof;
  
			    yySynAttribute.additive_expression.Tree = mMPC_BinaryExpr(yySynAttribute.additive_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MINUS, yyAttrStackPtr [1-1].additive_expression.Tree,
					yyAttrStackPtr [3-1].max_or_min_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.additive_expression.Tree);
			    yySynAttribute.additive_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.additive_expression.Ignore =
							  yyAttrStackPtr [1-1].additive_expression.Ignore ||
							  yyAttrStackPtr [3-1].max_or_min_expression.Ignore;
			    yySynAttribute.additive_expression.Tree->MPC_Expr.BegPos = yySynAttribute.additive_expression.BegPos = yyAttrStackPtr [1-1].additive_expression.BegPos;  
			    yySynAttribute.additive_expression.Tree->MPC_Expr.EndPos = yySynAttribute.additive_expression.EndPos = yyAttrStackPtr [3-1].max_or_min_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].additive_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].max_or_min_expression.IsIntConst) {
			      yySynAttribute.additive_expression.IsIntConst = true;
			      yySynAttribute.additive_expression.Value = Eval_BinaryExpr(MINUS,
					yyAttrStackPtr [1-1].additive_expression.Value,
					yyAttrStackPtr [3-1].max_or_min_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.additive_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.additive_expression.Tree,yySynAttribute.additive_expression.Value);
			    }
			    else {
			      yySynAttribute.additive_expression.IsIntConst = false;
			      yySynAttribute.additive_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.additive_expression.Scope = yyAttrStackPtr [1-1].additive_expression.Scope || yyAttrStackPtr [3-1].max_or_min_expression.Scope;

			;

} break;
case 1031: /* shift_expression : additive_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 170; {
/* line 2408 "mpcPars.lalr" */

			  yySynAttribute.shift_expression.Tree  =  yyAttrStackPtr [1-1].additive_expression.Tree;

			  yySynAttribute.shift_expression.IsIntConst  =  yyAttrStackPtr [1-1].additive_expression.IsIntConst;

			  yySynAttribute.shift_expression.Value  =  yyAttrStackPtr [1-1].additive_expression.Value;

			  yySynAttribute.shift_expression.Sizeof  =  yyAttrStackPtr [1-1].additive_expression.Sizeof;

			  yySynAttribute.shift_expression.Scope  =  yyAttrStackPtr [1-1].additive_expression.Scope;

			  yySynAttribute.shift_expression.Ignore  =  yyAttrStackPtr [1-1].additive_expression.Ignore;

			  yySynAttribute.shift_expression.Position  =  yyAttrStackPtr [1-1].additive_expression.Position;

			  yySynAttribute.shift_expression.BegPos  =  yyAttrStackPtr [1-1].additive_expression.BegPos;
  
			  yySynAttribute.shift_expression.EndPos  =  yyAttrStackPtr [1-1].additive_expression.EndPos;
  
			;

} break;
case 1032: /* shift_expression : shift_expression '<<' additive_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 170; {
/* line 2429 "mpcPars.lalr" */

			  yySynAttribute.shift_expression.Sizeof = yyAttrStackPtr [1-1].shift_expression.Sizeof || yyAttrStackPtr [3-1].additive_expression.Sizeof;
  
			    yySynAttribute.shift_expression.Tree = mMPC_BinaryExpr(yySynAttribute.shift_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LEFT_SHIFT, yyAttrStackPtr [1-1].shift_expression.Tree,
					yyAttrStackPtr [3-1].additive_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.shift_expression.Tree);
			    yySynAttribute.shift_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.shift_expression.Ignore =
							  yyAttrStackPtr [1-1].shift_expression.Ignore ||
							  yyAttrStackPtr [3-1].additive_expression.Ignore;
			    yySynAttribute.shift_expression.Tree->MPC_Expr.BegPos = yySynAttribute.shift_expression.BegPos = yyAttrStackPtr [1-1].shift_expression.BegPos;  
			    yySynAttribute.shift_expression.Tree->MPC_Expr.EndPos = yySynAttribute.shift_expression.EndPos = yyAttrStackPtr [3-1].additive_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].shift_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].additive_expression.IsIntConst) {
			      yySynAttribute.shift_expression.IsIntConst = true;
			      yySynAttribute.shift_expression.Value = Eval_BinaryExpr(LEFT_SHIFT,
					yyAttrStackPtr [1-1].shift_expression.Value,
					yyAttrStackPtr [3-1].additive_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.shift_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.shift_expression.Tree,yySynAttribute.shift_expression.Value);
			    }
			    else {
			      yySynAttribute.shift_expression.IsIntConst = false;
			      yySynAttribute.shift_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.shift_expression.Scope = yyAttrStackPtr [1-1].shift_expression.Scope || yyAttrStackPtr [3-1].additive_expression.Scope;

			;

} break;
case 1033: /* shift_expression : shift_expression '>>' additive_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 170; {
/* line 2463 "mpcPars.lalr" */

			  yySynAttribute.shift_expression.Sizeof = yyAttrStackPtr [1-1].shift_expression.Sizeof || yyAttrStackPtr [3-1].additive_expression.Sizeof;
  
			    yySynAttribute.shift_expression.Tree = mMPC_BinaryExpr(yySynAttribute.shift_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					RIGHT_SHIFT, yyAttrStackPtr [1-1].shift_expression.Tree,
					yyAttrStackPtr [3-1].additive_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.shift_expression.Tree);
			    yySynAttribute.shift_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.shift_expression.Ignore =
							  yyAttrStackPtr [1-1].shift_expression.Ignore ||
							  yyAttrStackPtr [3-1].additive_expression.Ignore;
			    yySynAttribute.shift_expression.Tree->MPC_Expr.BegPos = yySynAttribute.shift_expression.BegPos = yyAttrStackPtr [1-1].shift_expression.BegPos;  
			    yySynAttribute.shift_expression.Tree->MPC_Expr.EndPos = yySynAttribute.shift_expression.EndPos = yyAttrStackPtr [3-1].additive_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].shift_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].additive_expression.IsIntConst) {
			      yySynAttribute.shift_expression.IsIntConst = true;
			      yySynAttribute.shift_expression.Value = Eval_BinaryExpr(RIGHT_SHIFT,
					yyAttrStackPtr [1-1].shift_expression.Value,
					yyAttrStackPtr [3-1].additive_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.shift_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.shift_expression.Tree,yySynAttribute.shift_expression.Value);
			    }
			    else {
			      yySynAttribute.shift_expression.IsIntConst = false;
			      yySynAttribute.shift_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.shift_expression.Scope = yyAttrStackPtr [1-1].shift_expression.Scope || yyAttrStackPtr [3-1].additive_expression.Scope;

			;

} break;
case 1034: /* relational_expression : shift_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 171; {
/* line 2497 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Tree  =  yyAttrStackPtr [1-1].shift_expression.Tree;

			  yySynAttribute.relational_expression.IsIntConst  =  yyAttrStackPtr [1-1].shift_expression.IsIntConst;

			  yySynAttribute.relational_expression.Value  =  yyAttrStackPtr [1-1].shift_expression.Value;

			  yySynAttribute.relational_expression.Sizeof  =  yyAttrStackPtr [1-1].shift_expression.Sizeof;

			  yySynAttribute.relational_expression.Scope  =  yyAttrStackPtr [1-1].shift_expression.Scope;

			  yySynAttribute.relational_expression.Ignore  =  yyAttrStackPtr [1-1].shift_expression.Ignore;

			  yySynAttribute.relational_expression.Position  =  yyAttrStackPtr [1-1].shift_expression.Position;

			  yySynAttribute.relational_expression.BegPos  =  yyAttrStackPtr [1-1].shift_expression.BegPos;
  
			  yySynAttribute.relational_expression.EndPos  =  yyAttrStackPtr [1-1].shift_expression.EndPos;
  
			;

} break;
case 1035: /* relational_expression : relational_expression '<' shift_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 171; {
/* line 2518 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Sizeof = yyAttrStackPtr [1-1].relational_expression.Sizeof || yyAttrStackPtr [3-1].shift_expression.Sizeof;
  
			    yySynAttribute.relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LESS_THEN, yyAttrStackPtr [1-1].relational_expression.Tree,
					yyAttrStackPtr [3-1].shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.relational_expression.Tree);
			    yySynAttribute.relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.relational_expression.Ignore =
							  yyAttrStackPtr [1-1].relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].shift_expression.Ignore;
			    yySynAttribute.relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.relational_expression.BegPos = yyAttrStackPtr [1-1].relational_expression.BegPos;  
			    yySynAttribute.relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.relational_expression.EndPos = yyAttrStackPtr [3-1].shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].shift_expression.IsIntConst) {
			      yySynAttribute.relational_expression.IsIntConst = true;
			      yySynAttribute.relational_expression.Value = Eval_BinaryExpr(LESS_THEN,
					yyAttrStackPtr [1-1].relational_expression.Value,
					yyAttrStackPtr [3-1].shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.relational_expression.Tree,yySynAttribute.relational_expression.Value);
			    }
			    else {
			      yySynAttribute.relational_expression.IsIntConst = false;
			      yySynAttribute.relational_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.relational_expression.Scope = yyAttrStackPtr [1-1].relational_expression.Scope || yyAttrStackPtr [3-1].shift_expression.Scope;

			;

} break;
case 1036: /* relational_expression : relational_expression '>' shift_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 171; {
/* line 2552 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Sizeof = yyAttrStackPtr [1-1].relational_expression.Sizeof || yyAttrStackPtr [3-1].shift_expression.Sizeof;
  
			    yySynAttribute.relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					GREAT_THEN, yyAttrStackPtr [1-1].relational_expression.Tree,
					yyAttrStackPtr [3-1].shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.relational_expression.Tree);
			    yySynAttribute.relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.relational_expression.Ignore =
							  yyAttrStackPtr [1-1].relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].shift_expression.Ignore;
			    yySynAttribute.relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.relational_expression.BegPos = yyAttrStackPtr [1-1].relational_expression.BegPos;  
			    yySynAttribute.relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.relational_expression.EndPos = yyAttrStackPtr [3-1].shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].shift_expression.IsIntConst) {
			      yySynAttribute.relational_expression.IsIntConst = true;
			      yySynAttribute.relational_expression.Value = Eval_BinaryExpr(GREAT_THEN,
					yyAttrStackPtr [1-1].relational_expression.Value,
					yyAttrStackPtr [3-1].shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.relational_expression.Tree,yySynAttribute.relational_expression.Value);
			    }
			    else {
			      yySynAttribute.relational_expression.IsIntConst = false;
			      yySynAttribute.relational_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.relational_expression.Scope = yyAttrStackPtr [1-1].relational_expression.Scope || yyAttrStackPtr [3-1].shift_expression.Scope;

			;

} break;
case 1037: /* relational_expression : relational_expression '<=' shift_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 171; {
/* line 2586 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Sizeof = yyAttrStackPtr [1-1].relational_expression.Sizeof || yyAttrStackPtr [3-1].shift_expression.Sizeof;
  
			    yySynAttribute.relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LESS_OR_EQ, yyAttrStackPtr [1-1].relational_expression.Tree,
					yyAttrStackPtr [3-1].shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.relational_expression.Tree);
			    yySynAttribute.relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.relational_expression.Ignore =
							  yyAttrStackPtr [1-1].relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].shift_expression.Ignore;
			    yySynAttribute.relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.relational_expression.BegPos = yyAttrStackPtr [1-1].relational_expression.BegPos;  
			    yySynAttribute.relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.relational_expression.EndPos = yyAttrStackPtr [3-1].shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].shift_expression.IsIntConst) {
			      yySynAttribute.relational_expression.IsIntConst = true;
			      yySynAttribute.relational_expression.Value = Eval_BinaryExpr(LESS_OR_EQ,
					yyAttrStackPtr [1-1].relational_expression.Value,
					yyAttrStackPtr [3-1].shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.relational_expression.Tree,yySynAttribute.relational_expression.Value);
			    }
			    else {
			      yySynAttribute.relational_expression.IsIntConst = false;
			      yySynAttribute.relational_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.relational_expression.Scope = yyAttrStackPtr [1-1].relational_expression.Scope || yyAttrStackPtr [3-1].shift_expression.Scope;

			;

} break;
case 1038: /* relational_expression : relational_expression '>=' shift_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 171; {
/* line 2620 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Sizeof = yyAttrStackPtr [1-1].relational_expression.Sizeof || yyAttrStackPtr [3-1].shift_expression.Sizeof;
  
			    yySynAttribute.relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					GREAT_OR_EQ, yyAttrStackPtr [1-1].relational_expression.Tree,
					yyAttrStackPtr [3-1].shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.relational_expression.Tree);
			    yySynAttribute.relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.relational_expression.Ignore =
							  yyAttrStackPtr [1-1].relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].shift_expression.Ignore;
			    yySynAttribute.relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.relational_expression.BegPos = yyAttrStackPtr [1-1].relational_expression.BegPos;  
			    yySynAttribute.relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.relational_expression.EndPos = yyAttrStackPtr [3-1].shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].shift_expression.IsIntConst) {
			      yySynAttribute.relational_expression.IsIntConst = true;
			      yySynAttribute.relational_expression.Value = Eval_BinaryExpr(GREAT_OR_EQ,
					yyAttrStackPtr [1-1].relational_expression.Value,
					yyAttrStackPtr [3-1].shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.relational_expression.Tree,yySynAttribute.relational_expression.Value);
			    }
			    else {
			      yySynAttribute.relational_expression.IsIntConst = false;
			      yySynAttribute.relational_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.relational_expression.Scope = yyAttrStackPtr [1-1].relational_expression.Scope || yyAttrStackPtr [3-1].shift_expression.Scope;

			;

} break;
case 1039: /* equality_expression : relational_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 172; {
/* line 2654 "mpcPars.lalr" */

			  yySynAttribute.equality_expression.Tree  =  yyAttrStackPtr [1-1].relational_expression.Tree;

			  yySynAttribute.equality_expression.IsIntConst  =  yyAttrStackPtr [1-1].relational_expression.IsIntConst;

			  yySynAttribute.equality_expression.Value  =  yyAttrStackPtr [1-1].relational_expression.Value;

			  yySynAttribute.equality_expression.Sizeof  =  yyAttrStackPtr [1-1].relational_expression.Sizeof;

			  yySynAttribute.equality_expression.Scope  =  yyAttrStackPtr [1-1].relational_expression.Scope;

			  yySynAttribute.equality_expression.Ignore  =  yyAttrStackPtr [1-1].relational_expression.Ignore;

			  yySynAttribute.equality_expression.Position  =  yyAttrStackPtr [1-1].relational_expression.Position;

			  yySynAttribute.equality_expression.BegPos  =  yyAttrStackPtr [1-1].relational_expression.BegPos;
  
			  yySynAttribute.equality_expression.EndPos  =  yyAttrStackPtr [1-1].relational_expression.EndPos;
  
			;

} break;
case 1040: /* equality_expression : equality_expression '==' relational_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 172; {
/* line 2675 "mpcPars.lalr" */

			  yySynAttribute.equality_expression.Sizeof = yyAttrStackPtr [1-1].equality_expression.Sizeof || yyAttrStackPtr [3-1].relational_expression.Sizeof;
  
			    yySynAttribute.equality_expression.Tree = mMPC_BinaryExpr(yySynAttribute.equality_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					EQUAL, yyAttrStackPtr [1-1].equality_expression.Tree,
					yyAttrStackPtr [3-1].relational_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.equality_expression.Tree);
			    yySynAttribute.equality_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.equality_expression.Ignore =
							  yyAttrStackPtr [1-1].equality_expression.Ignore ||
							  yyAttrStackPtr [3-1].relational_expression.Ignore;
			    yySynAttribute.equality_expression.Tree->MPC_Expr.BegPos = yySynAttribute.equality_expression.BegPos = yyAttrStackPtr [1-1].equality_expression.BegPos;  
			    yySynAttribute.equality_expression.Tree->MPC_Expr.EndPos = yySynAttribute.equality_expression.EndPos = yyAttrStackPtr [3-1].relational_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].equality_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].relational_expression.IsIntConst) {
			      yySynAttribute.equality_expression.IsIntConst = true;
			      yySynAttribute.equality_expression.Value = Eval_BinaryExpr(EQUAL,
					yyAttrStackPtr [1-1].equality_expression.Value,
					yyAttrStackPtr [3-1].relational_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.equality_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.equality_expression.Tree,yySynAttribute.equality_expression.Value);
			    }
			    else {
			      yySynAttribute.equality_expression.IsIntConst = false;
			      yySynAttribute.equality_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.equality_expression.Scope = yyAttrStackPtr [1-1].equality_expression.Scope || yyAttrStackPtr [3-1].relational_expression.Scope;

			;

} break;
case 1041: /* equality_expression : equality_expression '!=' relational_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 172; {
/* line 2709 "mpcPars.lalr" */

			  yySynAttribute.equality_expression.Sizeof = yyAttrStackPtr [1-1].equality_expression.Sizeof || yyAttrStackPtr [3-1].relational_expression.Sizeof;
  
			    yySynAttribute.equality_expression.Tree = mMPC_BinaryExpr(yySynAttribute.equality_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					NOT_EQUAL, yyAttrStackPtr [1-1].equality_expression.Tree,
					yyAttrStackPtr [3-1].relational_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.equality_expression.Tree);
			    yySynAttribute.equality_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.equality_expression.Ignore =
							  yyAttrStackPtr [1-1].equality_expression.Ignore ||
							  yyAttrStackPtr [3-1].relational_expression.Ignore;
			    yySynAttribute.equality_expression.Tree->MPC_Expr.BegPos = yySynAttribute.equality_expression.BegPos = yyAttrStackPtr [1-1].equality_expression.BegPos;  
			    yySynAttribute.equality_expression.Tree->MPC_Expr.EndPos = yySynAttribute.equality_expression.EndPos = yyAttrStackPtr [3-1].relational_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].equality_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].relational_expression.IsIntConst) {
			      yySynAttribute.equality_expression.IsIntConst = true;
			      yySynAttribute.equality_expression.Value = Eval_BinaryExpr(NOT_EQUAL,
					yyAttrStackPtr [1-1].equality_expression.Value,
					yyAttrStackPtr [3-1].relational_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.equality_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.equality_expression.Tree,yySynAttribute.equality_expression.Value);
			    }
			    else {
			      yySynAttribute.equality_expression.IsIntConst = false;
			      yySynAttribute.equality_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.equality_expression.Scope = yyAttrStackPtr [1-1].equality_expression.Scope || yyAttrStackPtr [3-1].relational_expression.Scope;

			;

} break;
case 1042: /* AND_expression : equality_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 173; {
/* line 2743 "mpcPars.lalr" */

			  yySynAttribute.AND_expression.Tree  =  yyAttrStackPtr [1-1].equality_expression.Tree;

			  yySynAttribute.AND_expression.IsIntConst  =  yyAttrStackPtr [1-1].equality_expression.IsIntConst;

			  yySynAttribute.AND_expression.Value  =  yyAttrStackPtr [1-1].equality_expression.Value;

			  yySynAttribute.AND_expression.Sizeof  =  yyAttrStackPtr [1-1].equality_expression.Sizeof;

			  yySynAttribute.AND_expression.Scope  =  yyAttrStackPtr [1-1].equality_expression.Scope;

			  yySynAttribute.AND_expression.Ignore  =  yyAttrStackPtr [1-1].equality_expression.Ignore;

			  yySynAttribute.AND_expression.Position  =  yyAttrStackPtr [1-1].equality_expression.Position;

			  yySynAttribute.AND_expression.BegPos  =  yyAttrStackPtr [1-1].equality_expression.BegPos;
  
			  yySynAttribute.AND_expression.EndPos  =  yyAttrStackPtr [1-1].equality_expression.EndPos;
  
			;

} break;
case 1043: /* AND_expression : AND_expression '&' equality_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 173; {
/* line 2764 "mpcPars.lalr" */

			  yySynAttribute.AND_expression.Sizeof = yyAttrStackPtr [1-1].AND_expression.Sizeof || yyAttrStackPtr [3-1].equality_expression.Sizeof;
  
			    yySynAttribute.AND_expression.Tree = mMPC_BinaryExpr(yySynAttribute.AND_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					AND, yyAttrStackPtr [1-1].AND_expression.Tree,
					yyAttrStackPtr [3-1].equality_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.AND_expression.Tree);
			    yySynAttribute.AND_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.AND_expression.Ignore =
							  yyAttrStackPtr [1-1].AND_expression.Ignore ||
							  yyAttrStackPtr [3-1].equality_expression.Ignore;
			    yySynAttribute.AND_expression.Tree->MPC_Expr.BegPos = yySynAttribute.AND_expression.BegPos = yyAttrStackPtr [1-1].AND_expression.BegPos;  
			    yySynAttribute.AND_expression.Tree->MPC_Expr.EndPos = yySynAttribute.AND_expression.EndPos = yyAttrStackPtr [3-1].equality_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].AND_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].equality_expression.IsIntConst) {
			      yySynAttribute.AND_expression.IsIntConst = true;
			      yySynAttribute.AND_expression.Value = Eval_BinaryExpr(AND,
					yyAttrStackPtr [1-1].AND_expression.Value,
					yyAttrStackPtr [3-1].equality_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.AND_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.AND_expression.Tree,yySynAttribute.AND_expression.Value);
			    }
			    else {
			      yySynAttribute.AND_expression.IsIntConst = false;
			      yySynAttribute.AND_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.AND_expression.Scope = yyAttrStackPtr [1-1].AND_expression.Scope || yyAttrStackPtr [3-1].equality_expression.Scope;

			;

} break;
case 1044: /* exclusive_OR_expression : AND_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 174; {
/* line 2798 "mpcPars.lalr" */

			  yySynAttribute.exclusive_OR_expression.Tree  =  yyAttrStackPtr [1-1].AND_expression.Tree;

			  yySynAttribute.exclusive_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].AND_expression.IsIntConst;

			  yySynAttribute.exclusive_OR_expression.Value  =  yyAttrStackPtr [1-1].AND_expression.Value;

			  yySynAttribute.exclusive_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].AND_expression.Sizeof;

			  yySynAttribute.exclusive_OR_expression.Scope  =  yyAttrStackPtr [1-1].AND_expression.Scope;

			  yySynAttribute.exclusive_OR_expression.Ignore  =  yyAttrStackPtr [1-1].AND_expression.Ignore;

			  yySynAttribute.exclusive_OR_expression.Position  =  yyAttrStackPtr [1-1].AND_expression.Position;

			  yySynAttribute.exclusive_OR_expression.BegPos  =  yyAttrStackPtr [1-1].AND_expression.BegPos;
  
			  yySynAttribute.exclusive_OR_expression.EndPos  =  yyAttrStackPtr [1-1].AND_expression.EndPos;
  
			;

} break;
case 1045: /* exclusive_OR_expression : exclusive_OR_expression '^' AND_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 174; {
/* line 2819 "mpcPars.lalr" */

			  yySynAttribute.exclusive_OR_expression.Sizeof = yyAttrStackPtr [1-1].exclusive_OR_expression.Sizeof || yyAttrStackPtr [3-1].AND_expression.Sizeof;
  
			    yySynAttribute.exclusive_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.exclusive_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					EXCL_OR, yyAttrStackPtr [1-1].exclusive_OR_expression.Tree,
					yyAttrStackPtr [3-1].AND_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.exclusive_OR_expression.Tree);
			    yySynAttribute.exclusive_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.exclusive_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].exclusive_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].AND_expression.Ignore;
			    yySynAttribute.exclusive_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.exclusive_OR_expression.BegPos = yyAttrStackPtr [1-1].exclusive_OR_expression.BegPos;  
			    yySynAttribute.exclusive_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.exclusive_OR_expression.EndPos = yyAttrStackPtr [3-1].AND_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].exclusive_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].AND_expression.IsIntConst) {
			      yySynAttribute.exclusive_OR_expression.IsIntConst = true;
			      yySynAttribute.exclusive_OR_expression.Value = Eval_BinaryExpr(EXCL_OR,
					yyAttrStackPtr [1-1].exclusive_OR_expression.Value,
					yyAttrStackPtr [3-1].AND_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.exclusive_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.exclusive_OR_expression.Tree,yySynAttribute.exclusive_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.exclusive_OR_expression.IsIntConst = false;
			      yySynAttribute.exclusive_OR_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.exclusive_OR_expression.Scope = yyAttrStackPtr [1-1].exclusive_OR_expression.Scope || yyAttrStackPtr [3-1].AND_expression.Scope;

			;

} break;
case 1046: /* inclusive_OR_expression : exclusive_OR_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 175; {
/* line 2853 "mpcPars.lalr" */

			  yySynAttribute.inclusive_OR_expression.Tree  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Tree;

			  yySynAttribute.inclusive_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].exclusive_OR_expression.IsIntConst;

			  yySynAttribute.inclusive_OR_expression.Value  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Value;

			  yySynAttribute.inclusive_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Sizeof;

			  yySynAttribute.inclusive_OR_expression.Scope  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Scope;

			  yySynAttribute.inclusive_OR_expression.Ignore  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Ignore;

			  yySynAttribute.inclusive_OR_expression.Position  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Position;

			  yySynAttribute.inclusive_OR_expression.BegPos  =  yyAttrStackPtr [1-1].exclusive_OR_expression.BegPos;
  
			  yySynAttribute.inclusive_OR_expression.EndPos  =  yyAttrStackPtr [1-1].exclusive_OR_expression.EndPos;
  
			;

} break;
case 1047: /* inclusive_OR_expression : inclusive_OR_expression '|' exclusive_OR_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 175; {
/* line 2874 "mpcPars.lalr" */

			  yySynAttribute.inclusive_OR_expression.Sizeof = yyAttrStackPtr [1-1].inclusive_OR_expression.Sizeof || yyAttrStackPtr [3-1].exclusive_OR_expression.Sizeof;
  
			    yySynAttribute.inclusive_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.inclusive_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					INCL_OR, yyAttrStackPtr [1-1].inclusive_OR_expression.Tree,
					yyAttrStackPtr [3-1].exclusive_OR_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.inclusive_OR_expression.Tree);
			    yySynAttribute.inclusive_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.inclusive_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].inclusive_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].exclusive_OR_expression.Ignore;
			    yySynAttribute.inclusive_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.inclusive_OR_expression.BegPos = yyAttrStackPtr [1-1].inclusive_OR_expression.BegPos;  
			    yySynAttribute.inclusive_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.inclusive_OR_expression.EndPos = yyAttrStackPtr [3-1].exclusive_OR_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].inclusive_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].exclusive_OR_expression.IsIntConst) {
			      yySynAttribute.inclusive_OR_expression.IsIntConst = true;
			      yySynAttribute.inclusive_OR_expression.Value = Eval_BinaryExpr(INCL_OR,
					yyAttrStackPtr [1-1].inclusive_OR_expression.Value,
					yyAttrStackPtr [3-1].exclusive_OR_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.inclusive_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.inclusive_OR_expression.Tree,yySynAttribute.inclusive_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.inclusive_OR_expression.IsIntConst = false;
			      yySynAttribute.inclusive_OR_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.inclusive_OR_expression.Scope = yyAttrStackPtr [1-1].inclusive_OR_expression.Scope || yyAttrStackPtr [3-1].exclusive_OR_expression.Scope;

			;

} break;
case 1048: /* logical_AND_expression : inclusive_OR_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 176; {
/* line 2908 "mpcPars.lalr" */

			  yySynAttribute.logical_AND_expression.Tree  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Tree;

			  yySynAttribute.logical_AND_expression.IsIntConst  =  yyAttrStackPtr [1-1].inclusive_OR_expression.IsIntConst;

			  yySynAttribute.logical_AND_expression.Value  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Value;

			  yySynAttribute.logical_AND_expression.Sizeof  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Sizeof;

			  yySynAttribute.logical_AND_expression.Scope  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Scope;

			  yySynAttribute.logical_AND_expression.Ignore  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Ignore;

			  yySynAttribute.logical_AND_expression.Position  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Position;

			  yySynAttribute.logical_AND_expression.BegPos  =  yyAttrStackPtr [1-1].inclusive_OR_expression.BegPos;
  
			  yySynAttribute.logical_AND_expression.EndPos  =  yyAttrStackPtr [1-1].inclusive_OR_expression.EndPos;
  
			;

} break;
case 1049: /* logical_AND_expression : logical_AND_expression '&&' inclusive_OR_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 176; {
/* line 2929 "mpcPars.lalr" */

			  yySynAttribute.logical_AND_expression.Sizeof = yyAttrStackPtr [1-1].logical_AND_expression.Sizeof || yyAttrStackPtr [3-1].inclusive_OR_expression.Sizeof;
  
			    yySynAttribute.logical_AND_expression.Tree = mMPC_BinaryExpr(yySynAttribute.logical_AND_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LOG_AND, yyAttrStackPtr [1-1].logical_AND_expression.Tree,
					yyAttrStackPtr [3-1].inclusive_OR_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.logical_AND_expression.Tree);
			    yySynAttribute.logical_AND_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.logical_AND_expression.Ignore =
							  yyAttrStackPtr [1-1].logical_AND_expression.Ignore ||
							  yyAttrStackPtr [3-1].inclusive_OR_expression.Ignore;
			    yySynAttribute.logical_AND_expression.Tree->MPC_Expr.BegPos = yySynAttribute.logical_AND_expression.BegPos =yyAttrStackPtr [1-1].logical_AND_expression.BegPos;  
			    yySynAttribute.logical_AND_expression.Tree->MPC_Expr.EndPos = yySynAttribute.logical_AND_expression.EndPos =yyAttrStackPtr [3-1].inclusive_OR_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].logical_AND_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].inclusive_OR_expression.IsIntConst) {
			      yySynAttribute.logical_AND_expression.IsIntConst = true;
			      yySynAttribute.logical_AND_expression.Value = Eval_BinaryExpr(LOG_AND,
					yyAttrStackPtr [1-1].logical_AND_expression.Value,
					yyAttrStackPtr [3-1].inclusive_OR_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.logical_AND_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.logical_AND_expression.Tree,yySynAttribute.logical_AND_expression.Value);
			    }
			    else {
			      yySynAttribute.logical_AND_expression.IsIntConst = false;
			      yySynAttribute.logical_AND_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.logical_AND_expression.Scope = yyAttrStackPtr [1-1].logical_AND_expression.Scope || yyAttrStackPtr [3-1].inclusive_OR_expression.Scope;

			;

} break;
case 1050: /* logical_OR_expression : logical_AND_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 177; {
/* line 2963 "mpcPars.lalr" */

			  yySynAttribute.logical_OR_expression.Tree  =  yyAttrStackPtr [1-1].logical_AND_expression.Tree;

			  yySynAttribute.logical_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].logical_AND_expression.IsIntConst;

			  yySynAttribute.logical_OR_expression.Value  =  yyAttrStackPtr [1-1].logical_AND_expression.Value;

			  yySynAttribute.logical_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].logical_AND_expression.Sizeof;

			  yySynAttribute.logical_OR_expression.Scope  =  yyAttrStackPtr [1-1].logical_AND_expression.Scope;

			  yySynAttribute.logical_OR_expression.Ignore  =  yyAttrStackPtr [1-1].logical_AND_expression.Ignore;

			  yySynAttribute.logical_OR_expression.Position  =  yyAttrStackPtr [1-1].logical_AND_expression.Position;

			  yySynAttribute.logical_OR_expression.BegPos  =  yyAttrStackPtr [1-1].logical_AND_expression.BegPos;
  
			  yySynAttribute.logical_OR_expression.EndPos  =  yyAttrStackPtr [1-1].logical_AND_expression.EndPos;
  
			;

} break;
case 1051: /* logical_OR_expression : logical_OR_expression '||' logical_AND_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 177; {
/* line 2984 "mpcPars.lalr" */

			  yySynAttribute.logical_OR_expression.Sizeof = yyAttrStackPtr [1-1].logical_OR_expression.Sizeof || yyAttrStackPtr [3-1].logical_AND_expression.Sizeof;
  
			    yySynAttribute.logical_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.logical_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LOG_OR, yyAttrStackPtr [1-1].logical_OR_expression.Tree,
					yyAttrStackPtr [3-1].logical_AND_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.logical_OR_expression.Tree);
			    yySynAttribute.logical_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.logical_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].logical_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].logical_AND_expression.Ignore;
			    yySynAttribute.logical_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.logical_OR_expression.BegPos = yyAttrStackPtr [1-1].logical_OR_expression.BegPos;  
			    yySynAttribute.logical_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.logical_OR_expression.EndPos = yyAttrStackPtr [3-1].logical_AND_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].logical_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].logical_AND_expression.IsIntConst) {
			      yySynAttribute.logical_OR_expression.IsIntConst = true;
			      yySynAttribute.logical_OR_expression.Value = Eval_BinaryExpr(LOG_OR,
					yyAttrStackPtr [1-1].logical_OR_expression.Value,
					yyAttrStackPtr [3-1].logical_AND_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.logical_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.logical_OR_expression.Tree,yySynAttribute.logical_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.logical_OR_expression.IsIntConst = false;
			      yySynAttribute.logical_OR_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.logical_OR_expression.Scope = yyAttrStackPtr [1-1].logical_OR_expression.Scope || yyAttrStackPtr [3-1].logical_AND_expression.Scope;

			;

} break;
case 1052: /* conditional_expression : logical_OR_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 178; {
/* line 3018 "mpcPars.lalr" */

			  yySynAttribute.conditional_expression.Tree  =  yyAttrStackPtr [1-1].logical_OR_expression.Tree;

			  yySynAttribute.conditional_expression.IsIntConst  =  yyAttrStackPtr [1-1].logical_OR_expression.IsIntConst;

			  yySynAttribute.conditional_expression.Value  =  yyAttrStackPtr [1-1].logical_OR_expression.Value;

			  yySynAttribute.conditional_expression.Sizeof  =  yyAttrStackPtr [1-1].logical_OR_expression.Sizeof;

			  yySynAttribute.conditional_expression.Scope  =  yyAttrStackPtr [1-1].logical_OR_expression.Scope;

			  yySynAttribute.conditional_expression.Ignore  =  yyAttrStackPtr [1-1].logical_OR_expression.Ignore;

			  yySynAttribute.conditional_expression.Position  =  yyAttrStackPtr [1-1].logical_OR_expression.Position;

			  yySynAttribute.conditional_expression.BegPos  =  yyAttrStackPtr [1-1].logical_OR_expression.BegPos;
  
			  yySynAttribute.conditional_expression.EndPos  =  yyAttrStackPtr [1-1].logical_OR_expression.EndPos;
  
			;

} break;
case 1053: /* conditional_expression : logical_OR_expression '?' expression ':' conditional_expression .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 178; {
/* line 3039 "mpcPars.lalr" */

			  yySynAttribute.conditional_expression.Sizeof = yyAttrStackPtr [1-1].logical_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].expression.Sizeof || yyAttrStackPtr [5-1].conditional_expression.Sizeof;
  
			    if(yyAttrStackPtr [5-1].conditional_expression.Tree==NoTree)
				CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;
			    yySynAttribute.conditional_expression.Tree = mMPC_TernaryExpr(yySynAttribute.conditional_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					CONDITION, yyAttrStackPtr [1-1].logical_OR_expression.Tree,
					yyAttrStackPtr [3-1].expression.Tree, yyAttrStackPtr [5-1].conditional_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.conditional_expression.Tree);
			    yySynAttribute.conditional_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.conditional_expression.Ignore =
							yyAttrStackPtr [1-1].logical_OR_expression.Ignore ||
							yyAttrStackPtr [3-1].expression.Ignore        ||
							yyAttrStackPtr [5-1].conditional_expression.Ignore;
			    yySynAttribute.conditional_expression.Tree->MPC_Expr.BegPos = yySynAttribute.conditional_expression.BegPos = yyAttrStackPtr [1-1].logical_OR_expression.BegPos;  
			    yySynAttribute.conditional_expression.Tree->MPC_Expr.EndPos = yySynAttribute.conditional_expression.EndPos =   
				(yyAttrStackPtr [5-1].conditional_expression.Tree==NoTree)?yyAttrStackPtr [4-1].Scan.Position :  
							yyAttrStackPtr [5-1].conditional_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].logical_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].expression.IsIntConst        &&
			       yyAttrStackPtr [5-1].conditional_expression.IsIntConst) {
			      if(yyAttrStackPtr [1-1].logical_OR_expression.Value)
				yySynAttribute.conditional_expression.Value = yyAttrStackPtr [3-1].expression.Value;
			      else
				yySynAttribute.conditional_expression.Value = yyAttrStackPtr [5-1].conditional_expression.Value;
			      if(!yySynAttribute.conditional_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.conditional_expression.Tree,yySynAttribute.conditional_expression.Value);
			    }
			    else {
			      yySynAttribute.conditional_expression.IsIntConst = false;
			      yySynAttribute.conditional_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.conditional_expression.Scope = yyAttrStackPtr [1-1].logical_OR_expression.Scope ||
						yyAttrStackPtr [3-1].expression.Scope ||
							yyAttrStackPtr [5-1].conditional_expression.Scope;

			;

} break;
case 1054: /* quaternary_assignment : unary_expression '<-' expression_opt '@' expression_opt '@' unary_expression .*/
  yyStateStackPtr -= 7; yyAttrStackPtr -= 7; yyNonterminal = 179; {
/* line 3080 "mpcPars.lalr" */

			  yySynAttribute.quaternary_assignment.Sizeof = yyAttrStackPtr [1-1].unary_expression.Sizeof || yyAttrStackPtr [3-1].expression_opt.Sizeof || yyAttrStackPtr [5-1].expression_opt.Sizeof || yyAttrStackPtr [7-1].unary_expression.Sizeof;

			    yySynAttribute.quaternary_assignment.Tree = mMPC_QuaternaryExpr(yySynAttribute.quaternary_assignment.Position=yyAttrStackPtr [2-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree, NoTree,
					NoTree, SCAT_ASSIGN,
					yyAttrStackPtr [1-1].unary_expression.Tree, yyAttrStackPtr [3-1].expression_opt.Tree,
					yyAttrStackPtr [5-1].expression_opt.Tree, yyAttrStackPtr [7-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.quaternary_assignment.Tree);
                            yySynAttribute.quaternary_assignment.Tree->MPC_QuaternaryExpr.Operand2 =
                                  yyAttrStackPtr [3-1].expression_opt.Tree ? yyAttrStackPtr [3-1].expression_opt.Tree : mMPC_FreeNode(yySynAttribute.quaternary_assignment.Tree);
                            yySynAttribute.quaternary_assignment.Tree->MPC_QuaternaryExpr.Operand3 =
                                  yyAttrStackPtr [5-1].expression_opt.Tree ? yyAttrStackPtr [5-1].expression_opt.Tree : mMPC_FreeNode(yySynAttribute.quaternary_assignment.Tree);
			    ExprScopeEnd();    
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.quaternary_assignment.Ignore =
							  yyAttrStackPtr [1-1].unary_expression.Ignore || yyAttrStackPtr [3-1].expression_opt.Ignore ||
							  yyAttrStackPtr [5-1].expression_opt.Ignore  || yyAttrStackPtr [7-1].unary_expression.Ignore;
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.BegPos = yySynAttribute.quaternary_assignment.BegPos = yyAttrStackPtr [1-1].unary_expression.BegPos;  
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.EndPos = yySynAttribute.quaternary_assignment.EndPos = yyAttrStackPtr [7-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.quaternary_assignment.IsIntConst = false;
 yySynAttribute.quaternary_assignment.Value = 0;

			  yySynAttribute.quaternary_assignment.Scope = yyAttrStackPtr [1-1].unary_expression.Scope || yyAttrStackPtr [3-1].expression_opt.Scope || yyAttrStackPtr [5-1].expression_opt.Scope || yyAttrStackPtr [7-1].unary_expression.Scope;

			;

} break;
case 1055: /* quaternary_assignment : unary_expression '@@' expression_opt '@@' expression_opt '<-' unary_expression .*/
  yyStateStackPtr -= 7; yyAttrStackPtr -= 7; yyNonterminal = 179; {
/* line 3109 "mpcPars.lalr" */

			  yySynAttribute.quaternary_assignment.Sizeof = yyAttrStackPtr [1-1].unary_expression.Sizeof || yyAttrStackPtr [3-1].expression_opt.Sizeof || yyAttrStackPtr [5-1].expression_opt.Sizeof || yyAttrStackPtr [7-1].unary_expression.Sizeof;
  
			    yySynAttribute.quaternary_assignment.Tree = mMPC_QuaternaryExpr(yySynAttribute.quaternary_assignment.Position=yyAttrStackPtr [6-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree, NoTree,
					NoTree, SCAT_ASSIGN,
					yyAttrStackPtr [1-1].unary_expression.Tree, yyAttrStackPtr [3-1].expression_opt.Tree,
					yyAttrStackPtr [5-1].expression_opt.Tree, yyAttrStackPtr [7-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.quaternary_assignment.Tree);
                            yySynAttribute.quaternary_assignment.Tree->MPC_QuaternaryExpr.Operand2 =
                                  yyAttrStackPtr [3-1].expression_opt.Tree ? yyAttrStackPtr [3-1].expression_opt.Tree : mMPC_FreeNode(yySynAttribute.quaternary_assignment.Tree);
                            yySynAttribute.quaternary_assignment.Tree->MPC_QuaternaryExpr.Operand3 =
                                  yyAttrStackPtr [5-1].expression_opt.Tree ? yyAttrStackPtr [5-1].expression_opt.Tree : mMPC_FreeNode(yySynAttribute.quaternary_assignment.Tree);
			    ExprScopeEnd();    
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.quaternary_assignment.Ignore =
							  yyAttrStackPtr [1-1].unary_expression.Ignore || yyAttrStackPtr [3-1].expression_opt.Ignore ||
							  yyAttrStackPtr [5-1].expression_opt.Ignore  || yyAttrStackPtr [7-1].unary_expression.Ignore;
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.BegPos = yySynAttribute.quaternary_assignment.BegPos = yyAttrStackPtr [1-1].unary_expression.BegPos;  
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.EndPos = yySynAttribute.quaternary_assignment.EndPos = yyAttrStackPtr [7-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.quaternary_assignment.IsIntConst = false;
 yySynAttribute.quaternary_assignment.Value = 0;

			  yySynAttribute.quaternary_assignment.Scope = yyAttrStackPtr [1-1].unary_expression.Scope || yyAttrStackPtr [3-1].expression_opt.Scope || yyAttrStackPtr [5-1].expression_opt.Scope || yyAttrStackPtr [7-1].unary_expression.Scope;

			;

} break;
case 1056: /* assignment_expression : conditional_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 155; {
/* line 3138 "mpcPars.lalr" */

			    yySynAttribute.assignment_expression.Tree = yyAttrStackPtr [1-1].conditional_expression.Tree;
			    ExprScopeEnd();    
			  ;

			  yySynAttribute.assignment_expression.IsIntConst  =  yyAttrStackPtr [1-1].conditional_expression.IsIntConst;

			  yySynAttribute.assignment_expression.Value  =  yyAttrStackPtr [1-1].conditional_expression.Value;

			  yySynAttribute.assignment_expression.Sizeof  =  yyAttrStackPtr [1-1].conditional_expression.Sizeof;

			  yySynAttribute.assignment_expression.Scope  =  yyAttrStackPtr [1-1].conditional_expression.Scope;

			  yySynAttribute.assignment_expression.Ignore  =  yyAttrStackPtr [1-1].conditional_expression.Ignore;

			  yySynAttribute.assignment_expression.Position  =  yyAttrStackPtr [1-1].conditional_expression.Position;

			  yySynAttribute.assignment_expression.BegPos  =  yyAttrStackPtr [1-1].conditional_expression.BegPos;
  
			  yySynAttribute.assignment_expression.EndPos  =  yyAttrStackPtr [1-1].conditional_expression.EndPos;
  
			;

} break;
case 1057: /* assignment_expression : unary_expression assignment_operator assignment_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 155; {
/* line 3161 "mpcPars.lalr" */
yySynAttribute.assignment_expression.EndPos = yyAttrStackPtr [3-1].assignment_expression.EndPos;

			  yySynAttribute.assignment_expression.Sizeof = yyAttrStackPtr [1-1].unary_expression.Sizeof || yyAttrStackPtr [3-1].assignment_expression.Sizeof;
  
			    yySynAttribute.assignment_expression.Tree = mMPC_BinaryExpr(yySynAttribute.assignment_expression.Position=yyAttrStackPtr [2-1].assignment_operator.Position,
					NoExprFlag, EmptyString, NoTree, NoTree,
					NoTree, yyAttrStackPtr [2-1].assignment_operator.OpCode,
					yyAttrStackPtr [1-1].unary_expression.Tree,
					yyAttrStackPtr [3-1].assignment_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.assignment_expression.Tree);
			    ExprScopeEnd();    
			    yySynAttribute.assignment_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.assignment_expression.Ignore =
							  yyAttrStackPtr [1-1].unary_expression.Ignore ||
							  yyAttrStackPtr [3-1].assignment_expression.Ignore;
			    yySynAttribute.assignment_expression.Tree->MPC_Expr.BegPos = yySynAttribute.assignment_expression.BegPos = yyAttrStackPtr [1-1].unary_expression.BegPos;  
			    yySynAttribute.assignment_expression.Tree->MPC_Expr.EndPos = yySynAttribute.assignment_expression.EndPos = yyAttrStackPtr [3-1].assignment_expression.EndPos;  
			  ;

			    if(yyAttrStackPtr [1-1].unary_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].assignment_expression.IsIntConst) {
			      yySynAttribute.assignment_expression.IsIntConst = true;
			      yySynAttribute.assignment_expression.Value = Eval_BinaryExpr(yyAttrStackPtr [2-1].assignment_operator.OpCode,
					yyAttrStackPtr [1-1].unary_expression.Value,
					yyAttrStackPtr [3-1].assignment_expression.Value,
					yyAttrStackPtr [2-1].assignment_operator.Position
				      );
			    }
			    else {
			      yySynAttribute.assignment_expression.IsIntConst = false;
			      yySynAttribute.assignment_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.assignment_expression.Scope = yyAttrStackPtr [1-1].unary_expression.Scope || yyAttrStackPtr [3-1].assignment_expression.Scope;

			;

} break;
case 1058: /* assignment_expression : quaternary_assignment .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 155; {
/* line 3199 "mpcPars.lalr" */

			    yySynAttribute.assignment_expression.Tree = yyAttrStackPtr [1-1].quaternary_assignment.Tree;
			    ExprScopeEnd();    
			  ;

			  yySynAttribute.assignment_expression.IsIntConst  =  yyAttrStackPtr [1-1].quaternary_assignment.IsIntConst;

			  yySynAttribute.assignment_expression.Value  =  yyAttrStackPtr [1-1].quaternary_assignment.Value;

			  yySynAttribute.assignment_expression.Sizeof  =  yyAttrStackPtr [1-1].quaternary_assignment.Sizeof;

			  yySynAttribute.assignment_expression.Scope  =  yyAttrStackPtr [1-1].quaternary_assignment.Scope;

			  yySynAttribute.assignment_expression.Ignore  =  yyAttrStackPtr [1-1].quaternary_assignment.Ignore;

			  yySynAttribute.assignment_expression.Position  =  yyAttrStackPtr [1-1].quaternary_assignment.Position;

			  yySynAttribute.assignment_expression.BegPos  =  yyAttrStackPtr [1-1].quaternary_assignment.BegPos;
  
			  yySynAttribute.assignment_expression.EndPos  =  yyAttrStackPtr [1-1].quaternary_assignment.EndPos;

			    
			;

} break;
case 1059: /* assignment_operator : '=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3223 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1060: /* assignment_operator : '*=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3227 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=MULT_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1061: /* assignment_operator : '/=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3231 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=DIV_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1062: /* assignment_operator : '%=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3235 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=MOD_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1063: /* assignment_operator : '+=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3239 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=PLUS_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1064: /* assignment_operator : '-=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3243 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=MINUS_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1065: /* assignment_operator : '<<=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3247 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=LSHIFT_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1066: /* assignment_operator : '>>=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3251 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=RSHIFT_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1067: /* assignment_operator : '&=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3255 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=AND_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1068: /* assignment_operator : '^=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3259 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=EXCL_OR_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1069: /* assignment_operator : '|=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 180; {
/* line 3263 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=INCL_OR_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1070: /* expression : assignment_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 143; {
/* line 3267 "mpcPars.lalr" */

			  yySynAttribute.expression.Tree  =  yyAttrStackPtr [1-1].assignment_expression.Tree;

			  yySynAttribute.expression.IsIntConst  =  yyAttrStackPtr [1-1].assignment_expression.IsIntConst;

			  yySynAttribute.expression.Value  =  yyAttrStackPtr [1-1].assignment_expression.Value;

			  yySynAttribute.expression.Sizeof  =  yyAttrStackPtr [1-1].assignment_expression.Sizeof;

			  yySynAttribute.expression.Scope  =  yyAttrStackPtr [1-1].assignment_expression.Scope;

			  yySynAttribute.expression.Ignore  =  yyAttrStackPtr [1-1].assignment_expression.Ignore;

			  yySynAttribute.expression.Position  =  yyAttrStackPtr [1-1].assignment_expression.Position;

			  yySynAttribute.expression.BegPos  =  yyAttrStackPtr [1-1].assignment_expression.BegPos;
  
			  yySynAttribute.expression.EndPos  =  yyAttrStackPtr [1-1].assignment_expression.EndPos;
  
			;

} break;
case 1071: /* expression : expression ',' assignment_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 143; {
/* line 3288 "mpcPars.lalr" */

			  yySynAttribute.expression.Sizeof = yyAttrStackPtr [1-1].expression.Sizeof || yyAttrStackPtr [3-1].assignment_expression.Sizeof;
  
			    yySynAttribute.expression.Tree = mMPC_BinaryExpr(yySynAttribute.expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					COMMA, yyAttrStackPtr [1-1].expression.Tree,
					yyAttrStackPtr [3-1].assignment_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.expression.Tree);
			    yySynAttribute.expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.expression.Ignore =
							  yyAttrStackPtr [1-1].expression.Ignore ||
							  yyAttrStackPtr [3-1].assignment_expression.Ignore;
			    yySynAttribute.expression.Tree->MPC_Expr.BegPos = yySynAttribute.expression.BegPos = yyAttrStackPtr [1-1].expression.BegPos;  
			    yySynAttribute.expression.Tree->MPC_Expr.EndPos = yySynAttribute.expression.EndPos = yyAttrStackPtr [3-1].assignment_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].expression.IsIntConst && yyAttrStackPtr [3-1].assignment_expression.IsIntConst) {
			      yySynAttribute.expression.IsIntConst = true;
			      yySynAttribute.expression.Value = Eval_BinaryExpr(COMMA,
					yyAttrStackPtr [1-1].expression.Value,
					yyAttrStackPtr [3-1].assignment_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.expression.Tree,yySynAttribute.expression.Value);
			    }
			    else {
			      yySynAttribute.expression.IsIntConst = false;
			      yySynAttribute.expression.Value = 0;
			    }
			  ;

			  yySynAttribute.expression.Scope = yyAttrStackPtr [1-1].expression.Scope || yyAttrStackPtr [3-1].assignment_expression.Scope;

			;

} break;
case 1072: /* expression_opt : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 148; {
/* line 3321 "mpcPars.lalr" */

			  yySynAttribute.expression_opt.Tree = NoTree;

			  yySynAttribute.expression_opt.IsIntConst = false;

			  yySynAttribute.expression_opt.Value = 0;

			  yySynAttribute.expression_opt.Sizeof = false;

			  yySynAttribute.expression_opt.Scope = false;

			  yySynAttribute.expression_opt.Ignore = false;

			  yySynAttribute.expression_opt.Position = NoPosition;

			  yySynAttribute.expression_opt.BegPos = NoPosition;

			;

} break;
case 1073: /* expression_opt : expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 148; {
/* line 3340 "mpcPars.lalr" */

			  yySynAttribute.expression_opt.Tree  =  yyAttrStackPtr [1-1].expression.Tree;

			  yySynAttribute.expression_opt.IsIntConst  =  yyAttrStackPtr [1-1].expression.IsIntConst;

			  yySynAttribute.expression_opt.Value  =  yyAttrStackPtr [1-1].expression.Value;

			  yySynAttribute.expression_opt.Sizeof  =  yyAttrStackPtr [1-1].expression.Sizeof;

			  yySynAttribute.expression_opt.Scope  =  yyAttrStackPtr [1-1].expression.Scope;

			  yySynAttribute.expression_opt.Ignore  =  yyAttrStackPtr [1-1].expression.Ignore;

			  yySynAttribute.expression_opt.Position  =  yyAttrStackPtr [1-1].expression.Position;

			  yySynAttribute.expression_opt.BegPos  =  yyAttrStackPtr [1-1].expression.BegPos;
  
			;

} break;
case 1074: /* const_unary_expression : net_cast_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 181; {
/* line 3359 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Tree  =  yyAttrStackPtr [1-1].net_cast_expression.Tree;

			  yySynAttribute.const_unary_expression.IsIntConst  =  yyAttrStackPtr [1-1].net_cast_expression.IsIntConst;

			  yySynAttribute.const_unary_expression.Value  =  yyAttrStackPtr [1-1].net_cast_expression.Value;

			  yySynAttribute.const_unary_expression.Sizeof  =  yyAttrStackPtr [1-1].net_cast_expression.Sizeof;

			  yySynAttribute.const_unary_expression.Ignore  =  yyAttrStackPtr [1-1].net_cast_expression.Ignore;

			  yySynAttribute.const_unary_expression.Position  =  yyAttrStackPtr [1-1].net_cast_expression.Position;

			  yySynAttribute.const_unary_expression.BegPos  =  yyAttrStackPtr [1-1].net_cast_expression.BegPos;
  
			  yySynAttribute.const_unary_expression.EndPos  =  yyAttrStackPtr [1-1].net_cast_expression.EndPos;
  
			;

} break;
case 1075: /* const_unary_expression : const_unary_operator cast_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 181; {
/* line 3378 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof  =  yyAttrStackPtr [2-1].cast_expression.Sizeof;
  
			    yySynAttribute.const_unary_expression.Tree = mMPC_UnaryExpr(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].const_unary_operator.Position,
					NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [1-1].const_unary_operator.OpCode, yyAttrStackPtr [2-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [2-1].cast_expression.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yyAttrStackPtr [1-1].const_unary_operator.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [2-1].cast_expression.EndPos;  
			    yySynAttribute.const_unary_expression.IsIntConst = yyAttrStackPtr [2-1].cast_expression.IsIntConst;
			    if(yySynAttribute.const_unary_expression.IsIntConst) {
			      yySynAttribute.const_unary_expression.Value = Eval_UnaryExpr(
					yyAttrStackPtr [1-1].const_unary_operator.OpCode,
					yyAttrStackPtr [2-1].cast_expression.Value, yyAttrStackPtr [1-1].const_unary_operator.Position
				      );
			      if(!yySynAttribute.const_unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_unary_expression.Tree,yySynAttribute.const_unary_expression.Value);
			    }
			    else
			      yySynAttribute.const_unary_expression.Value = UNDEFINED;
			  ;

			;

} break;
case 1076: /* const_unary_expression : sizeof unary_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 181; {
/* line 3404 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = true;
  
			    yySynAttribute.const_unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					false, 0,
					yyAttrStackPtr [2-1].unary_expression.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yySynAttribute.const_unary_expression.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.const_unary_expression.IsIntConst = true;

			  yySynAttribute.const_unary_expression.Value=Eval_SizeofExpr(yyAttrStackPtr [2-1].unary_expression.Tree, yyAttrStackPtr [1-1].Scan.Position);

			;

} break;
case 1077: /* const_unary_expression : mpc_sizeof unary_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 181; {
/* line 3424 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = false;
  
			    yySynAttribute.const_unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					true, 0,
					yyAttrStackPtr [2-1].unary_expression.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.EndPos;  
			    yySynAttribute.const_unary_expression.IsIntConst = true;
			    yySynAttribute.const_unary_expression.Value = Eval_SizeofExpr(yyAttrStackPtr [2-1].unary_expression.Tree, yyAttrStackPtr [1-1].Scan.Position);
			    if(!yySynAttribute.const_unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_unary_expression.Tree,yySynAttribute.const_unary_expression.Value);
			  ;

			;

} break;
case 1078: /* const_unary_expression : sizeof '(' nested_type_on type_name nested_type_off ')' .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 181; {
/* line 3443 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = true;
  
			    CurrentPosition = yyAttrStackPtr [6-1].Scan.Position;
			    yySynAttribute.const_unary_expression.Tree = mMPC_Size_Of_Type(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					false, 0,
					yyAttrStackPtr [4-1].type_name.Type 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [6-1].Scan.Position;  
			  ;

			  yySynAttribute.const_unary_expression.IsIntConst = true;

			  yySynAttribute.const_unary_expression.Value=Eval_SizeofExpr(yyAttrStackPtr [4-1].type_name.Type, yyAttrStackPtr [1-1].Scan.Position);

			;

} break;
case 1079: /* const_unary_expression : mpc_sizeof '(' nested_type_on type_name nested_type_off ')' .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 181; {
/* line 3465 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = false;
  
			    CurrentPosition = yyAttrStackPtr [6-1].Scan.Position;
			    yySynAttribute.const_unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					true, 0,
					yyAttrStackPtr [4-1].type_name.Type 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [6-1].Scan.Position;  
			    yySynAttribute.const_unary_expression.IsIntConst = true;
			    yySynAttribute.const_unary_expression.Value = Eval_SizeofExpr(yyAttrStackPtr [4-1].type_name.Type, yyAttrStackPtr [1-1].Scan.Position);
			    if(!yySynAttribute.const_unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_unary_expression.Tree,yySynAttribute.const_unary_expression.Value);
			  ;

			;

} break;
case 1080: /* const_unary_expression : timeof new_scope '(' empty_net_declaring_list ')' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 181; {
/* line 3485 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = false;

			  yySynAttribute.const_unary_expression.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.const_unary_expression.EndPos  =  yyAttrStackPtr [5-1].Scan.Position;

			    yySynAttribute.const_unary_expression.Tree = mMPC_TimeofExpr(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
						   DoubleType, CONST_NET_LIST, CONST_NET,
						   yyAttrStackPtr [4-1].empty_net_declaring_list.Tree
				   );
			    yyAttrStackPtr [4-1].empty_net_declaring_list.Tree->MPC_NetDecl.Next =
				yyAttrStackPtr [4-1].empty_net_declaring_list.Tree->MPC_NetDecl.Prev = mMPC_FreeNode(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Ignore = yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yyAttrStackPtr [4-1].empty_net_declaring_list.Ignore;
			    Close_Scope(), Scope_Depth--;
			  ;

			  yySynAttribute.const_unary_expression.IsIntConst = false;

			  yySynAttribute.const_unary_expression.Value = 0;
 
			;

} break;
case 1081: /* const_unary_expression : timeof new_scope '(' single_net_declaring_list ')' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 181; {
/* line 3508 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = false;

			  yySynAttribute.const_unary_expression.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.const_unary_expression.EndPos  =  yyAttrStackPtr [5-1].Scan.Position;

			    yySynAttribute.const_unary_expression.Tree = mMPC_TimeofExpr(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
						   DoubleType, CONST_NET_LIST, CONST_NET,
						   yyAttrStackPtr [4-1].single_net_declaring_list.Tree
				   );
			    yyAttrStackPtr [4-1].single_net_declaring_list.Tree->MPC_NetDecl.Next =
				yyAttrStackPtr [4-1].single_net_declaring_list.Tree->MPC_NetDecl.Prev = mMPC_FreeNode(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Ignore = yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yyAttrStackPtr [4-1].single_net_declaring_list.Ignore;
			    Close_Scope(), Scope_Depth--;
			  ;

			  yySynAttribute.const_unary_expression.IsIntConst = false;

			  yySynAttribute.const_unary_expression.Value = 0;
 
			;

} break;
case 1082: /* const_unary_operator : '+' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 182; {
/* line 3531 "mpcPars.lalr" */
 yySynAttribute.const_unary_operator.OpCode=PLUS;
yySynAttribute.const_unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1083: /* const_unary_operator : '-' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 182; {
/* line 3535 "mpcPars.lalr" */
 yySynAttribute.const_unary_operator.OpCode=NEG;
yySynAttribute.const_unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1084: /* const_unary_operator : '~' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 182; {
/* line 3539 "mpcPars.lalr" */
 yySynAttribute.const_unary_operator.OpCode=NOT;
yySynAttribute.const_unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1085: /* const_unary_operator : '!' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 182; {
/* line 3543 "mpcPars.lalr" */
 yySynAttribute.const_unary_operator.OpCode=LOG_NOT;
yySynAttribute.const_unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1086: /* const_cast_expression : const_unary_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 183; {
/* line 3547 "mpcPars.lalr" */

			  yySynAttribute.const_cast_expression.Tree  =  yyAttrStackPtr [1-1].const_unary_expression.Tree;

			  yySynAttribute.const_cast_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_unary_expression.IsIntConst;

			  yySynAttribute.const_cast_expression.Value  =  yyAttrStackPtr [1-1].const_unary_expression.Value;

			  yySynAttribute.const_cast_expression.Sizeof  =  yyAttrStackPtr [1-1].const_unary_expression.Sizeof;

			  yySynAttribute.const_cast_expression.Ignore  =  yyAttrStackPtr [1-1].const_unary_expression.Ignore;

			  yySynAttribute.const_cast_expression.Position  =  yyAttrStackPtr [1-1].const_unary_expression.Position;

			  yySynAttribute.const_cast_expression.BegPos  =  yyAttrStackPtr [1-1].const_unary_expression.BegPos;
  
			  yySynAttribute.const_cast_expression.EndPos  =  yyAttrStackPtr [1-1].const_unary_expression.EndPos;
  
			;

} break;
case 1087: /* const_cast_expression : '(' nested_type_on type_name nested_type_off ')' const_cast_expression .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 183; {
/* line 3566 "mpcPars.lalr" */

			  yySynAttribute.const_cast_expression.Sizeof  =  yyAttrStackPtr [6-1].const_cast_expression.Sizeof;
  
			    yySynAttribute.const_cast_expression.Tree = mMPC_CastExpr(yySynAttribute.const_cast_expression.Position=yyAttrStackPtr [5-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [3-1].type_name.Type, yyAttrStackPtr [6-1].const_cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_cast_expression.Tree);
			    yySynAttribute.const_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_cast_expression.Ignore = yyAttrStackPtr [3-1].type_name.Ignore ||
								   yyAttrStackPtr [6-1].const_cast_expression.Ignore;
			    yySynAttribute.const_cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_cast_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.const_cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_cast_expression.EndPos = yyAttrStackPtr [6-1].const_cast_expression.EndPos;  
			  ;

			  yySynAttribute.const_cast_expression.IsIntConst = yyAttrStackPtr [6-1].const_cast_expression.IsIntConst &&
					yyAttrStackPtr [3-1].type_name.Type!=NoTree &&
					yyAttrStackPtr [3-1].type_name.Type->Kind==kMPC_BasicType &&
					yyAttrStackPtr [3-1].type_name.Type->MPC_BasicType.TypeConstructor<VOID &&
					yyAttrStackPtr [3-1].type_name.Type->MPC_BasicType.TypeConstructor>FLOAT;

			  yySynAttribute.const_cast_expression.Value  =  yyAttrStackPtr [6-1].const_cast_expression.Value;

			;

} break;
case 1088: /* const_multiplicative_expression : const_cast_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 184; {
/* line 3590 "mpcPars.lalr" */

			  yySynAttribute.const_multiplicative_expression.Tree  =  yyAttrStackPtr [1-1].const_cast_expression.Tree;

			  yySynAttribute.const_multiplicative_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_cast_expression.IsIntConst;

			  yySynAttribute.const_multiplicative_expression.Value  =  yyAttrStackPtr [1-1].const_cast_expression.Value;

			  yySynAttribute.const_multiplicative_expression.Sizeof  =  yyAttrStackPtr [1-1].const_cast_expression.Sizeof;

			  yySynAttribute.const_multiplicative_expression.Ignore  =  yyAttrStackPtr [1-1].const_cast_expression.Ignore;

			  yySynAttribute.const_multiplicative_expression.Position  =  yyAttrStackPtr [1-1].const_cast_expression.Position;

			  yySynAttribute.const_multiplicative_expression.BegPos  =  yyAttrStackPtr [1-1].const_cast_expression.BegPos;
  
			  yySynAttribute.const_multiplicative_expression.EndPos  =  yyAttrStackPtr [1-1].const_cast_expression.EndPos;
  
			;

} break;
case 1089: /* const_multiplicative_expression : const_multiplicative_expression '*' const_cast_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 184; {
/* line 3609 "mpcPars.lalr" */

			  yySynAttribute.const_multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].const_multiplicative_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_cast_expression.Sizeof;
  
			    yySynAttribute.const_multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MULT, yyAttrStackPtr [1-1].const_multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].const_cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_multiplicative_expression.Tree);
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.Flag.Ignore =
				  yySynAttribute.const_multiplicative_expression.Ignore = yyAttrStackPtr [1-1].const_multiplicative_expression.Ignore ||
					   yyAttrStackPtr [3-1].const_cast_expression.Ignore;
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_multiplicative_expression.BegPos = yyAttrStackPtr [1-1].const_multiplicative_expression.BegPos;  
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_multiplicative_expression.EndPos = yyAttrStackPtr [3-1].const_cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_multiplicative_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_cast_expression.IsIntConst) {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = true;
			      yySynAttribute.const_multiplicative_expression.Value = Eval_BinaryExpr(MULT,
					yyAttrStackPtr [1-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [3-1].const_cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_multiplicative_expression.Tree,yySynAttribute.const_multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = false;
			      yySynAttribute.const_multiplicative_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1090: /* const_multiplicative_expression : const_multiplicative_expression '/' const_cast_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 184; {
/* line 3642 "mpcPars.lalr" */

			  yySynAttribute.const_multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].const_multiplicative_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_cast_expression.Sizeof;
  
			    yySynAttribute.const_multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					DIV, yyAttrStackPtr [1-1].const_multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].const_cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_multiplicative_expression.Tree);
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.Flag.Ignore =
				  yySynAttribute.const_multiplicative_expression.Ignore = yyAttrStackPtr [1-1].const_multiplicative_expression.Ignore ||
					   yyAttrStackPtr [3-1].const_cast_expression.Ignore;
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_multiplicative_expression.BegPos = yyAttrStackPtr [1-1].const_multiplicative_expression.BegPos;  
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_multiplicative_expression.EndPos = yyAttrStackPtr [3-1].const_cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_multiplicative_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_cast_expression.IsIntConst) {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = true;
			      yySynAttribute.const_multiplicative_expression.Value = Eval_BinaryExpr(DIV,
					yyAttrStackPtr [1-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [3-1].const_cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_multiplicative_expression.Tree,yySynAttribute.const_multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = false;
			      yySynAttribute.const_multiplicative_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1091: /* const_multiplicative_expression : const_multiplicative_expression '%' const_cast_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 184; {
/* line 3675 "mpcPars.lalr" */

			  yySynAttribute.const_multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].const_multiplicative_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_cast_expression.Sizeof;
  
			    yySynAttribute.const_multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MOD, yyAttrStackPtr [1-1].const_multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].const_cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_multiplicative_expression.Tree);
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.Flag.Ignore =
				  yySynAttribute.const_multiplicative_expression.Ignore = yyAttrStackPtr [1-1].const_multiplicative_expression.Ignore ||
					   yyAttrStackPtr [3-1].const_cast_expression.Ignore;
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_multiplicative_expression.BegPos = yyAttrStackPtr [1-1].const_multiplicative_expression.BegPos;  
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_multiplicative_expression.EndPos = yyAttrStackPtr [3-1].const_cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_multiplicative_expression.IsIntConst &&
			      yyAttrStackPtr [3-1].const_cast_expression.IsIntConst) {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = true;
			      yySynAttribute.const_multiplicative_expression.Value = Eval_BinaryExpr(MOD,
					yyAttrStackPtr [1-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [3-1].const_cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_multiplicative_expression.Tree,yySynAttribute.const_multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = false;
			      yySynAttribute.const_multiplicative_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1092: /* const_max_or_min_expression : const_multiplicative_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 185; {
/* line 3708 "mpcPars.lalr" */

			  yySynAttribute.const_max_or_min_expression.Tree  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Tree;

			  yySynAttribute.const_max_or_min_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_multiplicative_expression.IsIntConst;

			  yySynAttribute.const_max_or_min_expression.Value  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Value;

			  yySynAttribute.const_max_or_min_expression.Sizeof  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Sizeof;

			  yySynAttribute.const_max_or_min_expression.Ignore  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Ignore;

			  yySynAttribute.const_max_or_min_expression.Position  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Position;

			  yySynAttribute.const_max_or_min_expression.BegPos  =  yyAttrStackPtr [1-1].const_multiplicative_expression.BegPos;
  
			  yySynAttribute.const_max_or_min_expression.EndPos  =  yyAttrStackPtr [1-1].const_multiplicative_expression.EndPos;
  
			;

} break;
case 1093: /* const_max_or_min_expression : const_max_or_min_expression '?<' const_multiplicative_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 185; {
/* line 3727 "mpcPars.lalr" */

			  yySynAttribute.const_max_or_min_expression.Sizeof = yyAttrStackPtr [1-1].const_max_or_min_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_multiplicative_expression.Sizeof;
  
			    yySynAttribute.const_max_or_min_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_max_or_min_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MIN, yyAttrStackPtr [1-1].const_max_or_min_expression.Tree,
					yyAttrStackPtr [3-1].const_multiplicative_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_max_or_min_expression.Tree);
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_max_or_min_expression.Ignore =
							  yyAttrStackPtr [1-1].const_max_or_min_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_multiplicative_expression.Ignore;
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_max_or_min_expression.BegPos = yyAttrStackPtr [1-1].const_max_or_min_expression.BegPos;   
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_max_or_min_expression.EndPos = yyAttrStackPtr [3-1].const_multiplicative_expression.EndPos;   
			    if(yyAttrStackPtr [1-1].const_max_or_min_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_multiplicative_expression.IsIntConst) {
			      yySynAttribute.const_max_or_min_expression.IsIntConst = true;
			      yySynAttribute.const_max_or_min_expression.Value = Eval_BinaryExpr(MIN,
					yyAttrStackPtr [1-1].const_max_or_min_expression.Value,
					yyAttrStackPtr [3-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_max_or_min_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_max_or_min_expression.Tree,yySynAttribute.const_max_or_min_expression.Value);
			    }
			    else {
			      yySynAttribute.const_max_or_min_expression.IsIntConst = false;
			      yySynAttribute.const_max_or_min_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1094: /* const_max_or_min_expression : const_max_or_min_expression '?>' const_multiplicative_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 185; {
/* line 3760 "mpcPars.lalr" */

			  yySynAttribute.const_max_or_min_expression.Sizeof = yyAttrStackPtr [1-1].const_max_or_min_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_multiplicative_expression.Sizeof;
  
			    yySynAttribute.const_max_or_min_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_max_or_min_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MAX, yyAttrStackPtr [1-1].const_max_or_min_expression.Tree,
					yyAttrStackPtr [3-1].const_multiplicative_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_max_or_min_expression.Tree);
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_max_or_min_expression.Ignore =
							  yyAttrStackPtr [1-1].const_max_or_min_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_multiplicative_expression.Ignore;
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_max_or_min_expression.BegPos = yyAttrStackPtr [1-1].const_max_or_min_expression.BegPos;   
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_max_or_min_expression.EndPos = yyAttrStackPtr [3-1].const_multiplicative_expression.EndPos;   
			    if(yyAttrStackPtr [1-1].const_max_or_min_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_multiplicative_expression.IsIntConst) {
			      yySynAttribute.const_max_or_min_expression.IsIntConst = true;
			      yySynAttribute.const_max_or_min_expression.Value = Eval_BinaryExpr(MAX,
					yyAttrStackPtr [1-1].const_max_or_min_expression.Value,
					yyAttrStackPtr [3-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_max_or_min_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_max_or_min_expression.Tree,yySynAttribute.const_max_or_min_expression.Value);
			    }
			    else {
			      yySynAttribute.const_max_or_min_expression.IsIntConst = false;
			      yySynAttribute.const_max_or_min_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1095: /* const_additive_expression : const_max_or_min_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 186; {
/* line 3793 "mpcPars.lalr" */

			  yySynAttribute.const_additive_expression.Tree  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Tree;

			  yySynAttribute.const_additive_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_max_or_min_expression.IsIntConst;

			  yySynAttribute.const_additive_expression.Value  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Value;

			  yySynAttribute.const_additive_expression.Sizeof  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Sizeof;

			  yySynAttribute.const_additive_expression.Ignore  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Ignore;

			  yySynAttribute.const_additive_expression.Position  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Position;

			  yySynAttribute.const_additive_expression.BegPos  =  yyAttrStackPtr [1-1].const_max_or_min_expression.BegPos;
  
			  yySynAttribute.const_additive_expression.EndPos  =  yyAttrStackPtr [1-1].const_max_or_min_expression.EndPos;
  
			;

} break;
case 1096: /* const_additive_expression : const_additive_expression '+' const_max_or_min_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 186; {
/* line 3812 "mpcPars.lalr" */

			  yySynAttribute.const_additive_expression.Sizeof = yyAttrStackPtr [1-1].const_additive_expression.Sizeof || yyAttrStackPtr [3-1].const_max_or_min_expression.Sizeof;
  
			    yySynAttribute.const_additive_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_additive_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					PLUS, yyAttrStackPtr [1-1].const_additive_expression.Tree,
					yyAttrStackPtr [3-1].const_max_or_min_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_additive_expression.Tree);
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_additive_expression.Ignore =
							  yyAttrStackPtr [1-1].const_additive_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_max_or_min_expression.Ignore;
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_additive_expression.BegPos = yyAttrStackPtr [1-1].const_additive_expression.BegPos;  
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_additive_expression.EndPos = yyAttrStackPtr [3-1].const_max_or_min_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_additive_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_max_or_min_expression.IsIntConst) {
			      yySynAttribute.const_additive_expression.IsIntConst = true;
			      yySynAttribute.const_additive_expression.Value = Eval_BinaryExpr(PLUS,
					yyAttrStackPtr [1-1].const_additive_expression.Value,
					yyAttrStackPtr [3-1].const_max_or_min_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_additive_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_additive_expression.Tree,yySynAttribute.const_additive_expression.Value);
			    }
			    else {
			      yySynAttribute.const_additive_expression.IsIntConst = false;
			      yySynAttribute.const_additive_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1097: /* const_additive_expression : const_additive_expression '-' const_max_or_min_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 186; {
/* line 3844 "mpcPars.lalr" */

			  yySynAttribute.const_additive_expression.Sizeof = yyAttrStackPtr [1-1].const_additive_expression.Sizeof || yyAttrStackPtr [3-1].const_max_or_min_expression.Sizeof;
  
			    yySynAttribute.const_additive_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_additive_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MINUS, yyAttrStackPtr [1-1].const_additive_expression.Tree,
					yyAttrStackPtr [3-1].const_max_or_min_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_additive_expression.Tree);
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_additive_expression.Ignore =
							  yyAttrStackPtr [1-1].const_additive_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_max_or_min_expression.Ignore;
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_additive_expression.BegPos = yyAttrStackPtr [1-1].const_additive_expression.BegPos;  
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_additive_expression.EndPos = yyAttrStackPtr [3-1].const_max_or_min_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_additive_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_max_or_min_expression.IsIntConst) {
			      yySynAttribute.const_additive_expression.IsIntConst = true;
			      yySynAttribute.const_additive_expression.Value = Eval_BinaryExpr(MINUS,
					yyAttrStackPtr [1-1].const_additive_expression.Value,
					yyAttrStackPtr [3-1].const_max_or_min_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_additive_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_additive_expression.Tree,yySynAttribute.const_additive_expression.Value);
			    }
			    else {
			      yySynAttribute.const_additive_expression.IsIntConst = false;
			      yySynAttribute.const_additive_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1098: /* const_shift_expression : const_additive_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 187; {
/* line 3876 "mpcPars.lalr" */

			  yySynAttribute.const_shift_expression.Tree  =  yyAttrStackPtr [1-1].const_additive_expression.Tree;

			  yySynAttribute.const_shift_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_additive_expression.IsIntConst;

			  yySynAttribute.const_shift_expression.Value  =  yyAttrStackPtr [1-1].const_additive_expression.Value;

			  yySynAttribute.const_shift_expression.Sizeof  =  yyAttrStackPtr [1-1].const_additive_expression.Sizeof;

			  yySynAttribute.const_shift_expression.Ignore  =  yyAttrStackPtr [1-1].const_additive_expression.Ignore;

			  yySynAttribute.const_shift_expression.Position  =  yyAttrStackPtr [1-1].const_additive_expression.Position;

			  yySynAttribute.const_shift_expression.BegPos  =  yyAttrStackPtr [1-1].const_additive_expression.BegPos;
  
			  yySynAttribute.const_shift_expression.EndPos  =  yyAttrStackPtr [1-1].const_additive_expression.EndPos;
  
			;

} break;
case 1099: /* const_shift_expression : const_shift_expression '<<' const_additive_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 187; {
/* line 3895 "mpcPars.lalr" */

			  yySynAttribute.const_shift_expression.Sizeof = yyAttrStackPtr [1-1].const_shift_expression.Sizeof || yyAttrStackPtr [3-1].const_additive_expression.Sizeof;
  
			    yySynAttribute.const_shift_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_shift_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LEFT_SHIFT, yyAttrStackPtr [1-1].const_shift_expression.Tree,
					yyAttrStackPtr [3-1].const_additive_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_shift_expression.Tree);
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_shift_expression.Ignore =
							  yyAttrStackPtr [1-1].const_shift_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_additive_expression.Ignore;
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_shift_expression.BegPos = yyAttrStackPtr [1-1].const_shift_expression.BegPos;  
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_shift_expression.EndPos = yyAttrStackPtr [3-1].const_additive_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_shift_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_additive_expression.IsIntConst) {
			      yySynAttribute.const_shift_expression.IsIntConst = true;
			      yySynAttribute.const_shift_expression.Value = Eval_BinaryExpr(LEFT_SHIFT,
					yyAttrStackPtr [1-1].const_shift_expression.Value,
					yyAttrStackPtr [3-1].const_additive_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_shift_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_shift_expression.Tree,yySynAttribute.const_shift_expression.Value);
			    }
			    else {
			      yySynAttribute.const_shift_expression.IsIntConst = false;
			      yySynAttribute.const_shift_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1100: /* const_shift_expression : const_shift_expression '>>' const_additive_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 187; {
/* line 3927 "mpcPars.lalr" */

			  yySynAttribute.const_shift_expression.Sizeof = yyAttrStackPtr [1-1].const_shift_expression.Sizeof || yyAttrStackPtr [3-1].const_additive_expression.Sizeof;
  
			    yySynAttribute.const_shift_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_shift_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					RIGHT_SHIFT, yyAttrStackPtr [1-1].const_shift_expression.Tree,
					yyAttrStackPtr [3-1].const_additive_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_shift_expression.Tree);
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_shift_expression.Ignore =
							  yyAttrStackPtr [1-1].const_shift_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_additive_expression.Ignore;
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_shift_expression.BegPos = yyAttrStackPtr [1-1].const_shift_expression.BegPos;  
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_shift_expression.EndPos = yyAttrStackPtr [3-1].const_additive_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_shift_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_additive_expression.IsIntConst) {
			      yySynAttribute.const_shift_expression.IsIntConst = true;
			      yySynAttribute.const_shift_expression.Value = Eval_BinaryExpr(RIGHT_SHIFT,
					yyAttrStackPtr [1-1].const_shift_expression.Value,
					yyAttrStackPtr [3-1].const_additive_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_shift_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_shift_expression.Tree,yySynAttribute.const_shift_expression.Value);
			    }
			    else {
			      yySynAttribute.const_shift_expression.IsIntConst = false;
			      yySynAttribute.const_shift_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1101: /* const_relational_expression : const_shift_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 188; {
/* line 3959 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Tree  =  yyAttrStackPtr [1-1].const_shift_expression.Tree;

			  yySynAttribute.const_relational_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_shift_expression.IsIntConst;

			  yySynAttribute.const_relational_expression.Value  =  yyAttrStackPtr [1-1].const_shift_expression.Value;

			  yySynAttribute.const_relational_expression.Sizeof  =  yyAttrStackPtr [1-1].const_shift_expression.Sizeof;

			  yySynAttribute.const_relational_expression.Ignore  =  yyAttrStackPtr [1-1].const_shift_expression.Ignore;

			  yySynAttribute.const_relational_expression.Position  =  yyAttrStackPtr [1-1].const_shift_expression.Position;

			  yySynAttribute.const_relational_expression.BegPos  =  yyAttrStackPtr [1-1].const_shift_expression.BegPos;
  
			  yySynAttribute.const_relational_expression.EndPos  =  yyAttrStackPtr [1-1].const_shift_expression.EndPos;
  
			;

} break;
case 1102: /* const_relational_expression : const_relational_expression '<' const_shift_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 188; {
/* line 3978 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Sizeof = yyAttrStackPtr [1-1].const_relational_expression.Sizeof || yyAttrStackPtr [3-1].const_shift_expression.Sizeof;
  
			    yySynAttribute.const_relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LESS_THEN, yyAttrStackPtr [1-1].const_relational_expression.Tree,
					yyAttrStackPtr [3-1].const_shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_relational_expression.Tree);
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_relational_expression.Ignore =
							  yyAttrStackPtr [1-1].const_relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_shift_expression.Ignore;
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_relational_expression.BegPos = yyAttrStackPtr [1-1].const_relational_expression.BegPos;  
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_relational_expression.EndPos = yyAttrStackPtr [3-1].const_shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_shift_expression.IsIntConst) {
			      yySynAttribute.const_relational_expression.IsIntConst = true;
			      yySynAttribute.const_relational_expression.Value = Eval_BinaryExpr(LESS_THEN,
					yyAttrStackPtr [1-1].const_relational_expression.Value,
					yyAttrStackPtr [3-1].const_shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_relational_expression.Tree,yySynAttribute.const_relational_expression.Value);
			    }
			    else {
			      yySynAttribute.const_relational_expression.IsIntConst = false;
			      yySynAttribute.const_relational_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1103: /* const_relational_expression : const_relational_expression '>' const_shift_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 188; {
/* line 4010 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Sizeof = yyAttrStackPtr [1-1].const_relational_expression.Sizeof || yyAttrStackPtr [3-1].const_shift_expression.Sizeof;
  
			    yySynAttribute.const_relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					GREAT_THEN, yyAttrStackPtr [1-1].const_relational_expression.Tree,
					yyAttrStackPtr [3-1].const_shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_relational_expression.Tree);
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_relational_expression.Ignore =
							  yyAttrStackPtr [1-1].const_relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_shift_expression.Ignore;
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_relational_expression.BegPos = yyAttrStackPtr [1-1].const_relational_expression.BegPos;  
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_relational_expression.EndPos = yyAttrStackPtr [3-1].const_shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_shift_expression.IsIntConst) {
			      yySynAttribute.const_relational_expression.IsIntConst = true;
			      yySynAttribute.const_relational_expression.Value = Eval_BinaryExpr(GREAT_THEN,
					yyAttrStackPtr [1-1].const_relational_expression.Value,
					yyAttrStackPtr [3-1].const_shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_relational_expression.Tree,yySynAttribute.const_relational_expression.Value);
			    }
			    else {
			      yySynAttribute.const_relational_expression.IsIntConst = false;
			      yySynAttribute.const_relational_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1104: /* const_relational_expression : const_relational_expression '<=' const_shift_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 188; {
/* line 4042 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Sizeof = yyAttrStackPtr [1-1].const_relational_expression.Sizeof || yyAttrStackPtr [3-1].const_shift_expression.Sizeof;
  
			    yySynAttribute.const_relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LESS_OR_EQ, yyAttrStackPtr [1-1].const_relational_expression.Tree,
					yyAttrStackPtr [3-1].const_shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_relational_expression.Tree);
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_relational_expression.Ignore =
							  yyAttrStackPtr [1-1].const_relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_shift_expression.Ignore;
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_relational_expression.BegPos = yyAttrStackPtr [1-1].const_relational_expression.BegPos;  
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_relational_expression.EndPos = yyAttrStackPtr [3-1].const_shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_shift_expression.IsIntConst) {
			      yySynAttribute.const_relational_expression.IsIntConst = true;
			      yySynAttribute.const_relational_expression.Value = Eval_BinaryExpr(LESS_OR_EQ,
					yyAttrStackPtr [1-1].const_relational_expression.Value,
					yyAttrStackPtr [3-1].const_shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_relational_expression.Tree,yySynAttribute.const_relational_expression.Value);
			    }
			    else {
			      yySynAttribute.const_relational_expression.IsIntConst = false;
			      yySynAttribute.const_relational_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1105: /* const_relational_expression : const_relational_expression '>=' const_shift_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 188; {
/* line 4074 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Sizeof = yyAttrStackPtr [1-1].const_relational_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_shift_expression.Sizeof;
  
			    yySynAttribute.const_relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					GREAT_OR_EQ, yyAttrStackPtr [1-1].const_relational_expression.Tree,
					yyAttrStackPtr [3-1].const_shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_relational_expression.Tree);
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_relational_expression.Ignore =
							  yyAttrStackPtr [1-1].const_relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_shift_expression.Ignore;
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_relational_expression.BegPos = yyAttrStackPtr [1-1].const_relational_expression.BegPos;  
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_relational_expression.EndPos = yyAttrStackPtr [3-1].const_shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_shift_expression.IsIntConst) {
			      yySynAttribute.const_relational_expression.IsIntConst = true;
			      yySynAttribute.const_relational_expression.Value = Eval_BinaryExpr(GREAT_OR_EQ,
					yyAttrStackPtr [1-1].const_relational_expression.Value,
					yyAttrStackPtr [3-1].const_shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_relational_expression.Tree,yySynAttribute.const_relational_expression.Value);
			    }
			    else {
			      yySynAttribute.const_relational_expression.IsIntConst = false;
			      yySynAttribute.const_relational_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1106: /* const_equality_expression : const_relational_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 189; {
/* line 4107 "mpcPars.lalr" */

			  yySynAttribute.const_equality_expression.Tree  =  yyAttrStackPtr [1-1].const_relational_expression.Tree;

			  yySynAttribute.const_equality_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_relational_expression.IsIntConst;

			  yySynAttribute.const_equality_expression.Value  =  yyAttrStackPtr [1-1].const_relational_expression.Value;

			  yySynAttribute.const_equality_expression.Sizeof  =  yyAttrStackPtr [1-1].const_relational_expression.Sizeof;

			  yySynAttribute.const_equality_expression.Ignore  =  yyAttrStackPtr [1-1].const_relational_expression.Ignore;

			  yySynAttribute.const_equality_expression.Position  =  yyAttrStackPtr [1-1].const_relational_expression.Position;

			  yySynAttribute.const_equality_expression.BegPos  =  yyAttrStackPtr [1-1].const_relational_expression.BegPos;
  
			  yySynAttribute.const_equality_expression.EndPos  =  yyAttrStackPtr [1-1].const_relational_expression.EndPos;
  
			;

} break;
case 1107: /* const_equality_expression : const_equality_expression '==' const_relational_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 189; {
/* line 4126 "mpcPars.lalr" */

			  yySynAttribute.const_equality_expression.Sizeof = yyAttrStackPtr [1-1].const_equality_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_relational_expression.Sizeof;
  
			    yySynAttribute.const_equality_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_equality_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					EQUAL, yyAttrStackPtr [1-1].const_equality_expression.Tree,
					yyAttrStackPtr [3-1].const_relational_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_equality_expression.Tree);
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_equality_expression.Ignore =
							  yyAttrStackPtr [1-1].const_equality_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_relational_expression.Ignore;
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_equality_expression.BegPos = yyAttrStackPtr [1-1].const_equality_expression.BegPos;  
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_equality_expression.EndPos = yyAttrStackPtr [3-1].const_relational_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_equality_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_relational_expression.IsIntConst) {
			      yySynAttribute.const_equality_expression.IsIntConst = true;
			      yySynAttribute.const_equality_expression.Value = Eval_BinaryExpr(EQUAL,
					yyAttrStackPtr [1-1].const_equality_expression.Value,
					yyAttrStackPtr [3-1].const_relational_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_equality_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_equality_expression.Tree,yySynAttribute.const_equality_expression.Value);
			    }
			    else {
			      yySynAttribute.const_equality_expression.IsIntConst = false;
			      yySynAttribute.const_equality_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1108: /* const_equality_expression : const_equality_expression '!=' const_relational_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 189; {
/* line 4159 "mpcPars.lalr" */

			  yySynAttribute.const_equality_expression.Sizeof = yyAttrStackPtr [1-1].const_equality_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_relational_expression.Sizeof;
  
			    yySynAttribute.const_equality_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_equality_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					NOT_EQUAL, yyAttrStackPtr [1-1].const_equality_expression.Tree,
					yyAttrStackPtr [3-1].const_relational_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_equality_expression.Tree);
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_equality_expression.Ignore =
							  yyAttrStackPtr [1-1].const_equality_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_relational_expression.Ignore;
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_equality_expression.BegPos = yyAttrStackPtr [1-1].const_equality_expression.BegPos;  
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_equality_expression.EndPos = yyAttrStackPtr [3-1].const_relational_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_equality_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_relational_expression.IsIntConst) {
			      yySynAttribute.const_equality_expression.IsIntConst = true;
			      yySynAttribute.const_equality_expression.Value = Eval_BinaryExpr(NOT_EQUAL,
					yyAttrStackPtr [1-1].const_equality_expression.Value,
					yyAttrStackPtr [3-1].const_relational_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_equality_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_equality_expression.Tree,yySynAttribute.const_equality_expression.Value);
			    }
			    else {
			      yySynAttribute.const_equality_expression.IsIntConst = false;
			      yySynAttribute.const_equality_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1109: /* const_AND_expression : const_equality_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 190; {
/* line 4192 "mpcPars.lalr" */

			  yySynAttribute.const_AND_expression.Tree  =  yyAttrStackPtr [1-1].const_equality_expression.Tree;

			  yySynAttribute.const_AND_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_equality_expression.IsIntConst;

			  yySynAttribute.const_AND_expression.Value  =  yyAttrStackPtr [1-1].const_equality_expression.Value;

			  yySynAttribute.const_AND_expression.Sizeof  =  yyAttrStackPtr [1-1].const_equality_expression.Sizeof;

			  yySynAttribute.const_AND_expression.Ignore  =  yyAttrStackPtr [1-1].const_equality_expression.Ignore;

			  yySynAttribute.const_AND_expression.Position  =  yyAttrStackPtr [1-1].const_equality_expression.Position;

			  yySynAttribute.const_AND_expression.BegPos  =  yyAttrStackPtr [1-1].const_equality_expression.BegPos;
  
			  yySynAttribute.const_AND_expression.EndPos  =  yyAttrStackPtr [1-1].const_equality_expression.EndPos;
  
			;

} break;
case 1110: /* const_AND_expression : const_AND_expression '&' const_equality_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 190; {
/* line 4211 "mpcPars.lalr" */

			  yySynAttribute.const_AND_expression.Sizeof = yyAttrStackPtr [1-1].const_AND_expression.Sizeof || yyAttrStackPtr [3-1].const_equality_expression.Sizeof;
  
			    yySynAttribute.const_AND_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_AND_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					AND, yyAttrStackPtr [1-1].const_AND_expression.Tree,
					yyAttrStackPtr [3-1].const_equality_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_AND_expression.Tree);
			    yySynAttribute.const_AND_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_AND_expression.Ignore =
							  yyAttrStackPtr [1-1].const_AND_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_equality_expression.Ignore;
			    yySynAttribute.const_AND_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_AND_expression.BegPos = yyAttrStackPtr [1-1].const_AND_expression.BegPos;  
			    yySynAttribute.const_AND_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_AND_expression.EndPos = yyAttrStackPtr [3-1].const_equality_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_AND_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_equality_expression.IsIntConst) {
			      yySynAttribute.const_AND_expression.IsIntConst = true;
			      yySynAttribute.const_AND_expression.Value = Eval_BinaryExpr(AND,
					yyAttrStackPtr [1-1].const_AND_expression.Value,
					yyAttrStackPtr [3-1].const_equality_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_AND_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_AND_expression.Tree,yySynAttribute.const_AND_expression.Value);
			    }
			    else {
			      yySynAttribute.const_AND_expression.IsIntConst = false;
			      yySynAttribute.const_AND_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1111: /* const_exclusive_OR_expression : const_AND_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 191; {
/* line 4243 "mpcPars.lalr" */

			  yySynAttribute.const_exclusive_OR_expression.Tree  =  yyAttrStackPtr [1-1].const_AND_expression.Tree;

			  yySynAttribute.const_exclusive_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_AND_expression.IsIntConst;

			  yySynAttribute.const_exclusive_OR_expression.Value  =  yyAttrStackPtr [1-1].const_AND_expression.Value;

			  yySynAttribute.const_exclusive_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].const_AND_expression.Sizeof;

			  yySynAttribute.const_exclusive_OR_expression.Ignore  =  yyAttrStackPtr [1-1].const_AND_expression.Ignore;

			  yySynAttribute.const_exclusive_OR_expression.Position  =  yyAttrStackPtr [1-1].const_AND_expression.Position;

			  yySynAttribute.const_exclusive_OR_expression.BegPos  =  yyAttrStackPtr [1-1].const_AND_expression.BegPos;
  
			  yySynAttribute.const_exclusive_OR_expression.EndPos  =  yyAttrStackPtr [1-1].const_AND_expression.EndPos;
  
			;

} break;
case 1112: /* const_exclusive_OR_expression : const_exclusive_OR_expression '^' const_AND_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 191; {
/* line 4262 "mpcPars.lalr" */

			  yySynAttribute.const_exclusive_OR_expression.Sizeof = yyAttrStackPtr [1-1].const_exclusive_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_AND_expression.Sizeof;
  
			    yySynAttribute.const_exclusive_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_exclusive_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					EXCL_OR, yyAttrStackPtr [1-1].const_exclusive_OR_expression.Tree,
					yyAttrStackPtr [3-1].const_AND_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_exclusive_OR_expression.Tree);
			    yySynAttribute.const_exclusive_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_exclusive_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_AND_expression.Ignore;
			    yySynAttribute.const_exclusive_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_exclusive_OR_expression.BegPos = yyAttrStackPtr [1-1].const_exclusive_OR_expression.BegPos;  
			    yySynAttribute.const_exclusive_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_exclusive_OR_expression.EndPos = yyAttrStackPtr [3-1].const_AND_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_exclusive_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_AND_expression.IsIntConst) {
			      yySynAttribute.const_exclusive_OR_expression.IsIntConst = true;
			      yySynAttribute.const_exclusive_OR_expression.Value = Eval_BinaryExpr(EXCL_OR,
					yyAttrStackPtr [1-1].const_exclusive_OR_expression.Value,
					yyAttrStackPtr [3-1].const_AND_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_exclusive_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_exclusive_OR_expression.Tree,yySynAttribute.const_exclusive_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.const_exclusive_OR_expression.IsIntConst = false;
			      yySynAttribute.const_exclusive_OR_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1113: /* const_inclusive_OR_expression : const_exclusive_OR_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 192; {
/* line 4295 "mpcPars.lalr" */

			  yySynAttribute.const_inclusive_OR_expression.Tree  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Tree;

			  yySynAttribute.const_inclusive_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.IsIntConst;

			  yySynAttribute.const_inclusive_OR_expression.Value  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Value;

			  yySynAttribute.const_inclusive_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Sizeof;

			  yySynAttribute.const_inclusive_OR_expression.Ignore  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Ignore;

			  yySynAttribute.const_inclusive_OR_expression.Position  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Position;

			  yySynAttribute.const_inclusive_OR_expression.BegPos  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.BegPos;
  
			  yySynAttribute.const_inclusive_OR_expression.EndPos  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.EndPos;
  
			;

} break;
case 1114: /* const_inclusive_OR_expression : const_inclusive_OR_expression '|' const_exclusive_OR_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 192; {
/* line 4314 "mpcPars.lalr" */

			  yySynAttribute.const_inclusive_OR_expression.Sizeof = yyAttrStackPtr [1-1].const_inclusive_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_exclusive_OR_expression.Sizeof;
  
			    yySynAttribute.const_inclusive_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_inclusive_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					INCL_OR, yyAttrStackPtr [1-1].const_inclusive_OR_expression.Tree,
					yyAttrStackPtr [3-1].const_exclusive_OR_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_inclusive_OR_expression.Tree);
			    yySynAttribute.const_inclusive_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_inclusive_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_exclusive_OR_expression.Ignore;
			    yySynAttribute.const_inclusive_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_inclusive_OR_expression.BegPos = yyAttrStackPtr [1-1].const_inclusive_OR_expression.BegPos;  
			    yySynAttribute.const_inclusive_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_inclusive_OR_expression.EndPos = yyAttrStackPtr [3-1].const_exclusive_OR_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_inclusive_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_exclusive_OR_expression.IsIntConst) {
			      yySynAttribute.const_inclusive_OR_expression.IsIntConst = true;
			      yySynAttribute.const_inclusive_OR_expression.Value = Eval_BinaryExpr(INCL_OR,
					yyAttrStackPtr [1-1].const_inclusive_OR_expression.Value,
					yyAttrStackPtr [3-1].const_exclusive_OR_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_inclusive_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_inclusive_OR_expression.Tree,yySynAttribute.const_inclusive_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.const_inclusive_OR_expression.IsIntConst = false;
			      yySynAttribute.const_inclusive_OR_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1115: /* const_logical_AND_expression : const_inclusive_OR_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 193; {
/* line 4347 "mpcPars.lalr" */

			  yySynAttribute.const_logical_AND_expression.Tree  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Tree;

			  yySynAttribute.const_logical_AND_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.IsIntConst;

			  yySynAttribute.const_logical_AND_expression.Value  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Value;

			  yySynAttribute.const_logical_AND_expression.Sizeof  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Sizeof;

			  yySynAttribute.const_logical_AND_expression.Ignore  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Ignore;

			  yySynAttribute.const_logical_AND_expression.Position  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Position;

			  yySynAttribute.const_logical_AND_expression.BegPos  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.BegPos;
  
			  yySynAttribute.const_logical_AND_expression.EndPos  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.EndPos;
  
			;

} break;
case 1116: /* const_logical_AND_expression : const_logical_AND_expression '&&' const_inclusive_OR_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 193; {
/* line 4366 "mpcPars.lalr" */

			  yySynAttribute.const_logical_AND_expression.Sizeof = yyAttrStackPtr [1-1].const_logical_AND_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_inclusive_OR_expression.Sizeof;
  
			    yySynAttribute.const_logical_AND_expression.Tree = mMPC_BinaryExpr(
					yySynAttribute.const_logical_AND_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LOG_AND, yyAttrStackPtr [1-1].const_logical_AND_expression.Tree,
					yyAttrStackPtr [3-1].const_inclusive_OR_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_logical_AND_expression.Tree);
			    yySynAttribute.const_logical_AND_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_logical_AND_expression.Ignore =
							  yyAttrStackPtr [1-1].const_logical_AND_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_inclusive_OR_expression.Ignore;
			    yySynAttribute.const_logical_AND_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_logical_AND_expression.BegPos = yyAttrStackPtr [1-1].const_logical_AND_expression.BegPos;  
			    yySynAttribute.const_logical_AND_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_logical_AND_expression.EndPos = yyAttrStackPtr [3-1].const_inclusive_OR_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_logical_AND_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_inclusive_OR_expression.IsIntConst) {
			      yySynAttribute.const_logical_AND_expression.IsIntConst = true;
			      yySynAttribute.const_logical_AND_expression.Value = Eval_BinaryExpr(LOG_AND,
					yyAttrStackPtr [1-1].const_logical_AND_expression.Value,
					yyAttrStackPtr [3-1].const_inclusive_OR_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_logical_AND_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_logical_AND_expression.Tree,yySynAttribute.const_logical_AND_expression.Value);
			    }
			    else {
			      yySynAttribute.const_logical_AND_expression.IsIntConst = false;
			      yySynAttribute.const_logical_AND_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1117: /* const_logical_OR_expression : const_logical_AND_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 194; {
/* line 4400 "mpcPars.lalr" */

			  yySynAttribute.const_logical_OR_expression.Tree  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Tree;

			  yySynAttribute.const_logical_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_logical_AND_expression.IsIntConst;

			  yySynAttribute.const_logical_OR_expression.Value  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Value;

			  yySynAttribute.const_logical_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Sizeof;

			  yySynAttribute.const_logical_OR_expression.Ignore  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Ignore;

			  yySynAttribute.const_logical_OR_expression.Position  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Position;

			  yySynAttribute.const_logical_OR_expression.BegPos  =  yyAttrStackPtr [1-1].const_logical_AND_expression.BegPos;
  
			  yySynAttribute.const_logical_OR_expression.EndPos  =  yyAttrStackPtr [1-1].const_logical_AND_expression.EndPos;
  
			;

} break;
case 1118: /* const_logical_OR_expression : const_logical_OR_expression '||' const_logical_AND_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 194; {
/* line 4419 "mpcPars.lalr" */

			  yySynAttribute.const_logical_OR_expression.Sizeof = yyAttrStackPtr [1-1].const_logical_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_logical_AND_expression.Sizeof;
  
			    yySynAttribute.const_logical_OR_expression.Tree = mMPC_BinaryExpr(
					yySynAttribute.const_logical_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LOG_OR, yyAttrStackPtr [1-1].const_logical_OR_expression.Tree,
					yyAttrStackPtr [3-1].const_logical_AND_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_logical_OR_expression.Tree);
			    yySynAttribute.const_logical_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_logical_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].const_logical_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_logical_AND_expression.Ignore;
			    yySynAttribute.const_logical_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_logical_OR_expression.BegPos = yyAttrStackPtr [1-1].const_logical_OR_expression.BegPos;  
			    yySynAttribute.const_logical_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_logical_OR_expression.EndPos = yyAttrStackPtr [3-1].const_logical_AND_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_logical_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_logical_AND_expression.IsIntConst) {
			      yySynAttribute.const_logical_OR_expression.IsIntConst = true;
			      yySynAttribute.const_logical_OR_expression.Value = Eval_BinaryExpr(LOG_OR,
					yyAttrStackPtr [1-1].const_logical_OR_expression.Value,
					yyAttrStackPtr [3-1].const_logical_AND_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_logical_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_logical_OR_expression.Tree,yySynAttribute.const_logical_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.const_logical_OR_expression.IsIntConst = false;
			      yySynAttribute.const_logical_OR_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1119: /* const_conditional_expression : const_logical_OR_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 195; {
/* line 4453 "mpcPars.lalr" */

			  yySynAttribute.const_conditional_expression.Tree  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Tree;

			  yySynAttribute.const_conditional_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_logical_OR_expression.IsIntConst;

			  yySynAttribute.const_conditional_expression.Value  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Value;

			  yySynAttribute.const_conditional_expression.Sizeof  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Sizeof;

			  yySynAttribute.const_conditional_expression.Ignore  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Ignore;

			  yySynAttribute.const_conditional_expression.Position  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Position;

			  yySynAttribute.const_conditional_expression.BegPos  =  yyAttrStackPtr [1-1].const_logical_OR_expression.BegPos;
  
			  yySynAttribute.const_conditional_expression.EndPos  =  yyAttrStackPtr [1-1].const_logical_OR_expression.EndPos;
  
			;

} break;
case 1120: /* const_conditional_expression : const_logical_OR_expression '?' const_expression_opt ':' const_conditional_expression_opt .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 195; {
/* line 4472 "mpcPars.lalr" */

			  yySynAttribute.const_conditional_expression.Sizeof = yyAttrStackPtr [1-1].const_logical_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_expression_opt.Sizeof ||
				    yyAttrStackPtr [5-1].const_conditional_expression_opt.Sizeof;
  
			    if(yyAttrStackPtr [5-1].const_conditional_expression_opt.Tree==NoTree)
				CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;
			    yySynAttribute.const_conditional_expression.Tree = mMPC_TernaryExpr(yySynAttribute.const_conditional_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					CONDITION, yyAttrStackPtr [1-1].const_logical_OR_expression.Tree,
					yyAttrStackPtr [3-1].const_expression_opt.Tree,
					yyAttrStackPtr [5-1].const_conditional_expression_opt.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_conditional_expression.Tree);
			    yySynAttribute.const_conditional_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_conditional_expression.Ignore =
							yyAttrStackPtr [1-1].const_logical_OR_expression.Ignore ||
							yyAttrStackPtr [3-1].const_expression_opt.Ignore        ||
							yyAttrStackPtr [5-1].const_conditional_expression_opt.Ignore;
			    yySynAttribute.const_conditional_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_conditional_expression.BegPos = yyAttrStackPtr [1-1].const_logical_OR_expression.BegPos;  
			    yySynAttribute.const_conditional_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_conditional_expression.EndPos =   
			    		(yyAttrStackPtr [5-1].const_conditional_expression_opt.Tree==NoTree)?  
						yyAttrStackPtr [4-1].Scan.Position:  
						yyAttrStackPtr [5-1].const_conditional_expression_opt.EndPos;  
			    if(yyAttrStackPtr [1-1].const_logical_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_expression_opt.IsIntConst        &&
			       yyAttrStackPtr [5-1].const_conditional_expression_opt.IsIntConst) {
			      if(yyAttrStackPtr [1-1].const_logical_OR_expression.Value)
				yySynAttribute.const_conditional_expression.Value = yyAttrStackPtr [3-1].const_expression_opt.Value;
			      else
				yySynAttribute.const_conditional_expression.Value = yyAttrStackPtr [5-1].const_conditional_expression_opt.Value;
			      if(!yySynAttribute.const_conditional_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_conditional_expression.Tree,yySynAttribute.const_conditional_expression.Value);
			    }
			    else {
			      yySynAttribute.const_conditional_expression.IsIntConst = false;
			      yySynAttribute.const_conditional_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1121: /* const_conditional_expression_opt : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 197; {
/* line 4512 "mpcPars.lalr" */
 yySynAttribute.const_conditional_expression_opt.Tree = NoTree;
 yySynAttribute.const_conditional_expression_opt.IsIntConst = false;
 yySynAttribute.const_conditional_expression_opt.Value = 0;
 yySynAttribute.const_conditional_expression_opt.Sizeof = false;

		    	      yySynAttribute.const_conditional_expression_opt.Ignore = false;
 yySynAttribute.const_conditional_expression_opt.EndPos = NoPosition;
 ;

} break;
case 1122: /* const_conditional_expression_opt : const_conditional_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 197; {
/* line 4521 "mpcPars.lalr" */

			  yySynAttribute.const_conditional_expression_opt.Tree  =  yyAttrStackPtr [1-1].const_conditional_expression.Tree;

			  yySynAttribute.const_conditional_expression_opt.IsIntConst  =  yyAttrStackPtr [1-1].const_conditional_expression.IsIntConst;

			  yySynAttribute.const_conditional_expression_opt.Value  =  yyAttrStackPtr [1-1].const_conditional_expression.Value;

			  yySynAttribute.const_conditional_expression_opt.Sizeof  =  yyAttrStackPtr [1-1].const_conditional_expression.Sizeof;

			  yySynAttribute.const_conditional_expression_opt.Ignore  =  yyAttrStackPtr [1-1].const_conditional_expression.Ignore;

			  yySynAttribute.const_conditional_expression_opt.EndPos  =  yyAttrStackPtr [1-1].const_conditional_expression.EndPos;
  
			;

} break;
case 1123: /* constant_expression : const_conditional_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 198; {
/* line 4536 "mpcPars.lalr" */

			    yySynAttribute.constant_expression.Tree = yyAttrStackPtr [1-1].const_conditional_expression.Tree;
			    ExprScopeEnd();    
			  ;

			  yySynAttribute.constant_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_conditional_expression.IsIntConst;

			  yySynAttribute.constant_expression.Value  =  yyAttrStackPtr [1-1].const_conditional_expression.Value;

			  yySynAttribute.constant_expression.Sizeof  =  yyAttrStackPtr [1-1].const_conditional_expression.Sizeof;

			  yySynAttribute.constant_expression.Ignore  =  yyAttrStackPtr [1-1].const_conditional_expression.Ignore;

			  yySynAttribute.constant_expression.Position  =  yyAttrStackPtr [1-1].const_conditional_expression.Position;

			  yySynAttribute.constant_expression.BegPos  =  yyAttrStackPtr [1-1].const_conditional_expression.BegPos;
  
			  yySynAttribute.constant_expression.EndPos  =  yyAttrStackPtr [1-1].const_conditional_expression.EndPos;
  
			;

} break;
case 1124: /* const_expression_opt : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 196; {
/* line 4557 "mpcPars.lalr" */

			  yySynAttribute.const_expression_opt.Tree = NoTree;

			  yySynAttribute.const_expression_opt.IsIntConst = false;

			  yySynAttribute.const_expression_opt.Value = 0;

			  yySynAttribute.const_expression_opt.Sizeof = false;

			  yySynAttribute.const_expression_opt.Ignore = false;

			;

} break;
case 1125: /* const_expression_opt : constant_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 196; {
/* line 4570 "mpcPars.lalr" */

			  yySynAttribute.const_expression_opt.Tree  =  yyAttrStackPtr [1-1].constant_expression.Tree;

			  yySynAttribute.const_expression_opt.IsIntConst  =  yyAttrStackPtr [1-1].constant_expression.IsIntConst;

			  yySynAttribute.const_expression_opt.Value  =  yyAttrStackPtr [1-1].constant_expression.Value;

			  yySynAttribute.const_expression_opt.Sizeof  =  yyAttrStackPtr [1-1].constant_expression.Sizeof;

			  yySynAttribute.const_expression_opt.Ignore  =  yyAttrStackPtr [1-1].constant_expression.Ignore;

			;

} break;
case 1126: /* declaration : net_declaring_list ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 200; {
/* line 4583 "mpcPars.lalr" */
  
			    yySynAttribute.declaration.Tree = yyAttrStackPtr [1-1].net_declaring_list.Tree;
			    yySynAttribute.declaration.Tree->MPC_NetDecl.Flag.Ignore |= yyAttrStackPtr [1-1].net_declaring_list.Ignore;
			    yySynAttribute.declaration.Tree->MPC_NetDecl.Net = ReverseTree(yySynAttribute.declaration.Tree->MPC_NetDecl.Net);
			    yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].net_declaring_list.Position;  
			  ;

			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].net_declaring_list.Ignore;

			;

} break;
case 1127: /* declaration : subnet_declaring_list ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 200; {
/* line 4595 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree  =  yyAttrStackPtr [1-1].subnet_declaring_list.Tree;
 yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
						yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].subnet_declaring_list.Position; ;
  
			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].subnet_declaring_list.Ignore;

			;

} break;
case 1128: /* declaration : relation_declaration ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 200; {
/* line 4604 "mpcPars.lalr" */
  
			    yySynAttribute.declaration.Tree = mMPC_RelDecl(
					yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].relation_declaration.Position,  
					NoTree, NoTree, ReverseTree(yyAttrStackPtr [1-1].relation_declaration.Tree)
				   );
			    yySynAttribute.declaration.Tree->MPC_RelDecl.Relation->MPC_Relation.Prev->
				  MPC_FreeNode.Parent = yySynAttribute.declaration.Tree;
			    yySynAttribute.declaration.Tree->MPC_RelDecl.EndPos = yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].relation_declaration.Ignore;

			;

} break;
case 1129: /* declaration : net_type_declaration ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 200; {
/* line 4618 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree  =  yyAttrStackPtr [1-1].net_type_declaration.Tree;
 yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].net_type_declaration.Position;  
						yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position; ;
  
			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].net_type_declaration.Ignore;

			;

} break;
case 1130: /* declaration : sue_declaration_specifier ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 200; {
/* line 4627 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Type;
 yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].sue_declaration_specifier.Position;  
						yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position; ;
  
			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Ignore;

			;

} break;
case 1131: /* declaration : sue_type_specifier ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 200; {
/* line 4636 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree  =  yyAttrStackPtr [1-1].sue_type_specifier.Type;
 yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].sue_type_specifier.Position;  
						yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position; ;
  
			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].sue_type_specifier.Ignore;

			;

} break;
case 1132: /* declaration : declaring_list ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 200; {
/* line 4645 "mpcPars.lalr" */
  
			    yySynAttribute.declaration.Tree = yyAttrStackPtr [1-1].declaring_list.Tree;
			    if(yySynAttribute.declaration.Tree->Kind==kMPC_Typedef)
			       yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].declaring_list.Position;  
			    else {  
			      if(yyAttrStackPtr [1-1].declaring_list.Ignore)
				yySynAttribute.declaration.Tree->MPC_VarDecl.Flag.Ignore = true;
			      yySynAttribute.declaration.Tree->MPC_VarDecl.Var = ReverseTree(yySynAttribute.declaration.Tree->MPC_VarDecl.Var);
			      yySynAttribute.declaration.Position = yySynAttribute.declaration.Tree->MPC_VarDecl.Pos = yyAttrStackPtr [1-1].declaring_list.Position;  
			      yySynAttribute.declaration.Tree->MPC_Decls.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    }
			    yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].declaring_list.Ignore;

			;

} break;
case 1133: /* declaration : default_declaring_list ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 200; {
/* line 4663 "mpcPars.lalr" */
  
			    yySynAttribute.declaration.Tree = yyAttrStackPtr [1-1].default_declaring_list.Tree;
			    if(yySynAttribute.declaration.Tree->Kind==kMPC_Typedef)
			      yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].default_declaring_list.Position;
			    else {  
			      if(yyAttrStackPtr [1-1].default_declaring_list.Ignore)
				yySynAttribute.declaration.Tree->MPC_VarDecl.Flag.Ignore = true;
			      yySynAttribute.declaration.Tree->MPC_VarDecl.Var = ReverseTree(yySynAttribute.declaration.Tree->MPC_VarDecl.Var);
			      yySynAttribute.declaration.Position = yySynAttribute.declaration.Tree->MPC_VarDecl.Pos = yyAttrStackPtr [1-1].default_declaring_list.Position;  
			    }
			    yySynAttribute.declaration.EndPos = yySynAttribute.declaration.Tree->MPC_Decls.EndPos =  
				     CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].default_declaring_list.Ignore;

			;

} break;
case 1134: /* declaration : omp_declaration .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 200; {
/* line 4681 "mpcPars.lalr" */

                          yySynAttribute.declaration.Tree  =  yyAttrStackPtr [1-1].omp_declaration.Tree;

                          yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].omp_declaration.Ignore;

                          yySynAttribute.declaration.Position  =  yyAttrStackPtr [1-1].omp_declaration.Position;

                          yySynAttribute.declaration.EndPos  =  yyAttrStackPtr [1-1].omp_declaration.EndPos;

                        ;

} break;
case 1135: /* declaration : HEADER .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 200; {
/* line 4692 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree = mMPC_UncompDecl(NoPosition, NoTree, NoTree, yyAttrStackPtr [1-1].Scan.HEADER.SymForm);

			  yySynAttribute.declaration.Position = NoPosition;
 
			  yySynAttribute.declaration.EndPos = NoPosition;

			  yySynAttribute.declaration.Ignore = false;

			;

} break;
case 1136: /* declaration : SOURCE .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 200; {
/* line 4703 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree = mMPC_UncompDecl(NoPosition, NoTree, NoTree, END_OF_HEADER_STRING);

			  yySynAttribute.declaration.Position = NoPosition;
 
			  yySynAttribute.declaration.EndPos = NoPosition;

			  yySynAttribute.declaration.Ignore = false;

			;

} break;
case 1137: /* net_declaring_list : single_net_declaring_list .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 199; {
/* line 4714 "mpcPars.lalr" */

			  yySynAttribute.net_declaring_list.Tree  =  yyAttrStackPtr [1-1].single_net_declaring_list.Tree;

			  yySynAttribute.net_declaring_list.NetType  =  yyAttrStackPtr [1-1].single_net_declaring_list.NetType;

			  yySynAttribute.net_declaring_list.Class  =  yyAttrStackPtr [1-1].single_net_declaring_list.Class;

			  yySynAttribute.net_declaring_list.Ignore  =  yyAttrStackPtr [1-1].single_net_declaring_list.Ignore;

			  yySynAttribute.net_declaring_list.Position  =  yyAttrStackPtr [1-1].single_net_declaring_list.Position;
  
			;

} break;
case 1138: /* net_declaring_list : net_declaring_list ',' net_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 199; {
/* line 4727 "mpcPars.lalr" */

			    yySynAttribute.net_declaring_list.Tree = yyAttrStackPtr [1-1].net_declaring_list.Tree;
			    yySynAttribute.net_declaring_list.NetType = yyAttrStackPtr [1-1].net_declaring_list.NetType;
			    yySynAttribute.net_declaring_list.Class = yyAttrStackPtr [1-1].net_declaring_list.Class;
			    yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net =
				   mMPC_Net(yySynAttribute.net_declaring_list.Position = yyAttrStackPtr [1-1].net_declaring_list.Position,  
					yyAttrStackPtr [3-1].net_declarator.Ident, PRAGMA_BIG,
					yyAttrStackPtr [3-1].net_declarator.Distribution,
					yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net,
					yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net,
					UNDEFINED, yySynAttribute.net_declaring_list.NetType
				   );
			    Clean_OutAttributes(yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net);
			    if(!yyAttrStackPtr [3-1].net_declarator.Ignore &&
			       yyAttrStackPtr [3-1].net_declarator.Distribution->Kind==kMPC_Subnet &&
			       yyAttrStackPtr [3-1].net_declarator.Distribution->MPC_Subnet.Flexible)
			      yyAttrStackPtr [3-1].net_declarator.Distribution->MPC_Subnet.Next =
				yyAttrStackPtr [3-1].net_declarator.Distribution->MPC_Subnet.Prev =
						mMPC_FreeNode(yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net);
			    yySynAttribute.net_declaring_list.Class==TYPEDEF ? Add_Ident(yyAttrStackPtr [3-1].net_declarator.Ident,NSUE_TAG,yySynAttribute.net_declaring_list.NetType)
					   : Add_Ident(yyAttrStackPtr [3-1].net_declarator.Ident,IDENT,
						yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net);
			    yySynAttribute.net_declaring_list.Ignore = yyAttrStackPtr [3-1].net_declarator.Ignore || yyAttrStackPtr [1-1].net_declaring_list.Ignore;
			    yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.EndPos = yyAttrStackPtr [3-1].net_declarator.EndPos;  
			  ;

			;

} break;
case 1139: /* single_net_declaring_list : net_declaration_specifier net_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 164; {
/* line 4755 "mpcPars.lalr" */
  
			    tTree tmp;
			    yySynAttribute.single_net_declaring_list.Tree = mMPC_NetDecl(yySynAttribute.single_net_declaring_list.Position = yyAttrStackPtr [1-1].net_declaration_specifier.Position,  
					NoTree, NoTree,
					yySynAttribute.single_net_declaring_list.Class=yyAttrStackPtr [1-1].net_declaration_specifier.Class, NoDeclFlag,
					yyAttrStackPtr [1-1].net_declaration_specifier.Tree,
					NoTree
				   );
			    tmp = mMPC_FreeNode(yySynAttribute.single_net_declaring_list.Tree);
			    yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net =
				   mMPC_Net(yyAttrStackPtr [2-1].net_declarator.Position,
					yyAttrStackPtr [2-1].net_declarator.Ident, PRAGMA_BIG,
					yyAttrStackPtr [2-1].net_declarator.Distribution, tmp, tmp,
					UNDEFINED,
					yySynAttribute.single_net_declaring_list.NetType=yyAttrStackPtr [1-1].net_declaration_specifier.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net);
			    if(!yyAttrStackPtr [2-1].net_declarator.Ignore &&
			       yyAttrStackPtr [2-1].net_declarator.Distribution->Kind==kMPC_Subnet &&
			       yyAttrStackPtr [2-1].net_declarator.Distribution->MPC_Subnet.Flexible)
			      yyAttrStackPtr [2-1].net_declarator.Distribution->MPC_Subnet.Next =
				yyAttrStackPtr [2-1].net_declarator.Distribution->MPC_Subnet.Prev =
						mMPC_FreeNode(yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net);
			    yySynAttribute.single_net_declaring_list.Class==TYPEDEF ? Add_Ident(yyAttrStackPtr [2-1].net_declarator.Ident,NSUE_TAG,yySynAttribute.single_net_declaring_list.NetType)
					   : Add_Ident(yyAttrStackPtr [2-1].net_declarator.Ident,IDENT,
						yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net);
			    yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Flag.Exported = yyAttrStackPtr [1-1].net_declaration_specifier.Exported;
			    yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Flag.Ignore = yyAttrStackPtr [1-1].net_declaration_specifier.Ignore;
			    yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.EndPos = yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net->
			    		MPC_Net.EndPos = yyAttrStackPtr [2-1].net_declarator.EndPos;  
			    yySynAttribute.single_net_declaring_list.Ignore = yyAttrStackPtr [2-1].net_declarator.Ignore;
			  ;

			;

} break;
case 1140: /* net_declarator : general_identifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 209; {
/* line 4790 "mpcPars.lalr" */

			  yySynAttribute.net_declarator.Ident  =  yyAttrStackPtr [1-1].general_identifier.Ident;

			  yySynAttribute.net_declarator.Distribution = HOST;

			  yySynAttribute.net_declarator.Ignore  =  yyAttrStackPtr [1-1].general_identifier.Ignore;
 yySynAttribute.net_declarator.Position = yyAttrStackPtr [1-1].general_identifier.Position;  
				   yySynAttribute.net_declarator.EndPos = CurrentPosition = yyAttrStackPtr [1-1].general_identifier.EndPos ;
  
			;

} break;
case 1141: /* net_declarator : net_specifier general_identifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 209; {
/* line 4801 "mpcPars.lalr" */
 
			  yySynAttribute.net_declarator.Ident  =  yyAttrStackPtr [2-1].general_identifier.Ident;

			  yySynAttribute.net_declarator.Distribution  =  yyAttrStackPtr [1-1].net_specifier.Tree;

			    yySynAttribute.net_declarator.Ignore = yyAttrStackPtr [1-1].net_specifier.Ignore || yyAttrStackPtr [2-1].general_identifier.Ignore;
			  ;
 yySynAttribute.net_declarator.Position = yyAttrStackPtr [1-1].net_specifier.Position;  
				   yySynAttribute.net_declarator.EndPos = CurrentPosition = yyAttrStackPtr [2-1].general_identifier.EndPos;  ;
  
			;

} break;
case 1142: /* net_declarator : subnet_specifier general_identifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 209; {
/* line 4813 "mpcPars.lalr" */

			  yySynAttribute.net_declarator.Ident  =  yyAttrStackPtr [2-1].general_identifier.Ident;

			  yySynAttribute.net_declarator.Distribution  =  yyAttrStackPtr [1-1].subnet_specifier.Tree;

			    yySynAttribute.net_declarator.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore || yyAttrStackPtr [2-1].general_identifier.Ignore;
			  ;
 yySynAttribute.net_declarator.Position = yyAttrStackPtr [1-1].subnet_specifier.Position;  
				  yySynAttribute.net_declarator.EndPos = CurrentPosition = yyAttrStackPtr [2-1].general_identifier.EndPos; ;
  
			;

} break;
case 1143: /* net_declaration_specifier : net_type_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 210; {
/* line 4825 "mpcPars.lalr" */

			  yySynAttribute.net_declaration_specifier.Tree  =  yyAttrStackPtr [1-1].net_type_specifier.Tree;

			    yySynAttribute.net_declaration_specifier.Class = Default_Class==AUTO ? AUTO : GLOBAL_STATIC ;
			  ;

			  yySynAttribute.net_declaration_specifier.Exported = yySynAttribute.net_declaration_specifier.Class==GLOBAL_STATIC ? true : false ;

			  yySynAttribute.net_declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].net_type_specifier.Ignore;

			  yySynAttribute.net_declaration_specifier.Position  =  yyAttrStackPtr [1-1].net_type_specifier.Position;

			  
			;

} break;
case 1144: /* net_declaration_specifier : storage_class net_type_specifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 210; {
/* line 4840 "mpcPars.lalr" */
 
			  yySynAttribute.net_declaration_specifier.Tree  =  yyAttrStackPtr [2-1].net_type_specifier.Tree;
  
			    yySynAttribute.net_declaration_specifier.Class = yyAttrStackPtr [1-1].storage_class.Class;
			    if(yySynAttribute.net_declaration_specifier.Class==FLEXIBLE || yySynAttribute.net_declaration_specifier.Class==REGISTER ||
			       yySynAttribute.net_declaration_specifier.Class==AUTO && Default_Class!=AUTO)
			      Make_Message(
				456, xxError, yyAttrStackPtr [1-1].storage_class.Position, NoTree);
		
			    else if(yySynAttribute.net_declaration_specifier.Class==STATIC)
			      yySynAttribute.net_declaration_specifier.Class = Default_Class==AUTO ? LOCAL_STATIC : GLOBAL_STATIC;
			     yySynAttribute.net_declaration_specifier.Tree->MPC_NetTypeSpecifier.Pos = yySynAttribute.net_declaration_specifier.Position = yyAttrStackPtr [1-1].storage_class.Position;  
 			  ;

			  yySynAttribute.net_declaration_specifier.Exported = false;

			  yySynAttribute.net_declaration_specifier.Ignore  =  yyAttrStackPtr [2-1].net_type_specifier.Ignore;

			  
			;

} break;
case 1145: /* net_type_specifier : net general_identifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 213; {
/* line 4861 "mpcPars.lalr" */
  
			    tTree tmp=NoTree;
			    if(yyAttrStackPtr [2-1].general_identifier.Ident!=NoIdent &&
			       !(tmp=Find_Ident(yyAttrStackPtr [2-1].general_identifier.Ident,NSUE_TAG))) {
			      Make_MessageI(489 , xxError,
				yyAttrStackPtr [2-1].general_identifier.Position, xxIdent,
				(char*)&yyAttrStackPtr [2-1].general_identifier.Ident, NoTree
			      ); 
			
			      yySynAttribute.net_type_specifier.Ignore = true;
			    }
			    yySynAttribute.net_type_specifier.Ignore = !tmp || yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.net_type_specifier.Tree = mMPC_NetTypeSpecifier(
					yySynAttribute.net_type_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree, yyAttrStackPtr [2-1].general_identifier.Ident, tmp, NoTree
				   );
			    yySynAttribute.net_type_specifier.Tree->MPC_NetTypeSpecifier.ArgList = mMPC_FreeNode(yySynAttribute.net_type_specifier.Tree);
			    yySynAttribute.net_type_specifier.Tree->MPC_NetTypeSpecifier.EndPos = yySynAttribute.net_type_specifier.EndPos =
				 CurrentPosition = yyAttrStackPtr [2-1].general_identifier.EndPos;  
			  ;

			;

} break;
case 1146: /* net_type_specifier : net general_identifier '(' argument_expression_list ')' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 213; {
/* line 4884 "mpcPars.lalr" */
  
			    tTree tmp=NoTree;
			    if(yyAttrStackPtr [2-1].general_identifier.Ident!=NoIdent &&
			       !(tmp=Find_Ident(yyAttrStackPtr [2-1].general_identifier.Ident,NSUE_TAG)))
			      Make_MessageI(489 , xxError,
				yyAttrStackPtr [2-1].general_identifier.Position, xxIdent,
				(char*)&yyAttrStackPtr [2-1].general_identifier.Ident, NoTree
			      );
			
			    yySynAttribute.net_type_specifier.Ignore = !tmp || yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.net_type_specifier.Tree = mMPC_NetTypeSpecifier(yySynAttribute.net_type_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree, yyAttrStackPtr [2-1].general_identifier.Ident, tmp,
					ReverseTree(yyAttrStackPtr [4-1].argument_expression_list.Tree)
				   );
			    yySynAttribute.net_type_specifier.Tree->MPC_NetTypeSpecifier.ArgList->
					MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_type_specifier.Tree;
			    yySynAttribute.net_type_specifier.Tree->MPC_NetTypeSpecifier.EndPos = yySynAttribute.net_type_specifier.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			  ;

			;

} break;
case 1147: /* net_type_declaration : storage_class_opt nettype general_identifier new_scope '{' net_declaration '}' .*/
  yyStateStackPtr -= 7; yyAttrStackPtr -= 7; yyNonterminal = 203; {
/* line 4905 "mpcPars.lalr" */
  
			    Close_Scope();
			    Scope_Depth--;
			    Default_Class = EXTERN;  
			    if(!(yyAttrStackPtr [1-1].storage_class_opt.Class==EXTERN ||
				yyAttrStackPtr [1-1].storage_class_opt.Class==STATIC ||
				yyAttrStackPtr [1-1].storage_class_opt.Class==UNDEFINED)) {
				Make_Message(457, xxError,
					     yyAttrStackPtr [1-1].storage_class_opt.Position, NoTree);
		
				yySynAttribute.net_type_declaration.Ignore = true;
			    }
			    yySynAttribute.net_type_declaration.Tree = yyAttrStackPtr [6-1].net_declaration.Tree;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Ident = yyAttrStackPtr [3-1].general_identifier.Ident;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Class = yyAttrStackPtr [1-1].storage_class_opt.Class;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Pos = yySynAttribute.net_type_declaration.Position =  
				(!Compare(yyAttrStackPtr [1-1].storage_class_opt.Position,NoPosition) )?  
				 yyAttrStackPtr [2-1].Scan.Position:yyAttrStackPtr [1-1].storage_class_opt.Position;  
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.EndPos = yySynAttribute.net_type_declaration.EndPos = CurrentPosition = yyAttrStackPtr [7-1].Scan.Position;  
			    Add_Ident(yyAttrStackPtr [3-1].general_identifier.Ident, NSUE_TAG, yySynAttribute.net_type_declaration.Tree);
			    yySynAttribute.net_type_declaration.Ignore = yySynAttribute.net_type_declaration.Ignore || yyAttrStackPtr [3-1].general_identifier.Ignore || yyAttrStackPtr [6-1].net_declaration.Ignore;
			  ;

			;

} break;
case 1148: /* net_type_declaration : storage_class_opt nettype general_identifier new_scope '(' topo_parameter_list ')' '{' net_declaration '}' .*/
  yyStateStackPtr -= 10; yyAttrStackPtr -= 10; yyNonterminal = 203; {
/* line 4930 "mpcPars.lalr" */
  
			    Close_Scope();
			    Scope_Depth--;
			    Default_Class = EXTERN;  
			    Inside_topo_param_list = false;
			    if(!(yyAttrStackPtr [1-1].storage_class_opt.Class==EXTERN ||
				yyAttrStackPtr [1-1].storage_class_opt.Class==STATIC ||
				yyAttrStackPtr [1-1].storage_class_opt.Class==UNDEFINED)) {
				Make_Message(457, xxError,
					     yyAttrStackPtr [1-1].storage_class_opt.Position, NoTree);
		
				yySynAttribute.net_type_declaration.Ignore = true;
			    }
			    yySynAttribute.net_type_declaration.Tree = yyAttrStackPtr [9-1].net_declaration.Tree;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Ident = yyAttrStackPtr [3-1].general_identifier.Ident;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Class = yyAttrStackPtr [1-1].storage_class_opt.Class;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.ParamList = ReverseTree(yyAttrStackPtr [6-1].topo_parameter_list.Tree);
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.ParamList->MPC_Var.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_type_declaration.Tree;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Pos = yySynAttribute.net_type_declaration.Position =  
				(!Compare(yyAttrStackPtr [1-1].storage_class_opt.Position,NoPosition) )?  
				yyAttrStackPtr [2-1].Scan.Position:yyAttrStackPtr [1-1].storage_class_opt.Position;  
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.EndPos = yySynAttribute.net_type_declaration.EndPos = CurrentPosition = yyAttrStackPtr [10-1].Scan.Position;  
			    Add_Ident(yyAttrStackPtr [3-1].general_identifier.Ident, NSUE_TAG, yySynAttribute.net_type_declaration.Tree);
			    yySynAttribute.net_type_declaration.Ignore = yySynAttribute.net_type_declaration.Ignore || yyAttrStackPtr [3-1].general_identifier.Ignore ||
				     yyAttrStackPtr [6-1].topo_parameter_list.Ignore  || yyAttrStackPtr [9-1].net_declaration.Ignore;
			  ;

			;

} break;
case 1149: /* storage_class_opt : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 215; {
/* line 4960 "mpcPars.lalr" */
 yySynAttribute.storage_class_opt.Class = UNDEFINED;
 yySynAttribute.storage_class_opt.Position = NoPosition;
  ;

} break;
case 1150: /* storage_class_opt : storage_class .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 215; {
/* line 4964 "mpcPars.lalr" */

			  yySynAttribute.storage_class_opt.Class  =  yyAttrStackPtr [1-1].storage_class.Class;

			  yySynAttribute.storage_class_opt.Position  =  yyAttrStackPtr [1-1].storage_class.Position;

			  
		        ;

} break;
case 1151: /* topo_parameter_list : topo_parameter .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 217; {
/* line 4972 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    Push_Pattern(yyAttrStackPtr [1-1].topo_parameter.Type);
			    yySynAttribute.topo_parameter_list.Tree = mMPC_Var(yySynAttribute.topo_parameter_list.Position=yyAttrStackPtr [1-1].topo_parameter.Position,
					yyAttrStackPtr [1-1].topo_parameter.Ident, NoDeclFlag,
					tmp, tmp, Make_Type(),
					NO_NET, NoTree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.topo_parameter_list.Tree);
			    Add_Ident(yyAttrStackPtr [1-1].topo_parameter.Ident, IDENT, yySynAttribute.topo_parameter_list.Tree);
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.Flag.Parameter = YES;
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.Flag.Ignore = yySynAttribute.topo_parameter_list.Ignore = yyAttrStackPtr [1-1].topo_parameter.Ignore;
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.EndPos = yySynAttribute.topo_parameter_list.EndPos = yyAttrStackPtr [1-1].topo_parameter.EndPos;  
			  ;

			;

} break;
case 1152: /* topo_parameter_list : topo_parameter_list ',' topo_parameter .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 217; {
/* line 4990 "mpcPars.lalr" */

			    Push_Pattern(yyAttrStackPtr [3-1].topo_parameter.Type);
			    yySynAttribute.topo_parameter_list.Tree = mMPC_Var(yySynAttribute.topo_parameter_list.Position=yyAttrStackPtr [1-1].topo_parameter_list.Position,  
					yyAttrStackPtr [3-1].topo_parameter.Ident, NoDeclFlag,
					yyAttrStackPtr [1-1].topo_parameter_list.Tree,
					yyAttrStackPtr [1-1].topo_parameter_list.Tree, Make_Type(),
					NO_NET, NoTree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.topo_parameter_list.Tree);
			    Add_Ident(yyAttrStackPtr [3-1].topo_parameter.Ident, IDENT, yySynAttribute.topo_parameter_list.Tree);
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.Flag.Parameter = YES;
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.Flag.Ignore = yySynAttribute.topo_parameter_list.Ignore =
					yyAttrStackPtr [1-1].topo_parameter_list.Ignore && yyAttrStackPtr [3-1].topo_parameter.Ignore;
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.EndPos = yySynAttribute.topo_parameter_list.EndPos = yyAttrStackPtr [3-1].topo_parameter.EndPos;  
			  ;

			;

} break;
case 1153: /* topo_parameter : general_identifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 218; {
/* line 5008 "mpcPars.lalr" */

			  yySynAttribute.topo_parameter.Ident  =  yyAttrStackPtr [1-1].general_identifier.Ident;

			  yySynAttribute.topo_parameter.Type = ReplConstIntType;

			  yySynAttribute.topo_parameter.Ignore  =  yyAttrStackPtr [1-1].general_identifier.Ignore;

			  yySynAttribute.topo_parameter.Position  =  yyAttrStackPtr [1-1].general_identifier.Position;

			  yySynAttribute.topo_parameter.EndPos  =  yyAttrStackPtr [1-1].general_identifier.EndPos;
  
			  ;
{  Inside_topo_param_list = true; ; }
			;

} break;
case 1154: /* topo_parameter : basic_type_name general_identifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 218; {
/* line 5023 "mpcPars.lalr" */

			  yySynAttribute.topo_parameter.Ident  =  yyAttrStackPtr [2-1].general_identifier.Ident;

			    yySynAttribute.topo_parameter.Ignore = yyAttrStackPtr [1-1].basic_type_name.Ignore || yyAttrStackPtr [2-1].general_identifier.Ignore;
			    if(yyAttrStackPtr [1-1].basic_type_name.TypeName==INT)
			      yySynAttribute.topo_parameter.Type = ReplConstIntType;
			    else if(yyAttrStackPtr [1-1].basic_type_name.TypeName==DOUBLE || yyAttrStackPtr [1-1].basic_type_name.TypeName==FLOAT)
			      yySynAttribute.topo_parameter.Type = ReplConstDoubleType;
			    else {
			      yySynAttribute.topo_parameter.Type = ErrorType;
			      yySynAttribute.topo_parameter.Ignore = true;
			      Make_Message(458, xxError,
					   yyAttrStackPtr [1-1].basic_type_name.Position, NoTree);
		
			    }
			  ;

			  yySynAttribute.topo_parameter.Position  =  yyAttrStackPtr [1-1].basic_type_name.Position;
  
			  yySynAttribute.topo_parameter.EndPos  =  yyAttrStackPtr [2-1].general_identifier.EndPos;
  
			  ;
{  Inside_topo_param_list = true; ; }
			;

} break;
case 1155: /* topo_parameter : topo_parameter array_abstract_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 218; {
/* line 5048 "mpcPars.lalr" */

			  yySynAttribute.topo_parameter.Ident  =  yyAttrStackPtr [1-1].topo_parameter.Ident;

			    yySynAttribute.topo_parameter.Ignore = yyAttrStackPtr [1-1].topo_parameter.Ignore || yyAttrStackPtr [2-1].array_abstract_declarator.Ignore;
			    yySynAttribute.topo_parameter.Type = yyAttrStackPtr [1-1].topo_parameter.Type;  
			    if(TopType()->MPC_ArrayType.NumberOfComponents==UNDEFINED) {
			      yySynAttribute.topo_parameter.Ignore = true;
			      Make_Message(458, xxError, yyAttrStackPtr [2-1].array_abstract_declarator.Position, TopType());
					   
			    }
			  ;

			  yySynAttribute.topo_parameter.Position  =  yyAttrStackPtr [1-1].topo_parameter.Position;
  
			  yySynAttribute.topo_parameter.EndPos  =  yyAttrStackPtr [2-1].array_abstract_declarator.EndPos;
  
			;

} break;
case 1156: /* net_declaration : coord_declaration .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 216; {
/* line 5066 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore;
			  ;

			;

} break;
case 1157: /* net_declaration : coord_declaration parent_node_declaration .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 216; {
/* line 5076 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [2-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore || yyAttrStackPtr [2-1].parent_node_declaration.Ignore;
			  ;

			;

} break;
case 1158: /* net_declaration : coord_declaration node_declaration .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 216; {
/* line 5090 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore;
			  ;

			;

} break;
case 1159: /* net_declaration : coord_declaration node_declaration parent_node_declaration .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 216; {
/* line 5104 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [3-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].parent_node_declaration.Ignore;
			  ;

			;

} break;
case 1160: /* net_declaration : coord_declaration link_declaration .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 216; {
/* line 5123 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [2-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].link_declaration.Ignore;
			  ;

			;

} break;
case 1161: /* net_declaration : coord_declaration link_declaration parent_node_declaration .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 216; {
/* line 5135 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [2-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [3-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].link_declaration.Ignore ||
				     yyAttrStackPtr [3-1].parent_node_declaration.Ignore;
			  ;

			;

} break;
case 1162: /* net_declaration : coord_declaration node_declaration link_declaration .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 216; {
/* line 5152 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [3-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].link_declaration.Ignore;
			  ;

			;

} break;
case 1163: /* net_declaration : coord_declaration node_declaration link_declaration parent_node_declaration .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 216; {
/* line 5168 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [3-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl = 
						ReverseTree(yyAttrStackPtr [4-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].link_declaration.Ignore ||
				     yyAttrStackPtr [4-1].parent_node_declaration.Ignore;
			  ;

			;

} break;
case 1164: /* net_declaration : coord_declaration scheme_declaration .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 216; {
/* line 5189 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [2-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore || yyAttrStackPtr [2-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1165: /* net_declaration : coord_declaration parent_node_declaration scheme_declaration .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 216; {
/* line 5200 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [2-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [3-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore || yyAttrStackPtr [2-1].parent_node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1166: /* net_declaration : coord_declaration node_declaration scheme_declaration .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 216; {
/* line 5216 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [3-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore  || yyAttrStackPtr [3-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1167: /* net_declaration : coord_declaration node_declaration parent_node_declaration scheme_declaration .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 216; {
/* line 5231 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [3-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [4-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].parent_node_declaration.Ignore ||
				     yyAttrStackPtr [4-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1168: /* net_declaration : coord_declaration link_declaration scheme_declaration .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 216; {
/* line 5252 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [2-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [3-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].link_declaration.Ignore ||
				     yyAttrStackPtr [3-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1169: /* net_declaration : coord_declaration link_declaration parent_node_declaration scheme_declaration .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 216; {
/* line 5266 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [2-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [3-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [4-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].link_declaration.Ignore ||
				     yyAttrStackPtr [3-1].parent_node_declaration.Ignore ||
				     yyAttrStackPtr [4-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1170: /* net_declaration : coord_declaration node_declaration link_declaration scheme_declaration .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 216; {
/* line 5285 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [3-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [4-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].link_declaration.Ignore ||
				     yyAttrStackPtr [4-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1171: /* net_declaration : coord_declaration node_declaration link_declaration parent_node_declaration scheme_declaration .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 216; {
/* line 5303 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [3-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl = 
						ReverseTree(yyAttrStackPtr [4-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [5-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].link_declaration.Ignore ||
				     yyAttrStackPtr [4-1].parent_node_declaration.Ignore ||
				     yyAttrStackPtr [5-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1172: /* coord_declaration : coord coord_list ';' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 221; {
/* line 5326 "mpcPars.lalr" */

			    yySynAttribute.coord_declaration.Tree = yyAttrStackPtr [2-1].coord_list.Tree;
			    CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;
			  ;

			  yySynAttribute.coord_declaration.Ignore  =  yyAttrStackPtr [2-1].coord_list.Ignore;

			;

} break;
case 1173: /* coord_list : coord_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 226; {
/* line 5335 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.coord_list.Tree = mMPC_CoordDecl(yySynAttribute.coord_list.Position = yyAttrStackPtr [1-1].coord_declarator.Position,  
					yyAttrStackPtr [1-1].coord_declarator.Ident, tmp, tmp,
					yyAttrStackPtr [1-1].coord_declarator.Range
				   );
			    Add_Ident(yyAttrStackPtr [1-1].coord_declarator.Ident, IDENT, yySynAttribute.coord_list.Tree);
			    yySynAttribute.coord_list.Ignore = yyAttrStackPtr [1-1].coord_declarator.Ignore;
			    yySynAttribute.coord_list.Tree->MPC_CoordDecl.EndPos = yyAttrStackPtr [1-1].coord_declarator.EndPos;  
			  ;

			;

} break;
case 1174: /* coord_list : coord_list ',' coord_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 226; {
/* line 5349 "mpcPars.lalr" */
yySynAttribute.coord_list.Position = yyAttrStackPtr [3-1].coord_declarator.Position;

			    yySynAttribute.coord_list.Position = yyAttrStackPtr [1-1].coord_list.Position,  
			    yySynAttribute.coord_list.Tree = mMPC_CoordDecl(yyAttrStackPtr [3-1].coord_declarator.Position,  
					yyAttrStackPtr [3-1].coord_declarator.Ident, yyAttrStackPtr [1-1].coord_list.Tree,
					yyAttrStackPtr [1-1].coord_list.Tree, yyAttrStackPtr [3-1].coord_declarator.Range
				   );
			    Add_Ident(yyAttrStackPtr [3-1].coord_declarator.Ident, IDENT, yySynAttribute.coord_list.Tree);
			    yySynAttribute.coord_list.Ignore = yyAttrStackPtr [1-1].coord_list.Ignore || yyAttrStackPtr [3-1].coord_declarator.Ignore;
			    yySynAttribute.coord_list.Tree->MPC_CoordDecl.EndPos = yyAttrStackPtr [3-1].coord_declarator.EndPos;  
			  ;

			;

} break;
case 1175: /* coord_declarator : general_identifier '=' constant_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 227; {
/* line 5363 "mpcPars.lalr" */

			  yySynAttribute.coord_declarator.Ident  =  yyAttrStackPtr [1-1].general_identifier.Ident;

			  yySynAttribute.coord_declarator.Range  =  yyAttrStackPtr [3-1].constant_expression.Tree;

			    yySynAttribute.coord_declarator.Ignore = yyAttrStackPtr [1-1].general_identifier.Ignore || yyAttrStackPtr [3-1].constant_expression.Ignore;
			  ;

			  yySynAttribute.coord_declarator.Position  =  yyAttrStackPtr [1-1].general_identifier.Position;
  
			  yySynAttribute.coord_declarator.EndPos  =  yyAttrStackPtr [3-1].constant_expression.EndPos;
  
			;

} break;
case 1176: /* node_declaration : node '{' node_declaring_list '}' ';' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 223; {
/* line 5377 "mpcPars.lalr" */

			    yySynAttribute.node_declaration.Tree = yyAttrStackPtr [3-1].node_declaring_list.Tree;
			    CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;
			  ;

			  yySynAttribute.node_declaration.Ignore  =  yyAttrStackPtr [3-1].node_declaring_list.Ignore;

			;

} break;
case 1177: /* node_declaring_list : node_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 228; {
/* line 5386 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.node_declaring_list.Tree = mMPC_Node( yySynAttribute.node_declaring_list.Position = yyAttrStackPtr [1-1].node_declarator.Position, yyAttrStackPtr [1-1].node_declarator.NodeType,  
					yyAttrStackPtr [1-1].node_declarator.Dynamic ,
					tmp, tmp, yyAttrStackPtr [1-1].node_declarator.Predicate,
					yyAttrStackPtr [1-1].node_declarator.NodeQual
				   );
			    yySynAttribute.node_declaring_list.Ignore = yyAttrStackPtr [1-1].node_declarator.Ignore;
			    yySynAttribute.node_declaring_list.Tree->MPC_Node.EndPos = yyAttrStackPtr [1-1].node_declarator.EndPos;   
			  ;

			;

} break;
case 1178: /* node_declaring_list : node_declaring_list node_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 228; {
/* line 5400 "mpcPars.lalr" */
  
			    yySynAttribute.node_declaring_list.Position = yyAttrStackPtr [1-1].node_declaring_list.Position,  
			    yySynAttribute.node_declaring_list.Tree = mMPC_Node( yyAttrStackPtr [2-1].node_declarator.Position,  
					yyAttrStackPtr [2-1].node_declarator.NodeType,
					yyAttrStackPtr [2-1].node_declarator.Dynamic ,
					yyAttrStackPtr [1-1].node_declaring_list.Tree,
					yyAttrStackPtr [1-1].node_declaring_list.Tree,
					yyAttrStackPtr [2-1].node_declarator.Predicate,
					yyAttrStackPtr [2-1].node_declarator.NodeQual
				   );
			    yySynAttribute.node_declaring_list.Ignore = yyAttrStackPtr [1-1].node_declaring_list.Ignore || yyAttrStackPtr [2-1].node_declarator.Ignore;
			    yySynAttribute.node_declaring_list.Tree->MPC_Node.EndPos = yyAttrStackPtr [2-1].node_declarator.EndPos;   
			  ;

			;

} break;
case 1179: /* node_declarator : constant_expression ':' node_type_specifier ';' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 229; {
/* line 5416 "mpcPars.lalr" */

			  yySynAttribute.node_declarator.Predicate  =  yyAttrStackPtr [1-1].constant_expression.Tree;

			  yySynAttribute.node_declarator.NodeQual  =  yyAttrStackPtr [3-1].node_type_specifier.NodeQual;

			  yySynAttribute.node_declarator.NodeType  =  yyAttrStackPtr [3-1].node_type_specifier.NodeType;

			  yySynAttribute.node_declarator.Dynamic  =  yyAttrStackPtr [3-1].node_type_specifier.Dynamic;

			  yySynAttribute.node_declarator.Ignore  =  yyAttrStackPtr [1-1].constant_expression.Ignore;
 yySynAttribute.node_declarator.Position = yyAttrStackPtr [1-1].constant_expression.Position;  
						yySynAttribute.node_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position; ;
  
			;

} break;
case 1180: /* node_declarator : default ':' node_type_specifier ';' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 229; {
/* line 5431 "mpcPars.lalr" */

			  yySynAttribute.node_declarator.Predicate = NoTree;

			  yySynAttribute.node_declarator.NodeQual  =  yyAttrStackPtr [3-1].node_type_specifier.NodeQual;

			  yySynAttribute.node_declarator.NodeType  =  yyAttrStackPtr [3-1].node_type_specifier.NodeType;

			  yySynAttribute.node_declarator.Dynamic  =  yyAttrStackPtr [3-1].node_type_specifier.Dynamic;

			  yySynAttribute.node_declarator.Ignore = false;
 yySynAttribute.node_declarator.Position = yyAttrStackPtr [1-1].Scan.Position;  
						yySynAttribute.node_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position; ;
  
			;

} break;
case 1181: /* node_type_specifier : void .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 230; {
/* line 5446 "mpcPars.lalr" */

			  yySynAttribute.node_type_specifier.NodeQual = NoTree;

			    yySynAttribute.node_type_specifier.NodeType = VOID_NODE;
			    CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic = false;

			;

} break;
case 1182: /* node_type_specifier : speed_specifier memory .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 230; {
/* line 5457 "mpcPars.lalr" */

			    yySynAttribute.node_type_specifier.NodeQual = yyAttrStackPtr [1-1].speed_specifier.Tree;
			    yySynAttribute.node_type_specifier.NodeType = MEMORY_NODE + yyAttrStackPtr [1-1].speed_specifier.NodeQual;
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic  =  yyAttrStackPtr [1-1].speed_specifier.Dynamic;

			;

} break;
case 1183: /* node_type_specifier : speed_specifier scalar .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 230; {
/* line 5467 "mpcPars.lalr" */

			    yySynAttribute.node_type_specifier.NodeQual = yyAttrStackPtr [1-1].speed_specifier.Tree;
			    yySynAttribute.node_type_specifier.NodeType = SCALAR_NODE + yyAttrStackPtr [1-1].speed_specifier.NodeQual;
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic  =  yyAttrStackPtr [1-1].speed_specifier.Dynamic;

			;

} break;
case 1184: /* node_type_specifier : speed_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 230; {
/* line 5477 "mpcPars.lalr" */

			    yySynAttribute.node_type_specifier.NodeQual = yyAttrStackPtr [1-1].speed_specifier.Tree;
			    yySynAttribute.node_type_specifier.NodeType = SCALAR_NODE + yyAttrStackPtr [1-1].speed_specifier.NodeQual;
			    CurrentPosition = yyAttrStackPtr [1-1].speed_specifier.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic  =  yyAttrStackPtr [1-1].speed_specifier.Dynamic;

			;

} break;
case 1185: /* node_type_specifier : speed_specifier vector .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 230; {
/* line 5487 "mpcPars.lalr" */

			    yySynAttribute.node_type_specifier.NodeQual = yyAttrStackPtr [1-1].speed_specifier.Tree;
			    yySynAttribute.node_type_specifier.NodeType = VECTOR_NODE + yyAttrStackPtr [1-1].speed_specifier.NodeQual;
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic  =  yyAttrStackPtr [1-1].speed_specifier.Dynamic;

			;

} break;
case 1186: /* speed_specifier : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 231; {
/* line 5497 "mpcPars.lalr" */
 yySynAttribute.speed_specifier.Tree = NoTree;
 yySynAttribute.speed_specifier.NodeQual = 0;
 yySynAttribute.speed_specifier.Dynamic = false;

			      yySynAttribute.speed_specifier.Position = NoPosition;

			       ;

} break;
case 1187: /* speed_specifier : fast_node_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 231; {
/* line 5505 "mpcPars.lalr" */

			  yySynAttribute.speed_specifier.Tree  =  yyAttrStackPtr [1-1].fast_node_specifier.Tree;

			  yySynAttribute.speed_specifier.NodeQual  =  yyAttrStackPtr [1-1].fast_node_specifier.NodeQual;

			  yySynAttribute.speed_specifier.Dynamic = yyAttrStackPtr [1-1].fast_node_specifier.NodeQual ? false : true;

			  yySynAttribute.speed_specifier.Position  =  yyAttrStackPtr [1-1].fast_node_specifier.Position;

			  
			;

} break;
case 1188: /* speed_specifier : slow_node_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 231; {
/* line 5517 "mpcPars.lalr" */

			  yySynAttribute.speed_specifier.Tree  =  yyAttrStackPtr [1-1].slow_node_specifier.Tree;

			  yySynAttribute.speed_specifier.NodeQual  =  yyAttrStackPtr [1-1].slow_node_specifier.NodeQual;

			  yySynAttribute.speed_specifier.Dynamic = yyAttrStackPtr [1-1].slow_node_specifier.NodeQual ? false : true;

			  yySynAttribute.speed_specifier.Position  =  yyAttrStackPtr [1-1].slow_node_specifier.Position;

			  
			;

} break;
case 1189: /* speed_specifier : bench_node_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 231; {
/* line 5529 "mpcPars.lalr" */

			  yySynAttribute.speed_specifier.Tree  =  yyAttrStackPtr [1-1].bench_node_specifier.Tree;

			  yySynAttribute.speed_specifier.NodeQual = 0;
    
			  yySynAttribute.speed_specifier.Dynamic = true;
  
			  yySynAttribute.speed_specifier.Position  =  yyAttrStackPtr [1-1].bench_node_specifier.Position;

			  
			;

} break;
case 1190: /* fast_node_specifier : fast .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 232; {
/* line 5541 "mpcPars.lalr" */
  
			    yySynAttribute.fast_node_specifier.Tree = mMPC_NodeTypeQual( 
				yySynAttribute.fast_node_specifier.Position = yySynAttribute.fast_node_specifier.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position,  
				 NoTree, true, 1);
			    yySynAttribute.fast_node_specifier.NodeQual = FAST;
			    yySynAttribute.fast_node_specifier.EndPos.Column += 3;  
			    yySynAttribute.fast_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.fast_node_specifier.EndPos;  
			  ;

			;

} break;
case 1191: /* fast_node_specifier : fast '*' expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 232; {
/* line 5552 "mpcPars.lalr" */
yySynAttribute.fast_node_specifier.Position = yyAttrStackPtr [3-1].expression.Position;
  
			    yySynAttribute.fast_node_specifier.Tree = mMPC_NodeTypeQual(yySynAttribute.fast_node_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,
					yyAttrStackPtr [3-1].expression.Tree, true,
					yyAttrStackPtr [3-1].expression.Value
				   );
			    yySynAttribute.fast_node_specifier.NodeQual = FAST * yyAttrStackPtr [3-1].expression.Value;
			    yySynAttribute.fast_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.fast_node_specifier.EndPos = yyAttrStackPtr [3-1].expression.EndPos;  
			  ;

			;

} break;
case 1192: /* fast_node_specifier : expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 232; {
/* line 5564 "mpcPars.lalr" */
yySynAttribute.fast_node_specifier.Position = yyAttrStackPtr [1-1].expression.Position;
  
			    yySynAttribute.fast_node_specifier.Tree = mMPC_NodeTypeQual( yySynAttribute.fast_node_specifier.Position = yyAttrStackPtr [1-1].expression.BegPos,  
					yyAttrStackPtr [1-1].expression.Tree, true,
					yyAttrStackPtr [1-1].expression.Value
				   );
			    yySynAttribute.fast_node_specifier.NodeQual = FAST * yyAttrStackPtr [1-1].expression.Value;
			    yySynAttribute.fast_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.fast_node_specifier.EndPos = yyAttrStackPtr [1-1].expression.EndPos;  
			  ;

			;

} break;
case 1193: /* slow_node_specifier : slow .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 233; {
/* line 5576 "mpcPars.lalr" */
  
			    yySynAttribute.slow_node_specifier.Tree = mMPC_NodeTypeQual( yySynAttribute.slow_node_specifier.Position = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position,  
					 NoTree, false, 1);
			    yySynAttribute.slow_node_specifier.NodeQual = SLOW;
			    yySynAttribute.slow_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.slow_node_specifier.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.slow_node_specifier.EndPos.Column += 3;  
			  ;

			;

} break;
case 1194: /* slow_node_specifier : slow '*' expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 233; {
/* line 5586 "mpcPars.lalr" */
  
			    yySynAttribute.slow_node_specifier.Tree = mMPC_NodeTypeQual( yySynAttribute.slow_node_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					yyAttrStackPtr [3-1].expression.Tree, false,
					yyAttrStackPtr [3-1].expression.Value
				   );
			    yySynAttribute.slow_node_specifier.NodeQual = SLOW * yyAttrStackPtr [3-1].expression.Value;
			    yySynAttribute.slow_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.slow_node_specifier.EndPos = yyAttrStackPtr [3-1].expression.EndPos;  
			  ;

			;

} break;
case 1195: /* bench_node_specifier : bench '*' expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 234; {
/* line 5597 "mpcPars.lalr" */
  
			    yySynAttribute.bench_node_specifier.Tree = mMPC_BenchQual( yySynAttribute.bench_node_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					yyAttrStackPtr [3-1].expression.Tree,
					yyAttrStackPtr [3-1].expression.Tree->Kind==kMPC_FloatConst ?
						yyAttrStackPtr [3-1].expression.Tree->MPC_FloatConst.Value : 0.0 
				   );
			    yySynAttribute.bench_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.bench_node_specifier.EndPos = yyAttrStackPtr [3-1].expression.EndPos;  
			  ;

			;

} break;
case 1196: /* link_declaration : link '{' link_declaring_list '}' ';' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 224; {
/* line 5608 "mpcPars.lalr" */

			    yySynAttribute.link_declaration.Tree = mMPC_LinkDecl(yyAttrStackPtr [1-1].Scan.Position, NoTree,  
					ReverseTree(yyAttrStackPtr [3-1].link_declaring_list.Tree)
				   );
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.LinkDeclaringList->
				  MPC_LinkDeclaringList.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declaration.Tree;
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    yySynAttribute.link_declaration.Ignore = yyAttrStackPtr [3-1].link_declaring_list.Ignore;
			  ;

			;

} break;
case 1197: /* link_declaration : link new_scope free_coord_list '{' link_declaring_list '}' ';' .*/
  yyStateStackPtr -= 7; yyAttrStackPtr -= 7; yyNonterminal = 224; {
/* line 5620 "mpcPars.lalr" */

			    yySynAttribute.link_declaration.Tree = mMPC_LinkDecl(yyAttrStackPtr [1-1].Scan.Position, ReverseTree(yyAttrStackPtr [3-1].free_coord_list.Tree),  
					ReverseTree(yyAttrStackPtr [5-1].link_declaring_list.Tree)
				   );
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.FreeCoord->MPC_CoordDecl.Prev->
							  MPC_FreeNode.Parent = yySynAttribute.link_declaration.Tree;
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.LinkDeclaringList->
				  MPC_LinkDeclaringList.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declaration.Tree;
			    yySynAttribute.link_declaration.Ignore = yyAttrStackPtr [3-1].free_coord_list.Ignore || yyAttrStackPtr [5-1].link_declaring_list.Ignore;
			    Close_Scope();
			    Scope_Depth--;
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.EndPos = CurrentPosition = yyAttrStackPtr [7-1].Scan.Position;  
			  ;

			;

} break;
case 1198: /* link_declaring_list : link_declaration_member .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 235; {
/* line 5636 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.link_declaring_list.Tree = mMPC_LinkDeclaringList( yySynAttribute.link_declaring_list.Position = yyAttrStackPtr [1-1].link_declaration_member.Position,  
					yyAttrStackPtr [1-1].link_declaration_member.LinkType,
					yyAttrStackPtr [1-1].link_declaration_member.Dynamic,
					tmp, tmp,
					yyAttrStackPtr [1-1].link_declaration_member.Predicate,
					yyAttrStackPtr [1-1].link_declaration_member.LinkTypeSpec,
					ReverseTree(yyAttrStackPtr [1-1].link_declaration_member.LinkList)
				   );
			    yySynAttribute.link_declaring_list.Tree->MPC_LinkDeclaringList.LinkDeclarator->
				  MPC_LinkDeclarator.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declaring_list.Tree;
			    yySynAttribute.link_declaring_list.Ignore = yyAttrStackPtr [1-1].link_declaration_member.Ignore;
			    yySynAttribute.link_declaring_list.Tree->MPC_LinkDeclaringList.EndPos = yyAttrStackPtr [1-1].link_declaration_member.EndPos;  
			  ;

			;

} break;
case 1199: /* link_declaring_list : link_declaring_list link_declaration_member .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 235; {
/* line 5655 "mpcPars.lalr" */
  
			    yySynAttribute.link_declaring_list.Position = yyAttrStackPtr [1-1].link_declaring_list.Position,  
			    yySynAttribute.link_declaring_list.Tree = mMPC_LinkDeclaringList( yyAttrStackPtr [2-1].link_declaration_member.Position,  
					yyAttrStackPtr [2-1].link_declaration_member.LinkType,
					yyAttrStackPtr [2-1].link_declaration_member.Dynamic,
					yyAttrStackPtr [1-1].link_declaring_list.Tree,
					yyAttrStackPtr [1-1].link_declaring_list.Tree,
					yyAttrStackPtr [2-1].link_declaration_member.Predicate,
					yyAttrStackPtr [2-1].link_declaration_member.LinkTypeSpec,
					ReverseTree(yyAttrStackPtr [2-1].link_declaration_member.LinkList)
				   );
			    yySynAttribute.link_declaring_list.Tree->MPC_LinkDeclaringList.LinkDeclarator->
				  MPC_LinkDeclarator.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declaring_list.Tree;
			    yySynAttribute.link_declaring_list.Ignore = yyAttrStackPtr [1-1].link_declaring_list.Ignore || yyAttrStackPtr [2-1].link_declaration_member.Ignore;
			    yySynAttribute.link_declaring_list.Tree->MPC_LinkDeclaringList.EndPos = yyAttrStackPtr [2-1].link_declaration_member.EndPos;  
			  ;

			;

} break;
case 1200: /* link_declaration_member : constant_expression ':' link_declarator_list ';' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 237; {
/* line 5674 "mpcPars.lalr" */

			  yySynAttribute.link_declaration_member.Predicate  =  yyAttrStackPtr [1-1].constant_expression.Tree;

			  yySynAttribute.link_declaration_member.LinkTypeSpec  =  yyAttrStackPtr [3-1].link_declarator_list.LinkTypeSpec;

			  yySynAttribute.link_declaration_member.LinkType  =  yyAttrStackPtr [3-1].link_declarator_list.LinkType;

			  yySynAttribute.link_declaration_member.Dynamic  =  yyAttrStackPtr [3-1].link_declarator_list.Dynamic;

			  yySynAttribute.link_declaration_member.LinkList  =  yyAttrStackPtr [3-1].link_declarator_list.LinkList;
  
			    yySynAttribute.link_declaration_member.Ignore = yyAttrStackPtr [1-1].constant_expression.Ignore || yyAttrStackPtr [3-1].link_declarator_list.Ignore;
			    yySynAttribute.link_declaration_member.Position = yyAttrStackPtr [1-1].constant_expression.BegPos;  
			    yySynAttribute.link_declaration_member.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;
			  ;

			;

} break;
case 1201: /* link_declaration_member : default ':' link_declarator_list ';' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 237; {
/* line 5692 "mpcPars.lalr" */

			  yySynAttribute.link_declaration_member.Predicate = NoTree;

			  yySynAttribute.link_declaration_member.LinkTypeSpec  =  yyAttrStackPtr [3-1].link_declarator_list.LinkTypeSpec;

			  yySynAttribute.link_declaration_member.LinkType  =  yyAttrStackPtr [3-1].link_declarator_list.LinkType;

			  yySynAttribute.link_declaration_member.Dynamic  =  yyAttrStackPtr [3-1].link_declarator_list.Dynamic;

			  yySynAttribute.link_declaration_member.LinkList  =  yyAttrStackPtr [3-1].link_declarator_list.LinkList;

			  yySynAttribute.link_declaration_member.Ignore  =  yyAttrStackPtr [3-1].link_declarator_list.Ignore;
 yySynAttribute.link_declaration_member.Position = yyAttrStackPtr [1-1].Scan.Position;  
						yySynAttribute.link_declaration_member.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position; ;
  
			;

} break;
case 1202: /* link_declarator_list : link_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 238; {
/* line 5709 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.link_declarator_list.LinkList = yyAttrStackPtr [1-1].link_declarator.Tree;
			    if(yyAttrStackPtr [1-1].link_declarator.Pair)
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev->MPC_LinkDeclarator.Prev = tmp;
			    else
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev = tmp;
			  ;

			  yySynAttribute.link_declarator_list.LinkTypeSpec = NoTree;

			  yySynAttribute.link_declarator_list.LinkType = NORMAL_LINK;

			  yySynAttribute.link_declarator_list.Dynamic = false;

			  yySynAttribute.link_declarator_list.Ignore  =  yyAttrStackPtr [1-1].link_declarator.Ignore;

			;

} break;
case 1203: /* link_declarator_list : link_type_specifier link_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 238; {
/* line 5731 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.link_declarator_list.LinkList = yyAttrStackPtr [2-1].link_declarator.Tree;
			    if(yyAttrStackPtr [2-1].link_declarator.Pair)
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev->MPC_LinkDeclarator.Prev = tmp;
			    else
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev = tmp;
			  ;

			  yySynAttribute.link_declarator_list.LinkTypeSpec  = yyAttrStackPtr [1-1].link_type_specifier.Tree;

			  yySynAttribute.link_declarator_list.LinkType  =  yyAttrStackPtr [1-1].link_type_specifier.LinkType;

			  yySynAttribute.link_declarator_list.Dynamic  =  yyAttrStackPtr [1-1].link_type_specifier.Dynamic;

			  yySynAttribute.link_declarator_list.Ignore  =  yyAttrStackPtr [1-1].link_type_specifier.Ignore || yyAttrStackPtr [2-1].link_declarator.Ignore;

			;

} break;
case 1204: /* link_declarator_list : link_declarator_list ',' link_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 238; {
/* line 5753 "mpcPars.lalr" */

			  yySynAttribute.link_declarator_list.LinkTypeSpec  =  yyAttrStackPtr [1-1].link_declarator_list.LinkTypeSpec;

			  yySynAttribute.link_declarator_list.LinkType  =  yyAttrStackPtr [1-1].link_declarator_list.LinkType;

			  yySynAttribute.link_declarator_list.Dynamic  =  yyAttrStackPtr [1-1].link_declarator_list.Dynamic;

			    yySynAttribute.link_declarator_list.LinkList = yyAttrStackPtr [3-1].link_declarator.Tree;
			    if(yyAttrStackPtr [3-1].link_declarator.Pair)
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev->MPC_LinkDeclarator.Prev = 
								yyAttrStackPtr [1-1].link_declarator_list.LinkList;
			    else
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev = yyAttrStackPtr [1-1].link_declarator_list.LinkList;
			  ;

			  yySynAttribute.link_declarator_list.Ignore  =  yyAttrStackPtr [3-1].link_declarator.Ignore;

			;

} break;
case 1205: /* link_declarator : '[' constant_expression_list ']' '->' '[' constant_expression_list ']' .*/
  yyStateStackPtr -= 7; yyAttrStackPtr -= 7; yyNonterminal = 239; {
/* line 5774 "mpcPars.lalr" */

			    yySynAttribute.link_declarator.Tree = mMPC_LinkDeclarator(CurrentPosition=yyAttrStackPtr [7-1].Scan.Position,  
					NoTree, NoTree,
					ReverseTree(yyAttrStackPtr [2-1].constant_expression_list.Tree), ReverseTree(yyAttrStackPtr [6-1].constant_expression_list.Tree)
				   );
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.LeftNode->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declarator.Tree;
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.EndPos = yyAttrStackPtr [7-1].Scan.Position;  
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.Pos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.link_declarator.Ignore = yyAttrStackPtr [2-1].constant_expression_list.Ignore || yyAttrStackPtr [6-1].constant_expression_list.Ignore;
			  ;

			  yySynAttribute.link_declarator.Pair = false;

			;

} break;
case 1206: /* link_declarator : '[' constant_expression_list ']' '<->' '[' constant_expression_list ']' .*/
  yyStateStackPtr -= 7; yyAttrStackPtr -= 7; yyNonterminal = 239; {
/* line 5790 "mpcPars.lalr" */

			    tTree tmp, lexp, rexp;
			    tmp  =mMPC_LinkDeclarator(CurrentPosition=yyAttrStackPtr [7-1].Scan.Position,
					NoTree, NoTree,
					lexp=ReverseTree(yyAttrStackPtr [2-1].constant_expression_list.Tree),
					rexp=ReverseTree(yyAttrStackPtr [6-1].constant_expression_list.Tree)
				   ); 
			    tmp->MPC_LinkDeclarator.LeftNode->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = tmp;
			    tmp->MPC_LinkDeclarator.EndPos = yyAttrStackPtr [7-1].Scan.Position;  
			    tmp->MPC_LinkDeclarator.Pos = yyAttrStackPtr [1-1].Scan.Position;  

			    yySynAttribute.link_declarator.Tree = mMPC_LinkDeclarator(yyAttrStackPtr [4-1].Scan.Position, tmp,
					tmp, yyAttrStackPtr [6-1].constant_expression_list.Tree, yyAttrStackPtr [2-1].constant_expression_list.Tree
				   ); 
			    yySynAttribute.link_declarator.Ignore = yyAttrStackPtr [2-1].constant_expression_list.Ignore || yyAttrStackPtr [6-1].constant_expression_list.Ignore;
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.EndPos = yyAttrStackPtr [7-1].Scan.Position;  
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.Pos = yyAttrStackPtr [1-1].Scan.Position;  
			  ;

			  yySynAttribute.link_declarator.Pair = true;

			;

} break;
case 1207: /* free_coord_list : '(' coord_list ')' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 236; {
/* line 5814 "mpcPars.lalr" */

			    yySynAttribute.free_coord_list.Tree = yyAttrStackPtr [2-1].coord_list.Tree;
			    CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;
			  ;

			  yySynAttribute.free_coord_list.Ignore  =  yyAttrStackPtr [2-1].coord_list.Ignore;

			;

} break;
case 1208: /* link_type_specifier : length '*' primary_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 240; {
/* line 5823 "mpcPars.lalr" */

			    yySynAttribute.link_type_specifier.Tree = mMPC_LinkLengthSpecifier(
					yyAttrStackPtr [1-1].Scan.Position,
					yySynAttribute.link_type_specifier.LinkType=NORMAL_LINK+yyAttrStackPtr [3-1].primary_expression.Value*LONG_LINK,
					yyAttrStackPtr [3-1].primary_expression.Tree
				   );
			    yySynAttribute.link_type_specifier.Dynamic = (yyAttrStackPtr [3-1].primary_expression.IsIntConst ? false : true);
			    yySynAttribute.link_type_specifier.Tree->MPC_LinkLengthSpecifier.EndPos = yyAttrStackPtr [3-1].primary_expression.EndPos;  
			  ;

			  yySynAttribute.link_type_specifier.Ignore  =  yyAttrStackPtr [3-1].primary_expression.Ignore;

			;

} break;
case 1209: /* parent_node_declaration : parent '[' constant_expression_list ']' ';' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 222; {
/* line 5837 "mpcPars.lalr" */

			    yySynAttribute.parent_node_declaration.Tree = yyAttrStackPtr [3-1].constant_expression_list.Tree;
			    CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;
			  ;

			  yySynAttribute.parent_node_declaration.Ignore  =  yyAttrStackPtr [3-1].constant_expression_list.Ignore;

			;

} break;
case 1210: /* constant_expression_list : constant_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 241; {
/* line 5846 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.constant_expression_list.Tree = mMPC_Exprs(yyAttrStackPtr [1-1].constant_expression.Position,
					tmp, tmp, yyAttrStackPtr [1-1].constant_expression.Tree
				   );
			    yySynAttribute.constant_expression_list.Ignore = yyAttrStackPtr [1-1].constant_expression.Ignore;
			    yySynAttribute.constant_expression_list.Tree->MPC_Exprs.BegPos = yyAttrStackPtr [1-1].constant_expression.BegPos;
			    yySynAttribute.constant_expression_list.Tree->MPC_Exprs.EndPos = yyAttrStackPtr [1-1].constant_expression.EndPos; 
			  ;

			;

} break;
case 1211: /* constant_expression_list : constant_expression_list ',' constant_expression .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 241; {
/* line 5859 "mpcPars.lalr" */

			    yySynAttribute.constant_expression_list.Tree = mMPC_Exprs(yyAttrStackPtr [3-1].constant_expression.Position,
					yyAttrStackPtr [1-1].constant_expression_list.Tree,
					yyAttrStackPtr [1-1].constant_expression_list.Tree,
					yyAttrStackPtr [3-1].constant_expression.Tree
				   );
			    yySynAttribute.constant_expression_list.Ignore = yyAttrStackPtr [1-1].constant_expression_list.Ignore ||
				     yyAttrStackPtr [3-1].constant_expression.Ignore;
			    yySynAttribute.constant_expression_list.Tree->MPC_Exprs.BegPos = yyAttrStackPtr [3-1].constant_expression.BegPos;
			    yySynAttribute.constant_expression_list.Tree->MPC_Exprs.EndPos = yyAttrStackPtr [3-1].constant_expression.EndPos; 
			  ;

			;

} break;
case 1212: /* subnet_declaring_list : subnet subnet_list .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 201; {
/* line 5873 "mpcPars.lalr" */
  
			    yySynAttribute.subnet_declaring_list.Tree = mMPC_SubnetDecl(yySynAttribute.subnet_declaring_list.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree,
					Default_Class==AUTO ? AUTO : GLOBAL_STATIC,
					NoDeclFlag, ReverseTree(yyAttrStackPtr [2-1].subnet_list.Tree)
				   );
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Flag.Exported = Default_Class==EXTERN ;
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Flag.Ignore = yySynAttribute.subnet_declaring_list.Ignore = yyAttrStackPtr [2-1].subnet_list.Ignore;
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.EndPos = yyAttrStackPtr [2-1].subnet_list.EndPos;  
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Subnet->
				  MPC_Subnet.Prev->MPC_FreeNode.Parent = yySynAttribute.subnet_declaring_list.Tree;
			  ;

			;

} break;
case 1213: /* subnet_declaring_list : storage_class subnet subnet_list .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 201; {
/* line 5888 "mpcPars.lalr" */
  
			    tClass Class;
			    Class = yyAttrStackPtr [1-1].storage_class.Class;
			    if(Class==REGISTER || Class==TYPEDEF ||
			       Class==AUTO && Default_Class!=AUTO)
			      Make_Message(
				459, xxError, yyAttrStackPtr [1-1].storage_class.Position, NoTree), yySynAttribute.subnet_declaring_list.Ignore = true;
		
			    else if(Class==STATIC)
			      Class = Default_Class==AUTO ? LOCAL_STATIC : GLOBAL_STATIC;
			    yySynAttribute.subnet_declaring_list.Tree = mMPC_SubnetDecl(yySynAttribute.subnet_declaring_list.Position = yyAttrStackPtr [1-1].storage_class.Position,    
					NoTree, NoTree, Class,
					NoDeclFlag, ReverseTree(yyAttrStackPtr [3-1].subnet_list.Tree)
				   );
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Flag.Ignore = (yySynAttribute.subnet_declaring_list.Ignore |= yyAttrStackPtr [3-1].subnet_list.Ignore);
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Subnet->
				  MPC_Subnet.Prev->MPC_FreeNode.Parent = yySynAttribute.subnet_declaring_list.Tree;
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.EndPos = yyAttrStackPtr [3-1].subnet_list.EndPos;  
			  ;

			;

} break;
case 1214: /* subnet_list : subnet_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 242; {
/* line 5910 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.subnet_list.Tree = yyAttrStackPtr [1-1].subnet_declarator.Tree;
			    yySynAttribute.subnet_list.Tree->MPC_Subnet.Next = yySynAttribute.subnet_list.Tree->MPC_Subnet.Prev = tmp;
			  ;

			  yySynAttribute.subnet_list.Ignore  =  yyAttrStackPtr [1-1].subnet_declarator.Ignore;

			  yySynAttribute.subnet_list.Position  =  yyAttrStackPtr [1-1].subnet_declarator.Position;

			  yySynAttribute.subnet_list.EndPos  =  yyAttrStackPtr [1-1].subnet_declarator.EndPos;
  
			;

} break;
case 1215: /* subnet_list : subnet_list ',' subnet_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 242; {
/* line 5925 "mpcPars.lalr" */

			    yySynAttribute.subnet_list.Tree = yyAttrStackPtr [3-1].subnet_declarator.Tree;
			    yySynAttribute.subnet_list.Tree->MPC_Subnet.Next = yySynAttribute.subnet_list.Tree->MPC_Subnet.Prev = yyAttrStackPtr [1-1].subnet_list.Tree;
			    yySynAttribute.subnet_list.Ignore = yyAttrStackPtr [1-1].subnet_list.Ignore && yyAttrStackPtr [3-1].subnet_declarator.Ignore;
			  ;

			  yySynAttribute.subnet_list.Position  =  yyAttrStackPtr [1-1].subnet_list.Position;
  
			  yySynAttribute.subnet_list.EndPos  =  yyAttrStackPtr [3-1].subnet_declarator.EndPos;
  
			;

} break;
case 1216: /* subnet_declarator : subnet_specifier general_identifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 243; {
/* line 5937 "mpcPars.lalr" */
  
			    yySynAttribute.subnet_declarator.Tree = Add_Ident(yyAttrStackPtr [2-1].general_identifier.Ident, IDENT, yyAttrStackPtr [1-1].subnet_specifier.Tree);
			    if(yyAttrStackPtr [1-1].subnet_specifier.WithPredicate) {
			      yySynAttribute.subnet_declarator.Tree->MPC_Subnet.Ident = yyAttrStackPtr [2-1].general_identifier.Ident;
			      yySynAttribute.subnet_declarator.Tree->MPC_Subnet.Flexible = false;
			    }
			    yySynAttribute.subnet_declarator.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore || yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.subnet_declarator.Position = yyAttrStackPtr [1-1].subnet_specifier.Position;  
			    yySynAttribute.subnet_declarator.EndPos = CurrentPosition = yyAttrStackPtr [2-1].general_identifier.EndPos;  
			  ;

			;

} break;
case 1217: /* subnet_specifier : '[' NETorSUBNETname ':' expression ']' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 145; {
/* line 5950 "mpcPars.lalr" */
  
			    yySynAttribute.subnet_specifier.Tree = mMPC_Subnet(
			    		yySynAttribute.subnet_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoIdent, false,
					Find_Ident(yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident,IDENT), 
					NoTree, NoTree, yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident,
					yySynAttribute.subnet_specifier.Flexible=true, yyAttrStackPtr [4-1].expression.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.subnet_specifier.Tree);
			    yySynAttribute.subnet_specifier.Ignore = yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ignore || yyAttrStackPtr [4-1].expression.Ignore;
			    yySynAttribute.subnet_specifier.EndPos = yySynAttribute.subnet_specifier.Tree->MPC_Subnet.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			  ;

			  yySynAttribute.subnet_specifier.WithPredicate = true;

			;

} break;
case 1218: /* subnet_specifier : '[' NETorSUBNETname ':' parent ']' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 145; {
/* line 5968 "mpcPars.lalr" */
  
			    yySynAttribute.subnet_specifier.Tree = Find_Ident(yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident,IDENT);
			    yySynAttribute.subnet_specifier.Position = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.subnet_specifier.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    yySynAttribute.subnet_specifier.WithPredicate = false;
			    if(yySynAttribute.subnet_specifier.Tree!=NoTree && yySynAttribute.subnet_specifier.Tree->Kind==kMPC_Net &&
			       yySynAttribute.subnet_specifier.Tree->MPC_Net.Topology!=PARAMETER)
			      yySynAttribute.subnet_specifier.Tree = yySynAttribute.subnet_specifier.Tree->MPC_Net.Distribution;  
			    else if(yySynAttribute.subnet_specifier.Tree!=NoTree && yySynAttribute.subnet_specifier.Tree->Kind==kMPC_Net &&
				    yySynAttribute.subnet_specifier.Tree->MPC_Net.Topology==PARAMETER)
			      yySynAttribute.subnet_specifier.WithPredicate = true,
			      yySynAttribute.subnet_specifier.Tree = Make_ParentSubnet(yySynAttribute.subnet_specifier.Tree, yySynAttribute.subnet_specifier.Position, yySynAttribute.subnet_specifier.EndPos);  
			    else if(yySynAttribute.subnet_specifier.Tree!=NoTree && yySynAttribute.subnet_specifier.Tree->Kind==kMPC_Subnet) {
			      yySynAttribute.subnet_specifier.Ignore = true;
			      Make_Message(101, xxError, yyAttrStackPtr [2-1].Scan.Position, yySynAttribute.subnet_specifier.Tree);
					   
			    }
			    else {
			      yySynAttribute.subnet_specifier.Ignore = true;
			      Make_MessageI(102, xxError, yyAttrStackPtr [2-1].Scan.Position, xxIdent,
					    (char*)&yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident, NoTree);
					    
			    }
			    yySynAttribute.subnet_specifier.Ignore = yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ignore;
			  ;

			;

} break;
case 1219: /* relation_declaration : relation relation_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 202; {
/* line 5996 "mpcPars.lalr" */

			    yySynAttribute.relation_declaration.Tree = yyAttrStackPtr [2-1].relation_declarator.Tree;
			    yySynAttribute.relation_declaration.Tree->MPC_Relation.Next = yySynAttribute.relation_declaration.Tree->MPC_Relation.Prev = nMPC_FreeNode();
			  ;

			  yySynAttribute.relation_declaration.Ignore  =  yyAttrStackPtr [2-1].relation_declarator.Ignore;

			  yySynAttribute.relation_declaration.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1220: /* relation_declaration : relation_declaration ',' relation_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 202; {
/* line 6007 "mpcPars.lalr" */

			    yySynAttribute.relation_declaration.Tree = yyAttrStackPtr [3-1].relation_declarator.Tree;
			    yySynAttribute.relation_declaration.Tree->MPC_Relation.Next =
				  yySynAttribute.relation_declaration.Tree->MPC_Relation.Prev = yyAttrStackPtr [1-1].relation_declaration.Tree;
			  ;

			  yySynAttribute.relation_declaration.Ignore  =  yyAttrStackPtr [3-1].relation_declarator.Ignore;

			  yySynAttribute.relation_declaration.Position  =  yyAttrStackPtr [1-1].relation_declaration.Position;
  
			;

} break;
case 1221: /* relation_declarator : NETorSUBNETname relational_operator NETorSUBNETname .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 244; {
/* line 6019 "mpcPars.lalr" */
  
				yySynAttribute.relation_declarator.Tree = mMPC_Relation(yyAttrStackPtr [2-1].relational_operator.Position,
					yyAttrStackPtr [2-1].relational_operator.OpCode, NoTree, NoTree,
					Find_Ident(yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Ident, IDENT),
					Find_Ident(yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ident, IDENT)
				  );
			  	
				;

			  yySynAttribute.relation_declarator.Ignore = yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Ignore || yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ignore ;

			;

} break;
case 1222: /* relational_operator : '==' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 245; {
/* line 6032 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = EQUAL;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 ;

} break;
case 1223: /* relational_operator : '!=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 245; {
/* line 6036 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = NOT_EQUAL;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 ;

} break;
case 1224: /* relational_operator : '>' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 245; {
/* line 6040 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = GREAT_THEN;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  ;

} break;
case 1225: /* relational_operator : '>=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 245; {
/* line 6044 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = GREAT_OR_EQ;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 ;

} break;
case 1226: /* relational_operator : '<' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 245; {
/* line 6048 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = LESS_THEN;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  ;

} break;
case 1227: /* relational_operator : '<=' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 245; {
/* line 6052 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = LESS_OR_EQ;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 ;

} break;
case 1228: /* default_declaring_list : declaration_qualifier_list declarator initializer_opt .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 207; {
/* line 6056 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    yySynAttribute.default_declaring_list.NoClass = yyAttrStackPtr [1-1].declaration_qualifier_list.Class==UNDEFINED ?
									 true : false;
			    yySynAttribute.default_declaring_list.Class =  yySynAttribute.default_declaring_list.NoClass ?
					Default_Class : yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    yySynAttribute.default_declaring_list.Ignore = yyAttrStackPtr [2-1].declarator.Ignore;
			    if(!yySynAttribute.default_declaring_list.NoClass && yySynAttribute.default_declaring_list.Class==EXTERN && yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [3-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [2-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.default_declaring_list.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position;  
			    yySynAttribute.default_declaring_list.EndPos = (yyAttrStackPtr [3-1].initializer_opt.Tree==NoTree )?  
				yyAttrStackPtr [2-1].declarator.EndPos:yyAttrStackPtr [3-1].initializer_opt.EndPos;  

			    NestedType_ON();
			    Push_Pattern(
				mMPC_BasicType(NoPosition, NoTree, NoTree,
					Make_TypeFlag(
					  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const,
					  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile,
					  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl,
					  NO , NO ,
					  NO , NO , NO ,
					  YES , NO 
					), INT 
				)
			    );
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF)
			      yySynAttribute.default_declaring_list.Type = Make_Type();  
			    else
			      tmp = mMPC_FreeNode(
				      yySynAttribute.default_declaring_list.Tree = mMPC_VarDecl(
						yySynAttribute.default_declaring_list.Position, NoTree, NoTree, yySynAttribute.default_declaring_list.Class,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore
						), yySynAttribute.default_declaring_list.Type=Make_Type() , NoTree
					     )
				    );
			    NestedType_OFF(); 

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.default_declaring_list.Type);
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF) {
			      yySynAttribute.default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree, NoTree, NoTypeFlag,  
					 yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				       )
				     );
			      (void)Clean_OutAttributes(yySynAttribute.default_declaring_list.Tree);
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      if(Default_Class!=EXTERN)
			        yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [2-1].declarator.Ignore ||
							       yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;
			      if(yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [3-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [2-1].declarator.Ident),yySynAttribute.default_declaring_list.Tree);  
		
				 yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.default_declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN || yySynAttribute.default_declaring_list.Class==EXTERN &&
							yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						yyAttrStackPtr [3-1].initializer_opt.Tree
					   )
				 );
			      if(ftype!=NoTree)
				Check_PrevImplicitDecl(yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var),
				Check_ResultType(ftype, yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var);
			      (void)Clean_OutAttributes(yySynAttribute.default_declaring_list.Tree);
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1229: /* default_declaring_list : type_qualifier_list declarator initializer_opt .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 207; {
/* line 6201 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    yySynAttribute.default_declaring_list.NoClass = yyAttrStackPtr [1-1].type_qualifier_list.Class==UNDEFINED ? true : false;
			    yySynAttribute.default_declaring_list.Class =  yySynAttribute.default_declaring_list.NoClass ?
					Default_Class : yyAttrStackPtr [1-1].type_qualifier_list.Class;
			    yySynAttribute.default_declaring_list.Ignore = yyAttrStackPtr [2-1].declarator.Ignore;
			    if(!yySynAttribute.default_declaring_list.NoClass && yySynAttribute.default_declaring_list.Class==EXTERN && yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [3-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [2-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.default_declaring_list.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position;  
			    yySynAttribute.default_declaring_list.EndPos = (yyAttrStackPtr [3-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [2-1].declarator.EndPos:yyAttrStackPtr [3-1].initializer_opt.EndPos;  

			    NestedType_ON();
			    Push_Pattern(
				mMPC_BasicType(NoPosition, NoTree, NoTree,
					Make_TypeFlag(
					  yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const,
					  yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile,
					  yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl,
					  NO , NO ,
					  NO , NO , NO ,
					  YES , NO 
					), INT 
				)
			    );
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF)
			      yySynAttribute.default_declaring_list.Type = Make_Type();  
			    else
			      tmp = mMPC_FreeNode(
				      yySynAttribute.default_declaring_list.Tree = mMPC_VarDecl(
						yySynAttribute.default_declaring_list.Position, NoTree, NoTree, yySynAttribute.default_declaring_list.Class,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].type_qualifier_list.Ignore
						), yySynAttribute.default_declaring_list.Type=Make_Type() , NoTree
					     )
				    );
			    NestedType_OFF(); 

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.default_declaring_list.Type);
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF) {
			      yySynAttribute.default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree, NoTree, NoTypeFlag,  
					 yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				       )
				     );
			      (void)Clean_OutAttributes(yySynAttribute.default_declaring_list.Tree);
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      if(Default_Class!=EXTERN)
			        yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
							       yyAttrStackPtr [2-1].declarator.Ignore;
			      if(yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [3-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [2-1].declarator.Ident),yySynAttribute.default_declaring_list.Tree);  
		
				 yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.default_declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN || yySynAttribute.default_declaring_list.Class==EXTERN &&
							yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						yyAttrStackPtr [3-1].initializer_opt.Tree
					   )
				 );
			      if(ftype!=NoTree)
				Check_PrevImplicitDecl(yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var),
				Check_ResultType(ftype, yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var);
			      (void)Clean_OutAttributes(yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var);
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1230: /* default_declaring_list : default_declaring_list ',' declarator initializer_opt .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 207; {
/* line 6345 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    yySynAttribute.default_declaring_list.Tree = yyAttrStackPtr [1-1].default_declaring_list.Tree;
			    yySynAttribute.default_declaring_list.Type = yyAttrStackPtr [1-1].default_declaring_list.Type;
			    yySynAttribute.default_declaring_list.Class =  yyAttrStackPtr [1-1].default_declaring_list.Class;
			    yySynAttribute.default_declaring_list.NoClass = yyAttrStackPtr [1-1].default_declaring_list.NoClass;
			    yySynAttribute.default_declaring_list.Ignore = yyAttrStackPtr [1-1].default_declaring_list.Ignore && yyAttrStackPtr [3-1].declarator.Ignore;
			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    if(!yySynAttribute.default_declaring_list.NoClass && yySynAttribute.default_declaring_list.Class==EXTERN && yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [4-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [3-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.default_declaring_list.Position = yyAttrStackPtr [1-1].default_declaring_list.Position;  
			    yySynAttribute.default_declaring_list.EndPos = (yyAttrStackPtr [4-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [3-1].declarator.EndPos:yyAttrStackPtr [4-1].initializer_opt.EndPos;  

			    tmp = yyAttrStackPtr [1-1].default_declaring_list.Tree->MPC_VarDecl.Var;

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [3-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.default_declaring_list.Type);
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF) {
			      yySynAttribute.default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [3-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].default_declaring_list.Position, yyAttrStackPtr [1-1].default_declaring_list.Tree,  
					 yyAttrStackPtr [1-1].default_declaring_list.Tree, NoTypeFlag,
					 yyAttrStackPtr [3-1].declarator.Ident, Make_Type()
				       )
				     );
			      (void)Clean_OutAttributes(yySynAttribute.default_declaring_list.Tree);
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      if(Default_Class!=EXTERN)
			        yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.TypedefList = YES;
					
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].default_declaring_list.Ignore ||
							       yyAttrStackPtr [3-1].declarator.Ignore;
			      if(yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [4-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [3-1].declarator.Ident),yySynAttribute.default_declaring_list.Tree);  
		
				 yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.default_declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [3-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [3-1].declarator.Position, yyAttrStackPtr [3-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN || yySynAttribute.default_declaring_list.Class==EXTERN &&
							yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [3-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [3-1].declarator.Distribution,
						yyAttrStackPtr [4-1].initializer_opt.Tree
					   )
				 );
			      if(ftype!=NoTree)
				Check_PrevImplicitDecl(yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var),
				Check_ResultType(ftype, yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var);
			      (void)Clean_OutAttributes(yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var);
			      if(yyAttrStackPtr [3-1].declarator.Distribution!=NO_NET)
				yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;

			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1231: /* declaring_list : declaration_specifier declarator initializer_opt .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 206; {
/* line 6464 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    yySynAttribute.declaring_list.NoClass = yyAttrStackPtr [1-1].declaration_specifier.Class==UNDEFINED ? true : false;
			    yySynAttribute.declaring_list.Class =  yySynAttribute.declaring_list.NoClass ? Default_Class : yyAttrStackPtr [1-1].declaration_specifier.Class;
			    yySynAttribute.declaring_list.Ignore = yyAttrStackPtr [2-1].declarator.Ignore;
			    if(!yySynAttribute.declaring_list.NoClass && yySynAttribute.declaring_list.Class==EXTERN && yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [3-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [2-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.declaring_list.Position = yyAttrStackPtr [1-1].declaration_specifier.Position;  
			    yySynAttribute.declaring_list.EndPos = (yyAttrStackPtr [3-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [2-1].declarator.EndPos:yyAttrStackPtr [3-1].initializer_opt.EndPos;  

			    NestedType_ON();
			    Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF)
			      yySynAttribute.declaring_list.Type = Make_Type();  
			    else
			      tmp = mMPC_FreeNode(
				      yySynAttribute.declaring_list.Tree = mMPC_VarDecl(
						yySynAttribute.declaring_list.Position, NoTree, NoTree, yySynAttribute.declaring_list.Class,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].declaration_specifier.Ignore
						), yySynAttribute.declaring_list.Type=Make_Type() , NoTree
					     )
				    );
			    NestedType_OFF(); 

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.declaring_list.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF) {
			      yySynAttribute.declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree, NoTree, NoTypeFlag,
					 yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				       )
				     );
			      (void)Clean_OutAttributes(yySynAttribute.declaring_list.Tree);
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      if(Default_Class!=EXTERN)
			        yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore ||
							       yyAttrStackPtr [2-1].declarator.Ignore;
			      if(yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [3-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [2-1].declarator.Ident),yySynAttribute.declaring_list.Tree);  
		
				 yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN || yySynAttribute.declaring_list.Class==EXTERN &&
							yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						yyAttrStackPtr [3-1].initializer_opt.Tree
					   )
				 );
			      if(ftype!=NoTree)
				Check_PrevImplicitDecl(yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var),
				Check_ResultType(ftype, yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var);
			      (void)Clean_OutAttributes(yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var);
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1232: /* declaring_list : type_specifier declarator initializer_opt .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 206; {
/* line 6596 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    yySynAttribute.declaring_list.NoClass = yyAttrStackPtr [1-1].type_specifier.Class==UNDEFINED ? true : false;
			    yySynAttribute.declaring_list.Class =  yySynAttribute.declaring_list.NoClass ? Default_Class : yyAttrStackPtr [1-1].type_specifier.Class;
			    yySynAttribute.declaring_list.Ignore = yyAttrStackPtr [2-1].declarator.Ignore;
			    if(!yySynAttribute.declaring_list.NoClass && yySynAttribute.declaring_list.Class==EXTERN && yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [3-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [2-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.declaring_list.Position = yyAttrStackPtr [1-1].type_specifier.Position;  
			    yySynAttribute.declaring_list.EndPos = (yyAttrStackPtr [3-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [2-1].declarator.EndPos:yyAttrStackPtr [3-1].initializer_opt.EndPos;  

			    NestedType_ON();
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF)
			      yySynAttribute.declaring_list.Type = Make_Type();  
			    else
			      tmp = mMPC_FreeNode(
				      yySynAttribute.declaring_list.Tree = mMPC_VarDecl(
						yySynAttribute.declaring_list.Position, NoTree, NoTree, yySynAttribute.declaring_list.Class,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].type_specifier.Ignore
						), yySynAttribute.declaring_list.Type=Make_Type() , NoTree
					     )
				    );
			    NestedType_OFF(); 

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.declaring_list.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF) {
			      yySynAttribute.declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].type_specifier.Position, NoTree, NoTree, NoTypeFlag,
					 yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				       )
				     );
			      (void)Clean_OutAttributes(yySynAttribute.declaring_list.Tree);
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      if(Default_Class!=EXTERN)
			        yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore ||
							       yyAttrStackPtr [2-1].declarator.Ignore;
			      if(yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [3-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [2-1].declarator.Ident),yySynAttribute.declaring_list.Tree);  
		
				 yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN || yySynAttribute.declaring_list.Class==EXTERN &&
							yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						yyAttrStackPtr [3-1].initializer_opt.Tree
					   )
				 );
			      if(ftype!=NoTree)
				Check_PrevImplicitDecl(yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var),
				Check_ResultType(ftype, yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var);
			      (void)Clean_OutAttributes(yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var);
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1233: /* declaring_list : declaring_list ',' declarator initializer_opt .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 206; {
/* line 6728 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    yySynAttribute.declaring_list.Tree = yyAttrStackPtr [1-1].declaring_list.Tree;
			    yySynAttribute.declaring_list.Type = yyAttrStackPtr [1-1].declaring_list.Type;
			    yySynAttribute.declaring_list.Class =  yyAttrStackPtr [1-1].declaring_list.Class;
			    yySynAttribute.declaring_list.NoClass = yyAttrStackPtr [1-1].declaring_list.NoClass;
			    yySynAttribute.declaring_list.Ignore = yyAttrStackPtr [1-1].declaring_list.Ignore && yyAttrStackPtr [3-1].declarator.Ignore;
			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    if(!yySynAttribute.declaring_list.NoClass && yySynAttribute.declaring_list.Class==EXTERN && yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [4-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [3-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.declaring_list.Position = yyAttrStackPtr [1-1].declaring_list.Position;  
			    yySynAttribute.declaring_list.EndPos = (yyAttrStackPtr [4-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [3-1].declarator.EndPos:yyAttrStackPtr [4-1].initializer_opt.EndPos;  
			    tmp = yyAttrStackPtr [1-1].declaring_list.Tree->MPC_VarDecl.Var;

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [3-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.declaring_list.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF) {
			      yySynAttribute.declaring_list.Tree = Add_Ident(yyAttrStackPtr [3-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].declaring_list.Position, yyAttrStackPtr [1-1].declaring_list.Tree,
					 yyAttrStackPtr [1-1].declaring_list.Tree, NoTypeFlag,
					 yyAttrStackPtr [3-1].declarator.Ident, Make_Type()
				       )
				     );
			      (void)Clean_OutAttributes(yySynAttribute.declaring_list.Tree);
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      if(Default_Class!=EXTERN)
			        yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.TypedefList = YES;
					
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].declaring_list.Ignore ||
							       yyAttrStackPtr [3-1].declarator.Ignore;
			      if(yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [4-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [3-1].declarator.Ident),yySynAttribute.declaring_list.Tree);  
		
				 yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [3-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [3-1].declarator.Position, yyAttrStackPtr [3-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN || yySynAttribute.declaring_list.Class==EXTERN &&
							yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [3-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [3-1].declarator.Distribution,
						yyAttrStackPtr [4-1].initializer_opt.Tree
					   )
				 );
			      if(ftype!=NoTree)
				Check_PrevImplicitDecl(yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var),
				Check_ResultType(ftype, yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var);
			      (void)Clean_OutAttributes(yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var);
			      if(yyAttrStackPtr [3-1].declarator.Distribution!=NO_NET)
				yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1234: /* declaration_specifier : basic_declaration_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 250; {
/* line 6845 "mpcPars.lalr" */

			    switch(yyAttrStackPtr [1-1].basic_declaration_specifier.TypeName) {
			      case LONG_LONG:
			      case SIGNED_LONG_LONG:
			      case SIGNED_LONG_LONG_INT:
				yySynAttribute.declaration_specifier.Type = MakeTree(kMPC_Typedef);
				*(yySynAttribute.declaration_specifier.Type) = *LongLongType;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Const;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Volatile;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Repl;
				break;
			      case UNSIGNED_LONG_LONG:
			      case UNSIGNED_LONG_LONG_INT:
				yySynAttribute.declaration_specifier.Type = MakeTree(kMPC_Typedef);
				*(yySynAttribute.declaration_specifier.Type) = *UnsignedLongLongType;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Const;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Volatile;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Repl;
				break;
			      default:
			        yySynAttribute.declaration_specifier.Type = mMPC_BasicType(
					NoPosition, NoTree, NoTree,
					Make_TypeFlag(
					  yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Const,
					  yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Volatile,
					  yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Repl,
					  NO , NO ,
					  NO , NO , NO ,
					  YES , yyAttrStackPtr [1-1].basic_declaration_specifier.Ignore
					),
					BasicTypeConstructor(yyAttrStackPtr [1-1].basic_declaration_specifier.TypeName)
				       );
			        
			    }
			  ;

			  yySynAttribute.declaration_specifier.Class  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Class;

			  yySynAttribute.declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Ignore;

			  yySynAttribute.declaration_specifier.Position  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Position;

			  yySynAttribute.declaration_specifier.EndPos  =  yyAttrStackPtr [1-1].basic_declaration_specifier.EndPos;
  
			;

} break;
case 1235: /* declaration_specifier : sue_declaration_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 250; {
/* line 6891 "mpcPars.lalr" */

			    yySynAttribute.declaration_specifier.Type = yyAttrStackPtr [1-1].sue_declaration_specifier.Type;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].sue_declaration_specifier.Qual.Const;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].sue_declaration_specifier.Qual.Volatile;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].sue_declaration_specifier.Qual.Repl;
			  ;

			  yySynAttribute.declaration_specifier.Class  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Class;

			  yySynAttribute.declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Ignore;

			  yySynAttribute.declaration_specifier.Position  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Position;

			  yySynAttribute.declaration_specifier.EndPos  =  yyAttrStackPtr [1-1].sue_declaration_specifier.EndPos;
  
			;

} break;
case 1236: /* declaration_specifier : typedef_declaration_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 250; {
/* line 6908 "mpcPars.lalr" */

			    yySynAttribute.declaration_specifier.Type = MakeTree(kMPC_Typedef);  
							    
			    *(yySynAttribute.declaration_specifier.Type) =  *(yyAttrStackPtr [1-1].typedef_declaration_specifier.Type);
			    if(yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const && yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Const)
			      DECL_WarningI((477, xxWarning, yyAttrStackPtr [1-1].typedef_declaration_specifier.Position, xxIdent, (char*)&(yySynAttribute.declaration_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.declaration_specifier.Type));
		
			    if(yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile && yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Volatile)
			      DECL_WarningI((478, xxWarning, yyAttrStackPtr [1-1].typedef_declaration_specifier.Position, xxIdent, (char*)&(yySynAttribute.declaration_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.declaration_specifier.Type));
		
			    if(yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl && yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Repl)
			      DECL_WarningI((479, xxWarning, yyAttrStackPtr [1-1].typedef_declaration_specifier.Position, xxIdent, (char*)&(yySynAttribute.declaration_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.declaration_specifier.Type));
		
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Const;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Volatile;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Repl;
			  ;

			  yySynAttribute.declaration_specifier.Class  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.Class;

			  yySynAttribute.declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.Ignore;

			  yySynAttribute.declaration_specifier.Position  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.Position;

			  yySynAttribute.declaration_specifier.EndPos  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.EndPos;
  
			;

} break;
case 1237: /* type_specifier : basic_type_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 251; {
/* line 6936 "mpcPars.lalr" */
  
			    switch(yyAttrStackPtr [1-1].basic_type_specifier.TypeName) {
			      case LONG_LONG:
			      case SIGNED_LONG_LONG:
			      case SIGNED_LONG_LONG_INT:
				yySynAttribute.type_specifier.Type = MakeTree(kMPC_Typedef);
				*(yySynAttribute.type_specifier.Type) = *LongLongType;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Const;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Volatile;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Repl;
				break;
			      case UNSIGNED_LONG_LONG:
			      case UNSIGNED_LONG_LONG_INT:
				yySynAttribute.type_specifier.Type = MakeTree(kMPC_Typedef);
				*(yySynAttribute.type_specifier.Type) = *UnsignedLongLongType;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Const;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Volatile;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Repl;
				break;
			      default:
			        yySynAttribute.type_specifier.Type = mMPC_BasicType(
					NoPosition, NoTree, NoTree,
					Make_TypeFlag(
					  yyAttrStackPtr [1-1].basic_type_specifier.Qual.Const,
					  yyAttrStackPtr [1-1].basic_type_specifier.Qual.Volatile,
					  yyAttrStackPtr [1-1].basic_type_specifier.Qual.Repl,
					  NO , NO ,
					  NO , NO , NO ,
					  YES , yyAttrStackPtr [1-1].basic_type_specifier.Ignore
					),
					BasicTypeConstructor(yyAttrStackPtr [1-1].basic_type_specifier.TypeName)
				       );
				   yySynAttribute.type_specifier.EndPos = yyAttrStackPtr [1-1].basic_type_specifier.EndPos;  
			    }
			  ;

			  yySynAttribute.type_specifier.Class  =  yyAttrStackPtr [1-1].basic_type_specifier.Class;

			  yySynAttribute.type_specifier.Ignore  =  yyAttrStackPtr [1-1].basic_type_specifier.Ignore;

			  yySynAttribute.type_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_specifier.Position;

			;

} break;
case 1238: /* type_specifier : sue_type_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 251; {
/* line 6980 "mpcPars.lalr" */

			    yySynAttribute.type_specifier.Type = yyAttrStackPtr [1-1].sue_type_specifier.Type;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].sue_type_specifier.Qual.Const;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].sue_type_specifier.Qual.Volatile;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].sue_type_specifier.Qual.Repl;
			  ;

			  yySynAttribute.type_specifier.Class  =  yyAttrStackPtr [1-1].sue_type_specifier.Class;

			  yySynAttribute.type_specifier.Ignore  =  yyAttrStackPtr [1-1].sue_type_specifier.Ignore;

			  yySynAttribute.type_specifier.Position  =  yyAttrStackPtr [1-1].sue_type_specifier.Position;

			  yySynAttribute.type_specifier.EndPos  =  yyAttrStackPtr [1-1].sue_type_specifier.EndPos;
  
			;

} break;
case 1239: /* type_specifier : typedef_type_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 251; {
/* line 6997 "mpcPars.lalr" */

			    yySynAttribute.type_specifier.Type = MakeTree(kMPC_Typedef);  
							    
			    *(yySynAttribute.type_specifier.Type) =  *(yyAttrStackPtr [1-1].typedef_type_specifier.Type);
			    if(yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const && yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Const)
			      DECL_WarningI((477, xxWarning, yyAttrStackPtr [1-1].typedef_type_specifier.Position, xxIdent, (char*)&(yySynAttribute.type_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.type_specifier.Type));
		
			    if(yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile && yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Volatile)
			      DECL_WarningI((478, xxWarning, yyAttrStackPtr [1-1].typedef_type_specifier.Position, xxIdent, (char*)&(yySynAttribute.type_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.type_specifier.Type));
		
			    if(yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl && yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Repl)
			      DECL_WarningI((479, xxWarning, yyAttrStackPtr [1-1].typedef_type_specifier.Position, xxIdent, (char*)&(yySynAttribute.type_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.type_specifier.Type));
		
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Const;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Volatile;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Repl;
			  ;

			  yySynAttribute.type_specifier.Class  =  yyAttrStackPtr [1-1].typedef_type_specifier.Class;

			  yySynAttribute.type_specifier.Ignore  =  yyAttrStackPtr [1-1].typedef_type_specifier.Ignore;

			  yySynAttribute.type_specifier.Position  =  yyAttrStackPtr [1-1].typedef_type_specifier.Position;

			  yySynAttribute.type_specifier.EndPos  =  yyAttrStackPtr [1-1].typedef_type_specifier.EndPos;
  
			;

} break;
case 1240: /* declaration_qualifier_list : storage_class .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 246; {
/* line 7025 "mpcPars.lalr" */

			    yySynAttribute.declaration_qualifier_list.Class = yyAttrStackPtr [1-1].storage_class.Class;
			    yySynAttribute.declaration_qualifier_list.Ignore = false;
			    if(yySynAttribute.declaration_qualifier_list.Class==FLEXIBLE) {
			      yySynAttribute.declaration_qualifier_list.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [1-1].storage_class.Position,
					   NoTree);
		
			    }
			  ;

			  yySynAttribute.declaration_qualifier_list.Qual = NoQual;

			  yySynAttribute.declaration_qualifier_list.Position  =  yyAttrStackPtr [1-1].storage_class.Position;

			  yySynAttribute.declaration_qualifier_list.EndPos  =  yyAttrStackPtr [1-1].storage_class.EndPos;
  
			;

} break;
case 1241: /* declaration_qualifier_list : type_qualifier_list storage_class .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 246; {
/* line 7044 "mpcPars.lalr" */

			    yySynAttribute.declaration_qualifier_list.Class = yyAttrStackPtr [2-1].storage_class.Class;
			    yySynAttribute.declaration_qualifier_list.Ignore = false;
			    if(yySynAttribute.declaration_qualifier_list.Class==FLEXIBLE) {
			      yySynAttribute.declaration_qualifier_list.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [2-1].storage_class.Position,
					   NoTree);
		
			    }
			  ;

			  yySynAttribute.declaration_qualifier_list.Qual  =  yyAttrStackPtr [1-1].type_qualifier_list.Qual;

			  yySynAttribute.declaration_qualifier_list.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			  yySynAttribute.declaration_qualifier_list.EndPos  =  yyAttrStackPtr [2-1].storage_class.EndPos;
  
			;

} break;
case 1242: /* declaration_qualifier_list : declaration_qualifier_list declaration_qualifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 246; {
/* line 7063 "mpcPars.lalr" */

			    yySynAttribute.declaration_qualifier_list.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;
			    if(yyAttrStackPtr [2-1].declaration_qualifier.Class==UNDEFINED)
				yySynAttribute.declaration_qualifier_list.Class = yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    else {
				yySynAttribute.declaration_qualifier_list.Ignore = true;
				Make_Message(462, xxError, yyAttrStackPtr [2-1].declaration_qualifier.Position, NoTree);
					     
			    }
			    yySynAttribute.declaration_qualifier_list.Qual = JoinQualifiers(yyAttrStackPtr [1-1].declaration_qualifier_list.Qual,
						  yyAttrStackPtr [2-1].declaration_qualifier.Qual, &yySynAttribute.declaration_qualifier_list.Ignore,
						  yyAttrStackPtr [2-1].declaration_qualifier.Position);
			  ;

			  yySynAttribute.declaration_qualifier_list.Position  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Position;
  
			  yySynAttribute.declaration_qualifier_list.EndPos  =  yyAttrStackPtr [2-1].declaration_qualifier.EndPos;
  
			;

} break;
case 1243: /* declaration_qualifier : type_qualifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 256; {
/* line 7083 "mpcPars.lalr" */

			  yySynAttribute.declaration_qualifier.Qual  =  yyAttrStackPtr [1-1].type_qualifier.Qual;

			  yySynAttribute.declaration_qualifier.Class = UNDEFINED;

			  yySynAttribute.declaration_qualifier.Position  =  yyAttrStackPtr [1-1].type_qualifier.Position;

			  yySynAttribute.declaration_qualifier.EndPos  =  yyAttrStackPtr [1-1].type_qualifier.EndPos;
  
			;

} break;
case 1244: /* declaration_qualifier : storage_class .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 256; {
/* line 7094 "mpcPars.lalr" */

			  yySynAttribute.declaration_qualifier.Qual = NoQual;

			    yySynAttribute.declaration_qualifier.Class = yyAttrStackPtr [1-1].storage_class.Class;
			    if(yySynAttribute.declaration_qualifier.Class==FLEXIBLE)
			      Make_Message(461, xxError, yyAttrStackPtr [1-1].storage_class.Position, NoTree);
					   
			  ;

			  yySynAttribute.declaration_qualifier.Position  =  yyAttrStackPtr [1-1].storage_class.Position;

			  yySynAttribute.declaration_qualifier.EndPos  =  yyAttrStackPtr [1-1].storage_class.EndPos;
  
			;

} break;
case 1245: /* type_qualifier_list : type_qualifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 249; {
/* line 7109 "mpcPars.lalr" */

			  yySynAttribute.type_qualifier_list.Class = UNDEFINED;

			  yySynAttribute.type_qualifier_list.Qual  =  yyAttrStackPtr [1-1].type_qualifier.Qual;

			  yySynAttribute.type_qualifier_list.Ignore = false;

			  yySynAttribute.type_qualifier_list.Position  =  yyAttrStackPtr [1-1].type_qualifier.Position;

			  yySynAttribute.type_qualifier_list.EndPos  =  yyAttrStackPtr [1-1].type_qualifier.EndPos;
  
			;

} break;
case 1246: /* type_qualifier_list : type_qualifier_list type_qualifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 249; {
/* line 7122 "mpcPars.lalr" */

			  yySynAttribute.type_qualifier_list.Class = UNDEFINED;

			    yySynAttribute.type_qualifier_list.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore;
			    yySynAttribute.type_qualifier_list.Qual = JoinQualifiers(yyAttrStackPtr [1-1].type_qualifier_list.Qual,
						  yyAttrStackPtr [2-1].type_qualifier.Qual, &yySynAttribute.type_qualifier_list.Ignore,
						  yyAttrStackPtr [2-1].type_qualifier.Position);
			  ;

			  yySynAttribute.type_qualifier_list.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			  yySynAttribute.type_qualifier_list.EndPos  =  yyAttrStackPtr [2-1].type_qualifier.EndPos;
  
			;

} break;
case 1247: /* type_qualifier : const .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 257; {
/* line 7137 "mpcPars.lalr" */
  
			    yySynAttribute.type_qualifier.Qual = NoQual;
			    yySynAttribute.type_qualifier.Qual.Const = true;
			    yySynAttribute.type_qualifier.Position = yySynAttribute.type_qualifier.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.type_qualifier.EndPos.Column += 4;  
			  ;

			;

} break;
case 1248: /* type_qualifier : volatile .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 257; {
/* line 7146 "mpcPars.lalr" */
  
			    yySynAttribute.type_qualifier.Qual = NoQual;
			    yySynAttribute.type_qualifier.Qual.Volatile = true;
			    yySynAttribute.type_qualifier.Position = yySynAttribute.type_qualifier.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.type_qualifier.EndPos.Column += 7;  
			  ;

			;

} break;
case 1249: /* type_qualifier : repl .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 257; {
/* line 7155 "mpcPars.lalr" */
  
			    yySynAttribute.type_qualifier.Qual = NoQual;
			    yySynAttribute.type_qualifier.Qual.Repl = true;
			    yySynAttribute.type_qualifier.Position = yySynAttribute.type_qualifier.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.type_qualifier.EndPos.Column += 3;  
			  ;

			;

} break;
case 1250: /* basic_declaration_specifier : basic_type_specifier storage_class .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 252; {
/* line 7164 "mpcPars.lalr" */

			  yySynAttribute.basic_declaration_specifier.TypeName  =  yyAttrStackPtr [1-1].basic_type_specifier.TypeName;

			    yySynAttribute.basic_declaration_specifier.Class = yyAttrStackPtr [2-1].storage_class.Class;
			    yySynAttribute.basic_declaration_specifier.Ignore = yyAttrStackPtr [1-1].basic_type_specifier.Ignore;
			    if(yySynAttribute.basic_declaration_specifier.Class==FLEXIBLE) {
			      yySynAttribute.basic_declaration_specifier.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [2-1].storage_class.Position, NoTree);
		
			    }
			  ;

			  yySynAttribute.basic_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].basic_type_specifier.Qual;

			  yySynAttribute.basic_declaration_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_specifier.Position;
  
			  yySynAttribute.basic_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].storage_class.EndPos;
  
			;

} break;
case 1251: /* basic_declaration_specifier : declaration_qualifier_list basic_type_name .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 252; {
/* line 7184 "mpcPars.lalr" */

			  yySynAttribute.basic_declaration_specifier.TypeName  =  yyAttrStackPtr [2-1].basic_type_name.TypeName;

			  yySynAttribute.basic_declaration_specifier.Class  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class;

			  yySynAttribute.basic_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual;

			  yySynAttribute.basic_declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;

			  yySynAttribute.basic_declaration_specifier.Position  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Position;
  
			  yySynAttribute.basic_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].basic_type_name.EndPos;
  
			;

} break;
case 1252: /* basic_declaration_specifier : basic_declaration_specifier declaration_qualifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 252; {
/* line 7199 "mpcPars.lalr" */

			    yySynAttribute.basic_declaration_specifier.Ignore = yyAttrStackPtr [1-1].basic_declaration_specifier.Ignore;
			    yySynAttribute.basic_declaration_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].basic_declaration_specifier.Qual,
						  yyAttrStackPtr [2-1].declaration_qualifier.Qual, &yySynAttribute.basic_declaration_specifier.Ignore,
						  yyAttrStackPtr [2-1].declaration_qualifier.Position);
			    if(yyAttrStackPtr [1-1].basic_declaration_specifier.Class==UNDEFINED)
			      yySynAttribute.basic_declaration_specifier.Class = yyAttrStackPtr [2-1].declaration_qualifier.Class;
			    else if(yyAttrStackPtr [2-1].declaration_qualifier.Class!=UNDEFINED) {
			      yySynAttribute.basic_declaration_specifier.Ignore = true;
			      Make_Message(
				463, xxError, yyAttrStackPtr [2-1].declaration_qualifier.Position, NoTree);
		
			    }
			  ;

			  yySynAttribute.basic_declaration_specifier.TypeName  =  yyAttrStackPtr [1-1].basic_declaration_specifier.TypeName;

			  yySynAttribute.basic_declaration_specifier.Position  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Position;
  
			  yySynAttribute.basic_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].declaration_qualifier.EndPos;
  
			;

} break;
case 1253: /* basic_declaration_specifier : basic_declaration_specifier basic_type_name .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 252; {
/* line 7222 "mpcPars.lalr" */

			    yySynAttribute.basic_declaration_specifier.Ignore = yyAttrStackPtr [1-1].basic_declaration_specifier.Ignore;
			    if( !( yySynAttribute.basic_declaration_specifier.TypeName=BasicTypeName(yyAttrStackPtr [1-1].basic_declaration_specifier.TypeName,
							  yyAttrStackPtr [2-1].basic_type_name.TypeName) ) ) {
				yySynAttribute.basic_declaration_specifier.Ignore = true;
				Make_Message(464, xxError, yyAttrStackPtr [2-1].basic_type_name.Position, NoTree);
		
			    }
			  ;

			  yySynAttribute.basic_declaration_specifier.Class  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Class;

			  yySynAttribute.basic_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Qual;

			  yySynAttribute.basic_declaration_specifier.Position  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Position;
  
			  yySynAttribute.basic_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].basic_type_name.EndPos;
  
			;

} break;
case 1254: /* basic_type_specifier : basic_type_name .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 254; {
/* line 7242 "mpcPars.lalr" */

			  yySynAttribute.basic_type_specifier.TypeName  =  yyAttrStackPtr [1-1].basic_type_name.TypeName;

			  yySynAttribute.basic_type_specifier.Class = UNDEFINED;

			  yySynAttribute.basic_type_specifier.Qual = NoQual;

			  yySynAttribute.basic_type_specifier.Ignore = false;

			  yySynAttribute.basic_type_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_name.Position;

			  yySynAttribute.basic_type_specifier.EndPos  =  yyAttrStackPtr [1-1].basic_type_name.EndPos;
  
			;

} break;
case 1255: /* basic_type_specifier : type_qualifier_list basic_type_name .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 254; {
/* line 7257 "mpcPars.lalr" */

			  yySynAttribute.basic_type_specifier.TypeName  =  yyAttrStackPtr [2-1].basic_type_name.TypeName;

			  yySynAttribute.basic_type_specifier.Class = UNDEFINED;

			  yySynAttribute.basic_type_specifier.Qual  =  yyAttrStackPtr [1-1].type_qualifier_list.Qual;

			  yySynAttribute.basic_type_specifier.Ignore  =  yyAttrStackPtr [1-1].type_qualifier_list.Ignore;

			  yySynAttribute.basic_type_specifier.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			  yySynAttribute.basic_type_specifier.EndPos  =  yyAttrStackPtr [2-1].basic_type_name.EndPos;
  
			;

} break;
case 1256: /* basic_type_specifier : basic_type_specifier type_qualifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 254; {
/* line 7272 "mpcPars.lalr" */

			    yySynAttribute.basic_type_specifier.Ignore = yyAttrStackPtr [1-1].basic_type_specifier.Ignore;
			    yySynAttribute.basic_type_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].basic_type_specifier.Qual,
						  yyAttrStackPtr [2-1].type_qualifier.Qual, &yySynAttribute.basic_type_specifier.Ignore,
						  yyAttrStackPtr [2-1].type_qualifier.Position);
			  ;

			  yySynAttribute.basic_type_specifier.TypeName  =  yyAttrStackPtr [1-1].basic_type_specifier.TypeName;

			  yySynAttribute.basic_type_specifier.Class  =  yyAttrStackPtr [1-1].basic_type_specifier.Class;

			  yySynAttribute.basic_type_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_specifier.Position;
   
			  yySynAttribute.basic_type_specifier.EndPos  =  yyAttrStackPtr [2-1].type_qualifier.EndPos;
   
			;

} break;
case 1257: /* basic_type_specifier : basic_type_specifier basic_type_name .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 254; {
/* line 7289 "mpcPars.lalr" */

			    yySynAttribute.basic_type_specifier.Ignore = yyAttrStackPtr [1-1].basic_type_specifier.Ignore;
			    if( !( yySynAttribute.basic_type_specifier.TypeName=BasicTypeName(yyAttrStackPtr [1-1].basic_type_specifier.TypeName,
							  yyAttrStackPtr [2-1].basic_type_name.TypeName) ) ) {
				yySynAttribute.basic_type_specifier.Ignore = true;
				Make_Message(464, xxError, yyAttrStackPtr [2-1].basic_type_name.Position, NoTree);
					     
			    }
			  ;

			  yySynAttribute.basic_type_specifier.Class = UNDEFINED;

			  yySynAttribute.basic_type_specifier.Qual  =  yyAttrStackPtr [1-1].basic_type_specifier.Qual;

			  yySynAttribute.basic_type_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_specifier.Position;
  
			  yySynAttribute.basic_type_specifier.EndPos  =  yyAttrStackPtr [2-1].basic_type_name.EndPos;
  
			;

} break;
case 1258: /* sue_declaration_specifier : sue_type_specifier storage_class .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 204; {
/* line 7309 "mpcPars.lalr" */

			  yySynAttribute.sue_declaration_specifier.Type  =  yyAttrStackPtr [1-1].sue_type_specifier.Type;

			    yySynAttribute.sue_declaration_specifier.Class = yyAttrStackPtr [2-1].storage_class.Class;
			    yySynAttribute.sue_declaration_specifier.Ignore = yyAttrStackPtr [1-1].sue_type_specifier.Ignore;
			    if(yySynAttribute.sue_declaration_specifier.Class==FLEXIBLE) {
			      yySynAttribute.sue_declaration_specifier.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [2-1].storage_class.Position, NoTree);
					   
			    }
			  ;

			  yySynAttribute.sue_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].sue_type_specifier.Qual;

			  yySynAttribute.sue_declaration_specifier.Position  =  yyAttrStackPtr [1-1].sue_type_specifier.Position;
  
			  yySynAttribute.sue_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].storage_class.EndPos;
  
			;

} break;
case 1259: /* sue_declaration_specifier : declaration_qualifier_list elaborated_type_name .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 204; {
/* line 7329 "mpcPars.lalr" */

			    yySynAttribute.sue_declaration_specifier.Type = yyAttrStackPtr [2-1].elaborated_type_name.Type;
			    yySynAttribute.sue_declaration_specifier.Qual = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Const = yySynAttribute.sue_declaration_specifier.Qual.Const;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Volatile = yySynAttribute.sue_declaration_specifier.Qual.Volatile;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Repl = yySynAttribute.sue_declaration_specifier.Qual.Repl;
			  ;

			  yySynAttribute.sue_declaration_specifier.Class  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class;

			    yySynAttribute.sue_declaration_specifier.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore ||
				     yyAttrStackPtr [2-1].elaborated_type_name.Ignore;
			  ;

			  yySynAttribute.sue_declaration_specifier.Position  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Position;
  
			  yySynAttribute.sue_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].elaborated_type_name.EndPos;
  
			;

} break;
case 1260: /* sue_declaration_specifier : sue_declaration_specifier declaration_qualifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 204; {
/* line 7349 "mpcPars.lalr" */

			    yySynAttribute.sue_declaration_specifier.Type = yyAttrStackPtr [1-1].sue_declaration_specifier.Type;
			    yySynAttribute.sue_declaration_specifier.Ignore = yyAttrStackPtr [1-1].sue_declaration_specifier.Ignore;
			    if(yyAttrStackPtr [1-1].sue_declaration_specifier.Class==UNDEFINED)
			      yySynAttribute.sue_declaration_specifier.Class = yyAttrStackPtr [2-1].declaration_qualifier.Class;
			    else if(yyAttrStackPtr [2-1].declaration_qualifier.Class==UNDEFINED)
			      yySynAttribute.sue_declaration_specifier.Class = yyAttrStackPtr [1-1].sue_declaration_specifier.Class;
			    else {
			      yySynAttribute.sue_declaration_specifier.Ignore = true;
			      Make_Message(
				463, xxError, yyAttrStackPtr [2-1].declaration_qualifier.Position, NoTree);
				
			    }
			    yySynAttribute.sue_declaration_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].sue_declaration_specifier.Qual,
						  yyAttrStackPtr [2-1].declaration_qualifier.Qual,
						  &yySynAttribute.sue_declaration_specifier.Ignore, yyAttrStackPtr [2-1].declaration_qualifier.Position);
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Const |= yySynAttribute.sue_declaration_specifier.Qual.Const;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Volatile |= yySynAttribute.sue_declaration_specifier.Qual.Volatile;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Repl |= yySynAttribute.sue_declaration_specifier.Qual.Repl;
			  ;

			  yySynAttribute.sue_declaration_specifier.Position  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Position;
  
			  yySynAttribute.sue_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].declaration_qualifier.EndPos;
  
			;

} break;
case 1261: /* sue_type_specifier : elaborated_type_name .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 205; {
/* line 7376 "mpcPars.lalr" */

			  yySynAttribute.sue_type_specifier.Type  =  yyAttrStackPtr [1-1].elaborated_type_name.Type;

			  yySynAttribute.sue_type_specifier.Class = UNDEFINED;

			  yySynAttribute.sue_type_specifier.Qual = NoQual;

			  yySynAttribute.sue_type_specifier.Ignore  =  yyAttrStackPtr [1-1].elaborated_type_name.Ignore;

			  yySynAttribute.sue_type_specifier.Position  =  yyAttrStackPtr [1-1].elaborated_type_name.Position;

			  yySynAttribute.sue_type_specifier.EndPos  =  yyAttrStackPtr [1-1].elaborated_type_name.EndPos;
  
			;

} break;
case 1262: /* sue_type_specifier : type_qualifier_list elaborated_type_name .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 205; {
/* line 7391 "mpcPars.lalr" */

			    yySynAttribute.sue_type_specifier.Type = yyAttrStackPtr [2-1].elaborated_type_name.Type;
			    yySynAttribute.sue_type_specifier.Qual = yyAttrStackPtr [1-1].type_qualifier_list.Qual;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Const = yySynAttribute.sue_type_specifier.Qual.Const;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Volatile = yySynAttribute.sue_type_specifier.Qual.Volatile;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Repl = yySynAttribute.sue_type_specifier.Qual.Repl;
			  ;

			    yySynAttribute.sue_type_specifier.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore || yyAttrStackPtr [2-1].elaborated_type_name.Ignore;
			  ;

			  yySynAttribute.sue_type_specifier.Class = UNDEFINED;

			  yySynAttribute.sue_type_specifier.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			  yySynAttribute.sue_type_specifier.EndPos  =  yyAttrStackPtr [2-1].elaborated_type_name.EndPos;
  
			;

} break;
case 1263: /* sue_type_specifier : sue_type_specifier type_qualifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 205; {
/* line 7410 "mpcPars.lalr" */

			    yySynAttribute.sue_type_specifier.Type = yyAttrStackPtr [1-1].sue_type_specifier.Type;
			    yySynAttribute.sue_type_specifier.Ignore = yyAttrStackPtr [1-1].sue_type_specifier.Ignore;
			    yySynAttribute.sue_type_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].sue_type_specifier.Qual,
						  yyAttrStackPtr [2-1].type_qualifier.Qual, &yySynAttribute.sue_type_specifier.Ignore,
						  yyAttrStackPtr [2-1].type_qualifier.Position);
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Const |= yySynAttribute.sue_type_specifier.Qual.Const;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Volatile |= yySynAttribute.sue_type_specifier.Qual.Volatile;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Repl |= yySynAttribute.sue_type_specifier.Qual.Repl;
			  ;

			  yySynAttribute.sue_type_specifier.Class = UNDEFINED;

			  yySynAttribute.sue_type_specifier.Position  =  yyAttrStackPtr [1-1].sue_type_specifier.Position;
  
			  yySynAttribute.sue_type_specifier.EndPos  =  yyAttrStackPtr [2-1].type_qualifier.EndPos;
  
			;

} break;
case 1264: /* typedef_declaration_specifier : typedef_type_specifier storage_class .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 253; {
/* line 7429 "mpcPars.lalr" */

			  yySynAttribute.typedef_declaration_specifier.Type  =  yyAttrStackPtr [1-1].typedef_type_specifier.Type;

			    yySynAttribute.typedef_declaration_specifier.Class = yyAttrStackPtr [2-1].storage_class.Class;
			    yySynAttribute.typedef_declaration_specifier.Ignore = yyAttrStackPtr [1-1].typedef_type_specifier.Ignore;
			    if(yySynAttribute.typedef_declaration_specifier.Class==FLEXIBLE) {
			      yySynAttribute.typedef_declaration_specifier.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [2-1].storage_class.Position, NoTree);
					   
			    }
			  ;

			  yySynAttribute.typedef_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].typedef_type_specifier.Qual;

			  yySynAttribute.typedef_declaration_specifier.Position  =  yyAttrStackPtr [1-1].typedef_type_specifier.Position;
  
			  yySynAttribute.typedef_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].storage_class.EndPos;
  
			;

} break;
case 1265: /* typedef_declaration_specifier : declaration_qualifier_list TYPEDEFname .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 253; {
/* line 7449 "mpcPars.lalr" */

			  tTree decl;
			    yySynAttribute.typedef_declaration_specifier.Ignore = yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ignore || yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;
			    decl = Find_Ident(yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ident, IDENT);
			    if(decl!=NoTree && decl->Kind==kMPC_Typedef)
			      yySynAttribute.typedef_declaration_specifier.Type = decl;
			    else {
			      yySynAttribute.typedef_declaration_specifier.Ignore = true;
			      Make_MessageI(465,xxError, yyAttrStackPtr [2-1].Scan.Position,
					 xxIdent, (char *)&yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ident, NoTree);
					 
			    }
			  ;

			  yySynAttribute.typedef_declaration_specifier.Class  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class;

			  yySynAttribute.typedef_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual;
  
			    yySynAttribute.typedef_declaration_specifier.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position;  
			    CurrentPosition = yySynAttribute.typedef_declaration_specifier.EndPos = yyAttrStackPtr [2-1].Scan.Position; 
			    yySynAttribute.typedef_declaration_specifier.EndPos.Column += yyAttrStackPtr [2-1].Scan.TYPEDEFname.Length - 1 ;  
			  ;

			;

} break;
case 1266: /* typedef_declaration_specifier : typedef_declaration_specifier declaration_qualifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 253; {
/* line 7474 "mpcPars.lalr" */

			  yySynAttribute.typedef_declaration_specifier.Type  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.Type;

			    if(yyAttrStackPtr [1-1].typedef_declaration_specifier.Class==UNDEFINED)
			      yySynAttribute.typedef_declaration_specifier.Class = yyAttrStackPtr [2-1].declaration_qualifier.Class;
			    else if(yyAttrStackPtr [2-1].declaration_qualifier.Class==UNDEFINED)
			      yySynAttribute.typedef_declaration_specifier.Class = yyAttrStackPtr [1-1].typedef_declaration_specifier.Class;
			    else
			      Make_Message(466, xxError,
					   yyAttrStackPtr [2-1].declaration_qualifier.Position, NoTree);
					   
			  ;
  
			    yySynAttribute.typedef_declaration_specifier.Ignore = yyAttrStackPtr [1-1].typedef_declaration_specifier.Ignore;
			    yySynAttribute.typedef_declaration_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual,
						  yyAttrStackPtr [2-1].declaration_qualifier.Qual, &yySynAttribute.typedef_declaration_specifier.Ignore,
						  yyAttrStackPtr [2-1].declaration_qualifier.Position);
			    CurrentPosition = yySynAttribute.typedef_declaration_specifier.Position = yyAttrStackPtr [1-1].typedef_declaration_specifier.Position;  
			    yySynAttribute.typedef_declaration_specifier.EndPos = yyAttrStackPtr [2-1].declaration_qualifier.EndPos;  
			  ;

			;

} break;
case 1267: /* typedef_type_specifier : TYPEDEFname .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 255; {
/* line 7497 "mpcPars.lalr" */

			  tTree decl;
			    yySynAttribute.typedef_type_specifier.Ignore = yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ignore;
			    decl = Find_Ident(yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ident, IDENT);
			    if(decl!=NoTree && decl->Kind==kMPC_Typedef)
			      yySynAttribute.typedef_type_specifier.Type = decl;
			    else {
			      yySynAttribute.typedef_type_specifier.Ignore = true;
			      Make_MessageI(467,xxError, yyAttrStackPtr [1-1].Scan.Position,
				 xxIdent, (char *)&yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ident, NoTree);
				 
			    }
			  ;

			  yySynAttribute.typedef_type_specifier.Class = UNDEFINED;

			  yySynAttribute.typedef_type_specifier.Qual = NoQual;
  
			    yySynAttribute.typedef_type_specifier.Position = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;
			    yySynAttribute.typedef_type_specifier.EndPos = yySynAttribute.typedef_type_specifier.Position;  
			    yySynAttribute.typedef_type_specifier.EndPos.Column += yyAttrStackPtr [1-1].Scan.TYPEDEFname.Length - 1 ;  
			  ;

			;

} break;
case 1268: /* typedef_type_specifier : type_qualifier_list TYPEDEFname .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 255; {
/* line 7522 "mpcPars.lalr" */

			  tTree decl;
			    yySynAttribute.typedef_type_specifier.Ignore = yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ignore || yyAttrStackPtr [1-1].type_qualifier_list.Ignore;
			    decl = Find_Ident(yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ident, IDENT);
			    if(decl!=NoTree && decl->Kind==kMPC_Typedef)
			      yySynAttribute.typedef_type_specifier.Type = decl;
			    else {
			      yySynAttribute.typedef_type_specifier.Ignore = true;
			      Make_MessageI(467,xxError, yyAttrStackPtr [2-1].Scan.Position,
				 xxIdent, (char *)&yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ident, NoTree);
				 
			    }
			  ;

			  yySynAttribute.typedef_type_specifier.Class = UNDEFINED;

			  yySynAttribute.typedef_type_specifier.Qual  =  yyAttrStackPtr [1-1].type_qualifier_list.Qual;
  
			    yySynAttribute.typedef_type_specifier.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position;  
			    CurrentPosition = yySynAttribute.typedef_type_specifier.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.typedef_type_specifier.EndPos.Column += yyAttrStackPtr [2-1].Scan.TYPEDEFname.Length - 1 ;  
			  ;

			;

} break;
case 1269: /* typedef_type_specifier : typedef_type_specifier type_qualifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 255; {
/* line 7547 "mpcPars.lalr" */

			  yySynAttribute.typedef_type_specifier.Type  =  yyAttrStackPtr [1-1].typedef_type_specifier.Type;

			  yySynAttribute.typedef_type_specifier.Class  =  yyAttrStackPtr [1-1].typedef_type_specifier.Class;

			    yySynAttribute.typedef_type_specifier.Ignore = yyAttrStackPtr [1-1].typedef_type_specifier.Ignore;
			    yySynAttribute.typedef_type_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].typedef_type_specifier.Qual,
						  yyAttrStackPtr [2-1].type_qualifier.Qual, &yySynAttribute.typedef_type_specifier.Ignore,
						  yyAttrStackPtr [2-1].type_qualifier.Position);
			  ;

			  yySynAttribute.typedef_type_specifier.Position  =  yyAttrStackPtr [1-1].typedef_type_specifier.Position;
  
			  yySynAttribute.typedef_type_specifier.EndPos  =  yyAttrStackPtr [2-1].type_qualifier.EndPos;
  
			;

} break;
case 1270: /* storage_class : typedef .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 214; {
/* line 7564 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = TYPEDEF;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 6;  
			  ;
 
			;

} break;
case 1271: /* storage_class : extern .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 214; {
/* line 7573 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = EXTERN;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 5;  
			  ;

			;

} break;
case 1272: /* storage_class : static .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 214; {
/* line 7582 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = STATIC;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 5;  
			  ;

			;

} break;
case 1273: /* storage_class : auto .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 214; {
/* line 7591 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = AUTO;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 3;  
			  ;

			;

} break;
case 1274: /* storage_class : register .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 214; {
/* line 7600 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = REGISTER;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;
			    yySynAttribute.storage_class.EndPos.Column += 7;  
			  ;

			;

} break;
case 1275: /* storage_class : flex .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 214; {
/* line 7609 "mpcPars.lalr" */
  
			  yySynAttribute.storage_class.Class = FLEXIBLE;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 3;  
			  ;

			;

} break;
case 1276: /* basic_type_name : xx323 void .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 219; {
/* line 7618 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = VOID;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 3;  
			  ;

			;

} break;
case 1277: /* xx323 : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 259; {
/* line 7628 "mpcPars.lalr" */
 yySynAttribute.basic_type_name.Ignore = false;
 ;

} break;
case 1278: /* basic_type_name : xx323 char .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 219; {
/* line 7631 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = CHAR;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 3;  
			  ;

			;

} break;
case 1279: /* basic_type_name : xx323 short .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 219; {
/* line 7641 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = SHORT;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 4;  
			  ;

			;

} break;
case 1280: /* basic_type_name : xx323 int .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 219; {
/* line 7651 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = INT;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 2;  
			  ;

			;

} break;
case 1281: /* basic_type_name : xx323 long .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 219; {
/* line 7661 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = LONG;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 3;  
			  ;

			;

} break;
case 1282: /* basic_type_name : xx323 float .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 219; {
/* line 7671 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = FLOAT;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 4;  
			  ;

			;

} break;
case 1283: /* basic_type_name : xx323 double .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 219; {
/* line 7681 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = DOUBLE;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 5;  
			  ;

			;

} break;
case 1284: /* basic_type_name : xx323 signed .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 219; {
/* line 7691 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = SIGNED;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 5;  
			  ;

			;

} break;
case 1285: /* basic_type_name : xx323 unsigned .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 219; {
/* line 7701 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = UNSIGNED;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 7;  
			  ;

			;

} break;
case 1286: /* elaborated_type_name : struct_or_union_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 258; {
/* line 7711 "mpcPars.lalr" */

			    yySynAttribute.elaborated_type_name.Type = yyAttrStackPtr [1-1].struct_or_union_specifier.Type;
			    if(Is_PrototypeScope &&
			       yySynAttribute.elaborated_type_name.Type->MPC_Type.EquivType==NoTree )
			      DECL_Warning((480, xxWarning, yyAttrStackPtr [1-1].struct_or_union_specifier.Position, NoTree));
				
			  ;

			  yySynAttribute.elaborated_type_name.Ignore  =  yyAttrStackPtr [1-1].struct_or_union_specifier.Ignore;

			  yySynAttribute.elaborated_type_name.Position  =  yyAttrStackPtr [1-1].struct_or_union_specifier.Position;

			  yySynAttribute.elaborated_type_name.EndPos  =  yyAttrStackPtr [1-1].struct_or_union_specifier.EndPos;
  
			;

} break;
case 1287: /* elaborated_type_name : enum_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 258; {
/* line 7727 "mpcPars.lalr" */

			    yySynAttribute.elaborated_type_name.Type = yyAttrStackPtr [1-1].enum_specifier.Type;
			    if(Is_PrototypeScope &&
			       yySynAttribute.elaborated_type_name.Type->MPC_Type.EquivType==NoTree )
			      DECL_Warning((481, xxWarning, yyAttrStackPtr [1-1].enum_specifier.Position, NoTree));
				
			  ;

			  yySynAttribute.elaborated_type_name.Ignore  =  yyAttrStackPtr [1-1].enum_specifier.Ignore;

			  yySynAttribute.elaborated_type_name.Position  =  yyAttrStackPtr [1-1].enum_specifier.Position;

			  yySynAttribute.elaborated_type_name.EndPos  =  yyAttrStackPtr [1-1].enum_specifier.EndPos;
  
			;

} break;
case 1288: /* struct_or_union_specifier : struct_or_union '{' struct_declaration_list '}' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 260; {
/* line 7743 "mpcPars.lalr" */
  
			    Save_SUE_Tags();
			    Close_Scope(), Scope_Depth--; SU_Scope--;
			    if(!Scope_Depth) Default_Class = EXTERN;
			    yySynAttribute.struct_or_union_specifier.Type = yyAttrStackPtr [1-1].struct_or_union.Tree;
			    yySynAttribute.struct_or_union_specifier.Ident = yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.SU_Tag = NoIdent;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.MemberDecls =
				  ReverseTree(yyAttrStackPtr [3-1].struct_declaration_list.Tree);
			    yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.MemberDecls->
				  MPC_SU_MemberDecl.Prev->MPC_FreeNode.Parent = yySynAttribute.struct_or_union_specifier.Type;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Flag = NoTypeFlag;
			    if(Default_Class!=EXTERN)
			      yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Flag.Local = YES;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_DerivedType.NumberOfComponents = UNDEFINED;
			    yySynAttribute.struct_or_union_specifier.Position = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.Pos = yyAttrStackPtr [1-1].struct_or_union.Position;  
			    yySynAttribute.struct_or_union_specifier.EndPos = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			  yySynAttribute.struct_or_union_specifier.Ignore  =  yyAttrStackPtr [3-1].struct_declaration_list.Ignore;

			;

} break;
case 1289: /* struct_or_union_specifier : struct_or_union general_identifier '{' struct_declaration_list '}' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 260; {
/* line 7765 "mpcPars.lalr" */
  
			    tTree decl;
			    yySynAttribute.struct_or_union_specifier.Type = yyAttrStackPtr [1-1].struct_or_union.Tree;
			    yySynAttribute.struct_or_union_specifier.Ignore = yyAttrStackPtr [4-1].struct_declaration_list.Ignore;
			    yySynAttribute.struct_or_union_specifier.Ident = yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.SU_Tag = yyAttrStackPtr [2-1].general_identifier.Ident;
			    if((decl=Find_InScope(yySynAttribute.struct_or_union_specifier.Ident, NSUE_TAG))!=NoTree &&
				decl->Kind==yySynAttribute.struct_or_union_specifier.Type->Kind) {  
			      Add_EquivType(yySynAttribute.struct_or_union_specifier.Type,decl);
			    }
			    Save_SUE_Tags();
			    Close_Scope(), Scope_Depth--; SU_Scope--;
			    if(yySynAttribute.struct_or_union_specifier.Type->MPC_Type.EquivType==NoTree) { 
			      if((decl=Find_InScope(yySynAttribute.struct_or_union_specifier.Ident, NSUE_TAG))!=NoTree &&
				 decl->Kind==yySynAttribute.struct_or_union_specifier.Type->Kind)
				Add_EquivType(yySynAttribute.struct_or_union_specifier.Type,decl);
			    }
			    yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.MemberDecls = 
					ReverseTree(yyAttrStackPtr [4-1].struct_declaration_list.Tree);
			    yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.MemberDecls->
				  MPC_SU_MemberDecl.Prev->MPC_FreeNode.Parent = yySynAttribute.struct_or_union_specifier.Type;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Flag = NoTypeFlag;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Pos = yyAttrStackPtr [2-1].general_identifier.Position;
			    Add_Ident(yySynAttribute.struct_or_union_specifier.Ident, NSUE_TAG, yySynAttribute.struct_or_union_specifier.Type);
			    if(!Scope_Depth) Default_Class = EXTERN;
			    if(Default_Class!=EXTERN)
			      yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Flag.Local = YES;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_DerivedType.NumberOfComponents = UNDEFINED;
			    yySynAttribute.struct_or_union_specifier.Position = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.Pos = yyAttrStackPtr [1-1].struct_or_union.Position;  
			    yySynAttribute.struct_or_union_specifier.EndPos = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.EndPos = yyAttrStackPtr [5-1].Scan.Position;  
			  ;

			;

} break;
case 1290: /* struct_or_union_specifier : struct_or_union general_identifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 260; {
/* line 7798 "mpcPars.lalr" */
  
			    tTree decl;
			    yySynAttribute.struct_or_union_specifier.Type = yyAttrStackPtr [1-1].struct_or_union.Tree;
			    yySynAttribute.struct_or_union_specifier.Ident = yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.SU_Tag = yyAttrStackPtr [2-1].general_identifier.Ident;
			    if((decl=Find_Ident(yySynAttribute.struct_or_union_specifier.Ident, NSUE_TAG))!=NoTree &&
				decl->Kind==yySynAttribute.struct_or_union_specifier.Type->Kind &&
				SU_Scope 
			      ) {
			      Add_EquivType(yySynAttribute.struct_or_union_specifier.Type,decl);
			      Close_Scope(), Scope_Depth--;
			    }
			    else {
			      Close_Scope(), Scope_Depth--;
			      Add_Ident(yySynAttribute.struct_or_union_specifier.Ident, NSUE_TAG, yySynAttribute.struct_or_union_specifier.Type);  
			    }
			    SU_Scope--;
			    if(!Scope_Depth) Default_Class = EXTERN;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Flag = NoTypeFlag;
			    if(Default_Class!=EXTERN)
			      yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Flag.Local = YES;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_DerivedType.NumberOfComponents = UNDEFINED;
			    yySynAttribute.struct_or_union_specifier.Position = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.Pos = yyAttrStackPtr [1-1].struct_or_union.Position;  
			    yySynAttribute.struct_or_union_specifier.EndPos = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.EndPos = yyAttrStackPtr [2-1].general_identifier.EndPos;  
			  ;

			  yySynAttribute.struct_or_union_specifier.Ignore  =  yyAttrStackPtr [2-1].general_identifier.Ignore;

			;

} break;
case 1291: /* struct_or_union : struct .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 262; {
/* line 7827 "mpcPars.lalr" */
 yySynAttribute.struct_or_union.Tree=nMPC_StructType(); Open_Scope(); Scope_Depth++; SU_Scope++; ;

			  yySynAttribute.struct_or_union.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1292: /* struct_or_union : union .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 262; {
/* line 7833 "mpcPars.lalr" */
 yySynAttribute.struct_or_union.Tree=nMPC_UnionType(); Open_Scope(); Scope_Depth++; SU_Scope++; ;

			  yySynAttribute.struct_or_union.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1293: /* struct_declaration_list : struct_declaration .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 263; {
/* line 7839 "mpcPars.lalr" */

			    yySynAttribute.struct_declaration_list.Tree = mMPC_SU_MemberDecl(
					yyAttrStackPtr [1-1].struct_declaration.Position, NoTree, NoTree,
					yyAttrStackPtr [1-1].struct_declaration.Tree
				   );
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.Member->
				  MPC_SU_Member.Prev->MPC_FreeNode.Parent = yySynAttribute.struct_declaration_list.Tree;
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.Next =
				  yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.Prev = nMPC_FreeNode();
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.EndPos = yyAttrStackPtr [1-1].struct_declaration.EndPos;  
			  ;

			  yySynAttribute.struct_declaration_list.Ignore  =  yyAttrStackPtr [1-1].struct_declaration.Ignore;

			;

} break;
case 1294: /* struct_declaration_list : struct_declaration_list struct_declaration .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 263; {
/* line 7855 "mpcPars.lalr" */

			    yySynAttribute.struct_declaration_list.Tree = mMPC_SU_MemberDecl(
					yyAttrStackPtr [2-1].struct_declaration.Position,
					yyAttrStackPtr [1-1].struct_declaration_list.Tree,
					yyAttrStackPtr [1-1].struct_declaration_list.Tree,
					yyAttrStackPtr [2-1].struct_declaration.Tree
				   );
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.Member->
				  MPC_SU_Member.Prev->MPC_FreeNode.Parent = yySynAttribute.struct_declaration_list.Tree;
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.EndPos = yyAttrStackPtr [2-1].struct_declaration.EndPos;  
			  ;

			  yySynAttribute.struct_declaration_list.Ignore = yyAttrStackPtr [1-1].struct_declaration_list.Ignore || yyAttrStackPtr [2-1].struct_declaration.Ignore;

			;

} break;
case 1295: /* struct_declaration : struct_declaring_list ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 264; {
/* line 7871 "mpcPars.lalr" */

			  yySynAttribute.struct_declaration.Tree = ReverseTree(yyAttrStackPtr [1-1].struct_declaring_list.Tree);

			  yySynAttribute.struct_declaration.Ignore  =  yyAttrStackPtr [1-1].struct_declaring_list.Ignore;

			  yySynAttribute.struct_declaration.Position  =  yyAttrStackPtr [1-1].struct_declaring_list.Position;
  
			  yySynAttribute.struct_declaration.EndPos  =  yyAttrStackPtr [2-1].Scan.Position;
  
			;

} break;
case 1296: /* struct_declaration : struct_default_declaring_list ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 264; {
/* line 7882 "mpcPars.lalr" */

			  yySynAttribute.struct_declaration.Tree = ReverseTree(yyAttrStackPtr [1-1].struct_default_declaring_list.Tree);

			  yySynAttribute.struct_declaration.Ignore  =  yyAttrStackPtr [1-1].struct_default_declaring_list.Ignore;

			  yySynAttribute.struct_declaration.Position  =  yyAttrStackPtr [1-1].struct_default_declaring_list.Position;
  
			  yySynAttribute.struct_declaration.EndPos  =  yyAttrStackPtr [2-1].Scan.Position;
  
			;

} break;
case 1297: /* struct_default_declaring_list : type_qualifier_list struct_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 266; {
/* line 7893 "mpcPars.lalr" */

			    tTree ftype;
			    yySynAttribute.struct_default_declaring_list.Type = mMPC_BasicType(NoPosition, NoTree, NoTree, NoTypeFlag, INT);
			    yySynAttribute.struct_default_declaring_list.Type->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    yySynAttribute.struct_default_declaring_list.Type->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    NestedType_ON();
			    Push_Pattern(yySynAttribute.struct_default_declaring_list.Type);
			    yySynAttribute.struct_default_declaring_list.Type = Make_Type();
			    NestedType_OFF();
			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].struct_declarator.Position 
				    );
			      }
			    }
			    Push_Pattern(yySynAttribute.struct_default_declaring_list.Type);
			    yySynAttribute.struct_default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].struct_declarator.Ident, NSUE_MEMBER,
				     mMPC_SU_Member(
					yyAttrStackPtr [2-1].struct_declarator.Position, yyAttrStackPtr [2-1].struct_declarator.Ident,
					yyAttrStackPtr [2-1].struct_declarator.BitFieldLength, NoTree, NoTree,
					Make_Type(), yyAttrStackPtr [2-1].struct_declarator.BitFieldSize_Expr
				     )
				   );
			    
			    yySynAttribute.struct_default_declaring_list.Tree->MPC_SU_Member.Next =
				  yySynAttribute.struct_default_declaring_list.Tree->MPC_SU_Member.Prev = nMPC_FreeNode();
			    yySynAttribute.struct_default_declaring_list.Tree->MPC_SU_Member.EndPos = yyAttrStackPtr [2-1].struct_declarator.EndPos;  
			  ;

			  yySynAttribute.struct_default_declaring_list.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore || yyAttrStackPtr [2-1].struct_declarator.Ignore;

			  yySynAttribute.struct_default_declaring_list.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			;

} break;
case 1298: /* struct_default_declaring_list : struct_default_declaring_list ',' struct_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 266; {
/* line 7955 "mpcPars.lalr" */

			    tTree ftype;
			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [3-1].struct_declarator.Position 
				    );
			      }
			    }
			    Push_Pattern(yySynAttribute.struct_default_declaring_list.Type=yyAttrStackPtr [1-1].struct_default_declaring_list.Type);
			    yySynAttribute.struct_default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [3-1].struct_declarator.Ident, NSUE_MEMBER,
				     mMPC_SU_Member(
					yyAttrStackPtr [3-1].struct_declarator.Position, yyAttrStackPtr [3-1].struct_declarator.Ident,
					yyAttrStackPtr [3-1].struct_declarator.BitFieldLength,
					yyAttrStackPtr [1-1].struct_default_declaring_list.Tree,
					yyAttrStackPtr [1-1].struct_default_declaring_list.Tree,
					Make_Type(), yyAttrStackPtr [3-1].struct_declarator.BitFieldSize_Expr
				     )
				   );
			    yySynAttribute.struct_default_declaring_list.Tree->MPC_SU_Member.EndPos = yyAttrStackPtr [3-1].struct_declarator.EndPos;  
			  ;

			  yySynAttribute.struct_default_declaring_list.Ignore = yyAttrStackPtr [1-1].struct_default_declaring_list.Ignore ||
						yyAttrStackPtr [3-1].struct_declarator.Ignore;

			  yySynAttribute.struct_default_declaring_list.Position  =  yyAttrStackPtr [1-1].struct_default_declaring_list.Position;
  
			;

} break;
case 1299: /* struct_declaring_list : type_specifier struct_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 265; {
/* line 8010 "mpcPars.lalr" */

			    tTree ftype;
			    yySynAttribute.struct_declaring_list.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore || yyAttrStackPtr [2-1].struct_declarator.Ignore;
			    if(yyAttrStackPtr [1-1].type_specifier.Class!=UNDEFINED)
			      yySynAttribute.struct_declaring_list.Ignore = true,
			      Make_Message(468, xxError, yyAttrStackPtr [1-1].type_specifier.Position, NoTree);
					   
			    NestedType_ON();
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			    yySynAttribute.struct_declaring_list.Type = Make_Type();
			    NestedType_OFF();
			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].struct_declarator.Position 
				    );
			      }
			    }
			    Push_Pattern(yySynAttribute.struct_declaring_list.Type);
			    yySynAttribute.struct_declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].struct_declarator.Ident, NSUE_MEMBER,
				     mMPC_SU_Member(
					yyAttrStackPtr [2-1].struct_declarator.Position, yyAttrStackPtr [2-1].struct_declarator.Ident,
					yyAttrStackPtr [2-1].struct_declarator.BitFieldLength, NoTree, NoTree,
					Make_Type(), yyAttrStackPtr [2-1].struct_declarator.BitFieldSize_Expr
				     )
				   );
			    yySynAttribute.struct_declaring_list.Tree->MPC_SU_Member.Next =
				  yySynAttribute.struct_declaring_list.Tree->MPC_SU_Member.Prev = nMPC_FreeNode();
			    yySynAttribute.struct_declaring_list.Tree->MPC_SU_Member.EndPos = yyAttrStackPtr [2-1].struct_declarator.EndPos;  
			  ;

			  yySynAttribute.struct_declaring_list.Position  =  yyAttrStackPtr [1-1].type_specifier.Position;
  
			;

} break;
case 1300: /* struct_declaring_list : struct_declaring_list ',' struct_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 265; {
/* line 8071 "mpcPars.lalr" */

			    tTree ftype;
			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [3-1].struct_declarator.Position 
				    );
			      }
			    }
			    Push_Pattern(yySynAttribute.struct_declaring_list.Type=yyAttrStackPtr [1-1].struct_declaring_list.Type);
			    yySynAttribute.struct_declaring_list.Tree = Add_Ident(yyAttrStackPtr [3-1].struct_declarator.Ident, NSUE_MEMBER,
				     mMPC_SU_Member(
					yyAttrStackPtr [3-1].struct_declarator.Position, yyAttrStackPtr [3-1].struct_declarator.Ident,
					yyAttrStackPtr [3-1].struct_declarator.BitFieldLength,
					yyAttrStackPtr [1-1].struct_declaring_list.Tree, yyAttrStackPtr [1-1].struct_declaring_list.Tree,
					Make_Type(), yyAttrStackPtr [3-1].struct_declarator.BitFieldSize_Expr
				     )
				   );
			    yySynAttribute.struct_declaring_list.Tree->MPC_SU_Member.EndPos = yyAttrStackPtr [3-1].struct_declarator.EndPos;  
			  ;

			  yySynAttribute.struct_declaring_list.Ignore = yyAttrStackPtr [1-1].struct_declaring_list.Ignore ||
					yyAttrStackPtr [3-1].struct_declarator.Ignore;

			  yySynAttribute.struct_declaring_list.Position  =  yyAttrStackPtr [1-1].struct_declaring_list.Position;
  
			;

} break;
case 1301: /* struct_declarator : declarator bit_field_size_opt .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 267; {
/* line 8125 "mpcPars.lalr" */

			    yySynAttribute.struct_declarator.Ident = yyAttrStackPtr [1-1].declarator.Ident;
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;  
			    }
			    yySynAttribute.struct_declarator.EndPos = (yyAttrStackPtr [2-1].bit_field_size_opt.Tree==NoTree)?  
				yyAttrStackPtr [1-1].declarator.EndPos:yyAttrStackPtr [2-1].bit_field_size_opt.EndPos;  
			  ;

			  yySynAttribute.struct_declarator.BitFieldLength  =  yyAttrStackPtr [2-1].bit_field_size_opt.Length;

			  yySynAttribute.struct_declarator.BitFieldSize_Expr  =  yyAttrStackPtr [2-1].bit_field_size_opt.Tree;

			  yySynAttribute.struct_declarator.Ignore = yyAttrStackPtr [1-1].declarator.Ignore || yyAttrStackPtr [2-1].bit_field_size_opt.Ignore;

			  yySynAttribute.struct_declarator.Position  =  yyAttrStackPtr [1-1].declarator.Position;
  
			;

} break;
case 1302: /* struct_declarator : bit_field_size .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 267; {
/* line 8146 "mpcPars.lalr" */

			  yySynAttribute.struct_declarator.Ident = NoIdent;

			  yySynAttribute.struct_declarator.BitFieldLength  =  yyAttrStackPtr [1-1].bit_field_size.Length;

			  yySynAttribute.struct_declarator.BitFieldSize_Expr  =  yyAttrStackPtr [1-1].bit_field_size.Tree;

			  yySynAttribute.struct_declarator.Ignore  =  yyAttrStackPtr [1-1].bit_field_size.Ignore;

			  yySynAttribute.struct_declarator.Position  =  yyAttrStackPtr [1-1].bit_field_size.Position;

			  yySynAttribute.struct_declarator.EndPos  =  yyAttrStackPtr [1-1].bit_field_size.EndPos;
  
			;

} break;
case 1303: /* bit_field_size_opt : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 268; {
/* line 8161 "mpcPars.lalr" */

			    
			  yySynAttribute.bit_field_size_opt.Length = UNDEFINED;

			  yySynAttribute.bit_field_size_opt.Tree = NoTree;

			  yySynAttribute.bit_field_size_opt.Ignore = false;

			    
			  yySynAttribute.bit_field_size_opt.EndPos = NoPosition;
  
			;

} break;
case 1304: /* bit_field_size_opt : bit_field_size .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 268; {
/* line 8174 "mpcPars.lalr" */

			    
			  yySynAttribute.bit_field_size_opt.Length  =  yyAttrStackPtr [1-1].bit_field_size.Length;

			  yySynAttribute.bit_field_size_opt.Tree  =  yyAttrStackPtr [1-1].bit_field_size.Tree;

			  yySynAttribute.bit_field_size_opt.Ignore  =  yyAttrStackPtr [1-1].bit_field_size.Ignore;

			    	
			  yySynAttribute.bit_field_size_opt.EndPos  =  yyAttrStackPtr [1-1].bit_field_size.EndPos;
  
			;

} break;
case 1305: /* bit_field_size : ':' constant_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 269; {
/* line 8187 "mpcPars.lalr" */

			    yySynAttribute.bit_field_size.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore;
			    yySynAttribute.bit_field_size.Tree = yyAttrStackPtr [2-1].constant_expression.Tree;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
			      yySynAttribute.bit_field_size.Length = yyAttrStackPtr [2-1].constant_expression.Value;
			    else
			      yySynAttribute.bit_field_size.Ignore = true,
			      Make_Message(469, xxError, yyAttrStackPtr [2-1].constant_expression.Position, yySynAttribute.bit_field_size.Tree);
					   
			  ;

			  yySynAttribute.bit_field_size.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			  yySynAttribute.bit_field_size.EndPos  =  yyAttrStackPtr [2-1].constant_expression.EndPos;
  
			;

} break;
case 1306: /* enum_specifier : enum '{' enumerator_list '}' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 261; {
/* line 8204 "mpcPars.lalr" */
  
			    yySynAttribute.enum_specifier.Type = mMPC_EnumType(
					yySynAttribute.enum_specifier.Position=yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree, NoTypeFlag,  
					NoIdent, ReverseTree(yyAttrStackPtr [3-1].enumerator_list.Tree)
				   );
			    yySynAttribute.enum_specifier.Type->MPC_EnumType.EnumList->MPC_EnumConst.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.enum_specifier.Type;
			    yySynAttribute.enum_specifier.Type->MPC_Type.Flag.Ignore = yySynAttribute.enum_specifier.Ignore = yyAttrStackPtr [3-1].enumerator_list.Ignore;
			     yySynAttribute.enum_specifier.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1307: /* enum_specifier : enum general_identifier '{' enumerator_list '}' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 261; {
/* line 8218 "mpcPars.lalr" */
  
			    tTree decl;
			    yySynAttribute.enum_specifier.Type = mMPC_EnumType(
					yySynAttribute.enum_specifier.Position=yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree, NoTypeFlag,  
					yyAttrStackPtr [2-1].general_identifier.Ident, ReverseTree(yyAttrStackPtr [4-1].enumerator_list.Tree)
				   );
			    yySynAttribute.enum_specifier.Type->MPC_EnumType.EnumList->MPC_EnumConst.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.enum_specifier.Type;
			    yySynAttribute.enum_specifier.Type->MPC_Type.Flag.Ignore = yySynAttribute.enum_specifier.Ignore = yyAttrStackPtr [4-1].enumerator_list.Ignore ||
									yyAttrStackPtr [2-1].general_identifier.Ignore;
			     yySynAttribute.enum_specifier.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    if((decl=Find_Ident(yyAttrStackPtr [2-1].general_identifier.Ident,NSUE_TAG))!=NoTree &&
				decl->Kind==yySynAttribute.enum_specifier.Type->Kind) {
			      
			      Add_EquivType(yySynAttribute.enum_specifier.Type,decl);
			    }
			    Add_Ident(yyAttrStackPtr [2-1].general_identifier.Ident, NSUE_TAG, yySynAttribute.enum_specifier.Type);
			  ;

			;

} break;
case 1308: /* enum_specifier : enum general_identifier .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 261; {
/* line 8240 "mpcPars.lalr" */
  
			    tTree decl;
			    yySynAttribute.enum_specifier.Type = mMPC_EnumType(
					yySynAttribute.enum_specifier.Position=yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree, NoTypeFlag,
					yyAttrStackPtr [2-1].general_identifier.Ident, NoTree
				   );
			    yySynAttribute.enum_specifier.EndPos = yyAttrStackPtr [2-1].general_identifier.EndPos;  
			    if((decl=Find_Ident(yyAttrStackPtr [2-1].general_identifier.Ident, NSUE_TAG))!=NoTree &&
				decl->Kind==yySynAttribute.enum_specifier.Type->Kind) {
			      Add_EquivType(yySynAttribute.enum_specifier.Type,decl);
			    }
			    else
			      Add_Ident(yyAttrStackPtr [2-1].general_identifier.Ident, NSUE_TAG, yySynAttribute.enum_specifier.Type);
			    yySynAttribute.enum_specifier.Ignore = yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.enum_specifier.Position = yyAttrStackPtr [2-1].general_identifier.Position;
			  ;

			;

} break;
case 1309: /* enumerator_list : general_identifier enumerator_value_opt .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 270; {
/* line 8260 "mpcPars.lalr" */

			    yySynAttribute.enumerator_list.Tree = mMPC_EnumConst(
					yyAttrStackPtr [1-1].general_identifier.Position, yyAttrStackPtr [1-1].general_identifier.Ident,
					yyAttrStackPtr [2-1].enumerator_value_opt.Present,
					(yyAttrStackPtr [2-1].enumerator_value_opt.Present ? yyAttrStackPtr [2-1].enumerator_value_opt.Value : 0),
					NoTree, NoTree
				   );
			    Add_Ident(yyAttrStackPtr [1-1].general_identifier.Ident, IDENT, yySynAttribute.enumerator_list.Tree);
			    yySynAttribute.enumerator_list.Tree->MPC_EnumConst.Next =
				  yySynAttribute.enumerator_list.Tree->MPC_EnumConst.Prev = nMPC_FreeNode();
			    yySynAttribute.enumerator_list.Ignore = yyAttrStackPtr [1-1].general_identifier.Ignore || yyAttrStackPtr [2-1].enumerator_value_opt.Ignore;
			    yySynAttribute.enumerator_list.Tree->MPC_EnumConst.EndPos =  
				 (!Compare(yyAttrStackPtr [2-1].enumerator_value_opt.EndPos,NoPosition) )?  
					yyAttrStackPtr [1-1].general_identifier.EndPos:  
					yyAttrStackPtr [2-1].enumerator_value_opt.EndPos;  
			  ;

			;

} break;
case 1310: /* enumerator_list : enumerator_list ',' general_identifier enumerator_value_opt .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 270; {
/* line 8279 "mpcPars.lalr" */
  
			    yySynAttribute.enumerator_list.Tree = mMPC_EnumConst(
					yyAttrStackPtr [3-1].general_identifier.Position, yyAttrStackPtr [3-1].general_identifier.Ident,
					yyAttrStackPtr [4-1].enumerator_value_opt.Present,
					(yyAttrStackPtr [4-1].enumerator_value_opt.Present ? yyAttrStackPtr [4-1].enumerator_value_opt.Value
								      : yyAttrStackPtr [1-1].enumerator_list.Tree->MPC_EnumConst.Value+1),
					yyAttrStackPtr [1-1].enumerator_list.Tree, yyAttrStackPtr [1-1].enumerator_list.Tree
				   );
			    Add_Ident(yyAttrStackPtr [3-1].general_identifier.Ident, IDENT, yySynAttribute.enumerator_list.Tree);
			    yySynAttribute.enumerator_list.Ignore = yyAttrStackPtr [1-1].enumerator_list.Ignore ||
				     yyAttrStackPtr [3-1].general_identifier.Ignore || yyAttrStackPtr [4-1].enumerator_value_opt.Ignore;
			  ;

			;

} break;
case 1311: /* enumerator_value_opt : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 271; {
/* line 8294 "mpcPars.lalr" */
 yySynAttribute.enumerator_value_opt.Present = NO;
 yySynAttribute.enumerator_value_opt.Value = UNDEFINED;
 yySynAttribute.enumerator_value_opt.Ignore = false;

		    yySynAttribute.enumerator_value_opt.EndPos = NoPosition;
  ;

} break;
case 1312: /* enumerator_value_opt : '=' constant_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 271; {
/* line 8301 "mpcPars.lalr" */

			  yySynAttribute.enumerator_value_opt.Present = YES;

			    yySynAttribute.enumerator_value_opt.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
			      yySynAttribute.enumerator_value_opt.Value = yyAttrStackPtr [2-1].constant_expression.Value;
			    else {
			      yySynAttribute.enumerator_value_opt.Ignore = YES;
			      Make_Message(470, xxError,
					   yyAttrStackPtr [2-1].constant_expression.Position, yyAttrStackPtr [2-1].constant_expression.Tree);
					   
			    }
			  ;

		          yySynAttribute.enumerator_value_opt.EndPos  =  yyAttrStackPtr [2-1].constant_expression.EndPos;
  
			;

} break;
case 1313: /* parameter_type_list : nested_type_on parameter_list nested_type_off .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 273; {
/* line 8319 "mpcPars.lalr" */
 yySynAttribute.parameter_type_list.Tree = ReverseTree(yyAttrStackPtr [2-1].parameter_list.Tree); ;

			  yySynAttribute.parameter_type_list.Length  =  yyAttrStackPtr [2-1].parameter_list.Length;

			  yySynAttribute.parameter_type_list.Ignore  =  yyAttrStackPtr [2-1].parameter_list.Ignore;

			;

} break;
case 1314: /* parameter_type_list : nested_type_on parameter_list ',' '...' nested_type_off .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 273; {
/* line 8327 "mpcPars.lalr" */

			    yySynAttribute.parameter_type_list.Tree = mMPC_Ellipsis(yyAttrStackPtr [4-1].Scan.Position,
					yyAttrStackPtr [2-1].parameter_list.Tree, yyAttrStackPtr [2-1].parameter_list.Tree
				   );
			    yySynAttribute.parameter_type_list.Tree = ReverseTree(yySynAttribute.parameter_type_list.Tree);
			    yySynAttribute.parameter_type_list.Tree->MPC_Ellipsis.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			    yySynAttribute.parameter_type_list.Tree->MPC_Ellipsis.EndPos.Column += 2;  
			  ;

			  yySynAttribute.parameter_type_list.Length = yyAttrStackPtr [2-1].parameter_list.Length + 1;

			  yySynAttribute.parameter_type_list.Ignore  =  yyAttrStackPtr [2-1].parameter_list.Ignore;

			;

} break;
case 1315: /* parameter_list : parameter_declaration .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 272; {
/* line 8342 "mpcPars.lalr" */

			    yySynAttribute.parameter_list.Tree = yyAttrStackPtr [1-1].parameter_declaration.Tree;
			    yySynAttribute.parameter_list.Tree->MPC_Decls.Next =
				yySynAttribute.parameter_list.Tree->MPC_Decls.Prev = mMPC_FreeNode(NoTree);
			    if(Opened_PrototypeScope) {  
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      Scope_Depth--;
			      if(yyAttrStackPtr [1-1].parameter_declaration.WithIdent && !IgnoreAll)
				
				Add_Ident(yySynAttribute.parameter_list.Tree->MPC_VarDecl.Var->MPC_Var.Ident,
					  IDENT, yySynAttribute.parameter_list.Tree->MPC_VarDecl.Var);
			      IgnoreAll = false;
			    }
			  ;

			  yySynAttribute.parameter_list.Length = 1;

			  yySynAttribute.parameter_list.Ignore  =  yyAttrStackPtr [1-1].parameter_declaration.Ignore;

			;

} break;
case 1316: /* parameter_list : parameter_list ',' parameter_declaration .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 272; {
/* line 8364 "mpcPars.lalr" */

			    yySynAttribute.parameter_list.Tree = yyAttrStackPtr [3-1].parameter_declaration.Tree;
			    yySynAttribute.parameter_list.Tree->MPC_Decls.Next =
				yySynAttribute.parameter_list.Tree->MPC_Decls.Prev = yyAttrStackPtr [1-1].parameter_list.Tree;
			    if(Opened_PrototypeScope) {  
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      Scope_Depth--;
			      if(yyAttrStackPtr [3-1].parameter_declaration.WithIdent && !IgnoreAll)
				
				Add_Ident(yySynAttribute.parameter_list.Tree->MPC_VarDecl.Var->MPC_Var.Ident,
					  IDENT, yySynAttribute.parameter_list.Tree->MPC_VarDecl.Var);
			      IgnoreAll = false;
			    }
			  ;

			  yySynAttribute.parameter_list.Length = yyAttrStackPtr [1-1].parameter_list.Length + 1;

			  yySynAttribute.parameter_list.Ignore = yyAttrStackPtr [1-1].parameter_list.Ignore && yyAttrStackPtr [3-1].parameter_declaration.Ignore;

			;

} break;
case 1317: /* parameter_declaration : declaration_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 274; {
/* line 8386 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
				 
			    }
			    Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type(), NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].declaration_specifier.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1318: /* parameter_declaration : declaration_specifier abstract_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 274; {
/* line 8419 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore || yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
				 
			    }
			    Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].declaration_specifier.Ignore
						), Make_Type() , NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1319: /* parameter_declaration : declaration_specifier declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 274; {
/* line 8453 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER && Class!=TYPEDEF) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
				 
			    }
			    if(Class==TYPEDEF) {
			      Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			      yySynAttribute.parameter_declaration.Tree = mMPC_Typedef(yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree, NoTree,  
					NoTypeFlag, yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				     );
			      Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT, yySynAttribute.parameter_declaration.Tree);
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag = yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Ignore |= yySynAttribute.parameter_declaration.Ignore;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			    else {
			      NestedType_ON();
			      Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			      tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].declaration_specifier.Ignore
						), Make_Type() , NoTree
					   )
				  );
			      NestedType_OFF(); 
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  

			      Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						NoTree 
					   )
				 );
			      (void)Clean_OutAttributes(yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var);
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			    } 
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = true;

			;

} break;
case 1320: /* parameter_declaration : declaration_qualifier_list .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 274; {
/* line 8522 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
				 
			    }
			    Push_Pattern(tmp = CopyTree(IntType));
			    tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    tmp->MPC_Type.Flag.Volatile =yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type(), NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].declaration_qualifier_list.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1321: /* parameter_declaration : declaration_qualifier_list abstract_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 274; {
/* line 8558 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore ||
				     yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
				 
			    }
			    Push_Pattern(tmp = CopyTree(IntType));
			    tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    tmp->MPC_Type.Flag.Volatile =yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1322: /* parameter_declaration : declaration_qualifier_list declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 274; {
/* line 8595 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER && Class!=TYPEDEF) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
				 
			    }
			    if(Class==TYPEDEF) {
			      Push_Pattern(tmp = CopyTree(IntType));
			      tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			      tmp->MPC_Type.Flag.Volatile =
					yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			      tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			      yySynAttribute.parameter_declaration.Tree = mMPC_Typedef(yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree, NoTree,
					NoTypeFlag, yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				     );
			      Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT, yySynAttribute.parameter_declaration.Tree);
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag = yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Ignore |= yySynAttribute.parameter_declaration.Ignore;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			    else {
			      NestedType_ON();
			      Push_Pattern(tmp = CopyTree(IntType));
			      tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			      tmp->MPC_Type.Flag.Volatile =
					yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			      tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			      tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			      NestedType_OFF(); 

			      Push_Pattern(yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.DeclSpecifier);
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						NoTree 
					   )
				 );
			      (void)Clean_OutAttributes(yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var);
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = true;

			;

} break;
case 1323: /* parameter_declaration : type_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 274; {
/* line 8671 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_specifier.Position, NoTree);
				 
			    }
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type(), NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].type_specifier.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1324: /* parameter_declaration : type_specifier abstract_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 274; {
/* line 8704 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore || yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_specifier.Position, NoTree);
				 
			    }
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1325: /* parameter_declaration : type_specifier declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 274; {
/* line 8737 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER && Class!=TYPEDEF) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_specifier.Position, NoTree);
				 
			    }
			    if(Class==TYPEDEF) {
			      Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			      yySynAttribute.parameter_declaration.Tree = mMPC_Typedef(yyAttrStackPtr [1-1].type_specifier.Position, NoTree, NoTree,  
					NoTypeFlag, yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				     );
			      Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT, yySynAttribute.parameter_declaration.Tree);
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag = yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Ignore |= yySynAttribute.parameter_declaration.Ignore;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			    else {
			      NestedType_ON();
			      Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			      tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			      NestedType_OFF(); 

			      Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						NoTree 
					   )
				 );
			      (void)Clean_OutAttributes(yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var);
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = true;

			;

} break;
case 1326: /* parameter_declaration : type_qualifier_list .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 274; {
/* line 8805 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree);
				 
			    }
			    Push_Pattern(tmp = CopyTree(IntType));
			    tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    tmp->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type(), NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].type_qualifier_list.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1327: /* parameter_declaration : type_qualifier_list abstract_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 274; {
/* line 8841 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
				     yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree);
				 
			    }
			    Push_Pattern(tmp = CopyTree(IntType));
			    tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    tmp->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1328: /* parameter_declaration : type_qualifier_list declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 274; {
/* line 8878 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER && Class!=TYPEDEF) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree);
				 
			    }
			    if(Class==TYPEDEF) {
			      Push_Pattern(tmp = CopyTree(IntType));
			      tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			      tmp->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			      tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			      yySynAttribute.parameter_declaration.Tree = mMPC_Typedef(yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree, NoTree,  
					NoTypeFlag, yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				     );
			      Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT, yySynAttribute.parameter_declaration.Tree);
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag = yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Local = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Ignore |= yySynAttribute.parameter_declaration.Ignore;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			    else {
			      NestedType_ON();
			      Push_Pattern(tmp = CopyTree(IntType));
			      tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			      tmp->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			      tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			      tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			      NestedType_OFF(); 

			      Push_Pattern(yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.DeclSpecifier);
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						NoTree 
					   )
				 );
			      (void)Clean_OutAttributes(yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var);
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = true;

			;

} break;
case 1329: /* identifier_list : IDENTIFIER .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 276; {
/* line 8952 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.identifier_list.Tree = mMPC_VarDecl(yySynAttribute.identifier_list.Position=yyAttrStackPtr [1-1].Scan.Position,
					tmp, tmp, AUTO, NoDeclFlag, IntType, NoTree
				   );
			    tmp = mMPC_FreeNode(yySynAttribute.identifier_list.Tree);
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var =
				   mMPC_Var(yySynAttribute.identifier_list.Position,
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, NoDeclFlag,
					tmp, tmp, IntType,
					NO_NET, NoTree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var);
			    Add_Ident(yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, IDENT, yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var);
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.Parameter = YES;
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.Ignore = yySynAttribute.identifier_list.Ignore =
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.identifier_list.Length = 1;

			;

} break;
case 1330: /* identifier_list : identifier_list ',' IDENTIFIER .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 276; {
/* line 8980 "mpcPars.lalr" */

			    tTree tmp;
			    yySynAttribute.identifier_list.Tree = mMPC_VarDecl(yyAttrStackPtr [1-1].identifier_list.Position,
					yyAttrStackPtr [1-1].identifier_list.Tree,
					yyAttrStackPtr [1-1].identifier_list.Tree,
					AUTO, NoDeclFlag, IntType, NoTree
				   );
			    yySynAttribute.identifier_list.Position=yyAttrStackPtr [3-1].Scan.Position;
			    tmp = mMPC_FreeNode(yySynAttribute.identifier_list.Tree);
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.EndPos.Column += yyAttrStackPtr [3-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var =
				   mMPC_Var(yySynAttribute.identifier_list.Position,
					yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ident, NoDeclFlag,
					tmp, tmp, IntType,
					NO_NET, NoTree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var);
			    Add_Ident(yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ident, IDENT, yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var);
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.Parameter = YES;
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos.Column += yyAttrStackPtr [3-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.Ignore = yySynAttribute.identifier_list.Ignore =
					yyAttrStackPtr [1-1].identifier_list.Ignore && yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.identifier_list.Length = yyAttrStackPtr [1-1].identifier_list.Length + 1;

			;

} break;
case 1331: /* type_name : type_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 160; {
/* line 9010 "mpcPars.lalr" */

			    Try_ExprScopeBegin();
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			 
			    yySynAttribute.type_name.Type = Make_Type();
			  ;

			  yySynAttribute.type_name.Ignore  =  yyAttrStackPtr [1-1].type_specifier.Ignore;

			;

} break;
case 1332: /* type_name : type_specifier abstract_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 160; {
/* line 9021 "mpcPars.lalr" */

			    Try_ExprScopeBegin();
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			 
			    yySynAttribute.type_name.Type = Make_Type();
			  ;

			    yySynAttribute.type_name.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore ||
					yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			  ;

			;

} break;
case 1333: /* type_name : type_qualifier_list .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 160; {
/* line 9034 "mpcPars.lalr" */

			    Push_Pattern(
				mMPC_BasicType(yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree, NoTree,
					Make_TypeFlag(yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl, NO,
						NO, NO, NO,
						NO, YES, NO
					), INT
				)
			    );
			    yySynAttribute.type_name.Type = Make_Type();
			  ;

			  yySynAttribute.type_name.Ignore  =  yyAttrStackPtr [1-1].type_qualifier_list.Ignore;

			;

} break;
case 1334: /* type_name : type_qualifier_list abstract_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 160; {
/* line 9052 "mpcPars.lalr" */

			    Try_ExprScopeBegin();
			    Push_Pattern(
				mMPC_BasicType(yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree, NoTree,
					Make_TypeFlag(yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl, NO,
						NO, NO, NO,
						NO, YES, NO
					), INT
				)
			    );
			    yySynAttribute.type_name.Type = Make_Type();
			  ;

			    yySynAttribute.type_name.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
					yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			  ;

			;

} break;
case 1335: /* initializer_opt : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 248; {
/* line 9073 "mpcPars.lalr" */

			  yySynAttribute.initializer_opt.Tree = NoTree;

			  yySynAttribute.initializer_opt.Position = NoPosition;

			  yySynAttribute.initializer_opt.EndPos = NoPosition;
  
			;

} break;
case 1336: /* initializer_opt : '=' initializer .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 248; {
/* line 9082 "mpcPars.lalr" */

			  yySynAttribute.initializer_opt.Tree  =  yyAttrStackPtr [2-1].initializer.Tree;

			  yySynAttribute.initializer_opt.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			  yySynAttribute.initializer_opt.EndPos  =  yyAttrStackPtr [2-1].initializer.EndPos;
  
			;

} break;
case 1337: /* initializer : '{' initializer_list '}' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 277; {
/* line 9091 "mpcPars.lalr" */
  
			    yySynAttribute.initializer.Tree = mMPC_InitList(
					yySynAttribute.initializer.Position = yyAttrStackPtr [1-1].Scan.Position, NoTree,  
					NoTree, yyAttrStackPtr [2-1].initializer_list.Length,
					ReverseTree(yyAttrStackPtr [2-1].initializer_list.Tree)
				   );
			    yySynAttribute.initializer.Tree->MPC_InitList.List->MPC_Initializer.Prev->
						     MPC_FreeNode.Parent = yySynAttribute.initializer.Tree;
			    yySynAttribute.initializer.Tree->MPC_InitList.EndPos = yySynAttribute.initializer.EndPos =  
					 CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1338: /* initializer : '{' initializer_list ',' '}' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 277; {
/* line 9105 "mpcPars.lalr" */
  
			    yySynAttribute.initializer.Tree = mMPC_InitList(
					yySynAttribute.initializer.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree, yyAttrStackPtr [2-1].initializer_list.Length,
					ReverseTree(yyAttrStackPtr [2-1].initializer_list.Tree)
				   );
			    yySynAttribute.initializer.Tree->MPC_InitList.List->MPC_Initializer.Prev->
						     MPC_FreeNode.Parent = yySynAttribute.initializer.Tree;
			    yySynAttribute.initializer.Tree->MPC_InitList.EndPos = yySynAttribute.initializer.EndPos =  
					 CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1339: /* initializer : assignment_expression .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 277; {
/* line 9119 "mpcPars.lalr" */
  
			    yySynAttribute.initializer.Tree = mMPC_SimpleInit(yyAttrStackPtr [1-1].assignment_expression.Position,
					NoTree, NoTree, yyAttrStackPtr [1-1].assignment_expression.Tree
				   );
			    yySynAttribute.initializer.Tree->MPC_SimpleInit.EndPos = yySynAttribute.initializer.EndPos = yyAttrStackPtr [1-1].assignment_expression.EndPos;  
			  ;

			  yySynAttribute.initializer.Position  =  yyAttrStackPtr [1-1].assignment_expression.Position;

			;

} break;
case 1340: /* initializer_list : initializer .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 278; {
/* line 9130 "mpcPars.lalr" */

			    yySynAttribute.initializer_list.Tree = yyAttrStackPtr [1-1].initializer.Tree;
			    yySynAttribute.initializer_list.Tree->MPC_Initializer.Next =
				  yySynAttribute.initializer_list.Tree->MPC_Initializer.Prev = nMPC_FreeNode();
			  ;

			  yySynAttribute.initializer_list.Length = 1;

			;

} break;
case 1341: /* initializer_list : initializer_list ',' initializer .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 278; {
/* line 9140 "mpcPars.lalr" */

			    yySynAttribute.initializer_list.Tree = yyAttrStackPtr [3-1].initializer.Tree;
			    yySynAttribute.initializer_list.Tree->MPC_Initializer.Next =
				  yySynAttribute.initializer_list.Tree->MPC_Initializer.Prev = yyAttrStackPtr [1-1].initializer_list.Tree;
			  ;

			  yySynAttribute.initializer_list.Length = yyAttrStackPtr [1-1].initializer_list.Length + 1;

			;

} break;
case 1342: /* omp_declaration : OMP_DECL .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 208; {
/* line 9150 "mpcPars.lalr" */

			    if(!yyAttrStackPtr [1-1].Scan.OMP_DECL.Ignore) {
                              yySynAttribute.omp_declaration.EndPos.Line = yyAttrStackPtr [1-1].Scan.Position.Line;
                              yySynAttribute.omp_declaration.EndPos.Column = yyAttrStackPtr [1-1].Scan.Position.Column + strlen(yyAttrStackPtr [1-1].Scan.OMP_DECL.SymForm) - 1;
			    }
			    else
			      yySynAttribute.omp_declaration.EndPos = NoPosition;
                            yySynAttribute.omp_declaration.Tree = mMPC_UncompDecl(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree, yyAttrStackPtr [1-1].Scan.OMP_DECL.SymForm);
                            yySynAttribute.omp_declaration.Tree->MPC_Decls.EndPos = yySynAttribute.omp_declaration.EndPos;
                          ;

                          yySynAttribute.omp_declaration.Ignore  =  yyAttrStackPtr [1-1].Scan.OMP_DECL.Ignore;

                          yySynAttribute.omp_declaration.Position  =  yyAttrStackPtr [1-1].Scan.Position;

                        ;

} break;
case 1343: /* statement : labeled_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9167 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].labeled_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].labeled_statement.Chain;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].labeled_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].labeled_statement.EndPos;
  
			;

} break;
case 1344: /* statement : compound_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9178 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].compound_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].compound_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].compound_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].compound_statement.EndPos;
  
			;

} break;
case 1345: /* statement : expression_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9189 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].expression_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].expression_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].expression_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].expression_statement.EndPos;
  
			;

} break;
case 1346: /* statement : selection_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9200 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].selection_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].selection_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].selection_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].selection_statement.EndPos;
  
			;

} break;
case 1347: /* statement : iteration_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9211 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].iteration_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].iteration_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].iteration_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].iteration_statement.EndPos;
  
			;

} break;
case 1348: /* statement : jump_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9222 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].jump_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].jump_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].jump_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].jump_statement.EndPos;
  
			;

} break;
case 1349: /* statement : recon_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9233 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].recon_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].recon_statement.Chain;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].recon_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].recon_statement.EndPos;
  
			;

} break;
case 1350: /* statement : fan_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9244 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].fan_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].fan_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].fan_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].fan_statement.EndPos;
  
			;

} break;
case 1351: /* statement : omp_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9255 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].omp_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].omp_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].omp_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].omp_statement.EndPos;

                        ;

} break;
case 1352: /* statement : scheme_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 280; {
/* line 9266 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].scheme_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].scheme_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].scheme_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].scheme_statement.EndPos;

			;

} break;
case 1353: /* labeled_statement : general_identifier ':' statement .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 279; {
/* line 9277 "mpcPars.lalr" */

			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [3-1].statement.Tree;
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Next =
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Prev =
				  yySynAttribute.labeled_statement.Chain = mMPC_IdentLabel(yyAttrStackPtr [1-1].general_identifier.Position, NoTree, NoTree,
						yyAttrStackPtr [1-1].general_identifier.Ident
					  );
			    yySynAttribute.labeled_statement.Chain->MPC_IdentLabel.EndPos = yyAttrStackPtr [2-1].Scan.Position;   
			    yySynAttribute.labeled_statement.Chain->MPC_Label.PrevLabel = LabelList;
			    LabelList = yySynAttribute.labeled_statement.Chain;
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [1-1].general_identifier.Ignore || yyAttrStackPtr [3-1].statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [3-1].statement.EndPos;
  
			;

} break;
case 1354: /* labeled_statement : case constant_expression ':' statement .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 279; {
/* line 9294 "mpcPars.lalr" */

			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [4-1].statement.Tree;
			    yyAttrStackPtr [4-1].statement.Chain->MPC_Stats.Next =
			    yyAttrStackPtr [4-1].statement.Chain->MPC_Stats.Prev =
				  yySynAttribute.labeled_statement.Chain = mMPC_CaseLabel(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,
						yyAttrStackPtr [2-1].constant_expression.Value,
						yyAttrStackPtr [2-1].constant_expression.Tree
					  );
			    yySynAttribute.labeled_statement.Chain->MPC_CaseLabel.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore || yyAttrStackPtr [4-1].statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [4-1].statement.EndPos;
  
			;

} break;
case 1355: /* labeled_statement : default ':' statement .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 279; {
/* line 9310 "mpcPars.lalr" */

			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [3-1].statement.Tree;
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Next =
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Prev =
				  yySynAttribute.labeled_statement.Chain = mMPC_Default(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree);
			    yySynAttribute.labeled_statement.Chain->MPC_Default.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [3-1].statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [3-1].statement.EndPos;
  
			;

} break;
case 1356: /* labeled_statement : net_specifier ':' statement .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 279; {
/* line 9323 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_specifier.Position, NoTree);
					 
#endif
			  ; }
			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [3-1].statement.Tree;
			    yySynAttribute.labeled_statement.Chain = yyAttrStackPtr [3-1].statement.Chain;
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [1-1].net_specifier.Ignore || yyAttrStackPtr [3-1].statement.Ignore;
			    if(yySynAttribute.labeled_statement.Tree!=yySynAttribute.labeled_statement.Chain) { 
			      STATS_Warning((624, xxError, yyAttrStackPtr [2-1].Scan.Position, yySynAttribute.labeled_statement.Tree));
					    
			    }
			    if(yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Fan) {
			      
			      yySynAttribute.labeled_statement.Ignore = true;
			      Make_Message(621, xxError, yyAttrStackPtr [1-1].net_specifier.Position,
					   yySynAttribute.labeled_statement.Tree);
					   
			    }
			    if(!yyAttrStackPtr [1-1].net_specifier.Simple || yyAttrStackPtr [1-1].net_specifier.Tree==COMPUTING_SPACE &&
				!(yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Goto ||
				  yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Continue ||
				  yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Break ||
				  yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Return)) {
			      yySynAttribute.labeled_statement.Ignore = true;
			      Make_Message(622, xxError, yyAttrStackPtr [1-1].net_specifier.Position,
					   yySynAttribute.labeled_statement.Tree);
					   
			    }
			    
			    yySynAttribute.labeled_statement.Ignore |= Recurse_DistrLabel(yySynAttribute.labeled_statement.Tree,yyAttrStackPtr [1-1].net_specifier.Tree,
							 yyAttrStackPtr [1-1].net_specifier.Position);
			    
			    yySynAttribute.labeled_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.labeled_statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [3-1].statement.EndPos;
  
			;

} break;
case 1357: /* labeled_statement : subnet_specifier ':' statement .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 279; {
/* line 9368 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].subnet_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].subnet_specifier.Position, NoTree);
					 
#endif
			  ; }
			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [3-1].statement.Tree;
			    yySynAttribute.labeled_statement.Chain = yyAttrStackPtr [3-1].statement.Chain;
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore || yyAttrStackPtr [3-1].statement.Ignore;
			    if(yySynAttribute.labeled_statement.Tree!=yySynAttribute.labeled_statement.Chain) { 
			      STATS_Warning((625, xxError, yyAttrStackPtr [1-1].subnet_specifier.Position, yySynAttribute.labeled_statement.Tree));
					    
			    }
			    if(yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Fan) {
			      
			      yySynAttribute.labeled_statement.Ignore = true;
			      Make_Message(623, xxError,
					   yyAttrStackPtr [1-1].subnet_specifier.Position, yySynAttribute.labeled_statement.Tree);
					   
			    }
			    
			    yySynAttribute.labeled_statement.Ignore |= Recurse_DistrLabel(yySynAttribute.labeled_statement.Tree,yyAttrStackPtr [1-1].subnet_specifier.Tree,
							 yyAttrStackPtr [1-1].subnet_specifier.Position);
			    
			    yySynAttribute.labeled_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.labeled_statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [3-1].statement.EndPos;
  
			;

} break;
case 1358: /* compound_statement : '{' new_scope '}' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 281; {
/* line 9403 "mpcPars.lalr" */
  
			    yySynAttribute.compound_statement.Tree = mMPC_Compound(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree,
					NO, NoTree, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls = mMPC_FreeNode(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats = mMPC_FreeNode(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.EndPos = yySynAttribute.compound_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.compound_statement.Ignore = false;
			    Close_Scope();
			    Scope_Depth--;
			  ;

			;

} break;
case 1359: /* compound_statement : '{' new_scope declaration_list '}' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 281; {
/* line 9420 "mpcPars.lalr" */
  
			    yySynAttribute.compound_statement.Tree = mMPC_Compound(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree,
					NO, NoTree, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls = ReverseTree(yyAttrStackPtr [3-1].declaration_list.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls->MPC_Decls.Prev->
							MPC_FreeNode.Parent = yySynAttribute.compound_statement.Tree;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats = mMPC_FreeNode(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Flag.Ignore = yySynAttribute.compound_statement.Ignore = yyAttrStackPtr [3-1].declaration_list.Ignore;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.EndPos = yySynAttribute.compound_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			    Close_Scope();
			    Scope_Depth--;
			  ;

			;

} break;
case 1360: /* compound_statement : '{' new_scope statement_list '}' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 281; {
/* line 9439 "mpcPars.lalr" */
  
			    yySynAttribute.compound_statement.Tree = mMPC_Compound(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree,
					NO, NoTree, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats = ReverseTree(yyAttrStackPtr [3-1].statement_list.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats->MPC_Stats.Prev->
							MPC_FreeNode.Parent = yySynAttribute.compound_statement.Tree;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls = mMPC_FreeNode(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Flag.Ignore = yySynAttribute.compound_statement.Ignore = yyAttrStackPtr [3-1].statement_list.Ignore;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.EndPos = yySynAttribute.compound_statement.EndPos =   
			    		CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			    Close_Scope();
			    Scope_Depth--;
			  ;

			;

} break;
case 1361: /* compound_statement : '{' new_scope declaration_list statement_list '}' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 281; {
/* line 9458 "mpcPars.lalr" */
  
			    yySynAttribute.compound_statement.Tree = mMPC_Compound(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,
					NoStatFlag, NoTree,
					NO, NoTree, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls = ReverseTree(yyAttrStackPtr [3-1].declaration_list.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls->MPC_Decls.Prev->
							MPC_FreeNode.Parent = yySynAttribute.compound_statement.Tree;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats = ReverseTree(yyAttrStackPtr [4-1].statement_list.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats->MPC_Stats.Prev->
							MPC_FreeNode.Parent = yySynAttribute.compound_statement.Tree;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Flag.Ignore = yySynAttribute.compound_statement.Ignore = yyAttrStackPtr [3-1].declaration_list.Ignore ||
								       yyAttrStackPtr [4-1].statement_list.Ignore;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.EndPos = yySynAttribute.compound_statement.EndPos =   
			    		CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    Close_Scope();
			    Scope_Depth--;
			  ;

			;

} break;
case 1362: /* declaration_list : declaration .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 290; {
/* line 9480 "mpcPars.lalr" */
  
			    tTree last;
			    yySynAttribute.declaration_list.Tree = last = yyAttrStackPtr [1-1].declaration.Tree;
			    while(last->MPC_Decls.Next)
			      last = last->MPC_Decls.Next; 
			    last->MPC_Decls.Next = last->MPC_Decls.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.declaration_list.Ignore = yyAttrStackPtr [1-1].declaration.Ignore;
			    yySynAttribute.declaration_list.EndPos = yyAttrStackPtr [1-1].declaration.EndPos;  
			  ;

			;

} break;
case 1363: /* declaration_list : declaration_list declaration .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 290; {
/* line 9492 "mpcPars.lalr" */

			    tTree last;
			    yySynAttribute.declaration_list.Tree = last = yyAttrStackPtr [2-1].declaration.Tree;
			    while(last->MPC_Decls.Next)
			      last = last->MPC_Decls.Next; 
			    last->MPC_Decls.Next = last->MPC_Decls.Prev = yyAttrStackPtr [1-1].declaration_list.Tree;
			    yySynAttribute.declaration_list.Ignore = yyAttrStackPtr [1-1].declaration_list.Ignore && yyAttrStackPtr [2-1].declaration.Ignore;
			  ;

			  yySynAttribute.declaration_list.EndPos  =  yyAttrStackPtr [2-1].declaration.EndPos;
  
			;

} break;
case 1364: /* statement_list : statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 291; {
/* line 9505 "mpcPars.lalr" */

			    yySynAttribute.statement_list.Tree = yyAttrStackPtr [1-1].statement.Tree;
			    yyAttrStackPtr [1-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [1-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.statement_list.Ignore = yyAttrStackPtr [1-1].statement.Ignore;
			  ;

			;

} break;
case 1365: /* statement_list : statement_list statement .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 291; {
/* line 9514 "mpcPars.lalr" */

			    yySynAttribute.statement_list.Tree = yyAttrStackPtr [2-1].statement.Tree;
			    yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Prev = yyAttrStackPtr [1-1].statement_list.Tree;
			    yySynAttribute.statement_list.Ignore = yyAttrStackPtr [1-1].statement_list.Ignore && yyAttrStackPtr [2-1].statement.Ignore;
			  ;

			;

} break;
case 1366: /* expression_statement : expression_opt ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 282; {
/* line 9523 "mpcPars.lalr" */
  
			    yySynAttribute.expression_statement.Tree = mMPC_ExprStat( (yyAttrStackPtr [1-1].expression_opt.Tree==NoTree )?  
			    		yyAttrStackPtr [2-1].Scan.Position:yyAttrStackPtr [1-1].expression_opt.BegPos ,  
					NoTree, NoTree,
					NoStatFlag, NoTree, yyAttrStackPtr [1-1].expression_opt.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.expression_statement.Tree);
			    yySynAttribute.expression_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.expression_statement.Ignore = yyAttrStackPtr [1-1].expression_opt.Ignore;
			    yySynAttribute.expression_statement.Tree->MPC_ExprStat.EndPos = yySynAttribute.expression_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			;

} break;
case 1367: /* selection_statement : if '(' expression ')' statement .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 283; {
/* line 9537 "mpcPars.lalr" */
  
			    yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.selection_statement.Tree = mMPC_If(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression.Tree,
					ReverseTree(yyAttrStackPtr [5-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.selection_statement.Tree);
			    yySynAttribute.selection_statement.Tree->MPC_If.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.selection_statement.Tree;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.selection_statement.Ignore = yyAttrStackPtr [3-1].expression.Ignore ||
								   yyAttrStackPtr [5-1].statement.Ignore;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.EndPos = yySynAttribute.selection_statement.EndPos = yyAttrStackPtr [5-1].statement.EndPos;  
			  ;

			;

} break;
case 1368: /* selection_statement : if '(' expression ')' statement else statement .*/
  yyStateStackPtr -= 7; yyAttrStackPtr -= 7; yyNonterminal = 283; {
/* line 9553 "mpcPars.lalr" */
  
			    yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yyAttrStackPtr [7-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [7-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.selection_statement.Tree = mMPC_IfElse(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression.Tree,
					ReverseTree(yyAttrStackPtr [5-1].statement.Tree),
					ReverseTree(yyAttrStackPtr [7-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.selection_statement.Tree);
			    yySynAttribute.selection_statement.Tree->MPC_IfElse.Then->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.selection_statement.Tree;
			    yySynAttribute.selection_statement.Tree->MPC_IfElse.Else->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.selection_statement.Tree;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.selection_statement.Ignore = yyAttrStackPtr [3-1].expression.Ignore ||
							  yyAttrStackPtr [5-1].statement.Ignore || yyAttrStackPtr [7-1].statement.Ignore;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.EndPos = yySynAttribute.selection_statement.EndPos = yyAttrStackPtr [7-1].statement.EndPos;  
			  ;

			;

} break;
case 1369: /* selection_statement : switch '(' expression ')' statement .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 283; {
/* line 9573 "mpcPars.lalr" */
  
			    yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.selection_statement.Tree = mMPC_Switch(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression.Tree,
					ReverseTree(yyAttrStackPtr [5-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.selection_statement.Tree);
			    yySynAttribute.selection_statement.Tree->MPC_Switch.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.selection_statement.Tree;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.selection_statement.Ignore = yyAttrStackPtr [3-1].expression.Ignore ||
								   yyAttrStackPtr [5-1].statement.Ignore;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.EndPos = yySynAttribute.selection_statement.EndPos = yyAttrStackPtr [5-1].statement.EndPos;  
			  ;

			;

} break;
case 1370: /* iteration_statement : while '(' expression ')' statement .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 284; {
/* line 9589 "mpcPars.lalr" */
  
			    yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.iteration_statement.Tree = mMPC_While(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression.Tree,
					ReverseTree(yyAttrStackPtr [5-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.iteration_statement.Tree);
			    yySynAttribute.iteration_statement.Tree->MPC_While.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.iteration_statement.Tree;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.iteration_statement.Ignore = yyAttrStackPtr [3-1].expression.Ignore ||
								   yyAttrStackPtr [5-1].statement.Ignore;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.EndPos = yySynAttribute.iteration_statement.EndPos = yyAttrStackPtr [5-1].statement.EndPos;  
			  ;

			;

} break;
case 1371: /* iteration_statement : do statement while '(' expression ')' ';' .*/
  yyStateStackPtr -= 7; yyAttrStackPtr -= 7; yyNonterminal = 284; {
/* line 9605 "mpcPars.lalr" */
  
			    yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.iteration_statement.Tree = mMPC_DoWhile(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree,
					ReverseTree(yyAttrStackPtr [2-1].statement.Tree), yyAttrStackPtr [5-1].expression.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.iteration_statement.Tree);
			    yySynAttribute.iteration_statement.Tree->MPC_DoWhile.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.iteration_statement.Tree;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.iteration_statement.Ignore = yyAttrStackPtr [5-1].expression.Ignore ||
								   yyAttrStackPtr [2-1].statement.Ignore;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.EndPos = yySynAttribute.iteration_statement.EndPos =   
			    		CurrentPosition = yyAttrStackPtr [7-1].Scan.Position;  
			  ;

			;

} break;
case 1372: /* iteration_statement : for '(' expression_opt ';' expression_opt ';' expression_opt ')' statement .*/
  yyStateStackPtr -= 9; yyAttrStackPtr -= 9; yyNonterminal = 284; {
/* line 9622 "mpcPars.lalr" */
  
			    yyAttrStackPtr [9-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [9-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.iteration_statement.Tree = mMPC_For(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression_opt.Tree,
					yyAttrStackPtr [5-1].expression_opt.Tree, yyAttrStackPtr [7-1].expression_opt.Tree,
					ReverseTree(yyAttrStackPtr [9-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.iteration_statement.Tree);
			    yySynAttribute.iteration_statement.Tree->MPC_For.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.iteration_statement.Tree;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.iteration_statement.Ignore = yyAttrStackPtr [3-1].expression_opt.Ignore ||
				  yyAttrStackPtr [5-1].expression_opt.Ignore || yyAttrStackPtr [7-1].expression_opt.Ignore || yyAttrStackPtr [9-1].statement.Ignore;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.EndPos = yySynAttribute.iteration_statement.EndPos = yyAttrStackPtr [9-1].statement.EndPos;  
			  ;

			;

} break;
case 1373: /* jump_statement : goto general_identifier ';' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 285; {
/* line 9639 "mpcPars.lalr" */
  
			    yySynAttribute.jump_statement.Tree = mMPC_Goto(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [2-1].general_identifier.Ident
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.jump_statement.Ignore = yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			   		CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1374: /* jump_statement : continue ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 285; {
/* line 9651 "mpcPars.lalr" */
  
			    yySynAttribute.jump_statement.Tree = mMPC_Continue(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Ignore = false;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			;

} break;
case 1375: /* jump_statement : break ';' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 285; {
/* line 9663 "mpcPars.lalr" */
  
			    yySynAttribute.jump_statement.Tree = mMPC_Break(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Ignore = false;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			;

} break;
case 1376: /* jump_statement : break '?' ';' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 285; {
/* line 9675 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
					 
#endif
			  ; }  
			    yySynAttribute.jump_statement.Tree = mMPC_BreakFan(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Ignore = false;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1377: /* jump_statement : return expression_opt ';' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 285; {
/* line 9695 "mpcPars.lalr" */
  
			    yySynAttribute.jump_statement.Tree = mMPC_Return(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [2-1].expression_opt.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Ignore = yyAttrStackPtr [2-1].expression_opt.Ignore;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1378: /* recon_statement : recon statement .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 286; {
/* line 9707 "mpcPars.lalr" */

			    yySynAttribute.recon_statement.Tree = Make_Epilogue(yyAttrStackPtr [1-1].Scan.Position);
			    yySynAttribute.recon_statement.Tree->MPC_Stat.Next = yySynAttribute.recon_statement.Tree->MPC_Stat.Prev = yyAttrStackPtr [2-1].statement.Tree;
			    yySynAttribute.recon_statement.Chain = yyAttrStackPtr [2-1].statement.Chain;
			    yyAttrStackPtr [2-1].statement.Tree->MPC_Stat.Benchmark = true;
			
			    yySynAttribute.recon_statement.Ignore = yyAttrStackPtr [2-1].statement.Ignore;
			    yySynAttribute.recon_statement.Ignore |= Recurse_DistrLabel(yyAttrStackPtr [2-1].statement.Tree, RECON_NET, yyAttrStackPtr [1-1].Scan.Position);
			  ;

			  yySynAttribute.recon_statement.EndPos  =  yyAttrStackPtr [2-1].statement.EndPos;
  
			;

} break;
case 1379: /* fan_statement : fan subnet_specifier statement .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 287; {
/* line 9721 "mpcPars.lalr" */
  
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.fan_statement.Tree = mMPC_Fan(yyAttrStackPtr [1-1].Scan.Position, NoTree,  
					NoTree, NoStatFlag, yyAttrStackPtr [2-1].subnet_specifier.Tree,
					ReverseTree(yyAttrStackPtr [3-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.fan_statement.Tree);
			    yySynAttribute.fan_statement.Tree->MPC_Fan.Body->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.fan_statement.Tree;
			    yySynAttribute.fan_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.fan_statement.Ignore = yyAttrStackPtr [2-1].subnet_specifier.Ignore ||
								   yyAttrStackPtr [3-1].statement.Ignore;
			    yySynAttribute.fan_statement.Tree->MPC_Stat.EndPos = yySynAttribute.fan_statement.EndPos = yyAttrStackPtr [3-1].statement.EndPos;  
			  ;

			;

} break;
case 1380: /* omp_statement : OMP_STAT .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 288; {
/* line 9737 "mpcPars.lalr" */

			    if(!yyAttrStackPtr [1-1].Scan.OMP_STAT.Ignore) {
                              yySynAttribute.omp_statement.EndPos.Line = yyAttrStackPtr [1-1].Scan.Position.Line;
                              yySynAttribute.omp_statement.EndPos.Column = yyAttrStackPtr [1-1].Scan.Position.Column + strlen(yyAttrStackPtr [1-1].Scan.OMP_STAT.SymForm) - 1;
			    }
			    else
			      yySynAttribute.omp_statement.EndPos = NoPosition;
                            yySynAttribute.omp_statement.Tree = mMPC_UncompStat(
                                        yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,
                                        NoStatFlag, CONST_NET_LIST, yyAttrStackPtr [1-1].Scan.OMP_STAT.SymForm
                                   );
                            yySynAttribute.omp_statement.Tree->MPC_Decls.EndPos = yySynAttribute.omp_statement.EndPos;
                          ;

                          yySynAttribute.omp_statement.Ignore  =  yyAttrStackPtr [1-1].Scan.OMP_STAT.Ignore;

                        ;

} break;
case 1381: /* translation_unit : external_definition .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 138; {
/* line 9755 "mpcPars.lalr" */

			    {
			      tTree last;
			      yySynAttribute.translation_unit.Tree = last = yyAttrStackPtr [1-1].external_definition.Tree;
			      while(last->MPC_Decls.Next)
			        last = last->MPC_Decls.Next; 
			      last->MPC_Decls.Next = last->MPC_Decls.Prev =
							mMPC_FreeNode(TreeRoot);
			    }
			  ;

			  yySynAttribute.translation_unit.Ignore  =  yyAttrStackPtr [1-1].external_definition.Ignore;

			;

} break;
case 1382: /* translation_unit : translation_unit external_definition .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 138; {
/* line 9770 "mpcPars.lalr" */

			    tTree last;
			    yySynAttribute.translation_unit.Tree = last = yyAttrStackPtr [2-1].external_definition.Tree;
			    while(last->MPC_Decls.Next)
			      last = last->MPC_Decls.Next; 
			    last->MPC_Decls.Next = last->MPC_Decls.Prev =
							yyAttrStackPtr [1-1].translation_unit.Tree;
			    yySynAttribute.translation_unit.Ignore = yyAttrStackPtr [1-1].translation_unit.Ignore && yyAttrStackPtr [2-1].external_definition.Ignore;
			  ;

			;

} break;
case 1383: /* external_definition : function_definition .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 292; {
/* line 9782 "mpcPars.lalr" */

			  yySynAttribute.external_definition.Tree  =  yyAttrStackPtr [1-1].function_definition.Tree;

			  yySynAttribute.external_definition.Ignore  =  yyAttrStackPtr [1-1].function_definition.Ignore;

			   
			;

} break;
case 1384: /* external_definition : declaration .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 292; {
/* line 9790 "mpcPars.lalr" */

			  yySynAttribute.external_definition.Tree  =  yyAttrStackPtr [1-1].declaration.Tree;

			  yySynAttribute.external_definition.Ignore  =  yyAttrStackPtr [1-1].declaration.Ignore;

			  
			;

} break;
case 1385: /* function_definition : function_declarator compound_statement .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 293; {
/* line 9798 "mpcPars.lalr" */

			    tTree Type, ParamList;
			    if(Opened_ParameterScope) {
			      Close_Scope();
			      Scope_Depth--;
			      Opened_ParameterScope = false;
			    }
			    if(yyAttrStackPtr [1-1].function_declarator.Ignore) {
			      Type = Default_FunctionType;
			      ParamList = mMPC_FreeNode(NoTree);
			    }
			    else {
			      Check_PrevImplicitDecl(yyAttrStackPtr [1-1].function_declarator.Var);
			      Check_ResultType(yyAttrStackPtr [1-1].function_declarator.Type, yyAttrStackPtr [1-1].function_declarator.Var);
			      Type = yyAttrStackPtr [1-1].function_declarator.Type;
			      ParamList = Original_ParamList; 
			      if(Tree_IsType(Type->MPC_FunctionType.ParamList,kMPC_Decls))
			        Type->MPC_FunctionType.ParamList->MPC_Decls.Prev->
								  MPC_FreeNode.Parent = Type;
			      else if(Type->MPC_FunctionType.ParamList) 
			        Type->MPC_FunctionType.ParamList->MPC_FreeNode.Parent = Type;
			    }
			    yySynAttribute.function_definition.Tree = mMPC_Function(yyAttrStackPtr [1-1].function_declarator.Position,  
					NoTree, NoTree,
				        Type->MPC_FunctionType.Kind, NoDeclFlag, 
					yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Distribution,
					Add_Ident(yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Ident,
					          IDENT, yyAttrStackPtr [1-1].function_declarator.Var),
					Type, ParamList, yyAttrStackPtr [2-1].compound_statement.Tree
				   );
			    while(LabelList) {
			      if(LabelList->MPC_Label.PrevLabel)
				LabelList->MPC_Label.PrevLabel->MPC_Label.NextLabel = LabelList;
			      yySynAttribute.function_definition.Tree->MPC_Function.LabelList = LabelList;
			      LabelList = LabelList->MPC_Label.PrevLabel;
			    }
			    yySynAttribute.function_definition.Tree->MPC_Function.EndPos = yyAttrStackPtr [2-1].compound_statement.EndPos;  
			    yySynAttribute.function_definition.Tree->MPC_Function.Flag.Ignore |=
				  Check_LabelList(yySynAttribute.function_definition.Tree->MPC_Function.LabelList);
			    yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Next =
				yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Prev = mMPC_FreeNode(yySynAttribute.function_definition.Tree);
			    yyAttrStackPtr [2-1].compound_statement.Tree->MPC_Stats.Next =
				yyAttrStackPtr [2-1].compound_statement.Tree->MPC_Stats.Prev = mMPC_FreeNode(yySynAttribute.function_definition.Tree);
			    yyAttrStackPtr [2-1].compound_statement.Tree->MPC_Compound.FunctionBody = YES;
			    if(Tree_IsType(ParamList, kMPC_Decls)) 
			      ParamList->MPC_Decls.Prev->MPC_FreeNode.Parent = yySynAttribute.function_definition.Tree;
			    else if(ParamList)
			      ParamList->MPC_FreeNode.Parent = yySynAttribute.function_definition.Tree;
			    Default_Class = EXTERN;
			    yySynAttribute.function_definition.Tree->MPC_Function.Flag.Exported =
				yySynAttribute.function_definition.Tree->MPC_Function.Name->MPC_Var.Flag.Exported = YES;
			    yySynAttribute.function_definition.Tree->MPC_Function.Flag.Ignore = yySynAttribute.function_definition.Ignore = yyAttrStackPtr [1-1].function_declarator.Ignore
								     || yyAttrStackPtr [2-1].compound_statement.Ignore;
			    if(Scope_Depth>0) 
			      Scope_Depth = 0;

#ifndef __CB_COMPILER__
			    if(DEMO_MODE)
			      WL_Add(yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Ident);
#endif
			  ;

			;

} break;
case 1386: /* function_declarator : declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 294; {
/* line 9862 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					IntType, yyAttrStackPtr [1-1].declarator.Distribution, yyAttrStackPtr [1-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var( yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declarator.Position,  
					yyAttrStackPtr [1-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type,
					yyAttrStackPtr [1-1].declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    if(yyAttrStackPtr [1-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [1-1].declarator.EndPos;  
			  ;

			;

} break;
case 1387: /* function_declarator : declaration_specifier declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 294; {
/* line 9890 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].declaration_specifier.Type,
					yyAttrStackPtr [2-1].declarator.Distribution,yyAttrStackPtr [2-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var( yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_specifier.Position,  
					yyAttrStackPtr [2-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_specifier.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
				 	yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
					
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			  ;

			;

} break;
case 1388: /* function_declarator : type_specifier declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 294; {
/* line 9930 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].type_specifier.Type,
					yyAttrStackPtr [2-1].declarator.Distribution,yyAttrStackPtr [2-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_specifier.Position,  
					yyAttrStackPtr [2-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			  ;

			;

} break;
case 1389: /* function_declarator : declaration_qualifier_list declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 294; {
/* line 9959 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].declarator.Distribution,yyAttrStackPtr [2-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position,  
					yyAttrStackPtr [2-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_qualifier_list.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
					yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
					
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			  ;

			;

} break;
case 1390: /* function_declarator : type_qualifier_list declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 294; {
/* line 10004 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].declarator.Distribution,yyAttrStackPtr [2-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position,  
					yyAttrStackPtr [2-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			  ;

			;

} break;
case 1391: /* function_declarator : old_function_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 294; {
/* line 10038 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(IntType,
					yyAttrStackPtr [1-1].old_function_declarator.Distribution,
					yyAttrStackPtr [1-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].old_function_declarator.Position,  
					yyAttrStackPtr [1-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type,
					yyAttrStackPtr [1-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [1-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [1-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1392: /* function_declarator : declaration_specifier old_function_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 294; {
/* line 10063 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore ||
						 yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].declaration_specifier.Type,
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_specifier.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_specifier.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
					yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
					
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1393: /* function_declarator : type_specifier old_function_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 294; {
/* line 10101 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].type_specifier.Type,
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_specifier.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1394: /* function_declarator : declaration_qualifier_list old_function_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 294; {
/* line 10128 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_qualifier_list.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
					yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
					
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1395: /* function_declarator : type_qualifier_list old_function_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 294; {
/* line 10171 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1396: /* function_declarator : old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 294; {
/* line 10203 "mpcPars.lalr" */

			    Close_Scope(), Scope_Depth--;  
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(IntType,
					yyAttrStackPtr [1-1].old_function_declarator.Distribution,
					yyAttrStackPtr [1-1].old_function_declarator.Position,
					yyAttrStackPtr [4-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].old_function_declarator.Position,  
					yyAttrStackPtr [1-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type,
					yyAttrStackPtr [1-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [1-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [4-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1397: /* function_declarator : declaration_specifier old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 294; {
/* line 10229 "mpcPars.lalr" */

			    Close_Scope(),Scope_Depth--;  
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore ||
						 yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].declaration_specifier.Type,
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					yyAttrStackPtr [5-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_specifier.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_specifier.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
				 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
		
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [5-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1398: /* function_declarator : type_specifier old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 294; {
/* line 10268 "mpcPars.lalr" */

			    Close_Scope(), Scope_Depth--;  
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].type_specifier.Type,
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					yyAttrStackPtr [5-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_specifier.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [5-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1399: /* function_declarator : declaration_qualifier_list old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 294; {
/* line 10296 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Close_Scope(), Scope_Depth--;  
			    Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					yyAttrStackPtr [5-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_qualifier_list.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
				 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
		
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [5-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1400: /* function_declarator : type_qualifier_list old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 294; {
/* line 10340 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Close_Scope(), Scope_Depth--;  
			    Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					yyAttrStackPtr [5-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    (void)Clean_OutAttributes(yySynAttribute.function_declarator.Var);
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [5-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1401: /* declarator : unary_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 247; {
/* line 10373 "mpcPars.lalr" */

			  yySynAttribute.declarator.Ident  =  yyAttrStackPtr [1-1].unary_declarator.Ident;

			  yySynAttribute.declarator.Distribution  =  yyAttrStackPtr [1-1].unary_declarator.Distribution;

			  yySynAttribute.declarator.Ignore  =  yyAttrStackPtr [1-1].unary_declarator.Ignore;

			  yySynAttribute.declarator.Position  =  yyAttrStackPtr [1-1].unary_declarator.Position;

			  yySynAttribute.declarator.EndPos  =  yyAttrStackPtr [1-1].unary_declarator.EndPos;
  
			;

} break;
case 1402: /* declarator : paren_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 247; {
/* line 10386 "mpcPars.lalr" */

			  yySynAttribute.declarator.Ident  =  yyAttrStackPtr [1-1].paren_declarator.Ident;

			  yySynAttribute.declarator.Distribution  =  yyAttrStackPtr [1-1].paren_declarator.Distribution;

			  yySynAttribute.declarator.Ignore  =  yyAttrStackPtr [1-1].paren_declarator.Ignore;

			  yySynAttribute.declarator.Position  =  yyAttrStackPtr [1-1].paren_declarator.Position;

			  yySynAttribute.declarator.EndPos  =  yyAttrStackPtr [1-1].paren_declarator.EndPos;
  
			;

} break;
case 1403: /* unary_declarator : postfix_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 296; {
/* line 10399 "mpcPars.lalr" */

			  yySynAttribute.unary_declarator.Ident  =  yyAttrStackPtr [1-1].postfix_declarator.Ident;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [1-1].postfix_declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = NO;

			  yySynAttribute.unary_declarator.Ignore  =  yyAttrStackPtr [1-1].postfix_declarator.Ignore;

			  yySynAttribute.unary_declarator.Position  =  yyAttrStackPtr [1-1].postfix_declarator.Position;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [1-1].postfix_declarator.EndPos;
  
			;

} break;
case 1404: /* unary_declarator : '*' declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 296; {
/* line 10414 "mpcPars.lalr" */
  
			    yySynAttribute.unary_declarator.Ident = yyAttrStackPtr [2-1].declarator.Ident;
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.unary_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					NoTypeFlag, 1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			  ;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [2-1].declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = YES;

			  yySynAttribute.unary_declarator.Ignore  =  yyAttrStackPtr [2-1].declarator.Ignore;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [2-1].declarator.EndPos;
  
			;

} break;
case 1405: /* unary_declarator : '*' step declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 296; {
/* line 10437 "mpcPars.lalr" */
  
			    yySynAttribute.unary_declarator.Ident = yyAttrStackPtr [3-1].declarator.Ident;
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.unary_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					NoTypeFlag, 1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree;
			  ;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [3-1].declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = YES;

			    yySynAttribute.unary_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].declarator.Ignore;
			  ;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [3-1].declarator.EndPos;
  
			;

} break;
case 1406: /* unary_declarator : '*' type_qualifier_list declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 296; {
/* line 10462 "mpcPars.lalr" */
  
			    yySynAttribute.unary_declarator.Ident = yyAttrStackPtr [3-1].declarator.Ident;
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.unary_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [2-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yyAttrStackPtr [2-1].type_qualifier_list.Ignore),
					1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			  ;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [3-1].declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = YES;

			    yySynAttribute.unary_declarator.Ignore = yyAttrStackPtr [2-1].type_qualifier_list.Ignore || yyAttrStackPtr [3-1].declarator.Ignore;
			  ;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [3-1].declarator.EndPos;
  
			;

} break;
case 1407: /* unary_declarator : '*' step type_qualifier_list declarator .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 296; {
/* line 10492 "mpcPars.lalr" */
  
			    yySynAttribute.unary_declarator.Ident = yyAttrStackPtr [4-1].declarator.Ident;
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.unary_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [3-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yyAttrStackPtr [2-1].step.Ignore ||
						yyAttrStackPtr [3-1].type_qualifier_list.Ignore),
					1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree;
			  ;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [4-1].declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = YES;

			    yySynAttribute.unary_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore ||
					 yyAttrStackPtr [3-1].type_qualifier_list.Ignore ||
							yyAttrStackPtr [4-1].declarator.Ignore;
			  ;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [4-1].declarator.EndPos;
  
			;

} break;
case 1408: /* postfix_declarator : paren_declarator postfixing_abstract_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 298; {
/* line 10525 "mpcPars.lalr" */

			  yySynAttribute.postfix_declarator.Ident  =  yyAttrStackPtr [1-1].paren_declarator.Ident;

			    yySynAttribute.postfix_declarator.Ignore = yyAttrStackPtr [1-1].paren_declarator.Ignore ||
					yyAttrStackPtr [2-1].postfixing_abstract_declarator.Ignore;
			    if(yySynAttribute.postfix_declarator.Ignore)
			      yySynAttribute.postfix_declarator.Distribution = NO_NET;
			    else {
			      tTree type;
			      yySynAttribute.postfix_declarator.Distribution = yyAttrStackPtr [1-1].paren_declarator.Distribution;
			      if((type=TopType())!=NoTree && type->Kind==kMPC_FunctionType) {
			        type->MPC_FunctionType.NetParam = yySynAttribute.postfix_declarator.Distribution;
			        if(yySynAttribute.postfix_declarator.Distribution!=NoTree && yySynAttribute.postfix_declarator.Distribution->Kind==kMPC_Net &&
				   yySynAttribute.postfix_declarator.Distribution->MPC_Net.Topology==PARAMETER) {
				  type->MPC_FunctionType.NetParamType =
					yySynAttribute.postfix_declarator.Distribution->MPC_Net.NetType;
				  Add_Ident(
					yySynAttribute.postfix_declarator.Distribution->MPC_Net.Ident, IDENT, yySynAttribute.postfix_declarator.Distribution
				  );  
				}
			      }
			    }
			  ;

			  yySynAttribute.postfix_declarator.EndPos  =  yyAttrStackPtr [2-1].postfixing_abstract_declarator.EndPos;
  
			  yySynAttribute.postfix_declarator.Position  =  yyAttrStackPtr [1-1].paren_declarator.Position;
  
			;

} break;
case 1409: /* postfix_declarator : '(' unary_declarator close_prototype_scope ')' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 298; {
/* line 10555 "mpcPars.lalr" */

			  yySynAttribute.postfix_declarator.Ident  =  yyAttrStackPtr [2-1].unary_declarator.Ident;

			  yySynAttribute.postfix_declarator.Distribution  =  yyAttrStackPtr [2-1].unary_declarator.Distribution;

			  yySynAttribute.postfix_declarator.Ignore  =  yyAttrStackPtr [2-1].unary_declarator.Ignore;
  
			    yySynAttribute.postfix_declarator.Position = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.postfix_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1410: /* postfix_declarator : '(' unary_declarator close_prototype_scope ')' postfixing_abstract_declarator .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 298; {
/* line 10568 "mpcPars.lalr" */

			  yySynAttribute.postfix_declarator.Ident  =  yyAttrStackPtr [2-1].unary_declarator.Ident;

			    yySynAttribute.postfix_declarator.Ignore = yyAttrStackPtr [2-1].unary_declarator.Ignore ||
					yyAttrStackPtr [5-1].postfixing_abstract_declarator.Ignore;
			    if(yySynAttribute.postfix_declarator.Ignore)
			      yySynAttribute.postfix_declarator.Distribution = NO_NET;
			    else {
			      tTree type;
			      yySynAttribute.postfix_declarator.Distribution = yyAttrStackPtr [2-1].unary_declarator.Distribution;
			      if((type=TopType())!=NoTree && type->Kind==kMPC_FunctionType) {
			        if(!yyAttrStackPtr [2-1].unary_declarator.Pointer)
				  type->MPC_FunctionType.NetParam = yySynAttribute.postfix_declarator.Distribution;
			        if(yySynAttribute.postfix_declarator.Distribution!=NoTree && yySynAttribute.postfix_declarator.Distribution->Kind==kMPC_Net &&
				   yySynAttribute.postfix_declarator.Distribution->MPC_Net.Topology==PARAMETER) {
				  if(!yyAttrStackPtr [2-1].unary_declarator.Pointer)
				    type->MPC_FunctionType.NetParamType =
					yySynAttribute.postfix_declarator.Distribution->MPC_Net.NetType;
				  Add_Ident(
					yySynAttribute.postfix_declarator.Distribution->MPC_Net.Ident, IDENT, yySynAttribute.postfix_declarator.Distribution
				  );  
				}
			      }
			    }
			  ;

			  yySynAttribute.postfix_declarator.EndPos  =  yyAttrStackPtr [5-1].postfixing_abstract_declarator.EndPos;
  
			  yySynAttribute.postfix_declarator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1411: /* postfix_declarator : net_specifier '(' unary_declarator close_prototype_scope ')' postfixing_abstract_declarator .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 298; {
/* line 10600 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_specifier.Position, NoTree);
					 
#endif
			  ; }
			  yySynAttribute.postfix_declarator.Ident  =  yyAttrStackPtr [3-1].unary_declarator.Ident;

			    yySynAttribute.postfix_declarator.Ignore = yyAttrStackPtr [1-1].net_specifier.Ignore || yyAttrStackPtr [3-1].unary_declarator.Ignore ||
					yyAttrStackPtr [6-1].postfixing_abstract_declarator.Ignore;
			    if(yySynAttribute.postfix_declarator.Ignore)
			      yySynAttribute.postfix_declarator.Distribution = NO_NET;
			    else {
			      tTree type, netparam;
			      yySynAttribute.postfix_declarator.Distribution = yyAttrStackPtr [3-1].unary_declarator.Distribution;
			      if((type=TopType())!=NoTree && type->Kind==kMPC_FunctionType) {
			        type->MPC_FunctionType.NetParam = netparam = yyAttrStackPtr [1-1].net_specifier.Tree;
			        if(netparam!=NoTree && netparam->Kind==kMPC_Net &&
				   netparam->MPC_Net.Topology==PARAMETER) {
				  type->MPC_FunctionType.NetParamType =
					netparam->MPC_Net.NetType;
				  Add_Ident(
					netparam->MPC_Net.Ident, IDENT, netparam
				  );  
				}
			      }
			    }
			  ;

			  yySynAttribute.postfix_declarator.EndPos  =  yyAttrStackPtr [6-1].postfixing_abstract_declarator.EndPos;
  
			  yySynAttribute.postfix_declarator.Position  =  yyAttrStackPtr [1-1].net_specifier.Position;
  
			;

} break;
case 1412: /* paren_declarator : net_specifier IDENTIFIER .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 297; {
/* line 10639 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_specifier.Position, NoTree);
					 
#endif
			  ; }
			  yySynAttribute.paren_declarator.Ident  =  yyAttrStackPtr [2-1].Scan.IDENTIFIER.Ident;

			  yySynAttribute.paren_declarator.Distribution  =  yyAttrStackPtr [1-1].net_specifier.Tree;

			  yySynAttribute.paren_declarator.Ignore = yyAttrStackPtr [1-1].net_specifier.Ignore || yyAttrStackPtr [2-1].Scan.IDENTIFIER.Ignore;
  
			    yySynAttribute.paren_declarator.Position = yyAttrStackPtr [1-1].net_specifier.Position;  
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos.Column += yyAttrStackPtr [2-1].Scan.IDENTIFIER.Length - 1 ;  
			  ;

			;

} break;
case 1413: /* paren_declarator : subnet_specifier IDENTIFIER .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 297; {
/* line 10663 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].subnet_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].subnet_specifier.Position, NoTree);
					 
#endif
			  ; }
			  yySynAttribute.paren_declarator.Ident  =  yyAttrStackPtr [2-1].Scan.IDENTIFIER.Ident;

			  yySynAttribute.paren_declarator.Distribution  =  yyAttrStackPtr [1-1].subnet_specifier.Tree;

			  yySynAttribute.paren_declarator.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore || yyAttrStackPtr [2-1].Scan.IDENTIFIER.Ignore;
  
			    yySynAttribute.paren_declarator.Position = yyAttrStackPtr [1-1].subnet_specifier.Position;  
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos.Column += yyAttrStackPtr [2-1].Scan.IDENTIFIER.Length - 1 ;  
			  ;

			;

} break;
case 1414: /* paren_declarator : IDENTIFIER .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 297; {
/* line 10687 "mpcPars.lalr" */

			  yySynAttribute.paren_declarator.Ident  =  yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident;

			  yySynAttribute.paren_declarator.Distribution = NO_NET;

			  yySynAttribute.paren_declarator.Ignore = false;

			    yySynAttribute.paren_declarator.Position = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;
			    yySynAttribute.paren_declarator.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			  ;

			;

} break;
case 1415: /* paren_declarator : '(' paren_declarator ')' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 297; {
/* line 10701 "mpcPars.lalr" */

			  yySynAttribute.paren_declarator.Ident  =  yyAttrStackPtr [2-1].paren_declarator.Ident;

			  yySynAttribute.paren_declarator.Distribution  =  yyAttrStackPtr [2-1].paren_declarator.Distribution;

			  yySynAttribute.paren_declarator.Ignore  =  yyAttrStackPtr [2-1].paren_declarator.Ignore;
  
			    yySynAttribute.paren_declarator.Position = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos = CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1416: /* net_specifier : '[' host ']' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 212; {
/* line 10714 "mpcPars.lalr" */
 yySynAttribute.net_specifier.Tree = TreeRoot->MPC_Root.Host; ;

			  yySynAttribute.net_specifier.Simple = true;

			  yySynAttribute.net_specifier.Ignore = false;

			  yySynAttribute.net_specifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1417: /* net_specifier : '[*]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 212; {
/* line 10724 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].Scan.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].Scan.Position, NoTree);
					 
#endif
			  ; } yySynAttribute.net_specifier.Tree = TreeRoot->MPC_Root.ComputingSpace; ;

			  yySynAttribute.net_specifier.Simple = true;

			  yySynAttribute.net_specifier.Ignore = false;

			  yySynAttribute.net_specifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;

			;

} break;
case 1418: /* net_specifier : net_name_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 212; {
/* line 10743 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_name_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_name_specifier.Position, NoTree);
					 
#endif
			  ; }
			  yySynAttribute.net_specifier.Tree  =  yyAttrStackPtr [1-1].net_name_specifier.Tree;

			  yySynAttribute.net_specifier.Simple  =  yyAttrStackPtr [1-1].net_name_specifier.Simple;

			  yySynAttribute.net_specifier.Ignore  =  yyAttrStackPtr [1-1].net_name_specifier.Ignore;

			  yySynAttribute.net_specifier.Position  =  yyAttrStackPtr [1-1].net_name_specifier.Position;

			;

} break;
case 1419: /* net_name_specifier : '[' NETorSUBNETname ']' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 146; {
/* line 10763 "mpcPars.lalr" */

			    yySynAttribute.net_name_specifier.Ignore = yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ignore;
			    if(!yySynAttribute.net_name_specifier.Ignore) {
			      if(!(yySynAttribute.net_name_specifier.Tree=Find_Ident(yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident,IDENT)))
				Make_MessageI(103, xxError,
					yyAttrStackPtr [2-1].Scan.Position, xxIdent,
					(char *) & yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident, NoTree
					
				), yySynAttribute.net_name_specifier.Ignore = true;
			    }
			    else
			      yySynAttribute.net_name_specifier.Tree = ErrorNet; 
			  ;

			  yySynAttribute.net_name_specifier.Simple = true;

			  yySynAttribute.net_name_specifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1420: /* net_name_specifier : '[' net_type_specifier ']' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 146; {
/* line 10783 "mpcPars.lalr" */
  
			    yySynAttribute.net_name_specifier.Ignore = yyAttrStackPtr [2-1].net_type_specifier.Ignore;
			    if(yySynAttribute.net_name_specifier.Ignore) {
                              yySynAttribute.net_name_specifier.Tree = ErrorNet;
                              yySynAttribute.net_name_specifier.Position = yyAttrStackPtr [1-1].Scan.Position;
                            }
                            else {
			      tTree tmp;
			      tmp = nMPC_FreeNode();
			      yySynAttribute.net_name_specifier.Tree = mMPC_Net(
					  yySynAttribute.net_name_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					  NoIdent, PRAGMA_BIG,
					  SINGLE_NODE, tmp, tmp, PARAMETER,
					  yyAttrStackPtr [2-1].net_type_specifier.Tree
				     );
			      Clean_OutAttributes(yySynAttribute.net_name_specifier.Tree);
			      yySynAttribute.net_name_specifier.Tree->MPC_Net.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    }
			  ;

			  yySynAttribute.net_name_specifier.Simple = false;

			;

} break;
case 1421: /* net_name_specifier : '[' net_type_specifier general_identifier ']' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 146; {
/* line 10807 "mpcPars.lalr" */
  
			    yySynAttribute.net_name_specifier.Ignore = yyAttrStackPtr [2-1].net_type_specifier.Ignore || yyAttrStackPtr [3-1].general_identifier.Ignore;
			    if(yySynAttribute.net_name_specifier.Ignore) {
                              yySynAttribute.net_name_specifier.Tree = ErrorNet;
                              yySynAttribute.net_name_specifier.Position = yyAttrStackPtr [1-1].Scan.Position;
                            }
                            else {
			      tTree tmp;
			      tmp = nMPC_FreeNode();
			      yySynAttribute.net_name_specifier.Tree = mMPC_Net(
					  yySynAttribute.net_name_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					  yyAttrStackPtr [3-1].general_identifier.Ident, PRAGMA_BIG,
					  SINGLE_NODE, tmp, tmp, PARAMETER,
					  yyAttrStackPtr [2-1].net_type_specifier.Tree
				     );
			      Clean_OutAttributes(yySynAttribute.net_name_specifier.Tree);
			      yySynAttribute.net_name_specifier.Tree->MPC_Net.SingleNode = false;
			      yySynAttribute.net_name_specifier.Tree->MPC_Net.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			    }
			  ;

			  yySynAttribute.net_name_specifier.Simple = false;

			;

} break;
case 1422: /* general_identifier : IDENTIFIER .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 211; {
/* line 10832 "mpcPars.lalr" */

			  yySynAttribute.general_identifier.Ident  =  yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident;

			  yySynAttribute.general_identifier.Ignore  =  yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;

			  yySynAttribute.general_identifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			     yySynAttribute.general_identifier.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			     yySynAttribute.general_identifier.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			     ;
  
			;

} break;
case 1423: /* general_identifier : NETorSUBNETname .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 211; {
/* line 10845 "mpcPars.lalr" */

			  yySynAttribute.general_identifier.Ident  =  yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Ident;

			  yySynAttribute.general_identifier.Ignore  =  yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Ignore;

			  yySynAttribute.general_identifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			     yySynAttribute.general_identifier.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			     yySynAttribute.general_identifier.EndPos.Column += yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Length - 1 ;  
			     ;
  
			;

} break;
case 1424: /* general_identifier : TYPEDEFname .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 211; {
/* line 10858 "mpcPars.lalr" */

			  yySynAttribute.general_identifier.Ident  =  yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ident;

			  yySynAttribute.general_identifier.Ignore  =  yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ignore;

			  yySynAttribute.general_identifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			    yySynAttribute.general_identifier.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.general_identifier.EndPos.Column += yyAttrStackPtr [1-1].Scan.TYPEDEFname.Length - 1 ;  
			    ;
  
			;

} break;
case 1425: /* old_function_declarator : postfix_old_function_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 295; {
/* line 10871 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.Ignore;

			  yySynAttribute.old_function_declarator.Position  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.Position;

			  yySynAttribute.old_function_declarator.EndPos  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.EndPos;
  
			;

} break;
case 1426: /* old_function_declarator : '*' old_function_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 295; {
/* line 10884 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [2-1].old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [2-1].old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore  =  yyAttrStackPtr [2-1].old_function_declarator.Ignore;
  
			    yySynAttribute.old_function_declarator.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.old_function_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					NoTypeFlag, 1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			  ;

			;

} break;
case 1427: /* old_function_declarator : '*' step old_function_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 295; {
/* line 10905 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [3-1].old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [3-1].old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].old_function_declarator.Ignore;
  
			    yySynAttribute.old_function_declarator.EndPos = yyAttrStackPtr [3-1].old_function_declarator.EndPos;  
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.old_function_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					NoTypeFlag, 1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree;
			    TopType()->MPC_Type.Flag.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			  ;

			;

} break;
case 1428: /* old_function_declarator : '*' type_qualifier_list old_function_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 295; {
/* line 10927 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [3-1].old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [3-1].old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore = yyAttrStackPtr [2-1].type_qualifier_list.Ignore || yyAttrStackPtr [3-1].old_function_declarator.Ignore;
  
			    yySynAttribute.old_function_declarator.EndPos = yyAttrStackPtr [3-1].old_function_declarator.EndPos;  
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.old_function_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [2-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yyAttrStackPtr [2-1].type_qualifier_list.Ignore),
					1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			  ;

			;

} break;
case 1429: /* old_function_declarator : '*' step type_qualifier_list old_function_declarator .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 295; {
/* line 10954 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [4-1].old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [4-1].old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].type_qualifier_list.Ignore ||
				    yyAttrStackPtr [4-1].old_function_declarator.Ignore;
  
			    yySynAttribute.old_function_declarator.EndPos = yyAttrStackPtr [4-1].old_function_declarator.EndPos;  
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.old_function_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [3-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yyAttrStackPtr [2-1].step.Ignore ||
						yyAttrStackPtr [3-1].type_qualifier_list.Ignore),
					1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree;
			  ;

			;

} break;
case 1430: /* postfix_old_function_declarator : paren_declarator '(' new_scope identifier_list ')' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 302; {
/* line 10983 "mpcPars.lalr" */

			  yySynAttribute.postfix_old_function_declarator.Ident  =  yyAttrStackPtr [1-1].paren_declarator.Ident;

			  yySynAttribute.postfix_old_function_declarator.Distribution  =  yyAttrStackPtr [1-1].paren_declarator.Distribution;

			  yySynAttribute.postfix_old_function_declarator.Ignore = yyAttrStackPtr [1-1].paren_declarator.Ignore || yyAttrStackPtr [4-1].identifier_list.Ignore;
  
			    Opened_PrototypeScope = false; 
			    Push_Pattern(
			      mMPC_FunctionType(yySynAttribute.postfix_old_function_declarator.Position=yyAttrStackPtr [1-1].paren_declarator.Position,  
				NoTree, NoTree, NoTypeFlag,
				yyAttrStackPtr [4-1].identifier_list.Length, UNDEFINED, NoTree,
				NoTree, NoTree,
				nMPC_FreeNode(),
				ReverseTree(yyAttrStackPtr [4-1].identifier_list.Tree)
			      )
			    );
			    TopType()->MPC_FunctionType.Flag.Native = NativeMode;
			    
				 yySynAttribute.postfix_old_function_declarator.EndPos = CurrentPosition=yyAttrStackPtr [5-1].Scan.Position  
			  ;

			;

} break;
case 1431: /* postfix_old_function_declarator : '(' old_function_declarator ')' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 302; {
/* line 11007 "mpcPars.lalr" */

			  yySynAttribute.postfix_old_function_declarator.Ident  =  yyAttrStackPtr [2-1].old_function_declarator.Ident;

			  yySynAttribute.postfix_old_function_declarator.Distribution  =  yyAttrStackPtr [2-1].old_function_declarator.Distribution;

			  yySynAttribute.postfix_old_function_declarator.Ignore  =  yyAttrStackPtr [2-1].old_function_declarator.Ignore;

			  yySynAttribute.postfix_old_function_declarator.Position  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.postfix_old_function_declarator.EndPos  =  yyAttrStackPtr [3-1].Scan.Position;
  
			;

} break;
case 1432: /* postfix_old_function_declarator : '(' old_function_declarator ')' postfixing_abstract_declarator .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 302; {
/* line 11020 "mpcPars.lalr" */

			  yySynAttribute.postfix_old_function_declarator.Ident  =  yyAttrStackPtr [2-1].old_function_declarator.Ident;

			  yySynAttribute.postfix_old_function_declarator.Distribution  =  yyAttrStackPtr [2-1].old_function_declarator.Distribution;

			  yySynAttribute.postfix_old_function_declarator.Ignore = yyAttrStackPtr [2-1].old_function_declarator.Ignore ||
				    yyAttrStackPtr [4-1].postfixing_abstract_declarator.Ignore;

			  yySynAttribute.postfix_old_function_declarator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			  yySynAttribute.postfix_old_function_declarator.EndPos  =  yyAttrStackPtr [4-1].postfixing_abstract_declarator.EndPos;
  
			;

} break;
case 1433: /* abstract_declarator : unary_abstract_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 275; {
/* line 11034 "mpcPars.lalr" */

			  yySynAttribute.abstract_declarator.Ignore  =  yyAttrStackPtr [1-1].unary_abstract_declarator.Ignore;

			  
			  yySynAttribute.abstract_declarator.EndPos  =  yyAttrStackPtr [1-1].unary_abstract_declarator.EndPos;
  
			;

} break;
case 1434: /* abstract_declarator : postfix_abstract_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 275; {
/* line 11042 "mpcPars.lalr" */

			  yySynAttribute.abstract_declarator.Ignore  =  yyAttrStackPtr [1-1].postfix_abstract_declarator.Ignore;

			  
			  yySynAttribute.abstract_declarator.EndPos  =  yyAttrStackPtr [1-1].postfix_abstract_declarator.EndPos;
  
			;

} break;
case 1435: /* abstract_declarator : postfixing_abstract_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 275; {
/* line 11050 "mpcPars.lalr" */

			  yySynAttribute.abstract_declarator.Ignore  =  yyAttrStackPtr [1-1].postfixing_abstract_declarator.Ignore;

			  
			  yySynAttribute.abstract_declarator.EndPos  =  yyAttrStackPtr [1-1].postfixing_abstract_declarator.EndPos;
  
			;

} break;
case 1436: /* postfixing_abstract_declarator : array_abstract_declarator .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 300; {
/* line 11058 "mpcPars.lalr" */

			  yySynAttribute.postfixing_abstract_declarator.Ignore  =  yyAttrStackPtr [1-1].array_abstract_declarator.Ignore;

			  yySynAttribute.postfixing_abstract_declarator.Position  =  yyAttrStackPtr [1-1].array_abstract_declarator.Position;

			  yySynAttribute.postfixing_abstract_declarator.EndPos  =  yyAttrStackPtr [1-1].array_abstract_declarator.EndPos;
  
			;

} break;
case 1437: /* postfixing_abstract_declarator : '(' new_scope open_prototype_scope ')' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 300; {
/* line 11067 "mpcPars.lalr" */

			  yySynAttribute.postfixing_abstract_declarator.Ignore = false;
  
			    Opened_PrototypeScope = true;
			    Is_PrototypeScope = false;
			    Push_Pattern(
			      mMPC_FunctionType( yySynAttribute.postfixing_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
				NoTree, NoTree,
				NoTypeFlag, UNDEFINED, UNDEFINED,
				NoTree, NoTree, NoTree,
				nMPC_FreeNode(),
				nMPC_FreeNode()
			      )
			    );
			    TopType()->MPC_FunctionType.Flag.Native = NativeMode;
			    
				yySynAttribute.postfixing_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1438: /* postfixing_abstract_declarator : '(' new_scope open_prototype_scope parameter_type_list ')' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 300; {
/* line 11088 "mpcPars.lalr" */
  
			    Opened_PrototypeScope = true;
			    Is_PrototypeScope = false;
			    Push_Pattern(
			      mMPC_FunctionType(yySynAttribute.postfixing_abstract_declarator.Position = yyAttrStackPtr [5-1].Scan.Position,  
				NoTree, NoTree,
				NoTypeFlag, yyAttrStackPtr [4-1].parameter_type_list.Length, UNDEFINED,
				NoTree, NoTree, NoTree,
				nMPC_FreeNode(),
				yyAttrStackPtr [4-1].parameter_type_list.Tree
			      )
			    );
			    TopType()->MPC_FunctionType.Flag.Native = NativeMode;
			    
				yySynAttribute.postfixing_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    {
			      tTree Type;
			      Type = TopType();
			      if(Type->MPC_FunctionType.NumberOfComponents==1 &&
				 Type->MPC_FunctionType.ParamList->Kind==kMPC_VarDecl &&
				 Type->MPC_FunctionType.ParamList->
					MPC_VarDecl.DeclSpecifier==VoidType &&
				 Type->MPC_FunctionType.ParamList->
					MPC_VarDecl.Var->Kind==kMPC_FreeNode)
				Type->MPC_FunctionType.NumberOfComponents = 0; 
			    }
			    yySynAttribute.postfixing_abstract_declarator.Ignore = yyAttrStackPtr [4-1].parameter_type_list.Ignore;
			  ;

			;

} break;
case 1439: /* array_abstract_declarator : '[]' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 220; {
/* line 11119 "mpcPars.lalr" */

			  yySynAttribute.array_abstract_declarator.Ignore = false;
  
			    Push_Pattern(
			      mMPC_ArrayType(
				yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
				NoTypeFlag, UNDEFINED ,
				1 , NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			     yySynAttribute.array_abstract_declarator.Position =  
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;  
			  ;

			;

} break;
case 1440: /* array_abstract_declarator : '[' ']' .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 220; {
/* line 11137 "mpcPars.lalr" */

			  yySynAttribute.array_abstract_declarator.Ignore = false;
  
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,  
				NoTypeFlag, UNDEFINED ,
				1 , NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			;

} break;
case 1441: /* array_abstract_declarator : '[' step ']' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 220; {
/* line 11155 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
				NoTree , NoTree ,
				NoTypeFlag, UNDEFINED ,
				yyAttrStackPtr [2-1].step.Value, NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    TopType()->MPC_ArrayType.Flag.ExplStep = YES;
			    TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    TopType()->MPC_ArrayType.DynStep = yyAttrStackPtr [2-1].step.Tree;  
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1442: /* array_abstract_declarator : '[' constant_expression ']' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 220; {
/* line 11175 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.Value<=0 && yyAttrStackPtr [2-1].constant_expression.IsIntConst) {
			      yySynAttribute.array_abstract_declarator.Ignore = true;
			      Make_Message(473, xxError,
					   yyAttrStackPtr [2-1].constant_expression.Position, yyAttrStackPtr [2-1].constant_expression.Tree);
					   
			    }
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
				NoTree , NoTree ,
				NoTypeFlag, yyAttrStackPtr [2-1].constant_expression.Value,
				1 , NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
			      TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    else
			      TopType()->MPC_ArrayType.ArraySize = yyAttrStackPtr [2-1].constant_expression.Tree;
			    TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1443: /* array_abstract_declarator : '[' constant_expression step ']' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 220; {
/* line 11203 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore || yyAttrStackPtr [3-1].step.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.Value<=0 && yyAttrStackPtr [2-1].constant_expression.IsIntConst) {
			      yySynAttribute.array_abstract_declarator.Ignore = true;
			      Make_Message(473, xxError,
					   yyAttrStackPtr [2-1].constant_expression.Position, yyAttrStackPtr [2-1].constant_expression.Tree);
					   
			    }
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
				NoTree , NoTree ,
				NoTypeFlag, yyAttrStackPtr [2-1].constant_expression.Value,
				yyAttrStackPtr [3-1].step.Value, NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    TopType()->MPC_ArrayType.Flag.ExplStep = YES;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
			      TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    else
			      TopType()->MPC_ArrayType.ArraySize = yyAttrStackPtr [2-1].constant_expression.Tree;
			    TopType()->MPC_ArrayType.DynStep = yyAttrStackPtr [3-1].step.Tree;  
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1444: /* array_abstract_declarator : array_abstract_declarator '[' constant_expression ']' .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 220; {
/* line 11232 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [1-1].array_abstract_declarator.Ignore ||
				     yyAttrStackPtr [3-1].constant_expression.Ignore;
			    if(yyAttrStackPtr [3-1].constant_expression.Value<=0 && yyAttrStackPtr [3-1].constant_expression.IsIntConst) {
			      yySynAttribute.array_abstract_declarator.Ignore = true;
			      Make_Message(473, xxError,
					   yyAttrStackPtr [3-1].constant_expression.Position, yyAttrStackPtr [3-1].constant_expression.Tree);
					   
			    }
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].array_abstract_declarator.Position,  
				NoTree , NoTree ,
				NoTypeFlag, yyAttrStackPtr [3-1].constant_expression.Value,
				1 , NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    if(yyAttrStackPtr [3-1].constant_expression.IsIntConst)
			      TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    else
			      TopType()->MPC_ArrayType.ArraySize = yyAttrStackPtr [3-1].constant_expression.Tree;
			    TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1445: /* array_abstract_declarator : array_abstract_declarator '[' constant_expression step ']' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 220; {
/* line 11261 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [1-1].array_abstract_declarator.Ignore ||
				     yyAttrStackPtr [3-1].constant_expression.Ignore || yyAttrStackPtr [4-1].step.Ignore;
			    if(yyAttrStackPtr [3-1].constant_expression.Value<=0 && yyAttrStackPtr [3-1].constant_expression.IsIntConst) {
			      yySynAttribute.array_abstract_declarator.Ignore = true;
			      Make_Message(473, xxError,
					   yyAttrStackPtr [3-1].constant_expression.Position, yyAttrStackPtr [3-1].constant_expression.Tree);
					   
			    }
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].array_abstract_declarator.Position,  
				NoTree , NoTree ,
				NoTypeFlag, yyAttrStackPtr [3-1].constant_expression.Value,
				yyAttrStackPtr [4-1].step.Value, NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    TopType()->MPC_ArrayType.Flag.ExplStep = YES;
			    if(yyAttrStackPtr [3-1].constant_expression.IsIntConst)
			      TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    else
			      TopType()->MPC_ArrayType.ArraySize = yyAttrStackPtr [3-1].constant_expression.Tree;
			    TopType()->MPC_ArrayType.DynStep = yyAttrStackPtr [4-1].step.Tree;  
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			  ;

			;

} break;
case 1446: /* unary_abstract_declarator : '*' .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 303; {
/* line 11291 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = false;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					NoTypeFlag, 1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			  ;

			  
			;

} break;
case 1447: /* unary_abstract_declarator : '*' step .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 303; {
/* line 11307 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					NoTypeFlag, 1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree; 
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [2-1].step.EndPos;  
			  ;

			  
			;

} break;
case 1448: /* unary_abstract_declarator : '*' type_qualifier_list .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 303; {
/* line 11324 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].type_qualifier_list.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [2-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yySynAttribute.unary_abstract_declarator.Ignore),
					1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [2-1].type_qualifier_list.EndPos;  
			  ;

			  
			;

} break;
case 1449: /* unary_abstract_declarator : '*' step type_qualifier_list .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 303; {
/* line 11347 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].type_qualifier_list.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [3-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yySynAttribute.unary_abstract_declarator.Ignore),
					1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree; 
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [3-1].type_qualifier_list.EndPos;  
			  ;

			  
			;

} break;
case 1450: /* unary_abstract_declarator : '*' abstract_declarator .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 303; {
/* line 11370 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = false;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					NoTypeFlag, 1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  
			;

} break;
case 1451: /* unary_abstract_declarator : '*' step abstract_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 303; {
/* line 11386 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					NoTypeFlag, 1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree; 
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [3-1].abstract_declarator.EndPos;  
			  ;

			  
			;

} break;
case 1452: /* unary_abstract_declarator : '*' type_qualifier_list abstract_declarator .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 303; {
/* line 11403 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].type_qualifier_list.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [2-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yySynAttribute.unary_abstract_declarator.Ignore),
					1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [3-1].abstract_declarator.EndPos;  
			  ;

			  
			;

} break;
case 1453: /* unary_abstract_declarator : '*' step type_qualifier_list abstract_declarator .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 303; {
/* line 11426 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].type_qualifier_list.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [3-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yySynAttribute.unary_abstract_declarator.Ignore),
					1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree; 
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [4-1].abstract_declarator.EndPos;  
			  ;

			  
			;

} break;
case 1454: /* postfix_abstract_declarator : '(' unary_abstract_declarator ')' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 304; {
/* line 11449 "mpcPars.lalr" */

			  yySynAttribute.postfix_abstract_declarator.Ignore  =  yyAttrStackPtr [2-1].unary_abstract_declarator.Ignore;

			  
			  yySynAttribute.postfix_abstract_declarator.EndPos  =  yyAttrStackPtr [3-1].Scan.Position;
  
			;

} break;
case 1455: /* postfix_abstract_declarator : '(' postfix_abstract_declarator ')' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 304; {
/* line 11457 "mpcPars.lalr" */

			  yySynAttribute.postfix_abstract_declarator.Ignore  =  yyAttrStackPtr [2-1].postfix_abstract_declarator.Ignore;

			  
			  yySynAttribute.postfix_abstract_declarator.EndPos  =  yyAttrStackPtr [3-1].Scan.Position;
  
			;

} break;
case 1456: /* postfix_abstract_declarator : '(' postfixing_abstract_declarator ')' .*/
  yyStateStackPtr -= 3; yyAttrStackPtr -= 3; yyNonterminal = 304; {
/* line 11465 "mpcPars.lalr" */

			  yySynAttribute.postfix_abstract_declarator.Ignore  =  yyAttrStackPtr [2-1].postfixing_abstract_declarator.Ignore;

			  
			  yySynAttribute.postfix_abstract_declarator.EndPos  =  yyAttrStackPtr [3-1].Scan.Position;
  
			;

} break;
case 1457: /* postfix_abstract_declarator : '(' unary_abstract_declarator ')' postfixing_abstract_declarator .*/
  yyStateStackPtr -= 4; yyAttrStackPtr -= 4; yyNonterminal = 304; {
/* line 11473 "mpcPars.lalr" */

			    yySynAttribute.postfix_abstract_declarator.Ignore = yyAttrStackPtr [2-1].unary_abstract_declarator.Ignore ||
					yyAttrStackPtr [4-1].postfixing_abstract_declarator.Ignore;
			  ;

			  
			  yySynAttribute.postfix_abstract_declarator.EndPos  =  yyAttrStackPtr [4-1].postfixing_abstract_declarator.EndPos;
  
			;

} break;
case 1458: /* step : ':' constant_expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 299; {
/* line 11483 "mpcPars.lalr" */

			    yySynAttribute.step.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst &&
			       yyAttrStackPtr [2-1].constant_expression.Value<=0) {
			      yySynAttribute.step.Ignore = true;
			      yySynAttribute.step.Value = UNDEFINED;
			      Make_Message(474, xxError,
					   yyAttrStackPtr [2-1].constant_expression.Position, yyAttrStackPtr [2-1].constant_expression.Tree);
					   
			    }
			    else {
			      yySynAttribute.step.Value = yyAttrStackPtr [2-1].constant_expression.Value;
			      if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
				yySynAttribute.step.Tree = nMPC_FreeNode();
			      else
				yySynAttribute.step.Tree = yyAttrStackPtr [2-1].constant_expression.Tree;
			    }
			  ;

			  
			  yySynAttribute.step.EndPos  =  yyAttrStackPtr [2-1].constant_expression.EndPos;
  
			;

} break;
case 1459: /* grid_step : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 149; {
/* line 11507 "mpcPars.lalr" */

			  yySynAttribute.grid_step.Tree = NoTree;

			  yySynAttribute.grid_step.IsIntConst = true;

			  yySynAttribute.grid_step.Value = 1;
   
			  yySynAttribute.grid_step.Scope = false;

			  yySynAttribute.grid_step.Ignore = false;

			  yySynAttribute.grid_step.Position = NoPosition;

			;

} break;
case 1460: /* grid_step : ':' expression .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 149; {
/* line 11522 "mpcPars.lalr" */

			  yySynAttribute.grid_step.Tree  =  yyAttrStackPtr [2-1].expression.Tree;

			  yySynAttribute.grid_step.IsIntConst  =  yyAttrStackPtr [2-1].expression.IsIntConst;

			  yySynAttribute.grid_step.Value  =  yyAttrStackPtr [2-1].expression.Value;

			  yySynAttribute.grid_step.Scope  =  yyAttrStackPtr [2-1].expression.Scope;

			  yySynAttribute.grid_step.Ignore  =  yyAttrStackPtr [2-1].expression.Ignore;

			  yySynAttribute.grid_step.Position  =  yyAttrStackPtr [1-1].Scan.Position;

			;

} break;
case 1461: /* new_scope : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 162; {
/* line 11537 "mpcPars.lalr" */
 ;
{  Open_Scope(); Scope_Depth++; Default_Class = AUTO; ; } ;

} break;
case 1462: /* open_prototype_scope : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 305; {
/* line 11540 "mpcPars.lalr" */
 ;
{  Is_PrototypeScope = true; ; } ;

} break;
case 1463: /* close_prototype_scope : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 301; {
/* line 11543 "mpcPars.lalr" */
 ;
{  if(Opened_PrototypeScope){ Close_Scope(); Scope_Depth--;
					      Opened_PrototypeScope = false; } ; } ;

} break;
case 1464: /* nested_type_on : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 159; {
/* line 11547 "mpcPars.lalr" */
 ;
{  NestedType_ON(); ; } ;

} break;
case 1465: /* nested_type_off : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 161; {
/* line 11550 "mpcPars.lalr" */
 ;
{  NestedType_OFF(); ; } ;

} break;
case 1466: /* enable_dyn_array : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 165; {
/* line 11553 "mpcPars.lalr" */
 ;
{  DynArray_Possible++; ; } ;

} break;
case 1467: /* disable_dyn_array : .*/
  yyStateStackPtr -= 0; yyAttrStackPtr -= 0; yyNonterminal = 166; {
/* line 11556 "mpcPars.lalr" */
 ;
{  DynArray_Possible--; ; } ;

} break;
case 1468: /* empty_net_declaring_list : net_declaration_specifier .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 163; {
/* line 11559 "mpcPars.lalr" */

			    tTree tmp;
			    yySynAttribute.empty_net_declaring_list.Tree = mMPC_NetDecl(yyAttrStackPtr [1-1].net_declaration_specifier.Position,
					NoTree, NoTree,
					yySynAttribute.empty_net_declaring_list.Class=yyAttrStackPtr [1-1].net_declaration_specifier.Class, NoDeclFlag,
					yyAttrStackPtr [1-1].net_declaration_specifier.Tree,
					NoTree
				   );
			    yySynAttribute.empty_net_declaring_list.Tree->MPC_NetDecl.Net = mMPC_FreeNode(yySynAttribute.empty_net_declaring_list.Tree);
			    yySynAttribute.empty_net_declaring_list.Tree->MPC_NetDecl.Flag.Exported = yyAttrStackPtr [1-1].net_declaration_specifier.Exported;
			    yySynAttribute.empty_net_declaring_list.Tree->MPC_NetDecl.Flag.Ignore = yySynAttribute.empty_net_declaring_list.Ignore = yyAttrStackPtr [1-1].net_declaration_specifier.Ignore;
			  ;

			;

} break;
case 1469: /* scheme_declaration : scheme '{' scheme_declaring_list '}' ';' .*/
  yyStateStackPtr -= 5; yyAttrStackPtr -= 5; yyNonterminal = 225; {
/* line 11574 "mpcPars.lalr" */

			    yySynAttribute.scheme_declaration.Tree = mMPC_Compound(yyAttrStackPtr [5-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						 NoTree, NO, NoTree,
						 ReverseTree(yyAttrStackPtr [3-1].scheme_declaring_list.Tree)
				   );
			    yySynAttribute.scheme_declaration.Tree->MPC_Compound.Stats->MPC_Stat.Prev->MPC_FreeNode.Parent = yySynAttribute.scheme_declaration.Tree;
			    yySynAttribute.scheme_declaration.Tree->MPC_Compound.Decls = mMPC_FreeNode(yySynAttribute.scheme_declaration.Tree);
			    yySynAttribute.scheme_declaration.Tree = mMPC_Scheme(yyAttrStackPtr [5-1].Scan.Position, yySynAttribute.scheme_declaration.Tree);
			  ;

			  yySynAttribute.scheme_declaration.Ignore = yyAttrStackPtr [1-1].Scan.scheme.Ignore || yyAttrStackPtr [3-1].scheme_declaring_list.Ignore;

			;

} break;
case 1470: /* scheme_declaration : scheme '{' declaration_list scheme_declaring_list '}' ';' .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 225; {
/* line 11588 "mpcPars.lalr" */

			    yySynAttribute.scheme_declaration.Tree = mMPC_Compound(yyAttrStackPtr [6-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						 NoTree, NO,
						 ReverseTree(yyAttrStackPtr [3-1].declaration_list.Tree),
						 ReverseTree(yyAttrStackPtr [4-1].scheme_declaring_list.Tree)
				   );
			    yySynAttribute.scheme_declaration.Tree->MPC_Compound.Stats->MPC_Stat.Prev->MPC_FreeNode.Parent = yySynAttribute.scheme_declaration.Tree;
			    yySynAttribute.scheme_declaration.Tree->MPC_Compound.Decls->MPC_Decls.Prev->MPC_FreeNode.Parent = yySynAttribute.scheme_declaration.Tree;
			    yySynAttribute.scheme_declaration.Tree = mMPC_Scheme(yyAttrStackPtr [6-1].Scan.Position, yySynAttribute.scheme_declaration.Tree);
			  ;

			  yySynAttribute.scheme_declaration.Ignore = yyAttrStackPtr [1-1].Scan.scheme.Ignore || yyAttrStackPtr [4-1].scheme_declaring_list.Ignore;

			;

} break;
case 1471: /* scheme_declaring_list : statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 306; {
/* line 11603 "mpcPars.lalr" */

			    yySynAttribute.scheme_declaring_list.Tree = yyAttrStackPtr [1-1].statement.Tree;
			    yyAttrStackPtr [1-1].statement.Chain->MPC_Stats.Next =
				 yyAttrStackPtr [1-1].statement.Chain->MPC_Stats.Prev = nMPC_FreeNode();
			  ;

			  yySynAttribute.scheme_declaring_list.Ignore  =  yyAttrStackPtr [1-1].statement.Ignore;

			;

} break;
case 1472: /* scheme_declaring_list : scheme_declaring_list statement .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 306; {
/* line 11613 "mpcPars.lalr" */

			    yySynAttribute.scheme_declaring_list.Tree = yyAttrStackPtr [2-1].statement.Tree;
			    yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Next =
				 yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Prev = yyAttrStackPtr [1-1].scheme_declaring_list.Tree;
			  ;

			  yySynAttribute.scheme_declaring_list.Ignore = yyAttrStackPtr [1-1].scheme_declaring_list.Ignore || yyAttrStackPtr [2-1].statement.Ignore;

			;

} break;
case 1473: /* scheme_statement : computation_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 289; {
/* line 11623 "mpcPars.lalr" */

			  yySynAttribute.scheme_statement.Tree  =  yyAttrStackPtr [1-1].computation_statement.Tree;

			  yySynAttribute.scheme_statement.Chain  =  yyAttrStackPtr [1-1].computation_statement.Tree;

			  yySynAttribute.scheme_statement.Ignore  =  yyAttrStackPtr [1-1].computation_statement.Ignore;

			  yySynAttribute.scheme_statement.EndPos  =  yyAttrStackPtr [1-1].computation_statement.EndPos;

			;

} break;
case 1474: /* scheme_statement : communication_statement .*/
  yyStateStackPtr -= 1; yyAttrStackPtr -= 1; yyNonterminal = 289; {
/* line 11634 "mpcPars.lalr" */

			  yySynAttribute.scheme_statement.Tree  =  yyAttrStackPtr [1-1].communication_statement.Tree;

			  yySynAttribute.scheme_statement.Chain  =  yyAttrStackPtr [1-1].communication_statement.Tree;

			  yySynAttribute.scheme_statement.Ignore  =  yyAttrStackPtr [1-1].communication_statement.Ignore;

			  yySynAttribute.scheme_statement.EndPos  =  yyAttrStackPtr [1-1].communication_statement.EndPos;

			;

} break;
case 1475: /* scheme_statement : par statement .*/
  yyStateStackPtr -= 2; yyAttrStackPtr -= 2; yyNonterminal = 289; {
/* line 11645 "mpcPars.lalr" */

			    yySynAttribute.scheme_statement.Tree = yySynAttribute.scheme_statement.Chain = mMPC_ParScheme(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						  SINGLE_NODE_LIST, NoTree, NoTree, NoTree, NoTree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Init = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Cond = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Reinit = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Stats = ReverseTree(yyAttrStackPtr [2-1].statement.Tree);
			  ;

			  yySynAttribute.scheme_statement.Ignore = yyAttrStackPtr [1-1].Scan.par.Ignore || yyAttrStackPtr [2-1].statement.Ignore;

			  yySynAttribute.scheme_statement.EndPos  =  yyAttrStackPtr [2-1].statement.EndPos;

			;

} break;
case 1476: /* scheme_statement : par '(' expression_opt ';' expression_opt ';' expression_opt ')' statement .*/
  yyStateStackPtr -= 9; yyAttrStackPtr -= 9; yyNonterminal = 289; {
/* line 11662 "mpcPars.lalr" */

			    yySynAttribute.scheme_statement.Tree = yySynAttribute.scheme_statement.Chain = mMPC_ParScheme(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						  SINGLE_NODE_LIST, yyAttrStackPtr [3-1].expression_opt.Tree,
						  yyAttrStackPtr [5-1].expression_opt.Tree, yyAttrStackPtr [7-1].expression_opt.Tree, NoTree);
			    yyAttrStackPtr [9-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [9-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Stats = ReverseTree(yyAttrStackPtr [9-1].statement.Tree);
			  ;

			  yySynAttribute.scheme_statement.Ignore = yyAttrStackPtr [1-1].Scan.par.Ignore || yyAttrStackPtr [3-1].expression_opt.Ignore || yyAttrStackPtr [5-1].expression_opt.Ignore ||
				    yyAttrStackPtr [7-1].expression_opt.Ignore || yyAttrStackPtr [9-1].statement.Ignore;

			  yySynAttribute.scheme_statement.EndPos  =  yyAttrStackPtr [9-1].statement.EndPos;

			;

} break;
case 1477: /* computation_statement : expression '%%' '[' constant_expression_list ']' ';' .*/
  yyStateStackPtr -= 6; yyAttrStackPtr -= 6; yyNonterminal = 307; {
/* line 11678 "mpcPars.lalr" */

			    yySynAttribute.computation_statement.Tree = mMPC_CompScheme(yyAttrStackPtr [2-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						   SINGLE_NODE_LIST, yyAttrStackPtr [1-1].expression.Tree,
						   ReverseTree(yyAttrStackPtr [4-1].constant_expression_list.Tree));
			    yySynAttribute.computation_statement.Tree->MPC_CompScheme.Node->MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.computation_statement.Tree;
			  ;

			  yySynAttribute.computation_statement.Ignore = yyAttrStackPtr [1-1].expression.Ignore || yyAttrStackPtr [4-1].constant_expression_list.Ignore;

			  yySynAttribute.computation_statement.EndPos  =  yyAttrStackPtr [6-1].Scan.Position;

			;

} break;
case 1478: /* communication_statement : expression '%%' '[' constant_expression_list ']' '->' '[' constant_expression_list ']' ';' .*/
  yyStateStackPtr -= 10; yyAttrStackPtr -= 10; yyNonterminal = 308; {
/* line 11691 "mpcPars.lalr" */

			    yySynAttribute.communication_statement.Tree = mMPC_CommScheme(yyAttrStackPtr [2-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						   SINGLE_NODE_LIST, yyAttrStackPtr [1-1].expression.Tree,
						   ReverseTree(yyAttrStackPtr [4-1].constant_expression_list.Tree), ReverseTree(yyAttrStackPtr [8-1].constant_expression_list.Tree));
			    yySynAttribute.communication_statement.Tree->MPC_CommScheme.From->MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.communication_statement.Tree;
			    yySynAttribute.communication_statement.Tree->MPC_CommScheme.To->MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.communication_statement.Tree;
			  ;

			  yySynAttribute.communication_statement.Ignore = yyAttrStackPtr [1-1].expression.Ignore || yyAttrStackPtr [4-1].constant_expression_list.Ignore || yyAttrStackPtr [8-1].constant_expression_list.Ignore;

			  yySynAttribute.communication_statement.EndPos  =  yyAttrStackPtr [10-1].Scan.Position;

			;

} break;
}

	       /* SPEC State = Next (Top (), Nonterminal); nonterminal transition */
	       yyState = * (yyNBasePtr [* yyStateStackPtr ++] + yyNonterminal);
	       * yyAttrStackPtr ++ = yySynAttribute;
	       if (yyState < yyFirstFinalState) goto ParseLoop;	/* read reduce ? */
	       yyState = yyFinalToProd [yyState - yyFirstReadReduceState];
	    } 

	 } else {					/* read */
	    yyStateStackPtr ++;
	    yyGetAttribute (yyAttrStackPtr ++, mpcScan_Attribute);
	    yyTerminal = mpcScan_GetToken ();
	    yyIsRepairing = false;
	 }
      }
   }

static void yyErrorRecovery
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange *	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      bool	yyTokensSkipped	;
      tSet	yyContinueSet	;
      tSet	yyRestartSet	;
      int	yyLength = 0	;
      char	yyContinueString [256];

   /* 1. report an error */
      ErrorMessage (xxSyntaxError, xxError, mpcScan_Attribute.Position);

   /* 2. report the set of expected terminal symbols */
      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      yyComputeContinuation (yyStateStack, yyStackSize, yyStackPtr, & yyContinueSet);
      yyContinueString [0] = '\0';
      while (! IsEmpty (& yyContinueSet)) {
	 char * yyTokenString = mpcPars_TokenName [Extract (& yyContinueSet)];
	 if ((yyLength += strlen (yyTokenString) + 1) >= 256) break;
	 (void) strcat (yyContinueString, yyTokenString);
	 (void) strcat (yyContinueString, " ");
      }
      ErrorMessageI (xxExpectedTokens, xxInformation, mpcScan_Attribute.Position,
	 xxString, yyContinueString);
      ReleaseSet (& yyContinueSet);

   /* 3. compute the set of terminal symbols for restart of the parse */
      MakeSet (& yyRestartSet, (short) yyLastTerminal);
      yyComputeRestartPoints (yyStateStack, yyStackSize, yyStackPtr, & yyRestartSet);

   /* 4. skip terminal symbols until a restart point is reached */
      yyTokensSkipped = false;
      while (! IsElement (* yyTerminal, & yyRestartSet)) {
	 * yyTerminal = mpcScan_GetToken ();
	 yyTokensSkipped = true;
      }
      ReleaseSet (& yyRestartSet);

   /* 5. report the restart point */
      if (yyTokensSkipped) {
	 ErrorMessage (xxRestartPoint, xxInformation, mpcScan_Attribute.Position);
      }
   }

/*
   compute the set of terminal symbols that can be accepted (read)
   in a given stack configuration (eventually after reduce actions)
*/

static void yyComputeContinuation
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet)
# else
   (yyStack, yyStackSize, yyStackPtr, yyContinueSet)
   yyStateRange *	yyStack		;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyContinueSet	;
# endif
   {
      register yySymbolRange	yyTerminal;
      register yyStateRange	yyState = yyStack [yyStackPtr];

      AssignEmpty (yyContinueSet);
      for (yyTerminal = yyFirstTerminal; yyTerminal <= yyLastTerminal; yyTerminal ++) {
	 if (yyNext (yyState, yyTerminal) != yyNoState &&
	    yyIsContinuation (yyTerminal, yyStack, yyStackSize, yyStackPtr)) {
	    Include (yyContinueSet, (short) yyTerminal);
	 }
      }
   }

/*
   check whether a given terminal symbol can be accepted (read)
   in a certain stack configuration (eventually after reduce actions)
*/

static bool yyIsContinuation
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));	/* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      yState = yyStack [yyStackPtr];
      for (;;) {
	 yyStack [yyStackPtr] = yState;
	 yState = yyNext (yState, yyTerminal);
	 if (yState == yyNoState) {
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return false;
	 }
	 if (yState <= yyLastReadReduceState) {		/* read or read reduce ? */
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return true;
	 }

	 for (;;) {					/* reduce */
	    if (yState == yyStopState) {
	       ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	       return true;
	    } else { 
	       yyStackPtr -= yyLength [yState - yyFirstReduceState];
	       yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	    }

	    yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	    if (yyStackPtr >= yyStackSize) {
	       ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    }
	    yyStackPtr ++;
	    if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	    yState = yyFinalToProd [yState - yyFirstReadReduceState];	/* read reduce */
	 }
      }
   }

/*
   compute a set of terminal symbols that can be used to restart
   parsing in a given stack configuration. we simulate parsing until
   end of file using a suffix program synthesized by the function
   Continuation. All symbols acceptable in the states reached during
   the simulation can be used to restart parsing.
*/

static void yyComputeRestartPoints
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet)
# else
   (yyStateStack, yyStackSize, yyStackPtr, yyRestartSet)
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyRestartSet	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
	       tSet		yyContinueSet	;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange)); /* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      AssignEmpty (yyRestartSet);
      yState = yyStack [yyStackPtr];

      for (;;) {
	 if (yyStackPtr >= yyStackSize) {
	    ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	 }
	 yyStack [yyStackPtr] = yState;
	 yyComputeContinuation (yyStack, yyStackSize, yyStackPtr, & yyContinueSet);
	 Union (yyRestartSet, & yyContinueSet);
	 yState = yyNext (yState, yyContinuation [yState]);

	 if (yState >= yyFirstFinalState) {		/* final state ? */
	    if (yState <= yyLastReadReduceState) {	/* read reduce ? */
	       yyStackPtr ++;
	       yState = yyFinalToProd [yState - yyFirstReadReduceState];
	    }

	    for (;;) {					/* reduce */
	       if (yState == yyStopState) {
		  ReleaseSet (& yyContinueSet);
		  ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
		  return;
	       } else { 
		  yyStackPtr -= yyLength [yState - yyFirstReduceState];
		  yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	       }

	       yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	       yyStackPtr ++;
	       if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	       yState = yyFinalToProd [yState - yyFirstReadReduceState]; /* read reduce */
	    }
	 } else {					/* read */
	    yyStackPtr ++;
	 }
      }
   }

/* access the parse table:   Next : State x Symbol -> Action */

static yyStateRange yyNext
# if defined __STDC__ | defined __cplusplus
   (yyStateRange yyState, yySymbolRange yySymbol)
# else
   (yyState, yySymbol) yyStateRange yyState; yySymbolRange yySymbol;
# endif
   {
      register yyTCombType * yyTCombPtr;

      if (yySymbol <= yyLastTerminal) {
	 for (;;) {
	    yyTCombPtr = yyTBasePtr [yyState] + yySymbol;
	    if (yyTCombPtr->Check != yyState) {
	       if ((yyState = yyDefault [yyState]) == yyNoState) return yyNoState;
	    } else {
	       return yyTCombPtr->Next;
	    }
	 }
      } else {
	return * (yyNBasePtr [yyState] + yySymbol);
      }
   }

static void BeginmpcPars ()
   {
/* line 412 "mpcPars.lalr" */



  extern int   LinesInFile;
  extern tTree Last_FunctionUndeclared;

  /*Errors_Exit = Print_Messages;  **** call this function when xxFatal-error; */

  FirstPass = true;

  IgnoreAll = false;

  NativeMode = NATIVE_MPC;

  InitIdents();
  Init_TypeTable();
  Init_ScopeStack();
  Init_SubnetTable();
  (void)Make_UniqueNumber(NoTree);

#ifndef __CB_COMPILER__
  if(DEMO_MODE) WL_Init();
#endif

  LabelList = NoTree;
  Original_ParamList = NoTree;
  Last_FunctionUndeclared = NoTree;

  TreeRoot = mMPC_Root (NoTree, NoTree, NoTree,
			Clean_OutAttributes(nMPC_Net()), Clean_OutAttributes(nMPC_Net()),
			Clean_OutAttributes(nMPC_Net()), Clean_OutAttributes(nMPC_Net()), 
			Clean_OutAttributes(nMPC_Net()), Clean_OutAttributes(nMPC_NetList()), 
			Clean_OutAttributes(nMPC_NetList()), Clean_OutAttributes(nMPC_NetList()), 
			Clean_OutAttributes(nMPC_NetList()), Clean_OutAttributes(nMPC_NetList())
	     );
  TreeRoot->MPC_Root.Source = mMPC_FreeNode (TreeRoot);
  TreeRoot->MPC_Root.Messages = mMPC_FreeNode (TreeRoot);
  TreeRoot->MPC_Root.Host->MPC_Net.Ident = MakeIdent(HOST_NAME, strlen(HOST_NAME));
  TreeRoot->MPC_Root.Host->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.Host->MPC_Net.SingleNode = true;
  TreeRoot->MPC_Root.SingleNode->MPC_Net.Ident =
				 MakeIdent(SINGLE_NODE_NAME,strlen(SINGLE_NODE_NAME));
  TreeRoot->MPC_Root.SingleNode->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.SingleNode->MPC_Net.SingleNode = true;
  TreeRoot->MPC_Root.ComputingSpace->MPC_Net.Ident = MakeIdent(ALL_NAME, strlen(ALL_NAME));
  TreeRoot->MPC_Root.ComputingSpace->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.Const->MPC_Net.Ident = MakeIdent(CONST_NET_NAME, strlen(CONST_NET_NAME));
  TreeRoot->MPC_Root.Const->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.Recon->MPC_Net.Ident = MakeIdent(RECON_NAME, strlen(RECON_NAME));
  TreeRoot->MPC_Root.Recon->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.HostList->MPC_NetList.Net = HOST;
  TreeRoot->MPC_Root.HostList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.HostList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);
  TreeRoot->MPC_Root.SingleNodeList->MPC_NetList.Net = SINGLE_NODE;
  TreeRoot->MPC_Root.SingleNodeList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.SingleNodeList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);
  TreeRoot->MPC_Root.ComputingSpaceList->MPC_NetList.Net = COMPUTING_SPACE;
  TreeRoot->MPC_Root.ComputingSpaceList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.ComputingSpaceList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);
  TreeRoot->MPC_Root.ReconList->MPC_NetList.Net = RECON_NET;
  TreeRoot->MPC_Root.ReconList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.ReconList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);
  TreeRoot->MPC_Root.ConstList->MPC_NetList.Net = CONST_NET;
  TreeRoot->MPC_Root.ConstList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.ConstList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);

  ErrorNet = mMPC_Net(NoPosition, MakeIdent(ERROR_NAME, strlen(ERROR_NAME)),
		      false, HOST, NoTree, NoTree, CONST, NoTree);
  ErrorNetList = mMPC_NetList(NoTree, NoTree, ErrorNet);
  ErrorNetList->MPC_NetList.Next = ErrorNetList->MPC_NetList.Prev = nMPC_FreeNode();
  ErrorNetList->MPC_NetList.UnReduceable = true;


  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, VOID));
  VoidType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, CHAR));
  CharType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, INT));
  IntType = Make_Type();

  ConstIntType = CopyTree(IntType);
  ConstIntType->MPC_Type.Flag.Const = YES;
  Push_Pattern(ConstIntType);
  ConstIntType = Make_Type();

  ReplIntType = CopyTree(IntType);
  ReplIntType->MPC_Type.Flag.Repl = YES;
  Push_Pattern(ReplIntType);
  ReplIntType = Make_Type();

  ReplConstIntType = CopyTree(ConstIntType);
  ReplConstIntType->MPC_Type.Flag.Repl = YES;
  Push_Pattern(ReplConstIntType);
  ReplConstIntType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, UNSIGNED));
  UnsignedType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, LONG));
  LongType = Make_Type();

  Push_Pattern(
	mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, UNSIGNED_LONG
	)
  );
  UnsignedLongType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, FLOAT));
  FloatType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, DOUBLE));
  DoubleType = Make_Type();

  ReplConstDoubleType = CopyTree(DoubleType);
  ReplConstDoubleType->MPC_Type.Flag.Repl = YES;
  ReplConstDoubleType->MPC_Type.Flag.Const = YES;
  Push_Pattern(ReplConstDoubleType);
  ReplConstDoubleType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition,NoTree/*Next*/,NoTree/*Prev*/,NoTypeFlag,LONG_DOUBLE));
  LongDoubleType = Make_Type();

	/* 'long long' extensions: */

  Push_Pattern(
    mMPC_Typedef(NoPosition, NoTree, NoTree, NoTypeFlag, MakeIdent("mpC_long_long", 13), LongType)
  );
  LongLongType = Make_Type();
  Push_Pattern(
    mMPC_Typedef(NoPosition, NoTree, NoTree, NoTypeFlag, MakeIdent("mpC_unsigned_long_long", 22), UnsignedLongType)
  );
  UnsignedLongLongType = Make_Type();


  Push_Pattern(mMPC_BasicType(NoPosition,NoTree/*Next*/,NoTree/*Prev*/,NoTypeFlag,NO_TYPE));
  ErrorType = Make_Type();

  Push_Pattern(
	mMPC_FunctionType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag,
		UNDEFINED/*NumberOfComponents*/, NODAL/*Kind*/,
		IntType/*ResultType*/, NoTree/*NetParamType*/, NoTree/*NetParam*/,
		NoTree/*NetworkParamList*/, NoTree/*ParamList*/
	)
  );
  Default_FunctionType = Make_Type();
  Default_FunctionType->MPC_FunctionType.NetworkParamList = mMPC_FreeNode(Default_FunctionType);
  Default_FunctionType->MPC_FunctionType.ParamList = mMPC_FreeNode(Default_FunctionType);
  Default_FunctionType->MPC_FunctionType.Flag.Source = NO;
  Default_FunctionType->MPC_FunctionType.Flag.Nodal = YES;
  Default_FunctionType->MPC_FunctionType.Flag.Native = NativeMode;

  Push_Pattern(
	mMPC_FunctionType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag,
		UNDEFINED/*NumberOfComponents*/, BASIC/*Kind*/,
		IntType/*ResultType*/, NoTree/*NetParamType*/, NoTree/*NetParam*/,
		NoTree/*NetworkParamList*/, NoTree/*ParamList*/
	)
  );
  Barrier_FunctionType = Make_Type();
  Barrier_FunctionType->MPC_FunctionType.NetworkParamList = mMPC_FreeNode(Barrier_FunctionType);
  Barrier_FunctionType->MPC_FunctionType.ParamList = mMPC_FreeNode(Barrier_FunctionType);
  Barrier_FunctionType->MPC_FunctionType.Flag.Source = NO;
  Barrier_FunctionType->MPC_FunctionType.Flag.Network = YES;
  Barrier_FunctionType->MPC_FunctionType.Flag.Native = NativeMode;

  /* Subtree needed for 'coordof'(2) implementation: */
  DummyIdent = NoIdent;


#ifndef __CB_COMPILER__
	/* Patterns for generation of topo-functions: */

  Emit_TopoTypes();

	/* Type "Int" for runtime functions: */

  Push_Pattern(
    mMPC_Typedef(NoPosition, NoTree, NoTree, NoTypeFlag, MakeIdent("Int", 3), IntType)
  );
  MPI_Int_Type = Make_Type();

#endif



   }

void ClosempcPars ()
   {
/* line 600 "mpcPars.lalr" */



  TreeRoot->MPC_Root.Source =
    ReverseTree(TreeRoot->MPC_Root.Source);
  FirstPass = false;



   }
