/* $Id: Scanner.c,v 2.19 1993/08/18 17:28:53 grosch rel $ */

# define bool		char
# define true		1
# define false		0
# define StdIn		0
 
# include "mpcScan.h"

# ifdef __cplusplus
extern "C" {
#    include "mpcScanSource.h"
#    include "rSystem.h"
#    include "General.h"
#    include "DynArray.h"
#    include "Positions.h"
}
# else
#    include "mpcScanSource.h"
#    include "rSystem.h"
#    include "General.h"
#    include "DynArray.h"
#    include "Positions.h"
# endif
 
# include <stdio.h>
# if defined __STDC__ | defined __cplusplus
#  include <stdlib.h>
# else
/* extern char * malloc ();
   extern void free (); */
# endif

# define yyTabSpace	8

# define yyStart(State)	{ yyPreviousStart = yyStartState; yyStartState = State; }
# define yyPrevious	{ yyStateRange s = yyStartState; \
	 		yyStartState = yyPreviousStart; yyPreviousStart = s; }
# define yyEcho		{ char * yyEnd = mpcScan_TokenPtr + mpcScan_TokenLength; \
			char yyCh = * yyEnd; * yyEnd = '\0'; \
	 		(void) fputs (mpcScan_TokenPtr, stdout); * yyEnd = yyCh; }
# define yyLess(n)	{ yyChBufferIndex -= mpcScan_TokenLength - n; mpcScan_TokenLength = n; }
# define yyTab		yyLineStart -= yyTabSpace - 1 - ((unsigned char *) mpcScan_TokenPtr - yyLineStart - 1) % yyTabSpace
# define yyTab1(a)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) mpcScan_TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyTab2(a,b)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) mpcScan_TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyEol(Column)	{ yyLineCount ++; yyLineStart = yyChBufferIndex - 1 - Column; }
# define output(c)	(void) putchar ((int) c)
# define unput(c)	* (-- yyChBufferIndex) = c

# define yyDNoState		0
# define yyFileStackSize	16
# define yyInitBufferSize	1024 * 8 + 256
# define yyFirstCh	(unsigned char) '\0'
# define yyLastCh	(unsigned char) '\377'
# define yyEolCh	(unsigned char) '\12'
# define yyEobCh	(unsigned char) '\177'
# define yyDStateCount	659
# define yyTableSize	5107
# define yyEobState	88
# define yyDefaultState	89
# define STD	1
# define comment	3
# define linecomment	5
# define pseudocomment	7
# define position	9
# define file	11
# define pragma	13
# define openmp	15
# define header	17
# define keywords	19
# define native	21
# define unused	23
 
static void yyExit () { rExit (1); }

typedef unsigned short	yyStateRange;
typedef struct { yyStateRange yyCheck, yyNext; } yyCombType;
 
	char *		mpcScan_TokenPtr	;
	short		mpcScan_TokenLength	;
	mpcScan_tScanAttribute	mpcScan_Attribute	;
	void		(* mpcScan_Exit) () = yyExit;
 
static	yyCombType	yyComb		[yyTableSize   + 1] = {{1, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1, 93},
{1, 90},
{0, 0},
{1, 39},
{1, 39},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1, 100},
{1, 410},
{1, 46},
{1, 559},
{33, 33},
{1, 325},
{1, 383},
{1, 72},
{1, 532},
{1, 530},
{1, 397},
{1, 392},
{1, 531},
{1, 390},
{1, 68},
{1, 395},
{1, 59},
{1, 55},
{1, 55},
{1, 55},
{1, 55},
{1, 55},
{1, 55},
{1, 55},
{1, 55},
{1, 55},
{1, 529},
{1, 406},
{1, 368},
{1, 401},
{1, 385},
{1, 407},
{1, 377},
{30, 30},
{369, 370},
{377, 378},
{381, 382},
{25, 25},
{25, 26},
{386, 387},
{388, 389},
{397, 398},
{399, 400},
{401, 412},
{1, 58},
{410, 411},
{407, 416},
{57, 37},
{407, 415},
{61, 40},
{520, 523},
{540, 541},
{520, 521},
{542, 543},
{543, 544},
{542, 554},
{30, 30},
{56, 37},
{59, 70},
{1, 504},
{25, 25},
{1, 535},
{1, 381},
{25, 25},
{110, 111},
{1, 227},
{1, 320},
{1, 308},
{1, 347},
{1, 359},
{1, 289},
{1, 341},
{1, 281},
{1, 363},
{109, 110},
{25, 25},
{1, 263},
{1, 108},
{1, 214},
{57, 37},
{1, 204},
{61, 40},
{1, 176},
{1, 142},
{1, 130},
{1, 443},
{1, 118},
{1, 349},
{112, 113},
{56, 37},
{59, 70},
{1, 442},
{1, 379},
{1, 405},
{1, 502},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 94},
{3, 654},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 101},
{3, 54},
{3, 54},
{3, 560},
{3, 647},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 655},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 636},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{26, 88},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{3, 54},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 95},
{5, 634},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 102},
{5, 53},
{5, 53},
{5, 561},
{87, 88},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 35},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 638},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{113, 114},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{5, 53},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 96},
{7, 631},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 103},
{7, 52},
{7, 52},
{7, 562},
{114, 115},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 632},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 640},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{115, 116},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{7, 52},
{9, 93},
{9, 558},
{116, 117},
{60, 40},
{119, 120},
{120, 121},
{121, 122},
{65, 42},
{81, 71},
{122, 123},
{81, 71},
{11, 97},
{11, 557},
{81, 63},
{81, 63},
{81, 63},
{81, 63},
{81, 63},
{81, 63},
{81, 63},
{81, 63},
{81, 63},
{81, 63},
{9, 104},
{124, 125},
{125, 126},
{9, 559},
{126, 127},
{127, 128},
{128, 129},
{131, 132},
{132, 133},
{133, 134},
{134, 135},
{11, 105},
{60, 40},
{11, 73},
{11, 559},
{9, 642},
{65, 42},
{9, 49},
{9, 49},
{9, 49},
{9, 49},
{9, 49},
{9, 49},
{9, 49},
{9, 49},
{9, 49},
{11, 642},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{137, 138},
{138, 139},
{139, 140},
{140, 141},
{13, 29},
{143, 144},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{13, 29},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 98},
{15, 91},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 106},
{15, 47},
{15, 47},
{15, 563},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 643},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{144, 145},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{15, 47},
{17, 93},
{17, 90},
{50, 32},
{19, 93},
{19, 90},
{21, 93},
{21, 90},
{51, 32},
{66, 42},
{41, 41},
{41, 41},
{41, 41},
{41, 41},
{41, 41},
{41, 41},
{41, 41},
{41, 41},
{41, 41},
{41, 41},
{130, 131},
{145, 146},
{108, 254},
{146, 147},
{17, 100},
{64, 65},
{17, 74},
{19, 100},
{118, 119},
{21, 100},
{19, 559},
{41, 81},
{21, 559},
{108, 109},
{64, 66},
{50, 32},
{130, 436},
{63, 62},
{118, 452},
{148, 149},
{51, 32},
{66, 42},
{19, 642},
{63, 62},
{21, 642},
{50, 88},
{149, 150},
{136, 154},
{151, 152},
{152, 153},
{155, 156},
{154, 164},
{17, 75},
{136, 493},
{156, 157},
{157, 158},
{136, 148},
{64, 65},
{154, 155},
{51, 88},
{19, 542},
{159, 168},
{160, 161},
{41, 81},
{21, 536},
{136, 137},
{64, 66},
{161, 162},
{159, 160},
{63, 62},
{162, 163},
{19, 545},
{164, 165},
{165, 166},
{166, 167},
{63, 62},
{168, 169},
{68, 399},
{19, 549},
{68, 41},
{68, 41},
{68, 41},
{68, 41},
{68, 41},
{68, 41},
{68, 41},
{68, 41},
{68, 41},
{68, 41},
{169, 170},
{170, 171},
{172, 173},
{173, 192},
{174, 175},
{176, 177},
{178, 179},
{180, 181},
{181, 182},
{182, 183},
{183, 184},
{184, 185},
{173, 180},
{186, 187},
{187, 188},
{188, 189},
{173, 174},
{21, 539},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 99},
{23, 92},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 107},
{23, 25},
{23, 25},
{23, 564},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 645},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{189, 190},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{23, 25},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{190, 191},
{192, 193},
{193, 194},
{195, 196},
{196, 197},
{198, 199},
{199, 200},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{200, 201},
{201, 202},
{202, 203},
{204, 205},
{29, 29},
{205, 206},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{29, 29},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{206, 207},
{207, 208},
{208, 209},
{211, 212},
{212, 213},
{215, 216},
{216, 217},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{218, 219},
{219, 220},
{220, 221},
{221, 222},
{38, 38},
{222, 223},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{38, 38},
{45, 46},
{210, 236},
{214, 242},
{223, 224},
{224, 225},
{45, 46},
{225, 226},
{228, 229},
{229, 230},
{230, 231},
{231, 232},
{210, 211},
{214, 215},
{227, 228},
{45, 46},
{45, 46},
{45, 46},
{45, 46},
{45, 46},
{45, 46},
{45, 46},
{45, 46},
{227, 423},
{232, 233},
{233, 234},
{234, 235},
{236, 237},
{237, 238},
{69, 41},
{45, 46},
{69, 69},
{69, 69},
{69, 69},
{69, 69},
{69, 69},
{69, 69},
{69, 69},
{69, 69},
{69, 69},
{69, 69},
{177, 195},
{238, 239},
{239, 240},
{240, 241},
{177, 417},
{242, 243},
{243, 244},
{244, 245},
{245, 246},
{177, 186},
{246, 247},
{69, 81},
{248, 249},
{177, 178},
{111, 218},
{111, 315},
{111, 301},
{177, 327},
{45, 46},
{111, 285},
{249, 250},
{111, 277},
{250, 251},
{45, 46},
{45, 46},
{111, 259},
{111, 248},
{111, 210},
{45, 46},
{111, 198},
{251, 252},
{111, 172},
{111, 136},
{111, 124},
{252, 253},
{111, 112},
{45, 46},
{254, 255},
{255, 256},
{256, 257},
{45, 46},
{257, 258},
{45, 46},
{69, 81},
{45, 46},
{259, 267},
{45, 67},
{260, 261},
{261, 262},
{259, 260},
{264, 265},
{265, 266},
{267, 268},
{45, 88},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{268, 269},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 44},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 45},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{67, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{269, 270},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 28},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{270, 271},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{272, 273},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{273, 274},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 48},
{48, 75},
{48, 75},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 86},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{70, 64},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{274, 275},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{48, 75},
{49, 49},
{49, 49},
{49, 49},
{49, 49},
{49, 49},
{49, 49},
{49, 49},
{49, 49},
{49, 49},
{49, 49},
{275, 276},
{277, 278},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{278, 279},
{279, 280},
{281, 282},
{282, 283},
{283, 284},
{286, 287},
{49, 50},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{142, 159},
{285, 293},
{49, 51},
{263, 272},
{287, 288},
{142, 484},
{142, 467},
{263, 264},
{289, 296},
{142, 151},
{291, 292},
{290, 291},
{285, 286},
{263, 479},
{294, 295},
{297, 298},
{301, 302},
{142, 426},
{142, 143},
{289, 290},
{142, 354},
{290, 476},
{289, 345},
{302, 303},
{303, 304},
{49, 50},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{77, 82},
{304, 305},
{305, 306},
{49, 51},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{306, 307},
{310, 311},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{311, 312},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{312, 313},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{313, 314},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{309, 335},
{309, 310},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{315, 316},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{316, 317},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{317, 318},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{53, 53},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{318, 319},
{321, 322},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{322, 323},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{323, 324},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{327, 328},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{320, 321},
{328, 329},
{325, 326},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{320, 331},
{293, 299},
{329, 330},
{331, 332},
{332, 333},
{55, 56},
{293, 294},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{325, 394},
{55, 57},
{333, 334},
{71, 63},
{71, 63},
{71, 63},
{71, 63},
{71, 63},
{71, 63},
{71, 63},
{71, 63},
{71, 63},
{71, 63},
{296, 300},
{335, 459},
{335, 336},
{336, 337},
{337, 338},
{296, 297},
{338, 339},
{58, 46},
{339, 340},
{341, 342},
{342, 343},
{55, 56},
{58, 72},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{78, 73},
{343, 344},
{55, 57},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{345, 346},
{348, 472},
{349, 350},
{350, 351},
{351, 352},
{352, 353},
{354, 355},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{355, 356},
{356, 357},
{357, 358},
{360, 361},
{58, 38},
{71, 88},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{58, 38},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{361, 362},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{365, 366},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 83},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{79, 74},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{366, 367},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{72, 82},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{371, 372},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 31},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 84},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{80, 75},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{372, 373},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{73, 73},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{373, 374},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 27},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{374, 375},
{363, 364},
{375, 376},
{402, 403},
{368, 369},
{403, 404},
{359, 360},
{347, 371},
{359, 402},
{363, 482},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{347, 348},
{359, 431},
{368, 388},
{368, 414},
{385, 413},
{385, 386},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 85},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{417, 418},
{418, 419},
{419, 420},
{368, 503},
{385, 506},
{420, 421},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{421, 422},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{74, 74},
{76, 76},
{76, 76},
{76, 76},
{76, 76},
{76, 76},
{76, 76},
{76, 76},
{76, 76},
{308, 365},
{383, 409},
{390, 525},
{392, 526},
{423, 424},
{424, 425},
{395, 657},
{308, 488},
{427, 428},
{379, 380},
{426, 427},
{395, 635},
{428, 429},
{429, 430},
{308, 309},
{431, 432},
{432, 433},
{433, 434},
{390, 391},
{390, 527},
{76, 60},
{392, 393},
{434, 435},
{436, 437},
{383, 384},
{395, 396},
{437, 438},
{426, 448},
{438, 439},
{76, 61},
{439, 440},
{440, 441},
{443, 444},
{444, 445},
{445, 446},
{446, 447},
{448, 449},
{449, 450},
{450, 451},
{452, 491},
{453, 454},
{454, 455},
{452, 453},
{444, 461},
{455, 456},
{456, 457},
{457, 458},
{459, 460},
{461, 462},
{462, 463},
{463, 464},
{464, 465},
{76, 60},
{465, 466},
{468, 469},
{469, 470},
{470, 471},
{472, 473},
{473, 474},
{474, 475},
{476, 477},
{76, 61},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{379, 408},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{467, 468},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 43},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{477, 478},
{479, 480},
{480, 481},
{482, 483},
{484, 485},
{467, 498},
{485, 486},
{486, 487},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{488, 489},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 83},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{489, 490},
{491, 492},
{82, 82},
{82, 82},
{82, 82},
{493, 494},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{494, 495},
{82, 82},
{82, 82},
{82, 82},
{495, 496},
{82, 82},
{496, 497},
{82, 82},
{498, 499},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{499, 500},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{82, 82},
{83, 82},
{500, 501},
{508, 514},
{509, 510},
{511, 512},
{83, 82},
{512, 513},
{515, 516},
{518, 519},
{521, 522},
{523, 524},
{533, 534},
{536, 537},
{537, 538},
{83, 82},
{83, 82},
{83, 82},
{83, 82},
{83, 82},
{83, 82},
{83, 82},
{83, 82},
{539, 540},
{545, 546},
{546, 547},
{84, 73},
{547, 548},
{549, 550},
{550, 551},
{83, 82},
{84, 73},
{551, 552},
{552, 553},
{508, 509},
{554, 555},
{555, 556},
{565, 566},
{566, 567},
{567, 568},
{84, 73},
{84, 73},
{84, 73},
{84, 73},
{84, 73},
{84, 73},
{84, 73},
{84, 73},
{568, 569},
{559, 601},
{560, 606},
{561, 611},
{569, 570},
{571, 572},
{562, 616},
{84, 73},
{559, 565},
{560, 571},
{561, 577},
{83, 82},
{511, 517},
{562, 583},
{572, 573},
{563, 621},
{83, 82},
{83, 82},
{564, 626},
{573, 574},
{574, 575},
{83, 82},
{563, 589},
{575, 576},
{577, 578},
{564, 595},
{578, 579},
{579, 580},
{580, 581},
{83, 82},
{581, 582},
{583, 584},
{584, 585},
{83, 82},
{585, 586},
{83, 82},
{84, 73},
{83, 82},
{586, 587},
{83, 77},
{587, 588},
{84, 73},
{84, 73},
{589, 590},
{590, 591},
{591, 592},
{84, 73},
{592, 593},
{593, 594},
{595, 596},
{596, 597},
{85, 74},
{597, 598},
{598, 599},
{84, 73},
{599, 600},
{85, 74},
{601, 602},
{84, 73},
{602, 603},
{84, 73},
{603, 604},
{84, 73},
{604, 605},
{84, 78},
{85, 74},
{85, 74},
{85, 74},
{85, 74},
{85, 74},
{85, 74},
{85, 74},
{85, 74},
{606, 607},
{607, 608},
{608, 609},
{86, 75},
{609, 610},
{611, 612},
{612, 613},
{85, 74},
{86, 75},
{613, 614},
{614, 615},
{616, 617},
{617, 618},
{618, 619},
{619, 620},
{621, 622},
{622, 623},
{86, 75},
{86, 75},
{86, 75},
{86, 75},
{86, 75},
{86, 75},
{86, 75},
{86, 75},
{504, 511},
{623, 624},
{624, 625},
{626, 627},
{504, 533},
{504, 518},
{627, 628},
{86, 75},
{628, 629},
{629, 630},
{632, 633},
{85, 74},
{647, 648},
{636, 657},
{638, 657},
{640, 657},
{85, 74},
{85, 74},
{636, 637},
{638, 639},
{640, 641},
{85, 74},
{504, 507},
{642, 657},
{504, 505},
{504, 520},
{643, 658},
{645, 659},
{642, 635},
{85, 74},
{648, 649},
{643, 644},
{645, 646},
{85, 74},
{649, 650},
{85, 74},
{86, 75},
{85, 74},
{650, 651},
{85, 79},
{651, 652},
{86, 75},
{86, 75},
{652, 653},
{655, 656},
{0, 0},
{86, 75},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{86, 75},
{504, 528},
{504, 515},
{0, 0},
{86, 75},
{0, 0},
{86, 75},
{0, 0},
{86, 75},
{0, 0},
{86, 80},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{504, 508},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
static	yyCombType *	yyBasePtr	[yyDStateCount + 1] = {& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [127],
& yyComb [0],
& yyComb [383],
& yyComb [0],
& yyComb [639],
& yyComb [0],
& yyComb [886],
& yyComb [0],
& yyComb [897],
& yyComb [0],
& yyComb [880],
& yyComb [0],
& yyComb [1003],
& yyComb [0],
& yyComb [1250],
& yyComb [0],
& yyComb [1253],
& yyComb [0],
& yyComb [1255],
& yyComb [0],
& yyComb [1365],
& yyComb [0],
& yyComb [60],
& yyComb [127],
& yyComb [0],
& yyComb [0],
& yyComb [1573],
& yyComb [56],
& yyComb [0],
& yyComb [0],
& yyComb [4],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [1648],
& yyComb [0],
& yyComb [0],
& yyComb [1220],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [1737],
& yyComb [1865],
& yyComb [2121],
& yyComb [2377],
& yyComb [2585],
& yyComb [1176],
& yyComb [1190],
& yyComb [2703],
& yyComb [2959],
& yyComb [3215],
& yyComb [3423],
& yyComb [4],
& yyComb [3],
& yyComb [3493],
& yyComb [2],
& yyComb [813],
& yyComb [5],
& yyComb [0],
& yyComb [1225],
& yyComb [1207],
& yyComb [817],
& yyComb [1191],
& yyComb [1865],
& yyComb [1289],
& yyComb [1753],
& yyComb [2377],
& yyComb [3462],
& yyComb [3616],
& yyComb [3872],
& yyComb [4128],
& yyComb [0],
& yyComb [4336],
& yyComb [2597],
& yyComb [3436],
& yyComb [3616],
& yyComb [3872],
& yyComb [860],
& yyComb [4454],
& yyComb [4676],
& yyComb [4701],
& yyComb [4774],
& yyComb [4799],
& yyComb [292],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [1179],
& yyComb [7],
& yyComb [1],
& yyComb [1728],
& yyComb [19],
& yyComb [411],
& yyComb [559],
& yyComb [655],
& yyComb [783],
& yyComb [0],
& yyComb [1185],
& yyComb [800],
& yyComb [784],
& yyComb [790],
& yyComb [790],
& yyComb [0],
& yyComb [814],
& yyComb [811],
& yyComb [821],
& yyComb [812],
& yyComb [822],
& yyComb [0],
& yyComb [1173],
& yyComb [816],
& yyComb [825],
& yyComb [816],
& yyComb [826],
& yyComb [0],
& yyComb [1206],
& yyComb [873],
& yyComb [862],
& yyComb [872],
& yyComb [858],
& yyComb [0],
& yyComb [2569],
& yyComb [878],
& yyComb [1020],
& yyComb [1178],
& yyComb [1165],
& yyComb [0],
& yyComb [1186],
& yyComb [1185],
& yyComb [0],
& yyComb [1195],
& yyComb [1188],
& yyComb [0],
& yyComb [1212],
& yyComb [1207],
& yyComb [1203],
& yyComb [1212],
& yyComb [0],
& yyComb [1222],
& yyComb [1219],
& yyComb [1216],
& yyComb [1227],
& yyComb [0],
& yyComb [1222],
& yyComb [1234],
& yyComb [1218],
& yyComb [0],
& yyComb [1226],
& yyComb [1250],
& yyComb [1234],
& yyComb [0],
& yyComb [1248],
& yyComb [1251],
& yyComb [1243],
& yyComb [0],
& yyComb [1251],
& yyComb [1712],
& yyComb [1245],
& yyComb [0],
& yyComb [1257],
& yyComb [1239],
& yyComb [1251],
& yyComb [1246],
& yyComb [1248],
& yyComb [0],
& yyComb [1263],
& yyComb [1245],
& yyComb [1257],
& yyComb [1381],
& yyComb [1521],
& yyComb [0],
& yyComb [1521],
& yyComb [1523],
& yyComb [0],
& yyComb [1523],
& yyComb [1525],
& yyComb [0],
& yyComb [1539],
& yyComb [1523],
& yyComb [1563],
& yyComb [1555],
& yyComb [1550],
& yyComb [0],
& yyComb [1570],
& yyComb [1555],
& yyComb [1605],
& yyComb [1597],
& yyComb [1592],
& yyComb [0],
& yyComb [1671],
& yyComb [1609],
& yyComb [1609],
& yyComb [0],
& yyComb [1672],
& yyComb [1611],
& yyComb [1611],
& yyComb [0],
& yyComb [1631],
& yyComb [1637],
& yyComb [1630],
& yyComb [1628],
& yyComb [1639],
& yyComb [1658],
& yyComb [1671],
& yyComb [1668],
& yyComb [0],
& yyComb [1676],
& yyComb [1675],
& yyComb [1668],
& yyComb [1666],
& yyComb [1676],
& yyComb [1678],
& yyComb [1691],
& yyComb [1687],
& yyComb [0],
& yyComb [1681],
& yyComb [1682],
& yyComb [1691],
& yyComb [1701],
& yyComb [1713],
& yyComb [0],
& yyComb [1700],
& yyComb [1701],
& yyComb [1697],
& yyComb [1707],
& yyComb [1720],
& yyComb [0],
& yyComb [1722],
& yyComb [1722],
& yyComb [1722],
& yyComb [1727],
& yyComb [1724],
& yyComb [0],
& yyComb [1739],
& yyComb [1738],
& yyComb [1736],
& yyComb [1731],
& yyComb [0],
& yyComb [1755],
& yyComb [1748],
& yyComb [1752],
& yyComb [0],
& yyComb [2570],
& yyComb [1751],
& yyComb [1755],
& yyComb [0],
& yyComb [1753],
& yyComb [1772],
& yyComb [1876],
& yyComb [2144],
& yyComb [0],
& yyComb [2277],
& yyComb [2308],
& yyComb [2388],
& yyComb [2539],
& yyComb [0],
& yyComb [2533],
& yyComb [2540],
& yyComb [2540],
& yyComb [0],
& yyComb [2546],
& yyComb [2543],
& yyComb [2543],
& yyComb [0],
& yyComb [2572],
& yyComb [2559],
& yyComb [2552],
& yyComb [0],
& yyComb [2579],
& yyComb [2578],
& yyComb [2558],
& yyComb [0],
& yyComb [3385],
& yyComb [2566],
& yyComb [0],
& yyComb [3410],
& yyComb [2567],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [2573],
& yyComb [2580],
& yyComb [2578],
& yyComb [2600],
& yyComb [2590],
& yyComb [2610],
& yyComb [0],
& yyComb [4295],
& yyComb [2858],
& yyComb [2599],
& yyComb [2639],
& yyComb [2634],
& yyComb [2728],
& yyComb [0],
& yyComb [2894],
& yyComb [2891],
& yyComb [2987],
& yyComb [3120],
& yyComb [0],
& yyComb [3380],
& yyComb [3115],
& yyComb [3152],
& yyComb [3153],
& yyComb [0],
& yyComb [3446],
& yyComb [0],
& yyComb [3225],
& yyComb [3368],
& yyComb [3386],
& yyComb [0],
& yyComb [3396],
& yyComb [3401],
& yyComb [3402],
& yyComb [0],
& yyComb [3406],
& yyComb [3418],
& yyComb [3414],
& yyComb [3409],
& yyComb [3427],
& yyComb [0],
& yyComb [3418],
& yyComb [3414],
& yyComb [3428],
& yyComb [0],
& yyComb [3437],
& yyComb [0],
& yyComb [4082],
& yyComb [3435],
& yyComb [3449],
& yyComb [3449],
& yyComb [3447],
& yyComb [3455],
& yyComb [0],
& yyComb [3452],
& yyComb [3468],
& yyComb [3486],
& yyComb [3482],
& yyComb [0],
& yyComb [4074],
& yyComb [3472],
& yyComb [3525],
& yyComb [0],
& yyComb [4075],
& yyComb [0],
& yyComb [3540],
& yyComb [3642],
& yyComb [0],
& yyComb [4135],
& yyComb [4],
& yyComb [0],
& yyComb [3780],
& yyComb [3902],
& yyComb [4021],
& yyComb [4068],
& yyComb [4062],
& yyComb [0],
& yyComb [3],
& yyComb [0],
& yyComb [4340],
& yyComb [0],
& yyComb [7],
& yyComb [0],
& yyComb [4355],
& yyComb [0],
& yyComb [4136],
& yyComb [10],
& yyComb [0],
& yyComb [11],
& yyComb [0],
& yyComb [4349],
& yyComb [0],
& yyComb [4352],
& yyComb [0],
& yyComb [0],
& yyComb [4356],
& yyComb [0],
& yyComb [12],
& yyComb [0],
& yyComb [28],
& yyComb [0],
& yyComb [14],
& yyComb [4062],
& yyComb [4072],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [18],
& yyComb [0],
& yyComb [0],
& yyComb [16],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [4120],
& yyComb [4111],
& yyComb [4111],
& yyComb [4129],
& yyComb [4141],
& yyComb [0],
& yyComb [4280],
& yyComb [4286],
& yyComb [0],
& yyComb [4305],
& yyComb [4284],
& yyComb [4299],
& yyComb [4306],
& yyComb [0],
& yyComb [4291],
& yyComb [4307],
& yyComb [4295],
& yyComb [4304],
& yyComb [0],
& yyComb [4303],
& yyComb [4317],
& yyComb [4320],
& yyComb [4321],
& yyComb [4321],
& yyComb [0],
& yyComb [0],
& yyComb [4314],
& yyComb [4320],
& yyComb [4315],
& yyComb [4317],
& yyComb [0],
& yyComb [4311],
& yyComb [4330],
& yyComb [4314],
& yyComb [0],
& yyComb [4326],
& yyComb [4335],
& yyComb [4317],
& yyComb [4331],
& yyComb [4329],
& yyComb [4337],
& yyComb [0],
& yyComb [4323],
& yyComb [0],
& yyComb [4335],
& yyComb [4338],
& yyComb [4332],
& yyComb [4342],
& yyComb [4345],
& yyComb [0],
& yyComb [4385],
& yyComb [4336],
& yyComb [4346],
& yyComb [4348],
& yyComb [0],
& yyComb [4351],
& yyComb [4342],
& yyComb [4350],
& yyComb [0],
& yyComb [4355],
& yyComb [4386],
& yyComb [0],
& yyComb [4393],
& yyComb [4401],
& yyComb [0],
& yyComb [4389],
& yyComb [0],
& yyComb [4395],
& yyComb [4394],
& yyComb [4393],
& yyComb [0],
& yyComb [4420],
& yyComb [4437],
& yyComb [0],
& yyComb [4452],
& yyComb [0],
& yyComb [4434],
& yyComb [4463],
& yyComb [4457],
& yyComb [4468],
& yyComb [0],
& yyComb [4471],
& yyComb [4470],
& yyComb [4609],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [4817],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [4619],
& yyComb [4620],
& yyComb [0],
& yyComb [4676],
& yyComb [4623],
& yyComb [0],
& yyComb [0],
& yyComb [4624],
& yyComb [0],
& yyComb [0],
& yyComb [4625],
& yyComb [0],
& yyComb [22],
& yyComb [4626],
& yyComb [0],
& yyComb [4627],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [4628],
& yyComb [0],
& yyComb [0],
& yyComb [4631],
& yyComb [4630],
& yyComb [0],
& yyComb [4620],
& yyComb [16],
& yyComb [0],
& yyComb [9],
& yyComb [10],
& yyComb [0],
& yyComb [4654],
& yyComb [4656],
& yyComb [4665],
& yyComb [0],
& yyComb [4665],
& yyComb [4659],
& yyComb [4659],
& yyComb [4658],
& yyComb [0],
& yyComb [4661],
& yyComb [4672],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [4653],
& yyComb [4654],
& yyComb [4655],
& yyComb [4658],
& yyComb [4667],
& yyComb [4670],
& yyComb [4632],
& yyComb [4650],
& yyComb [4645],
& yyComb [4648],
& yyComb [4664],
& yyComb [0],
& yyComb [4648],
& yyComb [4674],
& yyComb [4673],
& yyComb [4668],
& yyComb [4683],
& yyComb [0],
& yyComb [4667],
& yyComb [4686],
& yyComb [4681],
& yyComb [4676],
& yyComb [4690],
& yyComb [0],
& yyComb [4674],
& yyComb [4692],
& yyComb [4688],
& yyComb [4686],
& yyComb [4700],
& yyComb [0],
& yyComb [4686],
& yyComb [4704],
& yyComb [4699],
& yyComb [4695],
& yyComb [4708],
& yyComb [0],
& yyComb [4692],
& yyComb [4710],
& yyComb [4706],
& yyComb [4701],
& yyComb [4715],
& yyComb [0],
& yyComb [4714],
& yyComb [4715],
& yyComb [4708],
& yyComb [4704],
& yyComb [0],
& yyComb [4730],
& yyComb [4730],
& yyComb [4722],
& yyComb [4718],
& yyComb [0],
& yyComb [4735],
& yyComb [4735],
& yyComb [4729],
& yyComb [4724],
& yyComb [0],
& yyComb [4741],
& yyComb [4741],
& yyComb [4733],
& yyComb [4728],
& yyComb [0],
& yyComb [4745],
& yyComb [4745],
& yyComb [4746],
& yyComb [4741],
& yyComb [0],
& yyComb [4758],
& yyComb [4760],
& yyComb [4753],
& yyComb [4748],
& yyComb [0],
& yyComb [0],
& yyComb [4818],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [4826],
& yyComb [0],
& yyComb [4827],
& yyComb [0],
& yyComb [4828],
& yyComb [0],
& yyComb [4836],
& yyComb [4839],
& yyComb [0],
& yyComb [4840],
& yyComb [0],
& yyComb [4751],
& yyComb [4771],
& yyComb [4792],
& yyComb [4794],
& yyComb [4794],
& yyComb [4840],
& yyComb [0],
& yyComb [0],
& yyComb [4852],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
};
static	yyStateRange	yyDefault	[yyDStateCount + 1] = {0,
38,
1,
29,
3,
29,
5,
29,
7,
30,
9,
30,
11,
19,
13,
29,
15,
11,
17,
30,
19,
30,
21,
29,
23,
23,
0,
0,
26,
26,
26,
0,
0,
26,
26,
26,
26,
0,
26,
0,
0,
63,
0,
0,
0,
0,
67,
71,
80,
71,
0,
0,
71,
71,
71,
69,
50,
51,
71,
76,
50,
51,
0,
71,
70,
50,
51,
71,
71,
71,
71,
0,
77,
78,
79,
48,
69,
71,
71,
71,
71,
87,
83,
87,
87,
87,
87,
0,
0,
0,
87,
28,
26,
0,
36,
35,
34,
30,
47,
25,
0,
54,
53,
52,
33,
30,
47,
25,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
87,
0,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
87,
87,
0,
38,
38,
38,
38,
38,
38,
87,
0,
87,
0,
87,
0,
87,
0,
87,
87,
0,
87,
0,
87,
0,
87,
0,
0,
87,
0,
87,
0,
87,
0,
87,
38,
38,
38,
0,
0,
87,
0,
0,
87,
0,
0,
0,
0,
0,
0,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
0,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
38,
0,
0,
87,
0,
0,
0,
87,
87,
0,
87,
87,
0,
0,
87,
0,
0,
87,
0,
87,
87,
0,
87,
0,
0,
0,
0,
0,
0,
0,
0,
0,
87,
0,
0,
87,
87,
0,
87,
87,
0,
87,
87,
0,
87,
87,
87,
0,
87,
87,
87,
87,
0,
87,
87,
0,
90,
90,
87,
54,
53,
52,
47,
25,
87,
87,
87,
87,
87,
0,
54,
54,
54,
54,
54,
54,
53,
53,
53,
53,
53,
53,
52,
52,
52,
52,
52,
52,
47,
47,
47,
47,
47,
47,
25,
25,
25,
25,
25,
25,
87,
87,
87,
87,
0,
54,
54,
54,
54,
54,
53,
53,
53,
53,
53,
52,
52,
52,
52,
52,
47,
47,
47,
47,
47,
25,
25,
25,
25,
25,
90,
34,
0,
90,
0,
54,
54,
53,
53,
52,
52,
87,
47,
47,
25,
25,
87,
87,
87,
87,
87,
87,
0,
90,
36,
0,
0,
47,
25,
};
static	yyStateRange	yyEobTrans	[yyDStateCount + 1] = {0,
0,
0,
54,
54,
53,
53,
52,
52,
0,
0,
0,
0,
0,
0,
47,
47,
0,
0,
0,
0,
0,
0,
25,
25,
25,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
46,
47,
75,
0,
0,
0,
52,
53,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
82,
73,
74,
75,
0,
0,
0,
0,
0,
0,
82,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
47,
25,
0,
54,
53,
52,
0,
0,
47,
25,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
54,
53,
52,
47,
25,
0,
0,
0,
0,
0,
0,
54,
54,
54,
54,
54,
54,
53,
53,
53,
53,
53,
53,
52,
52,
52,
52,
52,
52,
47,
47,
47,
47,
47,
47,
25,
25,
25,
25,
25,
25,
0,
0,
0,
0,
0,
54,
54,
54,
54,
54,
53,
53,
53,
53,
53,
52,
52,
52,
52,
52,
47,
47,
47,
47,
47,
25,
25,
25,
25,
25,
0,
0,
0,
0,
0,
54,
54,
53,
53,
52,
52,
0,
47,
47,
25,
25,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
47,
25,
};

static	yyStateRange	yyInitStateStack [yyInitBufferSize] = {0};
static	yyStateRange *	yyStateStack	= yyInitStateStack;
static	unsigned long	yyStateStackSize= yyInitBufferSize;
static	yyStateRange	yyStartState	= 0;
static	yyStateRange	yyPreviousStart	= 1;

static  short		yySourceFile	;
static	bool		yyEof		;
static	unsigned char *	yyChBufferPtr	;
static	unsigned char *	yyChBufferStart	;
static	unsigned long	yyChBufferSize	;
static	unsigned char *	yyChBufferIndex	= ((unsigned char *) yyComb) + 2; /* dirty trick */
static	int		yyBytesRead	;
static	int		yyLineCount	;
static	unsigned char *	yyLineStart	;

static	struct {
	short		yySourceFile	;
	bool		yyEof		;
	unsigned char *	yyChBufferPtr	;
	unsigned char *	yyChBufferStart	;
	unsigned long	yyChBufferSize	;
	unsigned char *	yyChBufferIndex	;
	int		yyBytesRead	;
	int		yyLineCount	;
	unsigned char *	yyLineStart	;
	} yyFileStack [yyFileStackSize + 1], * yyFileStackPtr = yyFileStack;

static	unsigned char	yyToLower	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^', '_',
'`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

static	unsigned char	yyToUpper	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
'`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};
 
static	void	yyInitialize	();
static	void	yyErrorMessage	ARGS((int yyErrorCode));
static	char	input		();
/* line 115 "mpc.rex" */


    /* Copyright (C) 1993 Ilya N. Ledovskikh, All rights reserved.
       Portions Copyright (C) 1989,1990 James A. Roskind.          */

# include <string.h>
# include <errno.h>
# include <stdlib.h>


void mpcScan_ErrorAttribute
# if defined __STDC__ | defined __cplusplus
 (int Token, mpcScan_tScanAttribute * pAttribute)
# else
 (Token, pAttribute) int Token; mpcScan_tScanAttribute * pAttribute;
# endif
{
 pAttribute->Position = mpcScan_Attribute.Position;
 switch (Token) {
 case /* IDENTIFIER */ 1: 
 pAttribute->IDENTIFIER.SymForm=NULL;
 pAttribute->IDENTIFIER.Ignore=YES;
 pAttribute->IDENTIFIER.Length=0;
 ;
 pAttribute->IDENTIFIER.Ident=NoIdent;
 ;
 break;
 case /* NETorSUBNETname */ 2: 
 pAttribute->NETorSUBNETname.SymForm=NULL;
 pAttribute->NETorSUBNETname.Ignore=YES;
 pAttribute->NETorSUBNETname.Length=0;
 ;
 pAttribute->NETorSUBNETname.Ident=NoIdent;
 ;
 break;
 case /* TYPEDEFname */ 3: 
 pAttribute->TYPEDEFname.SymForm=NULL;
 pAttribute->TYPEDEFname.Ignore=YES;
 pAttribute->TYPEDEFname.Length=0;
 ;
 pAttribute->TYPEDEFname.Ident=NoIdent;
 ;
 break;
 case /* FLOATINGconstant */ 4: 
 pAttribute->FLOATINGconstant.SymForm=NULL;
 pAttribute->FLOATINGconstant.Ignore=YES;
 pAttribute->FLOATINGconstant.Length=0;
 ;
 pAttribute->FLOATINGconstant.FloatConst=0.0;
 ;
 break;
 case /* INTEGERconstant */ 5: 
 pAttribute->INTEGERconstant.SymForm=NULL;
 pAttribute->INTEGERconstant.Ignore=YES;
 pAttribute->INTEGERconstant.Length=0;
 ;
 pAttribute->INTEGERconstant.IntConst=0;
 ;
 break;
 case /* OCTALconstant */ 6: 
 pAttribute->OCTALconstant.SymForm=NULL;
 pAttribute->OCTALconstant.Ignore=YES;
 pAttribute->OCTALconstant.Length=0;
 ;
 pAttribute->OCTALconstant.OctConst=0;
 ;
 break;
 case /* HEXconstant */ 7: 
 pAttribute->HEXconstant.SymForm=NULL;
 pAttribute->HEXconstant.Ignore=YES;
 pAttribute->HEXconstant.Length=0;
 ;
 pAttribute->HEXconstant.HexConst=0;
 ;
 break;
 case /* CHARACTERconstant */ 8: 
 pAttribute->CHARACTERconstant.SymForm=NULL;
 pAttribute->CHARACTERconstant.Ignore=YES;
 pAttribute->CHARACTERconstant.Length=0;
 ;
 pAttribute->CHARACTERconstant.CharConst=0;
 ;
 break;
 case /* STRINGliteral */ 9: 
 pAttribute->STRINGliteral.SymForm=NULL;
 pAttribute->STRINGliteral.Ignore=YES;
 pAttribute->STRINGliteral.Length=0;
 ;
 pAttribute->STRINGliteral.StrLit=NULL;
 ;
 break;
 case /* HEADER */ 10: 
 pAttribute->HEADER.SymForm=NULL;
 pAttribute->HEADER.Ignore=YES;
 pAttribute->HEADER.Length=0;
 ;
 break;
 case /* SOURCE */ 11: 
 pAttribute->SOURCE.SymForm=NULL;
 pAttribute->SOURCE.Ignore=YES;
 pAttribute->SOURCE.Length=0;
 ;
 break;
 case /* OMP_DECL */ 12: 
 pAttribute->OMP_DECL.SymForm=NULL;
 pAttribute->OMP_DECL.Ignore=YES;
 ;
 break;
 case /* OMP_STAT */ 13: 
 pAttribute->OMP_STAT.SymForm=NULL;
 pAttribute->OMP_STAT.Ignore=YES;
 ;
 break;
 case /* bench */ 14: 
pAttribute->bench.Ignore=true;
 break;
 case /* coord */ 15: 
pAttribute->coord.Ignore=true;
 break;
 case /* coordof */ 16: 
pAttribute->coordof.Ignore=true;
 break;
 case /* fan */ 17: 
pAttribute->fan.Ignore=true;
 break;
 case /* fast */ 18: 
pAttribute->fast.Ignore=true;
 break;
 case /* flex */ 19: 
pAttribute->flex.Ignore=true;
 break;
 case /* host */ 20: 
pAttribute->host.Ignore=true;
 break;
 case /* length */ 21: 
pAttribute->length.Ignore=true;
 break;
 case /* link */ 22: 
pAttribute->link.Ignore=true;
 break;
 case /* memory */ 23: 
pAttribute->memory.Ignore=true;
 break;
 case /* net */ 24: 
pAttribute->net.Ignore=true;
 break;
 case /* nettype */ 25: 
pAttribute->nettype.Ignore=true;
 break;
 case /* node */ 26: 
pAttribute->node.Ignore=true;
 break;
 case /* parent */ 27: 
pAttribute->parent.Ignore=true;
 break;
 case /* recon */ 28: 
pAttribute->recon.Ignore=true;
 break;
 case /* relation */ 29: 
pAttribute->relation.Ignore=true;
 break;
 case /* repl */ 30: 
pAttribute->repl.Ignore=true;
 break;
 case /* scalar */ 31: 
pAttribute->scalar.Ignore=true;
 break;
 case /* slow */ 32: 
pAttribute->slow.Ignore=true;
 break;
 case /* subnet */ 33: 
pAttribute->subnet.Ignore=true;
 break;
 case /* vector */ 34: 
pAttribute->vector.Ignore=true;
 break;
 case /* par */ 35: 
pAttribute->par.Ignore=true;
 break;
 case /* scheme */ 36: 
pAttribute->scheme.Ignore=true;
 break;
 case /* timeof */ 37: 
pAttribute->timeof.Ignore=true;
 break;
 }
}



int LinesInFile = 0;

int  isaTYPE(tIdent Ident) {
  tTree tree;
  int res;
  if(tree=Find_Ident(Ident, IDENT)) {
    res = Tree_IsType(tree, kMPC_Typedef);
    return res;
  }
  return 0;
}

int  isaNET(tIdent Ident) {
  tTree tree;
  int res;
  if(tree=Find_Ident(Ident, IDENT)) {
    res = Tree_IsType(tree, kMPC_NetOrSubnet);
    return res;
  }
  return 0;
}

int Treat_As_Ident(void) {
  char Word[32];
  int length;
  length = mpcScan_GetWord (Word);
  mpcScan_Attribute.IDENTIFIER.Ignore = NO;
  mpcScan_Attribute.IDENTIFIER.Ident =
    MakeIdent (Word, length);
  if(isaTYPE (mpcScan_Attribute.IDENTIFIER.Ident)) {
    return 3;
  }
  else if(isaNET(mpcScan_Attribute.IDENTIFIER.Ident)) {
    return 2;
  }
  else {
    return 1;
  }

}

# define MAX_BYTE_VALUE 256    /** tmp-definition!!! **/

static int Get_Oct_Code(char *Image, int *Next_Char_Index)
{
  int code=0, i;
  for(i=0; i<3; i++){
    switch( *(Image + i) ){
      case '0': code = code * 8; break;
      case '1': code = code * 8 + 1; break;
      case '2': code = code * 8 + 2; break;
      case '3': code = code * 8 + 3; break;
      case '4': code = code * 8 + 4; break;
      case '5': code = code * 8 + 5; break;
      case '6': code = code * 8 + 6; break;
      case '7': code = code * 8 + 7; break;
      default: goto DONE;
    }
  }
  DONE: *Next_Char_Index += i;
  return code;
}

static int Get_Hex_Code(char *Image, int *Next_Char_Index)
{
  int code=0, i;
  for(i=0; i<3; i++){
    switch( *(Image + i) ){
      case '0': code = code * 16; break;
      case '1': code = code * 16 + 1; break;
      case '2': code = code * 16 + 2; break;
      case '3': code = code * 16 + 3; break;
      case '4': code = code * 16 + 4; break;
      case '5': code = code * 16 + 5; break;
      case '6': code = code * 16 + 6; break;
      case '7': code = code * 16 + 7; break;
      case '8': code = code * 16 + 8; break;
      case '9': code = code * 16 + 9; break;
      case 'a':
      case 'A': code = code * 16 + 10; break;
      case 'b':
      case 'B': code = code * 16 + 11; break;
      case 'c':
      case 'C': code = code * 16 + 12; break;
      case 'd':
      case 'D': code = code * 16 + 13; break;
      case 'e':
      case 'E': code = code * 16 + 14; break;
      case 'f':
      case 'F': code = code * 16 + 15; break;
      default: goto DONE;
    }
  }
  DONE: *Next_Char_Index += i;
  return code;
}

static int Str_to_Char (char *Image, tPosition Position)
{
  int value=0, index=1 /* first character after '; */;

  while(Image[index] && Image[index]!='\''){
    switch(Image[index]){
      case '\\':
	switch(Image[++index]){
	  case '\'': value = MAX_BYTE_VALUE*value + '\''; index++; break;
	  case '"' : value = MAX_BYTE_VALUE*value + '"';  index++; break;
	  case '?' : value = MAX_BYTE_VALUE*value + '?';  index++; break;
	  case '\\': value = MAX_BYTE_VALUE*value + '\\'; index++; break;
	  case 'a' : value = MAX_BYTE_VALUE*value + '\a'; index++; break;
	  case 'b' : value = MAX_BYTE_VALUE*value + '\b'; index++; break;
	  case 'f' : value = MAX_BYTE_VALUE*value + '\f'; index++; break;
	  case 'n' : value = MAX_BYTE_VALUE*value + '\n'; index++; break;
	  case 'r' : value = MAX_BYTE_VALUE*value + '\r'; index++; break;
	  case 't': value = MAX_BYTE_VALUE*value + '\t'; index++; break;
	  case 'v': value = MAX_BYTE_VALUE*value + '\v'; index++; break;
	  default:
	    if(Image[index]>='0' && Image[index]<='7') {  /* octal code: */
	      value = MAX_BYTE_VALUE*value +
			Get_Oct_Code(Image+index, &index);
	    }
	    else if(Image[index]=='x')
	      value = MAX_BYTE_VALUE*value +
			Get_Hex_Code(Image + ++index, &index);
	    else
	      Make_Message(50, xxError, Position, NoTree); break;
		/* "Invalid escape sequence in character constant" */
	}
	break;
      default:
	value = MAX_BYTE_VALUE*value + Image[index++];
    }
  }
  return value;
}


 
int mpcScan_GetToken ()
{
   register	yyStateRange	yyState;
   register	yyStateRange *	yyStatePtr;
   register	unsigned char * yyChBufferIndexReg;
   register	yyCombType * *	yyBasePtrReg = yyBasePtr;
/* line 443 "mpc.rex" */


#define MAX_TOKEN_LENGTH 2048

          char Word[MAX_TOKEN_LENGTH]; 
	  short length;
	  char OMP_prefix[]="#pragma omp ";
          const short OMP_prefix_length=12;
	  int index;
	  tPosition Pos;
	  static tString CurrentFileName;
#ifdef __CB_COMPILER__
	  bool EmptyHeader;   /* only for correct compilation of scanner... */
#endif

   
yyBegin:
   yyState		= yyStartState;		/* initialize */
   yyStatePtr		= & yyStateStack [1];
   yyChBufferIndexReg 	= yyChBufferIndex;
   mpcScan_TokenPtr	 	= (char *) yyChBufferIndexReg;
 
   /* ASSERT yyChBuffer [yyChBufferIndex] == first character */
 
yyContinue:		/* continue after sentinel or skipping blanks */
   for (;;) {		/* execute as many state transitions as possible */
					/* determine next state and get next character */
      register yyCombType * yyTablePtr = (yyBasePtrReg [yyState] + * yyChBufferIndexReg ++);
      if (yyTablePtr->yyCheck == yyState) {
	 yyState = yyTablePtr->yyNext;
	 * yyStatePtr ++ = yyState;		/* push state */
	 goto yyContinue;
      }
      yyChBufferIndexReg --;			/* reconsider character */
      if ((yyState = yyDefault [yyState]) == yyDNoState) break;
   }
 
   for (;;) {					/* search for last final state */
      mpcScan_TokenLength = yyChBufferIndexReg - (unsigned char *) mpcScan_TokenPtr;
      yyChBufferIndex = yyChBufferIndexReg;
switch (* -- yyStatePtr) {
case 657:;
case 658:;
case 659:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 513 "mpc.rex" */
{ yyStart(comment); 
} yyy1: goto yyBegin;
case 656:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 514 "mpc.rex" */
{ yyStart(STD); 
} yyy2: goto yyBegin;
case 36:;
case 54:;
case 94:;
case 101:;
case 560:;
case 571:;
case 572:;
case 573:;
case 574:;
case 575:;
case 576:;
case 606:;
case 607:;
case 608:;
case 609:;
case 610:;
case 636:;
case 637:;
case 655:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 515 "mpc.rex" */
{
} yyy3: goto yyBegin;
case 654:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 516 "mpc.rex" */
{yyEol(0); LinesInFile++; 
} yyy4: goto yyBegin;
case 653:;
/* line 518 "mpc.rex" */
{ yyStart(pseudocomment); 
} yyy5: goto yyBegin;
case 647:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 520 "mpc.rex" */
{
} yyy6: goto yyBegin;
case 635:;
case 639:;
case 641:;
case 644:;
case 646:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 522 "mpc.rex" */
{ yyStart(linecomment); 
} yyy7: goto yyBegin;
case 634:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 523 "mpc.rex" */
{ yyEol(0); yyStart(STD); LinesInFile++; 
} yyy8: goto yyBegin;
case 35:;
case 53:;
case 95:;
case 102:;
case 561:;
case 577:;
case 578:;
case 579:;
case 580:;
case 581:;
case 582:;
case 611:;
case 612:;
case 613:;
case 614:;
case 615:;
case 638:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 524 "mpc.rex" */
{
} yyy9: goto yyBegin;
case 633:;
/* line 529 "mpc.rex" */
{ yyStart(STD);
} yyy10: goto yyBegin;
case 631:;
/* line 530 "mpc.rex" */
{ yyEol(0); LinesInFile++; 
} yyy11: goto yyBegin;
case 34:;
case 52:;
case 96:;
case 103:;
case 562:;
case 583:;
case 584:;
case 585:;
case 586:;
case 587:;
case 588:;
case 616:;
case 617:;
case 618:;
case 619:;
case 620:;
case 632:;
case 640:;
/* line 531 "mpc.rex" */
{
		   length = mpcScan_GetWord(Word);
		   mpcScan_Attribute.OMP_STAT.Ignore = NO;  /* dirty trick, this is not OMP */
		   mpcScan_Attribute.OMP_STAT.SymForm = (tString)malloc(length);
		   (void)strcpy(mpcScan_Attribute.OMP_STAT.SymForm,Word);
                   return 13;
                 
} yyy12: goto yyBegin;
case 605:;
case 625:;
case 630:;
/* line 539 "mpc.rex" */
{ yyStart(unused); 
} yyy13: goto yyBegin;
case 570:;
case 594:;
case 600:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 540 "mpc.rex" */
{ yyStart(pragma); yyLineCount++; 
} yyy14: goto yyBegin;
case 559:;
case 563:;
case 564:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 541 "mpc.rex" */
{ yyStart(position); 
} yyy15: goto yyBegin;
case 558:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 542 "mpc.rex" */
{ yyStart(STD); 
} yyy16: goto yyBegin;
case 32:;
case 49:;
case 50:;
case 51:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 543 "mpc.rex" */
{
		length = mpcScan_GetWord(Word);
		Pos.Line = atoi(Word);
		LinesInFile = Pos.Line-1;
		Pos.Column = 1;
		yyStart(file);

} yyy17: goto yyBegin;
case 557:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 550 "mpc.rex" */
{
		mpcScan_Attribute.Position.Line = ++yyLineCount;
		New_SourceFile(CurrentFileName,
			       mpcScan_Attribute.Position, Pos);
		yyStart(STD);

} yyy18: goto yyBegin;
case 31:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 556 "mpc.rex" */
{
		tString s;

		length = mpcScan_GetWord(Word);
		mpcScan_Attribute.Position.Line = ++yyLineCount;
		mpcScan_Attribute.Position.Column += length;/**********/
	/*printf("#include file: %d %d\n", mpcScan_Attribute.Position.Line, mpcScan_Attribute.Position.Column);******/
		s = (tString)malloc(length+1);
		for(index=0;index<length;index++) *(s+index) = Word[index];
		*(s+length) = '\0';
		New_SourceFile(s, mpcScan_Attribute.Position, Pos);
		CurrentFileName = s;
		yyStart(unused);

} yyy19: goto yyBegin;
case 33:;
case 104:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 570 "mpc.rex" */
{
} yyy20: goto yyBegin;
case 30:;
case 97:;
case 105:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 571 "mpc.rex" */
{
} yyy21: goto yyBegin;
case 26:;
case 92:;
/* line 573 "mpc.rex" */
{ yyStart(STD);
				     if(Pos.Line>LinesInFile+1) {
					LinesInFile++;
				     }
                                   
} yyy22: goto yyBegin;
case 29:;
/* line 579 "mpc.rex" */
{
				     length = mpcScan_GetWord(Word);
				     if(!strcmp(Word,"keywords"))
				       {yyStart(keywords);}
				     else if(!strcmp(Word,"native"))
				       {yyStart(native);}
				     else if(!strcmp(Word,"omp"))
				       {yyStart(openmp);}

# ifdef __WRK
#  ifndef __CB_COMPILER__
				     else if(!strcmp(Word,"header")) {
					C_2_MPC_SOURCE = false;
					//HEADER_NAME_GENERATED = false;
					//EmptyHeader = true;
					yyStart(header);
				     }
				     else if(!strcmp(Word,"source")) {
					C_2_MPC_SOURCE = true;
					//PRAGMA_SOURCE_GENERATED = false;
					yyStart(unused);
					return 11;
				     }
#  endif
# endif

				     else
				       {yyStart(unused);}
				   
} yyy23: goto yyBegin;
case 28:;
case 91:;
/* line 608 "mpc.rex" */
{
				     bool omp_decl=false;
				     short i;
				     length = mpcScan_GetWord(Word);
				     for(i=0;i<length && !isalpha(Word[i]);i++);
				     if(!strncmp(Word+i,"threadprivate",13))
				       omp_decl = true;
				     mpcScan_Attribute.OMP_DECL.Ignore = NO;
				     mpcScan_Attribute.OMP_DECL.SymForm = (tString)malloc(OMP_prefix_length + length);
				     (void)strcpy(mpcScan_Attribute.OMP_DECL.SymForm,OMP_prefix);
				     (void)strcat(mpcScan_Attribute.OMP_DECL.SymForm,Word);
				     LinesInFile++;

				     yyStart(STD);
				     if(omp_decl)
				       return 12;
                                     else
				       return 13;
				   
} yyy24: goto yyBegin;
case 556:;
/* line 628 "mpc.rex" */
{ KEYWORDS = K_ANSI; yyStart(unused); 
} yyy25: goto yyBegin;
case 553:;
/* line 629 "mpc.rex" */
{ KEYWORDS = K_SHORT; yyStart(unused); 
} yyy26: goto yyBegin;
case 548:;
/* line 630 "mpc.rex" */
{ KEYWORDS = K_LONG; yyStart(unused); 
} yyy27: goto yyBegin;
case 544:;
/* line 631 "mpc.rex" */
{ KEYWORDS = K_ALL; yyStart(unused); 
} yyy28: goto yyBegin;
case 541:;
/* line 633 "mpc.rex" */
{ NativeMode = NATIVE_MPC; yyStart(unused); 
} yyy29: goto yyBegin;
case 538:;
/* line 634 "mpc.rex" */
{ NativeMode = NATIVE_CBR; yyStart(unused); 
} yyy30: goto yyBegin;
case 536:;
/* line 635 "mpc.rex" */
{ NativeMode = NATIVE_C; yyStart(unused); 
} yyy31: goto yyBegin;
case 27:;
case 48:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 637 "mpc.rex" */
{
#ifdef __WRK

#  ifndef __CB_COMPILER__
		tString s;

		length = mpcScan_GetWord(Word);
		mpcScan_Attribute.Position.Line = ++yyLineCount;
		mpcScan_Attribute.Position.Column += length;/**********/
		s = (tString)malloc(length+1);
		for(index=0;index<length;index++) *(s+index) = Word[index];
		*(s+length) = '\0';
		mpcScan_Attribute.HEADER.SymForm = s;
		//CurrentHeaderName = s;
		yyStart(unused);
		return 10;
#  endif

#endif

} yyy32: goto yyBegin;
case 504:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 668 "mpc.rex" */
{ return 38; 
} yyy33: goto yyBegin;
case 535:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 669 "mpc.rex" */
{ return 39; 
} yyy34: goto yyBegin;
case 534:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 670 "mpc.rex" */
{ return 40; 
} yyy35: goto yyBegin;
case 532:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 671 "mpc.rex" */
{ return 41; 
} yyy36: goto yyBegin;
case 531:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 672 "mpc.rex" */
{ return 42; 
} yyy37: goto yyBegin;
case 530:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 673 "mpc.rex" */
{ return 43; 
} yyy38: goto yyBegin;
case 529:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 674 "mpc.rex" */
{ return 44; 
} yyy39: goto yyBegin;
case 528:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 675 "mpc.rex" */
{ return 45; 
} yyy40: goto yyBegin;
case 68:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 676 "mpc.rex" */
{ return 46; 
} yyy41: goto yyBegin;
case 527:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 677 "mpc.rex" */
{ return 47; 
} yyy42: goto yyBegin;
case 526:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 678 "mpc.rex" */
{ return 48; 
} yyy43: goto yyBegin;
case 525:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 679 "mpc.rex" */
{ return 49; 
} yyy44: goto yyBegin;
case 524:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 680 "mpc.rex" */
{ return 50; 
} yyy45: goto yyBegin;
case 522:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 681 "mpc.rex" */
{ return 51; 
} yyy46: goto yyBegin;
case 519:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 682 "mpc.rex" */
{ return 52; 
} yyy47: goto yyBegin;
case 517:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 683 "mpc.rex" */
{ return 53; 
} yyy48: goto yyBegin;
case 516:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 684 "mpc.rex" */
{ return 54; 
} yyy49: goto yyBegin;
case 514:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 685 "mpc.rex" */
{ return 55; 
} yyy50: goto yyBegin;
case 513:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 686 "mpc.rex" */
{ return 56; 
} yyy51: goto yyBegin;
case 510:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 687 "mpc.rex" */
{ return 57; 
} yyy52: goto yyBegin;
case 507:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 688 "mpc.rex" */
{ return 58; 
} yyy53: goto yyBegin;
case 506:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 689 "mpc.rex" */
{ return 59; 
} yyy54: goto yyBegin;
case 505:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 690 "mpc.rex" */
{ return 60; 
} yyy55: goto yyBegin;
case 503:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 691 "mpc.rex" */
{ return 61; 
} yyy56: goto yyBegin;
case 383:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 692 "mpc.rex" */
{ return 62; 
} yyy57: goto yyBegin;
case 397:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 693 "mpc.rex" */
{ return 63; 
} yyy58: goto yyBegin;
case 392:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 694 "mpc.rex" */
{ return 64; 
} yyy59: goto yyBegin;
case 390:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 695 "mpc.rex" */
{ return 65; 
} yyy60: goto yyBegin;
case 502:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 696 "mpc.rex" */
{ return 66; 
} yyy61: goto yyBegin;
case 410:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 697 "mpc.rex" */
{ return 67; 
} yyy62: goto yyBegin;
case 501:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 698 "mpc.rex" */
{ return 68; 
} yyy63: goto yyBegin;
case 497:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 699 "mpc.rex" */
{ return 69; 
} yyy64: goto yyBegin;
case 492:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 700 "mpc.rex" */
{ return 70; 
} yyy65: goto yyBegin;
case 490:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 701 "mpc.rex" */
{ return 71; 
} yyy66: goto yyBegin;
case 487:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 702 "mpc.rex" */
{ return 72; 
} yyy67: goto yyBegin;
case 483:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 703 "mpc.rex" */
{ return 73; 
} yyy68: goto yyBegin;
case 481:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 704 "mpc.rex" */
{ return 74; 
} yyy69: goto yyBegin;
case 478:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 705 "mpc.rex" */
{ return 75; 
} yyy70: goto yyBegin;
case 475:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 706 "mpc.rex" */
{ return 76; 
} yyy71: goto yyBegin;
case 471:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 707 "mpc.rex" */
{ return 77; 
} yyy72: goto yyBegin;
case 466:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 708 "mpc.rex" */
{ return 78; 
} yyy73: goto yyBegin;
case 460:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 709 "mpc.rex" */
{ return 79; 
} yyy74: goto yyBegin;
case 458:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 710 "mpc.rex" */
{ return 80; 
} yyy75: goto yyBegin;
case 451:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 711 "mpc.rex" */
{ return 81; 
} yyy76: goto yyBegin;
case 447:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 712 "mpc.rex" */
{ return 82; 
} yyy77: goto yyBegin;
case 442:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 713 "mpc.rex" */
{ return 83; 
} yyy78: goto yyBegin;
case 441:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 714 "mpc.rex" */
{ return 84; 
} yyy79: goto yyBegin;
case 435:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 715 "mpc.rex" */
{ return 85; 
} yyy80: goto yyBegin;
case 430:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 716 "mpc.rex" */
{ return 86; 
} yyy81: goto yyBegin;
case 425:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 717 "mpc.rex" */
{ return 87; 
} yyy82: goto yyBegin;
case 422:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 718 "mpc.rex" */
{ return 88; 
} yyy83: goto yyBegin;
case 395:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 719 "mpc.rex" */
{ return 89; 
} yyy84: goto yyBegin;
case 325:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 720 "mpc.rex" */
{ return 90; 
} yyy85: goto yyBegin;
case 416:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 721 "mpc.rex" */
{ return 91; 
} yyy86: goto yyBegin;
case 415:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 722 "mpc.rex" */
{ return 92; 
} yyy87: goto yyBegin;
case 388:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 723 "mpc.rex" */
{ return 93; 
} yyy88: goto yyBegin;
case 386:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 724 "mpc.rex" */
{ return 94; 
} yyy89: goto yyBegin;
case 368:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 725 "mpc.rex" */
{ return 95; 
} yyy90: goto yyBegin;
case 385:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 726 "mpc.rex" */
{ return 96; 
} yyy91: goto yyBegin;
case 414:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 727 "mpc.rex" */
{ return 97; 
} yyy92: goto yyBegin;
case 413:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 728 "mpc.rex" */
{ return 98; 
} yyy93: goto yyBegin;
case 412:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 729 "mpc.rex" */
{ return 99; 
} yyy94: goto yyBegin;
case 411:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 730 "mpc.rex" */
{ return 100; 
} yyy95: goto yyBegin;
case 381:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 731 "mpc.rex" */
{ return 101; 
} yyy96: goto yyBegin;
case 379:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 732 "mpc.rex" */
{ return 102; 
} yyy97: goto yyBegin;
case 409:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 733 "mpc.rex" */
{ return 103; 
} yyy98: goto yyBegin;
case 408:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 734 "mpc.rex" */
{ return 104; 
} yyy99: goto yyBegin;
case 407:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 735 "mpc.rex" */
{ return 105; 
} yyy100: goto yyBegin;
case 406:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 736 "mpc.rex" */
{ return 106; 
} yyy101: goto yyBegin;
case 405:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 737 "mpc.rex" */
{ return 107; 
} yyy102: goto yyBegin;
case 404:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 738 "mpc.rex" */
{ return 108; 
} yyy103: goto yyBegin;
case 401:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 739 "mpc.rex" */
{ return 109; 
} yyy104: goto yyBegin;
case 400:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 740 "mpc.rex" */
{ return 110; 
} yyy105: goto yyBegin;
case 398:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 741 "mpc.rex" */
{ return 111; 
} yyy106: goto yyBegin;
case 396:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 742 "mpc.rex" */
{ return 112; 
} yyy107: goto yyBegin;
case 394:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 743 "mpc.rex" */
{ return 113; 
} yyy108: goto yyBegin;
case 393:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 744 "mpc.rex" */
{ return 114; 
} yyy109: goto yyBegin;
case 391:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 745 "mpc.rex" */
{ return 115; 
} yyy110: goto yyBegin;
case 389:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 746 "mpc.rex" */
{ return 116; 
} yyy111: goto yyBegin;
case 387:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 747 "mpc.rex" */
{ return 117; 
} yyy112: goto yyBegin;
case 384:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 748 "mpc.rex" */
{ return 118; 
} yyy113: goto yyBegin;
case 382:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 749 "mpc.rex" */
{ return 119; 
} yyy114: goto yyBegin;
case 380:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 750 "mpc.rex" */
{ return 120; 
} yyy115: goto yyBegin;
case 369:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 751 "mpc.rex" */
{ return 121; 
} yyy116: goto yyBegin;
case 377:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 752 "mpc.rex" */
{ return 122; 
} yyy117: goto yyBegin;
case 378:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 753 "mpc.rex" */
{ return 123; 
} yyy118: goto yyBegin;
case 376:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 754 "mpc.rex" */
{ return 124; 
} yyy119: goto yyBegin;
case 370:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 755 "mpc.rex" */
{ return 125; 
} yyy120: goto yyBegin;
case 367:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 756 "mpc.rex" */
{ return 126; 
} yyy121: goto yyBegin;
case 364:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 757 "mpc.rex" */
{ return 127; 
} yyy122: goto yyBegin;
case 362:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 758 "mpc.rex" */
{ return 128; 
} yyy123: goto yyBegin;
case 358:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 759 "mpc.rex" */
{ return 129; 
} yyy124: goto yyBegin;
case 353:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 760 "mpc.rex" */
{ return 130; 
} yyy125: goto yyBegin;
case 348:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 761 "mpc.rex" */
{ return 131; 
} yyy126: goto yyBegin;
case 346:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 762 "mpc.rex" */
{ return 132; 
} yyy127: goto yyBegin;
case 344:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 763 "mpc.rex" */
{ return 133; 
} yyy128: goto yyBegin;
case 340:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 764 "mpc.rex" */
{ return 134; 
} yyy129: goto yyBegin;
case 334:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 765 "mpc.rex" */
{ return 135; 
} yyy130: goto yyBegin;
case 330:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 766 "mpc.rex" */
{ return 136; 
} yyy131: goto yyBegin;
case 326:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 767 "mpc.rex" */
{ return 137; 
} yyy132: goto yyBegin;
case 324:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 772 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.bench.Ignore = NO; 
					    return 14;
			    }
			  
} yyy133: goto yyBegin;
case 319:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 781 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.bench.Ignore = NO; 
					    return 14;
			    }
			  
} yyy134: goto yyBegin;
case 312:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 791 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.coord.Ignore = NO; 
					    return 15;
			    }
			  
} yyy135: goto yyBegin;
case 305:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 800 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.coord.Ignore = NO; 
					    return 15;
			    }
			  
} yyy136: goto yyBegin;
case 314:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 810 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.coordof.Ignore = NO; 
					    return 16;
			    }
			  
} yyy137: goto yyBegin;
case 307:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 819 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.coordof.Ignore = NO; 
					    return 16;
			    }
			  
} yyy138: goto yyBegin;
case 300:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 829 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.fan.Ignore = NO; 
					    return 17;
			    }
			  
} yyy139: goto yyBegin;
case 299:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 838 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.fan.Ignore = NO; 
					    return 17;
			    }
			  
} yyy140: goto yyBegin;
case 298:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 848 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.fast.Ignore = NO; 
					    return 18;
			    }
			  
} yyy141: goto yyBegin;
case 295:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 857 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.fast.Ignore = NO; 
					    return 18;
			    }
			  
} yyy142: goto yyBegin;
case 292:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 867 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.flex.Ignore = NO; 
					    return 19;
			    }
			  
} yyy143: goto yyBegin;
case 288:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 876 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.flex.Ignore = NO; 
					    return 19;
			    }
			  
} yyy144: goto yyBegin;
case 284:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 886 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.host.Ignore = NO; 
					    return 20;
			    }
			  
} yyy145: goto yyBegin;
case 280:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 895 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.host.Ignore = NO; 
					    return 20;
			    }
			  
} yyy146: goto yyBegin;
case 276:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 905 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.length.Ignore = NO; 
					    return 21;
			    }
			  
} yyy147: goto yyBegin;
case 271:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 914 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.length.Ignore = NO; 
					    return 21;
			    }
			  
} yyy148: goto yyBegin;
case 266:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 924 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.link.Ignore = NO; 
					    return 22;
			    }
			  
} yyy149: goto yyBegin;
case 262:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 933 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.link.Ignore = NO; 
					    return 22;
			    }
			  
} yyy150: goto yyBegin;
case 258:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 943 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.memory.Ignore = NO; 
					    return 23;
			    }
			  
} yyy151: goto yyBegin;
case 253:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 952 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.memory.Ignore = NO; 
					    return 23;
			    }
			  
} yyy152: goto yyBegin;
case 243:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 962 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.net.Ignore = NO; 
					    return 24;
			    }
			  
} yyy153: goto yyBegin;
case 237:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 971 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.net.Ignore = NO; 
					    return 24;
			    }
			  
} yyy154: goto yyBegin;
case 247:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 981 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 25;
			    }
			  
} yyy155: goto yyBegin;
case 241:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 990 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 25;
			    }
			  
} yyy156: goto yyBegin;
case 235:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1000 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 25;
			    }
			  
} yyy157: goto yyBegin;
case 226:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1009 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 25;
			    }
			  
} yyy158: goto yyBegin;
case 217:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1019 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.node.Ignore = NO; 
					    return 26;
			    }
			  
} yyy159: goto yyBegin;
case 213:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1028 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.node.Ignore = NO; 
					    return 26;
			    }
			  
} yyy160: goto yyBegin;
case 206:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1040 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.par.Ignore = NO; 
					    return 35;
			    }
			  
} yyy161: goto yyBegin;
case 200:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1049 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.par.Ignore = NO; 
					    return 35;
			    }
			  
} yyy162: goto yyBegin;
case 209:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1060 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.parent.Ignore = NO; 
					    return 27;
			    }
			  
} yyy163: goto yyBegin;
case 203:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1069 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.parent.Ignore = NO; 
					    return 27;
			    }
			  
} yyy164: goto yyBegin;
case 197:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1079 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.recon.Ignore = NO; 
					    return 28;
			    }
			  
} yyy165: goto yyBegin;
case 194:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1088 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.recon.Ignore = NO; 
					    return 28;
			    }
			  
} yyy166: goto yyBegin;
case 191:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1098 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.relation.Ignore = NO; 
					    return 29;
			    }
			  
} yyy167: goto yyBegin;
case 185:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1107 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.relation.Ignore = NO; 
					    return 29;
			    }
			  
} yyy168: goto yyBegin;
case 179:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1117 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.repl.Ignore = NO; 
					    return 30;
			    }
			  
} yyy169: goto yyBegin;
case 175:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1126 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.repl.Ignore = NO; 
					    return 30;
			    }
			  
} yyy170: goto yyBegin;
case 171:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1136 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.scalar.Ignore = NO; 
					    return 31;
			    }
			  
} yyy171: goto yyBegin;
case 167:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1145 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.scalar.Ignore = NO; 
					    return 31;
			    }
			  
} yyy172: goto yyBegin;
case 163:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1157 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.scheme.Ignore = NO; 
					    return 36;
			    }
			  
} yyy173: goto yyBegin;
case 158:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1166 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.scheme.Ignore = NO; 
					    return 36;
			    }
			  
} yyy174: goto yyBegin;
case 153:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1177 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.slow.Ignore = NO; 
					    return 32;
			    }
			  
} yyy175: goto yyBegin;
case 150:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1186 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.slow.Ignore = NO; 
					    return 32;
			    }
			  
} yyy176: goto yyBegin;
case 147:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1196 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.subnet.Ignore = NO; 
					    return 33;
			    }
			  
} yyy177: goto yyBegin;
case 141:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1205 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.subnet.Ignore = NO; 
					    return 33;
			    }
			  
} yyy178: goto yyBegin;
case 135:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1217 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.timeof.Ignore = NO; 
					    return 37;
			    }
			  
} yyy179: goto yyBegin;
case 129:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1226 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.timeof.Ignore = NO; 
					    return 37;
			    }
			  
} yyy180: goto yyBegin;
case 123:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1237 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.vector.Ignore = NO; 
					    return 34;
			    }
			  
} yyy181: goto yyBegin;
case 117:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1246 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.vector.Ignore = NO; 
					    return 34;
			    }
			  
} yyy182: goto yyBegin;
case 38:;
case 58:;
case 108:;
case 109:;
case 110:;
case 111:;
case 112:;
case 113:;
case 114:;
case 115:;
case 116:;
case 118:;
case 119:;
case 120:;
case 121:;
case 122:;
case 124:;
case 125:;
case 126:;
case 127:;
case 128:;
case 130:;
case 131:;
case 132:;
case 133:;
case 134:;
case 136:;
case 137:;
case 138:;
case 139:;
case 140:;
case 142:;
case 143:;
case 144:;
case 145:;
case 146:;
case 148:;
case 149:;
case 151:;
case 152:;
case 154:;
case 155:;
case 156:;
case 157:;
case 159:;
case 160:;
case 161:;
case 162:;
case 164:;
case 165:;
case 166:;
case 168:;
case 169:;
case 170:;
case 172:;
case 173:;
case 174:;
case 176:;
case 177:;
case 178:;
case 180:;
case 181:;
case 182:;
case 183:;
case 184:;
case 186:;
case 187:;
case 188:;
case 189:;
case 190:;
case 192:;
case 193:;
case 195:;
case 196:;
case 198:;
case 199:;
case 201:;
case 202:;
case 204:;
case 205:;
case 207:;
case 208:;
case 210:;
case 211:;
case 212:;
case 214:;
case 215:;
case 216:;
case 218:;
case 219:;
case 220:;
case 221:;
case 222:;
case 223:;
case 224:;
case 225:;
case 227:;
case 228:;
case 229:;
case 230:;
case 231:;
case 232:;
case 233:;
case 234:;
case 236:;
case 238:;
case 239:;
case 240:;
case 242:;
case 244:;
case 245:;
case 246:;
case 248:;
case 249:;
case 250:;
case 251:;
case 252:;
case 254:;
case 255:;
case 256:;
case 257:;
case 259:;
case 260:;
case 261:;
case 263:;
case 264:;
case 265:;
case 267:;
case 268:;
case 269:;
case 270:;
case 272:;
case 273:;
case 274:;
case 275:;
case 277:;
case 278:;
case 279:;
case 281:;
case 282:;
case 283:;
case 285:;
case 286:;
case 287:;
case 289:;
case 290:;
case 291:;
case 293:;
case 294:;
case 296:;
case 297:;
case 301:;
case 302:;
case 303:;
case 304:;
case 306:;
case 308:;
case 309:;
case 310:;
case 311:;
case 313:;
case 315:;
case 316:;
case 317:;
case 318:;
case 320:;
case 321:;
case 322:;
case 323:;
case 327:;
case 328:;
case 329:;
case 331:;
case 332:;
case 333:;
case 335:;
case 336:;
case 337:;
case 338:;
case 339:;
case 341:;
case 342:;
case 343:;
case 345:;
case 347:;
case 349:;
case 350:;
case 351:;
case 352:;
case 354:;
case 355:;
case 356:;
case 357:;
case 359:;
case 360:;
case 361:;
case 363:;
case 365:;
case 366:;
case 371:;
case 372:;
case 373:;
case 374:;
case 375:;
case 402:;
case 403:;
case 417:;
case 418:;
case 419:;
case 420:;
case 421:;
case 423:;
case 424:;
case 426:;
case 427:;
case 428:;
case 429:;
case 431:;
case 432:;
case 433:;
case 434:;
case 436:;
case 437:;
case 438:;
case 439:;
case 440:;
case 443:;
case 444:;
case 445:;
case 446:;
case 448:;
case 449:;
case 450:;
case 452:;
case 453:;
case 454:;
case 455:;
case 456:;
case 457:;
case 459:;
case 461:;
case 462:;
case 463:;
case 464:;
case 465:;
case 467:;
case 468:;
case 469:;
case 470:;
case 472:;
case 473:;
case 474:;
case 476:;
case 477:;
case 479:;
case 480:;
case 482:;
case 484:;
case 485:;
case 486:;
case 488:;
case 489:;
case 491:;
case 493:;
case 494:;
case 495:;
case 496:;
case 498:;
case 499:;
case 500:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1258 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.IDENTIFIER.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.IDENTIFIER.Ignore = NO;
                            mpcScan_Attribute.IDENTIFIER.Ident =
					 MakeIdent (Word, length);
			    if (isaTYPE (
				mpcScan_Attribute.IDENTIFIER.Ident)) {
                                return 3;
			    }
                            else if(isaNET(
				    mpcScan_Attribute.IDENTIFIER.Ident)) {
				    return 2;
			    }
			    else {
				return 1;
			    }
			  
} yyy183: goto yyBegin;
case 37:;
case 55:;
case 56:;
case 57:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1277 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.INTEGERconstant.Length = 
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.INTEGERconstant.Ignore = NO;
			    mpcScan_Attribute.INTEGERconstant.IntConst =
				(int) strtol(Word, (char**)NULL, 10);
					/*atoi (Word);*/
			    if(errno) {
			      INIT_Warning((55, xxWarning, mpcScan_Attribute.Position, NoTree));
			      errno = 0;
			    }
			    mpcScan_Attribute.INTEGERconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.INTEGERconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.INTEGERconstant.SymForm+length) = '\0';
                  	    return 5; 
} yyy184: goto yyBegin;
case 40:;
case 59:;
case 60:;
case 61:;
case 76:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1295 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.OCTALconstant.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.OCTALconstant.Ignore = NO;
                            mpcScan_Attribute.OCTALconstant.OctConst =
				(int) strtol (Word, (char * *)NULL, 8);
			    if(errno) {
			      INIT_Warning((55, xxWarning, mpcScan_Attribute.Position, NoTree));
			      errno = 0;
			    }
			    mpcScan_Attribute.OCTALconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.OCTALconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.OCTALconstant.SymForm+length) = '\0';
                            return 6; 
} yyy185: goto yyBegin;
case 42:;
case 64:;
case 65:;
case 66:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1312 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.HEXconstant.Length =
			    		length = mpcScan_GetWord (Word);
                            mpcScan_Attribute.HEXconstant.Ignore = NO;
                            mpcScan_Attribute.HEXconstant.HexConst =
				(int) strtol (Word, (char * *)NULL, 16);
			    if(errno) {
			      INIT_Warning((55, xxWarning, mpcScan_Attribute.Position, NoTree));
			      errno = 0;
			    }
			    mpcScan_Attribute.HEXconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.HEXconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.HEXconstant.SymForm+length) = '\0';
                            return 7	; 
} yyy186: goto yyBegin;
case 41:;
case 62:;
case 63:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1329 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.FLOATINGconstant.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.FLOATINGconstant.Ignore = NO;
			    mpcScan_Attribute.FLOATINGconstant.FloatConst = strtod (Word, (char**)NULL);
				/* atof (Word); */
///***/printf("##### %e  errno=%d\n", mpcScan_Attribute.FLOATINGconstant.FloatConst, errno);
			    if(errno) {
			      INIT_Warning((55, xxWarning, mpcScan_Attribute.Position, NoTree));
			      errno = 0;
			    }
			    mpcScan_Attribute.FLOATINGconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.FLOATINGconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.FLOATINGconstant.SymForm+length) = '\0';
                            return 4; 
} yyy187: goto yyBegin;
case 43:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1347 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.CHARACTERconstant.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.CHARACTERconstant.Ignore = NO;
			    mpcScan_Attribute.CHARACTERconstant.CharConst =
					Str_to_Char (Word,
						     mpcScan_Attribute.Position);
				/***	Str_to_Char (PutString(Word, length));*/
			    mpcScan_Attribute.CHARACTERconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.CHARACTERconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.CHARACTERconstant.SymForm+length) = '\0';
                            return 8; 
} yyy188: goto yyBegin;
case 44:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1362 "mpc.rex" */
{ int i;
			    EmptyHeader = false;
			    mpcScan_Attribute.STRINGliteral.Length =
			    		length = mpcScan_GetWord (Word);
			/**************************************/
			    mpcScan_Attribute.STRINGliteral.Ignore = NO;
			    mpcScan_Attribute.STRINGliteral.SymForm = 
						(char*)malloc(length+1);
			    *(Word+length) = '\0';
			    mpcScan_Attribute.STRINGliteral.SymForm =
				memcpy (mpcScan_Attribute.STRINGliteral.SymForm,
					Word, length+1);
			    length -= 2;   /* remove begin- and end-'"',then *
					    * convert esc. seq. to code:     */
			    for(index=i=1; index<=length; index++,i++) {
			      if(Word[index]=='\\') { /* escape sequence: */
				index++;
				switch(Word[index]){
				  case'\'': Word[i] = '\''; break;
				  case'"': Word[i] = '\"'; break;
				  case'?': Word[i] = '\?'; break;
				  case'\\': Word[i] = '\\'; break;
				  case'a': Word[i] = '\a'; break;
				  case'b': Word[i] = '\b'; break;
				  case'f': Word[i] = '\f'; break;
				  case'n': Word[i] = '\n'; break;
				  case'r': Word[i] = '\r'; break;
				  case't': Word[i] = '\t'; break;
				  case'v': Word[i] = '\v'; break;
				  default:
				    if(Word[index]>='0' && Word[index]<='7')
					Word[i] = Get_Oct_Code(
							Word+index, &index);
				    else
				    if(Word[index]=='x')
					Word[i] = Get_Hex_Code(
							Word + ++index, &index);
				    else
				      Make_Message(
					54, xxError, mpcScan_Attribute.Position, NoTree);
				/* "Invalid escape sequence in string literal" */
				    index--;
				}
			      }
			      else
				Word[i] = Word[index];
			    }
			    length = i-1;
			    mpcScan_Attribute.STRINGliteral.Length = i; /*bytes*/
			    mpcScan_Attribute.STRINGliteral.StrLit =
						(char*)malloc(i);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.STRINGliteral.StrLit+index) =
							Word[index+1];
			    *(mpcScan_Attribute.STRINGliteral.StrLit+length) = '\0';
                            return 9; 
} yyy189: goto yyBegin;
case 90:;
/* line 1419 "mpc.rex" */
{ yyEol(0); LinesInFile++; 
} yyy190: goto yyBegin;
case 39:;
/* line 1421 "mpc.rex" */
{
} yyy191: goto yyBegin;
case 100:;
case 106:;
case 107:;
{/* BlankAction */
while (* yyChBufferIndexReg ++ == ' ') ;
mpcScan_TokenPtr = (char *) -- yyChBufferIndexReg;
yyState = yyStartState;
yyStatePtr = & yyStateStack [1];
goto yyContinue;
} yyy192: goto yyBegin;
case 93:;
case 98:;
case 99:;
{/* TabAction */
yyLineStart -= 7 - ((unsigned char *) mpcScan_TokenPtr - yyLineStart - 1) & 0x7; /* % 8 */
} yyy193: goto yyBegin;
case 1:;
case 2:;
case 3:;
case 4:;
case 5:;
case 6:;
case 7:;
case 8:;
case 9:;
case 10:;
case 11:;
case 12:;
case 13:;
case 14:;
case 15:;
case 16:;
case 17:;
case 18:;
case 19:;
case 20:;
case 21:;
case 22:;
case 23:;
case 24:;
case 25:;
case 45:;
case 46:;
case 47:;
case 67:;
case 69:;
case 70:;
case 71:;
case 72:;
case 73:;
case 74:;
case 75:;
case 77:;
case 78:;
case 79:;
case 80:;
case 81:;
case 82:;
case 83:;
case 84:;
case 85:;
case 86:;
case 87:;
case 399:;
case 508:;
case 509:;
case 511:;
case 512:;
case 515:;
case 518:;
case 520:;
case 521:;
case 523:;
case 533:;
case 537:;
case 539:;
case 540:;
case 542:;
case 543:;
case 545:;
case 546:;
case 547:;
case 549:;
case 550:;
case 551:;
case 552:;
case 554:;
case 555:;
case 565:;
case 566:;
case 567:;
case 568:;
case 569:;
case 589:;
case 590:;
case 591:;
case 592:;
case 593:;
case 595:;
case 596:;
case 597:;
case 598:;
case 599:;
case 601:;
case 602:;
case 603:;
case 604:;
case 621:;
case 622:;
case 623:;
case 624:;
case 626:;
case 627:;
case 628:;
case 629:;
case 642:;
case 643:;
case 645:;
case 648:;
case 649:;
case 650:;
case 651:;
case 652:;
	 /* non final states */
	 yyChBufferIndexReg --;			/* return character */
	 break;
 
case 89:
	 mpcScan_Attribute.Position.Line   = yyLineCount;
	 mpcScan_Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
      /* mpcScan_TokenLength   = 1; */
	 yyChBufferIndex = ++ yyChBufferIndexReg;
	 {
/* line 459 "mpc.rex" */

  Make_MessageI(51, xxError, mpcScan_Attribute.Position, xxCharacter, mpcScan_TokenPtr, NoTree);
		/* "Illegal character" */
  /********
  switch(yyStartState) {
    case comment: printf("---- comment ----\n"); break;
    case linecomment: printf("---- linecomment ----\n"); break;
    case position: printf("---- position ----\n"); break;
    case file: printf("---- file ----\n"); break;
    case pragma: printf("---- pragma ----\n"); break;
    case keywords: printf("---- keywords ----\n"); break;
    case native: printf("---- native ----\n"); break;
    case unused: printf("---- unused ----\n"); break;
    default: printf("---- STD ----\n"); break;
  }*******/

  if(yyStartState==position || yyStartState==pragma || yyStartState==unused) {
    Make_Message(52, xxInformation, mpcScan_Attribute.Position, NoTree);
		/* "Maybe your 'cpp' don't allows some ANSI C facilities" */
    Print_Messages();
    exit(1);
  }

	 }
	 goto yyBegin;
 
      case yyDNoState:				/* automatic initialization */
	 yyInitialize ();
	 yySourceFile = StdIn;
	 goto yyBegin;

case 88:
	 yyChBufferIndex = -- yyChBufferIndexReg; /* undo last state transition */
	 if (-- mpcScan_TokenLength == 0) {		/* get previous state */
	    yyState = yyStartState;
	 } else {
	    yyState = * (yyStatePtr - 1);
	 }

	 if (yyChBufferIndex != & yyChBufferStart [yyBytesRead]) {
						/* end of buffer sentinel in buffer */
	    if ((yyState = yyEobTrans [yyState]) == yyDNoState) continue;
	    yyChBufferIndexReg ++;
	    * yyStatePtr ++ = yyState;		/* push state */
	    goto yyContinue;
	 }
						/* end of buffer reached */
	 {  /* copy initial part of token in front of the input buffer */
	    register char * yySource = mpcScan_TokenPtr;
	    register char * yyTarget = mpcScan_TokenPtr = (char *) & yyChBufferPtr [yyMaxAlign - mpcScan_TokenLength % yyMaxAlign];
	    if (yySource != yyTarget) {
	       while (yySource < (char *) yyChBufferIndexReg) * yyTarget ++ = * yySource ++;
	       yyLineStart += (unsigned char *) yyTarget - yyChBufferStart - yyBytesRead;
	       yyChBufferStart = (unsigned char *) yyTarget;
	    } else {
	       yyChBufferStart = yyChBufferIndexReg;
	    }
	 }

	 if (! yyEof) {				/* read buffer and restart */
	    int yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - mpcScan_TokenLength));
	    if (yyChBufferFree < yyChBufferSize / 8) {
	       register int yyDelta;
	       register unsigned char * yyOldChBufferPtr = yyChBufferPtr;
	       ExtendArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
	       if (yyChBufferPtr == NULL) yyErrorMessage (1);
	       yyDelta = yyChBufferPtr - yyOldChBufferPtr;
	       yyChBufferStart	+= yyDelta;
	       yyLineStart	+= yyDelta;
	       mpcScan_TokenPtr	+= yyDelta;
	       yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - mpcScan_TokenLength));
	       if (yyStateStackSize < yyChBufferSize) {
		  yyStateRange * yyOldStateStack = yyStateStack;
		  ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
		  if (yyStateStack == NULL) yyErrorMessage (1);
		  yyStatePtr	+= yyStateStack - yyOldStateStack;
	       }
	    }
	    yyChBufferIndex = yyChBufferIndexReg = yyChBufferStart;
	    yyBytesRead = mpcScan_GetLine (yySourceFile, (char *) yyChBufferIndex, yyChBufferFree);
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	    goto yyContinue;
	 }

	 if (mpcScan_TokenLength == 0) {		/* end of file reached */
	    mpcScan_Attribute.Position.Line   = yyLineCount;
	    mpcScan_Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
	    mpcScan_CloseFile ();
	    if (yyFileStackPtr == yyFileStack) {
/* line 483 "mpc.rex" */
 if( yyStartState == comment )
            Make_Message(53, xxError, mpcScan_Attribute.Position, NoTree);
		/* "Unclosed comment" */

	    }
	    if (yyFileStackPtr == yyFileStack) return mpcScan_EofToken;
	    goto yyBegin;
	 }
	 break;
 
      default:
	 yyErrorMessage (0);
      }
   }
}
 
void mpcScan_BeginFile
# if defined __STDC__ | defined __cplusplus
   (char * yyFileName)
# else
   (yyFileName) char * yyFileName;
# endif
   {
      yyInitialize ();
      yySourceFile = mpcScan_BeginSource (yyFileName);
      if (yySourceFile < 0) yyErrorMessage (4);
   }

static void yyInitialize ()
   {
      if (yyFileStackPtr >= yyFileStack + yyFileStackSize) yyErrorMessage (2);
      yyFileStackPtr ++;			/* push file */
      yyFileStackPtr->yySourceFile	= yySourceFile		;
      yyFileStackPtr->yyEof		= yyEof			;
      yyFileStackPtr->yyChBufferPtr	= yyChBufferPtr		;
      yyFileStackPtr->yyChBufferStart	= yyChBufferStart	;
      yyFileStackPtr->yyChBufferSize	= yyChBufferSize	;
      yyFileStackPtr->yyChBufferIndex	= yyChBufferIndex	;
      yyFileStackPtr->yyBytesRead	= yyBytesRead		;
      yyFileStackPtr->yyLineCount	= yyLineCount		;
      yyFileStackPtr->yyLineStart	= yyLineStart		;
						/* initialize file state */
      yyChBufferSize	   = yyInitBufferSize;
      MakeArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
      if (yyChBufferPtr == NULL) yyErrorMessage (1);
      yyChBufferStart	   = & yyChBufferPtr [yyMaxAlign];
      yyChBufferStart [-1] = yyEolCh;		/* begin of line indicator */
      yyChBufferStart [ 0] = yyEobCh;		/* end of buffer sentinel */
      yyChBufferStart [ 1] = '\0';
      yyChBufferIndex	   = yyChBufferStart;
      yyEof		   = false;
      yyBytesRead	   = 0;
      yyLineCount	   = 1;
      yyLineStart	   = & yyChBufferStart [-1];
      if (yyStartState == 0) yyStartState = STD;
      yyStateStack [0]	   = yyDefaultState;	/* stack underflow sentinel */
   }

void mpcScan_CloseFile ()
   {
      if (yyFileStackPtr == yyFileStack) yyErrorMessage (3);
      mpcScan_CloseSource (yySourceFile);
      ReleaseArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
						/* pop file */
      yySourceFile	= yyFileStackPtr->yySourceFile		;
      yyEof		= yyFileStackPtr->yyEof			;
      yyChBufferPtr	= yyFileStackPtr->yyChBufferPtr		;
      yyChBufferStart	= yyFileStackPtr->yyChBufferStart	;
      yyChBufferSize	= yyFileStackPtr->yyChBufferSize	;
      yyChBufferIndex	= yyFileStackPtr->yyChBufferIndex	;
      yyBytesRead	= yyFileStackPtr->yyBytesRead		;
      yyLineCount	= yyFileStackPtr->yyLineCount		;
      yyLineStart	= yyFileStackPtr->yyLineStart		;
      yyFileStackPtr --;		
   }
 
int mpcScan_GetWord
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= mpcScan_TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = * yySource ++;
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - mpcScan_TokenPtr;
   }
 
int mpcScan_GetLower
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= mpcScan_TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToLower [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - mpcScan_TokenPtr;
   }
 
int mpcScan_GetUpper
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= mpcScan_TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToUpper [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - mpcScan_TokenPtr;
   }
 
static char input ()
   {
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) {
	 if (! yyEof) {
	    yyLineStart -= yyBytesRead;
	    yyChBufferIndex = yyChBufferStart = yyChBufferPtr;
	    yyBytesRead = mpcScan_GetLine (yySourceFile, (char *) yyChBufferIndex,
	       (int) Exp2 (Log2 (yyChBufferSize)));
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	 }
      }
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) return '\0';
      else return * yyChBufferIndex ++;
   }

void mpcScan_BeginScanner ()
   {
   }
 
void mpcScan_CloseScanner ()
   {
   }
 
static void yyErrorMessage
# if defined __STDC__ | defined __cplusplus
   (int yyErrorCode)
# else
   (yyErrorCode) int yyErrorCode;
# endif
   {
      WritePosition (stderr, mpcScan_Attribute.Position);
      switch (yyErrorCode) {
      case 0: (void) fprintf (stderr, ": mpcScan: internal error\n"); break;
      case 1: (void) fprintf (stderr, ": mpcScan: out of memory\n"); break;
      case 2: (void) fprintf (stderr, ": mpcScan: too many nested include files\n"); break;
      case 3: (void) fprintf (stderr, ": mpcScan: file stack underflow (too many calls of mpcScan_CloseFile)\n"); break;
      case 4: (void) fprintf (stderr, ": mpcScan: cannot open input file\n"); break;
      }
      mpcScan_Exit ();
   }
